Attribute VB_Name = "CircScapeFunctions"
Option Explicit
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\CircScapeFunctions.bas"


Public Function ExportRastersToAscii(pDocParams As esriSystem.IVariantArray, _
    pParams As esriSystem.IVariantArray) As String
  On Error GoTo ErrorHandler
  
  Dim datTimeBegan As Date
10:   datTimeBegan = Now
  
  Dim pApp As IApplication
  Dim pThisExt As Linkages.clsExtension
  Dim pMxDoc As IMxDocument
  
16:   Set pApp = pDocParams.Element(0)
17:   Set pThisExt = pDocParams.Element(1)
18:   Set pMxDoc = pDocParams.Element(2)
  
  ' RETURN ARRAY CONTAINS THE FOLLOWING:
  ' 0) IRasterLayer:  TEMPLATE RASTER LAYER
  ' 1) IVariantArray:  ADDITIONAL RASTER LAYERS; COULD BE EMPTY
  ' 2) String:  OUTPUT FOLDER TO SAVE ASCII RASTERS
  Dim pTemplate As IRasterLayer
  Dim pTemplateRaster As IRaster
  Dim pTemplateProps As IRasterProps
  Dim pTemplateSpRef As ISpatialReference
  Dim pTemplatePnt As IPnt
  
30:   Set pTemplate = pParams.Element(0)
31:   Set pTemplateRaster = pTemplate.Raster
32:   Set pTemplateProps = pTemplateRaster
33:   Set pTemplateSpRef = pTemplateProps.SpatialReference
34:   Set pTemplatePnt = pTemplateProps.MeanCellSize
  
  Dim booShouldClip As Boolean
  Dim pClipLayer As IFeatureLayer
  
  Dim pAdditionalRasters As esriSystem.IVariantArray
40:   Set pAdditionalRasters = pParams.Element(1)
  Dim pAdditionalFeatLayers As esriSystem.IVariantArray
42:   Set pAdditionalFeatLayers = pParams.Element(2)
  Dim strOutputFolder As String
44:   strOutputFolder = pParams.Element(3)
  Dim booAllHaveNoSpRef As Boolean
46:   booShouldClip = pParams.Element(4)
47:   Set pClipLayer = pParams.Element(5)
48:   booAllHaveNoSpRef = pParams.Element(6)
  
  ' CONVERT CLIP LAYER INTO IN-MEMORY FEATURE CLASS WITH SAME SPATIAL REFERENCE AS TEMPLATE
  Dim pInMemFClass As IFeatureClass
  Dim pGeomArray As esriSystem.IArray
  Dim pClipGeoDataset As IGeoDataset
  Dim pClipCursor As IFeatureCursor
  Dim pClipFeature As IFeature
  Dim pClipPolygon As IPolygon
57:   If booShouldClip Then
58:     Set pClipGeoDataset = pClipLayer.FeatureClass
59:     If Not Linkages.MyGeneralOperations.CompareSpatialReferences(pClipGeoDataset.SpatialReference, pTemplateSpRef) Then
60:       Set pGeomArray = New esriSystem.Array
61:       Set pClipCursor = pClipLayer.FeatureClass.Search(Nothing, True)
62:       Set pClipFeature = pClipCursor.NextFeature
63:       Do Until pClipFeature Is Nothing
64:         Set pClipPolygon = pClipFeature.ShapeCopy
65:         pClipPolygon.Project pTemplateSpRef
66:         pGeomArray.Add pClipPolygon
67:         Set pClipFeature = pClipCursor.NextFeature
68:       Loop
69:       Set pInMemFClass = Linkages.MyGeneralOperations.CreateInMemoryFeatureClass(pGeomArray)
70:     Else
71:       Set pInMemFClass = pClipLayer.FeatureClass
72:     End If
73:   End If
  
  Dim booAlreadyHasInfoFolder As Boolean
76:   booAlreadyHasInfoFolder = Linkages.aml_func_mod.ExistFileDir(strOutputFolder & "info")
'  MsgBox "booAlreadyHasInfoFolder = " & CStr(booAlreadyHasInfoFolder)
  
  ' FOR PROGRESS
  Dim lngWorkOrderCount As Long
  Dim lngWorkOrderCounter As Long
82:   lngWorkOrderCount = pAdditionalRasters.Count + 1 + (2 * pAdditionalFeatLayers.Count)
83:   lngWorkOrderCounter = 0
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
87:   Set psbar = pApp.StatusBar
  Dim pPro As IStepProgressor
89:   Set pPro = psbar.ProgressBar
  
  Dim pAddLayer As IRasterLayer
  Dim lngIndex As Long
  
  Dim strReport As String
95:   strReport = "Function failed..."
  
  ' WORKSPACE
  Dim pWsFact As IWorkspaceFactory
99:   Set pWsFact = New RasterWorkspaceFactory
  Dim pWS As IRasterWorkspace
  Dim strWsName As String
102:   strWsName = strOutputFolder
103:   If Right(strWsName, 1) = "\" Then
'    strWsName = strWsName & "\"
105:     strWsName = Left(strWsName, Len(strWsName) - 1)
106:   End If
107:   Set pWS = pWsFact.OpenFromFile(strWsName, 0)
  Dim pOutputNames As esriSystem.IStringArray
109:   Set pOutputNames = New esriSystem.strArray
  Dim strNewName As String
  
  Dim pWorkspace As IWorkspace
113:   Set pWorkspace = pWS
'  MsgBox "Workspace Path = " & pWorkspace.PathName & vbCrLf & "Is Directory = " & CStr(pWorkspace.IsDirectory)
  
  Dim strTemplateName As String
117:   strTemplateName = Linkages.MyGeneralOperations.ReplaceBadChars(pTemplate.Name, True, True, True, False) & ".asc"
118:   strTemplateName = MyGeneralOperations.MakeUniqueShapeFilename(strWsName & "\" & strTemplateName)
  
120:   ExportRastersToAscii = strReport
  
  ' DO ANALYSIS
123:   lngWorkOrderCounter = lngWorkOrderCounter + 1
124:   psbar.ShowProgressBar "Exporting " & pTemplate.Name & " to " & strTemplateName & "...", 1, lngWorkOrderCount, lngWorkOrderCounter, True
125:   DoEvents
  
  Dim pRastExportOp As IRasterExportOp
128:   Set pRastExportOp = New RasterConversionOp
  Dim pRastAnEnv As IRasterAnalysisEnvironment
130:   Set pRastAnEnv = pRastExportOp
  
  Dim dblCellSize As Double
133:   dblCellSize = (pTemplatePnt.X + pTemplatePnt.Y) / 2
  Dim pEnv As IEnvelope
135:   Set pEnv = pTemplateProps.Extent
136:   pEnv.Expand -(pTemplatePnt.X) / 10, -(pTemplatePnt.Y) / 10, False
137:   Set pRastAnEnv.OutSpatialReference = pTemplateSpRef
138:   Set pRastAnEnv.OutWorkspace = pWS
139:   pRastAnEnv.SetCellSize esriRasterEnvValue, dblCellSize
140:   pRastAnEnv.SetExtent esriRasterEnvValue, pEnv, pTemplateRaster
141:   If booShouldClip Then
142:     Set pRastAnEnv.Mask = pInMemFClass
143:   End If
  
  ' EXPORT TEMPLATE RASTER
146:   pRastExportOp.ExportToASCII pTemplateRaster, strTemplateName
  
  ' EXPORT ADDITIONAL RASTERS
  Dim pAddRaster As IRaster
150:   For lngIndex = 0 To pAdditionalRasters.Count - 1
151:     Set pAddLayer = pAdditionalRasters.Element(lngIndex)
152:     Set pAddRaster = pAddLayer.Raster
153:     strNewName = Linkages.MyGeneralOperations.ReplaceBadChars(pAddLayer.Name, True, True, True, False) & ".asc"
154:     strNewName = Linkages.MyGeneralOperations.MakeUniqueShapeFilename(strWsName & "\" & strNewName)
155:     pOutputNames.Add strNewName
    
157:     lngWorkOrderCounter = lngWorkOrderCounter + 1
158:     psbar.Message(1) = "Exporting " & pAddLayer.Name & " to " & strNewName & "..."
159:     pPro.Step
160:     DoEvents
    
162:     pRastExportOp.ExportToASCII pAddRaster, strNewName
163:   Next lngIndex
  
  ' EXPORT ADDITIONAL FEATURE CLASSES
  Dim pAddFeatLayer As IFeatureLayer
  Dim pOutputFNames As esriSystem.IStringArray
168:   Set pOutputFNames = New esriSystem.strArray
  Dim pTempConversionRasterDataset As IRasterDataset
  Dim pConOp As IConversionOp
171:   Set pConOp = New RasterConversionOp
  Dim pTempAnEnv As IRasterAnalysisEnvironment
173:   Set pTempAnEnv = pConOp
174:   Set pTempAnEnv.OutSpatialReference = pTemplateSpRef
175:   Set pTempAnEnv.OutWorkspace = pWS
176:   pTempAnEnv.SetCellSize esriRasterEnvValue, dblCellSize
177:   pTempAnEnv.SetExtent esriRasterEnvValue, pEnv, pTemplateRaster
178:   If booShouldClip Then
179:     Set pTempAnEnv.Mask = pInMemFClass
180:   End If
  
  ' ADDED OCT 31 2009
  Dim pFeatClassDesc As IFeatureClassDescriptor
  Dim pFeatClass As IFeatureClass
  Dim pField As IField
  Dim pSubArray As esriSystem.IVariantArray
  
  
  Dim pFeatGeoDataset As IGeoDataset
  Dim pTempRastDataset As IDataset
  Dim strTempName As String
  
193:   For lngIndex = 0 To pAdditionalFeatLayers.Count - 1
194:     Set pSubArray = pAdditionalFeatLayers.Element(lngIndex)
195:     Set pAddFeatLayer = pSubArray.Element(0)
196:     Set pField = pSubArray.Element(1)
197:     Set pFeatClass = pAddFeatLayer.FeatureClass
198:     Set pFeatGeoDataset = pFeatClass
199:     strNewName = Linkages.MyGeneralOperations.ReplaceBadChars(pAddFeatLayer.Name, True, True, True, False) & ".asc"
200:     strNewName = Linkages.MyGeneralOperations.MakeUniqueShapeFilename(strWsName & "\" & strNewName)
201:     strTempName = Linkages.MyGeneralOperations.MakeUniqueShapeFilename(strWsName & "\" & "CS_Temp")
202:     strTempName = Linkages.aml_func_mod.ReturnFilename(strTempName)
203:     pOutputFNames.Add strNewName
    
205:     lngWorkOrderCounter = lngWorkOrderCounter + 1
206:     psbar.ShowProgressBar "Exporting " & pAddFeatLayer.Name & " to " & strTempName & "...", 1, lngWorkOrderCount, lngWorkOrderCounter, True
'    pPro.Step
208:     DoEvents
    
210:     Set pFeatClassDesc = New FeatureClassDescriptor
211:     pFeatClassDesc.Create pFeatClass, Nothing, pField.Name
    
213:     Set pTempConversionRasterDataset = pConOp.ToRasterDataset(pFeatClassDesc, "GRID", pWS, strTempName)
214:     Set pTempRastDataset = pTempConversionRasterDataset
    
216:     lngWorkOrderCounter = lngWorkOrderCounter + 1
217:     psbar.ShowProgressBar "Exporting " & strTempName & " to " & strNewName & "...", 1, lngWorkOrderCount, lngWorkOrderCounter, True
'    pPro.Step
219:     DoEvents
    
221:     pRastExportOp.ExportToASCII pTempConversionRasterDataset, strNewName
    
223:     Set pTempConversionRasterDataset = Nothing
224:     If pTempRastDataset.CanDelete Then
225:       pTempRastDataset.DELETE
226:     End If
227:     Set pTempRastDataset = Nothing
    
229:   Next lngIndex
  
231:   pRastAnEnv.RestoreToPreviousDefaultEnvironment
  
233:   psbar.HideProgressBar
234:   pPro.position = 0
  
  Dim strBaseString As String
237:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
238:   strBaseString = strBaseString & "\viewkind4\uc1\pard\qc\b\f0\fs16 -- Analysis Complete --\b0 " & vbNewLine
239:   strBaseString = strBaseString & "\par \pard " & vbNewLine
240:   strBaseString = strBaseString & "\par \b Template Raster Layer:\b0 " & vbNewLine
241:   strBaseString = strBaseString & "\par   --> Template Layer = " & pTemplate.Name & vbNewLine
242:   strBaseString = strBaseString & "\par   --> Spatial Reference = " & pTemplateSpRef.Name & vbNewLine
243:   strBaseString = strBaseString & "\par   --> Cell Size:  X = " & CStr(pTemplatePnt.X) & ", Y = " & CStr(pTemplatePnt.Y) & vbNewLine
244:   strBaseString = strBaseString & "\par   --> Raster Size:  " & CStr(pTemplateProps.Width) & " Columns, " & _
        CStr(pTemplateProps.Height) & " Rows" & vbNewLine
246:   strBaseString = strBaseString & "\par   --> Saved as '" & Replace(strTemplateName, "\", "\\") & "'" & vbNewLine
247:   strBaseString = strBaseString & "\par " & vbNewLine
248:   strBaseString = strBaseString & "\par \b Additional Rasters Exported:\b0 " & vbNewLine
  
250:   If pAdditionalRasters.Count > 0 Then
251:     For lngIndex = 0 To pAdditionalRasters.Count - 1
252:       Set pAddLayer = pAdditionalRasters.Element(lngIndex)
253:       strNewName = pOutputNames.Element(lngIndex)
254:       strBaseString = strBaseString & "\par   " & CStr(lngIndex + 1) & "] " & pAddLayer.Name & vbNewLine
255:       strBaseString = strBaseString & "\par       --> Saved as '" & Replace(strNewName, "\", "\\") & "'" & vbNewLine
256:     Next lngIndex
257:   Else
258:     strBaseString = strBaseString & "\par   --> None..." & vbNewLine
259:   End If
  
261:   strBaseString = strBaseString & "\par " & vbNewLine
262:   strBaseString = strBaseString & "\par \b Additional Feature Layers Exported:\b0 " & vbNewLine
  
264:   If pAdditionalFeatLayers.Count > 0 Then
265:     For lngIndex = 0 To pAdditionalFeatLayers.Count - 1
266:       Set pSubArray = pAdditionalFeatLayers.Element(lngIndex)
267:       Set pAddFeatLayer = pSubArray.Element(0)
268:       Set pField = pSubArray.Element(1)
 '     Set pAddFeatLayer = pAdditionalFeatLayers.Element(lngIndex)
270:       strNewName = pOutputFNames.Element(lngIndex)
271:       strBaseString = strBaseString & "\par   " & CStr(lngIndex + 1) & "] " & pAddFeatLayer.Name & _
          ",  Attribute Field = [" & pField.Name & "]" & vbNewLine
273:       strBaseString = strBaseString & "\par       --> Saved as '" & Replace(strNewName, "\", "\\") & "'" & vbNewLine
274:     Next lngIndex
275:   Else
276:     strBaseString = strBaseString & "\par   --> None..." & vbNewLine
277:   End If
  
279:   strBaseString = strBaseString & "\par " & vbNewLine
280:   strBaseString = strBaseString & "\par \b Option to Clip Data to Polygon Layer: " & UCase(CStr(booShouldClip)) & "\b0 " & vbNewLine
281:   If booShouldClip Then
282:     strBaseString = strBaseString & "\par   --> Clip Layer = '" & pClipLayer.Name & "'" & vbNewLine
283:   End If
  
285:   strBaseString = strBaseString & "\par " & vbNewLine
286:   strBaseString = strBaseString & "\par \b All ASCII Rasters Exported To:\b0 " & vbNewLine
287:   strBaseString = strBaseString & "\par \pard   --> " & Replace(strOutputFolder, "\", "\\") & vbNewLine
288:   strBaseString = strBaseString & "\par " & vbNewLine
289:   strBaseString = strBaseString & "\par --------------------------- \par " & vbNewLine
290:   strBaseString = strBaseString & Linkages.MyGeneralOperations.ReturnTimeElapsedRTF(datTimeBegan, Now, 7)
291:   strBaseString = strBaseString & "\par }" & vbNewLine
292:   strBaseString = strBaseString & " " & vbNewLine

294:   strReport = strBaseString
  
296:   ExportRastersToAscii = strReport
  

299:   Set pFeatClassDesc = Nothing
300:   Set pFeatClass = Nothing
301:   Set pSubArray = Nothing
302:   Set pField = Nothing
303:   Set pApp = Nothing
304:   Set pThisExt = Nothing
305:   Set pMxDoc = Nothing
306:   Set pTemplate = Nothing
307:   Set pTemplateRaster = Nothing
308:   Set pTemplateProps = Nothing
309:   Set pTemplateSpRef = Nothing
310:   Set pTemplatePnt = Nothing
311:   Set pAdditionalRasters = Nothing
312:   Set pAdditionalFeatLayers = Nothing
313:   Set psbar = Nothing
314:   Set pPro = Nothing
315:   Set pAddLayer = Nothing
316:   Set pWsFact = Nothing
317:   Set pWS = Nothing
318:   Set pOutputNames = Nothing
319:   Set pWorkspace = Nothing
320:   Set pRastExportOp = Nothing
321:   Set pRastAnEnv = Nothing
322:   Set pEnv = Nothing
323:   Set pAddRaster = Nothing
324:   Set pAddFeatLayer = Nothing
325:   Set pOutputFNames = Nothing
326:   Set pTempConversionRasterDataset = Nothing
327:   Set pConOp = Nothing
328:   Set pTempAnEnv = Nothing
329:   Set pFeatGeoDataset = Nothing
330:   Set pTempRastDataset = Nothing


333:   If Not booAlreadyHasInfoFolder Then
334:     If Linkages.aml_func_mod.ExistFileDir(strWsName & "\info") Then
335:       Kill strWsName & "\info\*.*"
336:       RmDir strWsName & "\info"
337:     End If
338:   End If
  
  Exit Function
ErrorHandler:
  HandleError True, "ExportRastersToAscii " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
