Attribute VB_Name = "GridFunctions"
' GridFunctions:
' Jenness Enterprises
' http://www.jennessent.com
' jeffj@jennessent.com
'--------------------------------------
' AddFieldToVAT - GIVEN A RASTER, FIELDNAME, FIELD TYPE AND FIELD LENGTH, ADDS THE FIELD TO THE VAT.  IF NOT POSSIBLE
'                 (MAYBE USING FLOATING POINT GRID) THEN RETURNS NOTHING. OTHERWISE RETURNS TABLE.
' CalcGridLine - GIVEN pStartPolygon, pEndPolygon, pCorPolygon (FOR BOUNDARY REGION),
'                  pCorRaster As IRaster (FOR COST-DISTANCE), pEnv (IRasterAnalysisEnvironment),
'                  AND OPTIONAL ShouldClean, RETURNS AN IPolyline REPRESENTING LINE FROM START POLYGON TO END POLYGON
' CellValue - GIVEN A POINT AND RASTER, RETURNS CELL VALUE AS VARIANT.  MIGHT NEED TO MODIFY LATER FOR VERY LARGE GRIDS!
' CellValues - GIVEN A POINT COLLECTION AND RASTER, RETURNS CELL VALUES AS VARIANT ARRAY.  MIGHT NEED TO MODIFY LATER FOR VERY LARGE GRIDS!
' ClipRasterToPolygon - GIVEN pRaster As IRaster, pPolygon As IPolygon, SaveInside As Boolean,
'                  OPTIONAL pClipEnvelope, OPTIONAL CellSize, OPTIONAL pEnv (IRasterAnalysisEnvironment), RETURNS IRaster
' CompareSpatialReferences - GIVEN TWO SPATIAL REFERENCES, RETURNS BOOLEAN
' DistributePointsAlongShape - GIVEN ICurve AND SEPARATION DISTANCE, RETURNS A MULTIPOINT OF POINTS ALONG THAT SHAPE
' EllipticArcToPolygon - GIVEN AN ISegmentCollection AND NumVertices, RETURNS Polygon4 BASED ON CONVEX HULL AROUND VERTICES
' EllipticArcToPolygon2 - GIVEN AN ISegmentCollection AND NumVertices, RETURNS IMultipoint
' OpenRasterWorkspace - GIVEN sPath, RETURNS A RASTER WORKSPACE
' ReturnCellCount - GIVEN A RASTER, RETURNS COUNT OF NON-NULL CELLS
' ReturnCellSize - GIVEN A RASTER, RETURNS CELL SIZE BASED ON Y-DIMENSION
' ReturnPixelHeight - GIVEN A RASTER, RETURNS PIXEL HEIGHT (Y-DIMENSION)
' ReturnPixelWidth - GIVEN A RASTER, RETURNS PIXEL WIDTH (X-DIMENSION)
' ReturnPointsByCellSize - GIVEN A RASTER AND LINE, RETURNS IPointCollection WITH POINTS DISTRIBUTED APPROXIMATELY EQUAL TO
'                  CELL SIZE
' SetSpatialAnalysisSettings - GIVEN TargetEnv AND SourceEnv, ASSIGNS PROPERTIES OF SourceEnv TO TargetEnv
' SaveRasterAs -  GIVEN A RASTER BAND COLLECTION, FOLDER PATH, RASTER FILENAME, AND RASTER TYPE, SAVES RASTER AS PERMANENT FILE

Public Enum enumRasterType
   enum_Grid_Type
   enum_Imagine_Type
   enum_TIFF_Type
   enum_JPEG_Type
   enum_JP2000_Type
   enum_BMP_Type
   enum_PNG_Type
   enum_GIF_Type
   enum_PCI_Raster_Type
   enum_X11_Pixmap_Type
   enum_PCRaster_Type
   enum_Memory_Raster_Type
   enum_HDF4_Type
   enum_BIL_Type
   enum_BIP_Type
   enum_BSQ_Type
   enum_IDRISI_Type
   enum_Geodatabase_Type
End Enum

Option Explicit
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\GridFunctions.bas"


Public Function OpenRasterWorkspace(sPath As String) As IRasterWorkspace
  On Error GoTo ErrorHandler

  Dim pWKSF As IWorkspaceFactory
58:   Set pWKSF = New RasterWorkspaceFactory

  Dim pRasterWs As IRasterWorkspace
61:   Set pRasterWs = pWKSF.OpenFromFile(sPath, 0)
62:   Set OpenRasterWorkspace = pRasterWs

  Exit Function
ErrorHandler:
  HandleError True, "OpenRasterWorkspace " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Sub SaveRasterAs(pRasterBandCol As IRasterBandCollection, strPath As String, strName As String, lngRasterType As Long)
  On Error GoTo ErrorHandler
  
  
  ' MODIFICATION TO TRY TO WORK AROUND VB6 BUG
  ' ORIGINAL FUNCTION CALL AS FOLLOWS
  ' Public Sub SaveRasterAs(pRasterBandCol As IRasterBandCollection, strPath As String, strName As String, aRasterType As enumRasterType)
  ' MODIFIED FUNCTION CALL AS FOLLOWS
  ' Public Sub SaveRasterAs(pRasterBandCol As IRasterBandCollection, strPath As String, strName As String, lngRasterType As long)
  
  Dim aRasterType As enumRasterType
79:   aRasterType = lngRasterType
  
  
  
'  MsgBox "GridFunctions - Before: " & strPath
'  strPath = Linkages.aml_func_mod.BasicTrimAvenue(strPath, "", "/\")
'  MsgBox "GridFunctions - After: " & strPath
  
  Dim pSaveAs As IRasterBandCollection
88:   Set pSaveAs = pRasterBandCol
  Dim pRasterWs As IRasterWorkspace
90:   Set pRasterWs = OpenRasterWorkspace(strPath)
91:   If aRasterType = enum_Grid_Type Then
92:     pSaveAs.SaveAs strName, pRasterWs, "GRID"
93:   ElseIf aRasterType = enum_Imagine_Type Then
94:     pSaveAs.SaveAs strName, pRasterWs, "IMAGINE Image"
95:   ElseIf aRasterType = enum_TIFF_Type Then
96:     pSaveAs.SaveAs strName, pRasterWs, "TIFF"
97:   ElseIf aRasterType = enum_JPEG_Type Then
98:     pSaveAs.SaveAs strName, pRasterWs, "JPG"
99:   ElseIf aRasterType = enum_JP2000_Type Then
100:     pSaveAs.SaveAs strName, pRasterWs, "JP2"
101:   ElseIf aRasterType = enum_BMP_Type Then
102:     pSaveAs.SaveAs strName, pRasterWs, "BMP"
103:   ElseIf aRasterType = enum_PNG_Type Then
104:     pSaveAs.SaveAs strName, pRasterWs, "PNG"
105:   ElseIf aRasterType = enum_GIF_Type Then
106:     pSaveAs.SaveAs strName, pRasterWs, "GIF"
107:   ElseIf aRasterType = enum_PCI_Raster_Type Then
108:     pSaveAs.SaveAs strName, pRasterWs, "PIX"
109:   ElseIf aRasterType = enum_X11_Pixmap_Type Then
110:     pSaveAs.SaveAs strName, pRasterWs, "XPM"
111:   ElseIf aRasterType = enum_PCRaster_Type Then
112:     pSaveAs.SaveAs strName, pRasterWs, "MAP"
113:   ElseIf aRasterType = enum_Memory_Raster_Type Then
114:     pSaveAs.SaveAs strName, pRasterWs, "MEM"
115:   ElseIf aRasterType = enum_HDF4_Type Then
116:     pSaveAs.SaveAs strName, pRasterWs, "HDF4"
117:   ElseIf aRasterType = enum_BIL_Type Then
118:     pSaveAs.SaveAs strName, pRasterWs, "BIL"
119:   ElseIf aRasterType = enum_BIP_Type Then
120:     pSaveAs.SaveAs strName, pRasterWs, "BIP"
121:   ElseIf aRasterType = enum_BSQ_Type Then
122:     pSaveAs.SaveAs strName, pRasterWs, "BSQ"
123:   ElseIf aRasterType = enum_IDRISI_Type Then
124:     pSaveAs.SaveAs strName, pRasterWs, "GDB"
125:   ElseIf aRasterType = enum_Geodatabase_Type Then
126:     pSaveAs.SaveAs strName, pRasterWs, "GDB"
127:   End If
  

  Exit Sub
ErrorHandler:
  HandleError True, "SaveRasterAs " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Function ReturnCellSize(pRaster As IRaster) As Double
  On Error GoTo erh
  Dim pRasLayer As IRasterLayer
137:   Set pRasLayer = New RasterLayer
138:   pRasLayer.CreateFromRaster pRaster
  
  Dim pRasterProps As IRasterProps
141:   Set pRasterProps = pRaster
  
  Dim lngNumRows As Long
144:   lngNumRows = pRasLayer.RowCount
  
  Dim pEnvelope As IEnvelope
147:   Set pEnvelope = pRasterProps.Extent
  
149:   ReturnCellSize = pEnvelope.Height / lngNumRows
   
'  Debug.Print "By Rows = " & ReturnCellSize & ",   By Columns = " & pEnvelope.Width / pRasLayer.ColumnCount
  
  Exit Function
erh:
155:     MsgBox "Failed in ReturnCellSize: " & err.Description

End Function
Public Function ReturnPixelHeight(pRaster As IRaster) As Double
  On Error GoTo erh
  Dim pRasLayer As IRasterLayer
161:   Set pRasLayer = New RasterLayer
162:   pRasLayer.CreateFromRaster pRaster
  
  Dim pRasterProps As IRasterProps
165:   Set pRasterProps = pRaster
  
  Dim lngNumRows As Long
168:   lngNumRows = pRasLayer.RowCount
  
  Dim pEnvelope As IEnvelope
171:   Set pEnvelope = pRasterProps.Extent
  
173:   ReturnPixelHeight = pEnvelope.Height / lngNumRows
   
'  Debug.Print "By Rows = " & ReturnCellSize & ",   By Columns = " & pEnvelope.Width / pRasLayer.ColumnCount
  
  Exit Function
erh:
  HandleError True, "ReturnPixelHeight " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4


End Function

Public Function ReturnCellCount(pRaster As IRaster) As Long
  On Error GoTo ErrorHandler

  




  Exit Function
ErrorHandler:
  HandleError True, "ReturnCellCount " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CalcContinuousGridStats(pRaster As IRaster, pRasterStats As IRasterStatistics, _
      lngNumBins As Long) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  
  Dim pRasterAnalysisProps As IRasterAnalysisProps
  Dim pRasterProps As IRasterProps
204:   Set pRasterAnalysisProps = pRaster
205:   Set pRasterProps = pRaster
  
  Dim dblMaximum As Double
  Dim dblMinimum As Double
  Dim dblMean As Double
  Dim dblMedian As Double
  Dim dblMode As Double
  Dim dblStDev As Double
  
  




  Exit Function
ErrorHandler:
  HandleError True, "CalcContinuousGridStats " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnPixelWidth(pRaster As IRaster) As Double
  On Error GoTo erh
  Dim pRasLayer As IRasterLayer
227:   Set pRasLayer = New RasterLayer
228:   pRasLayer.CreateFromRaster pRaster
  
  Dim pRasterProps As IRasterProps
231:   Set pRasterProps = pRaster
  
  Dim lngNumCols As Long
234:   lngNumCols = pRasLayer.ColumnCount
  
  Dim pEnvelope As IEnvelope
237:   Set pEnvelope = pRasterProps.Extent
  
239:   ReturnPixelWidth = pEnvelope.Width / lngNumCols
   
'  Debug.Print "By Rows = " & ReturnCellSize & ",   By Columns = " & pEnvelope.Width / pRasLayer.ColumnCount
  
  Exit Function
erh:
  HandleError True, "ReturnPixelWidth " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

End Function

Public Function ReturnPointsByCellSize(pRaster As IRaster, ByVal pLine As IGeometry) As IPointCollection
  On Error GoTo erh
  
  Dim pCurve As ICurve
  Dim dblLength As Double
  
255:   If TypeOf pLine Is ICurve Then
256:     Set pCurve = pLine
257:     dblLength = pCurve.length
258:   Else
259:     MsgBox "Invalid geometry type!  Must implement 'ICurve'..."
260:     Set ReturnPointsByCellSize = Nothing
    Exit Function
262:   End If
  Dim pPointCollection As IPointCollection
  
  ' CHECK SPATIAL REFERENCES; MIGHT NEED TO PROJECT POLYLINE
  Dim pSrcSpRef As ISpatialReference
  Dim pRasProps As IRasterProps
268:   Set pRasProps = pRaster
269:   Set pSrcSpRef = pRasProps.SpatialReference
  
  Dim pTrgSpRef As ISpatialReference
272:   Set pTrgSpRef = pLine.SpatialReference
  
274:   If Not GridFunctions.CompareSpatialReferences(pSrcSpRef, pTrgSpRef) Then
275:     pLine.Project pSrcSpRef
276:   End If
  
  ' GET GRID CELL SIZE
  Dim dblCellSize As Double
280:   dblCellSize = GridFunctions.ReturnCellSize(pRaster)
  Dim NumPoints As Long
282:   NumPoints = Int(dblLength / dblCellSize) + 1
  
  Dim pMpt As IMultipoint
  Dim pSegCol As ISegmentCollection
286:   Set pSegCol = pLine
287:   Set pMpt = GridFunctions.EllipticArcToPolygon2(pSegCol, NumPoints)
288:   Set pPointCollection = pMpt
  
290:   Set ReturnPointsByCellSize = pPointCollection
    
  Exit Function
erh:
294:   If (Erl <> 0) Then
295:     MsgBox "Failed in ReturnPointsByCellSize: " & err.Description & vbCrLf & "Error at line " & CStr(Erl)
296:   Else
297:     MsgBox "Failed in ReturnPointsByCellSize: " & err.Description & vbCrLf & "No Line Number Available..."
298:   End If

End Function
Public Function CompareSpatialReferences(ByVal pSourceSR As ISpatialReference, ByVal pTargetSR As ISpatialReference) As Boolean
  
  On Error GoTo erh
  
305:   If pSourceSR Is Nothing And pTargetSR Is Nothing Then
306:     CompareSpatialReferences = True
    Exit Function
308:   ElseIf pSourceSR Is Nothing Or pTargetSR Is Nothing Then
309:     CompareSpatialReferences = False
    Exit Function
311:   End If
  
  Dim pSourceClone As IClone
  Dim pTargetClone As IClone
  Dim bSREqual As Boolean
  
317:   Set pSourceClone = pSourceSR
318:   Set pTargetClone = pTargetSR
  
  'Compare the coordinate system component of the spatial reference
321:   bSREqual = pSourceClone.IsEqual(pTargetClone)
  
  'If the comparison failed, return false and exit
324:   If Not bSREqual Then
325:     CompareSpatialReferences = False
    Exit Function
327:   End If
  
  'We can also compare the XY precision to ensure the spatial references are equal
  Dim pSourceSR2 As ISpatialReference2
  Dim bXYIsEqual As Boolean
  
333:   Set pSourceSR2 = pSourceSR
334:   bXYIsEqual = pSourceSR2.IsXYPrecisionEqual(pTargetSR)
  
  'If the comparison failed, return false and exit
337:   If Not bXYIsEqual Then
338:     CompareSpatialReferences = False
    Exit Function
340:   End If
  
342:   CompareSpatialReferences = True
  Exit Function
erh:
345:     MsgBox "Failed in CompareSpatialReferences: " & err.Description
End Function
Sub SetSpatialAnalysisSettings(TargetEnv As IRasterAnalysisEnvironment, _
                               SourceEnv As IRasterAnalysisEnvironment)
    On Error GoTo erh
350:     If Not SourceEnv Is Nothing Then
351:         Set TargetEnv.OutWorkspace = SourceEnv.OutWorkspace
352:         If Not SourceEnv.OutSpatialReference Is Nothing Then
353:             Set TargetEnv.OutSpatialReference = SourceEnv.OutSpatialReference
354:         End If
355:         TargetEnv.DefaultOutputRasterPrefix = SourceEnv.DefaultOutputRasterPrefix
356:         TargetEnv.DefaultOutputVectorPrefix = SourceEnv.DefaultOutputVectorPrefix
357:         If Not SourceEnv.Mask Is Nothing Then
358:             Set TargetEnv.Mask = SourceEnv.Mask
359:         End If
        Dim nCellSize As Double
361:         SourceEnv.GetCellSize 3, nCellSize
362:         If nCellSize <> 0 Then
363:             TargetEnv.SetCellSize 3, nCellSize
364:         End If
        Dim pExtent As IEnvelope
366:         SourceEnv.GetExtent 3, pExtent
367:         If Not pExtent Is Nothing Then
368:             TargetEnv.SetExtent 3, pExtent
369:         End If
370:         TargetEnv.VerifyType = SourceEnv.VerifyType
371:     End If
    Exit Sub
erh:
374:     MsgBox "Failed in SetSpatialAnalysisSettings: " & err.Description
End Sub

Public Function ClipRasterToPolygon(pRaster As IRaster, ByVal pPolygon As IPolygon, SaveInside As Boolean, _
      Optional ByVal pClipEnvelope As IEnvelope, Optional CellSize As Double, _
      Optional ByVal pEnv As IRasterAnalysisEnvironment, Optional booShowProgress As Boolean, _
      Optional pApp As IApplication) As IRaster
      
  On Error GoTo ErrorHandler

  
'  If pPolygon.IsEmpty Then
'    Dim xx As Long
'    xx = 1
'  End If
  
    ' PROGRESS BAR STUFF
391:   If booShowProgress Then
    Dim psbar As IStatusBar
393:     Set psbar = pApp.StatusBar
394:     psbar.ProgressBar.position = 1
    Dim pPro As IStepProgressor
396:     Set pPro = psbar.ProgressBar
397:   End If
  
'  MsgBox "Hello 1"
  
  ' FORCE OBJECT TO BE POLYGON IF THE FIRST SEGMENT IS A CURVE
  Dim booWorkingWithCurves As Boolean
  Dim pSegmentCollectionCurves As ISegmentCollection
'  Dim pSegTopoOp As ITopologicalOperator
'  Set pSegTopoOp = pPolygon
'  Dim pCheckSegLine As IPolyline
'  Set pCheckSegLine = pSegTopoOp.Boundary
408:   Set pSegmentCollectionCurves = pPolygon
  Dim pSegmentCurve As ISegment
410:   Set pSegmentCurve = pSegmentCollectionCurves.Segment(0)
  Dim pGeometryTypeA As esriGeometryType
412:   pGeometryTypeA = pSegmentCurve.GeometryType
  
414:   booWorkingWithCurves = (pGeometryTypeA = esriGeometryBezier3Curve) Or _
    (pGeometryTypeA = esriGeometryCircularArc) Or _
    (pGeometryTypeA = esriGeometryEllipticArc)
  
418:   If booWorkingWithCurves Then
    Dim pNewPoints As IPointCollection
420:     Set pNewPoints = GridFunctions.EllipticArcToPolygon2(pSegmentCollectionCurves, 100)
    Dim pNewPolygon As IPointCollection
422:     Set pNewPolygon = New Polygon
423:     pNewPolygon.SetPointCollection pNewPoints
424:     Set pPolygon = pNewPolygon
425:   End If
    
  
'  MsgBox "Hello 2"
  
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
  
  ' MAKE EXTRACTION OPERATOR
  Dim pExtractionOp As IExtractionOp
435:   Set pExtractionOp = New RasterExtractionOp
  
  Dim pRastAnalysisEnv As IRasterAnalysisEnvironment
  Dim pSpatialReference As ISpatialReference
  Dim pPolySpatRef As ISpatialReference
440:   Set pPolySpatRef = pPolygon.SpatialReference
  Dim SpatRefSame As Boolean
  Dim pEnvelope As IEnvelope
  
444:   If Not pEnv Is Nothing Then
445:     Set pRastAnalysisEnv = pEnv
446:     Set pSpatialReference = pRastAnalysisEnv.OutSpatialReference
    
    ' CHECK SPATIAL REFERENCE OF INCOMING POLYGON
449:     SpatRefSame = CompareSpatialReferences(pSpatialReference, pPolySpatRef)
450:     If Not SpatRefSame Then pPolygon.Project pSpatialReference
451:     pEnv.GetExtent esriRasterEnvValue, pEnvelope
    
453:   Else
    
    ' MAKE ANALYSIS ENVIRONMENT
456:     Set pRastAnalysisEnv = pExtractionOp
457:     pRastAnalysisEnv.RestoreToPreviousDefaultEnvironment
    
    ' ASSIGN CURRENT ANALYSIS ENVIRONMENT SETTINGS
    Dim theEnvType As esriRasterEnvSettingEnum
    Dim theExtEnvType As esriRasterEnvSettingEnum
    Dim pTempEnv As IEnvelope
    Dim theCellSize As Double
464:     pRastAnalysisEnv.GetCellSize theEnvType, theCellSize
465:     pRastAnalysisEnv.GetExtent theExtEnvType, pTempEnv
    Dim pRasterAnalysisProps As IRasterAnalysisProps
    Dim pRasterProps As IRasterProps
468:         Set pRasterAnalysisProps = pRaster
469:         Set pRasterProps = pRaster
    
    ' DETERMINE OUTPUT SPATIAL REFERENCE BASED ON INPUT RASTER
    
473:     Set pSpatialReference = pRasterProps.SpatialReference
    
    ' CHECK SPATIAL REFERENCE OF INCOMING POLYGON
476:     SpatRefSame = CompareSpatialReferences(pSpatialReference, pPolySpatRef)
477:     If Not SpatRefSame Then pPolygon.Project pSpatialReference
    
    ' DETERMINE ANALYSIS ENVIRONMENT TYPE AND CELL SIZE
480:     If CellSize <= 0 Then
481:       theCellSize = pRasterAnalysisProps.PixelHeight
482:       theEnvType = pRastAnalysisEnv.VerifyType
483:     Else
484:       theCellSize = CellSize
485:       theEnvType = esriRasterEnvValue
486:     End If
    
    Dim pTopoOp As ITopologicalOperator2
489:     If pClipEnvelope Is Nothing Then
      Dim pPolyEnvelope As IEnvelope
491:           Set pPolyEnvelope = pPolygon.Envelope
      Dim pRastEnvelope As IEnvelope
493:           Set pRastEnvelope = pRasterProps.Extent
494:           Set pTopoOp = pPolyEnvelope
495:           pTopoOp.IsKnownSimple = False
496:           pTopoOp.Simplify
      
498:       Set pEnvelope = pTopoOp.Intersect(pPolyEnvelope, esriGeometry2Dimension)
499:     Else
      ' CHECK SPATIAL REFERENCE OF ENVELOPE
501:       SpatRefSame = CompareSpatialReferences(pSpatialReference, pClipEnvelope.SpatialReference)
502:       If Not SpatRefSame Then
503:         pClipEnvelope.Project pSpatialReference
504:       End If
505:       Set pEnvelope = pClipEnvelope.Envelope
506:     End If
    
    ' SET ANALYSIS ENVIRONMENT PROPERTIES
509:     pRastAnalysisEnv.SetCellSize theEnvType, theCellSize
510:     pRastAnalysisEnv.SetExtent esriRasterEnvValue, pEnvelope
511:     Set pRastAnalysisEnv.OutSpatialReference = pSpatialReference
512:   End If
  
  
'  MsgBox "Hello 3"
516:   DoEvents
  
  ' CLIP INCOMING POLYGON TO ANALYSIS AREA; MIGHT HELP AVOID PROBLEMS WITH MULTIPART POLYGONS, HOLES, ETC.
  Dim pIntPolygon As IPolygon4
520:   Set pTopoOp = pPolygon
521:   pTopoOp.IsKnownSimple = False
522:   pTopoOp.Simplify
523:   Set pIntPolygon = pTopoOp.Intersect(pEnvelope, esriGeometry2Dimension)
524:   Set pIntPolygon = pPolygon
525:   Set pIntPolygon.SpatialReference = pPolygon.SpatialReference
  
'  ThisDocument.Graphic_MakeFromGeometry pMxDoc, pIntPolygon, "TestClipPolyGraphics"
  
  
530:   Set pTopoOp = pIntPolygon
531:   pTopoOp.IsKnownSimple = False
532:   pTopoOp.Simplify
  
  Dim pGeometryCollection As IGeometryCollection
  Dim pExtRing As IGeometryCollection
  Dim pIntRingBag As IGeometryCollection
537:   Set pGeometryCollection = pIntPolygon.ConnectedComponentBag
  Dim pIntGeoCol As IGeometryCollection
  Dim pIntPoly As IPolygon4
  Dim pOutGeoCol As IGeometryCollection
  Dim pOutPoly As IPolygon4
  
  Dim pSubPoly As IPolygon4
  Dim pSubRing As IRing
  Dim anIndex As Long
  Dim anIndex2 As Long
  
  Dim pClipRaster As IRaster
  Dim pOuterRaster As IRaster
  Dim pInnerRaster As IRaster
  
  Dim pNegativeGeometryCollection As IGeometryCollection
  Dim anIndex3 As Long
  Dim pNegPoly As IPolygon4
  
  ' MAKE A BUNCH OF NEW RASTER OPERATORS AND ASSIGN THE CURRENT ANALYSIS ENVIRONMENT
  Dim pRasMakerOp As IRasterMakerOp
558:   Set pRasMakerOp = New RasterMakerOp
559:   SetSpatialAnalysisSettings pRasMakerOp, pRastAnalysisEnv
  Dim pCondOp As IConditionalOp
561:   Set pCondOp = New RasterConditionalOp
562:   SetSpatialAnalysisSettings pCondOp, pRastAnalysisEnv
  Dim pLogicOp As ILogicalOp
564:   Set pLogicOp = New RasterMathOps
565:   SetSpatialAnalysisSettings pLogicOp, pRastAnalysisEnv
  Dim pMathOp As IMathOp
567:   Set pMathOp = New RasterMathOps
568:   SetSpatialAnalysisSettings pMathOp, pRastAnalysisEnv
  
  Dim pRasLayer As IRasterLayer
  Dim pTestGeometry As IGeometry
  Dim pTestGeoColl As IGeometryCollection
  Dim pSegmentCollection1 As ISegmentCollection
  Dim pSegment1 As ISegment
  Dim pGeometryType As esriGeometryType
  Dim pEllArcPolygon As IPolygon4
  
  Dim pFinalGrid As IRaster
579:   Set pFinalGrid = pRasMakerOp.MakeConstant(0, True)
580:   Set pClipRaster = pRasMakerOp.MakeConstant(1, True)
  
582:   If booShowProgress Then
583:     pPro.MaxRange = pGeometryCollection.GeometryCount + 2
584:     pPro.StepValue = 1
585:     pPro.Show
586:   End If
  
588:   DoEvents
'  MsgBox "Hello 4"
  
591:   For anIndex = 0 To pGeometryCollection.GeometryCount - 1

593:     Set pSubPoly = pGeometryCollection.Geometry(anIndex)
594:     Set pExtRing = pSubPoly.ExteriorRingBag
595:     Set pSubRing = pExtRing.Geometry(0)
596:     Set pOutGeoCol = New Polygon
597:     pOutGeoCol.AddGeometry pSubRing
598:     Set pOutPoly = pOutGeoCol
599:     Set pTopoOp = pOutPoly
600:     pTopoOp.IsKnownSimple = False
601:     pTopoOp.Simplify
    
'    Debug.Print anIndex & ":  Outer ring of Polygon is Circle?  " & CStr(TypeOf pOutPoly Is ICircularArc)

605:     Set pSegmentCollection1 = pOutPoly
606:     Set pSegment1 = pSegmentCollection1.Segment(0)
607:     pGeometryType = pSegment1.GeometryType
    
609:     If pGeometryType = esriGeometryCircularArc Then
610:       Set pOuterRaster = pExtractionOp.Circle(pClipRaster, pSegment1, Not SaveInside)
611:     ElseIf pGeometryType = esriGeometryEllipticArc Then
612:       Set pEllArcPolygon = EllipticArcToPolygon(pSegmentCollection1, 75)
613:       Set pOuterRaster = pExtractionOp.Polygon(pClipRaster, pEllArcPolygon, Not SaveInside)
614:     ElseIf pGeometryType = esriGeometryEnvelope Then
615:       Set pOuterRaster = pExtractionOp.Rectangle(pClipRaster, pOutPoly, Not SaveInside)
616:     Else
617:       Set pOuterRaster = pExtractionOp.Polygon(pClipRaster, pOutPoly, Not SaveInside)
618:     End If
619:     Set pOuterRaster = pLogicOp.IsNull(pOuterRaster)

621:     If pSubPoly.InteriorRingCount(pSubRing) > 0 Then
622:       Set pIntRingBag = pSubPoly.InteriorRingBag(pSubRing)
   
624:       For anIndex2 = 0 To pIntRingBag.GeometryCount - 1
625:         Set pIntGeoCol = New Polygon
626:         pIntGeoCol.AddGeometry pIntRingBag.Geometry(anIndex2)
627:         Set pIntPoly = pIntGeoCol
628:         Set pTopoOp = pIntPoly
629:         pTopoOp.IsKnownSimple = False
630:         pTopoOp.Simplify

632:         Set pSegmentCollection1 = pIntPoly
633:         Set pSegment1 = pSegmentCollection1.Segment(0)
634:         pGeometryType = pSegment1.GeometryType
                   
       ' CHECK FOR UNUSUAL SHAPES
637:         If pGeometryType = esriGeometryCircularArc Then
638:           Set pInnerRaster = pExtractionOp.Circle(pClipRaster, pSegment1, SaveInside)
639:           Set pInnerRaster = pLogicOp.IsNull(pInnerRaster)
640:           Set pOuterRaster = pMathOp.Times(pInnerRaster, pOuterRaster)
641:         ElseIf pGeometryType = esriGeometryEllipticArc Then
642:           Set pEllArcPolygon = EllipticArcToPolygon(pSegmentCollection1, 75)
643:           Set pInnerRaster = pExtractionOp.Polygon(pClipRaster, pEllArcPolygon, SaveInside)
644:           Set pInnerRaster = pLogicOp.IsNull(pInnerRaster)
645:           Set pOuterRaster = pMathOp.Times(pInnerRaster, pOuterRaster)
646:         ElseIf pGeometryType = esriGeometryEnvelope Then
647:           Set pInnerRaster = pExtractionOp.Rectangle(pClipRaster, pIntPoly, SaveInside)
648:           Set pInnerRaster = pLogicOp.IsNull(pInnerRaster)
649:           Set pOuterRaster = pMathOp.Times(pInnerRaster, pOuterRaster)
650:         Else
651:           Set pNegativeGeometryCollection = pIntPoly.ConnectedComponentBag
652:           For anIndex3 = 0 To pNegativeGeometryCollection.GeometryCount - 1
653:             Set pNegPoly = pNegativeGeometryCollection.Geometry(anIndex3)
654:             Set pTopoOp = pNegPoly
655:             pTopoOp.IsKnownSimple = False
656:             pTopoOp.Simplify
657:             Set pInnerRaster = pExtractionOp.Polygon(pClipRaster, pNegPoly, SaveInside)
658:             Set pInnerRaster = pLogicOp.IsNull(pInnerRaster)
659:             Set pOuterRaster = pMathOp.Times(pInnerRaster, pOuterRaster)
660:           Next anIndex3
661:         End If
        
'        ' CHECK FOR UNUSUAL SHAPES
'        If pGeometryType = esriGeometryCircularArc Then
'          Set pInnerRaster = pExtractionOp.Circle(pClipRaster, pSegment1, SaveInside)
'        ElseIf pGeometryType = esriGeometryEllipticArc Then
'          Set pEllArcPolygon = EllipticArcToPolygon(pSegmentCollection1, 75)
'          Set pInnerRaster = pExtractionOp.Polygon(pClipRaster, pEllArcPolygon, SaveInside)
'        ElseIf pGeometryType = esriGeometryEnvelope Then
'          Set pInnerRaster = pExtractionOp.Rectangle(pClipRaster, pIntPoly, SaveInside)
'        Else
'          Set pInnerRaster = pExtractionOp.Polygon(pClipRaster, pIntPoly, SaveInside)
'        End If
'        Set pInnerRaster = pLogicOp.IsNull(pInnerRaster)
'        Set pOuterRaster = pMathOp.Times(pInnerRaster, pOuterRaster)
        
        
678:         DoEvents
679:       Next anIndex2
    
681:     End If
    
683:     Set pFinalGrid = pMathOp.Plus(pFinalGrid, pOuterRaster)
684:     If booShowProgress Then
685:       pPro.Step
686:     End If
687:     DoEvents
688:   Next anIndex
  
  ' FOR DEBUGGING
  
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Dim pMap As IMap
'  Set pMap = pMxDoc.FocusMap
'  Set pRasLayer = New RasterLayer
'  pRasLayer.CreateFromRaster pFinalGrid
'  pMap.AddLayer pRasLayer
 
700:   Set pFinalGrid = pCondOp.SetNull(pLogicOp.EqualTo(pFinalGrid, pRasMakerOp.MakeConstant(0, True)), pFinalGrid)
701:   If booShowProgress Then
702:     pPro.Step
703:   End If
704:   Set ClipRasterToPolygon = pMathOp.Times(pFinalGrid, pRaster)
705:   If booShowProgress Then
706:     pPro.Step
707:   End If
  
709:   DoEvents
  
  ' RESET ANALYSIS ENVIRONMENT TO PREVIOUS STATE
712:   pRastAnalysisEnv.RestoreToPreviousDefaultEnvironment
  
714:   If booShowProgress Then
715:     pPro.Hide
716:   End If

  Exit Function
ErrorHandler:
  HandleError True, "ClipRasterToPolygon " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function EllipticArcToPolygon(SegCollection As ISegmentCollection, NumVertices As Long) As IPolygon4
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
  
'  Dim pEllArc As IEllipticArc
      
On Error GoTo erh

  Dim pCurve As ICurve
  Dim pGeometry As IGeometry
  
  Dim anIndex As Long
  Dim lngSegCount As Long
737:   lngSegCount = SegCollection.SegmentCount - 1
  Dim theLength As Double
739:   theLength = 0
  Dim theTestLength As Double
  Dim lngLengths() As Long
  ReDim lngLengths(lngSegCount)
743:   For anIndex = 0 To lngSegCount
744:     theTestLength = SegCollection.Segment(anIndex).length
745:     theLength = theLength + theTestLength
746:     lngLengths(anIndex) = theTestLength
747:   Next anIndex
  
  Dim pProportion As Double
  Dim lngVertices() As Long
  Dim lngNumVertices As Long
  ReDim lngVertices(lngSegCount)
753:   For anIndex = 0 To lngSegCount
754:     lngNumVertices = Int((lngLengths(anIndex) / theLength) * NumVertices)
755:     If lngNumVertices < 8 Then lngNumVertices = 8
756:     lngVertices(anIndex) = lngNumVertices
757:   Next anIndex
  
  Dim pMpt As IPointCollection
760:   Set pMpt = New Multipoint
  Dim pPoint As IPoint
762:   Set pPoint = New Point
  Dim pClone As IClone
  
  Dim pRatio As Double
  Dim anIndex2 As Long
  
768:   For anIndex = 0 To lngSegCount
769:     lngNumVertices = lngVertices(anIndex)
770:     pRatio = 1 / lngNumVertices
771:     Set pCurve = SegCollection.Segment(anIndex)
    
773:     For anIndex2 = 0 To lngNumVertices
'      If pGeometry.GeometryType = esriGeometryEllipticArc Then
775:       pCurve.QueryPoint 0, (pRatio * anIndex2), True, pPoint
776:       Set pClone = pPoint
        
 '   Graphic_MakeFromGeometry pMxDoc, pPoint, "DeleteMe"
    
780:       pMpt.AddPoint pClone.Clone
781:     Next anIndex2
782:   Next anIndex
  
  Dim pPoly4 As IPolygon4
  Dim pTopoOp2 As ITopologicalOperator2
  Dim pTopoOp3 As ITopologicalOperator3
787:   Set pTopoOp2 = pMpt
788:   Set pPoly4 = pTopoOp2.ConvexHull
789:   Set pTopoOp3 = pPoly4
790:   pTopoOp3.IsKnownSimple = False
791:   pTopoOp3.Simplify
  
793:   Set EllipticArcToPolygon = pPoly4
    Exit Function
  
erh:
797:     MsgBox "Failed in EllipticArcToPolygon: " & err.Description
End Function

Public Function EllipticArcToPolygon2(SegCollection As ISegmentCollection, NumVertices As Long) As IMultipoint
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
  
'  Dim pEllArc As IEllipticArc
      
On Error GoTo erh

  Dim pCurve As ICurve
  Dim pGeometry As IGeometry
  
  Dim anIndex As Long
  Dim lngSegCount As Long
813:   lngSegCount = SegCollection.SegmentCount - 1
  Dim theLength As Double
815:   theLength = 0
  Dim theTestLength As Double
  Dim lngLengths() As Long
  ReDim lngLengths(lngSegCount)
819:   For anIndex = 0 To lngSegCount
820:     theTestLength = SegCollection.Segment(anIndex).length
821:     theLength = theLength + theTestLength
822:     lngLengths(anIndex) = theTestLength
823:   Next anIndex
  
  Dim pProportion As Double
  Dim lngVertices() As Long
  Dim lngNumVertices As Long
  ReDim lngVertices(lngSegCount)
829:   For anIndex = 0 To lngSegCount
830:     lngNumVertices = Int((lngLengths(anIndex) / theLength) * NumVertices)
831:     If lngNumVertices < 8 Then lngNumVertices = 8
832:     lngVertices(anIndex) = lngNumVertices
833:   Next anIndex
  
  Dim pMpt As IPointCollection
836:   Set pMpt = New Multipoint
  Dim pPoint As IPoint
838:   Set pPoint = New Point
  Dim pClone As IClone
  
  Dim pRatio As Double
  Dim anIndex2 As Long
  
844:   For anIndex = 0 To lngSegCount
845:     lngNumVertices = lngVertices(anIndex)
846:     pRatio = 1 / lngNumVertices
847:     Set pCurve = SegCollection.Segment(anIndex)
    
849:     For anIndex2 = 0 To lngNumVertices
'      If pGeometry.GeometryType = esriGeometryEllipticArc Then
851:       pCurve.QueryPoint 0, (pRatio * anIndex2), True, pPoint
852:       Set pClone = pPoint
        
 '   Graphic_MakeFromGeometry pMxDoc, pPoint, "DeleteMe"
    
856:       pMpt.AddPoint pClone.Clone
857:     Next anIndex2
858:   Next anIndex
  
860:   Set EllipticArcToPolygon2 = pMpt
    Exit Function
  
erh:
864:     MsgBox "Failed in EllipticArcToPolygon2: " & err.Description
End Function

Public Function DistributePointsAlongShape(pCurve As ICurve, SeparationDistance As Double) As IPointCollection
      
On Error GoTo erh
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Dim pGeometry As IGeometry
  
  Dim anIndex As Long
  Dim theLength As Double
876:   theLength = pCurve.length
  
  Dim pMpt As IPointCollection
879:   Set pMpt = New Multipoint
  Dim pPoint As IPoint
881:   Set pPoint = New Point
  Dim pClone As IClone
  
  Dim dblRatio As Double
885:   dblRatio = SeparationDistance / theLength
  
  Dim theCurrentDist As Double
888:   theCurrentDist = 0
  
890:   Do While theCurrentDist < 1
891:     pCurve.QueryPoint esriNoExtension, theCurrentDist, True, pPoint
892:     Set pClone = pPoint
893:     pMpt.AddPoint pClone.Clone
'    ThisDocument.Graphic_MakeFromGeometry pMxDoc, pPoint, "TestClipPolyGraphics"
895:     theCurrentDist = theCurrentDist + dblRatio
896:   Loop
897:   pCurve.QueryPoint esriNoExtension, 1, True, pPoint
898:   Set pClone = pPoint
899:   pMpt.AddPoint pClone.Clone
  
  Dim pGeometry As IGeometry
902:   Set pGeometry = pMpt
903:   Set pGeometry.SpatialReference = pCurve.SpatialReference
  
905:   Set DistributePointsAlongShape = pMpt
  
    Exit Function
  
erh:
910:     MsgBox "Failed in DistributePointsAlongShape: " & err.Description
End Function

Public Function CalcGridLine(ByVal pStartPolygon As IPolygon, ByVal pEndPolygon As IPolygon, _
      ByVal pCorPolygon As IPolygon, pCorRaster As IRaster, pEnv As IRasterAnalysisEnvironment, _
      Optional ShouldClean As Boolean) As IPolyline
  On Error GoTo ErrorHandler

  
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
  Dim pClone As IClone
  
  Dim pEnvelope As IEnvelope
924:   pEnv.GetExtent esriRasterEnvValue, pEnvelope
'  Set pEnvelope = pEnv.GetExtent

  'Create a RasterMakerOp operator
  Dim pRasMakerOp As IRasterMakerOp
929:   Set pRasMakerOp = New RasterMakerOp
930:   GridFunctions.SetSpatialAnalysisSettings pRasMakerOp, pEnv

  Dim pSpRef As ISpatialReference
933:   Set pSpRef = pEnv.OutSpatialReference
  
  ' SET POLYGON SPATIAL REFERENCES; PROJECT THEM IF NECESSARY
936:   If Not (GridFunctions.CompareSpatialReferences(pStartPolygon.SpatialReference, pSpRef)) Then
937:     pStartPolygon.Project pSpRef
938:   End If
939:   If Not (GridFunctions.CompareSpatialReferences(pEndPolygon.SpatialReference, pSpRef)) Then
940:     pEndPolygon.Project pSpRef
941:   End If
  
  ' GENERATE A SERIES OF POINTS AROUND THE BOUNDARY OF THE END POLYGON
  Dim pPoints As IPointCollection
945:   Set pPoints = GridFunctions.ReturnPointsByCellSize(pCorRaster, pEndPolygon)
  Dim anIndex As Long
'  For anIndex = 0 To pPoints.PointCount - 1
'    ThisDocument.Graphic_MakeFromGeometry pMxDoc, pPoints.Point(anIndex), "DeleteMatrix"
'  Next anIndex
  
  ' Create the RasterDistanceOp object
  Dim pDistanceOp As IDistanceOp
953:   Set pDistanceOp = New RasterDistanceOp
  
  ' SET ANALYSIS ENVIRONMENT
956:   SetSpatialAnalysisSettings pDistanceOp, pEnv
  
  ' Declare the input source raster object
  Dim pBaseRaster As IRaster
960:   Set pBaseRaster = pRasMakerOp.MakeConstant(1, True)
  Dim pSourceDataset As IRaster
962:   Set pSourceDataset = ClipRasterToPolygon(pBaseRaster, pStartPolygon, True, , , pEnv)
  
  ' Declare the input cost raster object
  Dim pCostDataset As IGeoDataset
  
  ' Declare the output raster object
  Dim pOutputRaster As IGeoDataset
  
  ' Calls the method
971:   Set pOutputRaster = pDistanceOp.CostDistanceFull(pSourceDataset, pCorRaster, True, True, False)
  
  ' To access the backlink raster from the output generated from the above code:
  Dim pRasterBandCollection As IRasterBandCollection
975:   Set pRasterBandCollection = pOutputRaster
  Dim pDistBand As IRasterBand        ' DISTANCE BAND
977:   Set pDistBand = pRasterBandCollection.Item(0)
  Dim pDistRaster As IRasterBandCollection
979:   Set pDistRaster = New Raster
980:   pDistRaster.Add pDistBand, 0
  
  Dim pDistAsRaster As IRaster
983:   Set pDistAsRaster = pDistRaster
  
  Dim pBacklinkBand As IRasterBand    ' BACKLINK BAND
986:   Set pBacklinkBand = pRasterBandCollection.Item(1)
  Dim pBacklinkRaster As IRasterBandCollection
988:   Set pBacklinkRaster = New Raster
989:   pBacklinkRaster.Add pBacklinkBand, 0
  
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Dim pMap As IMap
'  Set pMap = pMxDoc.FocusMap
  
'  ThisDocument.Graphic_MakeFromGeometry pMxDoc, pCleanLine, "TestClipPolyGraphics"
  
'  Dim pRasLayer As IRasterLayer
'  Set pRasLayer = New RasterLayer
'  pRasLayer.CreateFromRaster pCorRaster
'  pMap.AddLayer pRasLayer
'  Dim pRasLayer2 As IRasterLayer
'  Set pRasLayer2 = New RasterLayer
'  pRasLayer2.CreateFromRaster pDistAsRaster
'  pMap.AddLayer pRasLayer2
'  Dim pRasLayer3 As IRasterLayer
'  Set pRasLayer3 = New RasterLayer
'  pRasLayer3.CreateFromRaster pBacklinkRaster
'  pMap.AddLayer pRasLayer3
  
'  Dim pEnumVertices As IEnumVertex
'  Set pEnumVertices = pPoints.EnumVertices
'  Dim pVertex As IPoint
'  Set pVertex = New Point
'  Dim lngPlaceholder As Long
'  Dim lngPlaceholder2 As Long
  
  ' ArcGIS APPEARS TO OCCASIONALLY SCREW UP THE SINGLE BACK PATH FUNCTION.  THEREFORE WE'LL
  ' CREATE THEM ALL
  
  Dim pPathCollection As IGeometryCollection
1022:   Set pPathCollection = pDistanceOp.CostPathAsPolyline(pPoints, pDistAsRaster, pBacklinkRaster)
  ' IF THIS PATH COLLECTION IS EMPTY, THEN LIKELY THAT ONE OF THE POLYGONS DOES NOT INTERSECT ANY GRID CELLS.
  ' THEREFORE CANNOT FIND PATH.
1025:   If pPathCollection.GeometryCount = 0 Then
    Dim pEmptyLine As IPolyline
1027:     Set pEmptyLine = New Polyline
1028:     pEmptyLine.SetEmpty
1029:     Set CalcGridLine = pEmptyLine
    Exit Function
1031:   End If
  
'  Dim pixelWidth As Double, pixelHeight As Double
'  pixelWidth = GridFunctions.ReturnPixelWidth(pDistAsRaster)
'  pixelHeight = GridFunctions.ReturnPixelHeight(pDistAsRaster)
'
'  Dim lngEnvYMax As Long, lngEnvXMin As Long
'  Dim pDistEnv As IEnvelope, pDistProps As IRasterProps
'  Set pDistProps = pDistAsRaster
'  Set pDistEnv = pDistProps.Extent
'  lngEnvYMax = pDistEnv.YMax
'  lngEnvXMin = pDistEnv.XMin
'
'  pEnumVertices.Reset
'  pEnumVertices.QueryNext pVertex, lngPlaceholder, lngPlaceholder2
  
  ' determine which row & col were clicked on
'  Dim lRow As Long, lCol As Long
'  Dim dblMinDist As Double
'  dblMinDist = pDistEnv.Width * pDistEnv.Height
'  Dim pMinPoint As IPoint
'  Set pClone = pVertex
'  Set pMinPoint = pClone.Clone
  
'  Dim pSizePoint As IPnt
'  Dim pPixBlock As IPixelBlock
'  Set pSizePoint = New Pnt
'  pSizePoint.SetCoords 1, 1
'  Dim pTLCPoint As IPnt
'  Dim pSafeArray As Variant
'  Dim dblPixVal As Double
  
'  Do While Not pVertex.IsEmpty
'    lCol = Round(Abs(pVertex.x - lngEnvXMin - (0.5 * pixelWidth)) / pixelWidth)
'    lRow = Round(Abs(pVertex.Y - lngEnvYMax + (0.5 * pixelHeight)) / pixelHeight)
'    Debug.Print "row: " & lRow & ", col " & lCol
    
    ' create a pixel block (that has only one pixel)
    
'    Set pPixBlock = pDistAsRaster.CreatePixelBlock(pSizePoint)
'    Set pTLCPoint = New Pnt
'    pTLCPoint.SetCoords lCol, lRow
'    pDistAsRaster.Read pTLCPoint, pPixBlock
'    pSafeArray = pPixBlock.SafeArray(0)
'    dblPixVal = pSafeArray(0, 0)
'    If dblPixVal < dblMinDist Then
'      dblMinDist = dblPixVal
'      Set pClone = pVertex
'      Set pMinPoint = pClone.Clone
'    End If
 '   Debug.Print "row: " & lRow & ", col " & lCol & ", val = " & dblPixVal & ".   Current min = " & dblMinDist
'    pEnumVertices.QueryNext pVertex, lngPlaceholder, lngPlaceholder2
'  Loop
  
'  Dim pPathPointCol As IPointCollection
'  Set pPathPointCol = New Multipoint
'  pPathPointCol.AddPoint pMinPoint
  
'  Dim pPathCollection As IGeometryCollection
'  Set pPathCollection = pDistanceOp.CostPathAsPolyline(pPathPointCol, pDistAsRaster, pBacklinkRaster)
   
  Dim pPath As IPolyline
  Dim pMinPath As IPolyline
  Dim dblShortDist As Double
1095:   Set pPath = pPathCollection.Geometry(0)
1096:   Set pMinPath = pPath
1097:   dblShortDist = pPath.length
1098:   If pPathCollection.GeometryCount > 1 Then
1099:     For anIndex = 1 To pPathCollection.GeometryCount - 1
1100:       Set pPath = pPathCollection.Geometry(anIndex)
1101:       If pPath.length < dblShortDist Then
1102:         Set pMinPath = pPath
1103:         dblShortDist = pPath.length
1104:       End If
1105:     Next anIndex
1106:   End If
  
  ' CLEAN POLYLINE
  Dim pBoundary As IPolyline
  Dim pTopoOp As ITopologicalOperator
1111:   Set pTopoOp = pCorPolygon
1112:   Set pBoundary = pTopoOp.Boundary
  
  Dim pCleanLine As IPolyline
1115:   If (ShouldClean) Then
1116:     Set pCleanLine = Linkages.CorridorAnalysisFunctions.CleanPolyline(pMinPath, pBoundary)
1117:   Else
1118:     Set pCleanLine = pMinPath
1119:   End If
  
  
'    Dim pixelWidth As Double, pixelHeight As Double
'    pixelWidth = pREnv.Width / pRLayer.ColumnCount
'    pixelHeight = pREnv.Height / pRLayer.RowCount
    
    ' determine which row & col were clicked on
'    Dim lRow As Long, lCol As Long
'    lCol = Round(Abs(pPoint.x - pREnv.XMin - (0.5 * pixelWidth)) / pixelWidth)
'    lRow = Round(Abs(pPoint.Y - pREnv.YMax + (0.5 * pixelHeight)) / pixelHeight)
  
  
  
  
  
  
  
  'pExtractOp.Polygon(pOutRaster, pCorPolygon, True)
  
  'Create a raster layer from the output and add it to ArcMap

'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Dim pMap As IMap
'  Set pMap = pMxDoc.FocusMap
  
'  ThisDocument.Graphic_MakeFromGeometry pMxDoc, pCleanLine, "TestClipPolyGraphics"
  
'  Dim pRasLayer As IRasterLayer
'  Set pRasLayer = New RasterLayer
'  pRasLayer.CreateFromRaster pCorRaster
'  pMap.AddLayer pRasLayer
'  Dim pRasLayer2 As IRasterLayer
'  Set pRasLayer2 = New RasterLayer
'  pRasLayer2.CreateFromRaster pDistAsRaster
'  pMap.AddLayer pRasLayer2
'  Dim pRasLayer3 As IRasterLayer
'  Set pRasLayer3 = New RasterLayer
'  pRasLayer3.CreateFromRaster pBacklinkRaster
'  pMap.AddLayer pRasLayer3
  
'  Set pCorRaster = Nothing
1162:   Set pDistAsRaster = Nothing
1163:   Set pBacklinkRaster = Nothing
1164:   pCleanLine.ReverseOrientation
1165:   Set pCleanLine.SpatialReference = pEnv.OutSpatialReference
1166:   Set CalcGridLine = pCleanLine


  Exit Function
ErrorHandler:
  HandleError True, "CalcGridLine " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CellValues(pPoints As IPointCollection, pRaster As IRaster) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

    Dim pRP As IRasterProps
1179:     Set pRP = pRaster
    
    Dim dblCellSize As Double
1182:     dblCellSize = ReturnCellSize(pRaster)
    
    'Get extent
    Dim pExtent As IEnvelope
1186:     Set pExtent = pRP.Extent
    Dim X1 As Double, Y1 As Double, X2 As Double, Y2 As Double
1188:     pExtent.QueryCoords X1, Y1, X2, Y2
    
    'Get a PixelBloc with cellvalues
    Dim pPB As IPixelBlock3
    Dim dWidth As Double, dHeight As Double
1193:     dWidth = pRP.Width
1194:     dHeight = pRP.Height
  
    'Create a Pnt to hold the PixelBlock size
    Dim pPnt As IPnt
1198:     Set pPnt = New Pnt
1199:     pPnt.SetCoords dWidth, dHeight
     
    'Create a point to set origin
    Dim pOrigin As IPnt
1203:     Set pOrigin = New Pnt
1204:     pOrigin.SetCoords 0, 0
     
    'Create and read entire grid into PixelBlock
1207:     Set pPB = pRaster.CreatePixelBlock(pPnt)
1208:     pRaster.Read pOrigin, pPB
    
    Dim lngIndex As Long
    Dim dblCellValue As Double
    Dim pPoint As IPoint
    Dim dx As Double, dy As Double
    Dim nX As Double, nY As Double
    Dim iX As Long, iY As Long
    
    Dim pOutArray As esriSystem.IVariantArray
1218:     Set pOutArray = New esriSystem.VarArray
    
    Dim vCellValue As Variant
    
1222:     For lngIndex = 0 To pPoints.PointCount - 1
1223:       Set pPoint = pPoints.Point(lngIndex)
      ' RETURN NULL IF OUTSIDE EXTENT
1225:       If pPoint.X < X1 Or pPoint.X > X2 Or pPoint.Y < Y1 Or pPoint.Y > Y2 Then
1226:         pOutArray.Add Null
1227:       Else
    
1229:         dx = pPoint.X - X1
1230:         dy = Y2 - pPoint.Y
        
        'Find ncells from left-top
1233:         nX = dx / dblCellSize
1234:         nY = dy / dblCellSize
        
        'Determine cell index by taking the int. It will also take care of the fact that the index is 0 based
1237:         iX = Int(nX)
1238:         iY = Int(nY)
        
1240:         If (iX < 0) Then iX = 0
1241:         If (iY < 0) Then iY = 0
1242:         If (iX > pRP.Width - 1) Then
1243:           iX = pRP.Width - 1
1244:         End If
1245:         If (iY > pRP.Height - 1) Then
1246:           iY = pRP.Height - 1
1247:         End If
        
        'Read cell values
1250:         vCellValue = pPB.GetVal(0, iX, iY)
1251:         Debug.Print "From CellValues function..." & vCellValue
1252:         If IsEmpty(vCellValue) Then
1253:           pOutArray.Add Null
1254:         Else
1255:           pOutArray.Add CDbl(vCellValue)
1256:         End If
1257:       End If
1258:     Next lngIndex
1259:     Set CellValues = pOutArray
    

  Exit Function
ErrorHandler:
  HandleError True, "CellValues " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CellValue(pPoint As IPoint, pRaster As IRaster) As Variant
  On Error GoTo ErrorHandler

    
'    Dim pRawPixels As IRawPixels
'    Dim pRasterBandCol As IRasterBandCollection
'    Set pRasterBandCol = pRaster
'    Set pRawPixels = pRasterBandCol.Item(0)
'create a point which determines the size for IPixelBlock
'    Dim aoiPNT As IPnt
'    Set aoiPNT = New Pnt
'        aoiPNT.SetCoords 1, 1
'create the IPixelBlock
'    Dim aoiPixelBlock As IPixelBlock
'    Set aoiPixelBlock = pRawPixels.CreatePixelBlock(aoiPNT)
    
    
    
    Dim pRP As IRasterProps
1286:     Set pRP = pRaster
    
    Dim dblCellSize As Double
1289:     dblCellSize = ReturnCellSize(pRaster)
    
    'Get extent
    Dim pExtent As IEnvelope
1293:     Set pExtent = pRP.Extent
    Dim X1 As Double, Y1 As Double, X2 As Double, Y2 As Double
1295:     pExtent.QueryCoords X1, Y1, X2, Y2
    
    ' RETURN NULL IF OUTSIDE EXTENT
1298:     If pPoint.X < X1 Or pPoint.X > X2 Or pPoint.Y < Y1 Or pPoint.Y > Y2 Then
1299:       CellValue = Null
      Exit Function
1301:     End If
    
    ' GET 1-CELL PIXELBLOCK
    'Get cell index from map coordinate
    Dim pCellPoint As IPoint  'Get dx dy from left-top
    Dim dx As Double, dy As Double
1307:     dx = pPoint.X - X1
1308:     dy = Y2 - pPoint.Y
    
    'Find ncells from left-top
    Dim nX As Double, nY As Double
1312:     nX = dx / dblCellSize
1313:     nY = dy / dblCellSize
    
    'Determine cell index by taking the int. It will also take care of the fact that the index is 0 based
    Dim iX As Long, iY As Long
1317:     iX = Int(nX)
1318:     iY = Int(nY)
    
    'If the index is < 0, set it to 0 - do I need this adjustment?
1321:     If (iX < 0) Then iX = 0
1322:     If (iY < 0) Then iY = 0
1323:     If (iX > pRP.Width - 1) Then
1324:       iX = pRP.Width - 1
1325:     End If
1326:     If (iY > pRP.Height - 1) Then
1327:       iY = pRP.Height - 1
1328:     End If
      
    'Create a point from cell index and return
1331:     Set pCellPoint = New Point
1332:     pCellPoint.PutCoords CDbl(iX), CDbl(iY)
    
    'Get a PixelBloc with cellvalues
    Dim pPB As IPixelBlock3
    Dim dWidth As Double, dHeight As Double
1337:     dWidth = pRP.Width
1338:     dHeight = pRP.Height
  
    'Create a Pnt to hold the PixelBlock size
    Dim pPnt As IPnt
1342:     Set pPnt = New Pnt
1343:     pPnt.SetCoords dWidth, dHeight
     
    'Create a point to set origin
    Dim pOrigin As IPnt
1347:     Set pOrigin = New Pnt
1348:     pOrigin.SetCoords 0, 0
     
    'Create and read the PixelBlock
1351:     Set pPB = pRaster.CreatePixelBlock(pPnt)
    
    'Read cell values
1354:     pRaster.Read pOrigin, pPB
    Dim vCellValue As Variant
1356:     vCellValue = pPB.GetVal(0, iX, iY)
1357:     Debug.Print "From function..." & vCellValue
1358:     If IsEmpty(vCellValue) Then
1359:       CellValue = Null
1360:     Else
1361:       CellValue = CDbl(vCellValue)
1362:     End If
    

  Exit Function
ErrorHandler:
  HandleError True, "CellValue " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

