Attribute VB_Name = "LinkagesFunctions2"
Option Explicit
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\LinkagesFunctions2.bas"


Public Function CombineLayers(pDocParams As esriSystem.IVariantArray, pParams As esriSystem.IVariantArray) As String
  On Error GoTo ErrorHandler

  Dim lngMilliseconds As Long
9:   lngMilliseconds = Linkages.MyGeneralOperations.GetTickCount
  Dim datTimeBegan As Date
11:   datTimeBegan = Now
  
  Dim pApp As IApplication
  Dim pMxDoc As IMxDocument
  Dim pThisExt As Linkages.clsExtension
  
17:   Set pApp = pDocParams.Element(0)
18:   Set pMxDoc = pDocParams.Element(1)
19:   Set pThisExt = pDocParams.Element(2)
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
23:   Set psbar = pApp.StatusBar
  Dim pPro As IStepProgressor
25:   Set pPro = psbar.ProgressBar
  

  ' RETURN ARRAY WILL CONTAIN
  ' 0) VARIANT ARRAY OF SELECTED LAYERS
  ' 1) SPATIAL REFERENCE OF EITHER FIRST RASTER LAYER OR FIRST LAYER
  '    NOTE: FUNCTION WILL EXIT IF ANY SPATIAL REFERENCES ARE UNKNOWN OR UNDEFINED, OR IF
  '          RASTERS ARE NOT ALL SAME PROJECTION
  ' 2) BOOLEAN:  WHETHER ANY RASTERS ARE PRESENT
  ' 3) BOOLEAN:  WHETHER TO USE ONLY SELECTED POLYGONS
  ' 4) STRING:  NEW RASTER LAYER LABELS
  ' 5) BOOLEAN: WHETHER TO SET OUTPUT "ZERO" VALUES TO "NODATA"
  ' 6) LONG:  NEW RASTER LAYER TRANSPARENCY
  ' 7) VARIANT ARRAY:  CONTAINS 4 ITEMS
  '     0) OUTPUT AREA RASTER NAME
  '     1) OUTPUT RASTER WORKSPACE PATH
  '     2) OUTPUT RASTER WORKSPACE OBJECT; EITHER IRasterWorkspace or IRasterWorkspaceEx
  '     3) OUTPUT RASTER WORKSPACE TYPE; SHOULD ONLY BE ENUM_FileGDB = 2 OR ENUM_File_Raster = 32
  
  Dim pLayerArray As esriSystem.IArray
  Dim pSpRef As ISpatialReference
  Dim booHasRasters As Boolean
  Dim pOutputArray As esriSystem.IVariantArray
  Dim strOutputName As String
  Dim strOutputPath As String
  Dim lngOutputType As JenDatasetTypes
  Dim pOutputWSEx As IRasterWorkspaceEx
  Dim pOutputWS As IRasterWorkspace2
  Dim pGeneralWS As IWorkspace
  Dim strOutputType As String
  Dim lngIndex As Long
  Dim lngTransparency As Long
  Dim booSetZeroToNoData As Boolean
  Dim booUseSelected As Boolean
  Dim strLabels As String
  
  Dim pOutputRasterStorDef As IRasterStorageDef
  Dim pOutputRasterDef As IRasterDef
  
64:   Set pLayerArray = pParams.Element(0)
65:   Set pSpRef = pParams.Element(1)
66:   booHasRasters = pParams.Element(2)
67:   booUseSelected = pParams.Element(3)
68:   strLabels = pParams.Element(4)
69:   booSetZeroToNoData = pParams.Element(5)
70:   lngTransparency = pParams.Element(6)
71:   Set pOutputArray = pParams.Element(7)
72:   strOutputName = pOutputArray.Element(0)
73:   strOutputPath = pOutputArray.Element(1)
74:   Set pGeneralWS = pOutputArray.Element(2)
75:   lngOutputType = pOutputArray.Element(3)
  
77:   If strLabels <> "" Then
78:     If Left(strLabels, 1) <> " " Then
79:       strLabels = " " & strLabels
80:     End If
81:   End If
  
  Dim pLayer As ILayer
  
  
  Dim pSourceExtent As IEnvelope
  Dim pGeoDataset As IGeoDataset
  Dim pSourceRaster As IRaster
  Dim pSourceProps As IRasterProps
  Dim pRasterLayer As IRasterLayer
  Dim pFeatureLayer As IFeatureLayer
  Dim pFeatureClass As IFeatureClass
  Dim dblCellSize As Double
  Dim dblTempCellSize As Double
  Dim pEnvelopePolygon As IPolygon
  
97:   dblCellSize = -9999
  
  ' REMEMBER TO PUT ALL VECTOR DATASETS IN SAME PROJECTION
  Dim strReport As String
101:   For lngIndex = 0 To pLayerArray.Count - 1
102:     Set pLayer = pLayerArray.Element(lngIndex)
103:     If TypeOf pLayer Is IRasterLayer Then
104:       Set pRasterLayer = pLayer
105:       Set pSourceRaster = pRasterLayer.Raster
106:       Set pSourceProps = pSourceRaster
107:       Set pGeoDataset = pSourceRaster
108:       If dblCellSize < 0 Then
109:         dblCellSize = Linkages.GridFunctions.ReturnCellSize(pSourceRaster)
110:       Else
111:         dblTempCellSize = Linkages.GridFunctions.ReturnCellSize(pSourceRaster)
112:         If dblTempCellSize < dblCellSize Then
113:           dblCellSize = dblTempCellSize
114:         End If
115:       End If
        
117:     Else
118:       Set pFeatureLayer = pLayer
119:       Set pFeatureClass = pFeatureLayer.FeatureClass
120:       Set pGeoDataset = pFeatureClass
121:     End If
    
123:     If pSourceExtent Is Nothing Then
124:       Set pSourceExtent = ReturnProjectedExtent(pGeoDataset.Extent, pSpRef)
125:     Else
126:       pSourceExtent.Union ReturnProjectedExtent(pGeoDataset.Extent, pSpRef)
127:     End If
    
129:     strReport = strReport & "  --> " & pLayer.Name & vbCrLf
130:   Next lngIndex
  
  ' HAVE TO SET THE CELL SIZE IF NO RASTERS FOUND
133:   If dblCellSize < 0 Then
134:     If pSourceExtent.Width > pSourceExtent.Height Then
135:       dblCellSize = pSourceExtent.Width / 1000
136:     Else
137:       dblCellSize = pSourceExtent.Height / 1000
138:     End If
139:   End If
  
  Dim strFormatString As String
  
143:   If lngOutputType = ENUM_FileGDB Then
144:     Set pOutputWSEx = pOutputArray.Element(2)
145:     strOutputType = "File Geodatabase Raster"
146:     strFormatString = "GDB"
'    ' IRasterStorageDef
'    Dim pGeneralStoragePoint As IPnt
'    Set pGeneralStoragePoint = New Pnt
'    pGeneralStoragePoint.SetCoords dblCellSize, dblCellSize
'
'    Set pOutputRasterStorDef = New RasterStorageDef
'    Set pOutputRasterStorDef.CellSize = pGeneralStoragePnt
'    pOutputRasterStorDef.CompressionType = esriRasterSdeCompressionTypeRunLength
'    pOutputRasterStorDef.PyramidLevel = 2
'    pOutputRasterStorDef.PyramidResampleType = RSP_BilinearInterpolation
'    pOutputRasterStorDef.TileHeight = 128
'    pOutputRasterStorDef.TileWidth = 128
'
'    ' IRasterDef
'    Set pOutputRasterDef = New RasterDef
'    Set pOutputRasterDef.SpatialReference = pSpRef
'    pOutputRasterDef.Description = "rasterdataset"
'
'    ' IGeometryDef
'    Set pOutputGeomDef = Nothing
    
168:   Else
169:     Set pOutputWS = pOutputArray.Element(2)
170:     strOutputType = "ESRI Grid"
171:     strFormatString = "GRID"
172:   End If
  
174:   psbar.ShowProgressBar "Combining Datasets", 1, pLayerArray.Count + 1, 1, True
  
  Dim pMapAlg As IMapAlgebraOp
177:   Set pMapAlg = New RasterMapAlgebraOp
  
  Dim pAnalysisEnv As IRasterAnalysisEnvironment
180:   Set pAnalysisEnv = pMapAlg
181:   pAnalysisEnv.SetCellSize esriRasterEnvValue, dblCellSize
182:   pAnalysisEnv.SetExtent esriRasterEnvValue, pSourceExtent
  
  Dim pLogOp As ILogicalOp
185:   Set pLogOp = New RasterMathOps
  Dim pAn2 As IRasterAnalysisEnvironment
187:   Set pAn2 = pLogOp
188:   pAn2.SetCellSize esriRasterEnvValue, dblCellSize
189:   pAn2.SetExtent esriRasterEnvValue, pSourceExtent
  
  Dim pConOp As IConditionalOp
192:   Set pConOp = New RasterConditionalOp
  Dim pAn3 As IRasterAnalysisEnvironment
194:   Set pAn3 = pConOp
195:   pAn3.SetCellSize esriRasterEnvValue, dblCellSize
196:   pAn3.SetExtent esriRasterEnvValue, pSourceExtent
  
  Dim pRasterNull As IRaster
  Dim pRasterAdd As IRaster
  
  Dim pZeroRaster As IRaster
  Dim pMakerOp As IRasterMakerOp
203:   Set pMakerOp = New RasterMakerOp
  Dim pAn4 As IRasterAnalysisEnvironment
205:   Set pAn4 = pMakerOp
206:   pAn4.SetCellSize esriRasterEnvValue, dblCellSize
207:   pAn4.SetExtent esriRasterEnvValue, pSourceExtent
208:   Set pZeroRaster = pMakerOp.MakeConstant(0, True)
  
  Dim pOneRaster As IRaster
211:   Set pOneRaster = pMakerOp.MakeConstant(1, True)
  
  Dim pTempLayer As IRasterLayer
  Dim strCombineString As String
  Dim strRasterName As String
  
  Dim pRasterCombineArray As esriSystem.IArray
218:   Set pRasterCombineArray = New esriSystem.Array
  
  Dim pMathOp As IMathOp
221:   Set pMathOp = New RasterMathOps
  Dim pAn5 As IRasterAnalysisEnvironment
223:   Set pAn5 = pMathOp
224:   pAn5.SetCellSize esriRasterEnvValue, dblCellSize
225:   pAn5.SetExtent esriRasterEnvValue, pSourceExtent
  
  ' FOLLOWING FOR CONVERTING FEATURE CLASSES
  Dim pFClassDescriptor As IFeatureClassDescriptor
  Dim pFieldIndex As Long
  Dim pSelSet As ISelectionSet
  Dim pTempRastDataset As IRasterDataset
  
  ' Create RasterWorkSpaceFactory
  Dim pWSF As IWorkspaceFactory
235:   Set pWSF = New RasterWorkspaceFactory
      
  ' Get RasterWorkspace
  Dim pRasterWs As IRasterWorkspace
  Dim strCurrentWorkspace As String
240:   strCurrentWorkspace = Linkages.aml_func_mod.ReturnDir(Linkages.aml_func_mod.GetMxDocPath(pApp))
241:   If Right(strCurrentWorkspace, 1) = "\" Then
242:     strCurrentWorkspace = Left(strCurrentWorkspace, Len(strCurrentWorkspace) - 1)
243:   End If
244:   Set pRasterWs = pWSF.OpenFromFile(strCurrentWorkspace, 0)
  
  Dim pConvertOp As IConversionOp
247:   Set pConvertOp = New RasterConversionOp
  Dim pAn6 As IRasterAnalysisEnvironment
249:   Set pAn6 = pConvertOp
250:   pAn6.SetCellSize esriRasterEnvValue, dblCellSize
251:   pAn6.SetExtent esriRasterEnvValue, pSourceExtent
252:   Set pAn6.OutSpatialReference = pSpRef
  
  Dim strPolyRasterName As String
  Dim pCumulativeRaster As IRaster
  Dim pRasterZeroToNull As IRaster
  
  Dim pArrayToDelete As esriSystem.IArray
259:   Set pArrayToDelete = New esriSystem.Array
  
261:   For lngIndex = 0 To pLayerArray.Count - 1
262:     Set pLayer = pLayerArray.Element(lngIndex)
263:     psbar.ShowProgressBar "Combining Datasets:  Adding " & pLayer.Name & "...", 1, pLayerArray.Count + 1, lngIndex + 1, True
264:     pPro.position = lngIndex + 1
265:     DoEvents
    
267:     If TypeOf pLayer Is IRasterLayer Then
268:       Set pRasterLayer = pLayer
269:       Set pSourceRaster = pRasterLayer.Raster
      
      ' CONVERT ALL ZERO-VALUES TO NULL-VALUES
272:       Set pRasterZeroToNull = pConOp.SetNull(pLogOp.EqualTo(pSourceRaster, pZeroRaster), pSourceRaster)
      
      ' SET ALL NULL VALUES TO 1, ALL OTHER VALUES TO 0
275:       Set pRasterNull = pLogOp.IsNull(pRasterZeroToNull)
      
277:     Else
278:       Set pFeatureLayer = pLayer
279:       Set pFeatureClass = pFeatureLayer.FeatureClass
280:       Set pGeoDataset = pFeatureClass
      
      ' CONVERT POLYGON LAYER TO RASTER, IN CORRECT PROJECTION
283:       Set pSelSet = ReturnSelSet(pLayer, booUseSelected)
284:       Set pFClassDescriptor = New FeatureClassDescriptor
285:       pFClassDescriptor.CreateFromSelectionSet pSelSet, Nothing, pFeatureClass.Fields.Field(0).Name
      
'      MsgBox "pFClassDescriptor is Nothing = " & CStr(pFClassDescriptor Is Nothing)
288:       strPolyRasterName = Linkages.MyGeneralOperations.MakeUniqueRasterName(32, strCurrentWorkspace, "poly", True)
      
290:       Set pTempRastDataset = pConvertOp.ToRasterDataset(pFClassDescriptor, "GRID", pRasterWs, strPolyRasterName)
291:       Set pSourceRaster = pTempRastDataset.CreateDefaultRaster
      
293:       pArrayToDelete.Add pTempRastDataset
      
      ' SET ALL NULL VALUES TO 1, ALL OTHER VALUES TO 0
296:       Set pRasterNull = pLogOp.IsNull(pSourceRaster)
      
298:     End If
            
    ' FLIP ZERO AND 1 VALUES SO FINAL RASTER CAN BE ADDED TO CUMULATIVE RASTER
301:     Set pRasterAdd = pConOp.Con(pLogOp.EqualTo(pRasterNull, pZeroRaster), pOneRaster, pZeroRaster)
  
303:     If pCumulativeRaster Is Nothing Then
304:       Set pCumulativeRaster = pRasterAdd
305:     Else
306:       Set pCumulativeRaster = pMathOp.Plus(pCumulativeRaster, pRasterAdd)
307:     End If
    
'    strRasterName = "Raster" & CStr(lngIndex + 1)
'    pMapAlg.BindRaster pRasterAdd, strRasterName
'    strCombineString = strCombineString & "[" & strRasterName & "] + "
    
313:     DoEvents
314:   Next lngIndex
  
  ' strCombineString = Left(strCombineString, Len(strCombineString) - 3)
  
  ' SET ZERO VALUES TO NULL IF REQUESTED
'  MsgBox "booSetZeroToNoData = " & CStr(booSetZeroToNoData)
  Dim pFinalRaster As IRaster
321:   If booSetZeroToNoData Then
322:     Set pFinalRaster = pConOp.SetNull(pLogOp.EqualTo(pCumulativeRaster, pZeroRaster), pCumulativeRaster)
323:   Else
324:     Set pFinalRaster = pCumulativeRaster
325:   End If
  
327:   psbar.ShowProgressBar "Combining Datasets: Creating Final Raster Layer...", _
        1, pLayerArray.Count + 1, pLayerArray.Count + 1, True
329:   pPro.position = pLayerArray.Count + 1
330:   DoEvents
  
  Dim pSaveAs As ISaveAs
333:   Set pSaveAs = pFinalRaster
  
  Dim pSumRasterDataset As IRasterDataset
336:   Set pSumRasterDataset = pSaveAs.SaveAs(strOutputName, pGeneralWS, strFormatString)
  
  Dim pNewRasterLayer As IRasterLayer
339:   Set pNewRasterLayer = New RasterLayer
340:   pNewRasterLayer.CreateFromDataset pSumRasterDataset
341:   pNewRasterLayer.Name = "Combined Datasets"
  
  Dim pSumRaster As IRaster
344:   Set pSumRaster = pNewRasterLayer.Raster
  
   ' SYMBOLIZE RASTER LAYER
      ' Get the number of rows from raster table
  Dim pTable As ITable
  Dim pBand As IRasterBand
  Dim pBandCol As IRasterBandCollection
  
352:   Set pBandCol = pSumRasterDataset
353:   Set pBand = pBandCol.Item(0)
  Dim TableExist As Boolean
355:   pBand.HasTable TableExist

  Dim pFSymbol As ISimpleFillSymbol
  Dim pUVRen As IRasterUniqueValueRenderer
  Dim pRasRen As IRasterRenderer
  Dim pWhiteColor As IColor
  Dim pGreenColor As IColor
  Dim pRedColor As IColor
  Dim pYellowColor As IColor
  Dim pRamp1 As IAlgorithmicColorRamp
  Dim pRamp2 As IAlgorithmicColorRamp
  Dim pMultiRamp As IMultiPartColorRamp
  Dim pRow As IRow
  
369:   If TableExist Then
370:     Set pTable = pBand.AttributeTable
    Dim lngNumValues As Integer
372:     lngNumValues = pTable.RowCount(Nothing)
  
    ' Create renderer and QI RasterRenderer
  '  Dim pStretchRen As IRasterStretchColorRampRenderer
  '  Set pStretchRen = New RasterStretchColorRampRenderer
    
  
  ' Create UniqueValue renderer and QI RasterRenderer
380:     Set pUVRen = New RasterUniqueValueRenderer
381:     Set pRasRen = pUVRen
    
    ' Set raster for the renderer and update
384:     Set pRasRen.Raster = pSumRaster
385:     pRasRen.Update
    
    ' COLORS
388:     Set pWhiteColor = New RgbColor
389:     Set pGreenColor = New RgbColor
390:     Set pRedColor = New RgbColor
391:     Set pYellowColor = New RgbColor
    
393:     pWhiteColor.RGB = RGB(255, 255, 255)
394:     pGreenColor.RGB = RGB(0, 140, 0)
395:     pRedColor.RGB = RGB(255, 50, 50)
396:     pYellowColor.RGB = RGB(255, 255, 0)
    
    Dim lngCount1 As Long
    Dim lngCount2 As Long
    


    
    ' CREATE COLOR RAMPS
405:     Set pRamp1 = New AlgorithmicColorRamp
406:     Set pRamp2 = New AlgorithmicColorRamp
407:     Set pMultiRamp = New MultiPartColorRamp
    
409:     pRamp1.Algorithm = esriCIELabAlgorithm
    Dim booUseSecondRamp As Boolean
    
412:     If lngNumValues = 1 Then
      
  '    pRamp1.SIZE = 1
  '    pRamp1.FromColor = pGreenColor
  '    pRamp1.ToColor = pGreenColor
  '    pRamp1.CreateRamp True
418:       booUseSecondRamp = False
    
420:     ElseIf lngNumValues <= 4 Then
      
422:       pRamp1.SIZE = lngNumValues
423:       pRamp1.FromColor = pYellowColor
424:       pRamp1.ToColor = pGreenColor
425:       pRamp1.CreateRamp True
426:       booUseSecondRamp = False
    
428:     Else
        
430:       If lngNumValues Mod 2 = 0 Then
431:         lngCount1 = lngNumValues / 2
432:         lngCount2 = lngCount1
433:       Else
434:         lngCount1 = Int(lngNumValues / 2) + 1
435:         lngCount2 = lngCount1 - 1
436:       End If
      
 '     MsgBox "lngNumValues = " & CStr(lngNumValues) & vbCrLf & _
             "[lngNumValues Mod 2 = 0] = " & CStr(lngNumValues Mod 2 = 0) & vbCrLf & _
             "lngCount1 = " & CStr(lngCount1) & vbCrLf & _
             "lngCount2 = " & CStr(lngCount2)

443:       pRamp1.SIZE = lngCount1
444:       pRamp1.FromColor = pRedColor
445:       pRamp1.ToColor = pYellowColor
446:       pRamp1.CreateRamp True
      
448:       pRamp2.Algorithm = esriCIELabAlgorithm
449:       pRamp2.SIZE = lngCount2
450:       pRamp2.FromColor = pYellowColor
451:       pRamp2.ToColor = pGreenColor
452:       pRamp2.CreateRamp True
  
454:       pMultiRamp.Ramp(0) = pRamp1
455:       pMultiRamp.Ramp(1) = pRamp2
456:       pMultiRamp.SIZE = lngCount1 + lngCount2
457:       pMultiRamp.CreateRamp True
      
459:       booUseSecondRamp = True
    
461:     End If
    
  ' Set UniqueValue renderer
464:     pUVRen.HeadingCount = 1   ' Use one heading
 '   pUVRen.Heading(0) = "Counts"
466:     pUVRen.ClassCount(0) = lngNumValues
467:     pUVRen.Field = "Value"
    
    Dim lngFieldIndex As Long
470:     lngFieldIndex = pTable.FindField("Value")
    
    Dim varLabelValue As Variant
473:     For lngIndex = 0 To lngNumValues - 1
474:         Set pRow = pTable.GetRow(lngIndex) 'Get a row from the table
475:         varLabelValue = pRow.Value(lngFieldIndex)
476:         pUVRen.AddValue 0, lngIndex, varLabelValue  'Get a row from the table
477:         pUVRen.Label(0, lngIndex) = CStr(varLabelValue) & strLabels ' Set label
478:         Set pFSymbol = New SimpleFillSymbol
479:         If CStr(varLabelValue) = "0" Then
480:           pFSymbol.Color = pWhiteColor
481:         Else
482:           If lngNumValues = 1 Then
483:             pFSymbol.Color = pGreenColor
484:           ElseIf booUseSecondRamp Then
485:             pFSymbol.Color = pMultiRamp.Color(lngIndex)
486:           Else
487:             pFSymbol.Color = pRamp1.Color(lngIndex)
488:           End If
489:         End If
490:         pUVRen.Symbol(0, lngIndex) = pFSymbol  'Set symbol
491:     Next lngIndex

    
    ' Plug this colorramp into renderer and select a band
'    pStretchRen.BandIndex = 0
'    pStretchRen.ColorRamp = pMultiRamp
    
    ' Update the renderer with new settings and plug into layer
499:     pRasRen.Update
500:     Set pNewRasterLayer.Renderer = pRasRen
501:   End If
    
  Dim pLayerEffects As ILayerEffects
504:   Set pLayerEffects = pNewRasterLayer
505:   pLayerEffects.Transparency = lngTransparency
506:   pMxDoc.FocusMap.AddLayer pNewRasterLayer
  
508:   CombineLayers = "Layer Count = " & CStr(pLayerArray.Count) & vbCrLf & _
    strReport & vbCrLf & _
    "Spatial Reference = " & pSpRef.Name & vbCrLf & _
    "Has Raster = " & CStr(booHasRasters) & vbCrLf & _
    "New Raster Name = " & strOutputName & vbCrLf & _
    "New Raster Workspace = " & strOutputPath & vbCrLf & _
    "Output Type = " & CStr(lngOutputType)
  
516:   pMxDoc.ActiveView.Refresh
517:   pMxDoc.UpdateContents
  
519:   Set pApp = Nothing
520:   Set pMxDoc = Nothing
521:   Set pThisExt = Nothing
522:   Set psbar = Nothing
523:   Set pPro = Nothing
524:   Set pLayerArray = Nothing
525:   Set pSpRef = Nothing
526:   Set pOutputArray = Nothing
527:   Set pOutputWSEx = Nothing
528:   Set pOutputWS = Nothing
529:   Set pGeneralWS = Nothing
530:   Set pOutputRasterStorDef = Nothing
531:   Set pOutputRasterDef = Nothing
532:   Set pLayer = Nothing
533:   Set pSourceExtent = Nothing
534:   Set pGeoDataset = Nothing
535:   Set pSourceRaster = Nothing
536:   Set pSourceProps = Nothing
537:   Set pRasterLayer = Nothing
538:   Set pFeatureLayer = Nothing
539:   Set pFeatureClass = Nothing
540:   Set pEnvelopePolygon = Nothing
541:   Set pMapAlg = Nothing
542:   Set pAnalysisEnv = Nothing
543:   Set pLogOp = Nothing
544:   Set pAn2 = Nothing
545:   Set pConOp = Nothing
546:   Set pAn3 = Nothing
547:   Set pRasterNull = Nothing
548:   Set pRasterAdd = Nothing
549:   Set pZeroRaster = Nothing
550:   Set pMakerOp = Nothing
551:   Set pAn4 = Nothing
552:   Set pOneRaster = Nothing
553:   Set pTempLayer = Nothing
554:   Set pRasterCombineArray = Nothing
555:   Set pMathOp = Nothing
556:   Set pAn5 = Nothing
557:   Set pFClassDescriptor = Nothing
558:   Set pSelSet = Nothing
559:   Set pTempRastDataset = Nothing
560:   Set pWSF = Nothing
561:   Set pRasterWs = Nothing
562:   Set pConvertOp = Nothing
563:   Set pAn6 = Nothing
564:   Set pCumulativeRaster = Nothing
565:   Set pRasterZeroToNull = Nothing
566:   Set pFinalRaster = Nothing
567:   Set pSaveAs = Nothing
568:   Set pSumRasterDataset = Nothing
569:   Set pNewRasterLayer = Nothing
570:   Set pSumRaster = Nothing
571:   Set pTable = Nothing
572:   Set pBand = Nothing
573:   Set pBandCol = Nothing
574:   Set pFSymbol = Nothing
575:   Set pUVRen = Nothing
576:   Set pRasRen = Nothing
577:   Set pWhiteColor = Nothing
578:   Set pGreenColor = Nothing
579:   Set pRedColor = Nothing
580:   Set pYellowColor = Nothing
581:   Set pRamp1 = Nothing
582:   Set pRamp2 = Nothing
583:   Set pMultiRamp = Nothing
584:   Set pRow = Nothing
585:   Set pLayerEffects = Nothing
  
  ' DELETE DATASETS
  Dim pDeleteDataset As IDataset
  
590:   If pArrayToDelete.Count > 0 Then
591:     For lngIndex = 0 To pArrayToDelete.Count - 1
      
593:       Set pDeleteDataset = pArrayToDelete.Element(lngIndex)
      
595:       If pDeleteDataset.CanDelete Then
596:         pDeleteDataset.DELETE
597:       End If
598:     Next lngIndex
599:   End If
  
601:   Set pDeleteDataset = Nothing
602:   Set pArrayToDelete = Nothing
  

  Exit Function
ErrorHandler:
  HandleError True, "CombineLayers " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnProjectedExtent(pEnvelope As IEnvelope, pSpRef As ISpatialReference) As IEnvelope
  On Error GoTo ErrorHandler


  Dim pOrigSpRef As ISpatialReference
615:   Set pOrigSpRef = pEnvelope.SpatialReference
616:   If Linkages.MyGeneralOperations.CompareSpatialReferences(pOrigSpRef, pSpRef) Then
617:     Set ReturnProjectedExtent = pEnvelope
618:   Else
    Dim pPolygon As IPointCollection
620:     Set pPolygon = New Polygon
    
    Dim pPoint As IPoint
623:     Set pPoint = New Point
    Dim pClone As IClone
    
626:     pPoint.PutCoords pEnvelope.XMin, pEnvelope.YMin
627:     Set pClone = pPoint
628:     pPolygon.AddPoint pClone.Clone
    
630:     pPoint.PutCoords pEnvelope.XMin, pEnvelope.YMax
631:     Set pClone = pPoint
632:     pPolygon.AddPoint pClone.Clone
    
634:     pPoint.PutCoords pEnvelope.XMax, pEnvelope.YMax
635:     Set pClone = pPoint
636:     pPolygon.AddPoint pClone.Clone
    
638:     pPoint.PutCoords pEnvelope.XMax, pEnvelope.YMin
639:     Set pClone = pPoint
640:     pPolygon.AddPoint pClone.Clone
    
    Dim pGeometry As IGeometry
643:     Set pGeometry = pPolygon
644:     Set pGeometry.SpatialReference = pEnvelope.SpatialReference
    
    Dim pTopoOp As ITopologicalOperator
647:     Set pTopoOp = pPolygon
648:     pTopoOp.Simplify
    
650:     pGeometry.Project pSpRef
651:     Set ReturnProjectedExtent = pGeometry.Envelope
652:   End If
  

  Exit Function
ErrorHandler:
  HandleError True, "ReturnProjectedExtent " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnSelSet(pFLayer As IFeatureLayer, booUseSelection As Boolean) As ISelectionSet
  On Error GoTo ErrorHandler

  
  Dim pFClass As IFeatureClass
665:   Set pFClass = pFLayer.FeatureClass
  Dim pCursor As IFeatureCursor
  Dim pNewLayer As IFeatureLayer
  Dim pFeatSel As IFeatureSelection
  Dim pTestSel As ISelectionSet
  
671:   If Not booUseSelection Then
672:     Set pNewLayer = New FeatureLayer
673:     Set pNewLayer.FeatureClass = pFClass
674:     Set pFeatSel = pNewLayer
675:     pFeatSel.SelectFeatures Nothing, esriSelectionResultNew, False
676:     Set pTestSel = pFeatSel.SelectionSet
    
678:   Else
679:     Set pFeatSel = pFLayer
    
681:     If pFeatSel.SelectionSet.Count = 0 Then
682:       Set pNewLayer = New FeatureLayer
683:       Set pNewLayer.FeatureClass = pFClass
684:       Set pFeatSel = pNewLayer
685:       pFeatSel.SelectFeatures Nothing, esriSelectionResultNew, False
686:       Set pTestSel = pFeatSel.SelectionSet
    
688:     Else
689:       Set pTestSel = pFeatSel.SelectionSet
690:     End If
691:   End If
      
693:   Set ReturnSelSet = pTestSel

  Exit Function
ErrorHandler:
  HandleError True, "ReturnSelSet " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

