Attribute VB_Name = "QuickSort"
Option Explicit
Option Compare Binary

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright 1996-2005 VBnet, Randy Birch, All Rights Reserved.
' Some pages may also contain other copyrights by the author.
' see http://vbnet.mvps.org/index.html?code/sort/qsvariations.htm
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Distribution: You can freely use this code in your own
'               applications, but you may not reproduce
'               or publish this code on any web site,
'               online service, or distribute as source
'               on any media without express permission.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' MODIFIED JAN. 4, 2006 BY JEFF JENNESS, TO SIMPLIFY IMPLEMENTATION IN ARCGIS
'-----------------------------------------------------------------------------

Public Sub ByteAscending(nArray() As Byte, inLow As Long, inHi As Long)

   Dim pivot As Byte
   Dim tmpSwap As Byte
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
25:    tmpLow = inLow
26:    tmpHi = inHi
   
28:    pivot = nArray((inLow + inHi) / 2)

30:    While (tmpLow <= tmpHi)
       
32:       While (nArray(tmpLow) < pivot And tmpLow < inHi)
33:          tmpLow = tmpLow + 1
34:       Wend
   
36:       While (pivot < nArray(tmpHi) And tmpHi > inLow)
37:          tmpHi = tmpHi - 1
38:       Wend

40:       If (tmpLow <= tmpHi) Then
41:          tmpSwap = nArray(tmpLow)
42:          nArray(tmpLow) = nArray(tmpHi)
43:          nArray(tmpHi) = tmpSwap
44:          tmpLow = tmpLow + 1
45:          tmpHi = tmpHi - 1
46:       End If
      
48:    Wend
    
50:    If (inLow < tmpHi) Then ByteAscending nArray(), inLow, tmpHi
51:    If (tmpLow < inHi) Then ByteAscending nArray(), tmpLow, inHi

End Sub


Public Sub ByteDescending(nArray() As Byte, inLow As Long, inHi As Long)

   Dim pivot As Byte
   Dim tmpSwap As Byte
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
63:    tmpLow = inLow
64:    tmpHi = inHi
   
66:    pivot = nArray((inLow + inHi) / 2)
   
68:    While (tmpLow <= tmpHi)
        
70:       While (nArray(tmpLow) > pivot And tmpLow < inHi)
71:          tmpLow = tmpLow + 1
72:       Wend
      
74:       While (pivot > nArray(tmpHi) And tmpHi > inLow)
75:          tmpHi = tmpHi - 1
76:       Wend
      
78:       If (tmpLow <= tmpHi) Then
79:          tmpSwap = nArray(tmpLow)
80:          nArray(tmpLow) = nArray(tmpHi)
81:          nArray(tmpHi) = tmpSwap
82:          tmpLow = tmpLow + 1
83:          tmpHi = tmpHi - 1
84:       End If
      
86:    Wend
    
88:    If (inLow < tmpHi) Then ByteDescending nArray(), inLow, tmpHi
89:    If (tmpLow < inHi) Then ByteDescending nArray(), tmpLow, inHi

End Sub
Public Sub LongAscending(nArray() As Long, inLow As Long, inHi As Long)

   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
99:    tmpLow = inLow
100:    tmpHi = inHi
   
102:    pivot = nArray((inLow + inHi) / 2)

104:    While (tmpLow <= tmpHi)
       
106:       While (nArray(tmpLow) < pivot And tmpLow < inHi)
107:          tmpLow = tmpLow + 1
108:       Wend
   
110:       While (pivot < nArray(tmpHi) And tmpHi > inLow)
111:          tmpHi = tmpHi - 1
112:       Wend

114:       If (tmpLow <= tmpHi) Then
115:          tmpSwap = nArray(tmpLow)
116:          nArray(tmpLow) = nArray(tmpHi)
117:          nArray(tmpHi) = tmpSwap
118:          tmpLow = tmpLow + 1
119:          tmpHi = tmpHi - 1
120:       End If
      
122:    Wend
    
124:    If (inLow < tmpHi) Then LongAscending nArray(), inLow, tmpHi
125:    If (tmpLow < inHi) Then LongAscending nArray(), tmpLow, inHi

End Sub


Public Sub LongDescending(nArray() As Long, inLow As Long, inHi As Long)

   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
137:    tmpLow = inLow
138:    tmpHi = inHi
   
140:    pivot = nArray((inLow + inHi) / 2)
   
142:    While (tmpLow <= tmpHi)
        
144:       While (nArray(tmpLow) > pivot And tmpLow < inHi)
145:          tmpLow = tmpLow + 1
146:       Wend
      
148:       While (pivot > nArray(tmpHi) And tmpHi > inLow)
149:          tmpHi = tmpHi - 1
150:       Wend
      
152:       If (tmpLow <= tmpHi) Then
153:          tmpSwap = nArray(tmpLow)
154:          nArray(tmpLow) = nArray(tmpHi)
155:          nArray(tmpHi) = tmpSwap
156:          tmpLow = tmpLow + 1
157:          tmpHi = tmpHi - 1
158:       End If
      
160:    Wend
    
162:    If (inLow < tmpHi) Then LongDescending nArray(), inLow, tmpHi
163:    If (tmpLow < inHi) Then LongDescending nArray(), tmpLow, inHi

End Sub




Public Sub SingleAscending(nArray() As Single, inLow As Long, inHi As Long)

   Dim pivot As Single
   Dim tmpSwap As Single
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
177:    tmpLow = inLow
178:    tmpHi = inHi
   
180:    pivot = nArray((inLow + inHi) / 2)

182:    While (tmpLow <= tmpHi)
       
184:       While (nArray(tmpLow) < pivot And tmpLow < inHi)
185:          tmpLow = tmpLow + 1
186:       Wend
   
188:       While (pivot < nArray(tmpHi) And tmpHi > inLow)
189:          tmpHi = tmpHi - 1
190:       Wend

192:       If (tmpLow <= tmpHi) Then
193:          tmpSwap = nArray(tmpLow)
194:          nArray(tmpLow) = nArray(tmpHi)
195:          nArray(tmpHi) = tmpSwap
196:          tmpLow = tmpLow + 1
197:          tmpHi = tmpHi - 1
198:       End If
      
200:    Wend
    
202:    If (inLow < tmpHi) Then SingleAscending nArray(), inLow, tmpHi
203:    If (tmpLow < inHi) Then SingleAscending nArray(), tmpLow, inHi

End Sub


Public Sub SingleDescending(nArray() As Single, inLow As Long, inHi As Long)

   Dim pivot As Single
   Dim tmpSwap As Single
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
215:    tmpLow = inLow
216:    tmpHi = inHi
   
218:    pivot = nArray((inLow + inHi) / 2)
   
220:    While (tmpLow <= tmpHi)
        
222:       While (nArray(tmpLow) > pivot And tmpLow < inHi)
223:          tmpLow = tmpLow + 1
224:       Wend
      
226:       While (pivot > nArray(tmpHi) And tmpHi > inLow)
227:          tmpHi = tmpHi - 1
228:       Wend
      
230:       If (tmpLow <= tmpHi) Then
231:          tmpSwap = nArray(tmpLow)
232:          nArray(tmpLow) = nArray(tmpHi)
233:          nArray(tmpHi) = tmpSwap
234:          tmpLow = tmpLow + 1
235:          tmpHi = tmpHi - 1
236:       End If
      
238:    Wend
    
240:    If (inLow < tmpHi) Then SingleDescending nArray(), inLow, tmpHi
241:    If (tmpLow < inHi) Then SingleDescending nArray(), tmpLow, inHi

End Sub
Public Sub DoubleAscendingWithObjects(nArray() As Double, varObjArray() As Variant, inLow As Long, inHi As Long)

  Dim pivot As Double
  Dim tmpSwap As Double
  Dim tmpSizeSwap As Variant
  Dim tmpLow As Long
  Dim tmpHi  As Long
   
252:   tmpLow = inLow
253:   tmpHi = inHi
   
255:   pivot = nArray((inLow + inHi) / 2)
256:   While (tmpLow <= tmpHi)
       
258:     While (nArray(tmpLow) < pivot And tmpLow < inHi)
259:        tmpLow = tmpLow + 1
260:     Wend
  
262:     While (pivot < nArray(tmpHi) And tmpHi > inLow)
263:        tmpHi = tmpHi - 1
264:     Wend
265:     If (tmpLow <= tmpHi) Then
266:        tmpSwap = nArray(tmpLow)
267:        nArray(tmpLow) = nArray(tmpHi)
268:        nArray(tmpHi) = tmpSwap
       
270:        tmpSizeSwap = varObjArray(tmpLow)
271:        varObjArray(tmpLow) = varObjArray(tmpHi)
272:        varObjArray(tmpHi) = tmpSizeSwap
       
274:        tmpLow = tmpLow + 1
275:        tmpHi = tmpHi - 1
276:     End If
     
278:   Wend
    
280:   If (inLow < tmpHi) Then DoubleAscendingWithObjects nArray(), varObjArray(), inLow, tmpHi
281:   If (tmpLow < inHi) Then DoubleAscendingWithObjects nArray(), varObjArray(), tmpLow, inHi

End Sub

Public Sub DoubleAscendingWithSizes(nArray() As Double, nSizeArray() As Double, inLow As Long, inHi As Long)

  Dim pivot As Double
  Dim tmpSwap As Double
  Dim tmpSizeSwap As Double
  Dim tmpLow As Long
  Dim tmpHi  As Long
   
293:   tmpLow = inLow
294:   tmpHi = inHi
   
296:   pivot = nArray((inLow + inHi) / 2)
297:   While (tmpLow <= tmpHi)
       
299:     While (nArray(tmpLow) < pivot And tmpLow < inHi)
300:        tmpLow = tmpLow + 1
301:     Wend
  
303:     While (pivot < nArray(tmpHi) And tmpHi > inLow)
304:        tmpHi = tmpHi - 1
305:     Wend
306:     If (tmpLow <= tmpHi) Then
307:        tmpSwap = nArray(tmpLow)
308:        nArray(tmpLow) = nArray(tmpHi)
309:        nArray(tmpHi) = tmpSwap
       
311:        tmpSizeSwap = nSizeArray(tmpLow)
312:        nSizeArray(tmpLow) = nSizeArray(tmpHi)
313:        nSizeArray(tmpHi) = tmpSizeSwap
       
315:        tmpLow = tmpLow + 1
316:        tmpHi = tmpHi - 1
317:     End If
     
319:   Wend
    
321:   If (inLow < tmpHi) Then DoubleAscendingWithSizes nArray(), nSizeArray(), inLow, tmpHi
322:   If (tmpLow < inHi) Then DoubleAscendingWithSizes nArray(), nSizeArray(), tmpLow, inHi

End Sub
Public Sub DoubleAscending(nArray() As Double, inLow As Long, inHi As Long)

   Dim pivot As Double
   Dim tmpSwap As Double
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
332:    tmpLow = inLow
333:    tmpHi = inHi
   
335:    pivot = nArray((inLow + inHi) / 2)

337:    While (tmpLow <= tmpHi)
       
339:       While (nArray(tmpLow) < pivot And tmpLow < inHi)
340:          tmpLow = tmpLow + 1
341:       Wend
   
343:       While (pivot < nArray(tmpHi) And tmpHi > inLow)
344:          tmpHi = tmpHi - 1
345:       Wend

347:       If (tmpLow <= tmpHi) Then
348:          tmpSwap = nArray(tmpLow)
349:          nArray(tmpLow) = nArray(tmpHi)
350:          nArray(tmpHi) = tmpSwap
351:          tmpLow = tmpLow + 1
352:          tmpHi = tmpHi - 1
353:       End If
      
355:    Wend
    
357:    If (inLow < tmpHi) Then DoubleAscending nArray(), inLow, tmpHi
358:    If (tmpLow < inHi) Then DoubleAscending nArray(), tmpLow, inHi

End Sub


Public Sub DoubleDescending(nArray() As Double, inLow As Long, inHi As Long)

   Dim pivot As Double
   Dim tmpSwap As Double
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
370:    tmpLow = inLow
371:    tmpHi = inHi
   
373:    pivot = nArray((inLow + inHi) / 2)
   
375:    While (tmpLow <= tmpHi)
        
377:       While (nArray(tmpLow) > pivot And tmpLow < inHi)
378:          tmpLow = tmpLow + 1
379:       Wend
      
381:       While (pivot > nArray(tmpHi) And tmpHi > inLow)
382:          tmpHi = tmpHi - 1
383:       Wend
      
385:       If (tmpLow <= tmpHi) Then
386:          tmpSwap = nArray(tmpLow)
387:          nArray(tmpLow) = nArray(tmpHi)
388:          nArray(tmpHi) = tmpSwap
389:          tmpLow = tmpLow + 1
390:          tmpHi = tmpHi - 1
391:       End If
      
393:    Wend
    
395:    If (inLow < tmpHi) Then DoubleDescending nArray(), inLow, tmpHi
396:    If (tmpLow < inHi) Then DoubleDescending nArray(), tmpLow, inHi

End Sub

Public Sub StringsAscending(sarray() As String, inLow As Long, inHi As Long)
  
   Dim pivot As String
   Dim tmpSwap As String
   Dim tmpLow As Long
   Dim tmpHi As Long
   
407:    tmpLow = inLow
408:    tmpHi = inHi
   
410:    pivot = sarray((inLow + inHi) / 2)
  
412:    While (tmpLow <= tmpHi)
   
414:       While (sarray(tmpLow) < pivot And tmpLow < inHi)
415:          tmpLow = tmpLow + 1
416:       Wend
      
418:       While (pivot < sarray(tmpHi) And tmpHi > inLow)
419:          tmpHi = tmpHi - 1
420:       Wend
      
422:       If (tmpLow <= tmpHi) Then
423:          tmpSwap = sarray(tmpLow)
424:          sarray(tmpLow) = sarray(tmpHi)
425:          sarray(tmpHi) = tmpSwap
426:          tmpLow = tmpLow + 1
427:          tmpHi = tmpHi - 1
428:       End If
   
430:    Wend
  
432:    If (inLow < tmpHi) Then StringsAscending sarray(), inLow, tmpHi
433:    If (tmpLow < inHi) Then StringsAscending sarray(), tmpLow, inHi

End Sub


Public Sub StringsDescending(sarray() As String, inLow As Long, inHi As Long)
  
   Dim pivot As String
   Dim tmpSwap As String
   Dim tmpLow As Long
   Dim tmpHi As Long
   
445:    tmpLow = inLow
446:    tmpHi = inHi
   
448:    pivot = sarray((inLow + inHi) / 2)
   
450:    While (tmpLow <= tmpHi)
      
452:       While (sarray(tmpLow) > pivot And tmpLow < inHi)
453:          tmpLow = tmpLow + 1
454:       Wend
    
456:       While (pivot > sarray(tmpHi) And tmpHi > inLow)
457:          tmpHi = tmpHi - 1
458:       Wend

460:       If (tmpLow <= tmpHi) Then
461:          tmpSwap = sarray(tmpLow)
462:          sarray(tmpLow) = sarray(tmpHi)
463:          sarray(tmpHi) = tmpSwap
464:          tmpLow = tmpLow + 1
465:          tmpHi = tmpHi - 1
466:       End If
  
468:    Wend
  
470:    If (inLow < tmpHi) Then StringsDescending sarray(), inLow, tmpHi
471:    If (tmpLow < inHi) Then StringsDescending sarray(), tmpLow, inHi

End Sub


Public Sub VariantAscending(sarray() As Variant, inLow As Long, inHi As Long)
  
   Dim pivot As Variant
   Dim tmpSwap As Variant
   Dim tmpLow As Long
   Dim tmpHi As Long
   
483:    tmpLow = inLow
484:    tmpHi = inHi
   
486:    pivot = sarray((inLow + inHi) / 2)
  
488:    While (tmpLow <= tmpHi)
   
490:       While (sarray(tmpLow) < pivot And tmpLow < inHi)
491:          tmpLow = tmpLow + 1
492:       Wend
      
494:       While (pivot < sarray(tmpHi) And tmpHi > inLow)
495:          tmpHi = tmpHi - 1
496:       Wend
      
498:       If (tmpLow <= tmpHi) Then
499:          tmpSwap = sarray(tmpLow)
500:          sarray(tmpLow) = sarray(tmpHi)
501:          sarray(tmpHi) = tmpSwap
502:          tmpLow = tmpLow + 1
503:          tmpHi = tmpHi - 1
504:       End If
   
506:    Wend
  
508:    If (inLow < tmpHi) Then VariantAscending sarray(), inLow, tmpHi
509:    If (tmpLow < inHi) Then VariantAscending sarray(), tmpLow, inHi

End Sub


Public Sub VariantDescending(sarray() As Variant, inLow As Long, inHi As Long)
  
   Dim pivot As Variant
   Dim tmpSwap As Variant
   Dim tmpLow As Long
   Dim tmpHi As Long
   
521:    tmpLow = inLow
522:    tmpHi = inHi
   
524:    pivot = sarray((inLow + inHi) / 2)
   
526:    While (tmpLow <= tmpHi)
      
528:       While (sarray(tmpLow) > pivot And tmpLow < inHi)
529:          tmpLow = tmpLow + 1
530:       Wend
    
532:       While (pivot > sarray(tmpHi) And tmpHi > inLow)
533:          tmpHi = tmpHi - 1
534:       Wend

536:       If (tmpLow <= tmpHi) Then
537:          tmpSwap = sarray(tmpLow)
538:          sarray(tmpLow) = sarray(tmpHi)
539:          sarray(tmpHi) = tmpSwap
540:          tmpLow = tmpLow + 1
541:          tmpHi = tmpHi - 1
542:       End If
  
544:    Wend
  
546:    If (inLow < tmpHi) Then VariantDescending sarray(), inLow, tmpHi
547:    If (tmpLow < inHi) Then VariantDescending sarray(), tmpLow, inHi

End Sub

Public Sub DatesDescending(nArray() As Date, inLow As Long, inHi As Long)

   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
558:    tmpLow = inLow
559:    tmpHi = inHi
   
561:    pivot = DateToJulian(nArray((inLow + inHi) / 2))
   
563:    While (tmpLow <= tmpHi)
        
565:       While DateToJulian(nArray(tmpLow)) > pivot And (tmpLow < inHi)
566:          tmpLow = tmpLow + 1
567:       Wend
      
569:       While (pivot > DateToJulian(nArray(tmpHi))) And (tmpHi > inLow)
570:          tmpHi = tmpHi - 1
571:       Wend
      
573:       If (tmpLow <= tmpHi) Then
574:          tmpSwap = nArray(tmpLow)
575:          nArray(tmpLow) = nArray(tmpHi)
576:          nArray(tmpHi) = tmpSwap
577:          tmpLow = tmpLow + 1
578:          tmpHi = tmpHi - 1
579:       End If
      
581:    Wend
    
583:    If (inLow < tmpHi) Then DatesDescending nArray(), inLow, tmpHi
584:    If (tmpLow < inHi) Then DatesDescending nArray(), tmpLow, inHi

End Sub


Public Sub DatesAscending(nArray() As Date, inLow As Long, inHi As Long)

   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
596:    tmpLow = inLow
597:    tmpHi = inHi
   
599:    pivot = DateToJulian(nArray((inLow + inHi) / 2))

601:    While (tmpLow <= tmpHi)
       
603:       While (DateToJulian(nArray(tmpLow)) < pivot) And (tmpLow < inHi)
604:          tmpLow = tmpLow + 1
605:       Wend
   
607:       While (pivot < DateToJulian(nArray(tmpHi))) And (tmpHi > inLow)
608:          tmpHi = tmpHi - 1
609:       Wend

611:       If (tmpLow <= tmpHi) Then
      
613:          tmpSwap = nArray(tmpLow)
614:          nArray(tmpLow) = nArray(tmpHi)
615:          nArray(tmpHi) = tmpSwap
616:          tmpLow = tmpLow + 1
617:          tmpHi = tmpHi - 1
         
619:       End If
      
621:    Wend
    
623:    If (inLow < tmpHi) Then DatesAscending nArray(), inLow, tmpHi
624:    If (tmpLow < inHi) Then DatesAscending nArray(), tmpLow, inHi

End Sub

Private Function DateToJulian(MyDate As Date) As Long

  'Return a numeric value representing
  'the passed date
632:    DateToJulian = dateValue(MyDate)

End Function
