Attribute VB_Name = "TestCode"
Option Explicit
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\TestCode.bas"

Public Function ExtractValsFromTable(pApp As IApplication, pMxDoc As IMxDocument, _
    pParamsArray As esriSystem.IVariantArray) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler
  
  Dim pUnknown As IUnknown
  Dim pField As IField
  Dim booDoAllRecords As Boolean
  Dim booWeight As Boolean
  Dim strName As String
  
14:   Set pUnknown = pParamsArray.Element(1)
15:   Set pField = pParamsArray.Element(2)
16:   strName = pParamsArray.Element(3)
17:   booWeight = pParamsArray.Element(4)
18:   booDoAllRecords = pParamsArray.Element(5)
  
  Dim pValues As esriSystem.IDoubleArray
  Dim pCounts As esriSystem.IDoubleArray
  
23:   Set pValues = New esriSystem.DoubleArray
24:   If booWeight Then
25:     Set pCounts = New esriSystem.DoubleArray
26:   Else
27:     Set pCounts = Nothing
28:   End If
  
  Dim pSelSet As ISelectionSet
  
32:   If TypeOf pUnknown Is IFeatureLayer Then
    Dim pFLayer As IFeatureLayer
    Dim pFClass As IFeatureClass
    Dim pFeatureCursor As IFeatureCursor
    Dim lngShapeType As Long
    Dim pPoint As IPoint
    Dim pMultipoint As IPointCollection
    Dim pPolygon As IPolygon
    Dim pPolyline As IPolyline
    Dim pArea As IArea
    Dim pGeometry As IGeometry
    Dim dblValue As Double
    Dim lngFieldIndex As Long
    Dim dblWeight As Double
    
47:     Set pFLayer = pUnknown
48:     Set pFClass = pFLayer.FeatureClass
49:     lngShapeType = pFClass.ShapeType
50:     lngFieldIndex = pFClass.FindField(pField.Name)
    
52:     If booDoAllRecords Then
53:       Set pFeatureCursor = pFClass.Search(Nothing, True)
54:     Else
      Dim pFeatureSel As IFeatureSelection
56:       Set pFeatureSel = pFLayer
57:       Set pSelSet = pFeatureSel.SelectionSet
58:       If pSelSet.Count = 0 Then
59:         Set pFeatureCursor = pFClass.Search(Nothing, True)
60:       Else
61:         pSelSet.Search Nothing, True, pFeatureCursor
62:       End If
63:     End If
    
'    Select Case pFeatureClass.ShapeType
'      Case 1
'        strShapeType = "Points"
'      Case 2
'        strShapeType = "Multipoints"
'      Case 3
'        strShapeType = "Polylines"
'      Case 4
'        strShapeType = "Polygons"
'      Case Else
'        strShapeType = "Features"
'    End Select
    
    Dim pFeature As IFeature
79:     Set pFeature = pFeatureCursor.NextFeature
80:     Do Until pFeature Is Nothing
81:       Set pGeometry = pFeature.ShapeCopy
82:       If Not pGeometry.IsEmpty Then
83:         dblValue = pFeature.Value(lngFieldIndex)
84:         pValues.Add dblValue
        
86:         If booWeight Then
          Select Case lngShapeType
            Case 1      ' POINTS
89:               booWeight = False
            
            Case 2      ' MULTIPOINTS
92:               Set pMultipoint = pGeometry
93:               pCounts.Add pMultipoint.PointCount
              
            Case 3      ' POLYLINES
96:               Set pPolyline = pGeometry
97:               pCounts.Add pPolyline.length
              
            Case 4      ' POLYGONS
100:               Set pPolygon = pGeometry
101:               Set pArea = pPolygon
102:               pCounts.Add pArea.Area
              
            Case Else
105:               booWeight = False
              
107:           End Select
108:         End If
109:       End If
      
111:       Set pFeature = pFeatureCursor.NextFeature
112:     Loop
    
114:   ElseIf TypeOf pUnknown Is IStandaloneTable Then
    Dim pStTable As IStandaloneTable
    Dim pTable As ITable
117:     Set pStTable = pUnknown
118:     Set pTable = pStTable.Table
    Dim pCursor As ICursor
    Dim pRow As IRow
    
122:     If booDoAllRecords Then
123:       Set pCursor = pTable.Search(Nothing, True)
124:     Else
      Dim pTableSel As ITableSelection
126:       Set pTableSel = pStTable
127:       Set pSelSet = pTableSel.SelectionSet
128:       If pSelSet.Count = 0 Then
129:         Set pCursor = pTable.Search(Nothing, True)
130:       Else
131:         pSelSet.Search Nothing, True, pCursor
132:       End If
133:     End If
    
135:     Set pRow = pCursor.NextRow
136:     Do Until pRow Is Nothing
137:       dblValue = pRow.Value(lngFieldIndex)
138:       pValues.Add dblValue
      
140:       Set pRow = pCursor.NextRow
141:     Loop
  
143:   End If
  
145:   If Not booWeight Then
146:     Set pCounts = Nothing
147:   End If
  
149:   Set ExtractValsFromTable = New esriSystem.VarArray
150:   ExtractValsFromTable.Add pValues
151:   ExtractValsFromTable.Add pCounts

  Exit Function
ErrorHandler:
  HandleError True, "ExtractValsFromTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ExtractValsFromRasterWithTable(pApp As IApplication, pMxDoc As IMxDocument, _
    pRasterBand As IRasterBand) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  Dim pValues As esriSystem.IDoubleArray
  Dim pCounts As esriSystem.IDoubleArray
  
  Dim pTable As ITable
166:   Set pTable = pRasterBand.AttributeTable
167:   If pTable Is Nothing Then
168:     Set pValues = ExtractValsFromRaster(pApp, pMxDoc, pRasterBand, 100, True)
169:     Set pCounts = Nothing
170:   Else
    
172:     Set pValues = New esriSystem.DoubleArray
173:     Set pCounts = New esriSystem.DoubleArray
    
    Dim pRow As IRow
    Dim lngValIndex As Long
    Dim lngCountIndex As Long
    Dim pCursor As ICursor
    
    Dim dblVal As Double
    Dim lngCount As Long
    
183:     lngValIndex = pTable.FindField("Value")
184:     lngCountIndex = pTable.FindField("Count")
    
186:     Set pCursor = pTable.Search(Nothing, True)
187:     Set pRow = pCursor.NextRow
    
189:     Do Until pRow Is Nothing
190:       dblVal = CDbl(pRow.Value(lngValIndex))
191:       lngCount = pRow.Value(lngCountIndex)
192:       pValues.Add CDbl(dblVal)
193:       pCounts.Add CDbl(lngCount)
194:       Set pRow = pCursor.NextRow
195:     Loop
    
197:   End If
  
199:   Set ExtractValsFromRasterWithTable = New esriSystem.VarArray
200:   ExtractValsFromRasterWithTable.Add pValues
201:   ExtractValsFromRasterWithTable.Add pCounts


  Exit Function
ErrorHandler:
  HandleError True, "ExtractValsFromRasterWithTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ExtractValsFromRaster(pApp As IApplication, pMxDoc As IMxDocument, pRasterBand As IRasterBand, _
  Optional dblProportion As Double = 100, Optional booShowProgress As Boolean, Optional strName As String) As esriSystem.IDoubleArray
  On Error GoTo ErrorHandler


  Dim pRastProps As IRasterProps
215:   Set pRastProps = pRasterBand

  
  Dim lngHeight As Long
  Dim lngWidth As Long
  Dim dblCellSize As Double
  Dim dblNoData As Double
  Dim varNoData As Variant
  
224:   dblCellSize = (pRastProps.MeanCellSize.X + pRastProps.MeanCellSize.Y) / 2
225:   lngWidth = pRastProps.Width
226:   lngHeight = pRastProps.Height
227:   varNoData = pRastProps.NoDataValue
  
229:   dblNoData = CDbl(varNoData)
  
  Dim lngCounter As Long
  Dim lngIncrements() As Long
  Dim lngTotal As Long
  Dim dblStep As Double
  Dim lngNext As Long
  Dim lngPrevious As Long
  Dim lngIncrement As Long
  Dim dblIndex As Double
  
'  Dim dblVals() As Double
'  ReDim dblVals(lngWidth * lngHeight)
  
  Dim lngScenario As Long
244:   If CLng(dblProportion) = 100 Then
245:     lngScenario = 1
246:   Else
    
248:     lngScenario = 2
  
    ' MAKE SAMPLE ARRAY, WHERE EACH VALUE INDICATES THE INCREMENT
251:     lngCounter = -1
252:     lngTotal = CLng(100000 / dblProportion)
253:     dblStep = 100 / dblProportion
254:     lngPrevious = 0
    ReDim lngIncrements(lngTotal)
    
257:     For dblIndex = 0 To lngTotal Step dblStep
258:       lngCounter = lngCounter + 1
259:       lngNext = CLng(dblIndex)
260:       lngIncrement = lngNext - lngPrevious
      
262:       If lngCounter > 0 Then
263:         lngIncrements(lngCounter - 1) = lngIncrement
264:       End If
      
266:       lngPrevious = lngNext
267:     Next dblIndex
    
    ReDim Preserve lngIncrements(lngCounter - 1)

271:   End If
  
  ' PROGRESS STUFF
274:   If booShowProgress Then
    Dim pPro As IStepProgressor
    Dim psbar As IStatusBar
277:     Set psbar = pApp.StatusBar
278:     Set pPro = psbar.ProgressBar
279:     pPro.position = 0
280:     psbar.ShowProgressBar "Analyzing Raster", 1, lngHeight, 1, True
281:     pPro.Message = "Preliminary Analysis:  Extracting Raster Cell Values from " & strName & "..."
282:   End If
  
  Dim pPnt As IPnt
285:   Set pPnt = New Pnt
286:   pPnt.SetCoords lngWidth, 1

  Dim pPixBlock As IPixelBlock3

  Dim pTopLeft As IPnt

  Dim lngIndex As Long
  Dim varNoDataArray As Variant
  Dim booHasData1() As Boolean
  Dim varData1 As Variant
  
  ' MAKE 1-ROW RASTER CURSOR
  Dim pRaster As IRaster2
  Dim pTempBandColl As IRasterBandCollection
300:   Set pTempBandColl = New Raster
301:   pTempBandColl.AppendBand pRasterBand
302:   Set pRaster = pTempBandColl
  Dim pRastCursor As IRasterCursor
304:   Set pRastCursor = pRaster.CreateCursorEx(pPnt)
   
  
307:   Set pPixBlock = pRastCursor.PixelBlock
308:   pPixBlock.PixelType(0) = PT_FLOAT
309:   pRastCursor.Reset
310:   Set pPixBlock = pRastCursor.PixelBlock
311:   varData1 = pPixBlock.PixelData(0)
312:   booHasData1 = ConvertNoDataMaskToSomethingUseful(pPixBlock.NoDataMask(0))
  
  ' BELOW IS WORKAROUND FOR PROBLEM IN WHICH PIXEL BLOCK APPEARS TO NOT BE ABLE TO CORRECTLY READ FIRST ROW.
  ' I THINK THIS HAS SOMETHING TO DO WITH SETTING THE PIXEL TYPE TO PT_FLOAT.  IT READS IT CORRECTLY AFTER
  ' THAT POINT, BUT I CANNOT SET IT BEFORE READING THE FIRST ROW FROM RASTER CURSOR, EVEN AFTER USING 'RESET'.
  ' CODE BELOW SIMPLY EXTRACTS varData1 and booHasData1 FROM A DIFFERENT PIXEL BLOCK THAT IS READ CORRECTLY.
  Dim pTempPixBlock As IPixelBlock3
  Dim pTempRaster As IRaster
320:   Set pTempRaster = pRaster
  Dim pTempPoint As IPnt
322:   Set pTempPoint = New Pnt
323:   pTempPoint.SetCoords lngWidth, 1
324:   Set pTempPixBlock = pTempRaster.CreatePixelBlock(pTempPoint)
325:   pTempPixBlock.PixelType(0) = PT_FLOAT
  Dim pTempOrigin As IPnt
327:   Set pTempOrigin = New Pnt
328:   pTempOrigin.SetCoords 0, 0
329:   pTempRaster.Read pTempOrigin, pTempPixBlock
330:   varData1 = pTempPixBlock.PixelData(0)
331:   booHasData1 = ConvertNoDataMaskToSomethingUseful(pTempPixBlock.NoDataMask(0))
  
  Dim lngDoEventsCounter As Long
334:   lngDoEventsCounter = 0
  
  Dim booShouldContinue As Boolean
337:   booShouldContinue = True
  Dim lngColCounter As Long
  Dim lngRowCounter As Long
340:   lngRowCounter = 1
  
  Dim pReturnArray As esriSystem.IDoubleArray
343:   Set pReturnArray = New esriSystem.DoubleArray

  Dim dblValue As Double
  
  Dim lngValCount As Long
348:   lngValCount = -1
    
350:   If lngScenario = 1 Then   ' IF SAMPLING ALL POINTS
351:     While booShouldContinue
  
      ' REFRESHES THE SCREEN EVERY 5%, HOPEFULLY WILL HELP ARCGIS PROGRESS BAR TO KEEP UPDATING EVEN IF YOU CLICK ON ANOTHER PROGRAM
354:       lngDoEventsCounter = lngDoEventsCounter + 1
355:       If lngDoEventsCounter > (lngHeight / 5) Then
356:         lngDoEventsCounter = 0
357:         DoEvents
358:       End If
  
360:       For lngColCounter = 0 To lngWidth - 1
361:         If booHasData1(lngColCounter) Then
'          Debug.Print varData1(lngColCounter, 0)
363:           pReturnArray.Add varData1(lngColCounter, 0)
'          lngValCount = lngValCount + 1
'          dblVals(lngValCount) = varData1(lngColCounter, 0)
366:         End If
367:       Next lngColCounter
  
369:       booShouldContinue = pRastCursor.Next
370:       If booShowProgress Then
371:         pPro.Step
372:       End If
      
374:       If booShouldContinue Then
375:         Set pPixBlock = pRastCursor.PixelBlock
376:         pPixBlock.PixelType(0) = PT_FLOAT
377:         varNoDataArray = pPixBlock.NoDataMask(0)
378:         booHasData1 = ConvertNoDataMaskToSomethingUseful(varNoDataArray)
379:         varData1 = pPixBlock.PixelData(0)
380:         lngRowCounter = lngRowCounter + 1
381:       End If
382:     Wend
    
384:   ElseIf lngScenario = 2 Then
385:     lngColCounter = 0
386:     lngIndex = 0
387:     lngRowCounter = 1
388:     While booShouldContinue
      
390:       If lngRowCounter >= 330 Then
391:         lngRowCounter = lngRowCounter
392:       End If
      
394:       dblValue = CDbl(varData1(lngColCounter, 0))
      ' GET VALUE AND ADD IT TO ARRAY
396:       If booHasData1(lngColCounter) Then
397:         pReturnArray.Add dblValue
398:       End If
      
'      Debug.Print "Index " & CStr(lngIndex) & "]  Row " & CStr(lngRowCounter) & _
        "; Column " & CStr(lngColCounter) & _
        ":  Value = " & CStr(dblValue) & _
        "....Added = " & CStr(booHasData1(lngColCounter))
         
      ' GET INCREMENT TO ADD TO CURRENT COLUMN INDEX
406:       lngIncrement = lngIncrements(lngIndex)
      
      ' INCREMENT INDEX BY ONE, AND RESET TO BEGINNING OF LIST IF IT HAS REACHED THE END
409:       lngIndex = lngIndex + 1
410:       If lngIndex > UBound(lngIncrements) Then lngIndex = 0
      
      ' GET NEW COLUMN INDEX BASED ON PREVIOUS VALUE + INCREMENT
413:       lngColCounter = lngColCounter + lngIncrement
      
      ' IF PAST END OF ROW, THEN MOVE RASTER CURSOR TO NEXT PIXEL BLOCK
416:       While lngColCounter > lngWidth - 1
417:         lngColCounter = lngColCounter - lngWidth
  
419:         booShouldContinue = pRastCursor.Next
420:         If booShowProgress Then
421:           pPro.Step
422:         End If
        
424:         If booShouldContinue Then
425:           Set pPixBlock = pRastCursor.PixelBlock
426:           pPixBlock.PixelType(0) = PT_FLOAT
427:           varNoDataArray = pPixBlock.NoDataMask(0)
428:           booHasData1 = ConvertNoDataMaskToSomethingUseful(varNoDataArray)
429:           varData1 = pPixBlock.PixelData(0)
430:           lngRowCounter = lngRowCounter + 1
431:         End If
432:       Wend
433:     Wend
  
435:   End If
  
'  ReDim dblVals(lngValCount)
'  ExtractValsFromRaster = dblVals
    
440:   If booShowProgress Then
441:     psbar.HideProgressBar
442:   End If
  
444:   Set ExtractValsFromRaster = pReturnArray
  

  Exit Function
ErrorHandler:
  HandleError True, "ExtractValsFromRaster " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ConvertNoDataMaskToSomethingUseful(varNoData As Variant) As Boolean()
  On Error GoTo ErrorHandler


  Dim lngIndex As Long
  
  Dim booReturn() As Boolean
  ReDim booReturn(((UBound(varNoData) + 1) * 8) - 1)
  Dim lngIntermediate As Long
  
463:   For lngIndex = 0 To UBound(varNoData)
464:     lngIntermediate = CLng(varNoData(lngIndex))
465:     booReturn(lngIndex * 8) = CBool(lngIntermediate And 128)
466:     booReturn((lngIndex * 8) + 1) = CBool(lngIntermediate And 64)
467:     booReturn((lngIndex * 8) + 2) = CBool(lngIntermediate And 32)
468:     booReturn((lngIndex * 8) + 3) = CBool(lngIntermediate And 16)
469:     booReturn((lngIndex * 8) + 4) = CBool(lngIntermediate And 8)
470:     booReturn((lngIndex * 8) + 5) = CBool(lngIntermediate And 4)
471:     booReturn((lngIndex * 8) + 6) = CBool(lngIntermediate And 2)
472:     booReturn((lngIndex * 8) + 7) = CBool(lngIntermediate And 1)
473:   Next lngIndex
  
475:   ConvertNoDataMaskToSomethingUseful = booReturn
  

  Exit Function
ErrorHandler:
  HandleError True, "ConvertNoDataMaskToSomethingUseful " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


