VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdHistogramStats"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_pApp As IApplication
Private m_pMxDoc As IMxDocument
Private m_bitmap As IPictureDisp
Private m_ExtensionConfig As IExtensionConfig

Implements ICommand
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "D:\arcGIS_stuff\saguaro\cmdHistogramStats.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler

16:   Set m_bitmap = LoadResPicture(102, vbResBitmap)

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler

26:   Set m_bitmap = Nothing
27:   Set m_pMxDoc = Nothing
28:   Set m_pApp = Nothing
29:   Set m_ExtensionConfig = Nothing

  Exit Sub
ErrorHandler:
  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler
  
  Dim booHasExtension As Boolean
40:   If (Not m_ExtensionConfig Is Nothing) Then
41:     If (m_ExtensionConfig.State = esriESEnabled) Then
42:       booHasExtension = True
43:     End If
44:   Else
45:     booHasExtension = False
46:   End If

  Dim pMxDoc As IMxDocument
49:   Set pMxDoc = m_pMxDoc

  Dim theMaps As IMaps
52:   Set theMaps = pMxDoc.Maps

  Dim boolShouldEnable As Boolean
55:   boolShouldEnable = False

  Dim theMap As IMap
  Dim theSTCol As IStandaloneTableCollection
  Dim pStandaloneTable As IStandaloneTable

  Dim pEnumLayer As IEnumLayer
  Dim pLayer As Variant
  Dim anIndex As Integer

  Dim pTableSelection As ITableSelection
  Dim pSelectionSet As ISelectionSet
  Dim pFeatureLayer As IFeatureLayer
  Dim anIndex2 As Long

70:   For anIndex = 0 To theMaps.Count - 1
71:     Set theMap = theMaps.Item(anIndex)
72:     Set theSTCol = theMap

74:     If (theSTCol.StandaloneTableCount > 0) Then
75:       For anIndex2 = 0 To theSTCol.StandaloneTableCount - 1
76:         Set pStandaloneTable = theSTCol.StandaloneTable(anIndex2)
77:         Set pTableSelection = pStandaloneTable
78:         Set pSelectionSet = pTableSelection.SelectionSet
79:         If Not pSelectionSet Is Nothing Then
80:           If pSelectionSet.Count > 0 Then
81:             boolShouldEnable = True
82:             Exit For
83:           End If
84:         End If
85:       Next anIndex2
86:       If boolShouldEnable Then
87:         Exit For
88:       End If
89:     End If

91:     If (theMap.LayerCount > 0) Then
92:       Set pEnumLayer = theMap.Layers
93:       pEnumLayer.Reset

95:       Set pLayer = pEnumLayer.Next
96:       If TypeOf pLayer Is IFeatureLayer Then
97:         Set pFeatureLayer = pLayer
98:         Set pTableSelection = pFeatureLayer
99:         Set pSelectionSet = pTableSelection.SelectionSet
100:         If Not pSelectionSet Is Nothing Then
101:           If pSelectionSet.Count > 0 Then
102:             boolShouldEnable = True
103:             Exit For
104:           End If
105:         End If
106:       End If

108:       Do Until pLayer Is Nothing Or boolShouldEnable
  '      Debug.Print "  --> " & pLayer.Name
110:         If TypeOf pLayer Is IFeatureLayer Then
111:           Set pFeatureLayer = pLayer
112:           Set pTableSelection = pFeatureLayer
113:           Set pSelectionSet = pTableSelection.SelectionSet
114:           If Not pSelectionSet Is Nothing Then
115:             If pSelectionSet.Count > 0 Then
116:               boolShouldEnable = True
117:               Exit For
118:             End If
119:           End If
120:         End If
121:         Set pLayer = pEnumLayer.Next
122:       Loop

124:       If boolShouldEnable Then
125:         Exit For
126:       End If
127:     End If
128:   Next anIndex

130:   ICommand_Enabled = boolShouldEnable And booHasExtension
'  ICommand_Enabled = True

  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
143:    ICommand_Checked = False


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
156:   ICommand_Name = "CorridorDesigner_StatisticsHistogramCommand"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
169:   ICommand_Caption = "ArcGIS Statistics"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
182:   ICommand_Tooltip = "Statistics on Selected Features"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
195:   ICommand_Message = "Open the standard ArcGIS statistics window, including simple statistics on selected features..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
208:   ICommand_HelpFile = ""


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
221:   ICommand_HelpContextID = 0


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
234:   ICommand_Bitmap = m_bitmap.Handle


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
247:   ICommand_Category = "Corridor Designer Tools"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler


259:   Set m_pApp = hook
260:   Set m_pMxDoc = m_pApp.Document
  
  Dim newUid As New uID
263:   newUid.Value = "Linkages.clsExtension"
264:   Set m_ExtensionConfig = m_pApp.FindExtensionByCLSID(newUid)


  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler

  
  Dim u As New uID
277:   u.Value = "{3E58D6D0-DF7A-11D1-ADD9-080009EC732A}"
  
  Dim pCmdItem As ICommandItem
280:   Set pCmdItem = m_pApp.Document.CommandBars.Find(u)
281:   pCmdItem.Execute


  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

