VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cmdSummarize"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_App As IApplication
Private m_mxDoc As IMxDocument
Private m_bitmap As IPictureDisp

Implements ICommand
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "D:\arcGIS_stuff\saguaro\cmdSummarize.cls"

 
Private Sub Class_Initialize()
  On Error GoTo ErrorHandler


  Set m_bitmap = LoadResPicture(118, vbResBitmap)


  Exit Sub
ErrorHandler:
  HandleError True, "Class_Initialize " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Sub Class_Terminate()
  On Error GoTo ErrorHandler


  Set m_bitmap = Nothing
  Set m_App = Nothing
  Set m_mxDoc = Nothing


  Exit Sub
ErrorHandler:

  HandleError True, "Class_Terminate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub

Private Property Get ICommand_Enabled() As Boolean
  On Error GoTo ErrorHandler

  
  Dim pDoc As IMxDocument
  Dim bolEnabled As Boolean
  Set pDoc = m_mxDoc
  bolEnabled = True
  
  Dim pCV As IContentsView
  Set pCV = pDoc.CurrentContentsView
  
  Dim pSelItem As IUnknown
  Set pSelItem = pDoc.SelectedItem
  ' Disable if the selected item is nothing or if
  ' it is not a layer or table
  If pSelItem Is Nothing Then
    bolEnabled = False
  ElseIf Not ((pCV.Name = "Display") Or (pCV.Name = "Source")) Then
'  ElseIf Not ((TypeOf pCV Is TOCCatalogView) Or (TypeOf pCV Is TOCDisplayView)) Then
    bolEnabled = False
  ElseIf Not (TypeOf pSelItem Is IFeatureLayer Or TypeOf pSelItem Is IStandaloneTable) Then
    bolEnabled = False
  End If
  
  If bolEnabled Then
    If TypeOf pSelItem Is IFeatureLayer Then
      Dim pFeatureLayer As IFeatureLayer
      Set pFeatureLayer = pSelItem
      bolEnabled = pFeatureLayer.Valid
    ElseIf TypeOf pSelItem Is IStandaloneTable Then
      Dim pStandaloneTable As IStandaloneTable
      Set pStandaloneTable = pSelItem
      bolEnabled = pStandaloneTable.Valid
    End If
  End If
  ICommand_Enabled = bolEnabled


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Enabled " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
 
Private Property Get ICommand_Checked() As Boolean
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
   ICommand_Checked = False


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Checked " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
 
Private Property Get ICommand_Name() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
  ICommand_Name = "SaguaroCommands_Summarize"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Name " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
 
Private Property Get ICommand_Caption() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
  ICommand_Caption = "ArcGIS Summarize"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Caption " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
 
Private Property Get ICommand_Tooltip() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
  ICommand_Tooltip = "ArcGIS Summarize"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Tooltip " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
 
Private Property Get ICommand_Message() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
  ICommand_Message = "Open the standard ArcGIS 'Summarize' window..."


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Message " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
 
Private Property Get ICommand_HelpFile() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
  ICommand_HelpFile = ""


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
 
Private Property Get ICommand_HelpContextID() As Long
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
  ICommand_HelpContextID = 0


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_HelpContextID " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
 
Private Property Get ICommand_Bitmap() As esriSystem.OLE_HANDLE
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
  ICommand_Bitmap = m_bitmap.Handle


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Bitmap " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
 
Private Property Get ICommand_Category() As String
  On Error GoTo ErrorHandler

  
  ' TODO: Add your implementation here
  ICommand_Category = "Saguaro Commands"


  Exit Property
ErrorHandler:
  HandleError True, "ICommand_Category " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Property
 
Private Sub ICommand_OnCreate(ByVal hook As Object)
  On Error GoTo ErrorHandler


  Set m_App = hook
  Set m_mxDoc = m_App.Document


  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnCreate " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub
 
Private Sub ICommand_OnClick()
  On Error GoTo ErrorHandler


  Dim pSelItem As IUnknown
  Set pSelItem = m_mxDoc.SelectedItem
  Dim pFeatureLayer As IFeatureLayer
  Dim pStandaloneTable As IStandaloneTable
  Dim pTableFields As ITableFields
  
  ' Disable if the selected item is nothing or if
  ' it is not a layer or table
  If pSelItem Is Nothing Then
    Exit Sub
  ElseIf TypeOf pSelItem Is IFeatureLayer Then
    Set pFeatureLayer = pSelItem
    If pFeatureLayer.Valid = False Then
      MsgBox "There is something wrong with " & pFeatureLayer.Name & "!  It is not a valid " & _
          "layer.  Unable to summarize this layer...", vbInformation, "Problem with Data:"
      Exit Sub
    End If
    Set pTableFields = pFeatureLayer
  
  ElseIf TypeOf pSelItem Is IStandaloneTable Then
    Set pStandaloneTable = pSelItem
    If pStandaloneTable.Valid = False Then
      MsgBox "There is something wrong with " & pStandaloneTable.Name & "!  It is not a valid " & _
          "table.  Unable to summarize this layer...", vbInformation, "Problem with Data:"
      Exit Sub
    End If
    Set pTableFields = pStandaloneTable
  Else
    Exit Sub
  End If
  
  ' LOOK FOR STRING FIELDS FIRST; IF NONE FOUND, THEN USE FIRST NUMERIC FIELD
  
  Dim anIndex As Long
  
  Dim pField As IField
  Dim boolFoundField As Boolean
  
  For anIndex = 0 To pTableFields.FieldCount - 1
    If pTableFields.Field(anIndex).Type = esriFieldTypeString Then
      boolFoundField = True
      Set pField = pTableFields.Field(anIndex)
      Exit For
    End If
  Next anIndex
  
  ' IF NO STRING FIELDS FOUND, TAKE FIRST NUMERIC FIELD
  If Not boolFoundField Then
    For anIndex = 0 To pTableFields.FieldCount - 1
      If pTableFields.Field(anIndex).Type < 4 Then  ' NUMERIC VALUES ARE LESS THAN 4
        boolFoundField = True
        Set pField = pTableFields.Field(anIndex)
        Exit For
      End If
    Next anIndex
  End If
  
  ' IF STILL NO FIELD FOUND, USE FIRST FIELD
  If Not boolFoundField Then
    Set pField = pTableFields.Field(0)
  End If
  
  Dim pSumUI As ISummarizeUI
  Set pSumUI = New SummarizeUI
  Set pSumUI.Application = m_App
  Set pSumUI.SummarizeTable = pSelItem
  Set pSumUI.SummarizeField = pField
  pSumUI.SummarizeOnSelectedOnly = True
  pSumUI.DoModal m_App.hWnd


  Exit Sub
ErrorHandler:
  HandleError True, "ICommand_OnClick " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), Err.Number, Err.Source, Err.Description, 4
End Sub


