Attribute VB_Name = "modClipFunctions"
Option Explicit
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\modClipFunctions.bas"

Public Function ClipRasterLayer(ByVal pPolygon As IPolygon, ByRef pRasterLayer As IRasterLayer, strPath As String, _
    pApp As IApplication) As IRasterLayer
  On Error GoTo ErrorHandler
  
'  MsgBox "ModClipFunctions - Before: " & strPath
'  strPath = Linkages.aml_func_mod.BasicTrimAvenue(strPath, "", "/\")
'  MsgBox "ModClipFunctions - After: " & strPath
  ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
13:   Set psbar = pApp.StatusBar
14:   psbar.ProgressBar.position = 1
  Dim pPro As IStepProgressor
'  Dim pProgAnim As IAnimationProgressor
'  Set pProgAnim = psbar.ProgressAnimation
'  pProgAnim.Show
19:   Set pPro = psbar.ProgressBar
20:   psbar.PlayProgressAnimation True

  Dim strCharacters As String
  Dim strNumbers As String
  
25:   strCharacters = "abcdefghijklmnopqrstuvwxyz_1234567890"
26:   strNumbers = "0123456789"
  Dim strCurrentName As String
28:   strCurrentName = pRasterLayer.Name
  
  Dim strGridName As String
  
 ' CALCULATE NAME FOR NEW GRID
33:   If InStr(1, strNumbers, Left(strCurrentName, 1)) > 0 Then
34:     strGridName = "z"
35:   Else
36:     strGridName = ""
37:   End If
  
  Dim lngIndex As Long
  Dim strChar As String
41:   For lngIndex = 1 To Len(strCurrentName)
42:     strChar = Mid(strCurrentName, lngIndex, 1)
43:     If InStr(1, strCharacters, strChar, vbTextCompare) = 0 Then
44:       strGridName = strGridName & "_"
45:     Else
46:       strGridName = strGridName & strChar
47:     End If
48:   Next lngIndex

  Dim strTestGridName As String
  Dim strBaseGridName As String
  Dim lngNameCounter As Long
  Dim strFileString As String
  Dim booGridExists As Boolean
  
56:   strTestGridName = Left(strGridName, 8) & "_clip"
57:   strBaseGridName = Left(strGridName, 8)
58:   lngNameCounter = 1
  
60:   strFileString = strPath & strGridName
61:   booGridExists = Linkages.aml_func_mod.ExistFileDir(strPath & strTestGridName)
  
63:   Do While booGridExists
64:     lngNameCounter = lngNameCounter + 1
65:     strTestGridName = Left(strBaseGridName, 8 - Len(CStr(lngNameCounter))) & "_clip" & CStr(lngNameCounter)
66:     booGridExists = Linkages.aml_func_mod.ExistFileDir(strPath & strTestGridName)
67:   Loop

69:   Screen.MousePointer = vbHourglass
70:   psbar.ProgressBar.Show
71:   psbar.ProgressBar.Message = "Clipping " & UCase(pRasterLayer.Name) & "..."
  
  Dim pRaster As IRaster
  Dim pClipRaster As IRaster

76:   Set pRaster = pRasterLayer.Raster
  ' aaa
  
  ' MIGHT NEED TO MAKE SURE CLIP POLYGON AND RASTER ARE IN SAME SPATIAL REFERENCE
  Dim pClipperPolygon As IPolygon
  Dim pClone As IClone
82:   Set pClone = pPolygon
83:   Set pClipperPolygon = pClone.Clone
  
  ' CHECK IF OBJECTS EVEN INTERSECT
  Dim pMapSpRef As ISpatialReference
  Dim pMxDoc As IMxDocument
  
89:   Set pMxDoc = pApp.Document
90:   Set pMapSpRef = pMxDoc.FocusMap.SpatialReference
  
  Dim pPolyEnv As IEnvelope
93:   Set pPolyEnv = pPolygon.Envelope
  Dim pPolyEnvPolygon As IPolygon
  Dim pPolySpatRef As ISpatialReference
96:   Set pPolySpatRef = pPolygon.SpatialReference
  
98:   Set pPolyEnvPolygon = Linkages.MyGeometricOperations.EnvelopeToPolygon(pPolyEnv)
  
  ' FOR DEBUGGING
'  MsgBox "Polygon Envelope is Nothing:  " & CStr(pPolyEnv Is Nothing) & vbCrLf & _
        "Polygon Envelope is Empty:  " & CStr(pPolyEnv.IsEmpty) & vbCrLf & _
        "Dimensions: " & pPolyEnv.Width & " x " & pPolyEnv.Height & vbCrLf & _
        "Spatial Reference = " & pPolyEnv.SpatialReference.Name
  ' END DEBUGGING
        
  Dim pRastEnv As IEnvelope
  Dim pRastProps As IRasterProps
109:   Set pRastProps = pRaster
110:   Set pRastEnv = pRastProps.Extent
  Dim pRastEnvPolygon As IPolygon
  Dim pRastSpatRef As ISpatialReference
113:   Set pRastSpatRef = pRastProps.SpatialReference
114:   Set pRastEnvPolygon = Linkages.MyGeometricOperations.EnvelopeToPolygon(pRastEnv)
  
  ' FOR DEBUGGING
'  MsgBox "Raster Envelope is Nothing:  " & CStr(pRastEnv Is Nothing) & vbCrLf & _
        "Raster Envelope is Empty:  " & CStr(pRastEnv.IsEmpty) & vbCrLf & _
        "Dimensions: " & pRastEnv.Width & " x " & pRastEnv.Height & vbCrLf & _
        "Raster Envelope Spatial Reference = " & pRastEnv.SpatialReference.Name & _
        "Raster Spatial Reference = " & pRastProps.SpatialReference.Name
  ' END DEBUGGING
  
  ' IF EITHER SPATIAL REFERENCE IS UNKNOWN, THEN SET REFERENCE = MAP REFERENCE
  
126:   If Not Linkages.GridFunctions.CompareSpatialReferences(pPolySpatRef, pRastSpatRef) And _
    (Not pPolySpatRef Is Nothing) And (Not pRastSpatRef Is Nothing) Then
128:       pClipperPolygon.Project pRastSpatRef
129:   End If
  
  Dim pRelOp As IRelationalOperator
132:   Set pRelOp = pClipperPolygon.Envelope

  ' FOR DEBUGGING
'  Set pPolyEnvPolygon = Linkages.MyGeometricOperations.EnvelopeToPolygon(pClipperPolygon.Envelope)
'  MsgBox "Clipper Polygon After Possible Projection Envelope is Nothing:  " & CStr(pClipperPolygon.Envelope Is Nothing) & vbCrLf & _
'        "Polygon Envelope is Empty:  " & CStr(pClipperPolygon.Envelope.IsEmpty) & vbCrLf & _
'        "Dimensions: " & pClipperPolygon.Envelope.Width & " x " & pClipperPolygon.Envelope.Height & vbCrLf & _
'        "Spatial Reference = " & pClipperPolygon.Envelope.SpatialReference.Name
'  Dim pTopoOp As ITopologicalOperator
'  Set pTopoOp = pPolyEnvPolygon
'  Dim pProxOp As IProximityOperator
'  Set pProxOp = pPolyEnvPolygon
'  MsgBox "Prox Op Distance: " & CStr(pProxOp.ReturnDistance(pRastEnv))
'  MsgBox "Relational Op 'Disjoint':  " & CStr(pRelOp.Disjoint(pRastEnvPolygon))
  ' END DEBUGGING
  
  Dim booDisjoint As Boolean
149:   booDisjoint = pRelOp.Disjoint(pRastEnv)
  
  ' FOR DEBUGGING
'  MsgBox "Disjoint = " & CStr(booDisjoint)
'  MsgBox "Envelopes Intersect = " & CStr(Not pRelOp.Disjoint(pRastEnv)) & vbCrLf & _
      "Poly Envelope = " & CStr(pPolyEnv.Width) & " x " & CStr(pPolyEnv.Height) & vbCrLf & _
      "Raster Envelope = " & CStr(pRastEnv.Width) & " x " & CStr(pRastEnv.Height)
  ' END DEBUGGING
      
158:   If pRelOp.Disjoint(pRastEnvPolygon) Then
159:     Screen.MousePointer = vbDefault
160:     psbar.ProgressBar.Hide
161:     psbar.PlayProgressAnimation False
    Exit Function
163:   End If
  
165:   Set pClipRaster = Linkages.GridFunctions.ClipRasterToPolygon(pRaster, pClipperPolygon, True, pPolyEnv, , , True, pApp)
  
  Dim pRasterBandCol As IRasterBandCollection
  Dim pDS As IDataset
169:   Set pRasterBandCol = pClipRaster
 
171:   Linkages.GridFunctions.SaveRasterAs pRasterBandCol, strPath, strTestGridName, enum_Grid_Type
  
  Dim pReturnRasterLayer As IRasterLayer
174:   Set pReturnRasterLayer = New RasterLayer
175:   pReturnRasterLayer.CreateFromFilePath strPath & strTestGridName
176:   Set ClipRasterLayer = pReturnRasterLayer
  
178:   Screen.MousePointer = vbDefault
179:   psbar.ProgressBar.Hide
'  pProgAnim.Hide
181:   psbar.PlayProgressAnimation False
  
183:   Set pRaster = Nothing
184:   Set pRasterLayer = Nothing
185:   Set pClipRaster = Nothing
  
  Exit Function
ErrorHandler:
  HandleError True, "ClipRasterLayer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ClipFeatureLayer(ByVal pPolygon As IPolygon, ByRef pFeatureLayer As IFeatureLayer, strPath As String, _
    pApp As IApplication) As IFeatureLayer
  On Error GoTo ErrorHandler

  
  Dim strName As String
198:   strName = pFeatureLayer.Name
199:   strName = Linkages.aml_func_mod.ClipExtension(strName) & "_clip.shp"
  
  Dim theNewName As String
202:   theNewName = Linkages.aml_func_mod.MakeUniqueFilename(strPath & strName)
  
  Dim pFeatureClass As IFeatureClass
205:   Set pFeatureClass = pFeatureLayer.FeatureClass
  Dim intShapeType As esriGeometryType
207:   intShapeType = pFeatureClass.ShapeType
  
  Dim intGeometryDim As esriGeometryDimension
  Select Case intShapeType
    Case 1, 2
      intGeometryDim = esriGeometry0Dimension
    Case 3, 6, 13, 14, 15, 16
      intGeometryDim = esriGeometry1Dimension
    Case 4, 5, 9, 11, 18, 19, 22
      intGeometryDim = esriGeometry2Dimension
    Case Else
      intGeometryDim = esriGeometry0Dimension
219:   End Select
  
  Dim strGeoFieldName As String
222:   strGeoFieldName = pFeatureClass.ShapeFieldName
  Dim pFields As IFields
224:   Set pFields = pFeatureClass.Fields
  Dim pGeoField As IField
226:   Set pGeoField = pFields.Field(pFields.FindField(strGeoFieldName))
227:   If (Not pGeoField Is Nothing) And (pGeoField.Type = esriFieldTypeGeometry) Then
      
    Dim pLayerSpRef As ISpatialReference
    Dim pGeoDef As IGeometryDef
231:     Set pGeoDef = pGeoField.GeometryDef
232:     Set pLayerSpRef = pGeoDef.SpatialReference
    
    Dim pCorSpRef As ISpatialReference
235:     Set pCorSpRef = pPolygon.SpatialReference
    Dim booRefSame As Boolean
237:     booRefSame = Linkages.MyGeneralOperations.CompareSpatialReferences(pLayerSpRef, pCorSpRef)
    
    ' MAKE SURE SPATIAL REFERENCES ARE THE SAME
    ' DO I NEED TO CHECK FOR ONE SPATIAL REFERENCE BEING UNKNOWN?
241:     If Not booRefSame Then
242:       pPolygon.Project pLayerSpRef
243:     End If
244:   Else
245:     Set pLayerSpRef = pPolygon.SpatialReference
246:   End If
  
' MsgBox "Polygon Spatial Reference = " & pPolygon.SpatialReference.Name
  
  Dim pFeatureCursor As IFeatureCursor
  
  Dim pSpatialFilter As ISpatialFilter
253:   Set pSpatialFilter = New SpatialFilter
  
255:   Set pSpatialFilter.Geometry = pPolygon
256:   pSpatialFilter.GeometryField = strGeoFieldName
257:   pSpatialFilter.SpatialRel = esriSpatialRelIntersects
        
  ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
261:   Set psbar = pApp.StatusBar
262:   psbar.ProgressBar.position = 1
'  Dim pProgAnim As IAnimationProgressor
'  Set pProgAnim = psbar.ProgressAnimation
'  pProgAnim.Show
  Dim pPro As IStepProgressor
267:   Set pPro = psbar.ProgressBar
268:   psbar.PlayProgressAnimation True
  
270:   Screen.MousePointer = vbHourglass
271:   psbar.ProgressBar.Show
272:   psbar.ProgressBar.Message = "Examining " & UCase(pFeatureLayer.Name) & "..."
  
  ' MAKE SELECTION ON FEATURE CLASS
  Dim pFeature As IFeature
  Dim lngFeatureCount As Long
277:   lngFeatureCount = pFeatureClass.FeatureCount(pSpatialFilter)
278:   Set pFeatureCursor = pFeatureClass.Search(pSpatialFilter, False)
279:   Set pFeature = pFeatureCursor.NextFeature
'  MsgBox lngFeatureCount & " features selected..."
281:   If pFeature Is Nothing Then
282:     Set ClipFeatureLayer = Nothing
283:     Screen.MousePointer = vbDefault
284:     psbar.ProgressBar.Hide
285:     psbar.PlayProgressAnimation False
    Exit Function
287:   End If
  
  ' ADD DEFAULT FIELDS TO TABLE
  Dim pField As IField
291:   Set pField = New Field
  Dim pFieldEdit As IFieldEdit
293:   Set pFieldEdit = pField
  Dim pField2 As IField
295:   Set pField2 = New Field
  Dim pFieldEdit2 As IFieldEdit
297:   Set pFieldEdit2 = pField2
  Dim strShapeName As String
  
  ' MAKE NEW SHAPEFILE
  Dim pClipFeatureClass As IFeatureClass
  Dim strOutputType As String
  Select Case intShapeType
    Case 1                         ' POINT
305:       Set pClipFeatureClass = aml_func_mod.CreateShapefile(Linkages.aml_func_mod.ReturnDir(theNewName), _
          Linkages.aml_func_mod.ReturnFilename(theNewName), _
          pLayerSpRef, "Point")
308:       strOutputType = "Point"
309:       With pFieldEdit
310:             .Name = "X_Coord"
311:             .AliasName = "X_Coord"
312:             .Type = esriFieldTypeDouble
313:       End With
314:       With pFieldEdit2
315:             .Name = "Y_Coord"
316:             .AliasName = "Y_Coord"
317:             .Type = esriFieldTypeDouble
318:       End With
319:       strShapeName = "Points"
    Case 2                         ' MULTIPOINT
321:       Set pClipFeatureClass = aml_func_mod.CreateShapefile(Linkages.aml_func_mod.ReturnDir(theNewName), _
          Linkages.aml_func_mod.ReturnFilename(theNewName), _
          pLayerSpRef, "Multipoint")
324:       strOutputType = "Multipoint"
325:       With pFieldEdit
326:             .Name = "clip_count"
327:             .AliasName = "clip_count"
328:             .Type = esriFieldTypeDouble
329:       End With
330:       strShapeName = "Multipoints"
    Case 3, 6, 13, 14, 15, 16      ' POLYLINE
332:       Set pClipFeatureClass = aml_func_mod.CreateShapefile(Linkages.aml_func_mod.ReturnDir(theNewName), _
          Linkages.aml_func_mod.ReturnFilename(theNewName), _
          pLayerSpRef, "Polyline")
335:       strOutputType = "Polyline"
336:       With pFieldEdit
337:             .Name = "clip_len"
338:             .AliasName = "clip_len"
339:             .Type = esriFieldTypeDouble
340:       End With
341:       strShapeName = "Polylines"
    Case 4, 5, 9, 11, 18, 19, 22   ' POLYGON
343:       Set pClipFeatureClass = aml_func_mod.CreateShapefile(Linkages.aml_func_mod.ReturnDir(theNewName), _
          Linkages.aml_func_mod.ReturnFilename(theNewName), _
          pLayerSpRef, "Polygon")
346:       strOutputType = "Polygon"
347:       With pFieldEdit
348:             .Name = "clip_area"
349:             .AliasName = "clip_area"
350:             .Type = esriFieldTypeDouble
351:       End With
352:       strShapeName = "Polygons"
    Case Else                      ' POINTS
354:       Set pClipFeatureClass = aml_func_mod.CreateShapefile(Linkages.aml_func_mod.ReturnDir(theNewName), _
          Linkages.aml_func_mod.ReturnFilename(theNewName), _
          pLayerSpRef, "Point")
357:       strOutputType = "Point"
358:       With pFieldEdit
359:             .Name = "X_Coord"
360:             .AliasName = "X_Coord"
361:             .Type = esriFieldTypeDouble
362:       End With
363:       With pFieldEdit2
364:             .Name = "Y_Coord"
365:             .AliasName = "Y_Coord"
366:             .Type = esriFieldTypeDouble
367:       End With
368:       strShapeName = "Vertices"
369:   End Select

371:   Screen.MousePointer = vbHourglass
372:   psbar.ShowProgressBar "Clipping " & strShapeName & " from " & UCase(pFeatureLayer.Name) & "...", 1, _
        lngFeatureCount, 1, False
        
  ' ADD GEOMETRIC MEASURE FIELD(S) TO FEATURE CLASS
  Dim pTable As ITable
377:   Set pTable = pClipFeatureClass
378:   pTable.AddField pField
379:   If strOutputType = "Point" Then pTable.AddField pField2
  
  ' ADD ORIGINAL FIELDS TO TABLE
  Dim intIndexArray() As Integer
  ReDim intIndexArray(pFields.FieldCount, 2)
  Dim intFieldIndex As Integer
  Dim intNewFieldIndex As Integer
386:   intNewFieldIndex = -1
  Dim pOriginalField As IField
  Dim pClone As IClone
  Dim pNewField As IField
  Dim pNewFieldEdit As IFieldEdit
  Dim lngOIDFieldIndex As String
392:   lngOIDFieldIndex = -9999
  Dim intNameCounter As Integer
  Dim strBaseName As String
  Dim strNewName As String
  
397:   For intFieldIndex = 0 To (pFields.FieldCount - 1)
398:     Set pOriginalField = pFields.Field(intFieldIndex)
399:     If (Not pOriginalField.Name = pFeatureClass.ShapeFieldName) Then
400:         Set pClone = pOriginalField
401:         Set pNewField = pClone.Clone
402:         Set pNewFieldEdit = pNewField
        'MsgBox "Field Name = " & pOriginalField.Name & vbCrLf & "Field Type = " & pOriginalField.Type
404:         If pOriginalField.Name = pFeatureClass.OIDFieldName Or pOriginalField.Type = esriFieldTypeOID Then
'          MsgBox "Converting to Long OID field..."
406:           Set pNewField = New Field
407:           Set pNewFieldEdit = pNewField
408:           pNewFieldEdit.Type = esriFieldTypeInteger
409:           pNewFieldEdit.Name = ("Orig_OID")
410:           lngOIDFieldIndex = intNewFieldIndex + 1
411:         ElseIf pNewField.Name = "AREA" Or pNewField.Name = "area" Or pNewField.Name = "Area" Then
412:           Set pNewField = New Field
413:           Set pNewFieldEdit = pNewField
414:           pNewFieldEdit.Type = esriFieldTypeDouble
415:           pNewFieldEdit.Precision = pOriginalField.Precision
416:           pNewFieldEdit.length = pOriginalField.length
417:           pNewFieldEdit.Name = "Orig_Area"
418:         End If
       ' MsgBox "Adding Field Name = " & pNewField.Name & vbCrLf & "Field Type = " & pNewField.Type
        
        ' MAKE SURE NEW FIELD NAME ISN'T ALREADY PRESENT
422:         intNameCounter = 1
423:         strNewName = pNewField.Name
424:         strBaseName = strNewName
425:         Do While pTable.FindField(strNewName) > -1
426:           intNameCounter = intNameCounter + 1
427:           strNewName = Left(strBaseName, 10 - Len(CStr(intNameCounter))) & CStr(intNameCounter)
428:         Loop
429:         pNewFieldEdit.Name = strNewName
430:         pTable.AddField pNewField
        
432:         intNewFieldIndex = intNewFieldIndex + 1
433:         intIndexArray(intNewFieldIndex, 0) = pFeatureClass.FindField(pOriginalField.Name)  ' ORIGINAL FEATURE CLASS
434:         intIndexArray(intNewFieldIndex, 1) = pTable.FindField(pNewField.Name)              ' NEW CLIPPED FEATURE CLASS
435:     End If
436:   Next intFieldIndex
  
  Dim pNewFields As IFields
439:   Set pNewFields = pClipFeatureClass.Fields
  Dim intMeasureField1Index As Long
  Dim intMeasureField2Index As Long
  Dim intIDFieldIndex As Long
  Select Case strOutputType
    Case "Point"
445:       intMeasureField1Index = pNewFields.FindField("X_Coord")
446:       intMeasureField2Index = pNewFields.FindField("Y_Coord")
    Case "Multipoint"
448:       intMeasureField1Index = pNewFields.FindField("clip_count")
    Case "Polyline"
450:       intMeasureField1Index = pNewFields.FindField("clip_len")
    Case "Polygon"
452:       intMeasureField1Index = pNewFields.FindField("clip_area")
453:   End Select
454:   intIDFieldIndex = pNewFields.FindField("unique_id")
  
  ' MAKE FEATURE CURSOR AND FEATURE BUFFER FOR NEW SHAPEFILE
  Dim pNewFeatBuf As IFeatureBuffer
  Dim pNewFeatCur As IFeatureCursor
459:   Set pNewFeatCur = pClipFeatureClass.Insert(True)
460:   Set pNewFeatBuf = pClipFeatureClass.CreateFeatureBuffer
  
  ' FOR POINTS
  Dim pPoint As IPoint
  
  ' FOR MULTIPOINTS
  Dim pOrigMultipoint As IMultipoint
  Dim pClipMultipoint As IMultipoint
  Dim pPointCollection As IPointCollection
  
  ' FOR POLYLINES
  Dim pOrigPolyline As IPolyline
  Dim pClipPolyline As IPolyline
  Dim pGeometryCollection As IGeometryCollection
  Dim pPath As IPath
  Dim pSubPolylineCollection As IGeometryCollection
  Dim pSubPolyline As IPolyline
  
  ' FOR POLYGONS
  Dim pOrigPolygon As IPolygon
  Dim pClipPolygon As IPolygon
  Dim pArea As IArea
  Dim pSubPoly As IPolygon
  Dim pPoly2 As IPolygon2
  Dim pPolyArray() As IPolygon
  
  Dim lngIndex As Long
  Dim lngCount As Long
488:   lngCount = 0
  
  ' pTopoOp IS THE CLIPPING BOUNDARY POLYGON
  Dim pTopoOp As ITopologicalOperator2
492:   Set pTopoOp = pPolygon
493:   pTopoOp.IsKnownSimple = False
494:   pTopoOp.Simplify
  
  Dim pTopoOp2 As ITopologicalOperator2
  
498:   Do Until pFeature Is Nothing
    
    Select Case strOutputType
      Case "Point"       ' ----------------------------------------------------------- POINTS
502:         Set pPoint = pFeature.ShapeCopy
503:         Set pNewFeatBuf.Shape = pPoint
504:         pNewFeatBuf.Value(intMeasureField1Index) = pPoint.X
505:         pNewFeatBuf.Value(intMeasureField2Index) = pPoint.Y
506:         lngCount = lngCount + 1
507:         pNewFeatBuf.Value(intIDFieldIndex) = lngCount
        ' ADD ORIGINAL DATA
509:         For intFieldIndex = 0 To intNewFieldIndex
510:           If intFieldIndex = lngOIDFieldIndex Then
511:             pNewFeatBuf.Value(intIndexArray(intFieldIndex, 1)) = CLng(pFeature.OID)
512:           Else
513:             pNewFeatBuf.Value(intIndexArray(intFieldIndex, 1)) = pFeature.Value(intIndexArray(intFieldIndex, 0))
514:           End If
515:         Next intFieldIndex
516:         pNewFeatCur.InsertFeature pNewFeatBuf
        
      Case "Multipoint"  ' ----------------------------------------------------------- MULTIPOINTS
519:         Set pOrigMultipoint = pFeature.ShapeCopy
520:         Set pClipMultipoint = pTopoOp.Intersect(pOrigMultipoint, esriGeometry0Dimension)
521:         Set pNewFeatBuf.Shape = pClipMultipoint
522:         Set pPointCollection = pClipMultipoint
523:         pNewFeatBuf.Value(intMeasureField1Index) = pPointCollection.PointCount
524:         lngCount = lngCount + 1
525:         pNewFeatBuf.Value(intIDFieldIndex) = lngCount
        ' ADD ORIGINAL DATA
527:         For intFieldIndex = 0 To intNewFieldIndex
528:           If intFieldIndex = lngOIDFieldIndex Then
529:             pNewFeatBuf.Value(intIndexArray(intFieldIndex, 1)) = CLng(pFeature.OID)
530:           Else
531:             pNewFeatBuf.Value(intIndexArray(intFieldIndex, 1)) = pFeature.Value(intIndexArray(intFieldIndex, 0))
532:           End If
533:         Next intFieldIndex
534:         pNewFeatCur.InsertFeature pNewFeatBuf

      Case "Polyline"    ' ----------------------------------------------------------- POLYLINES
        ' INTERSECT POLYLINE
538:         Set pOrigPolyline = pFeature.ShapeCopy
539:         Set pClipPolyline = pTopoOp.Intersect(pOrigPolyline, esriGeometry1Dimension)
        
        ' EXPLODE INTERSECTED POLYLINES
542:         Set pGeometryCollection = pClipPolyline
543:         For lngIndex = 0 To pGeometryCollection.GeometryCount - 1
544:           Set pPath = pGeometryCollection.Geometry(lngIndex)
545:           Set pSubPolyline = New Polyline
546:           Set pSubPolylineCollection = pSubPolyline
547:           pSubPolylineCollection.AddGeometry pPath
548:           If Not pSubPolyline Is Nothing Then
549:             Set pNewFeatBuf.Shape = pSubPolyline
550:             pNewFeatBuf.Value(intMeasureField1Index) = pSubPolyline.length
551:             lngCount = lngCount + 1
552:             pNewFeatBuf.Value(intIDFieldIndex) = lngCount
            ' ADD ORIGINAL DATA
554:             For intFieldIndex = 0 To intNewFieldIndex
555:               If intFieldIndex = lngOIDFieldIndex Then
    '            MsgBox "OID = " & CLng(pFeature.OID) & vbCrLf & _
                  "Writing to field '" & pNewFeatBuf.Fields.Field(intFieldIndex).Name & _
                  "', Type =" & pNewFeatBuf.Fields.Field(intFieldIndex).Type
                
560:                 pNewFeatBuf.Value(intIndexArray(intFieldIndex, 1)) = CLng(pFeature.OID)
561:               Else
562:                 pNewFeatBuf.Value(intIndexArray(intFieldIndex, 1)) = pFeature.Value(intIndexArray(intFieldIndex, 0))
563:               End If
564:             Next intFieldIndex
565:             pNewFeatCur.InsertFeature pNewFeatBuf
566:           End If
567:         Next lngIndex
        
      Case "Polygon"     ' ----------------------------------------------------------- POLYGONS
        ' INTERSECT POLYGON AND SIMPLIFY IT
571:         Set pOrigPolygon = pFeature.ShapeCopy
572:         Set pClipPolygon = pTopoOp.Intersect(pOrigPolygon, esriGeometry2Dimension)
573:         Set pTopoOp2 = pClipPolygon
574:         pTopoOp2.IsKnownSimple = False
575:         pTopoOp2.Simplify
        
        ' EXPLODE INTERSECTED POLYGONS
578:         Set pPoly2 = pClipPolygon
        ReDim pPolyArray(pPoly2.ExteriorRingCount - 1)
580:         pPoly2.GetConnectedComponents (pPoly2.ExteriorRingCount), pPolyArray(0)
        
582:         For lngIndex = 0 To UBound(pPolyArray)
          'Debug.Print "Polygon number : " & i & " Length : " & ppolout(i).length
584:           Set pSubPoly = pPolyArray(lngIndex)
585:           If Not pSubPoly Is Nothing Then
586:             Set pArea = pSubPoly
587:             Set pNewFeatBuf.Shape = pSubPoly
588:             pNewFeatBuf.Value(intMeasureField1Index) = pArea.Area
589:             lngCount = lngCount + 1
590:             pNewFeatBuf.Value(intIDFieldIndex) = lngCount
            ' ADD ORIGINAL DATA
592:             For intFieldIndex = 0 To intNewFieldIndex
593:               If intFieldIndex = lngOIDFieldIndex Then
594:                 pNewFeatBuf.Value(intIndexArray(intFieldIndex, 1)) = CLng(pFeature.OID)
595:               Else
596:                 pNewFeatBuf.Value(intIndexArray(intFieldIndex, 1)) = pFeature.Value(intIndexArray(intFieldIndex, 0))
597:               End If
598:             Next intFieldIndex
            
600:             pNewFeatCur.InsertFeature pNewFeatBuf
601:           End If
602:         Next lngIndex
    
604:     End Select
    
606:     Set pFeature = pFeatureCursor.NextFeature
607:     psbar.StepProgressBar
608:   Loop
  
610:   pNewFeatCur.Flush
  
612:   psbar.PlayProgressAnimation False
'  pProgAnim.Hide
614:   psbar.HideProgressBar
615:   Screen.MousePointer = vbDefault
  
  Dim pNewFeatureLayer As IFeatureLayer
618:   Set pNewFeatureLayer = New FeatureLayer
619:   Set pNewFeatureLayer.FeatureClass = pClipFeatureClass
  
621:   Set ClipFeatureLayer = pNewFeatureLayer

  Exit Function
ErrorHandler:
  HandleError True, "ClipFeatureLayer " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


