Attribute VB_Name = "modHelpStrings"
Option Explicit

Public Property Get Step1Polygons() As String
4:   Step1Polygons = _
    "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fmodern\fprq1\fcharset0 Courier New;}}" & vbCrLf & _
    "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\qc\b\f0\fs16 Identifying Corridor and Wildland Blocks\par" & vbCrLf & _
    "\pard\par" & vbCrLf & _
    "\b0 This function will evaluate a corridor connecting two wildland blocks.  Therefore you must identify the polygon objects that represent the corridor and each wildland block.  You may select these polygons by either selecting the appropriate polygon layer in the drop-down box, or by clicking on the actual polygon itself in your map.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "\b Note:\b0   Only a single polygon feature may be used for the corridor and wildland block polygons.  This single feature may be a multipart polygon, but it must be represented by either a single record in the attribute table or a single object selected on the screen.  Multipart polygons are considered single polygon objects, but multiple records in a polygon layer are not.  This tool will check for this condition before allowing you to proceed.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "If you wish to select the polygon by clicking on the map, then choose the option \f1 '<-- Select by clicking on map -->' \f0 in the drop-down box.  Choosing this option will enable the 'Select' button, which then opens a new dialog to allow you to select from the map.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "If you wish to select the polygon by selecting the layer in the drop-down box, then make sure that the layer has only a single polygon in it.  If there are multiple polygons in the layer, then you must select the appropriate polygon using the\f1  '<-- Select by clicking on map -->'\f0  option.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "\b Note:\b0   The selected corridor must intersect with both wildland blocks in order to be a valid corridor.  Also, the wildland blocks must not intersect with each other (if they intersect, then no corridor is needed!).  This tool will check for both of these conditions before allowing you to proceed.\par" & vbCrLf & _
    "}"
End Property

Public Property Get Step2PatchesGeneral() As String

22:   Step2PatchesGeneral = _
    "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
    "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\qc\b\f0\fs16 What are Patch Polygons?\b0\par" & vbCrLf & _
    "\pard\par" & vbCrLf & _
    "A habitat patch is a cluster of pixels that are good enough, big enough, and close enough together to support a particular species at some important level.  The CorridorDesigner toolbox includes functions to create patch polygons from your Habitat Suitability Model.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "Patch polygons are treated as stepping-stones through the corridor, and considered islands of high-quality habitat dispersed through potentially marginal corridor habitat.  Users of this tool will generally have some idea of a maximum threshold distance that a species is capable of making through marginal- or poor-quality habitat, and this tool will help the user decide whether the patch distribution in a corridor will allow that species to move through it.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "If you include patch polygons in your analysis, then this tool will identify the route through the corridor that uses the minimum necessary patch-to-patch distances.  If you do not include patch polygons, then this tool will identify the minimum distance required to move from one wildland block to the other.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "Upon completion, this tool will produce a report listing the patch-to-patch segment lengths required for a species to move from one wildland block to another, sorted in decreasing order by segment length.\par" & vbCrLf & _
    "}"

End Property
Public Property Get Step2PatchesCriteria() As String

38:   Step2PatchesCriteria = _
    "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
    "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\qc\b\f0\fs16 Selecting Patch Polygons\b0\par" & vbCrLf & _
    "\pard\par" & vbCrLf & _
    "Patch polygons may be available in a variety of sizes, and smaller patches may not be large enough to support the species at the level you feel is necessary for that species to be able to successfully traverse the corridor.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "The CorridorDesigner tool ""Create Patch Map"" allows you to generate patch polygons based on different size thresholds.  For example, a small patch may be useful for providing temporary refuge while a larger patch may support more long-term breeding events.  Even larger patches may support breeding over several generations.  The ""Create Patch Map"" tool creates a polygon patch layer with attribute values that indicate the value of the patch.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "If you feel your species will require patches that meet a minimum value  threshold, then you specify this threshold in this dialog.  Simply select the patch attribute field containing the threshold values, then enter the selection criteria.  Only those patches that meet your selection criteria will be considered in the analysis. \par" & vbCrLf & _
    "}"
     
End Property
 
Public Property Get BottleneckHelp() As String

53:   BottleneckHelp = _
    "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fmodern\fprq1\fcharset0 Courier New;}}" & vbCrLf & _
    "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\qc\b\f0\fs16 Bottleneck Analysis\b0\par" & vbCrLf & _
    "\pard\par" & vbCrLf & _
    "Some species may not be able to move through a corridor if that corridor becomes too narrow.  Bottlenecks in a corridor, even if they do not completely prevent movement, may still inhibit the species enough that the gene flow through the corridor is insufficient to achieve the linkage between wildland blocks that you are after.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "Presumably you have some general sense of a threshold level of corridor constriction that your species can handle.  This may be based on observed movement or dispersal behavior of that species, or from information on how that species behaves when in close proximity to developed areas.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "This tool will describe your corridor in terms of how wide it is over its full length.  Based on this information, you will be able to identify the location and relative length of narrow bottlenecks inside the corridor.  In the case of multi-strand corridors, this function will analyze and report on the strand with the widest bottleneck, and not on the strand with the widest overall corridor width.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "\b Note:\b0   Only a single polygon feature may be used for the corridor and wildland block polygons.  This single feature may be a multipart polygon, but it must be represented by either a single record in the attribute table or a single object selected on the screen.  Multipart polygons are considered single polygon objects, but multiple records in a polygon layer are not.  This tool will check for this condition before allowing you to proceed.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "If you wish to select the polygon by clicking on the map, then choose the option \f1 '<-- Select by clicking on map -->' \f0 in the drop-down box.  Choosing this option will enable the 'Select' button, which then opens a new dialog to allow you to select from the map.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "If you wish to select the polygon by selecting the layer in the drop-down box, then make sure that the layer has only a single polygon in it.  If there are multiple polygons in the layer, then you must select the appropriate polygon using the\f1  '<-- Select by clicking on map -->'\f0  option.\par" & vbCrLf & _
    "\par" & vbCrLf & _
    "\b Note:\b0   The selected corridor must intersect with both wildland blocks in order to be a valid corridor.  Also, the wildland blocks must not intersect with each other (if they intersect, then no corridor is needed!).  This tool will check for both of these conditions before allowing you to proceed.\par" & vbCrLf & _
    "}"


End Property
