Attribute VB_Name = "Metadata_Functions"
Option Explicit

' MyGeneralOperations
' Jeff Jenness
' Jenness Enterprises
' http://www.jennessent.com
'
'                           AddCitationDates: (Public Function) Adds Date Created, Date Published and Date Revised.  Date Published is required by FGDC standard
'        AddContact_CitationResponsibleParty: (Public Function) Adds Citation Responsible Party; ORIGINATOR role required by FGDC standard
'                        AddContact_Metadata: (Public Function) Adds Metadata Contact Name and Role, required by FGDC standard
'          AddContact_ResourcePointOfContact: (Public Function) Adds Resource Point of Contact, required by FGDC standard
'              AddDetailsForObjectDefinition: (Public Function) Sets the Object Definition in the "Fields" section, which describes
'                                              briefly what the objects contain.  I'm not sure if this only applies to feature classes.
'                         AddFieldAttributes: (Public Function) Adds attribute field descriptions
'                          AddNewGeoProcStep: (Public Function) Adds new geoprocessing step
'                          AddNewLineageStep: (Public Function) Adds new lineage step
'                   AddResourceDetailsStatus: (Public Function) Adds Resource Detains Status (Completed, Historical Archive, Ongoing, Proposed, etc.)
'                     AddResourceMaintenance: (Public Function) Adds Maintenance Interval (Continual, Daily, Weekly, Irregular, Not Planned, Unknown, etc.)
'               CheckIfContactAlreadyPresent: (Private Function) Internal function to see if a specified contact already exists.
' CopyAttributesFromSourceToDestinationField: (Public Function) Copies field descriptions from an existing field to a new field.
'                CopyLineageOrGeoprocHistory: (Public Function) Copies all lineage steps or geoprocessing steps from a source dataset to this new one.
'         InsertExistingGeoProcessingHistory: (Private Function) Internal function to splice in a set of geoprocessing steps into new metadata.
'               InsertExistingLineageHistory: (Private Function) Internal function to splice in a lineage history into new metadata
'                          ReturnAddressType: (Private Function) Internal function to return address code from enumeration (Physical, Postal, Both)
'     ReturnAllMetadataPropertiesFromDataset: (Public Function) Given a dataset, returns text string listing all XPath properties in metadata.
'             ReturnAttributeFieldXPathIndex: (Private Function) Internal function to return the XPath Index value of a specified field.
'               ReturnDataElementFromDataset: (Public Function) Create a Data Element from a Dataset
'ReturnExistingLineageOrGeoprocessingHistory: (Private Function) Internal function to copy existing lineage or geoprocessing history from a dataset
'             ReturnExistingMetadataKeyWords: (Public Function) Extract keywords from an existing dataset, in several keyword classes.
'                 ReturnGxDatasetFromDataset: (Public Function) Create a GXDataset from a Dataset.
'                    ReturnLargestIndexValue: (Private Function) Internal function to find the highest current XPath Index
'                      ReturnMaintenanceCode: (Private Function) Internal function to return Maintenance Code from enumeration (Continual, Daily, etc.)
'           ReturnMetadataPropSetFromDataset: (Public Function) Mostly internal function to return an IPropSet of dataset metadata.
'         ReturnMetadataXMLStringFromDataset: (Public Function) Given a dataset, returns text string containing all XML data.
'                         ReturnRoleCDString: (Private Function) Internal Function to return Contact Role Code from enumeration (Author, Publisher, Originator, etc.)
'                         ReturnStatusString: (Private Function) Internal function to return Metadata Status code from enumeration (Completed, Ongoing, etc.)
'                               SaveMetadata: (Public Sub) Saves current metadata
'                        SetMetadataAbstract: (Public Function) Adds or Replaces Metadata Abstract/Summary
'                   SetMetadataFormatVersion: (Public Function) Sets current version; optional method to save current ArcGIS version.
'                        SetMetadataKeyWords: (Public Function) Sets metadata keywords
'                         SetMetadataPurpose: (Public Function) Sets metadata purpose
'                 SynchronizeMetadataPropSet: (Public Function) Synchronizes/regenerates metadata with current version of data.  Use if you have added an attribute
'                                             field after initial metadata creation and before setting attributes of field.


Public Enum JenMetadataRoleCDValues
  JenMetadata_ResourceProvider = 1
  JenMetadata_Custodian = 2
  JenMetadata_Owner = 3
  JenMetadata_User = 4
  JenMetadata_Distributor = 5
  JenMetadata_Originator = 6
  JenMetadata_PointOfContact = 7
  JenMetadata_PrincipalInvestigator = 8
  JenMetadata_Processor = 9
  JenMetadata_Publisher = 10
  JenMetadata_Author = 11
  JenMetadata_Collaborator = 12
  JenMetadata_Editor = 13
  JenMetadata_Mediator = 14
  JenMetadata_RightsHolder = 15
End Enum

Public Enum JenMetadataAddressTypeValues
  JenMetadata_Postal = 1
  JenMetadata_Physical = 2
  JenMetadata_Both = 3
  JenMetadata_Skip = 4
End Enum

Public Enum JenMetadataLineageOrGeoprocValues
  JenMetadata_Lineage = 1
  JenMetadata_GeoprocessingHistory = 2
End Enum

Public Enum JenMetadataStatusValues
  JenMetadata_Completed = 1
  JenMetadata_HistoricalArchive = 2
  JenMetadata_Obsolete = 3
  JenMetadata_Ongoing = 4
  JenMetadata_Planned = 5
  JenMetadata_Required = 6
  JenMetadata_UnderDevelopment = 7
  JenMetadata_Proposed = 8
End Enum

Public Enum JenMetadataMaintenanceCodes
  JenMetadata_Maint_Continual = 1
  JenMetadata_Maint_Daily = 2
  JenMetadata_Maint_Weekly = 3
  JenMetadata_Maint_Fortnightly = 4
  JenMetadata_Maint_Monthly = 5
  JenMetadata_Maint_Quarterly = 6
  JenMetadata_Maint_BiAnnually = 7
  JenMetadata_Maint_Annually = 8
  JenMetadata_Maint_AsNeeded = 9
  JenMetadata_Maint_Irregular = 10
  JenMetadata_Maint_NotPlanned = 11
  JenMetadata_Maint_Unknown = 12
  JenMetadata_Maint_SemiMonthly = 13
End Enum

Public Function SampleCodeToSetMetadataProperties()
  
  Dim pFClass As IFeatureClass
  Dim pWS As IFeatureWorkspace
  Dim pWsFact As IWorkspaceFactory
106:   Set pWsFact = New ShapefileWorkspaceFactory
107:   Set pWS = pWsFact.OpenFromFile("D:\arcGIS_stuff\consultation\az_linkages\Crystal_Krause_Btlnck_Batch\Outputs\Output_Folder", 0)
108:   Set pFClass = pWS.OpenFeatureClass("abc_Def")
  
  Dim pDataset As IDataset
111:   Set pDataset = pFClass
  
113:   Debug.Print "------------------------------"
114:   Debug.Print "Feature Class Name = " & pDataset.BrowseName
  
  Dim pPropSet As IPropertySet
117:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  
  ' SYNCHRONIZE METADATA
  Dim strResponse As String
121:   strResponse = Linkages.Metadata_Functions.SynchronizeMetadataPropSet(pDataset)
122:   Debug.Print "Synchronization: " & strResponse
  
  Dim strAbstract As String
125:   strAbstract = "This dataset represents points along the bottleneck route.  This bottleneck route " & _
    "describes the path between the two habitat blocks 'aaa' and 'bbb', within the corridor polygon 'ccc'., " & _
    "which follows the route with the widest narrow point."
128:   strResponse = Linkages.Metadata_Functions.SetMetadataAbstract(pDataset, strAbstract)
129:   Debug.Print "Saving Abstract: " & strResponse
    
  Dim strPurpose As String
132:   strPurpose = "Point dataset of points along route with widest bottleneck, with corridor width values at each point."
133:   strResponse = Linkages.Metadata_Functions.SetMetadataPurpose(pDataset, strPurpose)
134:   Debug.Print "Saving Purpose: " & strResponse
  
  Dim pKeyWords As esriSystem.IStringArray
  Dim pIncludeThemeKeys As esriSystem.IStringArray
  Dim pIncludeSearchKeys As esriSystem.IStringArray
  Dim pIncludeDescKeys As esriSystem.IStringArray
  Dim pIncludeStratKeys As esriSystem.IStringArray
  Dim pIncludeThemeSlashThemekeys As esriSystem.IStringArray
  Dim pIncludePlaceKeys As esriSystem.IStringArray
  Dim pIncludeTemporalKeys As esriSystem.IStringArray
  
145:   Set pIncludeThemeKeys = New esriSystem.strArray
146:   Set pIncludeSearchKeys = New esriSystem.strArray
147:   Set pIncludeDescKeys = New esriSystem.strArray
148:   Set pIncludeStratKeys = New esriSystem.strArray
149:   Set pIncludeThemeSlashThemekeys = New esriSystem.strArray
150:   Set pIncludePlaceKeys = New esriSystem.strArray
151:   Set pIncludeTemporalKeys = New esriSystem.strArray
  
153:   pIncludeThemeSlashThemekeys.Add "theme_slash_theme"
154:   pIncludeTemporalKeys.Add "temporal"
  
  Dim pCombinedKeyWords As esriSystem.IStringArray
  Dim pFLayer As IFeatureLayer
  Dim pMxDoc As IMxDocument
  ' Set pMxDoc = ThisDocument
160:   Set pFLayer = Linkages.MyGeneralOperations.ReturnLayerByName("mroads", pMxDoc.FocusMap)
  Dim booSucceeded As Boolean
  Dim lngIndex As Long
163:   Set pCombinedKeyWords = Linkages.Metadata_Functions.ReturnExistingMetadataKeyWords(pFLayer.FeatureClass, _
      pKeyWords, booSucceeded, pIncludeThemeKeys, pIncludeSearchKeys, pIncludeDescKeys, pIncludeStratKeys, _
      pIncludeThemeSlashThemekeys, _
      pIncludePlaceKeys, pIncludeTemporalKeys)
167:   Debug.Print "Extracting keywords: " & UCase(CStr(booSucceeded))
'  If booSucceeded Then
'    Debug.Print "Combined..."
'    If pCombinedKeyWords.Count > 0 Then
'      For lngIndex = 0 To pCombinedKeyWords.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pCombinedKeyWords.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "Nothing in 'pCombinedKeyWords'..."
'    End If
'    Debug.Print "Theme..."
'    If pIncludeThemeKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeThemeKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeThemeKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeThemeKeys'..."
'    End If
'    Debug.Print "Search..."
'    If pIncludeSearchKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeSearchKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeSearchKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeSearchKeys'..."
'    End If
'    Debug.Print "Desc..."
'    If pIncludeDescKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeDescKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeDescKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeDescKeys'..."
'    End If
'    Debug.Print "Strat..."
'    If pIncludeStratKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeStratKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeStratKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeStratKeys'..."
'    End If
'    Debug.Print "ThemeSlashTheme..."
'    If pIncludeThemeSlashThemekeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeThemeSlashThemekeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeThemeSlashThemekeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeThemeSlashThemekeys'..."
'    End If
'    Debug.Print "Place..."
'    If pIncludePlaceKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludePlaceKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludePlaceKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludePlaceKeys'..."
'    End If
'    Debug.Print "Temporal..."
'    If pIncludeTemporalKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeTemporalKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeTemporalKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeTemporalKeys'..."
'    End If
'  End If
      
  
236:   pIncludeThemeKeys.Add "Bottleneck"
237:   pIncludeThemeKeys.Add "Width"
238:   pIncludeThemeKeys.Add "Corridor"
239:   pIncludeSearchKeys.Add "Bottleneck"
240:   pIncludeSearchKeys.Add "Width"
241:   pIncludeSearchKeys.Add "Corridor"
242:   strResponse = Linkages.Metadata_Functions.SetMetadataKeyWords(pDataset, pIncludeThemeKeys, pIncludeSearchKeys, _
        pIncludeDescKeys, pIncludeStratKeys, pIncludeThemeSlashThemekeys, pIncludePlaceKeys, pIncludeTemporalKeys)
244:   Debug.Print "Saving Keywords: " & strResponse
  
  Dim strAllProps As String
  Dim strXML As String
  
249:   strXML = Linkages.Metadata_Functions.ReturnMetadataXMLStringFromDataset(pDataset)
250:   strAllProps = Linkages.Metadata_Functions.ReturnAllMetadataPropertiesFromDataset(pDataset)
  
252:   Clipboard.Clear
253:   Clipboard.SetText strXML
254:   Clipboard.SetText strAllProps
  
'  Dim DataObj As New MSForms.DataObject
''  DataObj.SetText strXML
'  DataObj.SetText strAllProps
'  DataObj.PutInClipboard
'  Set DataObj = Nothing
  
  
  ' SET PROCESS STEP
  Dim strDescription As String
  Dim strName As String
266:   strDescription = "Generated points along bottleneck route."
267:   strName = "Sample..." & Linkages.aml_func_mod.GetTheUserName
268:   strResponse = Linkages.Metadata_Functions.AddNewLineageStep(pDataset, strDescription, Now, JenMetadata_Processor, _
      strName, "Sample Organization Name", "Sample Position Name", "1-234-567-8901", _
      "Sample Street", "Sample City", "Sample State", "Sample Zip", "Sample Country", "me@jennessent.com", _
      JenMetadata_Physical)
272:   Debug.Print "Lineage Successful = " & strResponse
  
  ' REPLACE PROCESS STEP
  Dim pSourceFClass As IFeatureClass
276:   Set pFLayer = Linkages.MyGeneralOperations.ReturnLayerByName("Roads_for_Metadata", pMxDoc.FocusMap)
277:   Set pSourceFClass = pFLayer.FeatureClass
'  strResponse = CopyLineageOrGeoprocHistory(pSourceFClass, pDataset, True, JenMetadata_Lineage)
'  Debug.Print "Lineage Transfer Successful = " & strResponse
  
  ' REPLACE GEOPROCESSING HISTORY
'  strResponse = CopyLineageOrGeoprocHistory(pSourceFClass, pDataset, False, JenMetadata_GeoprocessingHistory)
'  Debug.Print "Geoproc History Transfer Successful = " & strResponse
  
  ' ADD NEW GEOPROCESSING EVENT
286:   strResponse = AddNewGeoProcStep(pDataset, "Details on bottleneck analysis...", "c:/BatchBottleneck tool", _
      Now, "Corridor Designer Extension Batch Bottleneck Tool", False)
288:   Debug.Print "Added new Geoprocessing Event = " & strResponse
  
  ' ADD NEW METADATA CONTACTS
291:   strResponse = Linkages.Metadata_Functions.AddContact_Metadata(pDataset, JenMetadata_PointOfContact, _
    "Jeff1", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Postal)
294:   Debug.Print "Added Metadata Contact 'Point of Contact' = " & strResponse
295:   strResponse = Linkages.Metadata_Functions.AddContact_Metadata(pDataset, JenMetadata_Processor, _
    "Jeff1", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Postal)
298:   Debug.Print "Added Metadata Contact 'Processor' = " & strResponse
299:   strResponse = Linkages.Metadata_Functions.AddContact_Metadata(pDataset, JenMetadata_Custodian, _
    "Jeff5", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Postal)
302:   Debug.Print "Added Metadata Contact 'Custodian' = " & strResponse
303:   strResponse = Linkages.Metadata_Functions.AddContact_Metadata(pDataset, JenMetadata_Author, _
    "Jeff5", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Postal)
306:   Debug.Print "Added Metadata Contact 'Author' = " & strResponse
307:   strResponse = Linkages.Metadata_Functions.AddContact_Metadata(pDataset, JenMetadata_PointOfContact, _
    "Jeff1", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Physical)
310:   Debug.Print "Added Metadata Contact 'Point of Contact' with Physical address = " & strResponse
311:   strResponse = Linkages.Metadata_Functions.AddContact_Metadata(pDataset, JenMetadata_PointOfContact, _
    "Jeff1", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Both)
314:   Debug.Print "Added Metadata Contact 'Point of Contact' with Both address = " & strResponse
  
  ' ADD NEW CITATION CONTACTS; SHOULD HAVE ORIGINATOR
317:   strResponse = Linkages.Metadata_Functions.AddContact_CitationResponsibleParty(pDataset, JenMetadata_PointOfContact, _
    "Jeff1", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Postal)
320:   Debug.Print "Added CITATION Contact 'Point of Contact' = " & strResponse
321:   strResponse = Linkages.Metadata_Functions.AddContact_CitationResponsibleParty(pDataset, JenMetadata_Processor, _
    "Jeff1", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Postal)
324:   Debug.Print "Added CITATION Contact 'Processor' = " & strResponse
325:   strResponse = Linkages.Metadata_Functions.AddContact_CitationResponsibleParty(pDataset, JenMetadata_Originator, _
    "Jeff1", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Postal)
328:   Debug.Print "Added CITATION Contact 'Custodian' = " & strResponse
  
  ' ADD NEW RESOURCE CONTACTS
331:   strResponse = Linkages.Metadata_Functions.AddContact_ResourcePointOfContact(pDataset, JenMetadata_PointOfContact, _
    "Jeff1", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Postal)
334:   Debug.Print "Added RESOURCE Contact 'Point of Contact' = " & strResponse
335:   strResponse = Linkages.Metadata_Functions.AddContact_ResourcePointOfContact(pDataset, JenMetadata_Processor, _
    "Jeff1", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Postal)
338:   Debug.Print "Added RESOURCE Contact 'Processor' = " & strResponse
339:   strResponse = Linkages.Metadata_Functions.AddContact_ResourcePointOfContact(pDataset, JenMetadata_Custodian, _
    "Jeff1", "Jenness1", "Analyst1", "111-222-3345", "3020 N. Schevene", "Flagstaff", "AZ", _
    "86004", "USA", "me1@jennessent.com", JenMetadata_Postal)
342:   Debug.Print "Added RESOURCE Contact 'Custodian' = " & strResponse
  
  ' ADD CITATION DATES
  Dim datCreated As Date
  Dim datPublished As Date
  
348:   datCreated = Now
349:   datPublished = DateAdd("s", 1234567, datCreated)
350:   strResponse = Linkages.Metadata_Functions.AddCitationDates(pDataset, datCreated, datPublished)
351:   Debug.Print "Added Citation Dates = " & strResponse
  
  ' SET RESOURCE STATUS
354:   strResponse = Linkages.Metadata_Functions.AddResourceDetailsStatus(pDataset, JenMetadata_Ongoing)
355:   Debug.Print "Added Resource Status = " & strResponse
  
  ' SET MAINTENANCE STATUS
358:   strResponse = Linkages.Metadata_Functions.AddResourceMaintenance(pDataset, JenMetadata_Maint_Daily)
359:   Debug.Print "Added Resource Maintenance = " & strResponse
  
  ' SET OBJECT DEFINITION AND SOURCE
  ' This is the short section right after the "Fields" entry where it wants a description of what the objects are.  It might only
  ' apply to datasets with attribute fields.
    strResponse = Metadata_Functions.AddDetailsForObjectDefinition(pDataset, _
    "Points representing corridor midpoints", "Corridor Designer")
    Debug.Print "Added Resource Status = " & strResponse
  
  ' COPY OVER COMPLICATED FIELD INFO
  Dim pGCRoads As IFeatureClass
363:   Set pFLayer = Linkages.MyGeneralOperations.ReturnLayerByName("Roads_for_Metadata", pMxDoc.FocusMap)
364:   Set pGCRoads = pFLayer.FeatureClass
365:   strResponse = Linkages.Metadata_Functions.CopyAttributesFromSourceToDestinationField(pGCRoads, "BLM_OBS_USE1", _
      pDataset, "text_field")
367:   Debug.Print "Copy Complex Field = " & strResponse
  
  Dim pMRoads As IFeatureClass
370:   Set pFLayer = Linkages.MyGeneralOperations.ReturnLayerByName("mroads", pMxDoc.FocusMap)
371:   Set pMRoads = pFLayer.FeatureClass
372:   strResponse = Linkages.Metadata_Functions.CopyAttributesFromSourceToDestinationField(pMRoads, "FCC", _
      pDataset, "FCC")
374:   Debug.Print "Copy Complex Field 2 = " & strResponse
  
  ' ADD UDOM (Unrepresentable Domain) FIELD INFO
377:   strResponse = Linkages.Metadata_Functions.AddFieldAttributes(pDataset, "forudom", _
      "Description of an 'Unrepresentable Domain' field...", "World Book Encyclopedia", _
      , , , , , , , "Values represent area of polygons as calculated by spheroidal means...")
380:   Debug.Print "Add Unrepresentable Domain Field info = " & strResponse
  
  ' ADD EDOM (Enumerated Domain) FIELD INFO
  Dim varData() As Variant
  ReDim varData(0)
  Dim strList() As String
  ReDim strList(2, 5)
387:   strList(0, 0) = "Item #1"
388:   strList(1, 0) = "Item #1 Description"
389:   strList(2, 0) = "Item #1 Source"
390:   strList(0, 1) = "Item #2"
391:   strList(1, 1) = "Item #2 Description"
392:   strList(2, 1) = "Item #2 Source"
393:   strList(0, 2) = "Item #3"
394:   strList(1, 2) = "Item #3 Description"
395:   strList(2, 2) = "Item #3 Source"
396:   strList(0, 3) = "Item #4"
397:   strList(1, 3) = "Item #4 Description"
398:   strList(2, 3) = "Item #4 Source"
399:   strList(0, 4) = "Item #5"
400:   strList(1, 4) = "Item #5 Description"
401:   strList(2, 4) = "Item #5 Source"
402:   strList(0, 5) = "Item #6"
403:   strList(1, 5) = "Item #6 Description"
404:   strList(2, 5) = "Item #6 Source"
405:   varData(0) = strList
  
407:   strResponse = Linkages.Metadata_Functions.AddFieldAttributes(pDataset, "foredom", _
      "Description of an 'Enumerated Domain' field...", "World Book Encyclopedia", _
      , , , , , , varData)
410:   Debug.Print "Add Enumerated Domain Field info = " & strResponse
  
  ' ADD RDOM (Range Domain) FIELD INFO
413:   strResponse = Linkages.Metadata_Functions.AddFieldAttributes(pDataset, "forrdom", _
      "Description of an 'Range Domain' field...", "World Book Encyclopedia", _
       "0", "100", "54", "Meters", "1.234", "1.111")
416:   Debug.Print "Add Enumerated Domain Field info = " & strResponse
  
  ' ADD CODESET FIELD INFO
419:   strResponse = Linkages.Metadata_Functions.AddFieldAttributes(pDataset, "forcodeset", _
      "Description of an 'Codeset Domain' field...", "World Book Encyclopedia", _
      , , , , , , , , "Census Feature Classification Codes (also called ""FCC"")", _
      "Department of Commerce, Census Bureau")
423:   Debug.Print "Add Codeset Domain Field info = " & strResponse
  
  ' ADD ALL FOUR DOMAINS FIELD INFO
426:   strResponse = Linkages.Metadata_Functions.AddFieldAttributes(pDataset, "foralldom", _
      "Description of an 'Range Domain' field...", "World Book Encyclopedia", _
      "0", "100", "54", "Meters", "1.234", "1.111", varData, _
      "Values represent area of polygons as calculated by spheroidal means...", _
      "Census Feature Classification Codes (also called ""FCC"")", _
      "Department of Commerce, Census Bureau", True)
432:   Debug.Print "Add All Three Domain Field info = " & strResponse
  
  ' SET METADATA FORMAT VERSION
  Dim strFormatVersion As String
  Dim lngVersion As Long
437:   lngVersion = Linkages.aml_func_mod.ReturnArcGISVersionAlt2(pMxDoc, strFormatVersion)
'  strResponse = Linkages.Metadata_Functions.SetMetadataFormatVersion(pDataset, "Created in ArcGIS " & strFormatVersion)
439:   strResponse = Linkages.Metadata_Functions.SetMetadataFormatVersion(pDataset, , True, pMxDoc)
440:   Debug.Print "Added Format Version = " & strResponse
  
  
  ' RESYNCHRONIZE METADATA
444:   strResponse = Linkages.Metadata_Functions.SynchronizeMetadataPropSet(pDataset)
445:   Debug.Print "ReSynchronization: " & strResponse
  
ClearMemory:
448:   Set pFClass = Nothing
449:   Set pWS = Nothing
450:   Set pWsFact = Nothing
451:   Set pDataset = Nothing
452:   Set pPropSet = Nothing
453:   Set pKeyWords = Nothing
454:   Set pIncludeThemeKeys = Nothing
455:   Set pIncludeSearchKeys = Nothing
456:   Set pIncludeDescKeys = Nothing
457:   Set pIncludeStratKeys = Nothing
458:   Set pIncludeThemeSlashThemekeys = Nothing
459:   Set pIncludePlaceKeys = Nothing
460:   Set pIncludeTemporalKeys = Nothing
461:   Set pCombinedKeyWords = Nothing
462:   Set pFLayer = Nothing
463:   Set pMxDoc = Nothing
'  Set DataObj = Nothing
465:   Set pSourceFClass = Nothing








End Function

Public Function AddDetailsForObjectDefinition(pDataset As IDataset, strShortDefinition As String, _
    strDefinitionSource As String) As String

  On Error GoTo errHandler
  
'  strResponse = Metadata_Functions.AddDetailsForObjectDefinition(pDataset, _
    "Points representing corridor midpoints", "Corridor Designer")
'  Debug.Print "Added Resource Status = " & strResponse
  
  AddDetailsForObjectDefinition = "Succeeded"
  
  Dim pPropSet As IPropertySet
  Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  
  pPropSet.SetProperty "eainfo/detailed/enttyp/enttypd", strShortDefinition
  pPropSet.SetProperty "eainfo/detailed/enttyp/enttypds", strDefinitionSource
  
  
  Metadata_Functions.SaveMetadata pDataset, pPropSet
  
  GoTo ClearMemory
  Exit Function
  
errHandler:
  AddDetailsForObjectDefinition = "Failed"

ClearMemory:
  Set pPropSet = Nothing
  
End Function


Public Function CopyAttributesFromSourceToDestinationField(pSourceDataset As IDataset, _
  strSourceFieldName As String, pDestinationDataset As IDataset, strDestinationFieldName As String, _
  Optional booFailed As Boolean) As String
  

  On Error GoTo errHandler
  ' GENERALLY CALLED BY OTHER FUNCTIONS
485:   booFailed = False
486:   CopyAttributesFromSourceToDestinationField = "Succeeded"
  Dim pOrigPropSet As IPropertySet
488:   Set pOrigPropSet = ReturnMetadataPropSetFromDataset(pSourceDataset)
  Dim pNewPropSet As IPropertySet
490:   Set pNewPropSet = ReturnMetadataPropSetFromDataset(pDestinationDataset)
    
  ' GET SOURCE INDEX NUMBER
  Dim lngSourceFieldIndex As Long
494:   lngSourceFieldIndex = ReturnAttributeFieldXPathIndex(pSourceDataset, strSourceFieldName, booFailed)
495:   If lngSourceFieldIndex = -1 Then
496:     If booFailed Then
497:       CopyAttributesFromSourceToDestinationField = "ReturnAttributeFieldXPathIndex Failed"
498:     Else
499:       CopyAttributesFromSourceToDestinationField = "No Source Field Found"
500:     End If
501:     GoTo ClearMemory
502:   End If
    
  ' GET DESTINATION INDEX NUMBER
  Dim lngDestinationFieldIndex As Long
506:   lngDestinationFieldIndex = ReturnAttributeFieldXPathIndex(pDestinationDataset, strDestinationFieldName, booFailed)
507:   If lngDestinationFieldIndex = -1 Then
508:     If booFailed Then
509:       CopyAttributesFromSourceToDestinationField = "ReturnAttributeFieldXPathIndex Failed"
510:     Else
511:       CopyAttributesFromSourceToDestinationField = "No Destination Field Found"
512:     End If
513:     GoTo ClearMemory
514:   End If
  
  Dim strXOrigName As String
  Dim strXOrigNameSource As String
  Dim strXNewName As String
  Dim strXNewNameSource As String
  
'  Dim strXDomMin As String
'  Dim strXDomMax As String
'  Dim strXDomUnits As String
'  Dim strXDom As String
'  Dim strXUDom As String
'  Dim strXEDom As String
  
  ' GET CURRENT DESCRIPTION
529:   strXOrigName = "eainfo/detailed/attr[" & CStr(lngSourceFieldIndex) & "]/attrdef"         ' DESCRIPTION OF FIELD
530:   strXOrigNameSource = "eainfo/detailed/attr[" & CStr(lngSourceFieldIndex) & "]/attrdefs"   ' DESCRIPTION SOURCE
531:   strXNewName = "eainfo/detailed/attr[" & CStr(lngDestinationFieldIndex) & "]/attrdef"         ' DESCRIPTION OF FIELD
532:   strXNewNameSource = "eainfo/detailed/attr[" & CStr(lngDestinationFieldIndex) & "]/attrdefs"   ' DESCRIPTION SOURCE
  
'  strXDomMin = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/rdom/rdommin"  ' MINIMUM VALUE
'  strXDomMax = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/rdom/rdommax"  ' MAXIMUM VALUE
'  strXDomUnits = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/rdom/attrunit"   ' UNITS
'  strXDom = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv"
'  strXUDom = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/udom"  ' DESCRIPTION OF VALUES
'  strXUDom = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/edom"  ' LIST OF VALUES
                                                                          ' /edomv = Value
                                                                          ' /edomvd = Description of Value
                                                                          ' /edomvds = Enumerated domain value definition source
  
  ' WRITE DESCRIPTION AND SOURCE
  Dim varVal As Variant
  Dim strDescription As String
  Dim strDescriptionSource As String
  
549:   varVal = pOrigPropSet.GetProperty(strXOrigName)
550:   If Not IsEmpty(varVal) Then
551:     strDescription = CStr(varVal(0))
552:   Else
553:     strDescription = "<-- No Description Found -->"
554:   End If
555:   varVal = pOrigPropSet.GetProperty(strXOrigNameSource)
556:   If Not IsEmpty(varVal) Then
557:     strDescriptionSource = CStr(varVal(0))
558:   Else
559:     strDescriptionSource = "<-- No Description Source Found -->"
560:   End If
  
562:   pNewPropSet.SetProperty strXNewName, strDescription
563:   pNewPropSet.SetProperty strXNewNameSource, strDescriptionSource
  
  ' SET DOMAIN INFO
  Dim strOrigFClassXName As String
  Dim strNewFClassXName As String
  Dim varProperty As Variant
  Dim varSubProperty As Variant
  Dim lngIndex3 As Long
  Dim lngIndex4 As Long
  Dim strSubXName1 As String
  Dim strSubXName2 As String
  Dim strSubXName3 As String
  Dim varSubProp1 As Variant
  Dim varSubProp2 As Variant
  Dim strValue As String
  Dim varCheckPropertyPresent As Variant
  
580:   varProperty = Null
581:   varSubProperty = Null
582:   varSubProp1 = Null
583:   varSubProp2 = Null
584:   varCheckPropertyPresent = Null
585:   varVal = Null
  
'                strOrigFCLassXName = "eainfo/detailed/attr[" & CStr(lngIndex) & "]/attrdomv"
'                varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)
'                varSubProperty = varProperty(0)
'                For lngIndex2 = 0 To UBound(varProperty)
'                  Debug.Print "       " & CStr(lngIndex2) & "] " & CStr(varProperty(lngIndex2))
'                Next lngIndex2
              
  ' GET DOMAIN ATTRIBUTES FROM ORIGINAL FCLASS
595:   strOrigFClassXName = "eainfo/detailed/attr[" & CStr(lngSourceFieldIndex) & "]/attrdomv"
596:   strNewFClassXName = "eainfo/detailed/attr[" & CStr(lngDestinationFieldIndex) & "]/attrdomv"
597:   varProperty = pOrigPropSet.GetProperty(strOrigFClassXName)

  ' ADD DOMAIN ATTRIBUTES TO NEW FCLASS
600:   varCheckPropertyPresent = pNewPropSet.GetProperty(strNewFClassXName)
601:   If Not IsEmpty(varCheckPropertyPresent) Then
602:     pNewPropSet.RemoveProperty strNewFClassXName
603:   End If
604:   For lngIndex3 = 0 To UBound(varProperty)
605:     strSubXName1 = "eainfo/detailed/attr[" & CStr(lngSourceFieldIndex) & "]/attrdomv/" & _
        varProperty(lngIndex3) & "[" & CStr(lngIndex3) & "]"
607:     varSubProp1 = pOrigPropSet.GetProperty(strSubXName1)

609:     For lngIndex4 = 0 To UBound(varSubProp1)
610:       strSubXName2 = "eainfo/detailed/attr[" & CStr(lngSourceFieldIndex) & "]/attrdomv/" & _
          varProperty(lngIndex3) & "[" & CStr(lngIndex3) & "]/" & varSubProp1(lngIndex4)
612:       varSubProp2 = pOrigPropSet.GetProperty(strSubXName2)

      ' WRITE VALUE BACK TO NEW FCLASS
615:       strSubXName3 = "eainfo/detailed/attr[" & CStr(lngDestinationFieldIndex) & "]/attrdomv/" & _
          varProperty(lngIndex3) & "[" & CStr(lngIndex3) & "]/" & varSubProp1(lngIndex4)
617:       strValue = varSubProp2(0)
618:       pNewPropSet.SetProperty strSubXName3, strValue

620:     Next lngIndex4
621:   Next lngIndex3
  
  ' COPY ANY SUBTYPE INFO OVER
'  Dim lngSubTypeIndex As Long
'  Dim lngStFieldIndex As Long
'  Dim lngMaxSubTypeIndex As Long
'  Dim lngMaxStFieldIndex As Long
'
'  lngMaxSubTypeIndex = ReturnLargestIndexValue("", pSourceDataset)
  
'  pPropSet.RemoveProperty "eainfo/detailed/subtype"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stname", "Administrative"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stcode", "1"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[0]/stfldnm", "ROADS_SurfaceMaterial"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[0]/stflddd/domname", "SurfaceMaterialDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[0]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[0]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[0]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[0]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[0]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[0]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[1]/stfldnm", "ROADS_Status"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[1]/stflddd/domname", "RoadStatusDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[1]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[1]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[1]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[1]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[1]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[1]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[2]/stfldnm", "ROADS_Compendium"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[2]/stflddd/domname", "CompendiumDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[2]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[2]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[2]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[2]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[2]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[2]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[3]/stfldnm", "WildernessRecommendation"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[3]/stflddd/domname", "WildernessRecommendDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[3]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[3]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[3]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[3]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[3]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[3]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[4]/stfldnm", "WildernessMap_1980"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[4]/stflddd/domname", "WildMap1980Domain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[4]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[4]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[4]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[4]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[4]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[0]/stfield[4]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stname", "Closed"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stcode", "2"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[0]/stfldnm", "ROADS_SurfaceMaterial"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[0]/stflddd/domname", "SurfaceMaterialDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[0]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[0]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[0]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[0]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[0]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[0]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[1]/stfldnm", "ROADS_Status"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[1]/stflddd/domname", "RoadStatusDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[1]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[1]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[1]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[1]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[1]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[1]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[2]/stfldnm", "ROADS_Compendium"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[2]/stflddd/domname", "CompendiumDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[2]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[2]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[2]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[2]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[2]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[2]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[3]/stfldnm", "WildernessRecommendation"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[3]/stflddd/domname", "WildernessRecommendDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[3]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[3]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[3]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[3]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[3]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[3]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[4]/stfldnm", "WildernessMap_1980"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[4]/stflddd/domname", "WildMap1980Domain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[4]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[4]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[4]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[4]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[4]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[1]/stfield[4]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stname", "Public"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stcode", "3"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[0]/stfldnm", "ROADS_SurfaceMaterial"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[0]/stflddd/domname", "SurfaceMaterialDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[0]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[0]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[0]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[0]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[0]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[0]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[1]/stfldnm", "ROADS_Status"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[1]/stflddd/domname", "RoadStatusDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[1]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[1]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[1]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[1]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[1]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[1]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[2]/stfldnm", "ROADS_Compendium"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[2]/stflddd/domname", "CompendiumDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[2]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[2]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[2]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[2]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[2]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[2]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[3]/stfldnm", "WildernessRecommendation"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[3]/stflddd/domname", "WildernessRecommendDomain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[3]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[3]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[3]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[3]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[3]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[3]/stflddd/domfldtp", "String"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[4]/stfldnm", "WildernessMap_1980"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[4]/stflddd/domname", "WildMap1980Domain"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[4]/stflddd/domdesc", "Description"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[4]/stflddd/domtype", "Coded Value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[4]/stflddd/mrgtype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[4]/stflddd/splttype", "Default value"
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[4]/stflddd/domowner", ""
'  pPropSet.SetProperty "eainfo/detailed/subtype[2]/stfield[4]/stflddd/domfldtp", "String"

759:   Metadata_Functions.SaveMetadata pDestinationDataset, pNewPropSet
  
761:   GoTo ClearMemory
  Exit Function
  
errHandler:
765:   booFailed = True
766:   CopyAttributesFromSourceToDestinationField = "Failed"
  
ClearMemory:

770:   Set pOrigPropSet = Nothing
771:   Set pNewPropSet = Nothing
772:   varVal = Null
773:   varProperty = Null
774:   varSubProperty = Null
775:   varSubProp1 = Null
776:   varSubProp2 = Null
777:   varCheckPropertyPresent = Null




'
'
'    ' ----------------------------------------------------------------------------------------------
'    ' <<<<<<<<<<<<  BLM_AZStrip_UTM12_NAD83  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
'    '-----------------------------------------------------------------------------------------------
'    If strFieldName = "BLM_Add_Attribute" Then
'      strDescription = """TRUE"" or ""FALSE"", whether there was a polyline feature from the 'BLM_AZStrip_UTM12_NAD83' " & _
'          "feature class within 100m of the centroid of this polyline.  If so, then this '" & _
'          "BLM_AZStrip_UTM12_NAD83' feature would be considered a candidate for extracting attribute values " & _
'          "to describe this feature."
'      If Not IsEmpty(varProperty) Then
'        pPropSet.RemoveProperty strXName
'      End If
'      pPropSet.SetProperty strXName, strDescription
'
'      ' SET SOURCE IF IT IS NOT ALREADY SET
'      varSource = pPropSet.GetProperty(strXNameSource)
'      If IsEmpty(varSource) Then
'        pPropSet.SetProperty strXNameSource, "Lab of Landscape Ecology and Conservation Biology; " & _
'            "School of Earth Sciences and Environmental Sustainability; College of Engineering, " & _
'            "Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011"
'      End If
'    End If
'    If strFieldName = "BLM_Attribute_Source" Then
'      strDescription = "If 'BLM_Add_Attribute' above = ""TRUE"", then this field will contain the name of the " & _
'          "BLM feature class (BLM_AZStrip_UTM12_NAD83).  Otherwise it should be Null."
'      If Not IsEmpty(varProperty) Then
'        pPropSet.RemoveProperty strXName
'      End If
'      pPropSet.SetProperty strXName, strDescription
'
'      ' SET SOURCE IF IT IS NOT ALREADY SET
'      varSource = pPropSet.GetProperty(strXNameSource)
'      If IsEmpty(varSource) Then
'        pPropSet.SetProperty strXNameSource, "Lab of Landscape Ecology and Conservation Biology; " & _
'            "School of Earth Sciences and Environmental Sustainability; College of Engineering, " & _
'            "Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011"
'      End If
'    End If
'    If strFieldName = "BLM_Attribute_Distance" Then
'      strDescription = "If 'BLM_Add_Attribute' above = ""TRUE"", then this field will contain the distance " & _
'          "(in meters) from the centroid of this polyline to the nearest BLM feature.  Otherwise it should be Null.  " & _
'          "Values should always be <= 100m."
'      If Not IsEmpty(varProperty) Then
'        pPropSet.RemoveProperty strXName
'      End If
'      pPropSet.SetProperty strXName, strDescription
'
'      ' SET SOURCE IF IT IS NOT ALREADY SET
'      varSource = pPropSet.GetProperty(strXNameSource)
'      If IsEmpty(varSource) Then
'        pPropSet.SetProperty strXNameSource, "Lab of Landscape Ecology and Conservation Biology; " & _
'            "School of Earth Sciences and Environmental Sustainability; College of Engineering, " & _
'            "Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011"
'      End If
'
'      pPropSet.RemoveProperty strXDom
'      pPropSet.SetProperty strXDomMin, "0"
'      pPropSet.SetProperty strXDomMax, "100"
'      pPropSet.SetProperty strXDomUnits, "Meters"
'    End If
'    If strFieldName = "BLM_ObjectID" Then
'      strDescription = "If 'BLM_Add_Attribute' above = ""TRUE"", then this field will contain the OBJECTID " & _
'          "value of the nearest BLM feature, from the BLM_AZStrip_UTM12_NAD83 feature class."
'      If Not IsEmpty(varProperty) Then
'        pPropSet.RemoveProperty strXName
'      End If
'      pPropSet.SetProperty strXName, strDescription
'
'      ' SET SOURCE IF IT IS NOT ALREADY SET
'      varSource = pPropSet.GetProperty(strXNameSource)
'      If IsEmpty(varSource) Then
'        pPropSet.SetProperty strXNameSource, "Lab of Landscape Ecology and Conservation Biology; " & _
'            "School of Earth Sciences and Environmental Sustainability; College of Engineering, " & _
'            "Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011"
'      End If
'    End If
'
'
'    For lngBLMIndex = 0 To UBound(strBLMObsArray, 1)
'      If strFieldName = strBLMObsArray(lngBLMIndex, 0) Then '  "BLM_OBS_USE1", "BLM_OBS_USE2" or "BLM_OBS_USE3"
'
'        ' FIND ORIGINAL FIELD METADATA
'        For lngIndex = 0 To pBLM_AZStrip_UTM12_NAD83_FClass.Fields.FieldCount
'          strNames(0) = "eainfo/detailed/attr[" & CStr(lngIndex) & "]"
'          pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperties strNames, varVals
'          varSubVals = varVals(0)
'          If Not IsEmpty(varSubVals) Then
'            ' GET FIELD NAME
'            strOrigFCLassXName = "eainfo/detailed/attr[" & CStr(lngIndex) & "]/attrlabl"
'            varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)
'            If Not IsEmpty(varProperty) Then
'              varSubProperty = varProperty(0)
'              If IsEmpty(varSubProperty) Then
'                strOrigFieldName = "<-- No Field Name -->"
'              Else
'                strOrigFieldName = CStr(varSubProperty)
'              End If
'            Else
'              strOrigFieldName = "<-- No Field Name -->"
'            End If
'
'            If strOrigFieldName = strBLMObsArray(lngBLMIndex, 1) Then ' "OBS_USE1", "OBS_USE2", or "OBS_USE3"
'
'
'              If lngBLMIndex <= 4 Then
'                strOrigFCLassXName = "eainfo/detailed/attr[" & CStr(lngIndex) & "]/attrdomv"
'                varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)
'                varSubProperty = varProperty(0)
''                For lngIndex2 = 0 To UBound(varProperty)
''                  Debug.Print "       " & CStr(lngIndex2) & "] " & CStr(varProperty(lngIndex2))
''                Next lngIndex2
'
'                ' GET DOMAIN ATTRIBUTES FROM ORIGINAL FCLASS
'                strOrigFCLassXName = "eainfo/detailed/attr[" & CStr(lngIndex) & "]/attrdomv"
'                varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)
'
'                ' ADD DOMAIN ATTRIBUTES TO NEW FCLASS
'                varCheckPropertyPresent = pPropSet.GetProperty("eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv")
'                If Not IsEmpty(varCheckPropertyPresent) Then
'                  pPropSet.RemoveProperty "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv"
'                End If
'                For lngIndex3 = 0 To UBound(varProperty)
'                  strSubXName1 = "eainfo/detailed/attr[" & CStr(lngIndex) & "]/attrdomv/" & _
'                      varProperty(lngIndex3) & "[" & CStr(lngIndex3) & "]"
'                  varSubProp1 = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strSubXName1)
'
'                  For lngIndex4 = 0 To UBound(varSubProp1)
'                    strSubXName2 = "eainfo/detailed/attr[" & CStr(lngIndex) & "]/attrdomv/" & _
'                        varProperty(lngIndex3) & "[" & CStr(lngIndex3) & "]/" & varSubProp1(lngIndex4)
'                    varSubProp2 = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strSubXName2)
'
'                    ' WRITE VALUE BACK TO NEW FCLASS
'                    strSubXName3 = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/" & _
'                        varProperty(lngIndex3) & "[" & CStr(lngIndex3) & "]/" & varSubProp1(lngIndex4)
'                    strValue = varSubProp2(0)
'                    strValue = Replace(strValue, "20003", "2003")
'                    strValue = Replace(strValue, "Dicitonary", "Dictionary")
'                    pPropSet.SetProperty strSubXName3, strValue
'
'                  Next lngIndex4
'                Next lngIndex3
'              Else
''                strOrigFCLassXName = "eainfo/detailed/attr[" & CStr(lngIndex) & "]"
''                varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)
''                varSubProperty = varProperty(0)
''                Debug.Print "Examining " & strOrigFieldName & "..."
''                For lngIndex2 = 0 To UBound(varProperty)
''                  varSubProp1 = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName & "/" & _
''                        CStr(varProperty(lngIndex2)))
''                  Debug.Print "       " & CStr(lngIndex2) & "] " & CStr(varProperty(lngIndex2)) & " = " & _
''                        CStr(varSubProp1(0))
''                Next lngIndex2
'              End If
'
'              If strOrigFieldName = "ROAD_NO_" Then
'                Debug.Print "Here..."
'              End If
'
'              ' GET DEFINITION FROM ORIGINAL FCLASS
'              varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty("eainfo/detailed/attr[" & CStr(lngIndex) & "]/attrdef")
'              If Not IsEmpty(varProperty) Then
'                varSubProperty = varProperty(0)
'                If IsEmpty(varSubProperty) Then
'                  strDescription = "<-- No Description -->"
'                Else
'                  strDescription = CStr(varSubProperty)
'                End If
'              Else
'                strDescription = "<-- No Description -->"
'              End If
'              strDescription = Replace(strDescription, "  [Imported from TransportationLine_UTM12_NAD83]", "", , , vbTextCompare)
'              strDescription = strDescription & _
'                  "  This field should only have a value if the 'BLM_Add_Attribute' value = ""TRUE"".  " & _
'                  "[Imported from BLM_AZStrip_UTM12_NAD83, Field """ & strBLMObsArray(lngBLMIndex, 1) & """]"
'
'              ' SET FIELD DEFINITION OF NEW FCLASS
'              varCheckPropertyPresent = pPropSet.GetProperty("eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdef")
'              If Not IsEmpty(varCheckPropertyPresent) Then
'                pPropSet.RemoveProperty "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdef"
'              End If
'              pPropSet.SetProperty "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdef", strDescription
'
'              ' GET DESCRIPTION SOURCE FROM ORIGINAL FCLASS
'              varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty("eainfo/detailed/attr[" & CStr(lngIndex) & "]/attrdefs")
'              If Not IsEmpty(varProperty) Then
'                varSubProperty = varProperty(0)
'                If IsEmpty(varSubProperty) Then
'                  strDescriptionSource = "BLM_AZStrip_UTM12_NAD83"
'                Else
'                  strDescriptionSource = CStr(varSubProperty)
'                End If
'              Else
'                strDescriptionSource = "BLM_AZStrip_UTM12_NAD83"
'              End If
'              strDescriptionSource = Replace(strDescriptionSource, "Dicitonary", "Dictionary", , , vbTextCompare)
'              strDescriptionSource = Replace(strDescriptionSource, "20003", "2003", , , vbTextCompare)
'
'              ' SET DESCRIPTION SOURCE DEFINITION OF NEW FCLASS
'              varCheckPropertyPresent = pPropSet.GetProperty("eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdefs")
'              If Not IsEmpty(varCheckPropertyPresent) Then
'                pPropSet.RemoveProperty "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdefs"
'              End If
'
'              ' ONLY ADD THIS NEW ONE IF THERE WAS ONE IN THE ORIGINAL FCLASS
'              If strDescriptionSource <> "" Then
'                pPropSet.SetProperty "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdefs", strDescriptionSource
'              End If
'
'              Exit For
'            End If
'          End If
'        Next lngIndex
'      End If
'    Next lngBLMIndex
'  End If











End Function
Public Function SetMetadataFormatVersion(pDataset As IDataset, _
  Optional strFormatVersion As String, _
  Optional booInsertArcGISVersionAutomatically As Boolean = False, _
  Optional pMxDoc As IMapDocument) As String
    On Error GoTo errHandler
'
'  Dim strFormatVersion As String
'  Dim lngVersion As Long
'  lngVersion = Linkages.aml_func_mod.ReturnArcGISVersionAlt(pMxDoc, strFormatVersion)
'  strResponse = Metadata_Functions.SetMetadataFormatVersion(pDataset, "Created in ArcGIS " & strFormatVersion)
'  Debug.Print "Added Format Version = " & strResponse
  
1022:   SetMetadataFormatVersion = "Succeeded"
  
  Dim pPropSet As IPropertySet
1025:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  
  Dim strAutoVersion As String
  Dim lngAutoVersion As Long
1029:   If booInsertArcGISVersionAutomatically Then
1030:     If pMxDoc Is Nothing Then
1031:       MsgBox "Map Document required to generate version!"
1032:       strAutoVersion = strFormatVersion
1033:     Else
1034:       lngAutoVersion = Linkages.aml_func_mod.ReturnArcGISVersionAlt2(pMxDoc, strAutoVersion)
1035:       strAutoVersion = "Created in ArcGIS Version " & strAutoVersion
1036:     End If
1037:     pPropSet.RemoveProperty "distInfo/distFormat/formatVer"
1038:     pPropSet.SetProperty "distInfo/distFormat/formatVer", strAutoVersion
1039:   Else
1040:     pPropSet.RemoveProperty "distInfo/distFormat/formatVer"
1041:     pPropSet.SetProperty "distInfo/distFormat/formatVer", strFormatVersion
1042:   End If
  
1044:   Metadata_Functions.SaveMetadata pDataset, pPropSet
  
1046:   GoTo ClearMemory
  Exit Function
  
errHandler:
1050:   SetMetadataFormatVersion = "Failed"

ClearMemory:
1053:   Set pPropSet = Nothing

End Function

Public Function AddFieldAttributes(pDataset As IDataset, strFieldName As String, _
  strFieldDescription As String, strFieldDescriptionSource As String, _
  Optional strRDOMFieldMin As String, Optional strRDOMFieldMax As String, _
  Optional strRDOMFieldMean As String, Optional strRDOMFieldUnit As String, _
  Optional strRDOMFieldStDev As String, Optional strRDOMFieldMinResolution As String, _
  Optional varEDOMArrayOfList_ValueDescSource As Variant = Null, _
  Optional strUDOM_DescriptionOfValues As String, _
  Optional strCodesetNameOfList As String, Optional strCodesetSource As String, _
  Optional booClearExistingFieldInfoFirst As Boolean = True) As String
  
  On Error GoTo errHandler
1068:   AddFieldAttributes = "Succeeded"
  
  ' rdom = RANGE DOMAIN
  ' edim = ENUMERATED DOMAIN
  ' udom = UNREPRESENTABLE DOMAIN
  ' codesetd = CODESET DOMAIN
  
'  strResponse = Metadata_Functions.AddResourceMaintenance(pDataset, JenMetadata_Ongoing)
'  Debug.Print "Added Resource Status = " & strResponse

  ' IF varStringArrayOfValueDescSourceList EXISTS, IT SHOULD CONTAIN A STRING
  ' ARRAY WITH DIMENSIONS (2,X), WHERE X IS NUMBER OF ELEMENTS IN LIST.
  ' THIS IS ZERO-BASED, SO "2" MEANS 3 ATTRIBUTES PER ELEMENT (LIST ITEM, DESCRIPTION, SOURCE)
  Dim booAddList As Boolean
1082:   booAddList = False
  
  Dim strListArray() As String
1085:   If Not IsNull(varEDOMArrayOfList_ValueDescSource) Then
1086:     strListArray = varEDOMArrayOfList_ValueDescSource(0)
1087:     If UBound(strListArray, 1) <> 2 Then
1088:       MsgBox "Array has incorrect dimensions.  Skipping this item..."
1089:     Else
1090:       booAddList = True
1091:     End If
1092:   End If
     
  Dim pPropSet As IPropertySet
1095:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
1097:   Set pXMLPropSet = pPropSet
  
  ' GET INDEX NUMBER
  Dim lngFieldIndex As Long
  Dim booFailed As Boolean
1102:   lngFieldIndex = ReturnAttributeFieldXPathIndex(pDataset, strFieldName, booFailed)
1103:   If lngFieldIndex = -1 Then
1104:     If booFailed Then
1105:       AddFieldAttributes = "ReturnAttributeFieldXPathIndex Failed"
1106:     Else
1107:       AddFieldAttributes = "No Field Found"
1108:     End If
1109:     GoTo ClearMemory
1110:   End If
    
  Dim strXName As String
  Dim strXNameSource As String
  Dim strXDomMin As String
  Dim strXDomMax As String
  Dim strXDomUnits As String
  Dim strXDom As String
  Dim strXRDom As String
  Dim strXUDom As String
  Dim strXEDom As String
  Dim strXCodesetDom As String
  
  ' see http://resources.arcgis.com/en/help/main/10.1/index.html#//003t00000037000000
  ' GET CURRENT DESCRIPTION
1125:   strXName = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdef"         ' DESCRIPTION OF FIELD
1126:   strXNameSource = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdefs"   ' DESCRIPTION SOURCE
1127:   strXRDom = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/rdom"  ' RANGE DOMAIN IN GENERAL
1128:   strXDomMin = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/rdom/rdommin"  ' MINIMUM VALUE
1129:   strXDomMax = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/rdom/rdommax"  ' MAXIMUM VALUE
1130:   strXDomUnits = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/rdom/attrunit"   ' UNITS
1131:   strXDom = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv"
1132:   strXUDom = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/udom"  ' DESCRIPTION OF VALUES
1133:   strXEDom = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/edom"  ' LIST OF VALUES
1134:   strXCodesetDom = "eainfo/detailed/attr[" & CStr(lngFieldIndex) & "]/attrdomv/codesetd"  ' GENERAL CODESET DOMAIN
                                                                          ' /edomv = Value
                                                                          ' /edomvd = Description of Value
                                                                          ' /edomvds = Enumerated domain value definition source
  ' rdom = RANGE DOMAIN
  ' edim = ENUMERATED DOMAIN
  ' udom = UNREPRESENTABLE DOMAIN
  ' codesetd = CODESET DOMAIN
  
1143:   If booClearExistingFieldInfoFirst Then
1144:     pPropSet.RemoveProperty strXName
1145:     pPropSet.RemoveProperty strXNameSource
1146:     pPropSet.RemoveProperty strXRDom
1147:     pPropSet.RemoveProperty strXUDom
1148:     pPropSet.RemoveProperty strXEDom
1149:     pPropSet.RemoveProperty strXCodesetDom
1150:   End If
  
1152:   If Trim(strFieldDescription) <> "" Then pPropSet.SetProperty strXName, Trim(strFieldDescription)
1153:   If Trim(strFieldDescriptionSource) <> "" Then pPropSet.SetProperty strXNameSource, Trim(strFieldDescriptionSource)
1154:   If Trim(strRDOMFieldMin) <> "" Then pPropSet.SetProperty strXRDom & "/rdommin", Trim(strRDOMFieldMin)
1155:   If Trim(strRDOMFieldMax) <> "" Then pPropSet.SetProperty strXRDom & "/rdommax", Trim(strRDOMFieldMax)
1156:   If Trim(strRDOMFieldMean) <> "" Then pPropSet.SetProperty strXRDom & "/rdommean", Trim(strRDOMFieldMean)
1157:   If Trim(strRDOMFieldUnit) <> "" Then pPropSet.SetProperty strXRDom & "/attrunit", Trim(strRDOMFieldUnit)
1158:   If Trim(strRDOMFieldStDev) <> "" Then pPropSet.SetProperty strXRDom & "/rdomstdv", Trim(strRDOMFieldStDev)
1159:   If Trim(strRDOMFieldMinResolution) <> "" Then pPropSet.SetProperty strXRDom & "/attrmres", Trim(strRDOMFieldMinResolution)
1160:   If Trim(strUDOM_DescriptionOfValues) <> "" Then pPropSet.SetProperty strXUDom, strUDOM_DescriptionOfValues
1161:   If Trim(strCodesetNameOfList) <> "" Then pPropSet.SetProperty strXCodesetDom & "/codesetn", strCodesetNameOfList
1162:   If Trim(strCodesetSource) <> "" Then pPropSet.SetProperty strXCodesetDom & "/codesets", strCodesetSource
  
  Dim lngIndex As Long
  Dim strValue As String
  Dim strDescription As String
  Dim strSource As String
  Dim lngCounter As Long
1169:   lngCounter = -1
  
1171:   If booAddList Then
1172:     For lngIndex = 0 To UBound(strListArray, 2)
1173:       strValue = Trim(strListArray(0, lngIndex))
1174:       strDescription = Trim(strListArray(1, lngIndex))
1175:       strSource = Trim(strListArray(2, lngIndex))
      
1177:       If strValue <> "" Or strDescription <> "" Or strSource <> "" Then
1178:         lngCounter = lngCounter + 1
1179:         If strValue <> "" Then pPropSet.SetProperty strXEDom & "[" & CStr(lngCounter) & "]/edomv", strValue
1180:         If strDescription <> "" Then pPropSet.SetProperty strXEDom & "[" & CStr(lngCounter) & "]/edomvd", strDescription
1181:         If strSource <> "" Then pPropSet.SetProperty strXEDom & "[" & CStr(lngCounter) & "]/edomvds", strSource
1182:       End If
1183:     Next lngIndex
1184:   End If
  
'  strFieldDescription As String, strFieldDescriptionSource As String, _
'  Optional strRDOMFieldMin As String, Optional strRDOMFieldMax As String, _
'  Optional strRDOMFieldMean As String, Optional strRDOMFieldUnit As String, _
'  Optional strRDOMFieldStDev As String, Optional strRDOMFieldMinResolution As String, _
'  Optional varEDOMArrayOfList_ValueDescSource As Variant = Null, _
'  Optional strUDOM_DescriptionOfValues As String
  
  
1194:   Metadata_Functions.SaveMetadata pDataset, pPropSet
  
1196:   GoTo ClearMemory
  Exit Function
  
errHandler:
1200:   AddFieldAttributes = "Failed"

ClearMemory:
1203:   Erase strListArray
1204:   Set pPropSet = Nothing
1205:   Set pXMLPropSet = Nothing

  
  
End Function



Private Function ReturnAttributeFieldXPathIndex(pDataset As IDataset, strFieldName As String, _
    Optional booFailed As Boolean) As Long

  On Error GoTo errHandler
  ' GENERALLY CALLED BY OTHER FUNCTIONS
1218:   booFailed = False
  
  Dim pPropSet As IPropertySet
1221:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  
  ' GET INDEX NUMBER
  Dim lngFieldIndex As Long
  Dim booFoundField As Boolean
  Dim varVals As Variant
1227:   varVals = Array("placeholder")
  Dim varName As Variant
  Dim strTestName As String
  
1231:   booFoundField = False
  Dim lngIndex As Long
1233:   lngFieldIndex = -1
1234:   lngIndex = -1
1235:   Do Until IsEmpty(varVals)
1236:     lngIndex = lngIndex + 1
1237:     varVals = pPropSet.GetProperty("eainfo/detailed/attr[" & CStr(lngIndex) & "]")
1238:     If Not IsEmpty(varVals) Then
1239:       varName = pPropSet.GetProperty("eainfo/detailed/attr[" & CStr(lngIndex) & "]/attrlabl")
1240:       If Not IsEmpty(varName) Then
1241:         strTestName = CStr(varName(0))
'        Debug.Print CStr(lngIndex) & "] " & strTestName
1243:         If StrComp(Trim(strTestName), Trim(strFieldName), vbTextCompare) = 0 Then
1244:           booFoundField = True
1245:           lngFieldIndex = lngIndex
1246:           Exit Do
1247:         End If
1248:       End If
1249:     End If
1250:   Loop
  
1252:   If booFoundField Then
1253:     ReturnAttributeFieldXPathIndex = lngFieldIndex
1254:   Else
1255:     ReturnAttributeFieldXPathIndex = -1
1256:   End If
  
1258:   GoTo ClearMemory
  Exit Function
  
errHandler:
1262:   booFailed = True
1263:   ReturnAttributeFieldXPathIndex = -1
  
ClearMemory:
1266:   Set pPropSet = Nothing
1267:   varVals = Null
1268:   varName = Null
  
End Function



Public Function AddResourceMaintenance(pDataset As IDataset, enumMaintCode As JenMetadataMaintenanceCodes) As String

  On Error GoTo errHandler
  
'  strResponse = Metadata_Functions.AddResourceMaintenance(pDataset, JenMetadata_Ongoing)
'  Debug.Print "Added Resource Status = " & strResponse
  
1281:   AddResourceMaintenance = "Succeeded"
  
  Dim pPropSet As IPropertySet
1284:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
1286:   Set pXMLPropSet = pPropSet
  
  Dim strMaintenance As String
1289:   strMaintenance = ReturnMaintenanceCode(enumMaintCode)
1290:   pXMLPropSet.SetAttribute "dataIdInfo/resMaint/maintFreq/MaintFreqCd", "value", strMaintenance, esriXSPAAddOrReplace
  
1292:   Metadata_Functions.SaveMetadata pDataset, pPropSet
  
1294:   GoTo ClearMemory
  Exit Function
  
errHandler:
1298:   AddResourceMaintenance = "Failed"

ClearMemory:
1301:   Set pPropSet = Nothing
1302:   Set pXMLPropSet = Nothing
End Function
Public Function AddResourceDetailsStatus(pDataset As IDataset, enumJenStatus As JenMetadataStatusValues) As String

  On Error GoTo errHandler
  
'  strResponse = Metadata_Functions.AddResourceDetailsStatus(pDataset, JenMetadata_Ongoing)
'  Debug.Print "Added Resource Status = " & strResponse
  
1311:   AddResourceDetailsStatus = "Succeeded"
  
  Dim pPropSet As IPropertySet
1314:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
1316:   Set pXMLPropSet = pPropSet
  
  Dim strStatus As String
1319:   strStatus = ReturnStatusString(enumJenStatus)
1320:   pXMLPropSet.SetAttribute "dataIdInfo/idStatus/ProgCd", "value", strStatus, esriXSPAAddOrReplace
  
1322:   Metadata_Functions.SaveMetadata pDataset, pPropSet
  
1324:   GoTo ClearMemory
  Exit Function
  
errHandler:
1328:   AddResourceDetailsStatus = "Failed"

ClearMemory:
1331:   Set pPropSet = Nothing
1332:   Set pXMLPropSet = Nothing
  
End Function

Public Function AddCitationDates(pDataset As IDataset, _
  Optional datCreated As Date = CDate(0), _
  Optional datPublished As Date = CDate(0), _
  Optional datRevised As Date = CDate(0)) As String
  
  On Error GoTo errHandler
  
'  Dim datCreated As Date
'  Dim datPublished As Date
'  datCreated = Now
'  datPublished = DateAdd("s", 1234567, datCreated)
'  strResponse = Metadata_Functions.AddCitationDates(pDataset, datCreated, datPublished)
'  Debug.Print "Added Citation Dates = " & strResponse

1350:   AddCitationDates = "Succeeded"
  
  Dim pPropSet As IPropertySet
1353:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  
1355:   If Not datCreated = CDate(0) Then
1356:     pPropSet.SetProperty "dataIdInfo/idCitation/date/createDate", Format(datCreated, "yyyy-mm-ddTHh:Nn:Ss")
1357:   End If
1358:   If Not datPublished = CDate(0) Then
1359:     pPropSet.SetProperty "dataIdInfo/idCitation/date/pubDate", Format(datPublished, "yyyy-mm-ddTHh:Nn:Ss")
1360:   End If
1361:   If Not datRevised = CDate(0) Then
1362:     pPropSet.SetProperty "dataIdInfo/idCitation/date/reviseDate", Format(datRevised, "yyyy-mm-ddTHh:Nn:Ss")
1363:   End If

1365:   Metadata_Functions.SaveMetadata pDataset, pPropSet
  
1367:   GoTo ClearMemory
  Exit Function
  
errHandler:
1371:   AddCitationDates = "Failed"

ClearMemory:
1374:   Set pPropSet = Nothing
  
End Function



Public Function AddContact_Metadata(pDataset As IDataset, _
    enumJenRole As JenMetadataRoleCDValues, _
    strIndividualName As String, _
    Optional booGetIndividualNameAutomatically As Boolean = False, _
    Optional strOrganizationName As String = "", _
    Optional strPositionName As String = "", _
    Optional strVoiceNumber As String = "", _
    Optional strAddressStreet As String = "", _
    Optional strAddressCity As String = "", _
    Optional strAddressState As String = "", _
    Optional strAddressZip As String = "", _
    Optional strAddressCountry As String = "", _
    Optional strAddressEmail As String = "", _
    Optional enumJenAddressType As JenMetadataAddressTypeValues = JenMetadata_Skip, _
    Optional booSkipIfAlreadyPresent As Boolean = True) As String
    
    On Error GoTo errHandler
    
  ' NEED CONTACT FOR METADATA, CITATION RESPONSIBLE PARTY AND RESOURCE POINT OF CONTACT
  ' ADD NEW METADATA CONTACTS
  '  strName = Linkages.aml_func_mod.GetTheUserName
  '  strResponse = Metadata_Functions.AddContact_Metadata(pDataset, JenMetadata_PointOfContact, _
  '    "Jeff Jenness or strName", False, "Jenness Enterprises", "Geoanalyst and Programmer", "1-928-607-4635", _
  '    "3020 N. Schevene Blvd.", "Flagstaff", "AZ", "86004", "USA", "jeffj@jennessent.com", _
  "    JenMetadata_Postal, True)
  ' Debug.Print "Added Metadata Contact 'Custodian' = " & strResponse
  
1407:   AddContact_Metadata = "Succeeded"
  
1409:   If booGetIndividualNameAutomatically Then strIndividualName = Linkages.aml_func_mod.GetTheUserName
  
  Dim pPropSet As IPropertySet
1412:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
1414:   Set pXMLPropSet = pPropSet
  
  Dim strRole As String
1417:   strRole = ReturnRoleCDString(enumJenRole)
  
  Dim strAddressType As String
1420:   strAddressType = ReturnAddressType(enumJenAddressType)
    
  Dim lngXIndex As Long
  Dim strXPath As String
1424:   strXPath = "mdContact"
1425:   lngXIndex = ReturnLargestIndexValue(strXPath, pDataset) + 1
  
  Dim booContactAlreadyPresent As Boolean
1428:   If booSkipIfAlreadyPresent Then
1429:     booContactAlreadyPresent = CheckIfContactAlreadyPresent(pDataset, _
      enumJenRole, strIndividualName, strOrganizationName, _
       strPositionName, strVoiceNumber, strAddressStreet, strAddressCity, _
       strAddressState, strAddressZip, strAddressCountry, strAddressEmail, _
       enumJenAddressType, lngXIndex, pPropSet, pXMLPropSet, strXPath)
    
1435:     If booContactAlreadyPresent Then
1436:       AddContact_Metadata = "Metadata Contact Already Present"
1437:       GoTo ClearMemory
1438:     End If
1439:   End If
  
1441:   pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpIndName", strIndividualName
1442:   If strOrganizationName <> "" Then
1443:     pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpOrgName", strOrganizationName
1444:   End If
1445:   If strPositionName <> "" Then
1446:     pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpPosName", strPositionName
1447:   End If
1448:   If strVoiceNumber <> "" Then
1449:     pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntPhone/voiceNum", strVoiceNumber
1450:   End If
1451:   If strAddressStreet <> "" Then
1452:     pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/delPoint", strAddressStreet
1453:   End If
1454:   If strAddressCity <> "" Then
1455:     pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/city", strAddressCity
1456:   End If
1457:   If strAddressState <> "" Then
1458:     pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/adminArea", strAddressState
1459:   End If
1460:   If strAddressZip <> "" Then
1461:     pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/postCode", strAddressZip
1462:   End If
1463:   If strAddressCountry <> "" Then
1464:     pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/country", strAddressCountry
1465:   End If
1466:   If strAddressEmail <> "" Then
1467:     pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/eMailAdd", strAddressEmail
1468:   End If
  
1470:   pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/role/RoleCd", ""
1471:   pXMLPropSet.SetAttribute "mdContact[" & CStr(lngXIndex) & "]/role/RoleCd", "value", strRole, esriXSPAAddOrReplace
1472:   If enumJenAddressType <> JenMetadata_Skip Then
1473:     pXMLPropSet.SetAttribute "mdContact[" & CStr(lngXIndex) & _
         "]/rpCntInfo/cntAddress", "addressType", strAddressType, esriXSPAAddOrReplace
1475:   End If

1477:   Metadata_Functions.SaveMetadata pDataset, pPropSet

1479:   GoTo ClearMemory
  Exit Function
  
errHandler:
1483:   AddContact_Metadata = "Failed"

ClearMemory:
1486:   Set pPropSet = Nothing
1487:   Set pXMLPropSet = Nothing
End Function

Private Function CheckIfContactAlreadyPresent(pDataset As IDataset, _
    enumJenRole As JenMetadataRoleCDValues, _
    strIndividualName As String, _
    strOrganizationName As String, _
    strPositionName As String, _
    strVoiceNumber As String, _
    strAddressStreet As String, _
    strAddressCity As String, _
    strAddressState As String, _
    strAddressZip As String, _
    strAddressCountry As String, _
    strAddressEmail As String, _
    enumJenAddressType As JenMetadataAddressTypeValues, _
    lngMaxIndex As Long, _
    pPropSet As IPropertySet, _
    pXMLPropSet As IXmlPropertySet2, _
    strXPath As String, _
    Optional booFailed As Boolean) As Boolean
    
    On Error GoTo errHandler
  
  ' GENERALLY CALLED BY OTHER FUNCTIONS
  
  Dim varVals As Variant
'  varVals = Array("placeholder")
'
'  ReturnLargestIndexValue = -1
'  Do Until IsEmpty(varVals)
'    ReturnLargestIndexValue = ReturnLargestIndexValue + 1
'    varVals = pPropSet.GetProperty(strXPath & "[" & CStr(ReturnLargestIndexValue) & "]")
'  Loop
  
1522:   booFailed = False
  
  Dim booFoundDuplicate As Boolean
1525:   booFoundDuplicate = False
  Dim booFoundDuplicateInStep As Boolean
  Dim strTestVal As String
  Dim lngIndex As Long
  
1530:   For lngIndex = 0 To lngMaxIndex
1531:     booFoundDuplicateInStep = True
    
    ' NAME
1534:     varVals = pPropSet.GetProperty(strXPath & "[" & CStr(lngIndex) & "]/rpIndName")
1535:     If IsEmpty(varVals) Then
1536:       If strIndividualName <> "" Then booFoundDuplicateInStep = False
1537:     Else
1538:       strTestVal = CStr(varVals(0))
1539:       If Trim(strIndividualName) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1540:     End If
    
1542:     If booFoundDuplicateInStep Then
      ' ORGANIZATION
1544:       varVals = pPropSet.GetProperty(strXPath & "[" & CStr(lngIndex) & "]/rpOrgName")
1545:       If IsEmpty(varVals) Then
1546:         If strOrganizationName <> "" Then booFoundDuplicateInStep = False
1547:       Else
1548:         strTestVal = CStr(varVals(0))
1549:         If Trim(strOrganizationName) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1550:       End If
1551:     End If
    
1553:     If booFoundDuplicateInStep Then
      ' POSITION
1555:       varVals = pPropSet.GetProperty(strXPath & "[" & CStr(lngIndex) & "]/rpPosName")
1556:       If IsEmpty(varVals) Then
1557:         If strPositionName <> "" Then booFoundDuplicateInStep = False
1558:       Else
1559:         strTestVal = CStr(varVals(0))
1560:         If Trim(strPositionName) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1561:       End If
1562:     End If
      
1564:     If booFoundDuplicateInStep Then
      ' VOICE NUMBER
1566:       varVals = pPropSet.GetProperty(strXPath & "[" & CStr(lngIndex) & "]/rpCntInfo/cntPhone/voiceNum")
1567:       If IsEmpty(varVals) Then
1568:         If strVoiceNumber <> "" Then booFoundDuplicateInStep = False
1569:       Else
1570:         strTestVal = CStr(varVals(0))
1571:         If Trim(strVoiceNumber) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1572:       End If
1573:     End If
      
1575:     If booFoundDuplicateInStep Then
      ' ADDRESS STREET
1577:       varVals = pPropSet.GetProperty(strXPath & "[" & CStr(lngIndex) & "]/rpCntInfo/cntAddress/delPoint")
1578:       If IsEmpty(varVals) Then
1579:         If strAddressStreet <> "" Then booFoundDuplicateInStep = False
1580:       Else
1581:         strTestVal = CStr(varVals(0))
1582:         If Trim(strAddressStreet) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1583:       End If
1584:     End If
      
1586:     If booFoundDuplicateInStep Then
      ' ADDRESS CITY
1588:       varVals = pPropSet.GetProperty(strXPath & "[" & CStr(lngIndex) & "]/rpCntInfo/cntAddress/city")
1589:       If IsEmpty(varVals) Then
1590:         If strAddressCity <> "" Then booFoundDuplicateInStep = False
1591:       Else
1592:         strTestVal = CStr(varVals(0))
1593:         If Trim(strAddressCity) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1594:       End If
1595:     End If
      
1597:     If booFoundDuplicateInStep Then
      ' ADDRESS STATE
1599:       varVals = pPropSet.GetProperty(strXPath & "[" & CStr(lngIndex) & "]/rpCntInfo/cntAddress/adminArea")
1600:       If IsEmpty(varVals) Then
1601:         If strAddressState <> "" Then booFoundDuplicateInStep = False
1602:       Else
1603:         strTestVal = CStr(varVals(0))
1604:         If Trim(strAddressState) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1605:       End If
1606:     End If
      
1608:     If booFoundDuplicateInStep Then
      ' ADDRESS ZIP
1610:       varVals = pPropSet.GetProperty(strXPath & "[" & CStr(lngIndex) & "]/rpCntInfo/cntAddress/postCode")
1611:       If IsEmpty(varVals) Then
1612:         If strAddressZip <> "" Then booFoundDuplicateInStep = False
1613:       Else
1614:         strTestVal = CStr(varVals(0))
1615:         If Trim(strAddressZip) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1616:       End If
1617:     End If
      
1619:     If booFoundDuplicateInStep Then
      ' ADDRESS COUNTRY
1621:       varVals = pPropSet.GetProperty(strXPath & "[" & CStr(lngIndex) & "]/rpCntInfo/cntAddress/country")
1622:       If IsEmpty(varVals) Then
1623:         If strAddressCountry <> "" Then booFoundDuplicateInStep = False
1624:       Else
1625:         strTestVal = CStr(varVals(0))
1626:         If Trim(strAddressCountry) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1627:       End If
1628:     End If
      
1630:     If booFoundDuplicateInStep Then
      ' ADDRESS EMAIL
1632:       varVals = pPropSet.GetProperty(strXPath & "[" & CStr(lngIndex) & "]/rpCntInfo/cntAddress/eMailAdd")
1633:       If IsEmpty(varVals) Then
1634:         If strAddressEmail <> "" Then booFoundDuplicateInStep = False
1635:       Else
1636:         strTestVal = CStr(varVals(0))
1637:         If Trim(strAddressEmail) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1638:       End If
1639:     End If
      
1641:     If booFoundDuplicateInStep Then
      ' ROLE
1643:       pXMLPropSet.GetAttribute strXPath & "[" & CStr(lngIndex) & "]/role/RoleCd", "value", varVals
1644:       If IsEmpty(varVals) Then
1645:         booFoundDuplicateInStep = False
1646:       Else
1647:         strTestVal = CStr(varVals(0))
1648:         If Trim(ReturnRoleCDString(enumJenRole)) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1649:       End If
1650:     End If
      
1652:     If booFoundDuplicateInStep Then
      ' ADDRESS TYPE
1654:       pXMLPropSet.GetAttribute strXPath & "[" & CStr(lngIndex) & "]/rpCntInfo/cntAddress", "addressType", varVals
1655:       If IsEmpty(varVals) Then
1656:         If enumJenAddressType <> JenMetadata_Skip Then booFoundDuplicateInStep = False
1657:       Else
1658:         strTestVal = CStr(varVals(0))
1659:         If Trim(ReturnAddressType(enumJenAddressType)) <> Trim(strTestVal) Then booFoundDuplicateInStep = False
1660:       End If
1661:     End If
    
  
'  pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpIndName", strIndividualName
'  If strOrganizationName <> "" Then
'    pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpOrgName", strOrganizationName
'  End If
'  If strPositionName <> "" Then
'    pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpPosName", strPositionName
'  End If
'  If strVoiceNumber <> "" Then
'    pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntPhone/voiceNum", strVoiceNumber
'  End If
'  If strAddressStreet <> "" Then
'    pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/delPoint", strAddressStreet
'  End If
'  If strAddressCity <> "" Then
'    pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/city", strAddressCity
'  End If
'  If strAddressState <> "" Then
'    pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/adminArea", strAddressState
'  End If
'  If strAddressZip <> "" Then
'    pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/postCode", strAddressZip
'  End If
'  If strAddressCountry <> "" Then
'    pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/country", strAddressCountry
'  End If
'  If strAddressEmail <> "" Then
'    pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/eMailAdd", strAddressEmail
'  End If
'
'  pPropSet.SetProperty "mdContact[" & CStr(lngXIndex) & "]/role/RoleCd", ""
'  pXMLPropSet.SetAttribute "mdContact[" & CStr(lngXIndex) & "]/role/RoleCd", "value", strRole, esriXSPAAddOrReplace
'  If enumJenAddressType <> JenMetadata_Skip Then
'    pXMLPropSet.SetAttribute "mdContact[" & CStr(lngXIndex) & _
'         "]/rpCntInfo/cntAddress", "addressType", strAddressType, esriXSPAAddOrReplace
'  End If
'
'  Metadata_Functions.SaveMetadata pDataset, pPropSet

    
    
1704:     If booFoundDuplicateInStep Then
1705:       booFoundDuplicate = True
1706:       Exit For
1707:     End If
1708:   Next lngIndex
  
1710:   CheckIfContactAlreadyPresent = booFoundDuplicate
  
1712:   GoTo ClearMemory
  Exit Function
  
errHandler:
1716:   CheckIfContactAlreadyPresent = False
1717:   booFailed = True
  
ClearMemory:
1720:   varVals = Null
  
End Function

Public Function AddContact_CitationResponsibleParty(pDataset As IDataset, _
    enumJenRole As JenMetadataRoleCDValues, _
    strIndividualName As String, _
    Optional booGetIndividualNameAutomatically As Boolean = False, _
    Optional strOrganizationName As String = "", _
    Optional strPositionName As String = "", _
    Optional strVoiceNumber As String = "", _
    Optional strAddressStreet As String = "", _
    Optional strAddressCity As String = "", _
    Optional strAddressState As String = "", _
    Optional strAddressZip As String = "", _
    Optional strAddressCountry As String = "", _
    Optional strAddressEmail As String = "", _
    Optional enumJenAddressType As JenMetadataAddressTypeValues = JenMetadata_Skip, _
    Optional booSkipIfAlreadyPresent As Boolean = True) As String
    
  On Error GoTo errHandler
    
  ' NEED CONTACT FOR METADATA, CITATION RESPONSIBLE PARTY AND RESOURCE POINT OF CONTACT
    ' ADD NEW CITATION CONTACTS; SHOULD HAVE ORIGINATOR
  '  strName = Linkages.aml_func_mod.GetTheUserName
  '  strResponse = Metadata_Functions.AddContact_CitationResponsibleParty(pDataset, JenMetadata_PointOfContact, _
  '    "Jeff Jenness or strName", False, "Jenness Enterprises", "Geoanalyst and Programmer", "1-928-607-4635", _
  '    "3020 N. Schevene Blvd.", "Flagstaff", "AZ", "86004", "USA", "jeffj@jennessent.com", JenMetadata_Postal)
  ' Debug.Print "Added Citation Contact = " & strResponse
    
1750:   AddContact_CitationResponsibleParty = "Succeeded"
  
1752:   If booGetIndividualNameAutomatically Then strIndividualName = Linkages.aml_func_mod.GetTheUserName
    
  Dim pPropSet As IPropertySet
1755:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
1757:   Set pXMLPropSet = pPropSet
  
  Dim strRole As String
1760:   strRole = ReturnRoleCDString(enumJenRole)
  
  Dim strAddressType As String
1763:   strAddressType = ReturnAddressType(enumJenAddressType)
    
  Dim lngXIndex As Long
  Dim strXPath As String
1767:   strXPath = "dataIdInfo/idCitation/citRespParty"
1768:   lngXIndex = ReturnLargestIndexValue(strXPath, pDataset) + 1
      
  Dim booContactAlreadyPresent As Boolean
1771:   If booSkipIfAlreadyPresent Then
1772:     booContactAlreadyPresent = CheckIfContactAlreadyPresent(pDataset, _
      enumJenRole, strIndividualName, strOrganizationName, _
       strPositionName, strVoiceNumber, strAddressStreet, strAddressCity, _
       strAddressState, strAddressZip, strAddressCountry, strAddressEmail, _
       enumJenAddressType, lngXIndex, pPropSet, pXMLPropSet, strXPath)
    
1778:     If booContactAlreadyPresent Then
1779:       AddContact_CitationResponsibleParty = "Citation Contact Already Present"
1780:       GoTo ClearMemory
1781:     End If
1782:   End If
  
1784:   pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/rpIndName", strIndividualName
1785:   If strOrganizationName <> "" Then
1786:     pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/rpOrgName", strOrganizationName
1787:   End If
1788:   If strPositionName <> "" Then
1789:     pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/rpPosName", strPositionName
1790:   End If
1791:   If strVoiceNumber <> "" Then
1792:     pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/rpCntInfo/cntPhone/voiceNum", strVoiceNumber
1793:   End If
1794:   If strAddressStreet <> "" Then
1795:     pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/delPoint", strAddressStreet
1796:   End If
1797:   If strAddressCity <> "" Then
1798:     pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/city", strAddressCity
1799:   End If
1800:   If strAddressState <> "" Then
1801:     pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/adminArea", strAddressState
1802:   End If
1803:   If strAddressZip <> "" Then
1804:     pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/postCode", strAddressZip
1805:   End If
1806:   If strAddressCountry <> "" Then
1807:     pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/country", strAddressCountry
1808:   End If
1809:   If strAddressEmail <> "" Then
1810:     pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/eMailAdd", strAddressEmail
1811:   End If
  
1813:   pPropSet.SetProperty "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/role/RoleCd", ""
1814:   pXMLPropSet.SetAttribute "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & "]/role/RoleCd", "value", strRole, esriXSPAAddOrReplace
1815:   If enumJenAddressType <> JenMetadata_Skip Then
1816:     pXMLPropSet.SetAttribute "dataIdInfo/idCitation/citRespParty[" & CStr(lngXIndex) & _
         "]/rpCntInfo/cntAddress", "addressType", strAddressType, esriXSPAAddOrReplace
1818:   End If

1820:   Metadata_Functions.SaveMetadata pDataset, pPropSet

1822:   GoTo ClearMemory
  Exit Function
  
errHandler:
1826:   AddContact_CitationResponsibleParty = "Failed"

ClearMemory:
1829:   Set pPropSet = Nothing
1830:   Set pXMLPropSet = Nothing
End Function

Public Function AddContact_ResourcePointOfContact(pDataset As IDataset, _
    enumJenRole As JenMetadataRoleCDValues, _
    strIndividualName As String, _
    Optional booGetIndividualNameAutomatically As Boolean = False, _
    Optional strOrganizationName As String = "", _
    Optional strPositionName As String = "", _
    Optional strVoiceNumber As String = "", _
    Optional strAddressStreet As String = "", _
    Optional strAddressCity As String = "", _
    Optional strAddressState As String = "", _
    Optional strAddressZip As String = "", _
    Optional strAddressCountry As String = "", _
    Optional strAddressEmail As String = "", _
    Optional enumJenAddressType As JenMetadataAddressTypeValues = JenMetadata_Skip, _
    Optional booSkipIfAlreadyPresent As Boolean = True) As String
    
  On Error GoTo errHandler
    
  ' NEED CONTACT FOR METADATA, CITATION RESPONSIBLE PARTY AND RESOURCE POINT OF CONTACT
    ' ADD NEW CITATION CONTACTS; SHOULD HAVE ORIGINATOR
  '  strName = Linkages.aml_func_mod.GetTheUserName
  '  strResponse = Metadata_Functions.AddContact_ResourcePointOfContact(pDataset, JenMetadata_PointOfContact, _
  '    "Jeff Jenness or strName",False, "Jenness Enterprises", "Geoanalyst and Programmer", "1-928-607-4635", _
  '    "3020 N. Schevene Blvd.", "Flagstaff", "AZ", "86004", "USA", "jeffj@jennessent.com", JenMetadata_Postal)
  ' Debug.Print "Added Resource Contact = " & strResponse
  
1859:   AddContact_ResourcePointOfContact = "Succeeded"
  
1861:   If booGetIndividualNameAutomatically Then strIndividualName = Linkages.aml_func_mod.GetTheUserName
  
  Dim pPropSet As IPropertySet
1864:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
1866:   Set pXMLPropSet = pPropSet
  
  Dim strRole As String
1869:   strRole = ReturnRoleCDString(enumJenRole)
  
  Dim strAddressType As String
1872:   strAddressType = ReturnAddressType(enumJenAddressType)
    
  Dim lngXIndex As Long
  Dim strXPath As String
1876:   strXPath = "dataIdInfo/idPoC"
1877:   lngXIndex = ReturnLargestIndexValue(strXPath, pDataset) + 1
    
  Dim booContactAlreadyPresent As Boolean
1880:   If booSkipIfAlreadyPresent Then
1881:     booContactAlreadyPresent = CheckIfContactAlreadyPresent(pDataset, _
      enumJenRole, strIndividualName, strOrganizationName, _
       strPositionName, strVoiceNumber, strAddressStreet, strAddressCity, _
       strAddressState, strAddressZip, strAddressCountry, strAddressEmail, _
       enumJenAddressType, lngXIndex, pPropSet, pXMLPropSet, strXPath)
    
1887:     If booContactAlreadyPresent Then
1888:       AddContact_ResourcePointOfContact = "Resource Contact Already Present"
1889:       GoTo ClearMemory
1890:     End If
1891:   End If
  
1893:   pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/rpIndName", strIndividualName
1894:   If strOrganizationName <> "" Then
1895:     pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/rpOrgName", strOrganizationName
1896:   End If
1897:   If strPositionName <> "" Then
1898:     pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/rpPosName", strPositionName
1899:   End If
1900:   If strVoiceNumber <> "" Then
1901:     pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/rpCntInfo/cntPhone/voiceNum", strVoiceNumber
1902:   End If
1903:   If strAddressStreet <> "" Then
1904:     pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/delPoint", strAddressStreet
1905:   End If
1906:   If strAddressCity <> "" Then
1907:     pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/city", strAddressCity
1908:   End If
1909:   If strAddressState <> "" Then
1910:     pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/adminArea", strAddressState
1911:   End If
1912:   If strAddressZip <> "" Then
1913:     pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/postCode", strAddressZip
1914:   End If
1915:   If strAddressCountry <> "" Then
1916:     pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/country", strAddressCountry
1917:   End If
1918:   If strAddressEmail <> "" Then
1919:     pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/rpCntInfo/cntAddress/eMailAdd", strAddressEmail
1920:   End If
  
1922:   pPropSet.SetProperty "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/role/RoleCd", ""
1923:   pXMLPropSet.SetAttribute "dataIdInfo/idPoC[" & CStr(lngXIndex) & "]/role/RoleCd", "value", strRole, esriXSPAAddOrReplace
1924:   If enumJenAddressType <> JenMetadata_Skip Then
1925:     pXMLPropSet.SetAttribute "dataIdInfo/idPoC[" & CStr(lngXIndex) & _
         "]/rpCntInfo/cntAddress", "addressType", strAddressType, esriXSPAAddOrReplace
1927:   End If

1929:   Metadata_Functions.SaveMetadata pDataset, pPropSet

1931:   GoTo ClearMemory
  Exit Function
  
errHandler:
1935:   AddContact_ResourcePointOfContact = "Failed"

ClearMemory:
1938:   Set pPropSet = Nothing
1939:   Set pXMLPropSet = Nothing
End Function


Public Function AddNewGeoProcStep(pDataset As IDataset, _
    strDescription As String, _
    strToolSource As String, _
    datDate As Date, _
    strProcessName As String, _
    booShouldExport As Boolean) As String
  
  On Error GoTo errHandler
  
'  ' ADD NEW GEOPROCESSING EVENT
'  strResponse = AddNewGeoProcStep(pDataset, "NOTE:  This is not Python code! " & _
'      "  Parameters used in analysis...", app.Path & "\" & App.EXEName & ".dll\Tool_Name", _
'      Now, "Extension Name, then Tool Name", False)
'  Debug.Print "Added new Geoprocessing Event = " & strResponse
  
1958:   AddNewGeoProcStep = "Succeeded"
  
  Dim pPropSet As IPropertySet
1961:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
1963:   Set pXMLPropSet = pPropSet
  
  Dim strDate As String
  Dim strTime As String
  
1968:   strDate = Format(datDate, "yyyymmdd")
1969:   strTime = Format(datDate, "HhNnSs")
  
  Dim strExport As String
1972:   If booShouldExport Then
1973:     strExport = "True"
1974:   Else
1975:     strExport = ""
1976:   End If
  
  Dim lngLineageIndex As Long
  Dim strXPath As String
1980:   strXPath = "Esri/DataProperties/lineage/Process"
1981:   lngLineageIndex = ReturnLargestIndexValue(strXPath, pDataset) + 1
    
1983:   pPropSet.SetProperty "Esri/DataProperties/lineage/Process[" & CStr(lngLineageIndex) & _
      "]", strDescription

1986:   pXMLPropSet.SetAttribute "Esri/DataProperties/lineage/Process[" & CStr(lngLineageIndex) & _
      "]", "ToolSource", strToolSource, esriXSPAAddOrReplace
1988:   pXMLPropSet.SetAttribute "Esri/DataProperties/lineage/Process[" & CStr(lngLineageIndex) & _
      "]", "Date", strDate, esriXSPAAddOrReplace
1990:   pXMLPropSet.SetAttribute "Esri/DataProperties/lineage/Process[" & CStr(lngLineageIndex) & _
      "]", "Time", strTime, esriXSPAAddOrReplace
1992:   pXMLPropSet.SetAttribute "Esri/DataProperties/lineage/Process[" & CStr(lngLineageIndex) & _
      "]", "Name", strProcessName, esriXSPAAddOrReplace
1994:   pXMLPropSet.SetAttribute "Esri/DataProperties/lineage/Process[" & CStr(lngLineageIndex) & _
      "]", "export", strExport, esriXSPAAddOrReplace
  
1997:   Metadata_Functions.SaveMetadata pDataset, pPropSet

1999:   GoTo ClearMemory
  Exit Function
  
errHandler:
2003:   AddNewGeoProcStep = "Failed"

ClearMemory:
2006:   Set pPropSet = Nothing
2007:   Set pXMLPropSet = Nothing
  
End Function
Public Function CopyLineageOrGeoprocHistory(pSourceDataset As IDataset, pRecipientDataset As IDataset, _
    booEraseExistingInRecipient As Boolean, enumLineageOrGeoproc As JenMetadataLineageOrGeoprocValues) As String
    
'  strResponse = CopyLineageOrGeoprocHistory(pSourceDataset, pRecipientDataset, False, JenMetadata_GeoprocessingHistory)
'  Debug.Print "Geoproc History Transfer Successful = " & strResponse

  Dim strSourceXML As String
2017:   strSourceXML = ReturnExistingLineageOrGeoprocessingHistory(pSourceDataset, enumLineageOrGeoproc)
  
2019:   If enumLineageOrGeoproc = JenMetadata_Lineage Then
2020:     CopyLineageOrGeoprocHistory = InsertExistingLineageHistory(pRecipientDataset, strSourceXML, booEraseExistingInRecipient)
2021:   Else
2022:     CopyLineageOrGeoprocHistory = InsertExistingGeoProcessingHistory(pRecipientDataset, strSourceXML, booEraseExistingInRecipient)
2023:   End If
  
End Function

Private Function ReturnExistingLineageOrGeoprocessingHistory(pDataset As IDataset, _
     enumLineageOrGeoproc As JenMetadataLineageOrGeoprocValues) As String
  On Error GoTo errHandler:
  
  ' GENERALLY CALLED BY:
  '  CopyLineageOrGeoprocHistory
  '  InsertExistingGeoProcessingHistory
  '  InsertExistingLineageHistory
  
  Dim pPropSet As IPropertySet
2037:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
2039:   Set pXMLPropSet = pPropSet
  Dim strXPath As String
2041:   If enumLineageOrGeoproc = JenMetadata_Lineage Then
2042:     strXPath = "dqInfo/dataLineage"
2043:   Else
2044:     strXPath = "Esri/DataProperties/lineage"
2045:   End If
  
  Dim strXML As String
2048:   strXML = pXMLPropSet.GetXml(strXPath)
2049:   ReturnExistingLineageOrGeoprocessingHistory = strXML
  
'  Debug.Print strXML
  
2053:   GoTo ClearMemory
  Exit Function

errHandler:
2057:   ReturnExistingLineageOrGeoprocessingHistory = ""

ClearMemory:
2060:   Set pPropSet = Nothing
2061:   Set pXMLPropSet = Nothing
End Function

Private Function InsertExistingGeoProcessingHistory(pDataset As IDataset, strLineageHistory As String, _
    booEraseExistingInRecipient As Boolean) As String
  On Error GoTo errHandler:
  
  ' GENERALLY CALLED BY:
  '  CopyLineageOrGeoprocHistory
  
2071:   InsertExistingGeoProcessingHistory = "Succeeded"
    
  Dim pPropSet As IPropertySet
2074:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
2076:   Set pXMLPropSet = pPropSet
  
  Dim strCurrentLineage As String
  
  Dim strFullXML As String
  Dim lngStartSplice As Long
  Dim lngEndSplice As Long
  Dim lngInsertPoint As Long
  Dim lngInsertPoint2 As Long
  Dim strTempXML As String
  Dim strIntermXML As String
  
2088:   strFullXML = pXMLPropSet.GetXml("")
  
2090:   If booEraseExistingInRecipient Then
2091:     lngStartSplice = InStr(1, strFullXML, "<lineage>", vbTextCompare)
2092:     If lngStartSplice = 0 Then
2093:       pPropSet.SetProperty "Esri/DataProperties/lineage/Process[0]", "placeholder"
2094:       strFullXML = pXMLPropSet.GetXml("")
2095:       lngStartSplice = InStr(1, strFullXML, "<lineage>", vbTextCompare)
2096:     End If
    
2098:     lngEndSplice = InStr(1, strFullXML, "</lineage>", vbTextCompare)
    
2100:     lngInsertPoint = lngStartSplice
    
2102:     strTempXML = strFullXML
2103:     Do Until lngStartSplice = 0
2104:       strTempXML = Left(strTempXML, lngStartSplice - 1) & Right(strTempXML, Len(strTempXML) - lngEndSplice - 9)
2105:       lngStartSplice = InStr(1, strTempXML, "<lineage>", vbTextCompare)
2106:       lngEndSplice = InStr(1, strTempXML, "</lineage>", vbTextCompare)
2107:     Loop
    
2109:     strTempXML = Left(strTempXML, lngInsertPoint - 1) & strLineageHistory & _
        Right(strTempXML, Len(strTempXML) - lngInsertPoint + 1)
2111:   Else
    
    ' GET XML LINEAGE TEXT FROM CURRENT DATASET
2114:     strCurrentLineage = ReturnExistingLineageOrGeoprocessingHistory(pDataset, JenMetadata_GeoprocessingHistory)
2115:     lngInsertPoint = InStr(1, strCurrentLineage, "</lineage>", vbTextCompare)
    
    ' IF IT DOESN'T EXIST, CREATE NEW INSERT POINT BASED ON FULL XML STRING AND PASTE IN LINEAGE
2118:     If lngInsertPoint = 0 Then   ' IF THERE IS NO "Lineage" IN METADATA
2119:       pPropSet.SetProperty "Esri/DataProperties/lineage/Process[0]", "placeholder"
2120:       strFullXML = pXMLPropSet.GetXml("")
2121:       lngStartSplice = InStr(1, strFullXML, "<lineage>", vbTextCompare)
        
2123:       lngEndSplice = InStr(1, strFullXML, "</lineage>", vbTextCompare)
      
2125:       lngInsertPoint = lngStartSplice
      
2127:       strTempXML = strFullXML
2128:       Do Until lngStartSplice = 0
2129:         strTempXML = Left(strTempXML, lngStartSplice - 1) & Right(strTempXML, Len(strTempXML) - lngEndSplice - 9)
2130:         lngStartSplice = InStr(1, strTempXML, "<lineage>", vbTextCompare)
2131:         lngEndSplice = InStr(1, strTempXML, "</lineage>", vbTextCompare)
2132:       Loop
    
2134:       strTempXML = Left(strTempXML, lngInsertPoint - 1) & strLineageHistory & _
          Right(strTempXML, Len(strTempXML) - lngInsertPoint + 1)
2136:     Else
      
      ' IF IT DOES EXIST, THEN NEED TO TRIM OFF "dataLineage" TAGS AND STICK HISTORY INSIDE OF CURRENT LINEAGE
2139:       strLineageHistory = Replace(strLineageHistory, "<lineage>", "", , , vbBinaryCompare)
2140:       strLineageHistory = Replace(strLineageHistory, "</lineage>", "", , , vbBinaryCompare)
      
2142:       strIntermXML = Left(strCurrentLineage, lngInsertPoint - 1) & strLineageHistory & _
          Right(strCurrentLineage, Len(strCurrentLineage) - lngInsertPoint + 1)
      
      ' NOW REPLACE CURRENT LINEAGE IN FULL XML TEXT
2146:       lngStartSplice = InStr(1, strFullXML, "<lineage>", vbTextCompare)
2147:       If lngStartSplice = 0 Then
2148:         pPropSet.SetProperty "Esri/DataProperties/lineage/Process[0]", "placeholder"
2149:         strFullXML = pXMLPropSet.GetXml("")
2150:         lngStartSplice = InStr(1, strFullXML, "<lineage>", vbTextCompare)
2151:       End If
      
2153:       lngEndSplice = InStr(1, strFullXML, "</lineage>", vbTextCompare)
      
2155:       lngInsertPoint = lngStartSplice
2156:       strTempXML = strFullXML
2157:       Do Until lngStartSplice = 0
2158:         strTempXML = Left(strTempXML, lngStartSplice - 1) & Right(strTempXML, Len(strTempXML) - lngEndSplice - 9)
2159:         lngStartSplice = InStr(1, strTempXML, "<lineage>", vbTextCompare)
2160:         lngEndSplice = InStr(1, strTempXML, "</lineage>", vbTextCompare)
2161:       Loop
      
2163:       strTempXML = Left(strTempXML, lngInsertPoint - 1) & strIntermXML & _
          Right(strTempXML, Len(strTempXML) - lngInsertPoint + 1)
        
2166:     End If
2167:   End If
  
2169:   pXMLPropSet.SetXml strTempXML
    
  
2172:   Metadata_Functions.SaveMetadata pDataset, pPropSet
  
2174:   GoTo ClearMemory
  Exit Function

errHandler:
2178:   InsertExistingGeoProcessingHistory = "Failed"

ClearMemory:
2181:   Set pPropSet = Nothing
2182:   Set pXMLPropSet = Nothing
  
End Function

Private Function InsertExistingLineageHistory(pDataset As IDataset, strLineageHistory As String, _
    booEraseExistingInRecipient As Boolean) As String
  On Error GoTo errHandler:
  
  ' GENERALLY CALLED BY:
  '  CopyLineageOrGeoprocHistory
  
2193:   InsertExistingLineageHistory = "Succeeded"
    
  Dim pPropSet As IPropertySet
2196:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
2198:   Set pXMLPropSet = pPropSet
  
  Dim strCurrentLineage As String
  
  Dim strFullXML As String
  Dim lngStartSplice As Long
  Dim lngEndSplice As Long
  Dim lngInsertPoint As Long
  Dim lngInsertPoint2 As Long
  Dim strTempXML As String
  Dim strIntermXML As String
  
2210:   strFullXML = pXMLPropSet.GetXml("")
  
2212:   If booEraseExistingInRecipient Then
2213:     lngStartSplice = InStr(1, strFullXML, "<dataLineage>", vbTextCompare)
2214:     If lngStartSplice = 0 Then
2215:       pPropSet.SetProperty "dqInfo/dataLineage/prcStep[0]/stepDesc", "placeholder"
2216:       strFullXML = pXMLPropSet.GetXml("")
2217:       lngStartSplice = InStr(1, strFullXML, "<dataLineage>", vbTextCompare)
2218:     End If
    
2220:     lngEndSplice = InStr(1, strFullXML, "</dataLineage>", vbTextCompare)
    
2222:     lngInsertPoint = lngStartSplice
    
2224:     strTempXML = strFullXML
2225:     Do Until lngStartSplice = 0
2226:       strTempXML = Left(strTempXML, lngStartSplice - 1) & Right(strTempXML, Len(strTempXML) - lngEndSplice - 13)
2227:       lngStartSplice = InStr(1, strTempXML, "<dataLineage>", vbTextCompare)
2228:       lngEndSplice = InStr(1, strTempXML, "</dataLineage>", vbTextCompare)
2229:     Loop
    
2231:     strTempXML = Left(strTempXML, lngInsertPoint - 1) & strLineageHistory & _
        Right(strTempXML, Len(strTempXML) - lngInsertPoint + 1)
2233:   Else
    
    ' GET XML LINEAGE TEXT FROM CURRENT DATASET
2236:     strCurrentLineage = ReturnExistingLineageOrGeoprocessingHistory(pDataset, JenMetadata_Lineage)
2237:     lngInsertPoint = InStr(1, strCurrentLineage, "</dataLineage>", vbTextCompare)
    
    ' IF IT DOESN'T EXIST, CREATE NEW INSERT POINT BASED ON FULL XML STRING AND PASTE IN LINEAGE
2240:     If lngInsertPoint = 0 Then
      
2242:       strTempXML = pXMLPropSet.GetXml("")
2243:       lngInsertPoint = InStr(1, strTempXML, "</metadata>", vbTextCompare)
2244:       strTempXML = Left(strTempXML, lngInsertPoint - 1) & "<dqInfo>" & strLineageHistory & "</dqInfo>" & _
          Right(strTempXML, Len(strTempXML) - lngInsertPoint + 1)
2246:     Else
      
      
      ' IF IT DOES EXIST, THEN NEED TO TRIM OFF "dataLineage" TAGS AND STICK HISTORY INSIDE OF CURRENT LINEAGE
2250:       strLineageHistory = Replace(strLineageHistory, "<dataLineage>", "", , , vbTextCompare)
2251:       strLineageHistory = Replace(strLineageHistory, "</dataLineage>", "", , , vbTextCompare)
      
2253:       strIntermXML = Left(strCurrentLineage, lngInsertPoint - 1) & strLineageHistory & _
          Right(strCurrentLineage, Len(strCurrentLineage) - lngInsertPoint + 1)
      
      ' NOW REPLACE CURRENT LINEAGE IN FULL XML TEXT
2257:       lngStartSplice = InStr(1, strFullXML, "<dataLineage>", vbTextCompare)
2258:       If lngStartSplice = 0 Then
2259:         pPropSet.SetProperty "dqInfo/dataLineage/prcStep[0]/stepDesc", "placeholder"
2260:         strFullXML = pXMLPropSet.GetXml("")
2261:         lngStartSplice = InStr(1, strFullXML, "<dataLineage>", vbTextCompare)
2262:       End If
      
2264:       lngEndSplice = InStr(1, strFullXML, "</dataLineage>", vbTextCompare)
      
2266:       lngInsertPoint = lngStartSplice
2267:       strTempXML = strFullXML
2268:       Do Until lngStartSplice = 0
2269:         strTempXML = Left(strTempXML, lngStartSplice - 1) & Right(strTempXML, Len(strTempXML) - lngEndSplice - 13)
2270:         lngStartSplice = InStr(1, strTempXML, "<dataLineage>", vbTextCompare)
2271:         lngEndSplice = InStr(1, strTempXML, "</dataLineage>", vbTextCompare)
2272:       Loop
      
2274:       strTempXML = Left(strTempXML, lngInsertPoint - 1) & strIntermXML & _
          Right(strTempXML, Len(strTempXML) - lngInsertPoint + 1)
        
2277:     End If
2278:   End If
  
2280:   pXMLPropSet.SetXml strTempXML
      
2282:   Metadata_Functions.SaveMetadata pDataset, pPropSet
  
2284:   GoTo ClearMemory
  Exit Function

errHandler:
2288:   InsertExistingLineageHistory = "Failed"

ClearMemory:
2291:   Set pPropSet = Nothing
2292:   Set pXMLPropSet = Nothing
  
End Function

Public Function AddNewLineageStep(pDataset As IDataset, _
    strDescription As String, _
    datDate As Date, _
    enumJenRole As JenMetadataRoleCDValues, _
    strIndividualName As String, _
    Optional booGetIndividualNameAutomatically As Boolean = False, _
    Optional strOrganizationName As String = "", _
    Optional strPositionName As String = "", _
    Optional strVoiceNumber As String = "", _
    Optional strAddressStreet As String = "", _
    Optional strAddressCity As String = "", _
    Optional strAddressState As String = "", _
    Optional strAddressZip As String = "", _
    Optional strAddressCountry As String = "", _
    Optional strAddressEmail As String = "", _
    Optional enumJenAddressType As JenMetadataAddressTypeValues = JenMetadata_Skip) As String
  
  On Error GoTo errHandler
    
2315:   If booGetIndividualNameAutomatically Then strIndividualName = Linkages.aml_func_mod.GetTheUserName
  
'  strDescription = "Lengthy description of process, along with selected parameter values."
'  strName = Linkages.aml_func_mod.GetTheUserName
'  strResponse = Metadata_Functions.AddNewLineageStep(pDataset, strDescription, Now, JenMetadata_PointOfContact, _
'      "Jeff Jenness or strName", "Jenness Enterprises", "Geoanalyst and Programmer", "1-928-607-4635", _
'      "3020 N. Schevene Blvd.", "Flagstaff", "AZ", "86004", "USA", "jeffj@jennessent.com", JenMetadata_Postal)
'  Debug.Print "Lineage Successful = " & strResponse
  
2324:   AddNewLineageStep = "Succeeded"
  
  Dim pPropSet As IPropertySet
2327:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
2329:   Set pXMLPropSet = pPropSet
  
  Dim strRole As String
2332:   strRole = ReturnRoleCDString(enumJenRole)
  
  Dim strAddressType As String
2335:   strAddressType = ReturnAddressType(enumJenAddressType)
    
  Dim lngLineageIndex As Long
  Dim strXPath As String
2339:   strXPath = "dqInfo/dataLineage/prcStep"
2340:   lngLineageIndex = ReturnLargestIndexValue(strXPath, pDataset) + 1
  
'  Dim varVals As Variant
'  varVals = Array("placeholder")
'
'  lngLineageIndex = -1
'  Do Until IsEmpty(varVals)
'    lngLineageIndex = lngLineageIndex + 1
'    varVals = pPropSet.GetProperty("dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]")
'  Loop
  
  
  
  ' RoleCD values:
  '
  ' 006 = Originator
  ' 007 = Point of Contact
  ' 009 = Processor
  ' 010 = Publisher    ....   "A cited responsible party is added with the publisher " & _
  '                           "role to contain all information pertaining to the publisher. " & _
  '                           "The contents of the publication place element is placed in the " & _
  '                           "address's delivery point element. This may not be correct in all cases."

  
  ' AscTypeCD values:
  ' 001 = Cross Reference
  ' 002 - LargerWorkCitation
  
  ' MaintFreqCD values:
  
  ' RestrictCD values:
  
  ' ProgCD values:
  
  ' ClasscationCD values:  (sic)
  
  ' PresFormCD values:
  
  ' MedNameCD values:
  
  ' SpatRepTypCD values:  "Values will be either vector or grid; point = vector."
  
  ' GeoObjTypCD values:  "Related information with ArcGIS terminology recorded at " & _\
  '     "/metadata/spdoinfo/ptvctinf/esriterm, with feature type at efeageom/@code and feature count in efeacnt."

  ' TopoLevCD values:  "ArcGIS-related topology information is recorded at " & _
  '     "/metadata/spdoinfo/ptvctinf/esriterm/esritopo for all vector data formats.
  
2388:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepDesc"
2389:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepDateTm"
2390:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/rpIndName"
2391:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/rpOrgName"
2392:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/rpPosName"
2393:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/rpCntInfo/cntPhone/voiceNum"
2394:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/rpCntInfo/cntAddress/delPoint"
2395:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/rpCntInfo/cntAddress/city"
2396:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/rpCntInfo/cntAddress/adminArea"
2397:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/rpCntInfo/cntAddress/postCode"
2398:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/rpCntInfo/cntAddress/country"
2399:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/rpCntInfo/cntAddress/eMailAdd"
2400:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/role/RoleCd"
2401:   pPropSet.RemoveProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & "]/stepProc/displayName"
    
2403:   pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
      "]/stepDesc", strDescription
2405:   pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
       "]/stepDateTm", Format(datDate, "yyyy-mm-ddTHh:Nn:Ss") ' "2013-09-01T00:00:00"
2407:   pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
       "]/stepProc/rpIndName", strIndividualName
2409:   If strOrganizationName <> "" Then
2410:     pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
         "]/stepProc/rpOrgName", strOrganizationName
2412:   End If
2413:   If strPositionName <> "" Then
2414:     pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
         "]/stepProc/rpPosName", strPositionName
2416:   End If
2417:   If strVoiceNumber <> "" Then
2418:     pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
         "]/stepProc/rpCntInfo/cntPhone/voiceNum", strVoiceNumber
2420:   End If
2421:   If strAddressStreet <> "" Then
2422:     pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
         "]/stepProc/rpCntInfo/cntAddress/delPoint", strAddressStreet
2424:   End If
2425:   If strAddressCity <> "" Then
2426:     pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
         "]/stepProc/rpCntInfo/cntAddress/city", strAddressCity
2428:   End If
2429:   If strAddressState <> "" Then
2430:     pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
         "]/stepProc/rpCntInfo/cntAddress/adminArea", strAddressState
2432:   End If
2433:   If strAddressZip <> "" Then
2434:     pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
         "]/stepProc/rpCntInfo/cntAddress/postCode", strAddressZip
2436:   End If
2437:   If strAddressCountry <> "" Then
2438:     pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
         "]/stepProc/rpCntInfo/cntAddress/country", strAddressCountry
2440:   End If
2441:   If strAddressEmail <> "" Then
2442:     pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
         "]/stepProc/rpCntInfo/cntAddress/eMailAdd", strAddressEmail
2444:   End If
  
2446:   pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
       "]/stepProc/role/RoleCd", ""
       
2449:   pPropSet.SetProperty "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
       "]/stepProc/displayName", strIndividualName

2452:   pXMLPropSet.SetAttribute "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
      "]/stepProc/role/RoleCd", "value", strRole, esriXSPAAddOrReplace
  
2455:   If enumJenAddressType <> JenMetadata_Skip Then
2456:     pXMLPropSet.SetAttribute "dqInfo/dataLineage/prcStep[" & CStr(lngLineageIndex) & _
         "]/stepProc/rpCntInfo/cntAddress", "addressType", strAddressType, esriXSPAAddOrReplace
2458:   End If

2460:   Metadata_Functions.SaveMetadata pDataset, pPropSet

2462:   GoTo ClearMemory
  Exit Function
  
errHandler:
2466:   AddNewLineageStep = "Failed"

ClearMemory:
2469:   Set pPropSet = Nothing
2470:   Set pXMLPropSet = Nothing
  
End Function

Private Function ReturnLargestIndexValue(strXPath As String, pDataset As IDataset, _
    Optional booFailed As Boolean) As Long
  
  On Error GoTo errHandler
  
  ' GENERALLY CALLED BY OTHER FUNCTIONS
2480:   booFailed = False
  Dim pPropSet As IPropertySet
2482:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  
  Dim varVals As Variant
2485:   varVals = Array("placeholder")
  
2487:   ReturnLargestIndexValue = -1
2488:   Do Until IsEmpty(varVals)
2489:     ReturnLargestIndexValue = ReturnLargestIndexValue + 1
2490:     varVals = pPropSet.GetProperty(strXPath & "[" & CStr(ReturnLargestIndexValue) & "]")
2491:   Loop
2492:   ReturnLargestIndexValue = ReturnLargestIndexValue - 1
    
2494:   GoTo ClearMemory
  Exit Function
  
errHandler:
2498:   ReturnLargestIndexValue = -1
2499:   booFailed = True
  
ClearMemory:
2502:   Set pPropSet = Nothing
2503:   varVals = Null
  
End Function
Public Function ReturnAllMetadataPropertiesFromDataset(pDataset As IDataset, _
    Optional booFailed As Boolean) As String

  On Error GoTo errHandler
  
'  SAMPLE CODE
'  Dim pFLayer As IFeatureLayer
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Set pFLayer = Linkages.mygeneralOperations.ReturnLayerByName("Roads_for_Metadata", pMxDoc.FocusMap)
'  Dim pFClass As IFeatureClass
'
'  Set pFClass = pFLayer.FeatureClass
'  Dim pDataset As IDataset
'  Set pDataset = pFClass
'
'  Dim strAllProps As String
'  Dim strXML As String
'
'  strXML = Metadata_Functions.ReturnMetadataXMLStringFromDataset(pDataset)
'  strAllProps = Metadata_Functions.ReturnAllMetadataPropertiesFromDataset(pDataset)
'
'  Dim DataObj As New MSForms.DataObject
''  DataObj.SetText strXML
'  DataObj.SetText strAllProps
'  DataObj.PutInClipboard
'  Set DataObj = Nothing
  
2534:   booFailed = False
  Dim pPropSet As IPropertySet
2536:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)

  Dim varVals As Variant
  Dim varNames As Variant
2540:   pPropSet.GetAllProperties varNames, varVals
  
  Dim strProps As String
  Dim lngIndex As Long
  
  ' ALL PROPERTIES ========================================
  
2547:   For lngIndex = 0 To UBound(varVals)
2548:     If lngIndex <> UBound(varVals) Then

2550:       strProps = strProps & CStr(lngIndex) & "] " & varNames(lngIndex) & vbCrLf
2551:       If VarType(varVals(lngIndex)) = vbDataObject Then
2552:         strProps = strProps & "  --> *** DATA OBJECT ***" & vbCrLf
2553:       Else
2554:         strProps = strProps & "  --> " & varVals(lngIndex) & vbCrLf
2555:       End If
2556:     End If

2558:   Next lngIndex
  
2560:   ReturnAllMetadataPropertiesFromDataset = strProps
  
2562:   GoTo ClearMemory
  Exit Function
  
errHandler:
2566:   ReturnAllMetadataPropertiesFromDataset = "ReturnAllMetadataPropertiesFromDataset Failed"
2567:   booFailed = True
  
ClearMemory:
2570:   Set pPropSet = Nothing
2571:   varVals = Null
2572:   varNames = Null
  
End Function

Public Function ReturnMetadataXMLStringFromDataset(pDataset As IDataset, _
    Optional booFailed As Boolean) As String

  On Error GoTo errHandler
  
'  SAMPLE CODE
'  Dim pFLayer As IFeatureLayer
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Set pFLayer = Linkages.mygeneralOperations.ReturnLayerByName("Roads_for_Metadata", pMxDoc.FocusMap)
'  Dim pFClass As IFeatureClass
'
'  Set pFClass = pFLayer.FeatureClass
'  Dim pDataset As IDataset
'  Set pDataset = pFClass
'
'  Dim strAllProps As String
'  Dim strXML As String
'
'  strXML = Metadata_Functions.ReturnMetadataXMLStringFromDataset(pDataset)
'  strAllProps = Metadata_Functions.ReturnAllMetadataPropertiesFromDataset(pDataset)
'
'  Dim DataObj As New MSForms.DataObject
''  DataObj.SetText strXML
'  DataObj.SetText strAllProps
'  DataObj.PutInClipboard
'  Set DataObj = Nothing
  
2604:   booFailed = False
  
  Dim pPropSet As IPropertySet
2607:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  Dim pXMLPropSet As IXmlPropertySet2
2609:   Set pXMLPropSet = pPropSet
  
  Dim strXML As String
2612:   strXML = pXMLPropSet.GetXml("")
2613:   ReturnMetadataXMLStringFromDataset = strXML
    
2615:   GoTo ClearMemory
  Exit Function
  
errHandler:
2619:   ReturnMetadataXMLStringFromDataset = "ReturnMetadataXMLStringFromDataset Failed"
2620:   booFailed = True
  
ClearMemory:
2623:   Set pPropSet = Nothing
2624:   Set pXMLPropSet = Nothing
  
End Function

Public Function ReturnDataElementFromDataset(pDataset As IDataset, Optional booFailed As Boolean) As IDataElement

  On Error GoTo errHandler
  
  Dim pName As IName
2633:   Set pName = pDataset.FullName
'  Debug.Print pName.NameString
  
  Dim pDEUtils As IDEUtilities
2637:   Set pDEUtils = New DEUtilities
  
2639:   Set ReturnDataElementFromDataset = pDEUtils.MakeDataElementFromNameObject(pName)
  
2641:   GoTo ClearMemory
  Exit Function
  
errHandler:
2645:   Set ReturnDataElementFromDataset = Nothing
2646:   booFailed = True
  
ClearMemory:
2649:   Set pName = Nothing
2650:   Set pDEUtils = Nothing
  
End Function

Public Function SetMetadataKeyWords(pDataset As IDataset, _
  Optional pIncludeThemeKeys As esriSystem.IStringArray, _
  Optional pIncludeSearchKeys As esriSystem.IStringArray, _
  Optional pIncludeDescKeys As esriSystem.IStringArray, _
  Optional pIncludeStratKeys As esriSystem.IStringArray, _
  Optional pIncludeThemeSlashThemekeys As esriSystem.IStringArray, _
  Optional pIncludePlaceKeys As esriSystem.IStringArray, _
  Optional pIncludeTemporalKeys As esriSystem.IStringArray) As String   ', _
   ' lngReplaceOrAdd As esriXmlSetPropertyAction) As String
  
  On Error GoTo errHandler
  
'  Dim pKeyWords As esriSystem.IStringArray
'  Dim pIncludeThemeKeys As esriSystem.IStringArray
'  Dim pIncludeSearchKeys As esriSystem.IStringArray
'  Dim pIncludeDescKeys As esriSystem.IStringArray
'  Dim pIncludeStratKeys As esriSystem.IStringArray
'  Dim pIncludeThemeSlashThemekeys As esriSystem.IStringArray
'  Dim pIncludePlaceKeys As esriSystem.IStringArray
'  Dim pIncludeTemporalKeys As esriSystem.IStringArray
'
'  Set pIncludeThemeKeys = New esriSystem.strArray
'  Set pIncludeSearchKeys = New esriSystem.strArray
'  Set pIncludeDescKeys = New esriSystem.strArray
'  Set pIncludeStratKeys = New esriSystem.strArray
'  Set pIncludeThemeSlashThemekeys = New esriSystem.strArray
'  Set pIncludePlaceKeys = New esriSystem.strArray
'  Set pIncludeTemporalKeys = New esriSystem.strArray
'
'  pIncludeThemeKeys.Add "Keyword 1"
'  pIncludeThemeKeys.Add "Keyword 2"
'  pIncludeThemeKeys.Add "Keyword 3"
'  pIncludeSearchKeys.Add "Keyword 1"
'  pIncludeSearchKeys.Add "Keyword 2"
'  pIncludeSearchKeys.Add "Keyword 3"
'  pIncludeDescKeys.Add "Keyword 1"
'  pIncludeDescKeys.Add "Keyword 2"
'  pIncludeDescKeys.Add "Keyword 3"
'
'  pIncludePlaceKeys.Add "Flagstaff"
'  pIncludeThemeSlashThemekeys.Add "theme_slash_theme"
'  pIncludeTemporalKeys.Add "temporal"
'
'  strResponse = Metadata_Functions.SetMetadataKeyWords(pDataset, pIncludeThemeKeys, pIncludeSearchKeys, _
'        pIncludeDescKeys, pIncludeStratKeys, pIncludeThemeSlashThemekeys, pIncludePlaceKeys, pIncludeTemporalKeys)
'  Debug.Print "Saving Keywords: " & strResponse
  
  
2702:   SetMetadataKeyWords = "Succeeded"

  Dim strThemeKeywordsXPath As String
  Dim strSearchKeywordsXPath As String
  Dim strDescKeywordsXPath As String
  Dim strStratKeywordsXPath As String
  Dim strThemeSlashThemekeyKeywordsXPath As String
  Dim strPlaceKeywordsXPath As String
  Dim strTemporalKeywordsXPath As String
  
2712:   strThemeKeywordsXPath = "dataIdInfo/themeKeys/keyword"
2713:   strSearchKeywordsXPath = "dataIdInfo/searchKeys/keyword"
2714:   strDescKeywordsXPath = "dataIdInfo/descKeys/keyword"
2715:   strStratKeywordsXPath = "dataIdInfo/StratKeys/keyword"
2716:   strThemeSlashThemekeyKeywordsXPath = "idinfo/keywords/theme/themekey"
2717:   strPlaceKeywordsXPath = "idinfo/keywords/place/placekey"
2718:   strTemporalKeywordsXPath = "idinfo/keywords/temporal/tempkey"
  
  Dim lngIndex As Long
  Dim strValue As String
  
  Dim pPropSet As IPropertySet
2724:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  
2726:   If Not pIncludeThemeKeys Is Nothing Then
2727:     If pIncludeThemeKeys.Count > 0 Then
2728:       pPropSet.RemoveProperty strThemeKeywordsXPath
2729:       For lngIndex = 0 To pIncludeThemeKeys.Count - 1
2730:         strValue = pIncludeThemeKeys.Element(lngIndex)
2731:         pPropSet.SetProperty strThemeKeywordsXPath & "[" & CStr(lngIndex) & "]", strValue
    '    Debug.Print "  " & CStr(lngIndex) & "] " & strValue
2733:       Next lngIndex
2734:     End If
2735:   End If
  
2737:   If Not pIncludeStratKeys Is Nothing Then
2738:     If pIncludeStratKeys.Count > 0 Then
2739:       pPropSet.RemoveProperty strStratKeywordsXPath
2740:       For lngIndex = 0 To pIncludeStratKeys.Count - 1
2741:         strValue = pIncludeStratKeys.Element(lngIndex)
2742:         pPropSet.SetProperty strStratKeywordsXPath & "[" & CStr(lngIndex) & "]", strValue
2743:       Next lngIndex
2744:     End If
2745:   End If
  
2747:   If Not pIncludeSearchKeys Is Nothing Then
2748:     If pIncludeSearchKeys.Count > 0 Then
2749:       pPropSet.RemoveProperty strSearchKeywordsXPath
2750:       For lngIndex = 0 To pIncludeThemeKeys.Count - 1
2751:         strValue = pIncludeSearchKeys.Element(lngIndex)
2752:         pPropSet.SetProperty strSearchKeywordsXPath & "[" & CStr(lngIndex) & "]", strValue
2753:       Next lngIndex
2754:     End If
2755:   End If
  
2757:   If Not pIncludeDescKeys Is Nothing Then
2758:     If pIncludeDescKeys.Count > 0 Then
2759:       pPropSet.RemoveProperty strDescKeywordsXPath
2760:       For lngIndex = 0 To pIncludeDescKeys.Count - 1
2761:         strValue = pIncludeDescKeys.Element(lngIndex)
2762:         pPropSet.SetProperty strDescKeywordsXPath & "[" & CStr(lngIndex) & "]", strValue
2763:       Next lngIndex
2764:     End If
2765:   End If
  
2767:   If Not pIncludeThemeSlashThemekeys Is Nothing Then
2768:     If pIncludeThemeSlashThemekeys.Count > 0 Then
2769:       pPropSet.RemoveProperty strThemeSlashThemekeyKeywordsXPath
2770:       For lngIndex = 0 To pIncludeThemeSlashThemekeys.Count - 1
2771:         strValue = pIncludeThemeSlashThemekeys.Element(lngIndex)
2772:         pPropSet.SetProperty strThemeSlashThemekeyKeywordsXPath & "[" & CStr(lngIndex) & "]", strValue
2773:       Next lngIndex
2774:     End If
2775:   End If
  
2777:   If Not pIncludePlaceKeys Is Nothing Then
2778:     If pIncludePlaceKeys.Count > 0 Then
2779:       pPropSet.RemoveProperty strPlaceKeywordsXPath
2780:       For lngIndex = 0 To pIncludePlaceKeys.Count - 1
2781:         strValue = pIncludePlaceKeys.Element(lngIndex)
2782:         pPropSet.SetProperty strPlaceKeywordsXPath & "[" & CStr(lngIndex) & "]", strValue
2783:       Next lngIndex
2784:     End If
2785:   End If
  
2787:   If Not pIncludeTemporalKeys Is Nothing Then
2788:     If pIncludeTemporalKeys.Count > 0 Then
2789:       pPropSet.RemoveProperty strTemporalKeywordsXPath
2790:       For lngIndex = 0 To pIncludeTemporalKeys.Count - 1
2791:         strValue = pIncludeTemporalKeys.Element(lngIndex)
2792:         pPropSet.SetProperty strTemporalKeywordsXPath & "[" & CStr(lngIndex) & "]", strValue
2793:       Next lngIndex
2794:     End If
2795:   End If
  
  
2798:   Metadata_Functions.SaveMetadata pDataset, pPropSet
  
2800:   GoTo ClearMemory
  Exit Function
  
errHandler:
2804:   SetMetadataKeyWords = "Failed"

ClearMemory:
2807:   Set pPropSet = Nothing
  
End Function


Public Function ReturnExistingMetadataKeyWords(pDataset As IDataset, _
  pKeyWordsToInsertToArray As esriSystem.IStringArray, booSucceeded As Boolean, _
  Optional pIncludeThemeKeys As esriSystem.IStringArray, _
  Optional pIncludeSearchKeys As esriSystem.IStringArray, _
  Optional pIncludeDescKeys As esriSystem.IStringArray, _
  Optional pIncludeStratKeys As esriSystem.IStringArray, _
  Optional pIncludeThemeSlashThemekeys As esriSystem.IStringArray, _
  Optional pIncludePlaceKeys As esriSystem.IStringArray, _
  Optional pIncludeTemporalKeys As esriSystem.IStringArray) As esriSystem.IStringArray
  
  On Error GoTo errHandler
  
  ' SAMPLE CODE
'  Dim pKeyWords As esriSystem.IStringArray
'  Dim pIncludeThemeKeys As esriSystem.IStringArray
'  Dim pIncludeSearchKeys As esriSystem.IStringArray
'  Dim pIncludeDescKeys As esriSystem.IStringArray
'  Dim pIncludeStratKeys As esriSystem.IStringArray
'  Dim pIncludeThemeSlashThemekeys As esriSystem.IStringArray
'  Dim pIncludePlaceKeys As esriSystem.IStringArray
'  Dim pIncludeTemporalKeys As esriSystem.IStringArray
'
'  Set pIncludeThemeKeys = New esriSystem.strArray
'  Set pIncludeSearchKeys = New esriSystem.strArray
'  Set pIncludeDescKeys = New esriSystem.strArray
'  Set pIncludeStratKeys = New esriSystem.strArray
'  Set pIncludeThemeSlashThemekeys = New esriSystem.strArray
'  Set pIncludePlaceKeys = New esriSystem.strArray
'  Set pIncludeTemporalKeys = New esriSystem.strArray
'
'  pIncludeThemeSlashThemekeys.Add "theme_slash_theme"
'  pIncludeTemporalKeys.Add "temporal"
'
'  Dim pCombinedKeyWords As esriSystem.IStringArray
'  Dim pFLayer As IFeatureLayer
'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Set pFLayer = Linkages.mygeneralOperations.ReturnLayerByName("mroads", pMxDoc.FocusMap)
'  Dim booSucceeded As Boolean
'  Dim lngIndex As Long
'  Set pCombinedKeyWords = Metadata_Functions.ReturnExistingMetadataKeyWords(pFLayer.FeatureClass, _
'      pKeyWords, booSucceeded, pIncludeThemeKeys, pIncludesearchKeys, pIncludeDescKeys, pIncludeStratKeys, _
'      pIncludeThemeSlashThemekeys, _
'      pIncludePlaceKeys, pIncludeTemporalKeys)
'  Debug.Print "Extracting keywords: " & UCase(CStr(booSucceeded))
'  If booSucceeded Then
'    Debug.Print "Combined..."
'    If pCombinedKeyWords.Count > 0 Then
'      For lngIndex = 0 To pCombinedKeyWords.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pCombinedKeyWords.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "Nothing in 'pCombinedKeyWords'..."
'    End If
'    Debug.Print "Theme..."
'    If pIncludeThemeKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeThemeKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeThemeKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeThemeKeys'..."
'    End If
'    Debug.Print "Search..."
'    If pIncludeSearchKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeSearchKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeSearchKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeSearchKeys'..."
'    End If
'    Debug.Print "Desc..."
'    If pIncludeDescKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeDescKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeDescKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeDescKeys'..."
'    End If
'    Debug.Print "Strat..."
'    If pIncludeStratKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeStratKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeStratKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeStratKeys'..."
'    End If
'    Debug.Print "ThemeSlashTheme..."
'    If pIncludeThemeSlashThemekeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeThemeSlashThemekeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeThemeSlashThemekeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeThemeSlashThemekeys'..."
'    End If
'    Debug.Print "Place..."
'    If pIncludePlaceKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludePlaceKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludePlaceKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludePlaceKeys'..."
'    End If
'    Debug.Print "Temporal..."
'    If pIncludeTemporalKeys.Count > 0 Then
'      For lngIndex = 0 To pIncludeTemporalKeys.Count - 1
'        Debug.Print "  --> " & CStr(lngIndex + 1) & "] " & pIncludeTemporalKeys.Element(lngIndex)
'      Next lngIndex
'    Else
'      Debug.Print "-- Nothing in 'pIncludeTemporalKeys'..."
'    End If
'  End If
  
  
  ' THIS WILL ADD KEY WORDS TO VARIOUS STRING ARRAYS IF ANY EXIST
  
2927:   booSucceeded = True
  
  Dim strThemeKeywordsXPath As String
  Dim strSearchKeywordsXPath As String
  Dim strDescKeywordsXPath As String
  Dim strStratKeywordsXPath As String
  Dim strThemeSlashThemekeyKeywordsXPath As String
  Dim strPlaceKeywordsXPath As String
  Dim strTemporalKeywordsXPath As String
  Dim varAtts As Variant
  Dim strValue As String
  
  Dim lngIndex As Long
2940:   Set ReturnExistingMetadataKeyWords = New esriSystem.strArray
  Dim pKeyWordColl As New Collection
  Dim pThemeKeyWordColl As New Collection
  Dim pSearchKeyWordColl As New Collection
  Dim pStratKeyWordColl As New Collection
  Dim pDescKeyWordColl As New Collection
  Dim pThemeSlashThemeKeyWordColl As New Collection
  Dim pPlaceKeyWordColl As New Collection
  Dim pTemporalKeyWordColl As New Collection
  
2950:   If Not pKeyWordsToInsertToArray Is Nothing Then
2951:     If pKeyWordsToInsertToArray.Count > 0 Then
2952:       For lngIndex = 0 To pKeyWordsToInsertToArray.Count - 1
2953:         strValue = pKeyWordsToInsertToArray.Element(lngIndex)
2954:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pKeyWordColl, strValue) Then
2955:           ReturnExistingMetadataKeyWords.Add strValue
2956:           pKeyWordColl.Add True, strValue
2957:         End If
2958:       Next lngIndex
2959:     End If
2960:   End If
    
  Dim pPropSet As IPropertySet
2963:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
    
2965:   strThemeKeywordsXPath = "dataIdInfo/themeKeys/keyword"
2966:   strSearchKeywordsXPath = "dataIdInfo/searchKeys/keyword"
2967:   strStratKeywordsXPath = "dataIdInfo/StratKeys/keyword"
2968:   strDescKeywordsXPath = "dataIdInfo/descKeys/keyword"
2969:   strThemeSlashThemekeyKeywordsXPath = "idinfo/keywords/theme/themekey"
2970:   strPlaceKeywordsXPath = "idinfo/keywords/place/placekey"
2971:   strTemporalKeywordsXPath = "idinfo/keywords/temporal/tempkey"
      
   
'    Debug.Print "Keywords for '" & strFClassName & "'"
2975:   If Not pIncludeStratKeys Is Nothing Then
2976:     varAtts = pPropSet.GetProperty(strStratKeywordsXPath)
2977:     If Not IsEmpty(varAtts) Then
2978:       For lngIndex = 0 To UBound(varAtts)
2979:         strValue = CStr(varAtts(lngIndex))
  '        Debug.Print "  " & CStr(lngIndex) & "] " & strValue
        
2982:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pKeyWordColl, strValue) Then
2983:           ReturnExistingMetadataKeyWords.Add strValue
2984:           pKeyWordColl.Add True, strValue
2985:         End If
2986:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pStratKeyWordColl, strValue) Then
2987:           pIncludeStratKeys.Add strValue
2988:           pStratKeyWordColl.Add True, strValue
2989:         End If
2990:       Next lngIndex
2991:     End If
2992:   End If
  
2994:   If Not pIncludeThemeKeys Is Nothing Then
2995:     varAtts = pPropSet.GetProperty(strThemeKeywordsXPath)
2996:     If Not IsEmpty(varAtts) Then
2997:       For lngIndex = 0 To UBound(varAtts)
2998:         strValue = CStr(varAtts(lngIndex))
  '        Debug.Print "  " & CStr(lngIndex) & "] " & strValue
        
3001:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pKeyWordColl, strValue) Then
3002:           ReturnExistingMetadataKeyWords.Add strValue
3003:           pKeyWordColl.Add True, strValue
3004:         End If
3005:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pThemeKeyWordColl, strValue) Then
3006:           pIncludeThemeKeys.Add strValue
3007:           pThemeKeyWordColl.Add True, strValue
3008:         End If
3009:       Next lngIndex
3010:     End If
3011:   End If
  
3013:   If Not pIncludeSearchKeys Is Nothing Then
3014:     varAtts = pPropSet.GetProperty(strSearchKeywordsXPath)
3015:     If Not IsEmpty(varAtts) Then
3016:       For lngIndex = 0 To UBound(varAtts)
3017:         strValue = CStr(varAtts(lngIndex))
  '        Debug.Print "  " & CStr(lngIndex) & "] " & strValue
        
3020:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pKeyWordColl, strValue) Then
3021:           ReturnExistingMetadataKeyWords.Add strValue
3022:           pKeyWordColl.Add True, strValue
3023:         End If
3024:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pSearchKeyWordColl, strValue) Then
3025:           pIncludeSearchKeys.Add strValue
3026:           pSearchKeyWordColl.Add True, strValue
3027:         End If
3028:       Next lngIndex
3029:     End If
3030:   End If
  
3032:   If Not pIncludeDescKeys Is Nothing Then
3033:     varAtts = pPropSet.GetProperty(strDescKeywordsXPath)
3034:     If Not IsEmpty(varAtts) Then
3035:       For lngIndex = 0 To UBound(varAtts)
3036:         strValue = CStr(varAtts(lngIndex))
  '        Debug.Print "  " & CStr(lngIndex) & "] " & strValue
        
3039:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pKeyWordColl, strValue) Then
3040:           ReturnExistingMetadataKeyWords.Add strValue
3041:           pKeyWordColl.Add True, strValue
3042:         End If
3043:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pSearchKeyWordColl, strValue) Then
3044:           pIncludeDescKeys.Add strValue
3045:           pDescKeyWordColl.Add True, strValue
3046:         End If
3047:       Next lngIndex
3048:     End If
3049:   End If
  
3051:   If Not pIncludeThemeSlashThemekeys Is Nothing Then
3052:     varAtts = pPropSet.GetProperty(strThemeSlashThemekeyKeywordsXPath)
3053:     If Not IsEmpty(varAtts) Then
3054:       For lngIndex = 0 To UBound(varAtts)
3055:         strValue = CStr(varAtts(lngIndex))
  '        Debug.Print "  " & CStr(lngIndex) & "] " & strValue
        
3058:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pKeyWordColl, strValue) Then
3059:           ReturnExistingMetadataKeyWords.Add strValue
3060:           pKeyWordColl.Add True, strValue
3061:         End If
3062:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pThemeSlashThemeKeyWordColl, strValue) Then
3063:           pIncludeThemeSlashThemekeys.Add strValue
3064:           pThemeSlashThemeKeyWordColl.Add True, strValue
3065:         End If
3066:       Next lngIndex
3067:     End If
3068:   End If
  
3070:   If Not pIncludePlaceKeys Is Nothing Then
3071:     varAtts = pPropSet.GetProperty(strPlaceKeywordsXPath)
3072:     If Not IsEmpty(varAtts) Then
3073:       For lngIndex = 0 To UBound(varAtts)
3074:         strValue = CStr(varAtts(lngIndex))
  '        Debug.Print "  " & CStr(lngIndex) & "] " & strValue
        
3077:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pKeyWordColl, strValue) Then
3078:           ReturnExistingMetadataKeyWords.Add strValue
3079:           pKeyWordColl.Add True, strValue
3080:         End If
3081:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pPlaceKeyWordColl, strValue) Then
3082:           pIncludePlaceKeys.Add strValue
3083:           pPlaceKeyWordColl.Add True, strValue
3084:         End If
3085:       Next lngIndex
3086:     End If
3087:   End If
  
3089:   If Not pIncludeTemporalKeys Is Nothing Then
3090:     varAtts = pPropSet.GetProperty(strTemporalKeywordsXPath)
3091:     If Not IsEmpty(varAtts) Then
3092:       For lngIndex = 0 To UBound(varAtts)
3093:         strValue = CStr(varAtts(lngIndex))
  '        Debug.Print "  " & CStr(lngIndex) & "] " & strValue
        
3096:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pKeyWordColl, strValue) Then
3097:           ReturnExistingMetadataKeyWords.Add strValue
3098:           pKeyWordColl.Add True, strValue
3099:         End If
3100:         If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pTemporalKeyWordColl, strValue) Then
3101:           pIncludeTemporalKeys.Add strValue
3102:           pTemporalKeyWordColl.Add True, strValue
3103:         End If
3104:       Next lngIndex
3105:     End If
3106:   End If
    
3108:   GoTo ClearMemory
  Exit Function
  
errHandler:
3112:   booSucceeded = False
  
ClearMemory:
3115:   varAtts = Null
3116:   Set pKeyWordColl = Nothing
3117:   Set pThemeKeyWordColl = Nothing
3118:   Set pSearchKeyWordColl = Nothing
3119:   Set pStratKeyWordColl = Nothing
3120:   Set pDescKeyWordColl = Nothing
3121:   Set pThemeSlashThemeKeyWordColl = Nothing
3122:   Set pPlaceKeyWordColl = Nothing
3123:   Set pTemporalKeyWordColl = Nothing
3124:   Set pPropSet = Nothing
  
End Function

Public Function SetMetadataPurpose(pDataset As IDataset, strPurpose As String) As String ', _
   ' lngReplaceOrAdd As esriXmlSetPropertyAction) As String
  
  On Error GoTo errHandler
    
'  Dim strPurpose As String
'  strPurpose = "Point dataset of points along route with widest bottleneck, with corridor width values at each point."
'  strResponse = Metadata_Functions.SetMetadataPurpose(pDataset, strPurpose)
'  Debug.Print "Saving Purpose: " & strResponse
  
3138:   SetMetadataPurpose = "Succeeded"

  Dim strPurposeXPath As String
3141:   strPurposeXPath = "dataIdInfo/idPurp"
  
  Dim pPropSet As IPropertySet
3144:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  
3146:   pPropSet.SetProperty strPurposeXPath, strPurpose
  
3148:   Metadata_Functions.SaveMetadata pDataset, pPropSet
  
3150:   GoTo ClearMemory
  Exit Function
  
errHandler:
3154:   SetMetadataPurpose = "Failed"

ClearMemory:
3157:   Set pPropSet = Nothing
End Function

Public Function SetMetadataAbstract(pDataset As IDataset, strAbstract As String) As String ', _
   ' lngReplaceOrAdd As esriXmlSetPropertyAction) As String
  
  On Error GoTo errHandler
    
'  Dim strResponse As String
'  Dim strAbstract As String
'  strAbstract = "This dataset represents points along the bottleneck route.  This bottleneck route " & _
'    "describes the path between the two habitat blocks 'aaa' and 'bbb', within the corridor polygon 'ccc'., " & _
'    "which follows the route with the widest narrow point."
'  strResponse = Metadata_Functions.SetMetadataAbstract(pDataset, strAbstract)
'  Debug.Print "Saving Abstract: " & strResponse
  
3173:   SetMetadataAbstract = "Succeeded"

  Dim strAbstractXPath As String
3176:   strAbstractXPath = "idinfo/descript/abstract"
  Dim strDescriptionXPath As String
3178:   strDescriptionXPath = "dataIdInfo/idAbs"
  
  Dim pPropSet As IPropertySet
3181:   Set pPropSet = ReturnMetadataPropSetFromDataset(pDataset)
  
3183:   pPropSet.SetProperty strAbstractXPath, strAbstract
3184:   pPropSet.SetProperty strDescriptionXPath, strAbstract
  
3186:   Metadata_Functions.SaveMetadata pDataset, pPropSet
  
3188:   GoTo ClearMemory
  Exit Function
  
errHandler:
3192:   SetMetadataAbstract = "Failed"

ClearMemory:
3195:   Set pPropSet = Nothing
  
End Function
Public Function ReturnGxDatasetFromDataset(pDataset As IDataset, _
    Optional booFailed As Boolean) As IGxDataset
  
  On Error GoTo errHandler
  
  ' GENERALLY CALLED BY OTHER FUNCTIONS
  
3205:   booFailed = False
  
  Dim pName As IName
3208:   Set pName = pDataset.FullName
'  Debug.Print pName.NameString
  
  Dim pGxDataset As IGxDataset
3212:   Set pGxDataset = New GxDataset
3213:   Set pGxDataset.DatasetName = pName
  
3215:   Set ReturnGxDatasetFromDataset = pGxDataset
      
3217:   GoTo ClearMemory
  Exit Function
  
errHandler:
3221:   Set ReturnGxDatasetFromDataset = Nothing
3222:   booFailed = True
  
ClearMemory:
3225:   Set pName = Nothing
3226:   Set pGxDataset = Nothing
  
End Function

Public Function ReturnMetadataPropSetFromDataset(pDataset As IDataset, _
    Optional booFailed As Boolean) As IPropertySet
    
  On Error GoTo errHandler
  
  ' GENERALLY CALLED BY OTHER FUNCTIONS
  
  Dim pGxDataset As IGxDataset
3238:   Set pGxDataset = ReturnGxDatasetFromDataset(pDataset)
'  Debug.Print "Browse name = " & pGxDataset.Dataset.BrowseName
    
  Dim pMetaData As IMetadata
3242:   Set pMetaData = pGxDataset
  
'  Debug.Print pMetaData Is Nothing
  
  Dim pMetadataEdit As IMetadataEdit
3247:   Set pMetadataEdit = pGxDataset
'  Debug.Print "Can Edit = " & pMetadataEdit.CanEditMetadata
  
  Dim pPropSet As IPropertySet
3251:   Set pPropSet = pMetaData.Metadata
  
'  Debug.Print "Property Count = " & CStr(pPropSet.Count)
  Dim pXMLPropSet As IXmlPropertySet2
3255:   Set pXMLPropSet = pMetaData.Metadata
3256:   Set pPropSet = pXMLPropSet
'  Debug.Print "Property Set is New = " & CStr(pXMLPropSet.IsNew)
  
  Dim pXMLPropSet2 As IXmlPropertySet2
3260:   If pMetadataEdit.CanEditMetadata Then
3261:     If pXMLPropSet.IsNew Then
3262:       Set pXMLPropSet2 = pXMLPropSet
3263:       pXMLPropSet2.InitExisting
3264:       pMetaData.Metadata = pPropSet
3265:     End If
3266:   End If
  
3268:   Set ReturnMetadataPropSetFromDataset = pPropSet
'  Debug.Print "Re-Check Property Set is New = " & CStr(pXMLPropSet.IsNew)
        
3271:   GoTo ClearMemory
  Exit Function
  
errHandler:
3275:   Set ReturnMetadataPropSetFromDataset = Nothing
3276:   booFailed = True
  
ClearMemory:
3279:   Set pGxDataset = Nothing
3280:   Set pMetaData = Nothing
3281:   Set pMetadataEdit = Nothing
3282:   Set pPropSet = Nothing
3283:   Set pXMLPropSet = Nothing
3284:   Set pXMLPropSet2 = Nothing
  
End Function

Public Function SynchronizeMetadataPropSet(pDataset As IDataset) As String
    
  On Error GoTo errHandler
  
'  SYNCHRONIZE Metadata
'  strResponse = Metadata_Functions.SynchronizeMetadataPropSet(pDataset)
'  Debug.Print "ReSynchronization: " & strResponse
'
  ' SHOULD UPDATE ANY NEW CHANGES TO THE METADATA, LIKE ADDING NEW FIELDS
  
3298:   SynchronizeMetadataPropSet = "Succeeded"
  
  Dim pGxDataset As IGxDataset
3301:   Set pGxDataset = ReturnGxDatasetFromDataset(pDataset)
'  Debug.Print "Browse name = " & pGxDataset.Dataset.BrowseName
    
  Dim pMetaData As IMetadata
3305:   Set pMetaData = pGxDataset
  
'  Debug.Print pMetaData Is Nothing
  
  Dim pMetadataEdit As IMetadataEdit
3310:   Set pMetadataEdit = pGxDataset
'  Debug.Print "Can Edit = " & pMetadataEdit.CanEditMetadata
  
3313:   If pMetadataEdit.CanEditMetadata Then
3314:     pMetaData.SYNCHRONIZE esriMSAAccessed, 0
3315:   Else
3316:     SynchronizeMetadataPropSet = "Unable to synchronize; Metadata not editable..."
3317:   End If
          
3319:   GoTo ClearMemory
  Exit Function
  
errHandler:
3323:   SynchronizeMetadataPropSet = "Failed"
  
ClearMemory:
3326:   Set pGxDataset = Nothing
3327:   Set pMetaData = Nothing
3328:   Set pMetadataEdit = Nothing
  
End Function

Public Sub SaveMetadata(pDataset As IDataset, pPropSet As IPropertySet, _
    Optional booFailed As Boolean)
  On Error GoTo errHandler
  
  ' GENERALLY CALLED FROM OTHER FUNCTIONS
3337:   booFailed = False
  Dim pGxDataset As IGxDataset
3339:   Set pGxDataset = ReturnGxDatasetFromDataset(pDataset)
'  Debug.Print "Browse name = " & pGxDataset.Dataset.BrowseName
    
  Dim pMetaData As IMetadata
3343:   Set pMetaData = pGxDataset
  
  Dim pMetadataEdit As IMetadataEdit
3346:   Set pMetadataEdit = pMetaData
  
3348:   If pMetadataEdit.CanEditMetadata Then
3349:     pMetaData.Metadata = pPropSet
3350:   End If
  
3352:   GoTo ClearMemory
  Exit Sub
  
errHandler:
3356:   booFailed = True
  
ClearMemory:
3359:   Set pGxDataset = Nothing
3360:   Set pMetaData = Nothing
3361:   Set pMetadataEdit = Nothing
  
End Sub


Private Function ReturnAddressType(enumJenAddressType As JenMetadataAddressTypeValues) As String
  
  On Error GoTo errHandler
  ' GENERALLY CALLED BY OTHER FUNCTIONS
  
  Select Case enumJenAddressType
    Case JenMetadata_Postal
3373:       ReturnAddressType = "postal"
    Case JenMetadata_Physical
3375:       ReturnAddressType = "physical"
    Case JenMetadata_Both
3377:       ReturnAddressType = "both"
    Case Else
3379:       ReturnAddressType = "skip"
3380:   End Select
  
  Exit Function
  
errHandler:
3385:   ReturnAddressType = ""
  
End Function

Private Function ReturnMaintenanceCode(enumJenMaintenanceCode As JenMetadataMaintenanceCodes) As String
  
  On Error GoTo errHandler
  ' GENERALLY CALLED BY OTHER FUNCTIONS
      
  Select Case enumJenMaintenanceCode
    Case JenMetadata_Maint_Continual
3396:       ReturnMaintenanceCode = "001"
    Case JenMetadata_Maint_Daily
3398:       ReturnMaintenanceCode = "002"
    Case JenMetadata_Maint_Weekly
3400:       ReturnMaintenanceCode = "003"
    Case JenMetadata_Maint_Fortnightly
3402:       ReturnMaintenanceCode = "004"
    Case JenMetadata_Maint_Monthly
3404:       ReturnMaintenanceCode = "005"
    Case JenMetadata_Maint_Quarterly
3406:       ReturnMaintenanceCode = "006"
    Case JenMetadata_Maint_BiAnnually
3408:       ReturnMaintenanceCode = "007"
    Case JenMetadata_Maint_Annually
3410:       ReturnMaintenanceCode = "008"
    Case JenMetadata_Maint_AsNeeded
3412:       ReturnMaintenanceCode = "009"
    Case JenMetadata_Maint_Irregular
3414:       ReturnMaintenanceCode = "010"
    Case JenMetadata_Maint_NotPlanned
3416:       ReturnMaintenanceCode = "011"
    Case JenMetadata_Maint_Unknown
3418:       ReturnMaintenanceCode = "012"
    Case JenMetadata_Maint_SemiMonthly
3420:       ReturnMaintenanceCode = "013"
3421:   End Select
    
  Exit Function
  
errHandler:
3426:   ReturnMaintenanceCode = ""
  
End Function


Private Function ReturnStatusString(enumJenStatus As JenMetadataStatusValues) As String

  On Error GoTo errHandler
  ' GENERALLY CALLED BY OTHER FUNCTIONS
  Select Case enumJenStatus
    Case JenMetadata_Completed
3437:       ReturnStatusString = "001"
    Case JenMetadata_HistoricalArchive
3439:       ReturnStatusString = "002"
    Case JenMetadata_Obsolete
3441:       ReturnStatusString = "003"
    Case JenMetadata_Ongoing
3443:       ReturnStatusString = "004"
    Case JenMetadata_Planned
3445:       ReturnStatusString = "005"
    Case JenMetadata_Required
3447:       ReturnStatusString = "006"
    Case JenMetadata_UnderDevelopment
3449:       ReturnStatusString = "007"
    Case JenMetadata_Proposed
3451:       ReturnStatusString = "008"
3452:   End Select
  
  Exit Function
  
errHandler:
3457:   ReturnStatusString = ""
End Function

Private Function ReturnRoleCDString(enumJenRole As JenMetadataRoleCDValues) As String
  On Error GoTo errHandler
  ' GENERALLY CALLED BY OTHER FUNCTIONS
  
  Select Case enumJenRole
    Case JenMetadata_ResourceProvider
3466:       ReturnRoleCDString = "001"
    Case JenMetadata_Custodian
3468:       ReturnRoleCDString = "002"
    Case JenMetadata_Owner
3470:       ReturnRoleCDString = "003"
    Case JenMetadata_User
3472:       ReturnRoleCDString = "004"
    Case JenMetadata_Distributor
3474:       ReturnRoleCDString = "005"
    Case JenMetadata_Originator
3476:       ReturnRoleCDString = "006"
    Case JenMetadata_PointOfContact
3478:       ReturnRoleCDString = "007"
    Case JenMetadata_PrincipalInvestigator
3480:       ReturnRoleCDString = "008"
    Case JenMetadata_Processor
3482:       ReturnRoleCDString = "009"
    Case JenMetadata_Publisher
3484:       ReturnRoleCDString = "010"
    Case JenMetadata_Author
3486:       ReturnRoleCDString = "011"
    Case JenMetadata_Collaborator
3488:       ReturnRoleCDString = "012"
    Case JenMetadata_Editor
3490:       ReturnRoleCDString = "013"
    Case JenMetadata_Mediator
3492:       ReturnRoleCDString = "014"
    Case JenMetadata_RightsHolder
3494:       ReturnRoleCDString = "015"
    Case Else
3496:       ReturnRoleCDString = ""
3497:   End Select
  
  Exit Function
  
errHandler:
3502:   ReturnRoleCDString = ""
End Function


Public Sub SampleCode()
'  BELOW COPIED FROM D:\arcGIS_stuff\consultation\NAU_GCNP\Data\Transportation\Transportation_2_nov_24.mxd

Dim strBaseString As String
3510:   strBaseString = strBaseString & " " & vbNewLine
3511:   strBaseString = strBaseString & "' BELOW COPIED FROM D:\arcGIS_stuff\consultation\NAU_GCNP\Data\Transportation\Transportation_2_nov_24.mxd" & vbNewLine
3512:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "Public Sub ReplaceOrAddGeneralMetadataElements(pPropSet As IPropertySet, _" & vbNewLine
3514:   strBaseString = strBaseString & "    pFClassArray As esriSystem.IArray)" & vbNewLine
3515:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim pRoads_KNF_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pTIGER_2012_Trans_Near_Park_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pBLM_AZStrip_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pRoads_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pTrails_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pRoutes_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pUtah_Roads_Near_AOI_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pTrails_KNF_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pTransportationLine_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
3525:   strBaseString = strBaseString & "   " & vbNewLine
3526:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim pRoads_KNF_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pBLM_AZStrip_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pRoads_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pTrails_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pRoutes_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pTrails_KNF_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pTransportationLine_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
3536:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim pXMLPropSet As IXmlPropertySet" & vbNewLine
3538:   strBaseString = strBaseString & "  Set pXMLPropSet = pPropSet" & vbNewLine
  strBaseString = strBaseString & "  Dim pSubArray As esriSystem.IArray" & vbNewLine
3540:   strBaseString = strBaseString & " " & vbNewLine
3541:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(0)" & vbNewLine
3542:   strBaseString = strBaseString & "  Set pRoads_KNF_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
3543:   strBaseString = strBaseString & "  Set pRoads_KNF_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
3544:   strBaseString = strBaseString & " " & vbNewLine
3545:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(1)" & vbNewLine
3546:   strBaseString = strBaseString & "  Set pTIGER_2012_Trans_Near_Park_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
3547:   strBaseString = strBaseString & "  Set pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
3548:   strBaseString = strBaseString & " " & vbNewLine
3549:   strBaseString = strBaseString & "   " & vbNewLine
3550:   strBaseString = strBaseString & " " & vbNewLine
3551:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(2)" & vbNewLine
3552:   strBaseString = strBaseString & "  Set pBLM_AZStrip_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
3553:   strBaseString = strBaseString & "  Set pBLM_AZStrip_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
3554:   strBaseString = strBaseString & " " & vbNewLine
3555:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(3)" & vbNewLine
3556:   strBaseString = strBaseString & "  Set pRoads_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
3557:   strBaseString = strBaseString & "  Set pRoads_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
3558:   strBaseString = strBaseString & " " & vbNewLine
3559:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(4)" & vbNewLine
3560:   strBaseString = strBaseString & "  Set pTrails_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
3561:   strBaseString = strBaseString & "  Set pTrails_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
3562:   strBaseString = strBaseString & " " & vbNewLine
3563:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(5)" & vbNewLine
3564:   strBaseString = strBaseString & "  Set pRoutes_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
3565:   strBaseString = strBaseString & "  Set pRoutes_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
3566:   strBaseString = strBaseString & " " & vbNewLine
3567:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(6)" & vbNewLine
3568:   strBaseString = strBaseString & "  Set pUtah_Roads_Near_AOI_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
3569:   strBaseString = strBaseString & "  Set pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
3570:   strBaseString = strBaseString & "   " & vbNewLine
3571:   strBaseString = strBaseString & " " & vbNewLine
3572:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(7)" & vbNewLine
3573:   strBaseString = strBaseString & "  Set pTrails_KNF_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
3574:   strBaseString = strBaseString & "  Set pTrails_KNF_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
3575:   strBaseString = strBaseString & " " & vbNewLine
3576:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(8)" & vbNewLine
3577:   strBaseString = strBaseString & "  Set pTransportationLine_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
3578:   strBaseString = strBaseString & "  Set pTransportationLine_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
3579:   strBaseString = strBaseString & " " & vbNewLine
3580:   strBaseString = strBaseString & "  ' PUT TRANSPORTATION LINE FIRST FOR THIS FUNCTION" & vbNewLine
  strBaseString = strBaseString & "  Dim lngIndex As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim pNewFClassArray As esriSystem.IArray" & vbNewLine
3583:   strBaseString = strBaseString & "  Set pNewFClassArray = New esriSystem.Array" & vbNewLine
3584:   strBaseString = strBaseString & "  pNewFClassArray.Add pFClassArray.Element(8)" & vbNewLine
3585:   strBaseString = strBaseString & "  For lngIndex = 0 To 7" & vbNewLine
3586:   strBaseString = strBaseString & "    pNewFClassArray.Add pFClassArray.Element(lngIndex)" & vbNewLine
3587:   strBaseString = strBaseString & "  Next lngIndex" & vbNewLine
3588:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strAbstract As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strSummaryString As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strDescriptionString  As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strCreditString As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strUseLimitationsString As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strUseLimitationsString2 As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strThemeKeywords As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strSearchKeywords As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strSupplementalInformation As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strResponsiblePartyName As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strOtherConstraints As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strValue As String" & vbNewLine
  strBaseString = strBaseString & "  Dim varAtts As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim lngIndex2 As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim pContributorPropSet As IPropertySet" & vbNewLine
3604:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim lngPropSetIndex As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim strFClassNames(8) As String" & vbNewLine
3607:   strBaseString = strBaseString & "  strFClassNames(0) = ""TransportationLine_UTM12_NAD83""" & vbNewLine
3608:   strBaseString = strBaseString & "  strFClassNames(1) = ""KNF_UTM12_NAD83""" & vbNewLine
3609:   strBaseString = strBaseString & "  strFClassNames(2) = ""TIGER_2012_Trans_Near_Park_UTM12_NAD83""" & vbNewLine
3610:   strBaseString = strBaseString & "  strFClassNames(3) = ""BLM_AZStrip_UTM12_NAD83""" & vbNewLine
3611:   strBaseString = strBaseString & "  strFClassNames(4) = ""Roads_UTM12_NAD83""" & vbNewLine
3612:   strBaseString = strBaseString & "  strFClassNames(5) = ""Trails_UTM12_NAD83""" & vbNewLine
3613:   strBaseString = strBaseString & "  strFClassNames(6) = ""Routes_UTM12_NAD83""" & vbNewLine
3614:   strBaseString = strBaseString & "  strFClassNames(7) = ""Utah_Roads_Near_AOI_UTM12_NAD83""" & vbNewLine
3615:   strBaseString = strBaseString & "  strFClassNames(8) = ""Trails_KNF_UTM12_NAD83""" & vbNewLine
3616:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strFClassName As String" & vbNewLine
3618:   strBaseString = strBaseString & " " & vbNewLine
3619:   strBaseString = strBaseString & "   " & vbNewLine
3620:   strBaseString = strBaseString & "  strAbstract = ""idinfo/descript/abstract""" & vbNewLine
3621:   strBaseString = strBaseString & "  strSummaryString = ""dataIdInfo/idPurp""" & vbNewLine
3622:   strBaseString = strBaseString & "  strDescriptionString = ""dataIdInfo/idAbs""" & vbNewLine
3623:   strBaseString = strBaseString & "  strCreditString = ""dataIdInfo/idCredit""" & vbNewLine
3624:   strBaseString = strBaseString & "  strUseLimitationsString = ""dataIdInfo/resConst/Consts/useLimit""" & vbNewLine
3625:   strBaseString = strBaseString & "  strUseLimitationsString2 = ""idinfo/useconst""" & vbNewLine
3626:   strBaseString = strBaseString & "  strThemeKeywords = ""dataIdInfo/themeKeys/keyword""" & vbNewLine
3627:   strBaseString = strBaseString & "  strSearchKeywords = ""dataIdInfo/searchKeys/keyword""" & vbNewLine
3628:   strBaseString = strBaseString & "  strSupplementalInformation = ""dataIdInfo/suppInfo""" & vbNewLine
3629:   strBaseString = strBaseString & "  strResponsiblePartyName = ""dataIdInfo/idCitation/citRespParty/rpOrgName""" & vbNewLine
3630:   strBaseString = strBaseString & "  strOtherConstraints = ""dataIdInfo/resConst/LegConsts/othConsts""" & vbNewLine
3631:   strBaseString = strBaseString & " " & vbNewLine
3632:   strBaseString = strBaseString & "'  Data Quality?  in dqInfo/report/measDesc" & vbNewLine
3633:   strBaseString = strBaseString & " " & vbNewLine
3634:   strBaseString = strBaseString & " " & vbNewLine
3635:   strBaseString = strBaseString & "   " & vbNewLine
3636:   strBaseString = strBaseString & " " & vbNewLine
3637:   strBaseString = strBaseString & "  ' --------------------------------------------------------------------------------" & vbNewLine
3638:   strBaseString = strBaseString & "  ' <><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>" & vbNewLine
3639:   strBaseString = strBaseString & "  ' --------------------------------------------------------------------------------" & vbNewLine
3640:   strBaseString = strBaseString & " " & vbNewLine
3641:   strBaseString = strBaseString & "  ' ---------------------------------------------------------------------------------------------" & vbNewLine
3642:   strBaseString = strBaseString & "  '  478] mdContact/rpIndName  '    --> Mark Nebel" & vbNewLine
3643:   strBaseString = strBaseString & "  '  479] mdContact/rpOrgName  '    --> Grand Canyon National Park" & vbNewLine
3644:   strBaseString = strBaseString & "  '  480] mdContact/rpPosName  '    --> GIS Coordinator" & vbNewLine
3645:   strBaseString = strBaseString & "  '  481] mdContact/rpCntInfo/cntPhone/voiceNum  '    --> 928-638-7451" & vbNewLine
3646:   strBaseString = strBaseString & "  '  482] mdContact/rpCntInfo/cntAddress/delPoint  '    --> 1824 S. Thompson St" & vbNewLine
3647:   strBaseString = strBaseString & "  '  483] mdContact/rpCntInfo/cntAddress/delPoint  '    --> Suite 200" & vbNewLine
3648:   strBaseString = strBaseString & "  '  484] mdContact/rpCntInfo/cntAddress/city  '    --> Flagstaff" & vbNewLine
3649:   strBaseString = strBaseString & "  '  485] mdContact/rpCntInfo/cntAddress/adminArea  '    --> AZ" & vbNewLine
3650:   strBaseString = strBaseString & "  '  486] mdContact/rpCntInfo/cntAddress/postCode  '    --> 86001" & vbNewLine
3651:   strBaseString = strBaseString & "  '  487] mdContact/rpCntInfo/cntAddress/country  '    --> UAS" & vbNewLine
3652:   strBaseString = strBaseString & "  '  488] mdContact/rpCntInfo/cntAddress/eMailAdd  '    --> mark_nebel@nps.gov" & vbNewLine
3653:   strBaseString = strBaseString & "  '  489] mdContact/role/RoleCd  '    -->" & vbNewLine
3654:   strBaseString = strBaseString & "  '" & vbNewLine
3655:   strBaseString = strBaseString & "  '  Jill M. Rundall" & vbNewLine
3656:   strBaseString = strBaseString & "  '  Operations manager/Spatial analyst" & vbNewLine
3657:   strBaseString = strBaseString & "  '  Lab of Landscape Ecology and Conservation Biology" & vbNewLine
3658:   strBaseString = strBaseString & "  '  Ph: 928-523-4730" & vbNewLine
3659:   strBaseString = strBaseString & "  '  Fax: 928-523-7078" & vbNewLine
3660:   strBaseString = strBaseString & "  'E:   Jill.Rundall@ nau.edu" & vbNewLine
3661:   strBaseString = strBaseString & "  '" & vbNewLine
3662:   strBaseString = strBaseString & "  '  School of Earth Sciences and Environmental Sustainability" & vbNewLine
3663:   strBaseString = strBaseString & "  '  College of Engineering, Forestry and Natural Sciences" & vbNewLine
3664:   strBaseString = strBaseString & "  '  Northern Arizona University, Flagstaff, AZ 86011" & vbNewLine
3665:   strBaseString = strBaseString & " " & vbNewLine
3666:   strBaseString = strBaseString & "   " & vbNewLine
3667:   strBaseString = strBaseString & "'  ' PRIMARY CONTACT INFORMATION" & vbNewLine
3668:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""placeholder"")" & vbNewLine
3669:   strBaseString = strBaseString & "'  Debug.Print ""placeholder:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3670:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpIndName"")" & vbNewLine
3671:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpIndName:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3672:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpOrgName"")" & vbNewLine
3673:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpOrgName:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3674:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpPosName"")" & vbNewLine
3675:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpPosName:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3676:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpCntInfo/cntPhone/voiceNum"")" & vbNewLine
3677:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpCntInfo/cntPhone/voiceNum:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3678:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpCntInfo/cntAddress/delPoint"")" & vbNewLine
3679:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpCntInfo/cntAddress/delPoint:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3680:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpCntInfo/cntAddress/delPoint"")" & vbNewLine
3681:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpCntInfo/cntAddress/delPoint:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3682:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpCntInfo/cntAddress/city"")" & vbNewLine
3683:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpCntInfo/cntAddress/city:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3684:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpCntInfo/cntAddress/adminArea"")" & vbNewLine
3685:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpCntInfo/cntAddress/adminArea:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3686:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpCntInfo/cntAddress/postCode"")" & vbNewLine
3687:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpCntInfo/cntAddress/postCode:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3688:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpCntInfo/cntAddress/country"")" & vbNewLine
3689:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpCntInfo/cntAddress/country:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3690:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/rpCntInfo/cntAddress/eMailAdd"")" & vbNewLine
3691:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/rpCntInfo/cntAddress/eMailAdd:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3692:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""mdContact/role/RoleCd"")" & vbNewLine
3693:   strBaseString = strBaseString & "'  Debug.Print ""mdContact/role/RoleCd:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3694:   strBaseString = strBaseString & " " & vbNewLine
3695:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpIndName""" & vbNewLine
3696:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpOrgName""" & vbNewLine
3697:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpPosName""" & vbNewLine
3698:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntPhone/voiceNum""" & vbNewLine
3699:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/delPoint""" & vbNewLine
3700:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/city""" & vbNewLine
3701:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/adminArea""" & vbNewLine
3702:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/postCode""" & vbNewLine
3703:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/country""" & vbNewLine
3704:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/eMailAdd""" & vbNewLine
3705:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/role/RoleCd""" & vbNewLine
3706:   strBaseString = strBaseString & "'" & vbNewLine
3707:   strBaseString = strBaseString & "'" & vbNewLine
3708:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpIndName"", ""Jill M. Rundall""" & vbNewLine
3709:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpOrgName[0]"", ""Lab of Landscape Ecology and Conservation Biology""" & vbNewLine
3710:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpOrgName[1]"", ""School of Earth Sciences and Environmental Sustainability""" & vbNewLine
3711:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpOrgName[2]"", ""College of Engineering, Forestry and Natural Sciences""" & vbNewLine
3712:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpOrgName[3]"", ""Northern Arizona University""" & vbNewLine
3713:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpPosName"", ""Operations manager/Spatial analyst""" & vbNewLine
3714:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpCntInfo/cntPhone/voiceNum"", ""928-523-4730""" & vbNewLine
3715:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpCntInfo/cntAddress/delPoint[0]"", ""602 S Humphreys""" & vbNewLine
3716:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpCntInfo/cntAddress/delPoint[1]"", ""PO Box: 5694""" & vbNewLine
3717:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpCntInfo/cntAddress/city"", ""Flagstaff""" & vbNewLine
3718:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpCntInfo/cntAddress/adminArea"", ""AZ""" & vbNewLine
3719:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpCntInfo/cntAddress/postCode"", ""86011""" & vbNewLine
3720:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpCntInfo/cntAddress/country"", ""USA""" & vbNewLine
3721:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/rpCntInfo/cntAddress/eMailAdd"", ""Jill.Rundall@nau.edu""" & vbNewLine
3722:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/role/RoleCd"", """"" & vbNewLine
3723:   strBaseString = strBaseString & " " & vbNewLine
3724:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""distInfo/distFormat/formatVer""" & vbNewLine
3725:   strBaseString = strBaseString & "  pPropSet.SetProperty ""distInfo/distFormat/formatVer"", 10.1" & vbNewLine
3726:   strBaseString = strBaseString & " " & vbNewLine
3727:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idCitation/citRespParty/rpOrgName"")" & vbNewLine
3728:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idCitation/citRespParty/rpOrgName:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3729:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idCitation/citRespParty/role/RoleCd"")" & vbNewLine
3730:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idCitation/citRespParty/role/RoleCd:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3731:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idCitation/presForm/PresFormCd"")" & vbNewLine
3732:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idCitation/presForm/PresFormCd:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3733:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idCitation/resTitle"")" & vbNewLine
3734:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idCitation/resTitle:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3735:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idStatus/ProgCd"")" & vbNewLine
3736:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idStatus/ProgCd:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3737:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/rpIndName"")" & vbNewLine
3738:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/rpIndName:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3739:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/rpOrgName"")" & vbNewLine
3740:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/rpOrgName:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3741:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/rpPosName"")" & vbNewLine
3742:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/rpPosName:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3743:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/rpCntInfo/cntPhone/voiceNum"")" & vbNewLine
3744:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/rpCntInfo/cntPhone/voiceNum:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3745:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/rpCntInfo/cntAddress/delPoint"")" & vbNewLine
3746:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/rpCntInfo/cntAddress/delPoint:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3747:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/rpCntInfo/cntAddress/city"")" & vbNewLine
3748:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/rpCntInfo/cntAddress/city:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3749:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/rpCntInfo/cntAddress/adminArea"")" & vbNewLine
3750:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/rpCntInfo/cntAddress/adminArea:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3751:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/rpCntInfo/cntAddress/postCode"")" & vbNewLine
3752:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/rpCntInfo/cntAddress/postCode:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3753:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/rpCntInfo/cntAddress/country"")" & vbNewLine
3754:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/rpCntInfo/cntAddress/country:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3755:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/rpCntInfo/cntAddress/eMailAdd"")" & vbNewLine
3756:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/rpCntInfo/cntAddress/eMailAdd:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3757:   strBaseString = strBaseString & "'  varAtts = pPropSet.GetProperty(""dataIdInfo/idPoC/role/RoleCd"")" & vbNewLine
3758:   strBaseString = strBaseString & "'  Debug.Print ""dataIdInfo/idPoC/role/RoleCd:  Count = "" & CStr(UBound(varAtts) + 1)" & vbNewLine
3759:   strBaseString = strBaseString & " " & vbNewLine
3760:   strBaseString = strBaseString & "  ' LINEAGE =================================================================" & vbNewLine
  strBaseString = strBaseString & "  Dim strCompiledData As String" & vbNewLine
3762:   strBaseString = strBaseString & "  strCompiledData = ""Compiled transportation features and attributes "" & _" & vbNewLine
3763:   strBaseString = strBaseString & "    ""from multiple feature classes (""""TransportationLine_UTM12_NAD83"""", """"Roads_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
3764:   strBaseString = strBaseString & "    """"""BLM_AZStrip_UTM12_NAD83"""", """"Roads_UTM12_NAD83"""", """"UTAH_Roads_Near_AOI_UTM12_NAD83"""", "" & _" & vbNewLine
3765:   strBaseString = strBaseString & "    """"""Routes_UTM12_NAD83"""", """"Trails_UTM12_NAD83"""", """"TIGER_2012_Trans_Near_Park_UTM12_NAD83"""" "" & _" & vbNewLine
3766:   strBaseString = strBaseString & "    ""and """"UTAH_Roads_Near_AOI_UTM12_NAD83"""") into a single comprehensive transportation dataset "" & _" & vbNewLine
3767:   strBaseString = strBaseString & "    ""covering the Grand Canyon region.  Also identified the 4 closest features from each of these "" & _" & vbNewLine
3768:   strBaseString = strBaseString & "    ""feature classes to each compiled feature, and used these 4 closest features to estimate "" & _" & vbNewLine
3769:   strBaseString = strBaseString & "    ""the name, type, surface type and use level of each feature.""" & vbNewLine
3770:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strCompiledMetadata As String" & vbNewLine
3772:   strBaseString = strBaseString & "  strCompiledMetadata = ""Developed metadata that describes this compiled transportation feature class, "" & _" & vbNewLine
3773:   strBaseString = strBaseString & "    ""including imported metadata from the various contributor feature classes "" & _" & vbNewLine
3774:   strBaseString = strBaseString & "    ""(""""TransportationLine_UTM12_NAD83"""", """"Roads_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
3775:   strBaseString = strBaseString & "    """"""BLM_AZStrip_UTM12_NAD83"""", """"Roads_UTM12_NAD83"""", """"UTAH_Roads_Near_AOI_UTM12_NAD83"""", "" & _" & vbNewLine
3776:   strBaseString = strBaseString & "    """"""Routes_UTM12_NAD83"""", """"Trails_UTM12_NAD83"""", """"TIGER_2012_Trans_Near_Park_UTM12_NAD83"""" "" & _" & vbNewLine
3777:   strBaseString = strBaseString & "    ""and """"UTAH_Roads_Near_AOI_UTM12_NAD83"""")""" & vbNewLine
3778:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim varVals As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim varPerson As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim varDesc As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim strStepDesc As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strStepPerson As String" & vbNewLine
  strBaseString = strBaseString & "  Dim lngLineageCounter As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim lngCompiledDataIndex As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim lngCompiledMetadataIndex As Long" & vbNewLine
3787:   strBaseString = strBaseString & " " & vbNewLine
3788:   strBaseString = strBaseString & "  lngCompiledDataIndex = -999" & vbNewLine
3789:   strBaseString = strBaseString & "  lngCompiledMetadataIndex = -999" & vbNewLine
3790:   strBaseString = strBaseString & " " & vbNewLine
3791:   strBaseString = strBaseString & "  varVals = Array(""placeholder"")" & vbNewLine
3792:   strBaseString = strBaseString & "   " & vbNewLine
3793:   strBaseString = strBaseString & " " & vbNewLine
3794:   strBaseString = strBaseString & "  lngLineageCounter = -1" & vbNewLine
3795:   strBaseString = strBaseString & "  Do Until IsEmpty(varVals)" & vbNewLine
3796:   strBaseString = strBaseString & "    lngLineageCounter = lngLineageCounter + 1" & vbNewLine
3797:   strBaseString = strBaseString & "    varVals = pPropSet.GetProperty(""dqInfo/dataLineage/prcStep["" & CStr(lngLineageCounter) & ""]"")" & vbNewLine
3798:   strBaseString = strBaseString & " " & vbNewLine
3799:   strBaseString = strBaseString & "    If Not IsEmpty(varVals) Then" & vbNewLine
3800:   strBaseString = strBaseString & "      varPerson = pPropSet.GetProperty(""dqInfo/dataLineage/prcStep["" & CStr(lngLineageCounter) & ""]/stepProc/rpIndName"")" & vbNewLine
3801:   strBaseString = strBaseString & "      strStepPerson = CStr(varPerson(0))" & vbNewLine
3802:   strBaseString = strBaseString & "      varDesc = pPropSet.GetProperty(""dqInfo/dataLineage/prcStep["" & CStr(lngLineageCounter) & ""]/stepDesc"")" & vbNewLine
3803:   strBaseString = strBaseString & "      strStepDesc = CStr(varDesc(0))" & vbNewLine
3804:   strBaseString = strBaseString & " " & vbNewLine
3805:   strBaseString = strBaseString & "      If InStr(1, strStepPerson, ""Jenness"", vbTextCompare) > 0 And _" & vbNewLine
3806:   strBaseString = strBaseString & "         InStr(1, strStepDesc, "" Also identified the 4 closest features "", vbTextCompare) > 0 Then" & vbNewLine
3807:   strBaseString = strBaseString & "            lngCompiledDataIndex = lngLineageCounter" & vbNewLine
3808:   strBaseString = strBaseString & "      End If" & vbNewLine
3809:   strBaseString = strBaseString & "      If InStr(1, strStepPerson, ""Jenness"", vbTextCompare) > 0 And _" & vbNewLine
3810:   strBaseString = strBaseString & "         InStr(1, strStepDesc, ""from the various contributor feature classes"", vbTextCompare) > 0 Then" & vbNewLine
3811:   strBaseString = strBaseString & "            lngCompiledMetadataIndex = lngLineageCounter" & vbNewLine
3812:   strBaseString = strBaseString & "      End If" & vbNewLine
3813:   strBaseString = strBaseString & "    End If" & vbNewLine
3814:   strBaseString = strBaseString & " " & vbNewLine
3815:   strBaseString = strBaseString & "'    pXMLPropSet.GetAttribute ""dqInfo/dataLineage/prcStep["" & CStr(lngIndex) & _" & vbNewLine
3816:   strBaseString = strBaseString & "'        ""]/stepProc/role/RoleCd"", ""value"", varAtts" & vbNewLine
3817:   strBaseString = strBaseString & "'    Debug.Print lngIndex & ""] "" & varVals2(0) & "":  Value = "" & CStr(varAtts(0)) & _" & vbNewLine
3818:   strBaseString = strBaseString & "'        "" [n = "" & CStr(UBound(varAtts)) & ""]""" & vbNewLine
3819:   strBaseString = strBaseString & "'    lngIndex = lngIndex + 1" & vbNewLine
3820:   strBaseString = strBaseString & "'    varVals = pPropSet.GetProperty(""dqInfo/dataLineage/prcStep["" & CStr(lngLineageCounter) & ""]"")" & vbNewLine
3821:   strBaseString = strBaseString & "  Loop" & vbNewLine
3822:   strBaseString = strBaseString & " " & vbNewLine
3823:   strBaseString = strBaseString & "  If lngCompiledDataIndex = -999 And lngCompiledMetadataIndex = -999 Then" & vbNewLine
3824:   strBaseString = strBaseString & "    lngCompiledDataIndex = lngLineageCounter" & vbNewLine
3825:   strBaseString = strBaseString & "    lngCompiledMetadataIndex = lngLineageCounter + 1" & vbNewLine
3826:   strBaseString = strBaseString & "  ElseIf lngCompiledDataIndex = -999 Then" & vbNewLine
3827:   strBaseString = strBaseString & "    lngCompiledDataIndex = lngLineageCounter" & vbNewLine
3828:   strBaseString = strBaseString & "  ElseIf lngCompiledMetadataIndex = -999 Then" & vbNewLine
3829:   strBaseString = strBaseString & "    lngCompiledMetadataIndex = lngLineageCounter" & vbNewLine
3830:   strBaseString = strBaseString & "  End If" & vbNewLine
3831:   strBaseString = strBaseString & " " & vbNewLine
3832:   strBaseString = strBaseString & "  Debug.Print ""Data Index = "" & CStr(lngCompiledDataIndex)" & vbNewLine
3833:   strBaseString = strBaseString & "  Debug.Print ""MetaData Index = "" & CStr(lngCompiledMetadataIndex)" & vbNewLine
3834:   strBaseString = strBaseString & " " & vbNewLine
3835:   strBaseString = strBaseString & "'  636] dqInfo/dataLineage/prcStep/stepDesc    --> Made edits consistent with changes to Road and Trail feature classes related to West Boundary Road (W-1), Walden Trail Access Road (W-1B), and the Waldron Trail. Confirmed Datum transformation." & vbNewLine
3836:   strBaseString = strBaseString & "'  637] dqInfo/dataLineage/prcStep/stepDateTm    --> 2013-03-11T00:00:00" & vbNewLine
3837:   strBaseString = strBaseString & "'  638] dqInfo/dataLineage/prcStep/stepProc/rpIndName    --> Mark Nebel" & vbNewLine
3838:   strBaseString = strBaseString & "'  639] dqInfo/dataLineage/prcStep/stepProc/rpOrgName    --> Grand Canyon National Park" & vbNewLine
3839:   strBaseString = strBaseString & "'  640] dqInfo/dataLineage/prcStep/stepProc/rpPosName    --> GIS Coordinator" & vbNewLine
3840:   strBaseString = strBaseString & "'  641] dqInfo/dataLineage/prcStep/stepProc/rpCntInfo/cntPhone/voiceNum    --> 928-638-7451" & vbNewLine
3841:   strBaseString = strBaseString & "'  642] dqInfo/dataLineage/prcStep/stepProc/rpCntInfo/cntAddress/delPoint    --> 1824 S. Thompson St" & vbNewLine
3842:   strBaseString = strBaseString & "'  643] dqInfo/dataLineage/prcStep/stepProc/rpCntInfo/cntAddress/delPoint    --> Suite 200" & vbNewLine
3843:   strBaseString = strBaseString & "'  644] dqInfo/dataLineage/prcStep/stepProc/rpCntInfo/cntAddress/city    --> Flagstaff" & vbNewLine
3844:   strBaseString = strBaseString & "'  645] dqInfo/dataLineage/prcStep/stepProc/rpCntInfo/cntAddress/adminArea    --> AZ" & vbNewLine
3845:   strBaseString = strBaseString & "'  646] dqInfo/dataLineage/prcStep/stepProc/rpCntInfo/cntAddress/postCode    --> 86001" & vbNewLine
3846:   strBaseString = strBaseString & "'  647] dqInfo/dataLineage/prcStep/stepProc/rpCntInfo/cntAddress/country    --> UAS" & vbNewLine
3847:   strBaseString = strBaseString & "'  648] dqInfo/dataLineage/prcStep/stepProc/rpCntInfo/cntAddress/eMailAdd    --> mark_nebel@nps.gov" & vbNewLine
3848:   strBaseString = strBaseString & "'  649] dqInfo/dataLineage/prcStep/stepProc/role/RoleCd    -->" & vbNewLine
3849:   strBaseString = strBaseString & "'  650] dqInfo/dataLineage/prcStep/stepProc/displayName    --> Mark Nebel" & vbNewLine
3850:   strBaseString = strBaseString & " " & vbNewLine
3851:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepDesc""" & vbNewLine
3852:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepDateTm""" & vbNewLine
3853:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/rpIndName""" & vbNewLine
3854:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/rpOrgName""" & vbNewLine
3855:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/rpPosName""" & vbNewLine
3856:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/rpCntInfo/cntPhone/voiceNum""" & vbNewLine
3857:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/rpCntInfo/cntAddress/delPoint""" & vbNewLine
3858:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/rpCntInfo/cntAddress/city""" & vbNewLine
3859:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/rpCntInfo/cntAddress/adminArea""" & vbNewLine
3860:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/rpCntInfo/cntAddress/postCode""" & vbNewLine
3861:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/rpCntInfo/cntAddress/country""" & vbNewLine
3862:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/rpCntInfo/cntAddress/eMailAdd""" & vbNewLine
3863:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/role/RoleCd""" & vbNewLine
3864:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & ""]/stepProc/displayName""" & vbNewLine
3865:   strBaseString = strBaseString & " " & vbNewLine
3866:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3867:   strBaseString = strBaseString & "      ""]/stepDesc"", strCompiledData" & vbNewLine
3868:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3869:   strBaseString = strBaseString & "       ""]/stepDateTm"", ""2013-09-01T00:00:00""" & vbNewLine
3870:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3871:   strBaseString = strBaseString & "       ""]/stepProc/rpIndName"", ""Jeff Jenness""" & vbNewLine
3872:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3873:   strBaseString = strBaseString & "       ""]/stepProc/rpOrgName"", ""Jenness Enterprises""" & vbNewLine
3874:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3875:   strBaseString = strBaseString & "       ""]/stepProc/rpPosName"", ""GIS Analyst""" & vbNewLine
3876:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3877:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntPhone/voiceNum"", ""928-607-4638""" & vbNewLine
3878:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3879:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/delPoint"", ""3020 N. Schevene Blvd.""" & vbNewLine
3880:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3881:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/city"", ""Flagstaff""" & vbNewLine
3882:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3883:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/adminArea"", ""AZ""" & vbNewLine
3884:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3885:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/postCode"", ""86004""" & vbNewLine
3886:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3887:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/country"", ""UNITED STATES""" & vbNewLine
3888:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3889:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/eMailAdd"", ""jeffj@jennessent.com""" & vbNewLine
3890:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3891:   strBaseString = strBaseString & "       ""]/stepProc/role/RoleCd"", """"" & vbNewLine
3892:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3893:   strBaseString = strBaseString & "       ""]/stepProc/displayName"", ""Jeff Jenness""" & vbNewLine
3894:   strBaseString = strBaseString & "  pXMLPropSet.SetAttribute ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3895:   strBaseString = strBaseString & "      ""]/stepProc/role/RoleCd"", ""value"", ""009"", esriXSPAAddOrReplace" & vbNewLine
3896:   strBaseString = strBaseString & "  pXMLPropSet.SetAttribute ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledDataIndex) & _" & vbNewLine
3897:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress"", ""addressType"", ""both"", esriXSPAAddOrReplace" & vbNewLine
3898:   strBaseString = strBaseString & " " & vbNewLine
3899:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepDesc""" & vbNewLine
3900:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepDateTm""" & vbNewLine
3901:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/rpIndName""" & vbNewLine
3902:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/rpOrgName""" & vbNewLine
3903:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/rpPosName""" & vbNewLine
3904:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/rpCntInfo/cntPhone/voiceNum""" & vbNewLine
3905:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/rpCntInfo/cntAddress/delPoint""" & vbNewLine
3906:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/rpCntInfo/cntAddress/city""" & vbNewLine
3907:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/rpCntInfo/cntAddress/adminArea""" & vbNewLine
3908:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/rpCntInfo/cntAddress/postCode""" & vbNewLine
3909:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/rpCntInfo/cntAddress/country""" & vbNewLine
3910:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/rpCntInfo/cntAddress/eMailAdd""" & vbNewLine
3911:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/role/RoleCd""" & vbNewLine
3912:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & ""]/stepProc/displayName""" & vbNewLine
3913:   strBaseString = strBaseString & " " & vbNewLine
3914:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3915:   strBaseString = strBaseString & "      ""]/stepDesc"", strCompiledMetadata" & vbNewLine
3916:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3917:   strBaseString = strBaseString & "       ""]/stepDateTm"", ""2013-11-18T00:00:00""" & vbNewLine
3918:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3919:   strBaseString = strBaseString & "       ""]/stepProc/rpIndName"", ""Jeff Jenness""" & vbNewLine
3920:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3921:   strBaseString = strBaseString & "       ""]/stepProc/rpOrgName"", ""Jenness Enterprises""" & vbNewLine
3922:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3923:   strBaseString = strBaseString & "       ""]/stepProc/rpPosName"", ""GIS Analyst""" & vbNewLine
3924:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3925:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntPhone/voiceNum"", ""928-607-4638""" & vbNewLine
3926:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3927:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/delPoint"", ""3020 N. Schevene Blvd.""" & vbNewLine
3928:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3929:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/city"", ""Flagstaff""" & vbNewLine
3930:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3931:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/adminArea"", ""AZ""" & vbNewLine
3932:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3933:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/postCode"", ""86004""" & vbNewLine
3934:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3935:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/country"", ""UNITED STATES""" & vbNewLine
3936:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3937:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress/eMailAdd"", ""jeffj@jennessent.com""" & vbNewLine
3938:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3939:   strBaseString = strBaseString & "       ""]/stepProc/role/RoleCd"", """"" & vbNewLine
3940:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3941:   strBaseString = strBaseString & "       ""]/stepProc/displayName"", ""Jeff Jenness""" & vbNewLine
3942:   strBaseString = strBaseString & "  pXMLPropSet.SetAttribute ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3943:   strBaseString = strBaseString & "      ""]/stepProc/role/RoleCd"", ""value"", ""009"", esriXSPAAddOrReplace" & vbNewLine
3944:   strBaseString = strBaseString & "  pXMLPropSet.SetAttribute ""dqInfo/dataLineage/prcStep["" & CStr(lngCompiledMetadataIndex) & _" & vbNewLine
3945:   strBaseString = strBaseString & "       ""]/stepProc/rpCntInfo/cntAddress"", ""addressType"", ""both"", esriXSPAAddOrReplace" & vbNewLine
3946:   strBaseString = strBaseString & " " & vbNewLine
3947:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/rpIndName""" & vbNewLine
3948:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/rpOrgName""" & vbNewLine
3949:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/rpPosName""" & vbNewLine
3950:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/role/RoleCd""" & vbNewLine
3951:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/delPoint""" & vbNewLine
3952:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/city""" & vbNewLine
3953:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/adminArea""" & vbNewLine
3954:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/postCode""" & vbNewLine
3955:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/eMailAdd""" & vbNewLine
3956:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/country""" & vbNewLine
3957:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntPhone/voiceNum""" & vbNewLine
3958:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idCitation/date/pubDate""" & vbNewLine
3959:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""dataIdInfo/idCitation/presForm/PresFormCd""" & vbNewLine
3960:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""dataIdInfo/idCitation/resTitle""" & vbNewLine
3961:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""dataIdInfo/idStatus/ProgCd""" & vbNewLine
3962:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/rpIndName""" & vbNewLine
3963:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/rpOrgName""" & vbNewLine
3964:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/rpPosName""" & vbNewLine
3965:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/rpCntInfo/cntPhone/voiceNum""" & vbNewLine
3966:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/delPoint""" & vbNewLine
3967:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/city""" & vbNewLine
3968:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/adminArea""" & vbNewLine
3969:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/postCode""" & vbNewLine
3970:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/country""" & vbNewLine
3971:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/eMailAdd""" & vbNewLine
3972:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""dataIdInfo/idPoC/role/RoleCd""" & vbNewLine
3973:   strBaseString = strBaseString & " " & vbNewLine
3974:   strBaseString = strBaseString & "  '  474] dataIdInfo/idCitation/citRespParty/rpOrgName  '    --> Grand Canyon National Park" & vbNewLine
3975:   strBaseString = strBaseString & "  '  475] dataIdInfo/idCitation/citRespParty/role/RoleCd  '    -->" & vbNewLine
3976:   strBaseString = strBaseString & "  '  476] dataIdInfo/idCitation/presForm/PresFormCd  '    -->" & vbNewLine
3977:   strBaseString = strBaseString & "  '  477] dataIdInfo/idCitation/resTitle  '    --> Transportation_Test_Metadata" & vbNewLine
3978:   strBaseString = strBaseString & "  '  478] dataIdInfo/idStatus/ProgCd  '    -->" & vbNewLine
3979:   strBaseString = strBaseString & "  '  479] dataIdInfo/idPoC/rpIndName  '    --> Mark Nebel" & vbNewLine
3980:   strBaseString = strBaseString & "  '  480] dataIdInfo/idPoC/rpOrgName  '    --> Grand Canyon National Park" & vbNewLine
3981:   strBaseString = strBaseString & "  '  481] dataIdInfo/idPoC/rpPosName  '    --> GIS Coordinator" & vbNewLine
3982:   strBaseString = strBaseString & "  '  482] dataIdInfo/idPoC/rpCntInfo/cntPhone/voiceNum  '    --> 928-638-7451" & vbNewLine
3983:   strBaseString = strBaseString & "  '  483] dataIdInfo/idPoC/rpCntInfo/cntAddress/delPoint  '    --> 1824 S Thompson St" & vbNewLine
3984:   strBaseString = strBaseString & "  '  484] dataIdInfo/idPoC/rpCntInfo/cntAddress/delPoint  '    --> Suite 200" & vbNewLine
3985:   strBaseString = strBaseString & "  '  485] dataIdInfo/idPoC/rpCntInfo/cntAddress/city  '    --> Flagstaff" & vbNewLine
3986:   strBaseString = strBaseString & "  '  486] dataIdInfo/idPoC/rpCntInfo/cntAddress/adminArea  '    --> AZ" & vbNewLine
3987:   strBaseString = strBaseString & "  '  487] dataIdInfo/idPoC/rpCntInfo/cntAddress/postCode  '    --> 86001" & vbNewLine
3988:   strBaseString = strBaseString & "  '  488] dataIdInfo/idPoC/rpCntInfo/cntAddress/country  '    --> US" & vbNewLine
3989:   strBaseString = strBaseString & "  '  489] dataIdInfo/idPoC/rpCntInfo/cntAddress/eMailAdd  '    --> mark_nebel@nps.gov" & vbNewLine
3990:   strBaseString = strBaseString & "  '  490] dataIdInfo/idPoC/role/RoleCd  '    -->" & vbNewLine
3991:   strBaseString = strBaseString & " " & vbNewLine
3992:   strBaseString = strBaseString & "  ' FOR RoleCD:  ""006"" = ""Originator"";   ""007"" = ""Point of Contact""" & vbNewLine
3993:   strBaseString = strBaseString & " " & vbNewLine
3994:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpIndName"", ""Jill M. Rundall""" & vbNewLine
3995:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpOrgName[0]"", ""Lab of Landscape Ecology and Conservation Biology""" & vbNewLine
3996:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpOrgName[1]"", ""School of Earth Sciences and Environmental Sustainability""" & vbNewLine
3997:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpOrgName[2]"", ""College of Engineering, Forestry and Natural Sciences""" & vbNewLine
3998:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpOrgName[3]"", ""Northern Arizona University""" & vbNewLine
3999:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpPosName"", ""Operations manager/Spatial analyst""" & vbNewLine
4000:   strBaseString = strBaseString & "  pXMLPropSet.SetAttribute ""dataIdInfo/idCitation/citRespParty/role/RoleCd"", ""value"", ""006"", esriXSPAAddOrReplace" & vbNewLine
4001:   strBaseString = strBaseString & " " & vbNewLine
4002:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/delPoint[0]"", ""602 S Humphreys""" & vbNewLine
4003:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/delPoint[1]"", ""P.O Box 5694""" & vbNewLine
4004:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/city"", ""Flagstaff""" & vbNewLine
4005:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/adminArea"", ""AZ""" & vbNewLine
4006:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/postCode"", ""86011""" & vbNewLine
4007:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/eMailAdd"", ""Jill.Rundall@nau.edu""" & vbNewLine
4008:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntAddress/country"", ""UNITED STATES""" & vbNewLine
4009:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/rpCntInfo/cntPhone/voiceNum"", ""928-523-4730""" & vbNewLine
4010:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idCitation/date/pubDate"", ""2013-11-17T00:00:00""" & vbNewLine
4011:   strBaseString = strBaseString & " " & vbNewLine
4012:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""dataIdInfo/idCitation/presForm/PresFormCd""" & vbNewLine
4013:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""dataIdInfo/idCitation/citRespParty/role/RoleCd"", """"" & vbNewLine
4014:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""dataIdInfo/idCitation/presForm/PresFormCd"", """"" & vbNewLine
4015:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""dataIdInfo/idCitation/resTitle"", """"" & vbNewLine
4016:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""dataIdInfo/idStatus/ProgCd"", """"" & vbNewLine
4017:   strBaseString = strBaseString & " " & vbNewLine
4018:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpIndName"", ""Jill M. Rundall""" & vbNewLine
4019:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpOrgName[0]"", ""Lab of Landscape Ecology and Conservation Biology""" & vbNewLine
4020:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpOrgName[1]"", ""School of Earth Sciences and Environmental Sustainability""" & vbNewLine
4021:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpOrgName[2]"", ""College of Engineering, Forestry and Natural Sciences""" & vbNewLine
4022:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpOrgName[3]"", ""Northern Arizona University""" & vbNewLine
4023:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpPosName"", ""Operations manager/Spatial analyst""" & vbNewLine
4024:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpCntInfo/cntPhone/voiceNum"", ""928-523-4730""" & vbNewLine
4025:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/delPoint[0]"", ""602 S Humphreys""" & vbNewLine
4026:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/delPoint[1]"", ""P.O Box 5694""" & vbNewLine
4027:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/city"", ""Flagstaff""" & vbNewLine
4028:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/adminArea"", ""AZ""" & vbNewLine
4029:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/postCode"", ""86011""" & vbNewLine
4030:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/country"", ""UNITED STATES""" & vbNewLine
4031:   strBaseString = strBaseString & "  pPropSet.SetProperty ""dataIdInfo/idPoC/rpCntInfo/cntAddress/eMailAdd"", ""Jill.Rundall@nau.edu""" & vbNewLine
4032:   strBaseString = strBaseString & "  pXMLPropSet.SetAttribute ""dataIdInfo/idPoC/role/RoleCd"", ""value"", ""007"", esriXSPAAddOrReplace" & vbNewLine
4033:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""dataIdInfo/idPoC/role/RoleCd"", """"" & vbNewLine
4034:   strBaseString = strBaseString & " " & vbNewLine
4035:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""mdContact""" & vbNewLine
4036:   strBaseString = strBaseString & " " & vbNewLine
4037:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpIndName""" & vbNewLine
4038:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpOrgName""" & vbNewLine
4039:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpPosName""" & vbNewLine
4040:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntPhone/voiceNum""" & vbNewLine
4041:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/delPoint""" & vbNewLine
4042:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/city""" & vbNewLine
4043:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/adminArea""" & vbNewLine
4044:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/postCode""" & vbNewLine
4045:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/country""" & vbNewLine
4046:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/rpCntInfo/cntAddress/eMailAdd""" & vbNewLine
4047:   strBaseString = strBaseString & "'  pPropSet.RemoveProperty ""mdContact/role/RoleCd""" & vbNewLine
4048:   strBaseString = strBaseString & " " & vbNewLine
4049:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpIndName"", ""Jill M. Rundall""" & vbNewLine
4050:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpOrgName[0]"", ""Lab of Landscape Ecology and Conservation Biology""" & vbNewLine
4051:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpOrgName[1]"", ""School of Earth Sciences and Environmental Sustainability""" & vbNewLine
4052:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpOrgName[2]"", ""College of Engineering, Forestry and Natural Sciences""" & vbNewLine
4053:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpOrgName[3]"", ""Northern Arizona University""" & vbNewLine
4054:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpPosName"", ""Operations manager/Spatial analyst""" & vbNewLine
4055:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpCntInfo/cntPhone/voiceNum"", ""928-523-4730""" & vbNewLine
4056:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpCntInfo/cntAddress/delPoint[0]"", ""602 S Humphreys""" & vbNewLine
4057:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpCntInfo/cntAddress/delPoint[1]"", ""P.O Box 5694""" & vbNewLine
4058:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpCntInfo/cntAddress/city"", ""Flagstaff""" & vbNewLine
4059:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpCntInfo/cntAddress/adminArea"", ""AZ""" & vbNewLine
4060:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpCntInfo/cntAddress/postCode"", ""86011""" & vbNewLine
4061:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpCntInfo/cntAddress/country"", ""UNITED STATES""" & vbNewLine
4062:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[0]/rpCntInfo/cntAddress/eMailAdd"", ""Jill.Rundall@nau.edu""" & vbNewLine
4063:   strBaseString = strBaseString & "  pXMLPropSet.SetAttribute ""mdContact[0]/role/RoleCd"", ""value"", ""007"", esriXSPAAddOrReplace" & vbNewLine
4064:   strBaseString = strBaseString & "  pXMLPropSet.SetAttribute ""mdContact[0]/rpCntInfo/cntAddress"", ""addressType"", ""both"", esriXSPAAddOrReplace" & vbNewLine
4065:   strBaseString = strBaseString & " " & vbNewLine
4066:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[1]/rpIndName"", ""Jeff Jenness""" & vbNewLine
4067:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[1]/rpOrgName"", ""Jenness Enterprises""" & vbNewLine
4068:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[1]/rpPosName"", ""GIS Analyst, Application Designer""" & vbNewLine
4069:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[1]/rpCntInfo/cntPhone/voiceNum"", ""928-607-4638""" & vbNewLine
4070:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[1]/rpCntInfo/cntAddress/delPoint"", ""3020 N. Schevene Blvd.""" & vbNewLine
4071:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[1]/rpCntInfo/cntAddress/city"", ""Flagstaff""" & vbNewLine
4072:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[1]/rpCntInfo/cntAddress/adminArea"", ""AZ""" & vbNewLine
4073:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[1]/rpCntInfo/cntAddress/postCode"", ""86001""" & vbNewLine
4074:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[1]/rpCntInfo/cntAddress/country"", ""UNITED STATES""" & vbNewLine
4075:   strBaseString = strBaseString & "  pPropSet.SetProperty ""mdContact[1]/rpCntInfo/cntAddress/eMailAdd"", ""jeffj@jennessent.com""" & vbNewLine
4076:   strBaseString = strBaseString & "  pXMLPropSet.SetAttribute ""mdContact[1]/role/RoleCd"", ""value"", ""006"", esriXSPAAddOrReplace" & vbNewLine
4077:   strBaseString = strBaseString & "  pXMLPropSet.SetAttribute ""mdContact[1]/rpCntInfo/cntAddress"", ""addressType"", ""both"", esriXSPAAddOrReplace" & vbNewLine
4078:   strBaseString = strBaseString & " " & vbNewLine
4079:   strBaseString = strBaseString & "'  pPropSet.SetProperty ""mdContact/role/RoleCd"", """"" & vbNewLine
4080:   strBaseString = strBaseString & "  '  478] mdContact/rpIndName  '    --> Mark Nebel" & vbNewLine
4081:   strBaseString = strBaseString & "  '  479] mdContact/rpOrgName  '    --> Grand Canyon National Park" & vbNewLine
4082:   strBaseString = strBaseString & "  '  480] mdContact/rpPosName  '    --> GIS Coordinator" & vbNewLine
4083:   strBaseString = strBaseString & "  '  481] mdContact/rpCntInfo/cntPhone/voiceNum  '    --> 928-638-7451" & vbNewLine
4084:   strBaseString = strBaseString & "  '  482] mdContact/rpCntInfo/cntAddress/delPoint  '    --> 1824 S. Thompson St" & vbNewLine
4085:   strBaseString = strBaseString & "  '  483] mdContact/rpCntInfo/cntAddress/delPoint  '    --> Suite 200" & vbNewLine
4086:   strBaseString = strBaseString & "  '  484] mdContact/rpCntInfo/cntAddress/city  '    --> Flagstaff" & vbNewLine
4087:   strBaseString = strBaseString & "  '  485] mdContact/rpCntInfo/cntAddress/adminArea  '    --> AZ" & vbNewLine
4088:   strBaseString = strBaseString & "  '  486] mdContact/rpCntInfo/cntAddress/postCode  '    --> 86001" & vbNewLine
4089:   strBaseString = strBaseString & "  '  487] mdContact/rpCntInfo/cntAddress/country  '    --> UAS" & vbNewLine
4090:   strBaseString = strBaseString & "  '  488] mdContact/rpCntInfo/cntAddress/eMailAdd  '    --> mark_nebel@nps.gov" & vbNewLine
4091:   strBaseString = strBaseString & "  '  489] mdContact/role/RoleCd  '    -->" & vbNewLine
4092:   strBaseString = strBaseString & " " & vbNewLine
4093:   strBaseString = strBaseString & "  '" & vbNewLine
4094:   strBaseString = strBaseString & "  '  Jill M. Rundall" & vbNewLine
4095:   strBaseString = strBaseString & "  '  Operations manager/Spatial analyst" & vbNewLine
4096:   strBaseString = strBaseString & "  '  Lab of Landscape Ecology and Conservation Biology" & vbNewLine
4097:   strBaseString = strBaseString & "  '  Ph: 928-523-4730" & vbNewLine
4098:   strBaseString = strBaseString & "  '  Fax: 928-523-7078" & vbNewLine
4099:   strBaseString = strBaseString & "  'E:   Jill.Rundall@ nau.edu" & vbNewLine
4100:   strBaseString = strBaseString & "  '" & vbNewLine
4101:   strBaseString = strBaseString & "  '  School of Earth Sciences and Environmental Sustainability" & vbNewLine
4102:   strBaseString = strBaseString & "  '  College of Engineering, Forestry and Natural Sciences" & vbNewLine
4103:   strBaseString = strBaseString & "  '  Northern Arizona University, Flagstaff, AZ 86011" & vbNewLine
4104:   strBaseString = strBaseString & " " & vbNewLine
4105:   strBaseString = strBaseString & " " & vbNewLine
4106:   strBaseString = strBaseString & "  ' ---------------------------------------------------------------------------------------------" & vbNewLine
4107:   strBaseString = strBaseString & "  ' SUPPLEMENTAL INFORMATION" & vbNewLine
  strBaseString = strBaseString & "  Dim strOtherConstraintsData As String" & vbNewLine
4109:   strBaseString = strBaseString & "  strOtherConstraintsData = ""Additional Constraints for each "" & _" & vbNewLine
4110:   strBaseString = strBaseString & "    ""of the contributor feature classes are listed below:"" & vbCrLf & vbCrLf" & vbNewLine
4111:   strBaseString = strBaseString & " " & vbNewLine
4112:   strBaseString = strBaseString & "  For lngPropSetIndex = 0 To pNewFClassArray.Count - 1" & vbNewLine
4113:   strBaseString = strBaseString & "    strFClassName = strFClassNames(lngPropSetIndex)" & vbNewLine
4114:   strBaseString = strBaseString & "    Set pSubArray = pNewFClassArray.Element(lngPropSetIndex)" & vbNewLine
4115:   strBaseString = strBaseString & "    Set pContributorPropSet = pSubArray.Element(1)" & vbNewLine
4116:   strBaseString = strBaseString & " " & vbNewLine
4117:   strBaseString = strBaseString & "'    Debug.Print ""Descriptions for '"" & strFClassName & ""'""" & vbNewLine
4118:   strBaseString = strBaseString & "    varAtts = pContributorPropSet.GetProperty(strOtherConstraints)" & vbNewLine
4119:   strBaseString = strBaseString & " " & vbNewLine
4120:   strBaseString = strBaseString & "    If IsEmpty(varAtts) Then" & vbNewLine
4121:   strBaseString = strBaseString & "'      varAtts = pContributorPropSet.GetProperty(strOtherConstraints)" & vbNewLine
4122:   strBaseString = strBaseString & "'" & vbNewLine
4123:   strBaseString = strBaseString & "'      If IsEmpty(varAtts) Then" & vbNewLine
4124:   strBaseString = strBaseString & "        strOtherConstraintsData = strOtherConstraintsData & _" & vbNewLine
4125:   strBaseString = strBaseString & "            ""Additional Constraints for "" & strFClassName & _" & vbNewLine
4126:   strBaseString = strBaseString & "            ""  [-- No Additional Constraints Available --]"" & vbCrLf & vbCrLf" & vbNewLine
4127:   strBaseString = strBaseString & "'      Else" & vbNewLine
4128:   strBaseString = strBaseString & "'        For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4129:   strBaseString = strBaseString & "'          strValue = CStr(varAtts(lngIndex))" & vbNewLine
4130:   strBaseString = strBaseString & "'          strValue = RemoveTags(strValue)" & vbNewLine
4131:   strBaseString = strBaseString & "''          Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4132:   strBaseString = strBaseString & "'" & vbNewLine
4133:   strBaseString = strBaseString & "'          If InStr(1, strValue, ""DIV STYLE"", vbTextCompare) > 0 Then" & vbNewLine
4134:   strBaseString = strBaseString & "'            strOtherConstraintsData = strOtherConstraintsData & _" & vbNewLine
4135:   strBaseString = strBaseString & "'                ""<P><SPAN STYLE=""""font-weight:bold;"""">Use Limitations for "" & strFClassName & _" & vbNewLine
4136:   strBaseString = strBaseString & "'                "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>""" & vbNewLine
4137:   strBaseString = strBaseString & "'          Else" & vbNewLine
4138:   strBaseString = strBaseString & "'" & vbNewLine
4139:   strBaseString = strBaseString & "'            strOtherConstraintsData = strOtherConstraintsData & _" & vbNewLine
4140:   strBaseString = strBaseString & "'                ""<P><SPAN STYLE=""""font-weight:bold;"""">Use Limitations for "" & strFClassName & _" & vbNewLine
4141:   strBaseString = strBaseString & "'                "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>""" & vbNewLine
4142:   strBaseString = strBaseString & "'          End If" & vbNewLine
4143:   strBaseString = strBaseString & "'" & vbNewLine
4144:   strBaseString = strBaseString & "'        Next lngIndex" & vbNewLine
4145:   strBaseString = strBaseString & "'      End If" & vbNewLine
4146:   strBaseString = strBaseString & "    Else" & vbNewLine
4147:   strBaseString = strBaseString & "      For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4148:   strBaseString = strBaseString & "        strValue = CStr(varAtts(lngIndex))" & vbNewLine
4149:   strBaseString = strBaseString & "        strValue = RemoveTags(strValue)" & vbNewLine
4150:   strBaseString = strBaseString & "'        Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4151:   strBaseString = strBaseString & " " & vbNewLine
4152:   strBaseString = strBaseString & "        strOtherConstraintsData = strOtherConstraintsData & _" & vbNewLine
4153:   strBaseString = strBaseString & "            ""Additional Constraints for "" & strFClassName & _" & vbNewLine
4154:   strBaseString = strBaseString & "            "":  "" & strValue & vbCrLf & vbCrLf" & vbNewLine
4155:   strBaseString = strBaseString & "      Next lngIndex" & vbNewLine
4156:   strBaseString = strBaseString & "    End If" & vbNewLine
4157:   strBaseString = strBaseString & "  Next lngPropSetIndex" & vbNewLine
4158:   strBaseString = strBaseString & " " & vbNewLine
4159:   strBaseString = strBaseString & "  strOtherConstraintsData = Replace(strOtherConstraintsData, ""TrasnportationLine"", ""TransportationLine"", , , vbTextCompare)" & vbNewLine
4160:   strBaseString = strBaseString & "'  strSupplemental = strSupplemental & ""</DIV></DIV>""" & vbNewLine
4161:   strBaseString = strBaseString & " " & vbNewLine
4162:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strOtherConstraints)" & vbNewLine
4163:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4164:   strBaseString = strBaseString & "    pPropSet.RemoveProperty strOtherConstraints" & vbNewLine
4165:   strBaseString = strBaseString & "  End If" & vbNewLine
4166:   strBaseString = strBaseString & " " & vbNewLine
4167:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strOtherConstraints)" & vbNewLine
4168:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4169:   strBaseString = strBaseString & "    If UBound(varAtts) = 0 Then" & vbNewLine
4170:   strBaseString = strBaseString & "      pPropSet.SetProperty strOtherConstraints, strOtherConstraintsData" & vbNewLine
4171:   strBaseString = strBaseString & "    End If" & vbNewLine
4172:   strBaseString = strBaseString & "  Else" & vbNewLine
4173:   strBaseString = strBaseString & "    pPropSet.SetProperty strOtherConstraints, strOtherConstraintsData" & vbNewLine
4174:   strBaseString = strBaseString & "  End If" & vbNewLine
4175:   strBaseString = strBaseString & "'" & vbNewLine
4176:   strBaseString = strBaseString & "'  Debug.Print ""Final Description:""" & vbNewLine
4177:   strBaseString = strBaseString & "'  Debug.Print strFullDescription" & vbNewLine
4178:   strBaseString = strBaseString & "  'pPropSet.SetProperty strSummaryString & strfinalsummary" & vbNewLine
4179:   strBaseString = strBaseString & " " & vbNewLine
4180:   strBaseString = strBaseString & " " & vbNewLine
4181:   strBaseString = strBaseString & "  ' ---------------------------------------------------------------------------------------------" & vbNewLine
4182:   strBaseString = strBaseString & "  ' SUPPLEMENTAL INFORMATION" & vbNewLine
  strBaseString = strBaseString & "  Dim strSupplemental As String" & vbNewLine
4184:   strBaseString = strBaseString & "  strSupplemental = ""Supplemental Information for each "" & _" & vbNewLine
4185:   strBaseString = strBaseString & "    ""of the contributor feature classes are listed below:"" & vbCrLf & vbCrLf" & vbNewLine
4186:   strBaseString = strBaseString & " " & vbNewLine
4187:   strBaseString = strBaseString & "  For lngPropSetIndex = 0 To pNewFClassArray.Count - 1" & vbNewLine
4188:   strBaseString = strBaseString & "    strFClassName = strFClassNames(lngPropSetIndex)" & vbNewLine
4189:   strBaseString = strBaseString & "    Set pSubArray = pNewFClassArray.Element(lngPropSetIndex)" & vbNewLine
4190:   strBaseString = strBaseString & "    Set pContributorPropSet = pSubArray.Element(1)" & vbNewLine
4191:   strBaseString = strBaseString & " " & vbNewLine
4192:   strBaseString = strBaseString & "'    Debug.Print ""Descriptions for '"" & strFClassName & ""'""" & vbNewLine
4193:   strBaseString = strBaseString & "    varAtts = pContributorPropSet.GetProperty(strSupplementalInformation)" & vbNewLine
4194:   strBaseString = strBaseString & " " & vbNewLine
4195:   strBaseString = strBaseString & "    If IsEmpty(varAtts) Then" & vbNewLine
4196:   strBaseString = strBaseString & "'      varAtts = pContributorPropSet.GetProperty(strUseLimitationsString2)" & vbNewLine
4197:   strBaseString = strBaseString & "'" & vbNewLine
4198:   strBaseString = strBaseString & "'      If IsEmpty(varAtts) Then" & vbNewLine
4199:   strBaseString = strBaseString & "        strSupplemental = strSupplemental & _" & vbNewLine
4200:   strBaseString = strBaseString & "            ""Supplemental Information for "" & strFClassName & _" & vbNewLine
4201:   strBaseString = strBaseString & "            ""  [-- No Supplemental Information Available --]"" & vbCrLf & vbCrLf" & vbNewLine
4202:   strBaseString = strBaseString & "'      Else" & vbNewLine
4203:   strBaseString = strBaseString & "'        For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4204:   strBaseString = strBaseString & "'          strValue = CStr(varAtts(lngIndex))" & vbNewLine
4205:   strBaseString = strBaseString & "'          strValue = RemoveTags(strValue)" & vbNewLine
4206:   strBaseString = strBaseString & "''          Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4207:   strBaseString = strBaseString & "'" & vbNewLine
4208:   strBaseString = strBaseString & "'          If InStr(1, strValue, ""DIV STYLE"", vbTextCompare) > 0 Then" & vbNewLine
4209:   strBaseString = strBaseString & "'            strSupplemental = strSupplemental & _" & vbNewLine
4210:   strBaseString = strBaseString & "'                ""<P><SPAN STYLE=""""font-weight:bold;"""">Use Limitations for "" & strFClassName & _" & vbNewLine
4211:   strBaseString = strBaseString & "'                "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>""" & vbNewLine
4212:   strBaseString = strBaseString & "'          Else" & vbNewLine
4213:   strBaseString = strBaseString & "'" & vbNewLine
4214:   strBaseString = strBaseString & "'            strSupplemental = strSupplemental & _" & vbNewLine
4215:   strBaseString = strBaseString & "'                ""<P><SPAN STYLE=""""font-weight:bold;"""">Use Limitations for "" & strFClassName & _" & vbNewLine
4216:   strBaseString = strBaseString & "'                "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>""" & vbNewLine
4217:   strBaseString = strBaseString & "'          End If" & vbNewLine
4218:   strBaseString = strBaseString & "'" & vbNewLine
4219:   strBaseString = strBaseString & "'        Next lngIndex" & vbNewLine
4220:   strBaseString = strBaseString & "'      End If" & vbNewLine
4221:   strBaseString = strBaseString & "    Else" & vbNewLine
4222:   strBaseString = strBaseString & "      For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4223:   strBaseString = strBaseString & "        strValue = CStr(varAtts(lngIndex))" & vbNewLine
4224:   strBaseString = strBaseString & "        strValue = RemoveTags(strValue)" & vbNewLine
4225:   strBaseString = strBaseString & "'        Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4226:   strBaseString = strBaseString & " " & vbNewLine
4227:   strBaseString = strBaseString & "        strSupplemental = strSupplemental & _" & vbNewLine
4228:   strBaseString = strBaseString & "            ""Supplemental Information for "" & strFClassName & _" & vbNewLine
4229:   strBaseString = strBaseString & "            "":  "" & strValue & vbCrLf & vbCrLf" & vbNewLine
4230:   strBaseString = strBaseString & "      Next lngIndex" & vbNewLine
4231:   strBaseString = strBaseString & "    End If" & vbNewLine
4232:   strBaseString = strBaseString & "  Next lngPropSetIndex" & vbNewLine
4233:   strBaseString = strBaseString & " " & vbNewLine
4234:   strBaseString = strBaseString & "  strSupplemental = Replace(strSupplemental, ""TrasnportationLine"", ""TransportationLine"", , , vbTextCompare)" & vbNewLine
4235:   strBaseString = strBaseString & "'  strSupplemental = strSupplemental & ""</DIV></DIV>""" & vbNewLine
4236:   strBaseString = strBaseString & " " & vbNewLine
4237:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strSupplementalInformation)" & vbNewLine
4238:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4239:   strBaseString = strBaseString & "    pPropSet.RemoveProperty strSupplementalInformation" & vbNewLine
4240:   strBaseString = strBaseString & "  End If" & vbNewLine
4241:   strBaseString = strBaseString & " " & vbNewLine
4242:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strSupplementalInformation)" & vbNewLine
4243:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4244:   strBaseString = strBaseString & "    If UBound(varAtts) = 0 Then" & vbNewLine
4245:   strBaseString = strBaseString & "      pPropSet.SetProperty strSupplementalInformation, strSupplemental" & vbNewLine
4246:   strBaseString = strBaseString & "    End If" & vbNewLine
4247:   strBaseString = strBaseString & "  Else" & vbNewLine
4248:   strBaseString = strBaseString & "    pPropSet.SetProperty strSupplementalInformation, strSupplemental" & vbNewLine
4249:   strBaseString = strBaseString & "  End If" & vbNewLine
4250:   strBaseString = strBaseString & "'" & vbNewLine
4251:   strBaseString = strBaseString & "'  Debug.Print ""Final Description:""" & vbNewLine
4252:   strBaseString = strBaseString & "'  Debug.Print strFullDescription" & vbNewLine
4253:   strBaseString = strBaseString & "  'pPropSet.SetProperty strSummaryString & strfinalsummary" & vbNewLine
4254:   strBaseString = strBaseString & " " & vbNewLine
4255:   strBaseString = strBaseString & " " & vbNewLine
4256:   strBaseString = strBaseString & "  ' ---------------------------------------------------------------------------------------------" & vbNewLine
4257:   strBaseString = strBaseString & "  ' USE LIMITATIONS" & vbNewLine
  strBaseString = strBaseString & "  Dim strFullLimitations As String" & vbNewLine
4259:   strBaseString = strBaseString & "  strFullLimitations = ""<DIV STYLE=""""text-align:Left;""""><DIV><P><SPAN>Use Limitations for each "" & _" & vbNewLine
4260:   strBaseString = strBaseString & "    ""of the contributor feature classes are listed below:</SPAN></P>""" & vbNewLine
4261:   strBaseString = strBaseString & " " & vbNewLine
4262:   strBaseString = strBaseString & "  For lngPropSetIndex = 0 To pNewFClassArray.Count - 1" & vbNewLine
4263:   strBaseString = strBaseString & "    strFClassName = strFClassNames(lngPropSetIndex)" & vbNewLine
4264:   strBaseString = strBaseString & "    Set pSubArray = pNewFClassArray.Element(lngPropSetIndex)" & vbNewLine
4265:   strBaseString = strBaseString & "    Set pContributorPropSet = pSubArray.Element(1)" & vbNewLine
4266:   strBaseString = strBaseString & " " & vbNewLine
4267:   strBaseString = strBaseString & "'    Debug.Print ""Descriptions for '"" & strFClassName & ""'""" & vbNewLine
4268:   strBaseString = strBaseString & "    varAtts = pContributorPropSet.GetProperty(strUseLimitationsString)" & vbNewLine
4269:   strBaseString = strBaseString & " " & vbNewLine
4270:   strBaseString = strBaseString & "    If IsEmpty(varAtts) Then" & vbNewLine
4271:   strBaseString = strBaseString & "      varAtts = pContributorPropSet.GetProperty(strUseLimitationsString2)" & vbNewLine
4272:   strBaseString = strBaseString & " " & vbNewLine
4273:   strBaseString = strBaseString & "      If IsEmpty(varAtts) Then" & vbNewLine
4274:   strBaseString = strBaseString & "        strFullLimitations = strFullLimitations & _" & vbNewLine
4275:   strBaseString = strBaseString & "            ""<P><SPAN STYLE=""""font-weight:bold;"""">Use Limitations for "" & strFClassName & _" & vbNewLine
4276:   strBaseString = strBaseString & "            "":</SPAN><SPAN> &lt;-- No Use Limitations Available --&gt;</SPAN></P>"" & vbCrLf" & vbNewLine
4277:   strBaseString = strBaseString & "      Else" & vbNewLine
4278:   strBaseString = strBaseString & "        For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4279:   strBaseString = strBaseString & "          strValue = CStr(varAtts(lngIndex))" & vbNewLine
4280:   strBaseString = strBaseString & "          strValue = RemoveTags(strValue)" & vbNewLine
4281:   strBaseString = strBaseString & "'          Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4282:   strBaseString = strBaseString & " " & vbNewLine
4283:   strBaseString = strBaseString & "          If InStr(1, strValue, ""DIV STYLE"", vbTextCompare) > 0 Then" & vbNewLine
4284:   strBaseString = strBaseString & "            strFullLimitations = strFullLimitations & _" & vbNewLine
4285:   strBaseString = strBaseString & "                ""<P><SPAN STYLE=""""font-weight:bold;"""">Use Limitations for "" & strFClassName & _" & vbNewLine
4286:   strBaseString = strBaseString & "                "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>"" & vbCrLf" & vbNewLine
4287:   strBaseString = strBaseString & "          Else" & vbNewLine
4288:   strBaseString = strBaseString & " " & vbNewLine
4289:   strBaseString = strBaseString & "            strFullLimitations = strFullLimitations & _" & vbNewLine
4290:   strBaseString = strBaseString & "                ""<P><SPAN STYLE=""""font-weight:bold;"""">Use Limitations for "" & strFClassName & _" & vbNewLine
4291:   strBaseString = strBaseString & "                "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>"" & vbCrLf" & vbNewLine
4292:   strBaseString = strBaseString & "          End If" & vbNewLine
4293:   strBaseString = strBaseString & " " & vbNewLine
4294:   strBaseString = strBaseString & "        Next lngIndex" & vbNewLine
4295:   strBaseString = strBaseString & "      End If" & vbNewLine
4296:   strBaseString = strBaseString & "    Else" & vbNewLine
4297:   strBaseString = strBaseString & "      For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4298:   strBaseString = strBaseString & "        strValue = CStr(varAtts(lngIndex))" & vbNewLine
4299:   strBaseString = strBaseString & "        strValue = RemoveTags(strValue)" & vbNewLine
4300:   strBaseString = strBaseString & "'        Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4301:   strBaseString = strBaseString & " " & vbNewLine
4302:   strBaseString = strBaseString & "        strFullLimitations = strFullLimitations & _" & vbNewLine
4303:   strBaseString = strBaseString & "            ""<P><SPAN STYLE=""""font-weight:bold;"""">Use Limitations for "" & strFClassName & _" & vbNewLine
4304:   strBaseString = strBaseString & "            "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>"" & vbCrLf" & vbNewLine
4305:   strBaseString = strBaseString & " " & vbNewLine
4306:   strBaseString = strBaseString & "      Next lngIndex" & vbNewLine
4307:   strBaseString = strBaseString & "    End If" & vbNewLine
4308:   strBaseString = strBaseString & "  Next lngPropSetIndex" & vbNewLine
4309:   strBaseString = strBaseString & " " & vbNewLine
4310:   strBaseString = strBaseString & "  strFullLimitations = Replace(strFullLimitations, ""TrasnportationLine"", ""TransportationLine"", , , vbTextCompare)" & vbNewLine
4311:   strBaseString = strBaseString & "  strFullLimitations = strFullLimitations & ""</DIV></DIV>""" & vbNewLine
4312:   strBaseString = strBaseString & " " & vbNewLine
4313:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strUseLimitationsString)" & vbNewLine
4314:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4315:   strBaseString = strBaseString & "    pPropSet.RemoveProperty strUseLimitationsString" & vbNewLine
4316:   strBaseString = strBaseString & "  End If" & vbNewLine
4317:   strBaseString = strBaseString & " " & vbNewLine
4318:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strUseLimitationsString)" & vbNewLine
4319:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4320:   strBaseString = strBaseString & "    If UBound(varAtts) = 0 Then" & vbNewLine
4321:   strBaseString = strBaseString & "      pPropSet.SetProperty strUseLimitationsString, strFullLimitations" & vbNewLine
4322:   strBaseString = strBaseString & "    End If" & vbNewLine
4323:   strBaseString = strBaseString & "  Else" & vbNewLine
4324:   strBaseString = strBaseString & "    pPropSet.SetProperty strUseLimitationsString, strFullLimitations" & vbNewLine
4325:   strBaseString = strBaseString & "  End If" & vbNewLine
4326:   strBaseString = strBaseString & "'" & vbNewLine
4327:   strBaseString = strBaseString & "'  Debug.Print ""Final Description:""" & vbNewLine
4328:   strBaseString = strBaseString & "'  Debug.Print strFullDescription" & vbNewLine
4329:   strBaseString = strBaseString & "  'pPropSet.SetProperty strSummaryString & strfinalsummary" & vbNewLine
4330:   strBaseString = strBaseString & " " & vbNewLine
4331:   strBaseString = strBaseString & "  ' ---------------------------------------------------------------------------------------------" & vbNewLine
4332:   strBaseString = strBaseString & "  ' SET CREDITS" & vbNewLine
  strBaseString = strBaseString & "  Dim strFullCredits As String" & vbNewLine
4334:   strBaseString = strBaseString & "  strFullCredits = ""<DIV STYLE=""""text-align:Left;""""><DIV>""" & vbNewLine
4335:   strBaseString = strBaseString & " " & vbNewLine
4336:   strBaseString = strBaseString & "  For lngPropSetIndex = 0 To pNewFClassArray.Count - 1" & vbNewLine
4337:   strBaseString = strBaseString & "    strFClassName = strFClassNames(lngPropSetIndex)" & vbNewLine
4338:   strBaseString = strBaseString & "    Set pSubArray = pNewFClassArray.Element(lngPropSetIndex)" & vbNewLine
4339:   strBaseString = strBaseString & "    Set pContributorPropSet = pSubArray.Element(1)" & vbNewLine
4340:   strBaseString = strBaseString & " " & vbNewLine
4341:   strBaseString = strBaseString & "'    Debug.Print ""Credits for '"" & strFClassName & ""'""" & vbNewLine
4342:   strBaseString = strBaseString & "    varAtts = pContributorPropSet.GetProperty(strCreditString)" & vbNewLine
4343:   strBaseString = strBaseString & " " & vbNewLine
4344:   strBaseString = strBaseString & "    If IsEmpty(varAtts) Then" & vbNewLine
4345:   strBaseString = strBaseString & "'      varAtts = pContributorPropSet.GetProperty(strAbstract)" & vbNewLine
4346:   strBaseString = strBaseString & " " & vbNewLine
4347:   strBaseString = strBaseString & "'      If IsEmpty(varAtts) Then" & vbNewLine
4348:   strBaseString = strBaseString & "        strFullCredits = strFullCredits & _" & vbNewLine
4349:   strBaseString = strBaseString & "            ""<P><SPAN STYLE=""""font-weight:bold;"""">Credits for "" & strFClassName & _" & vbNewLine
4350:   strBaseString = strBaseString & "            "":</SPAN><SPAN> [-- No Credits Available --].       </SPAN></P>""" & vbNewLine
4351:   strBaseString = strBaseString & "'      Else" & vbNewLine
4352:   strBaseString = strBaseString & "'        For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4353:   strBaseString = strBaseString & "'          strValue = CStr(varAtts(lngIndex))" & vbNewLine
4354:   strBaseString = strBaseString & "'          strValue = RemoveTags(strValue)" & vbNewLine
4355:   strBaseString = strBaseString & "'          Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4356:   strBaseString = strBaseString & "'" & vbNewLine
4357:   strBaseString = strBaseString & "'          If InStr(1, strValue, ""DIV STYLE"", vbTextCompare) > 0 Then" & vbNewLine
4358:   strBaseString = strBaseString & "'            strFullDescription = strFullDescription & _" & vbNewLine
4359:   strBaseString = strBaseString & "'                ""<P><SPAN STYLE=""""font-weight:bold;"""">Description for "" & strFClassName & _" & vbNewLine
4360:   strBaseString = strBaseString & "'                "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>""" & vbNewLine
4361:   strBaseString = strBaseString & "'          Else" & vbNewLine
4362:   strBaseString = strBaseString & "'" & vbNewLine
4363:   strBaseString = strBaseString & "'            strFullDescription = strFullDescription & _" & vbNewLine
4364:   strBaseString = strBaseString & "'                ""<P><SPAN STYLE=""""font-weight:bold;"""">Description for "" & strFClassName & _" & vbNewLine
4365:   strBaseString = strBaseString & "'                "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>""" & vbNewLine
4366:   strBaseString = strBaseString & "'          End If" & vbNewLine
4367:   strBaseString = strBaseString & "'" & vbNewLine
4368:   strBaseString = strBaseString & "'        Next lngIndex" & vbNewLine
4369:   strBaseString = strBaseString & "'      End If" & vbNewLine
4370:   strBaseString = strBaseString & "    Else" & vbNewLine
4371:   strBaseString = strBaseString & "      For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4372:   strBaseString = strBaseString & "        strValue = CStr(varAtts(lngIndex))" & vbNewLine
4373:   strBaseString = strBaseString & "        strValue = RemoveTags(strValue)" & vbNewLine
4374:   strBaseString = strBaseString & "'        Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4375:   strBaseString = strBaseString & " " & vbNewLine
4376:   strBaseString = strBaseString & "        strFullCredits = strFullCredits & _" & vbNewLine
4377:   strBaseString = strBaseString & "            ""<P><SPAN STYLE=""""font-weight:bold;"""">Credits for "" & strFClassName & _" & vbNewLine
4378:   strBaseString = strBaseString & "            "":  </SPAN><SPAN> "" & strValue & "".       </SPAN></P>""" & vbNewLine
4379:   strBaseString = strBaseString & " " & vbNewLine
4380:   strBaseString = strBaseString & "      Next lngIndex" & vbNewLine
4381:   strBaseString = strBaseString & "    End If" & vbNewLine
4382:   strBaseString = strBaseString & "  Next lngPropSetIndex" & vbNewLine
4383:   strBaseString = strBaseString & " " & vbNewLine
4384:   strBaseString = strBaseString & "  strFullCredits = Replace(strFullCredits, ""TrasnportationLine"", ""TransportationLine"", , , vbTextCompare)" & vbNewLine
4385:   strBaseString = strBaseString & "  strFullCredits = strFullCredits & ""</DIV></DIV>""" & vbNewLine
4386:   strBaseString = strBaseString & " " & vbNewLine
4387:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strCreditString)" & vbNewLine
4388:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4389:   strBaseString = strBaseString & "    pPropSet.RemoveProperty strCreditString" & vbNewLine
4390:   strBaseString = strBaseString & "  End If" & vbNewLine
4391:   strBaseString = strBaseString & " " & vbNewLine
4392:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strCreditString)" & vbNewLine
4393:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4394:   strBaseString = strBaseString & "    If UBound(varAtts) = 0 Then" & vbNewLine
4395:   strBaseString = strBaseString & "      pPropSet.SetProperty strCreditString, strFullCredits" & vbNewLine
4396:   strBaseString = strBaseString & "    End If" & vbNewLine
4397:   strBaseString = strBaseString & "  Else" & vbNewLine
4398:   strBaseString = strBaseString & "    pPropSet.SetProperty strCreditString, strFullCredits" & vbNewLine
4399:   strBaseString = strBaseString & "  End If" & vbNewLine
4400:   strBaseString = strBaseString & "'" & vbNewLine
4401:   strBaseString = strBaseString & "'  Debug.Print ""Final Credits:""" & vbNewLine
4402:   strBaseString = strBaseString & "'  Debug.Print strFullCredits" & vbNewLine
4403:   strBaseString = strBaseString & "  'pPropSet.SetProperty strSummaryString & strfinalsummary" & vbNewLine
4404:   strBaseString = strBaseString & " " & vbNewLine
4405:   strBaseString = strBaseString & "   " & vbNewLine
4406:   strBaseString = strBaseString & " " & vbNewLine
4407:   strBaseString = strBaseString & "  ' ---------------------------------------------------------------------------------------------" & vbNewLine
4408:   strBaseString = strBaseString & "  ' SET DESCRIPTIONS" & vbNewLine
  strBaseString = strBaseString & "  Dim strFullDescription As String" & vbNewLine
4410:   strBaseString = strBaseString & "  strFullDescription = ""<DIV STYLE=""""text-align:Left;""""><DIV><P><SPAN>This feature class "" & _" & vbNewLine
4411:   strBaseString = strBaseString & "    ""compiles transportation features and attributes from "" & _" & vbNewLine
4412:   strBaseString = strBaseString & "    ""multiple feature classes (""""TransportationLine_UTM12_NAD83"""""" & _" & vbNewLine
4413:   strBaseString = strBaseString & "    """"""Roads_KNF_UTM12_NAD83"""", """"BLM_AZStrip_UTM12_NAD83"""", """"Roads_UTM12_NAD83"""", "" & _" & vbNewLine
4414:   strBaseString = strBaseString & "    """"""UTAH_Roads_Near_AOI_UTM12_NAD83"""", """"Routes_UTM12_NAD83"""", """"Trails_UTM12_NAD83"""", "" & _" & vbNewLine
4415:   strBaseString = strBaseString & "    """"""TIGER_2012_Trans_Near_Park_UTM12_NAD83"""" and """"UTAH_Roads_Near_AOI_UTM12_NAD83"""") into a "" & _" & vbNewLine
4416:   strBaseString = strBaseString & "    ""single comprehensive transportation dataset covering the Grand Canyon region.  Descriptions "" & _" & vbNewLine
4417:   strBaseString = strBaseString & "    ""for these contributor feature classes are listed below:</SPAN></P>""" & vbNewLine
4418:   strBaseString = strBaseString & " " & vbNewLine
4419:   strBaseString = strBaseString & "  For lngPropSetIndex = 0 To pNewFClassArray.Count - 1" & vbNewLine
4420:   strBaseString = strBaseString & "    strFClassName = strFClassNames(lngPropSetIndex)" & vbNewLine
4421:   strBaseString = strBaseString & "    Set pSubArray = pNewFClassArray.Element(lngPropSetIndex)" & vbNewLine
4422:   strBaseString = strBaseString & "    Set pContributorPropSet = pSubArray.Element(1)" & vbNewLine
4423:   strBaseString = strBaseString & " " & vbNewLine
4424:   strBaseString = strBaseString & "'    Debug.Print ""Descriptions for '"" & strFClassName & ""'""" & vbNewLine
4425:   strBaseString = strBaseString & "    varAtts = pContributorPropSet.GetProperty(strDescriptionString)" & vbNewLine
4426:   strBaseString = strBaseString & " " & vbNewLine
4427:   strBaseString = strBaseString & "    If IsEmpty(varAtts) Then" & vbNewLine
4428:   strBaseString = strBaseString & "      varAtts = pContributorPropSet.GetProperty(strAbstract)" & vbNewLine
4429:   strBaseString = strBaseString & " " & vbNewLine
4430:   strBaseString = strBaseString & "      If IsEmpty(varAtts) Then" & vbNewLine
4431:   strBaseString = strBaseString & "        strFullDescription = strFullDescription & _" & vbNewLine
4432:   strBaseString = strBaseString & "            ""<P><SPAN STYLE=""""font-weight:bold;"""">Description for "" & strFClassName & _" & vbNewLine
4433:   strBaseString = strBaseString & "            "":</SPAN><SPAN> &lt;-- No Description Available --&gt; </SPAN></P>""" & vbNewLine
4434:   strBaseString = strBaseString & "      Else" & vbNewLine
4435:   strBaseString = strBaseString & "        For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4436:   strBaseString = strBaseString & "          strValue = CStr(varAtts(lngIndex))" & vbNewLine
4437:   strBaseString = strBaseString & "          strValue = RemoveTags(strValue)" & vbNewLine
4438:   strBaseString = strBaseString & "'          Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4439:   strBaseString = strBaseString & " " & vbNewLine
4440:   strBaseString = strBaseString & "          If InStr(1, strValue, ""DIV STYLE"", vbTextCompare) > 0 Then" & vbNewLine
4441:   strBaseString = strBaseString & "            strFullDescription = strFullDescription & _" & vbNewLine
4442:   strBaseString = strBaseString & "                ""<P><SPAN STYLE=""""font-weight:bold;"""">Description for "" & strFClassName & _" & vbNewLine
4443:   strBaseString = strBaseString & "                "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>""" & vbNewLine
4444:   strBaseString = strBaseString & "          Else" & vbNewLine
4445:   strBaseString = strBaseString & " " & vbNewLine
4446:   strBaseString = strBaseString & "            strFullDescription = strFullDescription & _" & vbNewLine
4447:   strBaseString = strBaseString & "                ""<P><SPAN STYLE=""""font-weight:bold;"""">Description for "" & strFClassName & _" & vbNewLine
4448:   strBaseString = strBaseString & "                "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>""" & vbNewLine
4449:   strBaseString = strBaseString & "          End If" & vbNewLine
4450:   strBaseString = strBaseString & " " & vbNewLine
4451:   strBaseString = strBaseString & "        Next lngIndex" & vbNewLine
4452:   strBaseString = strBaseString & "      End If" & vbNewLine
4453:   strBaseString = strBaseString & "    Else" & vbNewLine
4454:   strBaseString = strBaseString & "      For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4455:   strBaseString = strBaseString & "        strValue = CStr(varAtts(lngIndex))" & vbNewLine
4456:   strBaseString = strBaseString & "        strValue = RemoveTags(strValue)" & vbNewLine
4457:   strBaseString = strBaseString & "'        Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4458:   strBaseString = strBaseString & " " & vbNewLine
4459:   strBaseString = strBaseString & "        strFullDescription = strFullDescription & _" & vbNewLine
4460:   strBaseString = strBaseString & "            ""<P><SPAN STYLE=""""font-weight:bold;"""">Description for "" & strFClassName & _" & vbNewLine
4461:   strBaseString = strBaseString & "            "":  </SPAN><SPAN> "" & strValue & ""</SPAN></P>""" & vbNewLine
4462:   strBaseString = strBaseString & " " & vbNewLine
4463:   strBaseString = strBaseString & "      Next lngIndex" & vbNewLine
4464:   strBaseString = strBaseString & "    End If" & vbNewLine
4465:   strBaseString = strBaseString & "  Next lngPropSetIndex" & vbNewLine
4466:   strBaseString = strBaseString & " " & vbNewLine
4467:   strBaseString = strBaseString & "  strFullDescription = Replace(strFullDescription, ""TrasnportationLine"", ""TransportationLine"", , , vbTextCompare)" & vbNewLine
4468:   strBaseString = strBaseString & "  strFullDescription = strFullDescription & ""</DIV></DIV>""" & vbNewLine
4469:   strBaseString = strBaseString & " " & vbNewLine
4470:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strDescriptionString)" & vbNewLine
4471:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4472:   strBaseString = strBaseString & "    pPropSet.RemoveProperty strDescriptionString" & vbNewLine
4473:   strBaseString = strBaseString & "  End If" & vbNewLine
4474:   strBaseString = strBaseString & " " & vbNewLine
4475:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strDescriptionString)" & vbNewLine
4476:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4477:   strBaseString = strBaseString & "    If UBound(varAtts) = 0 Then" & vbNewLine
4478:   strBaseString = strBaseString & "      pPropSet.SetProperty strDescriptionString, strFullDescription" & vbNewLine
4479:   strBaseString = strBaseString & "    End If" & vbNewLine
4480:   strBaseString = strBaseString & "  Else" & vbNewLine
4481:   strBaseString = strBaseString & "    pPropSet.SetProperty strDescriptionString, strFullDescription" & vbNewLine
4482:   strBaseString = strBaseString & "  End If" & vbNewLine
4483:   strBaseString = strBaseString & " " & vbNewLine
4484:   strBaseString = strBaseString & "'" & vbNewLine
4485:   strBaseString = strBaseString & "'  Debug.Print ""Final Description:""" & vbNewLine
4486:   strBaseString = strBaseString & "'  Debug.Print strFullDescription" & vbNewLine
4487:   strBaseString = strBaseString & "  'pPropSet.SetProperty strSummaryString & strfinalsummary" & vbNewLine
4488:   strBaseString = strBaseString & " " & vbNewLine
4489:   strBaseString = strBaseString & "  ' ---------------------------------------------------------------------------------------------" & vbNewLine
4490:   strBaseString = strBaseString & "   ' SET SUMMARIES" & vbNewLine
  strBaseString = strBaseString & "  Dim pSummaries As esriSystem.IStringArray" & vbNewLine
4492:   strBaseString = strBaseString & "  Set pSummaries = New esriSystem.strArray" & vbNewLine
  strBaseString = strBaseString & "  Dim strFullSummary As String" & vbNewLine
4494:   strBaseString = strBaseString & " " & vbNewLine
4495:   strBaseString = strBaseString & "  For lngPropSetIndex = 0 To pNewFClassArray.Count - 1" & vbNewLine
4496:   strBaseString = strBaseString & "    strFClassName = strFClassNames(lngPropSetIndex)" & vbNewLine
4497:   strBaseString = strBaseString & "    Set pSubArray = pNewFClassArray.Element(lngPropSetIndex)" & vbNewLine
4498:   strBaseString = strBaseString & "    Set pContributorPropSet = pSubArray.Element(1)" & vbNewLine
4499:   strBaseString = strBaseString & " " & vbNewLine
4500:   strBaseString = strBaseString & "'    Debug.Print ""Summaries for '"" & strFClassName & ""'""" & vbNewLine
4501:   strBaseString = strBaseString & "    varAtts = pContributorPropSet.GetProperty(strSummaryString)" & vbNewLine
4502:   strBaseString = strBaseString & " " & vbNewLine
4503:   strBaseString = strBaseString & "    If Not IsEmpty(varAtts) Then" & vbNewLine
4504:   strBaseString = strBaseString & "      For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4505:   strBaseString = strBaseString & "        strValue = CStr(varAtts(lngIndex))" & vbNewLine
4506:   strBaseString = strBaseString & "'        Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4507:   strBaseString = strBaseString & " " & vbNewLine
4508:   strBaseString = strBaseString & "        strFullSummary = strFullSummary & ""<b>Summary for "" & strFClassName & "":</b>"" & _" & vbNewLine
4509:   strBaseString = strBaseString & "            vbLf & ""<p>"" & strValue & ""</p>"" & vbLf & vbLf" & vbNewLine
4510:   strBaseString = strBaseString & " " & vbNewLine
4511:   strBaseString = strBaseString & "      Next lngIndex" & vbNewLine
4512:   strBaseString = strBaseString & "    End If" & vbNewLine
4513:   strBaseString = strBaseString & "  Next lngPropSetIndex" & vbNewLine
4514:   strBaseString = strBaseString & " " & vbNewLine
4515:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strSummaryString)" & vbNewLine
4516:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4517:   strBaseString = strBaseString & "    pPropSet.RemoveProperty strSummaryString" & vbNewLine
4518:   strBaseString = strBaseString & "  End If" & vbNewLine
4519:   strBaseString = strBaseString & " " & vbNewLine
4520:   strBaseString = strBaseString & "  ' ****** Summary can't be broken up into paragraphs!  Rewrite a single one from scratch..." & vbNewLine
4521:   strBaseString = strBaseString & "  strFullSummary = ""<DIV STYLE=""""text-align:Left;""""><DIV><P><SPAN>"" & _" & vbNewLine
4522:   strBaseString = strBaseString & "    ""This feature class compiles transportation features and attributes from "" & _" & vbNewLine
4523:   strBaseString = strBaseString & "    ""multiple feature classes into a single comprehensive transportation dataset covering the "" & _" & vbNewLine
4524:   strBaseString = strBaseString & "    ""Grand Canyon region.  Features are extracted primarily from the Grand Canyon National Park "" & _" & vbNewLine
4525:   strBaseString = strBaseString & "    """"""TransportationLine_UTM12_NAD83"""" feature class, and supplemented with features from "" & _" & vbNewLine
4526:   strBaseString = strBaseString & "    """"""Roads_KNF_UTM12_NAD83"""", """"BLM_AZStrip_UTM12_NAD83"""", """"Roads_UTM12_NAD83"""", "" & _" & vbNewLine
4527:   strBaseString = strBaseString & "    """"""UTAH_Roads_Near_AOI_UTM12_NAD83"""", """"Routes_UTM12_NAD83"""", """"Trails_UTM12_NAD83"""", "" & _" & vbNewLine
4528:   strBaseString = strBaseString & "    """"""TIGER_2012_Trans_Near_Park_UTM12_NAD83"""" and """"UTAH_Roads_Near_AOI_UTM12_NAD83"""".</SPAN></P>"" & _" & vbNewLine
4529:   strBaseString = strBaseString & "    ""<P><SPAN>Additional "" & _" & vbNewLine
4530:   strBaseString = strBaseString & "    ""attributes describing the transportation feature name, type, surface type and use level "" & _" & vbNewLine
4531:   strBaseString = strBaseString & "    ""were extracted from these feature classes based on proximity to the centroid of each feature.  "" & _" & vbNewLine
4532:   strBaseString = strBaseString & "    ""See descriptions of each attribute field for more detailed definitions of the attributes and "" & _" & vbNewLine
4533:   strBaseString = strBaseString & "    ""how the values were determined..</SPAN></P>"" & _" & vbNewLine
4534:   strBaseString = strBaseString & "    ""<P><SPAN>Process Steps and Lineage detailed below are extracted from "" & _" & vbNewLine
4535:   strBaseString = strBaseString & "    """"""TransportationLine_UTM12_NAD83""""</SPAN></P></DIV></DIV>""" & vbNewLine
4536:   strBaseString = strBaseString & " " & vbNewLine
4537:   strBaseString = strBaseString & "  strFullSummary = Replace(strFullSummary, ""TrasnportationLine"", ""TransportationLine"", , , vbTextCompare)" & vbNewLine
4538:   strBaseString = strBaseString & " " & vbNewLine
4539:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strSummaryString)" & vbNewLine
4540:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4541:   strBaseString = strBaseString & "    If UBound(varAtts) = 0 Then" & vbNewLine
4542:   strBaseString = strBaseString & "      pPropSet.SetProperty strSummaryString, strFullSummary" & vbNewLine
4543:   strBaseString = strBaseString & "    End If" & vbNewLine
4544:   strBaseString = strBaseString & "  Else" & vbNewLine
4545:   strBaseString = strBaseString & "    pPropSet.SetProperty strSummaryString, strFullSummary" & vbNewLine
4546:   strBaseString = strBaseString & "  End If" & vbNewLine
4547:   strBaseString = strBaseString & " " & vbNewLine
4548:   strBaseString = strBaseString & "'  Debug.Print ""Final Summary:""" & vbNewLine
4549:   strBaseString = strBaseString & "'  Debug.Print strFullSummary" & vbNewLine
4550:   strBaseString = strBaseString & "  'pPropSet.SetProperty strSummaryString & strfinalsummary" & vbNewLine
4551:   strBaseString = strBaseString & " " & vbNewLine
4552:   strBaseString = strBaseString & "  ' SET KEYWORDS" & vbNewLine
  strBaseString = strBaseString & "  Dim pKeyWords As esriSystem.IStringArray" & vbNewLine
4554:   strBaseString = strBaseString & "  Set pKeyWords = New esriSystem.strArray" & vbNewLine
  strBaseString = strBaseString & "  Dim pKeyWordColl As Collection" & vbNewLine
4556:   strBaseString = strBaseString & "  Set pKeyWordColl = New Collection" & vbNewLine
4557:   strBaseString = strBaseString & " " & vbNewLine
4558:   strBaseString = strBaseString & "  For lngPropSetIndex = 0 To pNewFClassArray.Count - 1" & vbNewLine
4559:   strBaseString = strBaseString & "    strFClassName = strFClassNames(lngPropSetIndex)" & vbNewLine
4560:   strBaseString = strBaseString & "    Set pSubArray = pNewFClassArray.Element(lngPropSetIndex)" & vbNewLine
4561:   strBaseString = strBaseString & "    Set pContributorPropSet = pSubArray.Element(1)" & vbNewLine
4562:   strBaseString = strBaseString & " " & vbNewLine
4563:   strBaseString = strBaseString & "    If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pKeyWordColl, strFClassName) Then" & vbNewLine
4564:   strBaseString = strBaseString & "      pKeyWords.Add strFClassName" & vbNewLine
4565:   strBaseString = strBaseString & "      pKeyWordColl.Add True, strFClassName" & vbNewLine
4566:   strBaseString = strBaseString & "    End If" & vbNewLine
4567:   strBaseString = strBaseString & " " & vbNewLine
4568:   strBaseString = strBaseString & "'    Debug.Print ""Keywords for '"" & strFClassName & ""'""" & vbNewLine
4569:   strBaseString = strBaseString & "    varAtts = pContributorPropSet.GetProperty(strThemeKeywords)" & vbNewLine
4570:   strBaseString = strBaseString & " " & vbNewLine
4571:   strBaseString = strBaseString & "    If Not IsEmpty(varAtts) Then" & vbNewLine
4572:   strBaseString = strBaseString & "      For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4573:   strBaseString = strBaseString & "        strValue = CStr(varAtts(lngIndex))" & vbNewLine
4574:   strBaseString = strBaseString & "'        Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4575:   strBaseString = strBaseString & " " & vbNewLine
4576:   strBaseString = strBaseString & "        If Not Linkages.MyGeneralOperations.CheckCollectionForKey(pKeyWordColl, strValue) Then" & vbNewLine
4577:   strBaseString = strBaseString & "          pKeyWords.Add strValue" & vbNewLine
4578:   strBaseString = strBaseString & "          pKeyWordColl.Add True, strValue" & vbNewLine
4579:   strBaseString = strBaseString & "        End If" & vbNewLine
4580:   strBaseString = strBaseString & " " & vbNewLine
4581:   strBaseString = strBaseString & "      Next lngIndex" & vbNewLine
4582:   strBaseString = strBaseString & "    End If" & vbNewLine
4583:   strBaseString = strBaseString & "  Next lngPropSetIndex" & vbNewLine
4584:   strBaseString = strBaseString & " " & vbNewLine
4585:   strBaseString = strBaseString & "  varAtts = pPropSet.GetProperty(strThemeKeywords)" & vbNewLine
4586:   strBaseString = strBaseString & "  If Not IsEmpty(varAtts) Then" & vbNewLine
4587:   strBaseString = strBaseString & "    pPropSet.RemoveProperty strThemeKeywords" & vbNewLine
4588:   strBaseString = strBaseString & "    pPropSet.RemoveProperty strSearchKeywords" & vbNewLine
4589:   strBaseString = strBaseString & "  End If" & vbNewLine
4590:   strBaseString = strBaseString & " " & vbNewLine
4591:   strBaseString = strBaseString & "'  Debug.Print ""Final Keywords:""" & vbNewLine
4592:   strBaseString = strBaseString & "  For lngIndex = 0 To pKeyWords.Count - 1" & vbNewLine
4593:   strBaseString = strBaseString & "    strValue = pKeyWords.Element(lngIndex)" & vbNewLine
4594:   strBaseString = strBaseString & "    pPropSet.SetProperty strThemeKeywords & ""["" & CStr(lngIndex) & ""]"", strValue" & vbNewLine
4595:   strBaseString = strBaseString & "    pPropSet.SetProperty strSearchKeywords & ""["" & CStr(lngIndex) & ""]"", strValue" & vbNewLine
4596:   strBaseString = strBaseString & "'    Debug.Print ""  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4597:   strBaseString = strBaseString & "  Next lngIndex" & vbNewLine
4598:   strBaseString = strBaseString & " " & vbNewLine
4599:   strBaseString = strBaseString & "'" & vbNewLine
4600:   strBaseString = strBaseString & "'  ' CHECK ABSTRACTS" & vbNewLine
4601:   strBaseString = strBaseString & "'  Debug.Print ""Abstracts...........""" & vbNewLine
4602:   strBaseString = strBaseString & "'  For lngPropSetIndex = 0 To pNewFClassArray.Count - 1" & vbNewLine
4603:   strBaseString = strBaseString & "'    strFClassName = strFClassNames(lngPropSetIndex)" & vbNewLine
4604:   strBaseString = strBaseString & "'    Set pSubArray = pNewFClassArray.Element(lngPropSetIndex)" & vbNewLine
4605:   strBaseString = strBaseString & "'    Set pContributorPropSet = pSubArray.Element(1)" & vbNewLine
4606:   strBaseString = strBaseString & "'" & vbNewLine
4607:   strBaseString = strBaseString & "'    Debug.Print ""Abstracts for '"" & strFClassName & ""'""" & vbNewLine
4608:   strBaseString = strBaseString & "'    varAtts = pContributorPropSet.GetProperty(strAbstract)" & vbNewLine
4609:   strBaseString = strBaseString & "'" & vbNewLine
4610:   strBaseString = strBaseString & "'    If IsEmpty(varAtts) Then" & vbNewLine
4611:   strBaseString = strBaseString & "'      Debug.Print ""..No Abstract""" & vbNewLine
4612:   strBaseString = strBaseString & "'    Else" & vbNewLine
4613:   strBaseString = strBaseString & "'      For lngIndex = 0 To UBound(varAtts)" & vbNewLine
4614:   strBaseString = strBaseString & "'        strValue = CStr(varAtts(lngIndex))" & vbNewLine
4615:   strBaseString = strBaseString & "'        Debug.Print ""..Abstract =  "" & CStr(lngIndex) & ""] "" & strValue" & vbNewLine
4616:   strBaseString = strBaseString & "'" & vbNewLine
4617:   strBaseString = strBaseString & "'      Next lngIndex" & vbNewLine
4618:   strBaseString = strBaseString & "'    End If" & vbNewLine
4619:   strBaseString = strBaseString & "'  Next lngPropSetIndex" & vbNewLine
4620:   strBaseString = strBaseString & " " & vbNewLine
4621:   strBaseString = strBaseString & " " & vbNewLine
4622:   strBaseString = strBaseString & "ClearMemory:" & vbNewLine
4623:   strBaseString = strBaseString & "  Set pRoads_KNF_UTM12_NAD83_FClass = Nothing" & vbNewLine
4624:   strBaseString = strBaseString & "  Set pTIGER_2012_Trans_Near_Park_UTM12_NAD83_FClass = Nothing" & vbNewLine
4625:   strBaseString = strBaseString & "  Set pBLM_AZStrip_UTM12_NAD83_FClass = Nothing" & vbNewLine
4626:   strBaseString = strBaseString & "  Set pRoads_UTM12_NAD83_FClass = Nothing" & vbNewLine
4627:   strBaseString = strBaseString & "  Set pTrails_UTM12_NAD83_FClass = Nothing" & vbNewLine
4628:   strBaseString = strBaseString & "  Set pRoutes_UTM12_NAD83_FClass = Nothing" & vbNewLine
4629:   strBaseString = strBaseString & "  Set pUtah_Roads_Near_AOI_UTM12_NAD83_FClass = Nothing" & vbNewLine
4630:   strBaseString = strBaseString & "  Set pTrails_KNF_UTM12_NAD83_FClass = Nothing" & vbNewLine
4631:   strBaseString = strBaseString & "  Set pTransportationLine_UTM12_NAD83_FClass = Nothing" & vbNewLine
4632:   strBaseString = strBaseString & "  Set pRoads_KNF_UTM12_NAD83_PropSet = Nothing" & vbNewLine
4633:   strBaseString = strBaseString & "  Set pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet = Nothing" & vbNewLine
4634:   strBaseString = strBaseString & "  Set pBLM_AZStrip_UTM12_NAD83_PropSet = Nothing" & vbNewLine
4635:   strBaseString = strBaseString & "  Set pRoads_UTM12_NAD83_PropSet = Nothing" & vbNewLine
4636:   strBaseString = strBaseString & "  Set pTrails_UTM12_NAD83_PropSet = Nothing" & vbNewLine
4637:   strBaseString = strBaseString & "  Set pRoutes_UTM12_NAD83_PropSet = Nothing" & vbNewLine
4638:   strBaseString = strBaseString & "  Set pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet = Nothing" & vbNewLine
4639:   strBaseString = strBaseString & "  Set pTrails_KNF_UTM12_NAD83_PropSet = Nothing" & vbNewLine
4640:   strBaseString = strBaseString & "  Set pTransportationLine_UTM12_NAD83_PropSet = Nothing" & vbNewLine
4641:   strBaseString = strBaseString & "  Set pXMLPropSet = Nothing" & vbNewLine
4642:   strBaseString = strBaseString & "  Set pSubArray = Nothing" & vbNewLine
4643:   strBaseString = strBaseString & "  Set pNewFClassArray = Nothing" & vbNewLine
4644:   strBaseString = strBaseString & "  Set pContributorPropSet = Nothing" & vbNewLine
4645:   strBaseString = strBaseString & "  Erase strFClassNames" & vbNewLine
4646:   strBaseString = strBaseString & "  Set pXMLPropSet = Nothing" & vbNewLine
4647:   strBaseString = strBaseString & "  Set pSummaries = Nothing" & vbNewLine
4648:   strBaseString = strBaseString & "  Set pKeyWords = Nothing" & vbNewLine
4649:   strBaseString = strBaseString & "  Set pKeyWordColl = Nothing" & vbNewLine
4650:   strBaseString = strBaseString & " " & vbNewLine
4651:   strBaseString = strBaseString & " " & vbNewLine
4652:   strBaseString = strBaseString & " " & vbNewLine
4653:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "End Sub" & vbNewLine
4655:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "Public Sub TestRemoveTags()" & vbNewLine
4657:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strtest As String" & vbNewLine
4659:   strBaseString = strBaseString & "  strtest = ""Hello <> Dolly<>test""" & vbNewLine
4660:   strBaseString = strBaseString & " " & vbNewLine
4661:   strBaseString = strBaseString & "'  strTest = """"" & vbNewLine
4662:   strBaseString = strBaseString & " " & vbNewLine
4663:   strBaseString = strBaseString & "  Debug.Print RemoveTags(strtest)" & vbNewLine
4664:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "End Sub" & vbNewLine
4666:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "Public Function RemoveTags(strString) As String" & vbNewLine
4668:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim lngIndex As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim lngEndIndex As Long" & vbNewLine
4671:   strBaseString = strBaseString & "  RemoveTags = strString" & vbNewLine
4672:   strBaseString = strBaseString & " " & vbNewLine
4673:   strBaseString = strBaseString & "  lngIndex = InStr(1, RemoveTags, ""<"")" & vbNewLine
4674:   strBaseString = strBaseString & " " & vbNewLine
4675:   strBaseString = strBaseString & "  Do Until lngIndex = 0" & vbNewLine
4676:   strBaseString = strBaseString & "    lngEndIndex = InStr(lngIndex, RemoveTags, "">"")" & vbNewLine
4677:   strBaseString = strBaseString & "    RemoveTags = Left(RemoveTags, lngIndex - 1) & Right(RemoveTags, Len(RemoveTags) - lngEndIndex)" & vbNewLine
4678:   strBaseString = strBaseString & " " & vbNewLine
4679:   strBaseString = strBaseString & "    lngIndex = InStr(1, RemoveTags, ""<"")" & vbNewLine
4680:   strBaseString = strBaseString & "  Loop" & vbNewLine
4681:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "End Function" & vbNewLine
4683:   strBaseString = strBaseString & " " & vbNewLine
4684:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "Public Sub ReplaceOrAddDescription(pPropSet As IPropertySet, lngFieldIndex As Long, _" & vbNewLine
4686:   strBaseString = strBaseString & "    pFClassArray As esriSystem.IArray)" & vbNewLine
4687:   strBaseString = strBaseString & " " & vbNewLine
4688:   strBaseString = strBaseString & "'  Debug.Print ""Set definition sources for all fields!""" & vbNewLine
4689:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim pRoads_KNF_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pTIGER_2012_Trans_Near_Park_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pBLM_AZStrip_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pRoads_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pTrails_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pRoutes_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pUtah_Roads_Near_AOI_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pTrails_KNF_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
  strBaseString = strBaseString & "  Dim pTransportationLine_UTM12_NAD83_FClass As IFeatureClass" & vbNewLine
4699:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim pRoads_KNF_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pBLM_AZStrip_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pRoads_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pTrails_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pRoutes_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pTrails_KNF_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
  strBaseString = strBaseString & "  Dim pTransportationLine_UTM12_NAD83_PropSet As IPropertySet" & vbNewLine
4709:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim pSubArray As esriSystem.IArray" & vbNewLine
4711:   strBaseString = strBaseString & " " & vbNewLine
4712:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(0)" & vbNewLine
4713:   strBaseString = strBaseString & "  Set pRoads_KNF_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
4714:   strBaseString = strBaseString & "  Set pRoads_KNF_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
4715:   strBaseString = strBaseString & " " & vbNewLine
4716:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(1)" & vbNewLine
4717:   strBaseString = strBaseString & "  Set pTIGER_2012_Trans_Near_Park_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
4718:   strBaseString = strBaseString & "  Set pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
4719:   strBaseString = strBaseString & " " & vbNewLine
4720:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(2)" & vbNewLine
4721:   strBaseString = strBaseString & "  Set pBLM_AZStrip_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
4722:   strBaseString = strBaseString & "  Set pBLM_AZStrip_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
4723:   strBaseString = strBaseString & " " & vbNewLine
4724:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(3)" & vbNewLine
4725:   strBaseString = strBaseString & "  Set pRoads_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
4726:   strBaseString = strBaseString & "  Set pRoads_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
4727:   strBaseString = strBaseString & " " & vbNewLine
4728:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(4)" & vbNewLine
4729:   strBaseString = strBaseString & "  Set pTrails_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
4730:   strBaseString = strBaseString & "  Set pTrails_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
4731:   strBaseString = strBaseString & " " & vbNewLine
4732:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(5)" & vbNewLine
4733:   strBaseString = strBaseString & "  Set pRoutes_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
4734:   strBaseString = strBaseString & "  Set pRoutes_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
4735:   strBaseString = strBaseString & " " & vbNewLine
4736:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(6)" & vbNewLine
4737:   strBaseString = strBaseString & "  Set pUtah_Roads_Near_AOI_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
4738:   strBaseString = strBaseString & "  Set pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
4739:   strBaseString = strBaseString & " " & vbNewLine
4740:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(7)" & vbNewLine
4741:   strBaseString = strBaseString & "  Set pTrails_KNF_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
4742:   strBaseString = strBaseString & "  Set pTrails_KNF_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
4743:   strBaseString = strBaseString & " " & vbNewLine
4744:   strBaseString = strBaseString & "  Set pSubArray = pFClassArray.Element(8)" & vbNewLine
4745:   strBaseString = strBaseString & "  Set pTransportationLine_UTM12_NAD83_FClass = pSubArray.Element(0)" & vbNewLine
4746:   strBaseString = strBaseString & "  Set pTransportationLine_UTM12_NAD83_PropSet = pSubArray.Element(1)" & vbNewLine
4747:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim lngIndex As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim lngIndex2 As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim varVals As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim varSubVals As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim strNames(0) As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strFieldName As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strDescription As String" & vbNewLine
  strBaseString = strBaseString & "  Dim varProperty As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim varSubProperty As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim strXName As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strProps As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strNewXName As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strOrigFClassXName As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strOrigFieldName As String" & vbNewLine
  strBaseString = strBaseString & "  Dim varCheckPropertyPresent As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim varSubProp1 As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim varSubProp2 As Variant" & vbNewLine
  strBaseString = strBaseString & "  Dim lngIndex3 As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim lngIndex4 As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim strSubXName1 As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strSubXName2 As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strSubXName3 As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strDescriptionSource As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strValue As String" & vbNewLine
4772:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strBLMObsArray() As String" & vbNewLine
  strBaseString = strBaseString & "  ReDim strBLMObsArray(11, 1)" & vbNewLine
4775:   strBaseString = strBaseString & "  strBLMObsArray(0, 0) = ""BLM_OBS_USE1""" & vbNewLine
4776:   strBaseString = strBaseString & "  strBLMObsArray(0, 1) = ""OBS_USE1""" & vbNewLine
4777:   strBaseString = strBaseString & "  strBLMObsArray(1, 0) = ""BLM_OBS_USE2""" & vbNewLine
4778:   strBaseString = strBaseString & "  strBLMObsArray(1, 1) = ""OBS_USE2""" & vbNewLine
4779:   strBaseString = strBaseString & "  strBLMObsArray(2, 0) = ""BLM_OBS_USE3""" & vbNewLine
4780:   strBaseString = strBaseString & "  strBLMObsArray(2, 1) = ""OBS_USE3""" & vbNewLine
4781:   strBaseString = strBaseString & "  strBLMObsArray(3, 0) = ""BLM_Use_Level""" & vbNewLine
4782:   strBaseString = strBaseString & "  strBLMObsArray(3, 1) = ""USE_LEVEL""" & vbNewLine
4783:   strBaseString = strBaseString & "  strBLMObsArray(4, 0) = ""BLM_Surface_PR""" & vbNewLine
4784:   strBaseString = strBaseString & "  strBLMObsArray(4, 1) = ""SURFACE_PR""" & vbNewLine
4785:   strBaseString = strBaseString & "  strBLMObsArray(5, 0) = ""BLM_Road_No""" & vbNewLine
4786:   strBaseString = strBaseString & "  strBLMObsArray(5, 1) = ""ROAD_NO_""" & vbNewLine
4787:   strBaseString = strBaseString & "  strBLMObsArray(6, 0) = ""BLM_Road_Name""" & vbNewLine
4788:   strBaseString = strBaseString & "  strBLMObsArray(6, 1) = ""ROAD_NAME""" & vbNewLine
4789:   strBaseString = strBaseString & "  strBLMObsArray(7, 0) = ""BLM_Straying_P""" & vbNewLine
4790:   strBaseString = strBaseString & "  strBLMObsArray(7, 1) = ""STRAYING_P""" & vbNewLine
4791:   strBaseString = strBaseString & "  strBLMObsArray(8, 0) = ""BLM_Purpose""" & vbNewLine
4792:   strBaseString = strBaseString & "  strBLMObsArray(8, 1) = ""PURPOSE""" & vbNewLine
4793:   strBaseString = strBaseString & "  strBLMObsArray(9, 0) = ""BLM_Route_ID""" & vbNewLine
4794:   strBaseString = strBaseString & "  strBLMObsArray(9, 1) = ""ROUTE_ID""" & vbNewLine
4795:   strBaseString = strBaseString & "  strBLMObsArray(10, 0) = ""BLM_RMP92""" & vbNewLine
4796:   strBaseString = strBaseString & "  strBLMObsArray(10, 1) = ""RMP92""" & vbNewLine
4797:   strBaseString = strBaseString & "  strBLMObsArray(11, 0) = ""BLM_E_Map""" & vbNewLine
4798:   strBaseString = strBaseString & "  strBLMObsArray(11, 1) = ""E_MAP""" & vbNewLine
  strBaseString = strBaseString & "  Dim lngBLMIndex As Long" & vbNewLine
4800:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strKNF_RoadArray() As String" & vbNewLine
  strBaseString = strBaseString & "  ReDim strKNF_RoadArray(6, 1)" & vbNewLine
4803:   strBaseString = strBaseString & "  strKNF_RoadArray(0, 0) = ""KNF_ObjectID""" & vbNewLine
4804:   strBaseString = strBaseString & "  strKNF_RoadArray(0, 1) = ""OBJECTID""" & vbNewLine
4805:   strBaseString = strBaseString & "  strKNF_RoadArray(1, 0) = ""KNF_ID""" & vbNewLine
4806:   strBaseString = strBaseString & "  strKNF_RoadArray(1, 1) = ""ID""" & vbNewLine
4807:   strBaseString = strBaseString & "  strKNF_RoadArray(2, 0) = ""KNF_Name""" & vbNewLine
4808:   strBaseString = strBaseString & "  strKNF_RoadArray(2, 1) = ""NAME""" & vbNewLine
4809:   strBaseString = strBaseString & "  strKNF_RoadArray(3, 0) = ""KNF_Lanes""" & vbNewLine
4810:   strBaseString = strBaseString & "  strKNF_RoadArray(3, 1) = ""LANES""" & vbNewLine
4811:   strBaseString = strBaseString & "  strKNF_RoadArray(4, 0) = ""KNF_Surface_Type""" & vbNewLine
4812:   strBaseString = strBaseString & "  strKNF_RoadArray(4, 1) = ""SURFACE_TY""" & vbNewLine
4813:   strBaseString = strBaseString & "  strKNF_RoadArray(5, 0) = ""KNF_Oper_Maint""" & vbNewLine
4814:   strBaseString = strBaseString & "  strKNF_RoadArray(5, 1) = ""OPER_MAINT""" & vbNewLine
4815:   strBaseString = strBaseString & "  strKNF_RoadArray(6, 0) = ""KNF_Objective""" & vbNewLine
4816:   strBaseString = strBaseString & "  strKNF_RoadArray(6, 1) = ""OBJECTIVE_""" & vbNewLine
  strBaseString = strBaseString & "  Dim lngKNFIndex As Long" & vbNewLine
4818:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strTIG_RoadArray() As String" & vbNewLine
  strBaseString = strBaseString & "  ReDim strTIG_RoadArray(2, 1)" & vbNewLine
4821:   strBaseString = strBaseString & "  strTIG_RoadArray(0, 0) = ""TIG_MTFCC""" & vbNewLine
4822:   strBaseString = strBaseString & "  strTIG_RoadArray(0, 1) = ""MTFCC""" & vbNewLine
4823:   strBaseString = strBaseString & "  strTIG_RoadArray(1, 0) = ""TIG_FULLNAME""" & vbNewLine
4824:   strBaseString = strBaseString & "  strTIG_RoadArray(1, 1) = ""FULLNAME""" & vbNewLine
4825:   strBaseString = strBaseString & "  strTIG_RoadArray(2, 0) = ""TIG_MT_Fclass""" & vbNewLine
4826:   strBaseString = strBaseString & "  strTIG_RoadArray(2, 1) = ""MT_FClass""" & vbNewLine
  strBaseString = strBaseString & "  Dim lngTIGIndex As Long" & vbNewLine
4828:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strROADS_RoadArray() As String" & vbNewLine
  strBaseString = strBaseString & "  ReDim strROADS_RoadArray(4, 1)" & vbNewLine
4831:   strBaseString = strBaseString & "  strROADS_RoadArray(0, 0) = ""ROADS_RoadName""" & vbNewLine
4832:   strBaseString = strBaseString & "  strROADS_RoadArray(0, 1) = ""RoadName""" & vbNewLine
4833:   strBaseString = strBaseString & "  strROADS_RoadArray(1, 0) = ""ROADS_FMSS_ID""" & vbNewLine
4834:   strBaseString = strBaseString & "  strROADS_RoadArray(1, 1) = ""FMSS_ID""" & vbNewLine
4835:   strBaseString = strBaseString & "  strROADS_RoadArray(2, 0) = ""ROADS_SurfaceMaterial""" & vbNewLine
4836:   strBaseString = strBaseString & "  strROADS_RoadArray(2, 1) = ""SurfaceMaterial""" & vbNewLine
4837:   strBaseString = strBaseString & "  strROADS_RoadArray(3, 0) = ""ROADS_Status""" & vbNewLine
4838:   strBaseString = strBaseString & "  strROADS_RoadArray(3, 1) = ""Status""" & vbNewLine
4839:   strBaseString = strBaseString & "  strROADS_RoadArray(4, 0) = ""ROADS_Compendium""" & vbNewLine
4840:   strBaseString = strBaseString & "  strROADS_RoadArray(4, 1) = ""Compendium""" & vbNewLine
  strBaseString = strBaseString & "  Dim lngRoads_Index As Long" & vbNewLine
4842:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strTrails_RoadArray() As String" & vbNewLine
  strBaseString = strBaseString & "  ReDim strTrails_RoadArray(2, 1)" & vbNewLine
4845:   strBaseString = strBaseString & "  strTrails_RoadArray(0, 0) = ""TRAILS_TrailName""" & vbNewLine
4846:   strBaseString = strBaseString & "  strTrails_RoadArray(0, 1) = ""TrailName""" & vbNewLine
4847:   strBaseString = strBaseString & "  strTrails_RoadArray(1, 0) = ""TRAILS_FMSS_ID""" & vbNewLine
4848:   strBaseString = strBaseString & "  strTrails_RoadArray(1, 1) = ""FMSS_ID""" & vbNewLine
4849:   strBaseString = strBaseString & "  strTrails_RoadArray(2, 0) = ""TRAILS_SurfaceMaterial""" & vbNewLine
4850:   strBaseString = strBaseString & "  strTrails_RoadArray(2, 1) = ""SurfaceMaterial""" & vbNewLine
  strBaseString = strBaseString & "  Dim lngTrails_Index As Long" & vbNewLine
4852:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strRoutes_RoadArray() As String" & vbNewLine
  strBaseString = strBaseString & "  ReDim strRoutes_RoadArray(2, 1)" & vbNewLine
4855:   strBaseString = strBaseString & "  strRoutes_RoadArray(0, 0) = ""ROUTES_RouteName""" & vbNewLine
4856:   strBaseString = strBaseString & "  strRoutes_RoadArray(0, 1) = ""RouteName""" & vbNewLine
  strBaseString = strBaseString & "  Dim lngRoutes_Index As Long" & vbNewLine
4858:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strUtah_RoadArray() As String" & vbNewLine
  strBaseString = strBaseString & "  ReDim strUtah_RoadArray(3, 1)" & vbNewLine
4861:   strBaseString = strBaseString & "  strUtah_RoadArray(0, 0) = ""UTAH_FullName""" & vbNewLine
4862:   strBaseString = strBaseString & "  strUtah_RoadArray(0, 1) = ""FULLNAME""" & vbNewLine
4863:   strBaseString = strBaseString & "  strUtah_RoadArray(1, 0) = ""UTAH_Alias1""" & vbNewLine
4864:   strBaseString = strBaseString & "  strUtah_RoadArray(1, 1) = ""ALIAS1""" & vbNewLine
4865:   strBaseString = strBaseString & "  strUtah_RoadArray(2, 0) = ""UTAH_SurfType""" & vbNewLine
4866:   strBaseString = strBaseString & "  strUtah_RoadArray(2, 1) = ""SURFTYPE""" & vbNewLine
4867:   strBaseString = strBaseString & "  strUtah_RoadArray(3, 0) = ""UTAH_SurfWidth""" & vbNewLine
4868:   strBaseString = strBaseString & "  strUtah_RoadArray(3, 1) = ""SURFWIDTH""" & vbNewLine
  strBaseString = strBaseString & "  Dim lngUtah_Index As Long" & vbNewLine
4870:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "  Dim strKNFTR_RoadArray() As String" & vbNewLine
  strBaseString = strBaseString & "  ReDim strKNFTR_RoadArray(6, 1)" & vbNewLine
4873:   strBaseString = strBaseString & "  strKNFTR_RoadArray(0, 0) = ""KNFTR_ID""" & vbNewLine
4874:   strBaseString = strBaseString & "  strKNFTR_RoadArray(0, 1) = ""ID""" & vbNewLine
4875:   strBaseString = strBaseString & "  strKNFTR_RoadArray(1, 0) = ""KNFTR_Name""" & vbNewLine
4876:   strBaseString = strBaseString & "  strKNFTR_RoadArray(1, 1) = ""NAME""" & vbNewLine
4877:   strBaseString = strBaseString & "  strKNFTR_RoadArray(2, 0) = ""KNFTR_Trail_Type""" & vbNewLine
4878:   strBaseString = strBaseString & "  strKNFTR_RoadArray(2, 1) = ""TRAIL_TYPE""" & vbNewLine
4879:   strBaseString = strBaseString & "  strKNFTR_RoadArray(3, 0) = ""KNFTR_Designed_Use""" & vbNewLine
4880:   strBaseString = strBaseString & "  strKNFTR_RoadArray(3, 1) = ""DESIGNED_U""" & vbNewLine
4881:   strBaseString = strBaseString & "  strKNFTR_RoadArray(4, 0) = ""KNFTR_Trail_Class""" & vbNewLine
4882:   strBaseString = strBaseString & "  strKNFTR_RoadArray(4, 1) = ""TRAIL_CLAS""" & vbNewLine
4883:   strBaseString = strBaseString & "  strKNFTR_RoadArray(5, 0) = ""KNFTR_Trail_Surface""" & vbNewLine
4884:   strBaseString = strBaseString & "  strKNFTR_RoadArray(5, 1) = ""TRAIL_SURF""" & vbNewLine
  strBaseString = strBaseString & "  Dim lngKNFTR_Index As Long" & vbNewLine
  strBaseString = strBaseString & "  Dim strXNameSource As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strXDomMin As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strXDomMax As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strXDomUnits As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strXDom As String" & vbNewLine
  strBaseString = strBaseString & "  Dim strXUDom As String" & vbNewLine
  strBaseString = strBaseString & "  Dim varSource As Variant" & vbNewLine
4893:   strBaseString = strBaseString & " " & vbNewLine
4894:   strBaseString = strBaseString & "  ' GET FIELD NAME" & vbNewLine
4895:   strBaseString = strBaseString & "  strXName = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrlabl""" & vbNewLine
4896:   strBaseString = strBaseString & "  varProperty = pPropSet.GetProperty(strXName)" & vbNewLine
4897:   strBaseString = strBaseString & "  If Not IsEmpty(varProperty) Then" & vbNewLine
4898:   strBaseString = strBaseString & "    varSubProperty = varProperty(0)" & vbNewLine
4899:   strBaseString = strBaseString & "    If IsEmpty(varSubProperty) Then" & vbNewLine
4900:   strBaseString = strBaseString & "      strFieldName = ""<-- No Field Name -->""" & vbNewLine
4901:   strBaseString = strBaseString & "    Else" & vbNewLine
4902:   strBaseString = strBaseString & "      strFieldName = CStr(varSubProperty)" & vbNewLine
4903:   strBaseString = strBaseString & "    End If" & vbNewLine
4904:   strBaseString = strBaseString & "  Else" & vbNewLine
4905:   strBaseString = strBaseString & "    strFieldName = ""<-- No Field Name -->""" & vbNewLine
4906:   strBaseString = strBaseString & "  End If" & vbNewLine
4907:   strBaseString = strBaseString & " " & vbNewLine
4908:   strBaseString = strBaseString & "  ' GET CURRENT DESCRIPTION" & vbNewLine
4909:   strBaseString = strBaseString & " " & vbNewLine
4910:   strBaseString = strBaseString & "  strXName = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef""" & vbNewLine
4911:   strBaseString = strBaseString & "  strXNameSource = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs""" & vbNewLine
4912:   strBaseString = strBaseString & "  strXDomMin = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/rdom/rdommin""" & vbNewLine
4913:   strBaseString = strBaseString & "  strXDomMax = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/rdom/rdommax""" & vbNewLine
4914:   strBaseString = strBaseString & "  strXDomUnits = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/rdom/attrunit""" & vbNewLine
4915:   strBaseString = strBaseString & "  strXDom = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv""" & vbNewLine
4916:   strBaseString = strBaseString & "  strXUDom = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/udom""" & vbNewLine
4917:   strBaseString = strBaseString & " " & vbNewLine
4918:   strBaseString = strBaseString & "  varProperty = pPropSet.GetProperty(strXName)" & vbNewLine
4919:   strBaseString = strBaseString & "  If Not IsEmpty(varProperty) Then" & vbNewLine
4920:   strBaseString = strBaseString & "    varSubProperty = varProperty(0)" & vbNewLine
4921:   strBaseString = strBaseString & "    If IsEmpty(varSubProperty) Then" & vbNewLine
4922:   strBaseString = strBaseString & "      strDescription = ""<-- No Description -->""" & vbNewLine
4923:   strBaseString = strBaseString & "    Else" & vbNewLine
4924:   strBaseString = strBaseString & "      strDescription = CStr(varSubProperty)" & vbNewLine
4925:   strBaseString = strBaseString & "    End If" & vbNewLine
4926:   strBaseString = strBaseString & "  Else" & vbNewLine
4927:   strBaseString = strBaseString & "    strDescription = ""<-- No Description -->""" & vbNewLine
4928:   strBaseString = strBaseString & "  End If" & vbNewLine
4929:   strBaseString = strBaseString & " " & vbNewLine
4930:   strBaseString = strBaseString & " " & vbNewLine
4931:   strBaseString = strBaseString & "  ' FIRST CHECK FOR ORIGINAL TRANSPORTATION LINE FIELDS" & vbNewLine
4932:   strBaseString = strBaseString & "  If pTransportationLine_UTM12_NAD83_FClass.FindField(strFieldName) > -1 Then" & vbNewLine
4933:   strBaseString = strBaseString & "    If InStr(1, strDescription, ""Imported from TransportationLine_UTM12_NAD83"", vbTextCompare) = 0 Then" & vbNewLine
4934:   strBaseString = strBaseString & "      strDescription = strDescription & ""  [Imported from TransportationLine_UTM12_NAD83]""" & vbNewLine
4935:   strBaseString = strBaseString & "    End If" & vbNewLine
4936:   strBaseString = strBaseString & "    If Not IsEmpty(varProperty) Then" & vbNewLine
4937:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXName" & vbNewLine
4938:   strBaseString = strBaseString & "    End If" & vbNewLine
4939:   strBaseString = strBaseString & "    pPropSet.SetProperty strXName, strDescription" & vbNewLine
4940:   strBaseString = strBaseString & " " & vbNewLine
4941:   strBaseString = strBaseString & "    ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
4942:   strBaseString = strBaseString & "    varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
4943:   strBaseString = strBaseString & "    If IsEmpty(varSource) Then" & vbNewLine
4944:   strBaseString = strBaseString & "      pPropSet.SetProperty strXNameSource, ""TransportationLine_UTM12_NAD83""" & vbNewLine
4945:   strBaseString = strBaseString & "    End If" & vbNewLine
4946:   strBaseString = strBaseString & " " & vbNewLine
4947:   strBaseString = strBaseString & "  Else" & vbNewLine
4948:   strBaseString = strBaseString & "    ' OTHERWISE GET CORRECT FIELD ATTRIBUTE DESCRIPTIONS" & vbNewLine
4949:   strBaseString = strBaseString & " " & vbNewLine
4950:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
4951:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  FINAL ATTRIBUTES  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
4952:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
4953:   strBaseString = strBaseString & " " & vbNewLine
4954:   strBaseString = strBaseString & "    If strFieldName = ""Final_Use_Level"" Then" & vbNewLine
4955:   strBaseString = strBaseString & "      strDescription = """"""Use Level"""" indicates the transportation quality and accessibility of this "" & _" & vbNewLine
4956:   strBaseString = strBaseString & "        ""feature, such as distinguishing between paved roads and 4-wheel drive tracks.  "" & _" & vbNewLine
4957:   strBaseString = strBaseString & "        """"""Final_Use_Level"""" is the most likely use level of this feature, based on 'use level' values from "" & _" & vbNewLine
4958:   strBaseString = strBaseString & "        ""BLM_AZStrip_UTM12_NAD83, Roads_UTM12_NAD83, Roads_KNF_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, "" & _" & vbNewLine
4959:   strBaseString = strBaseString & "        ""and TIGER_2012_Trans_Near_Park_UTM12_NAD83."" & vbCrLf & vbCrLf & _" & vbNewLine
4960:   strBaseString = strBaseString & "        ""The Final Use Level value is extracted from the 'Use Level' field of the closest feature that "" & _" & vbNewLine
4961:   strBaseString = strBaseString & "        ""does not have a Null or 'No Value' name value.  See descriptions of the attribute fields "" & _" & vbNewLine
4962:   strBaseString = strBaseString & "        """"""Use_Level_1"""", """"Use_Level_2"""", """"Use_Level_3"""" and """"Use_Level_4"""" for details."" & vbCrLf & vbCrLf & _" & vbNewLine
4963:   strBaseString = strBaseString & "        ""'Nearby Features' are defined as features from any of the potential contributor "" & _" & vbNewLine
4964:   strBaseString = strBaseString & "        ""feature classes that are <= 10 meters from the centroid of this feature."" & vbCrLf & vbCrLf & _" & vbNewLine
4965:   strBaseString = strBaseString & "        ""If no nearby features have non-Null 'Use Level' values, then this value will be Null.""" & vbNewLine
4966:   strBaseString = strBaseString & " " & vbNewLine
4967:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
4968:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
4969:   strBaseString = strBaseString & "      End If" & vbNewLine
4970:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
4971:   strBaseString = strBaseString & " " & vbNewLine
4972:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
4973:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
4974:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
4975:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
4976:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
4977:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
4978:   strBaseString = strBaseString & "      End If" & vbNewLine
4979:   strBaseString = strBaseString & " " & vbNewLine
4980:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXUDom" & vbNewLine
4981:   strBaseString = strBaseString & "      pPropSet.SetProperty strXUDom, ""Values extracted from 'use level' values obtained from "" & _" & vbNewLine
4982:   strBaseString = strBaseString & "        """"""BLM_AZStrip_UTM12_NAD83"""", """"Roads_UTM12_NAD83"""", """"Roads_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
4983:   strBaseString = strBaseString & "        """"""UTAH_Roads_Near_AOI_UTM12_NAD83"""", and """"TIGER_2012_Trans_Near_Park_UTM12_NAD83"""".""" & vbNewLine
4984:   strBaseString = strBaseString & " " & vbNewLine
4985:   strBaseString = strBaseString & "    End If" & vbNewLine
4986:   strBaseString = strBaseString & " " & vbNewLine
4987:   strBaseString = strBaseString & "    If strFieldName = ""Final_Use_Level_Source"" Then" & vbNewLine
4988:   strBaseString = strBaseString & "      strDescription = ""The name of the feature class used to extract the most likely Use Level "" & _" & vbNewLine
4989:   strBaseString = strBaseString & "        ""of this feature.  See the definition of the attribute field """"Final_Use_Level"""" above "" & _" & vbNewLine
4990:   strBaseString = strBaseString & "        ""for details."" & vbCrLf & vbCrLf & _" & vbNewLine
4991:   strBaseString = strBaseString & "        ""Possible values are "" & _" & vbNewLine
4992:   strBaseString = strBaseString & "        ""BLM_AZStrip_UTM12_NAD83, Roads_UTM12_NAD83, Roads_KNF_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, "" & _" & vbNewLine
4993:   strBaseString = strBaseString & "        ""or TIGER_2012_Trans_Near_Park_UTM12_NAD83.""" & vbNewLine
4994:   strBaseString = strBaseString & " " & vbNewLine
4995:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
4996:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
4997:   strBaseString = strBaseString & "      End If" & vbNewLine
4998:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
4999:   strBaseString = strBaseString & " " & vbNewLine
5000:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5001:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5002:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5003:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5004:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5005:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5006:   strBaseString = strBaseString & "      End If" & vbNewLine
5007:   strBaseString = strBaseString & " " & vbNewLine
5008:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXUDom" & vbNewLine
5009:   strBaseString = strBaseString & "      pPropSet.SetProperty strXUDom, ""Values selected from Feature Class Names "" & _" & vbNewLine
5010:   strBaseString = strBaseString & "        """"""BLM_AZStrip_UTM12_NAD83"""", """"Roads_UTM12_NAD83"""", """"Roads_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
5011:   strBaseString = strBaseString & "        """"""UTAH_Roads_Near_AOI_UTM12_NAD83"""", and """"TIGER_2012_Trans_Near_Park_UTM12_NAD83"""".""" & vbNewLine
5012:   strBaseString = strBaseString & " " & vbNewLine
5013:   strBaseString = strBaseString & "    End If" & vbNewLine
5014:   strBaseString = strBaseString & " " & vbNewLine
5015:   strBaseString = strBaseString & "    If strFieldName = ""Final_Surface_Type"" Then" & vbNewLine
5016:   strBaseString = strBaseString & "      strDescription = """"""Surface_Type"""" indicates the construction material of this feature, "" & _" & vbNewLine
5017:   strBaseString = strBaseString & "        ""such as distinguishing betweeen paved, gravel and dirt roads.  "" & _" & vbNewLine
5018:   strBaseString = strBaseString & "        ""The """"Final_Surface_Type"""" is the most likely surface type of this feature, based on "" & _" & vbNewLine
5019:   strBaseString = strBaseString & "        ""Surface Type values from Roads_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5020:   strBaseString = strBaseString & "        ""Roads_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83, Utah_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
5021:   strBaseString = strBaseString & "        ""TransportationLine_UTM12_NAD83."" & vbCrLf & vbCrLf & _" & vbNewLine
5022:   strBaseString = strBaseString & "        ""If the 'Surface_Type' value from Transportation_Line_UTM12_NAD83 is Null or 'No Value', then the "" & _" & vbNewLine
5023:   strBaseString = strBaseString & "        ""Final Surface Type value is extracted from the 'Type' field of the closest feature that "" & _" & vbNewLine
5024:   strBaseString = strBaseString & "        ""does not have a Null or 'No Value' Type value.  See descriptions of the attribute fields "" & _" & vbNewLine
5025:   strBaseString = strBaseString & "        """"""SurfaceType_1"""", """"SurfaceType_2"""", """"SurfaceType_3"""" and """"SurfaceType_4"""" for details."" & vbCrLf & vbCrLf & _" & vbNewLine
5026:   strBaseString = strBaseString & "        ""'Nearby Features' are defined as features from any of the potential contributor "" & _" & vbNewLine
5027:   strBaseString = strBaseString & "        ""feature classes that are <= 10 meters from the centroid of this feature."" & vbCrLf & vbCrLf & _" & vbNewLine
5028:   strBaseString = strBaseString & "        ""If no nearby features have non-Null 'Surface Type' values, then this value will be Null.""" & vbNewLine
5029:   strBaseString = strBaseString & " " & vbNewLine
5030:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5031:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5032:   strBaseString = strBaseString & "      End If" & vbNewLine
5033:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5034:   strBaseString = strBaseString & " " & vbNewLine
5035:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5036:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5037:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5038:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5039:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5040:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5041:   strBaseString = strBaseString & "      End If" & vbNewLine
5042:   strBaseString = strBaseString & " " & vbNewLine
5043:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXUDom" & vbNewLine
5044:   strBaseString = strBaseString & "      pPropSet.SetProperty strXUDom, ""Values extracted from 'use level' values obtained from "" & _" & vbNewLine
5045:   strBaseString = strBaseString & "        """"""BLM_AZStrip_UTM12_NAD83"""", """"Roads_UTM12_NAD83"""", """"Roads_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
5046:   strBaseString = strBaseString & "        """"""UTAH_Roads_Near_AOI_UTM12_NAD83"""", """"TIGER_2012_Trans_Near_Park_UTM12_NAD83"""" and "" & _" & vbNewLine
5047:   strBaseString = strBaseString & "        """"""TransportationLine_UTM12_NAD83."""".""" & vbNewLine
5048:   strBaseString = strBaseString & "    End If" & vbNewLine
5049:   strBaseString = strBaseString & " " & vbNewLine
5050:   strBaseString = strBaseString & "    If strFieldName = ""Final_Surface_Type_Source"" Then" & vbNewLine
5051:   strBaseString = strBaseString & "      strDescription = ""The name of the feature class used to extract the most likely Surface Type "" & _" & vbNewLine
5052:   strBaseString = strBaseString & "        ""of this feature.  See the definition of the attribute field """"Final_Surface_Type"""" above "" & _" & vbNewLine
5053:   strBaseString = strBaseString & "        ""for details."" & vbCrLf & vbCrLf & _" & vbNewLine
5054:   strBaseString = strBaseString & "        ""Possible values are Roads_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5055:   strBaseString = strBaseString & "        ""Roads_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83, Utah_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
5056:   strBaseString = strBaseString & "        ""TransportationLine_UTM12_NAD83.""" & vbNewLine
5057:   strBaseString = strBaseString & " " & vbNewLine
5058:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5059:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5060:   strBaseString = strBaseString & "      End If" & vbNewLine
5061:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5062:   strBaseString = strBaseString & " " & vbNewLine
5063:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5064:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5065:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5066:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5067:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5068:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5069:   strBaseString = strBaseString & "      End If" & vbNewLine
5070:   strBaseString = strBaseString & " " & vbNewLine
5071:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXUDom" & vbNewLine
5072:   strBaseString = strBaseString & "      pPropSet.SetProperty strXUDom, ""Values selected from Feature Class Names "" & _" & vbNewLine
5073:   strBaseString = strBaseString & "      """"""BLM_AZStrip_UTM12_NAD83"""", """"Roads_UTM12_NAD83"""", """"Roads_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
5074:   strBaseString = strBaseString & "        """"""UTAH_Roads_Near_AOI_UTM12_NAD83"""", """"TIGER_2012_Trans_Near_Park_UTM12_NAD83"""" and "" & _" & vbNewLine
5075:   strBaseString = strBaseString & "        """"""TransportationLine_UTM12_NAD83."""".""" & vbNewLine
5076:   strBaseString = strBaseString & " " & vbNewLine
5077:   strBaseString = strBaseString & "    End If" & vbNewLine
5078:   strBaseString = strBaseString & "    If strFieldName = ""Final_Type"" Then" & vbNewLine
5079:   strBaseString = strBaseString & "      strDescription = """"""Type"""" indicates the primary use or intended purpose of this feature, "" & _" & vbNewLine
5080:   strBaseString = strBaseString & "        ""such as distinguishing betweeen roads and hiking trails."" & _" & vbNewLine
5081:   strBaseString = strBaseString & "        ""The """"Final_Type"""" is the most likely type of this feature, based on Type values from "" & _" & vbNewLine
5082:   strBaseString = strBaseString & "        ""Transportation_Line_UTM12_NAD83 or extracted from nearby features from "" & _" & vbNewLine
5083:   strBaseString = strBaseString & "        ""BLM_AZStrip_UTM12_NAD83, Roads_KNF_UTM12_NAD83, Trails_KNF_UTM12_NAD83, "" & _" & vbNewLine
5084:   strBaseString = strBaseString & "        ""and TIGER_2012_Trans_Near_Park_UTM12_NAD83."" & vbCrLf & vbCrLf & _" & vbNewLine
5085:   strBaseString = strBaseString & "        ""If the 'Type' value from Transportation_Line_UTM12_NAD83 is Null or 'No Value', then the "" & _" & vbNewLine
5086:   strBaseString = strBaseString & "        ""Final Type value is extracted from the 'Type' field of the closest feature that "" & _" & vbNewLine
5087:   strBaseString = strBaseString & "        ""does not have a Null or 'No Value' Type value.  See descriptions of the attribute fields "" & _" & vbNewLine
5088:   strBaseString = strBaseString & "        """"""Type_1"""", """"Type_2"""", """"Type_3"""" and """"Type_4"""" for details."" & vbCrLf & vbCrLf & _" & vbNewLine
5089:   strBaseString = strBaseString & "        ""'Nearby Features' are defined as features from any of the potential contributor "" & _" & vbNewLine
5090:   strBaseString = strBaseString & "        ""feature classes that are <= 10 meters from the centroid of this feature."" & vbCrLf & vbCrLf & _" & vbNewLine
5091:   strBaseString = strBaseString & "        ""If no nearby features have non-Null 'Type' values, then this value will be Null.""" & vbNewLine
5092:   strBaseString = strBaseString & " " & vbNewLine
5093:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5094:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5095:   strBaseString = strBaseString & "      End If" & vbNewLine
5096:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5097:   strBaseString = strBaseString & " " & vbNewLine
5098:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5099:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5100:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5101:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5102:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5103:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5104:   strBaseString = strBaseString & "      End If" & vbNewLine
5105:   strBaseString = strBaseString & " " & vbNewLine
5106:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXUDom" & vbNewLine
5107:   strBaseString = strBaseString & "      pPropSet.SetProperty strXUDom, ""Values extracted from 'use level' values obtained from "" & _" & vbNewLine
5108:   strBaseString = strBaseString & "        """"""BLM_AZStrip_UTM12_NAD83"""", """"Trails_KNF_UTM12_NAD83"""", """"Roads_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
5109:   strBaseString = strBaseString & "        """"""Transportation_Line_UTM12_NAD83"""", and """"TIGER_2012_Trans_Near_Park_UTM12_NAD83"""".""" & vbNewLine
5110:   strBaseString = strBaseString & " " & vbNewLine
5111:   strBaseString = strBaseString & "    End If" & vbNewLine
5112:   strBaseString = strBaseString & " " & vbNewLine
5113:   strBaseString = strBaseString & "    If strFieldName = ""Final_Type_Source"" Then" & vbNewLine
5114:   strBaseString = strBaseString & "      strDescription = ""The name of the feature class used to extract the most likely Type "" & _" & vbNewLine
5115:   strBaseString = strBaseString & "        ""of this feature.  See the definition of the attribute field """"Final_Type"""" above "" & _" & vbNewLine
5116:   strBaseString = strBaseString & "        ""for details."" & vbCrLf & vbCrLf & _" & vbNewLine
5117:   strBaseString = strBaseString & "        ""Possible values are Transportation_Line_UTM12_NAD83, "" & _" & vbNewLine
5118:   strBaseString = strBaseString & "        ""BLM_AZStrip_UTM12_NAD83, Roads_KNF_UTM12_NAD83, Trails_KNF_UTM12_NAD83, "" & _" & vbNewLine
5119:   strBaseString = strBaseString & "        ""or TIGER_2012_Trans_Near_Park_UTM12_NAD83.""" & vbNewLine
5120:   strBaseString = strBaseString & " " & vbNewLine
5121:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5122:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5123:   strBaseString = strBaseString & "      End If" & vbNewLine
5124:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5125:   strBaseString = strBaseString & " " & vbNewLine
5126:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5127:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5128:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5129:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5130:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5131:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5132:   strBaseString = strBaseString & "      End If" & vbNewLine
5133:   strBaseString = strBaseString & " " & vbNewLine
5134:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXUDom" & vbNewLine
5135:   strBaseString = strBaseString & "      pPropSet.SetProperty strXUDom, ""Values selected from Feature Class Names "" & _" & vbNewLine
5136:   strBaseString = strBaseString & "        """"""BLM_AZStrip_UTM12_NAD83"""", """"Trails_KNF_UTM12_NAD83"""", """"Roads_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
5137:   strBaseString = strBaseString & "        """"""Transportation_Line_UTM12_NAD83"""", and """"TIGER_2012_Trans_Near_Park_UTM12_NAD83"""".""" & vbNewLine
5138:   strBaseString = strBaseString & "    End If" & vbNewLine
5139:   strBaseString = strBaseString & " " & vbNewLine
5140:   strBaseString = strBaseString & "    If strFieldName = ""Final_Name"" Then" & vbNewLine
5141:   strBaseString = strBaseString & "      strDescription = ""The most likely name of this feature, based on name values from "" & _" & vbNewLine
5142:   strBaseString = strBaseString & "        ""Transportation_Line_UTM12_NAD83 or extracted from nearby features from "" & _" & vbNewLine
5143:   strBaseString = strBaseString & "        ""BLM_AZStrip_UTM12_NAD83, Roads_UTM12_NAD83, Routes_UTM12_NAD83, Trails_UTM12_NAD83, "" & _" & vbNewLine
5144:   strBaseString = strBaseString & "        ""Roads_KNF_UTM12_NAD83, Trails_KNF_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, "" & _" & vbNewLine
5145:   strBaseString = strBaseString & "        ""and TIGER_2012_Trans_Near_Park_UTM12_NAD83."" & vbCrLf & vbCrLf & _" & vbNewLine
5146:   strBaseString = strBaseString & "        ""The Final Name value is extracted from the 'Name' field of the closest feature that "" & _" & vbNewLine
5147:   strBaseString = strBaseString & "        ""does not have a Null or 'No Value' name value.  See descriptions of the attribute fields "" & _" & vbNewLine
5148:   strBaseString = strBaseString & "        """"""Name_1"""", """"Name_2"""", """"Name_3"""" and """"Name_4"""" for details."" & vbCrLf & vbCrLf & _" & vbNewLine
5149:   strBaseString = strBaseString & "        ""'Nearby Features' are defined as features from any of the potential contributor "" & _" & vbNewLine
5150:   strBaseString = strBaseString & "        ""feature classes that are <= 10 meters from the centroid of this feature."" & vbCrLf & vbCrLf & _" & vbNewLine
5151:   strBaseString = strBaseString & "        ""If no nearby features have non-Null 'Name' values, then this value will be Null.""" & vbNewLine
5152:   strBaseString = strBaseString & " " & vbNewLine
5153:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5154:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5155:   strBaseString = strBaseString & "      End If" & vbNewLine
5156:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5157:   strBaseString = strBaseString & " " & vbNewLine
5158:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5159:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5160:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5161:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5162:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5163:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5164:   strBaseString = strBaseString & "      End If" & vbNewLine
5165:   strBaseString = strBaseString & " " & vbNewLine
5166:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXUDom" & vbNewLine
5167:   strBaseString = strBaseString & "      pPropSet.SetProperty strXUDom, ""Values extracted from 'use level' values obtained from "" & _" & vbNewLine
5168:   strBaseString = strBaseString & "        """"""BLM_AZStrip_UTM12_NAD83"""", """"Roads_UTM12_NAD83"""", """"Roads_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
5169:   strBaseString = strBaseString & "        """"""Routes_UTM12_NAD83"""", """"Trails_UTM12_NAD83"""", """"Trails_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
5170:   strBaseString = strBaseString & "        """"""UTAH_Roads_Near_AOI_UTM12_NAD83"""", """"TIGER_2012_Trans_Near_Park_UTM12_NAD83"""" and "" & _" & vbNewLine
5171:   strBaseString = strBaseString & "        """"""TransportationLine_UTM12_NAD83."""".""" & vbNewLine
5172:   strBaseString = strBaseString & " " & vbNewLine
5173:   strBaseString = strBaseString & "    End If" & vbNewLine
5174:   strBaseString = strBaseString & " " & vbNewLine
5175:   strBaseString = strBaseString & "    If strFieldName = ""Final_Name_Source"" Then" & vbNewLine
5176:   strBaseString = strBaseString & "      strDescription = ""The name of the feature class used to extract the most likely name "" & _" & vbNewLine
5177:   strBaseString = strBaseString & "        ""of this feature.  See the definition of the attribute field """"Final_Name"""" above "" & _" & vbNewLine
5178:   strBaseString = strBaseString & "        ""for details."" & vbCrLf & vbCrLf & _" & vbNewLine
5179:   strBaseString = strBaseString & "        ""Possible values are Transportation_Line_UTM12_NAD83, "" & _" & vbNewLine
5180:   strBaseString = strBaseString & "        ""BLM_AZStrip_UTM12_NAD83, Roads_UTM12_NAD83, Routes_UTM12_NAD83, Trails_UTM12_NAD83, "" & _" & vbNewLine
5181:   strBaseString = strBaseString & "        ""Roads_KNF_UTM12_NAD83, Trails_KNF_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, "" & _" & vbNewLine
5182:   strBaseString = strBaseString & "        ""or TIGER_2012_Trans_Near_Park_UTM12_NAD83.""" & vbNewLine
5183:   strBaseString = strBaseString & " " & vbNewLine
5184:   strBaseString = strBaseString & "   " & vbNewLine
5185:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5186:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5187:   strBaseString = strBaseString & "      End If" & vbNewLine
5188:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5189:   strBaseString = strBaseString & " " & vbNewLine
5190:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5191:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5192:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5193:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5194:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5195:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5196:   strBaseString = strBaseString & "      End If" & vbNewLine
5197:   strBaseString = strBaseString & " " & vbNewLine
5198:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXUDom" & vbNewLine
5199:   strBaseString = strBaseString & "      pPropSet.SetProperty strXUDom, ""Values selected from Feature Class Names "" & _" & vbNewLine
5200:   strBaseString = strBaseString & "        """"""BLM_AZStrip_UTM12_NAD83"""", """"Roads_UTM12_NAD83"""", """"Roads_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
5201:   strBaseString = strBaseString & "        """"""Routes_UTM12_NAD83"""", """"Trails_UTM12_NAD83"""", """"Trails_KNF_UTM12_NAD83"""", "" & _" & vbNewLine
5202:   strBaseString = strBaseString & "        """"""UTAH_Roads_Near_AOI_UTM12_NAD83"""", """"TIGER_2012_Trans_Near_Park_UTM12_NAD83"""" and "" & _" & vbNewLine
5203:   strBaseString = strBaseString & "        """"""TransportationLine_UTM12_NAD83."""".""" & vbNewLine
5204:   strBaseString = strBaseString & "    End If" & vbNewLine
5205:   strBaseString = strBaseString & " " & vbNewLine
5206:   strBaseString = strBaseString & " " & vbNewLine
5207:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
5208:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  NAME  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
5209:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
5210:   strBaseString = strBaseString & "    If strFieldName = ""Name_1"" Then" & vbNewLine
5211:   strBaseString = strBaseString & "      strDescription = ""The Name or Identifying Code of this feature.  This attribute field contains "" & _" & vbNewLine
5212:   strBaseString = strBaseString & "          ""the Name value from the closest feature from 9 potential contributor feature "" & _" & vbNewLine
5213:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
5214:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
5215:   strBaseString = strBaseString & "          ""should be Null if there were no features within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
5216:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
5217:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"Road_Name""""."" & vbCrLf & _" & vbNewLine
5218:   strBaseString = strBaseString & "          ""    - See description of """"BLM_Road_Name"""" above for definitions."" & vbCrLf & _" & vbNewLine
5219:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"RoadName""""."" & vbCrLf & _" & vbNewLine
5220:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_RoadName"""" above for definition."" & vbCrLf & _" & vbNewLine
5221:   strBaseString = strBaseString & "          "" - If from Routes_UTM12_NAD83, then the attribute field """"RouteName""""."" & vbCrLf & _" & vbNewLine
5222:   strBaseString = strBaseString & "          ""    - See description of """"ROUTES_RouteName"""" above for definition."" & vbCrLf & _" & vbNewLine
5223:   strBaseString = strBaseString & "          "" - If from Trails_UTM12_NAD83, then the attribute field """"TrailName""""."" & vbCrLf & _" & vbNewLine
5224:   strBaseString = strBaseString & "          ""    - See description of """"TRAILS_TrailName"""" above for definition."" & vbCrLf & _" & vbNewLine
5225:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"NAME""""."" & vbCrLf & _" & vbNewLine
5226:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Name"""" above for definition."" & vbCrLf & _" & vbNewLine
5227:   strBaseString = strBaseString & "          "" - If from Trails_KNF_UTM12_NAD83, then the attribute field """"NAME""""."" & vbCrLf & _" & vbNewLine
5228:   strBaseString = strBaseString & "          ""    - See description of """"KNFTR_Name"""" above for definition."" & vbCrLf & _" & vbNewLine
5229:   strBaseString = strBaseString & "          "" - If from UTAH_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"FullName""""."" & vbCrLf & _" & vbNewLine
5230:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_FullName"""" above for definition."" & vbCrLf & _" & vbNewLine
5231:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"FULLNAME""""."" & vbCrLf & _" & vbNewLine
5232:   strBaseString = strBaseString & "          ""    - See description of """"TIG_FULLNAME"""" above for definition."" & vbCrLf" & vbNewLine
5233:   strBaseString = strBaseString & "      strDescription = strDescription & _" & vbNewLine
5234:   strBaseString = strBaseString & "          "" - If from TransportationLine_UTM12_NAD83, then the attribute fields """"RoadName"""", "" & _" & vbNewLine
5235:   strBaseString = strBaseString & "          """"""RouteName"""", and/or """"TrailName""""."" & vbCrLf & _" & vbNewLine
5236:   strBaseString = strBaseString & "          ""    - See descriptions of """"RoadName"""", """"RouteName"""" and """"TrailName"""" above for definitions."" & vbCrLf & _" & vbNewLine
5237:   strBaseString = strBaseString & "          vbCrLf & ""If the nearest feature was from the TransportationLine_UTM12_NAD83 feature class, and if "" & _" & vbNewLine
5238:   strBaseString = strBaseString & "          ""all three attribute fields """"RoadName"""", """"RouteName"""" and """"TrailName"""" were empty or null, then "" & _" & vbNewLine
5239:   strBaseString = strBaseString & "          ""this feature was ignored and not considered as a candidate to assign a name to this feature.  "" & _" & vbNewLine
5240:   strBaseString = strBaseString & "          ""Features from any other nearby feature classes were included regardless of whether the Name values "" & _" & vbNewLine
5241:   strBaseString = strBaseString & "          ""were empty or not.""" & vbNewLine
5242:   strBaseString = strBaseString & " " & vbNewLine
5243:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5244:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5245:   strBaseString = strBaseString & "      End If" & vbNewLine
5246:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5247:   strBaseString = strBaseString & " " & vbNewLine
5248:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5249:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5250:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5251:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5252:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5253:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5254:   strBaseString = strBaseString & "      End If" & vbNewLine
5255:   strBaseString = strBaseString & "    End If" & vbNewLine
5256:   strBaseString = strBaseString & "    If strFieldName = ""Name_1_Source"" Then" & vbNewLine
5257:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the closest feature to this feature.  "" & _" & vbNewLine
5258:   strBaseString = strBaseString & "          ""The 9 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5259:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, Routes_UTM12_NAD83, Trails_UTM12_NAD83, "" & _" & vbNewLine
5260:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
5261:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.  "" & _" & vbNewLine
5262:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters."" & vbCrLf & vbCrLf & _" & vbNewLine
5263:   strBaseString = strBaseString & "          ""If this attribute value is extracted from the TransportationLine_UTM12_NAD83 feature class, then this "" & _" & vbNewLine
5264:   strBaseString = strBaseString & "          ""value is appended with either """":RoadName"""", """":RouteName"""" or """":TrailName"""" to indicate which "" & _" & vbNewLine
5265:   strBaseString = strBaseString & "          ""attribute field the attribute came from.""" & vbNewLine
5266:   strBaseString = strBaseString & " " & vbNewLine
5267:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5268:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5269:   strBaseString = strBaseString & "      End If" & vbNewLine
5270:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5271:   strBaseString = strBaseString & " " & vbNewLine
5272:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5273:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5274:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5275:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5276:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5277:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5278:   strBaseString = strBaseString & "      End If" & vbNewLine
5279:   strBaseString = strBaseString & "    End If" & vbNewLine
5280:   strBaseString = strBaseString & "    If strFieldName = ""Name_1_Distance"" Then" & vbNewLine
5281:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
5282:   strBaseString = strBaseString & "           ""closest feature from one of 9 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
5283:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
5284:   strBaseString = strBaseString & "          ""The 9 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5285:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, Routes_UTM12_NAD83, Trails_UTM12_NAD83, "" & _" & vbNewLine
5286:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
5287:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.""" & vbNewLine
5288:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5289:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5290:   strBaseString = strBaseString & "      End If" & vbNewLine
5291:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5292:   strBaseString = strBaseString & " " & vbNewLine
5293:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5294:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5295:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5296:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5297:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5298:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5299:   strBaseString = strBaseString & "      End If" & vbNewLine
5300:   strBaseString = strBaseString & " " & vbNewLine
5301:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
5302:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
5303:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
5304:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
5305:   strBaseString = strBaseString & " " & vbNewLine
5306:   strBaseString = strBaseString & "    End If" & vbNewLine
5307:   strBaseString = strBaseString & "    If strFieldName = ""Name_2"" Then" & vbNewLine
5308:   strBaseString = strBaseString & "      strDescription = ""The Name or Identifying Code of this feature.  This attribute field contains "" & _" & vbNewLine
5309:   strBaseString = strBaseString & "          ""the Name value from the 2nd-closest feature from 9 potential contributor feature "" & _" & vbNewLine
5310:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
5311:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
5312:   strBaseString = strBaseString & "          ""should be Null if there was no 2nd-closest feature within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
5313:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
5314:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"Road_Name""""."" & vbCrLf & _" & vbNewLine
5315:   strBaseString = strBaseString & "          ""    - See description of """"BLM_Road_Name"""" above for definitions."" & vbCrLf & _" & vbNewLine
5316:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"RoadName""""."" & vbCrLf & _" & vbNewLine
5317:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_RoadName"""" above for definition."" & vbCrLf & _" & vbNewLine
5318:   strBaseString = strBaseString & "          "" - If from Routes_UTM12_NAD83, then the attribute field """"RouteName""""."" & vbCrLf & _" & vbNewLine
5319:   strBaseString = strBaseString & "          ""    - See description of """"ROUTES_RouteName"""" above for definition."" & vbCrLf & _" & vbNewLine
5320:   strBaseString = strBaseString & "          "" - If from Trails_UTM12_NAD83, then the attribute field """"TrailName""""."" & vbCrLf & _" & vbNewLine
5321:   strBaseString = strBaseString & "          ""    - See description of """"TRAILS_TrailName"""" above for definition."" & vbCrLf & _" & vbNewLine
5322:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"NAME""""."" & vbCrLf & _" & vbNewLine
5323:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Name"""" above for definition."" & vbCrLf & _" & vbNewLine
5324:   strBaseString = strBaseString & "          "" - If from Trails_KNF_UTM12_NAD83, then the attribute field """"NAME""""."" & vbCrLf & _" & vbNewLine
5325:   strBaseString = strBaseString & "          ""    - See description of """"KNFTR_Name"""" above for definition."" & vbCrLf & _" & vbNewLine
5326:   strBaseString = strBaseString & "          "" - If from UTAH_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"FullName""""."" & vbCrLf & _" & vbNewLine
5327:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_FullName"""" above for definition."" & vbCrLf & _" & vbNewLine
5328:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"FULLNAME""""."" & vbCrLf & _" & vbNewLine
5329:   strBaseString = strBaseString & "          ""    - See description of """"TIG_FULLNAME"""" above for definition."" & vbCrLf" & vbNewLine
5330:   strBaseString = strBaseString & "      strDescription = strDescription & _" & vbNewLine
5331:   strBaseString = strBaseString & "          "" - If from TransportationLine_UTM12_NAD83, then the attribute fields """"RoadName"""", "" & _" & vbNewLine
5332:   strBaseString = strBaseString & "          """"""RouteName"""", and/or """"TrailName""""."" & vbCrLf & _" & vbNewLine
5333:   strBaseString = strBaseString & "          ""    - See descriptions of """"RoadName"""", """"RouteName"""" and """"TrailName"""" above for definitions."" & vbCrLf & _" & vbNewLine
5334:   strBaseString = strBaseString & "          vbCrLf & ""If the 2nd-nearest feature was from the TransportationLine_UTM12_NAD83 feature class, and if "" & _" & vbNewLine
5335:   strBaseString = strBaseString & "          ""all three attribute fields """"RoadName"""", """"RouteName"""" and """"TrailName"""" were empty or null, then "" & _" & vbNewLine
5336:   strBaseString = strBaseString & "          ""this feature was ignored and not considered as a candidate to assign a name to this feature.  "" & _" & vbNewLine
5337:   strBaseString = strBaseString & "          ""Features from any other nearby feature classes were included regardless of whether the Name values "" & _" & vbNewLine
5338:   strBaseString = strBaseString & "          ""were empty or not.""" & vbNewLine
5339:   strBaseString = strBaseString & " " & vbNewLine
5340:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5341:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5342:   strBaseString = strBaseString & "      End If" & vbNewLine
5343:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5344:   strBaseString = strBaseString & " " & vbNewLine
5345:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5346:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5347:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5348:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5349:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5350:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5351:   strBaseString = strBaseString & "      End If" & vbNewLine
5352:   strBaseString = strBaseString & "    End If" & vbNewLine
5353:   strBaseString = strBaseString & "    If strFieldName = ""Name_2_Source"" Then" & vbNewLine
5354:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the 2nd-closest feature to this feature.  "" & _" & vbNewLine
5355:   strBaseString = strBaseString & "          ""The 9 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5356:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, Routes_UTM12_NAD83, Trails_UTM12_NAD83, "" & _" & vbNewLine
5357:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
5358:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.  "" & _" & vbNewLine
5359:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters."" & vbCrLf & vbCrLf & _" & vbNewLine
5360:   strBaseString = strBaseString & "          ""If this attribute value is extracted from the TransportationLine_UTM12_NAD83 feature class, then this "" & _" & vbNewLine
5361:   strBaseString = strBaseString & "          ""value is appended with either """":RoadName"""", """":RouteName"""" or """":TrailName"""" to indicate which "" & _" & vbNewLine
5362:   strBaseString = strBaseString & "          ""attribute field the attribute came from.""" & vbNewLine
5363:   strBaseString = strBaseString & " " & vbNewLine
5364:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5365:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5366:   strBaseString = strBaseString & "      End If" & vbNewLine
5367:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5368:   strBaseString = strBaseString & " " & vbNewLine
5369:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5370:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5371:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5372:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5373:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5374:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5375:   strBaseString = strBaseString & "      End If" & vbNewLine
5376:   strBaseString = strBaseString & "    End If" & vbNewLine
5377:   strBaseString = strBaseString & "    If strFieldName = ""Name_2_Distance"" Then" & vbNewLine
5378:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
5379:   strBaseString = strBaseString & "           ""2nd-closest feature from one of 9 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
5380:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
5381:   strBaseString = strBaseString & "          ""The 9 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5382:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, Routes_UTM12_NAD83, Trails_UTM12_NAD83, "" & _" & vbNewLine
5383:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
5384:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.""" & vbNewLine
5385:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5386:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5387:   strBaseString = strBaseString & "      End If" & vbNewLine
5388:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5389:   strBaseString = strBaseString & " " & vbNewLine
5390:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5391:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5392:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5393:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5394:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5395:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5396:   strBaseString = strBaseString & "      End If" & vbNewLine
5397:   strBaseString = strBaseString & " " & vbNewLine
5398:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
5399:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
5400:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
5401:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
5402:   strBaseString = strBaseString & "    End If" & vbNewLine
5403:   strBaseString = strBaseString & "    If strFieldName = ""Name_3"" Then" & vbNewLine
5404:   strBaseString = strBaseString & "      strDescription = ""The Name or Identifying Code of this feature.  This attribute field contains "" & _" & vbNewLine
5405:   strBaseString = strBaseString & "          ""the Name value from the 3rd-closest feature from 9 potential contributor feature "" & _" & vbNewLine
5406:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
5407:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
5408:   strBaseString = strBaseString & "          ""should be Null if there was no 3rd-closest feature within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
5409:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
5410:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"Road_Name""""."" & vbCrLf & _" & vbNewLine
5411:   strBaseString = strBaseString & "          ""    - See description of """"BLM_Road_Name"""" above for definitions."" & vbCrLf & _" & vbNewLine
5412:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"RoadName""""."" & vbCrLf & _" & vbNewLine
5413:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_RoadName"""" above for definition."" & vbCrLf & _" & vbNewLine
5414:   strBaseString = strBaseString & "          "" - If from Routes_UTM12_NAD83, then the attribute field """"RouteName""""."" & vbCrLf & _" & vbNewLine
5415:   strBaseString = strBaseString & "          ""    - See description of """"ROUTES_RouteName"""" above for definition."" & vbCrLf & _" & vbNewLine
5416:   strBaseString = strBaseString & "          "" - If from Trails_UTM12_NAD83, then the attribute field """"TrailName""""."" & vbCrLf & _" & vbNewLine
5417:   strBaseString = strBaseString & "          ""    - See description of """"TRAILS_TrailName"""" above for definition."" & vbCrLf & _" & vbNewLine
5418:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"NAME""""."" & vbCrLf & _" & vbNewLine
5419:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Name"""" above for definition."" & vbCrLf & _" & vbNewLine
5420:   strBaseString = strBaseString & "          "" - If from Trails_KNF_UTM12_NAD83, then the attribute field """"NAME""""."" & vbCrLf & _" & vbNewLine
5421:   strBaseString = strBaseString & "          ""    - See description of """"KNFTR_Name"""" above for definition."" & vbCrLf & _" & vbNewLine
5422:   strBaseString = strBaseString & "          "" - If from UTAH_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"FullName""""."" & vbCrLf & _" & vbNewLine
5423:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_FullName"""" above for definition."" & vbCrLf & _" & vbNewLine
5424:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"FULLNAME""""."" & vbCrLf & _" & vbNewLine
5425:   strBaseString = strBaseString & "          ""    - See description of """"TIG_FULLNAME"""" above for definition."" & vbCrLf" & vbNewLine
5426:   strBaseString = strBaseString & "      strDescription = strDescription & _" & vbNewLine
5427:   strBaseString = strBaseString & "          "" - If from TransportationLine_UTM12_NAD83, then the attribute fields """"RoadName"""", "" & _" & vbNewLine
5428:   strBaseString = strBaseString & "          """"""RouteName"""", and/or """"TrailName""""."" & vbCrLf & _" & vbNewLine
5429:   strBaseString = strBaseString & "          ""    - See descriptions of """"RoadName"""", """"RouteName"""" and """"TrailName"""" above for definitions."" & vbCrLf & _" & vbNewLine
5430:   strBaseString = strBaseString & "          vbCrLf & ""If the 3rd-nearest feature was from the TransportationLine_UTM12_NAD83 feature class, and if "" & _" & vbNewLine
5431:   strBaseString = strBaseString & "          ""all three attribute fields """"RoadName"""", """"RouteName"""" and """"TrailName"""" were empty or null, then "" & _" & vbNewLine
5432:   strBaseString = strBaseString & "          ""this feature was ignored and not considered as a candidate to assign a name to this feature.  "" & _" & vbNewLine
5433:   strBaseString = strBaseString & "          ""Features from any other nearby feature classes were included regardless of whether the Name values "" & _" & vbNewLine
5434:   strBaseString = strBaseString & "          ""were empty or not.""" & vbNewLine
5435:   strBaseString = strBaseString & " " & vbNewLine
5436:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5437:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5438:   strBaseString = strBaseString & "      End If" & vbNewLine
5439:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5440:   strBaseString = strBaseString & " " & vbNewLine
5441:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5442:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5443:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5444:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5445:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5446:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5447:   strBaseString = strBaseString & "      End If" & vbNewLine
5448:   strBaseString = strBaseString & "    End If" & vbNewLine
5449:   strBaseString = strBaseString & "    If strFieldName = ""Name_3_Source"" Then" & vbNewLine
5450:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the 3rd-closest feature to this feature.  "" & _" & vbNewLine
5451:   strBaseString = strBaseString & "          ""The 9 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5452:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, Routes_UTM12_NAD83, Trails_UTM12_NAD83, "" & _" & vbNewLine
5453:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
5454:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.  "" & _" & vbNewLine
5455:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters."" & vbCrLf & vbCrLf & _" & vbNewLine
5456:   strBaseString = strBaseString & "          ""If this attribute value is extracted from the TransportationLine_UTM12_NAD83 feature class, then this "" & _" & vbNewLine
5457:   strBaseString = strBaseString & "          ""value is appended with either """":RoadName"""", """":RouteName"""" or """":TrailName"""" to indicate which "" & _" & vbNewLine
5458:   strBaseString = strBaseString & "          ""attribute field the attribute came from.""" & vbNewLine
5459:   strBaseString = strBaseString & " " & vbNewLine
5460:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5461:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5462:   strBaseString = strBaseString & "      End If" & vbNewLine
5463:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5464:   strBaseString = strBaseString & " " & vbNewLine
5465:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5466:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5467:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5468:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5469:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5470:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5471:   strBaseString = strBaseString & "      End If" & vbNewLine
5472:   strBaseString = strBaseString & "    End If" & vbNewLine
5473:   strBaseString = strBaseString & "    If strFieldName = ""Name_3_Distance"" Then" & vbNewLine
5474:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
5475:   strBaseString = strBaseString & "           ""3rd-closest feature from one of 9 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
5476:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
5477:   strBaseString = strBaseString & "          ""The 9 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5478:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, Routes_UTM12_NAD83, Trails_UTM12_NAD83, "" & _" & vbNewLine
5479:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
5480:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.""" & vbNewLine
5481:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5482:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5483:   strBaseString = strBaseString & "      End If" & vbNewLine
5484:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5485:   strBaseString = strBaseString & " " & vbNewLine
5486:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5487:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5488:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5489:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5490:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5491:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5492:   strBaseString = strBaseString & "      End If" & vbNewLine
5493:   strBaseString = strBaseString & " " & vbNewLine
5494:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
5495:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
5496:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
5497:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
5498:   strBaseString = strBaseString & "    End If" & vbNewLine
5499:   strBaseString = strBaseString & "    If strFieldName = ""Name_4"" Then" & vbNewLine
5500:   strBaseString = strBaseString & "      strDescription = ""The Name or Identifying Code of this feature.  This attribute field contains "" & _" & vbNewLine
5501:   strBaseString = strBaseString & "          ""the Name value from the 4th-closest feature from 9 potential contributor feature "" & _" & vbNewLine
5502:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
5503:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
5504:   strBaseString = strBaseString & "          ""should be Null if there was no 3rd-closest feature within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
5505:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
5506:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"Road_Name""""."" & vbCrLf & _" & vbNewLine
5507:   strBaseString = strBaseString & "          ""    - See description of """"BLM_Road_Name"""" above for definitions."" & vbCrLf & _" & vbNewLine
5508:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"RoadName""""."" & vbCrLf & _" & vbNewLine
5509:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_RoadName"""" above for definition."" & vbCrLf & _" & vbNewLine
5510:   strBaseString = strBaseString & "          "" - If from Routes_UTM12_NAD83, then the attribute field """"RouteName""""."" & vbCrLf & _" & vbNewLine
5511:   strBaseString = strBaseString & "          ""    - See description of """"ROUTES_RouteName"""" above for definition."" & vbCrLf & _" & vbNewLine
5512:   strBaseString = strBaseString & "          "" - If from Trails_UTM12_NAD83, then the attribute field """"TrailName""""."" & vbCrLf & _" & vbNewLine
5513:   strBaseString = strBaseString & "          ""    - See description of """"TRAILS_TrailName"""" above for definition."" & vbCrLf & _" & vbNewLine
5514:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"NAME""""."" & vbCrLf & _" & vbNewLine
5515:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Name"""" above for definition."" & vbCrLf & _" & vbNewLine
5516:   strBaseString = strBaseString & "          "" - If from Trails_KNF_UTM12_NAD83, then the attribute field """"NAME""""."" & vbCrLf & _" & vbNewLine
5517:   strBaseString = strBaseString & "          ""    - See description of """"KNFTR_Name"""" above for definition."" & vbCrLf & _" & vbNewLine
5518:   strBaseString = strBaseString & "          "" - If from UTAH_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"FullName""""."" & vbCrLf & _" & vbNewLine
5519:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_FullName"""" above for definition."" & vbCrLf & _" & vbNewLine
5520:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"FULLNAME""""."" & vbCrLf & _" & vbNewLine
5521:   strBaseString = strBaseString & "          ""    - See description of """"TIG_FULLNAME"""" above for definition."" & vbCrLf" & vbNewLine
5522:   strBaseString = strBaseString & "      strDescription = strDescription & _" & vbNewLine
5523:   strBaseString = strBaseString & "          "" - If from TransportationLine_UTM12_NAD83, then the attribute fields """"RoadName"""", "" & _" & vbNewLine
5524:   strBaseString = strBaseString & "          """"""RouteName"""", and/or """"TrailName""""."" & vbCrLf & _" & vbNewLine
5525:   strBaseString = strBaseString & "          ""    - See descriptions of """"RoadName"""", """"RouteName"""" and """"TrailName"""" above for definitions."" & vbCrLf & _" & vbNewLine
5526:   strBaseString = strBaseString & "          vbCrLf & ""If the 4th-nearest feature was from the TransportationLine_UTM12_NAD83 feature class, and if "" & _" & vbNewLine
5527:   strBaseString = strBaseString & "          ""all three attribute fields """"RoadName"""", """"RouteName"""" and """"TrailName"""" were empty or null, then "" & _" & vbNewLine
5528:   strBaseString = strBaseString & "          ""this feature was ignored and not considered as a candidate to assign a name to this feature.  "" & _" & vbNewLine
5529:   strBaseString = strBaseString & "          ""Features from any other nearby feature classes were included regardless of whether the Name values "" & _" & vbNewLine
5530:   strBaseString = strBaseString & "          ""were empty or not.""" & vbNewLine
5531:   strBaseString = strBaseString & " " & vbNewLine
5532:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5533:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5534:   strBaseString = strBaseString & "      End If" & vbNewLine
5535:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5536:   strBaseString = strBaseString & " " & vbNewLine
5537:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5538:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5539:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5540:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5541:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5542:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5543:   strBaseString = strBaseString & "      End If" & vbNewLine
5544:   strBaseString = strBaseString & "    End If" & vbNewLine
5545:   strBaseString = strBaseString & "    If strFieldName = ""Name_4_Source"" Then" & vbNewLine
5546:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the 4th-closest feature to this feature.  "" & _" & vbNewLine
5547:   strBaseString = strBaseString & "          ""The 9 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5548:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, Routes_UTM12_NAD83, Trails_UTM12_NAD83, "" & _" & vbNewLine
5549:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
5550:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.  "" & _" & vbNewLine
5551:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters."" & vbCrLf & vbCrLf & _" & vbNewLine
5552:   strBaseString = strBaseString & "          ""If this attribute value is extracted from the TransportationLine_UTM12_NAD83 feature class, then this "" & _" & vbNewLine
5553:   strBaseString = strBaseString & "          ""value is appended with either """":RoadName"""", """":RouteName"""" or """":TrailName"""" to indicate which "" & _" & vbNewLine
5554:   strBaseString = strBaseString & "          ""attribute field the attribute came from.""" & vbNewLine
5555:   strBaseString = strBaseString & " " & vbNewLine
5556:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5557:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5558:   strBaseString = strBaseString & "      End If" & vbNewLine
5559:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5560:   strBaseString = strBaseString & " " & vbNewLine
5561:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5562:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5563:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5564:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5565:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5566:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5567:   strBaseString = strBaseString & "      End If" & vbNewLine
5568:   strBaseString = strBaseString & "    End If" & vbNewLine
5569:   strBaseString = strBaseString & "    If strFieldName = ""Name_4_Distance"" Then" & vbNewLine
5570:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
5571:   strBaseString = strBaseString & "           ""4th-closest feature from one of 9 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
5572:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
5573:   strBaseString = strBaseString & "          ""The 9 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5574:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83, Routes_UTM12_NAD83, Trails_UTM12_NAD83, "" & _" & vbNewLine
5575:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
5576:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.""" & vbNewLine
5577:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5578:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5579:   strBaseString = strBaseString & "      End If" & vbNewLine
5580:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5581:   strBaseString = strBaseString & " " & vbNewLine
5582:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5583:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5584:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5585:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5586:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5587:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5588:   strBaseString = strBaseString & "      End If" & vbNewLine
5589:   strBaseString = strBaseString & " " & vbNewLine
5590:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
5591:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
5592:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
5593:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
5594:   strBaseString = strBaseString & "    End If" & vbNewLine
5595:   strBaseString = strBaseString & " " & vbNewLine
5596:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
5597:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Use Level  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
5598:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
5599:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_1"" Then" & vbNewLine
5600:   strBaseString = strBaseString & "      strDescription = """"""Use Level"""" indicates the transportation quality and accessibility of this feature, such as "" & _" & vbNewLine
5601:   strBaseString = strBaseString & "          ""distinguishing between paved roads and 4-wheel drive tracks.  This attribute field contains "" & _" & vbNewLine
5602:   strBaseString = strBaseString & "          ""the Use Level value from the closest feature from 5 potential contributor feature "" & _" & vbNewLine
5603:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
5604:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
5605:   strBaseString = strBaseString & "          ""should be Null if there were no features within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
5606:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
5607:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"E_Map""""."" & vbCrLf & _" & vbNewLine
5608:   strBaseString = strBaseString & "          ""    - See description of """"BLM_E_Map"""" above for definitions."" & vbCrLf & _" & vbNewLine
5609:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"Status""""."" & vbCrLf & _" & vbNewLine
5610:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_Status"""" above for definition."" & vbCrLf & _" & vbNewLine
5611:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"OPER_MAINT""""."" & vbCrLf & _" & vbNewLine
5612:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Oper_Maint"""" above for definition."" & vbCrLf & _" & vbNewLine
5613:   strBaseString = strBaseString & "          "" - If from UTAH_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"SurfType""""."" & vbCrLf & _" & vbNewLine
5614:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_SurfType"""" above for definition."" & vbCrLf & _" & vbNewLine
5615:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"MT_FCLASS""""."" & vbCrLf & _" & vbNewLine
5616:   strBaseString = strBaseString & "          ""    - See description of """"TIG_MT_Fclass"""" above for definition."" & vbCrLf & _" & vbNewLine
5617:   strBaseString = strBaseString & "          vbCrLf & _" & vbNewLine
5618:   strBaseString = strBaseString & "          ""The feature classes Trails_KNF_UTM12_NAD83, Trails_UTM12_NAD83, Routes_UTM12_NAD83 and "" & _" & vbNewLine
5619:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83 did not have good attribute values to describe Use Level.""" & vbNewLine
5620:   strBaseString = strBaseString & " " & vbNewLine
5621:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5622:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5623:   strBaseString = strBaseString & "      End If" & vbNewLine
5624:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5625:   strBaseString = strBaseString & " " & vbNewLine
5626:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5627:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5628:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5629:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5630:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5631:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5632:   strBaseString = strBaseString & "      End If" & vbNewLine
5633:   strBaseString = strBaseString & "    End If" & vbNewLine
5634:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_1_Source"" Then" & vbNewLine
5635:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the closest feature to this feature.  "" & _" & vbNewLine
5636:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5637:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and TIGER_2012_Trans_Near_Park_UTM12_NAD83.  "" & _" & vbNewLine
5638:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters.""" & vbNewLine
5639:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5640:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5641:   strBaseString = strBaseString & "      End If" & vbNewLine
5642:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5643:   strBaseString = strBaseString & " " & vbNewLine
5644:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5645:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5646:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5647:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5648:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5649:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5650:   strBaseString = strBaseString & "      End If" & vbNewLine
5651:   strBaseString = strBaseString & "    End If" & vbNewLine
5652:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_1_Distance"" Then" & vbNewLine
5653:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
5654:   strBaseString = strBaseString & "           ""closest feature from one of 5 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
5655:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
5656:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5657:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and TIGER_2012_Trans_Near_Park_UTM12_NAD83.""" & vbNewLine
5658:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5659:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5660:   strBaseString = strBaseString & "      End If" & vbNewLine
5661:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5662:   strBaseString = strBaseString & " " & vbNewLine
5663:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5664:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5665:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5666:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5667:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5668:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5669:   strBaseString = strBaseString & "      End If" & vbNewLine
5670:   strBaseString = strBaseString & " " & vbNewLine
5671:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
5672:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
5673:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
5674:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
5675:   strBaseString = strBaseString & "    End If" & vbNewLine
5676:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_2"" Then" & vbNewLine
5677:   strBaseString = strBaseString & "      strDescription = """"""Use Level"""" indicates the transportation quality and accessibility of this feature, such as "" & _" & vbNewLine
5678:   strBaseString = strBaseString & "          ""distinguishing between paved roads and 4-wheel drive tracks.  This attribute field contains "" & _" & vbNewLine
5679:   strBaseString = strBaseString & "          ""the Use Level value from the 2nd-closest feature from 5 potential contributor feature "" & _" & vbNewLine
5680:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
5681:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
5682:   strBaseString = strBaseString & "          ""should be Null if there was no 2nd-closest feature within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
5683:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
5684:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"E_Map""""."" & vbCrLf & _" & vbNewLine
5685:   strBaseString = strBaseString & "          ""    - See description of """"BLM_E_Map"""" above for definitions."" & vbCrLf & _" & vbNewLine
5686:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"Status""""."" & vbCrLf & _" & vbNewLine
5687:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_Status"""" above for definition."" & vbCrLf & _" & vbNewLine
5688:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"OPER_MAINT""""."" & vbCrLf & _" & vbNewLine
5689:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Oper_Maint"""" above for definition."" & vbCrLf & _" & vbNewLine
5690:   strBaseString = strBaseString & "          "" - If from UTAH_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"SurfType""""."" & vbCrLf & _" & vbNewLine
5691:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_SurfType"""" above for definition."" & vbCrLf & _" & vbNewLine
5692:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"MT_FCLASS""""."" & vbCrLf & _" & vbNewLine
5693:   strBaseString = strBaseString & "          ""    - See description of """"TIG_MT_Fclass"""" above for definition."" & vbCrLf & _" & vbNewLine
5694:   strBaseString = strBaseString & "          vbCrLf & _" & vbNewLine
5695:   strBaseString = strBaseString & "          ""The feature classes Trails_KNF_UTM12_NAD83, Trails_UTM12_NAD83, Routes_UTM12_NAD83 and "" & _" & vbNewLine
5696:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83 did not have good attribute values to describe Use Level.""" & vbNewLine
5697:   strBaseString = strBaseString & " " & vbNewLine
5698:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5699:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5700:   strBaseString = strBaseString & "      End If" & vbNewLine
5701:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5702:   strBaseString = strBaseString & " " & vbNewLine
5703:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5704:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5705:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5706:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5707:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5708:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5709:   strBaseString = strBaseString & "      End If" & vbNewLine
5710:   strBaseString = strBaseString & "    End If" & vbNewLine
5711:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_2_Source"" Then" & vbNewLine
5712:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the 2nd-closest feature to this feature.  "" & _" & vbNewLine
5713:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5714:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and TIGER_2012_Trans_Near_Park_UTM12_NAD83.  "" & _" & vbNewLine
5715:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters.""" & vbNewLine
5716:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5717:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5718:   strBaseString = strBaseString & "      End If" & vbNewLine
5719:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5720:   strBaseString = strBaseString & " " & vbNewLine
5721:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5722:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5723:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5724:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5725:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5726:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5727:   strBaseString = strBaseString & "      End If" & vbNewLine
5728:   strBaseString = strBaseString & "    End If" & vbNewLine
5729:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_2_Distance"" Then" & vbNewLine
5730:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
5731:   strBaseString = strBaseString & "           ""2nd-closest feature from one of 5 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
5732:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
5733:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5734:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and TIGER_2012_Trans_Near_Park_UTM12_NAD83.""" & vbNewLine
5735:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5736:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5737:   strBaseString = strBaseString & "      End If" & vbNewLine
5738:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5739:   strBaseString = strBaseString & " " & vbNewLine
5740:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5741:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5742:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5743:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5744:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5745:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5746:   strBaseString = strBaseString & "      End If" & vbNewLine
5747:   strBaseString = strBaseString & " " & vbNewLine
5748:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
5749:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
5750:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
5751:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
5752:   strBaseString = strBaseString & "    End If" & vbNewLine
5753:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_3"" Then" & vbNewLine
5754:   strBaseString = strBaseString & "      strDescription = """"""Use Level"""" indicates the transportation quality and accessibility of this feature, such as "" & _" & vbNewLine
5755:   strBaseString = strBaseString & "          ""distinguishing between paved roads and 4-wheel drive tracks.  This attribute field contains "" & _" & vbNewLine
5756:   strBaseString = strBaseString & "          ""the Use Level value from the 3rd-closest feature from 5 potential contributor feature "" & _" & vbNewLine
5757:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
5758:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
5759:   strBaseString = strBaseString & "          ""should be Null if there was no 3rd-closest feature within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
5760:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
5761:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"E_Map""""."" & vbCrLf & _" & vbNewLine
5762:   strBaseString = strBaseString & "          ""    - See description of """"BLM_E_Map"""" above for definitions."" & vbCrLf & _" & vbNewLine
5763:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"Status""""."" & vbCrLf & _" & vbNewLine
5764:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_Status"""" above for definition."" & vbCrLf & _" & vbNewLine
5765:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"OPER_MAINT""""."" & vbCrLf & _" & vbNewLine
5766:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Oper_Maint"""" above for definition."" & vbCrLf & _" & vbNewLine
5767:   strBaseString = strBaseString & "          "" - If from UTAH_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"SurfType""""."" & vbCrLf & _" & vbNewLine
5768:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_SurfType"""" above for definition."" & vbCrLf & _" & vbNewLine
5769:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"MT_FCLASS""""."" & vbCrLf & _" & vbNewLine
5770:   strBaseString = strBaseString & "          ""    - See description of """"TIG_MT_Fclass"""" above for definition."" & vbCrLf & _" & vbNewLine
5771:   strBaseString = strBaseString & "          vbCrLf & _" & vbNewLine
5772:   strBaseString = strBaseString & "          ""The feature classes Trails_KNF_UTM12_NAD83, Trails_UTM12_NAD83, Routes_UTM12_NAD83 and "" & _" & vbNewLine
5773:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83 did not have good attribute values to describe Use Level.""" & vbNewLine
5774:   strBaseString = strBaseString & " " & vbNewLine
5775:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5776:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5777:   strBaseString = strBaseString & "      End If" & vbNewLine
5778:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5779:   strBaseString = strBaseString & " " & vbNewLine
5780:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5781:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5782:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5783:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5784:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5785:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5786:   strBaseString = strBaseString & "      End If" & vbNewLine
5787:   strBaseString = strBaseString & "    End If" & vbNewLine
5788:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_3_Source"" Then" & vbNewLine
5789:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the 3rd-closest feature to this feature.  "" & _" & vbNewLine
5790:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5791:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and TIGER_2012_Trans_Near_Park_UTM12_NAD83.  "" & _" & vbNewLine
5792:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters.""" & vbNewLine
5793:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5794:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5795:   strBaseString = strBaseString & "      End If" & vbNewLine
5796:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5797:   strBaseString = strBaseString & " " & vbNewLine
5798:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5799:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5800:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5801:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5802:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5803:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5804:   strBaseString = strBaseString & "      End If" & vbNewLine
5805:   strBaseString = strBaseString & "    End If" & vbNewLine
5806:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_3_Distance"" Then" & vbNewLine
5807:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
5808:   strBaseString = strBaseString & "           ""3rd-closest feature from one of 5 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
5809:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
5810:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5811:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and TIGER_2012_Trans_Near_Park_UTM12_NAD83.""" & vbNewLine
5812:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5813:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5814:   strBaseString = strBaseString & "      End If" & vbNewLine
5815:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5816:   strBaseString = strBaseString & " " & vbNewLine
5817:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5818:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5819:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5820:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5821:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5822:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5823:   strBaseString = strBaseString & "      End If" & vbNewLine
5824:   strBaseString = strBaseString & " " & vbNewLine
5825:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
5826:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
5827:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
5828:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
5829:   strBaseString = strBaseString & "    End If" & vbNewLine
5830:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_4"" Then" & vbNewLine
5831:   strBaseString = strBaseString & "      strDescription = """"""Use Level"""" indicates the transportation quality and accessibility of this feature, such as "" & _" & vbNewLine
5832:   strBaseString = strBaseString & "          ""distinguishing between paved roads and 4-wheel drive tracks.  This attribute field contains "" & _" & vbNewLine
5833:   strBaseString = strBaseString & "          ""the Use Level value from the 4th-closest feature from 5 potential contributor feature "" & _" & vbNewLine
5834:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
5835:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
5836:   strBaseString = strBaseString & "          ""should be Null if there was no 4th-closest feature within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
5837:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
5838:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"E_Map""""."" & vbCrLf & _" & vbNewLine
5839:   strBaseString = strBaseString & "          ""    - See description of """"BLM_E_Map"""" above for definitions."" & vbCrLf & _" & vbNewLine
5840:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"Status""""."" & vbCrLf & _" & vbNewLine
5841:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_Status"""" above for definition."" & vbCrLf & _" & vbNewLine
5842:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"OPER_MAINT""""."" & vbCrLf & _" & vbNewLine
5843:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Oper_Maint"""" above for definition."" & vbCrLf & _" & vbNewLine
5844:   strBaseString = strBaseString & "          "" - If from UTAH_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"SurfType""""."" & vbCrLf & _" & vbNewLine
5845:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_SurfType"""" above for definition."" & vbCrLf & _" & vbNewLine
5846:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"MT_FCLASS""""."" & vbCrLf & _" & vbNewLine
5847:   strBaseString = strBaseString & "          ""    - See description of """"TIG_MT_Fclass"""" above for definition."" & vbCrLf & _" & vbNewLine
5848:   strBaseString = strBaseString & "          vbCrLf & _" & vbNewLine
5849:   strBaseString = strBaseString & "          ""The feature classes Trails_KNF_UTM12_NAD83, Trails_UTM12_NAD83, Routes_UTM12_NAD83 and "" & _" & vbNewLine
5850:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83 did not have good attribute values to describe Use Level.""" & vbNewLine
5851:   strBaseString = strBaseString & " " & vbNewLine
5852:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5853:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5854:   strBaseString = strBaseString & "      End If" & vbNewLine
5855:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5856:   strBaseString = strBaseString & " " & vbNewLine
5857:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5858:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5859:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5860:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5861:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5862:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5863:   strBaseString = strBaseString & "      End If" & vbNewLine
5864:   strBaseString = strBaseString & "    End If" & vbNewLine
5865:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_4_Source"" Then" & vbNewLine
5866:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the 4th-closest feature to this feature.  "" & _" & vbNewLine
5867:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5868:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and TIGER_2012_Trans_Near_Park_UTM12_NAD83.  "" & _" & vbNewLine
5869:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters.""" & vbNewLine
5870:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5871:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5872:   strBaseString = strBaseString & "      End If" & vbNewLine
5873:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5874:   strBaseString = strBaseString & " " & vbNewLine
5875:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5876:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5877:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5878:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5879:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5880:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5881:   strBaseString = strBaseString & "      End If" & vbNewLine
5882:   strBaseString = strBaseString & "    End If" & vbNewLine
5883:   strBaseString = strBaseString & "   " & vbNewLine
5884:   strBaseString = strBaseString & "    If strFieldName = ""Use_Level_4_Distance"" Then" & vbNewLine
5885:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
5886:   strBaseString = strBaseString & "           ""4th-closest feature from one of 5 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
5887:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
5888:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5889:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83, UTAH_Roads_Near_AOI_UTM12_NAD83 and TIGER_2012_Trans_Near_Park_UTM12_NAD83.""" & vbNewLine
5890:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5891:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5892:   strBaseString = strBaseString & "      End If" & vbNewLine
5893:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5894:   strBaseString = strBaseString & " " & vbNewLine
5895:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5896:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5897:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5898:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5899:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5900:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5901:   strBaseString = strBaseString & "      End If" & vbNewLine
5902:   strBaseString = strBaseString & " " & vbNewLine
5903:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
5904:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
5905:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
5906:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
5907:   strBaseString = strBaseString & "    End If" & vbNewLine
5908:   strBaseString = strBaseString & " " & vbNewLine
5909:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
5910:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Final Types  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
5911:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
5912:   strBaseString = strBaseString & "    If strFieldName = ""Type_1"" Then" & vbNewLine
5913:   strBaseString = strBaseString & "      strDescription = ""This is the Type value from the TransportationLine_UTM12_NAD83 feature "" & _" & vbNewLine
5914:   strBaseString = strBaseString & "          ""class attribute field """"PrimaryUse"""".  This attribute field ONLY has values for features "" & _" & vbNewLine
5915:   strBaseString = strBaseString & "          ""INSIDE the Grand Canyon NP.  If this feature is outside the park boundaries, or if this "" & _" & vbNewLine
5916:   strBaseString = strBaseString & "          ""feature was imported from another feature "" & _" & vbNewLine
5917:   strBaseString = strBaseString & "          ""class, then this value will be either '<Null>' or '<-- No Value -->'.""" & vbNewLine
5918:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5919:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5920:   strBaseString = strBaseString & "      End If" & vbNewLine
5921:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5922:   strBaseString = strBaseString & " " & vbNewLine
5923:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5924:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5925:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5926:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5927:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5928:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5929:   strBaseString = strBaseString & "      End If" & vbNewLine
5930:   strBaseString = strBaseString & "    End If" & vbNewLine
5931:   strBaseString = strBaseString & "    If strFieldName = ""Type_2"" Then" & vbNewLine
5932:   strBaseString = strBaseString & "      strDescription = """"""Type"""" indicates the primary use or intended purpose of this feature, such as "" & _" & vbNewLine
5933:   strBaseString = strBaseString & "          ""distinguishing betweeen roads and hiking trails.  This attribute field contains "" & _" & vbNewLine
5934:   strBaseString = strBaseString & "          ""the Type value from the closest feature from 5 potential contributor feature "" & _" & vbNewLine
5935:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
5936:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
5937:   strBaseString = strBaseString & "          ""should be Null if there were no features within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
5938:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
5939:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then this value is concatenated from the three attribute fields "" & _" & vbNewLine
5940:   strBaseString = strBaseString & "          """"""OBS_USE1"""", """"OBS_USE2"""" and """"OBS_USE3""""."" & vbCrLf & _" & vbNewLine
5941:   strBaseString = strBaseString & "          ""    - See descriptions of """"BLM_OBS_USE1"""", """"BLM_OBS_USE2"""" and """"BLM_OBS_USE3"""" above for definitions."" & vbCrLf & _" & vbNewLine
5942:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"Lanes""""."" & vbCrLf & _" & vbNewLine
5943:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Lanes"""" above for definition."" & vbCrLf & _" & vbNewLine
5944:   strBaseString = strBaseString & "          "" - If from Trails_KNF_UTM12_NAD83, then the attribute field """"Designed_U""""."" & vbCrLf & _" & vbNewLine
5945:   strBaseString = strBaseString & "          ""    - See description of """"KNFTR_Designed_Use"""" above for definition."" & vbCrLf & _" & vbNewLine
5946:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"MT_FCLASS""""."" & vbCrLf & _" & vbNewLine
5947:   strBaseString = strBaseString & "          ""    - See description of """"TIG_MT_Fclass"""" above for definition."" & vbCrLf & _" & vbNewLine
5948:   strBaseString = strBaseString & "          "" - If from TransportationLine_UTM12_NAD83, then the attribute field """"PrimaryUse""""."" & vbCrLf & _" & vbNewLine
5949:   strBaseString = strBaseString & "          ""    - See description of """"PrimaryUse"""" above for definition."" & vbCrLf & _" & vbNewLine
5950:   strBaseString = strBaseString & "          vbCrLf & _" & vbNewLine
5951:   strBaseString = strBaseString & "          ""The feature classes Roads_UTM12_NAD83, Trails_UTM12_NAD83, Routes_UTM12_NAD83 and "" & _" & vbNewLine
5952:   strBaseString = strBaseString & "          ""Utah_Roads_Near_AOI_UTM12_NAD83 did not have good attribute values to describe Type.""" & vbNewLine
5953:   strBaseString = strBaseString & " " & vbNewLine
5954:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5955:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5956:   strBaseString = strBaseString & "      End If" & vbNewLine
5957:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5958:   strBaseString = strBaseString & " " & vbNewLine
5959:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5960:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5961:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5962:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5963:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5964:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5965:   strBaseString = strBaseString & "      End If" & vbNewLine
5966:   strBaseString = strBaseString & "    End If" & vbNewLine
5967:   strBaseString = strBaseString & "    If strFieldName = ""Type_2_Source"" Then" & vbNewLine
5968:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the closest feature to this feature.  "" & _" & vbNewLine
5969:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5970:   strBaseString = strBaseString & "          ""Trails_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83 and TransportationLine_UTM12_NAD83.  "" & _" & vbNewLine
5971:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters.""" & vbNewLine
5972:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5973:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5974:   strBaseString = strBaseString & "      End If" & vbNewLine
5975:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5976:   strBaseString = strBaseString & " " & vbNewLine
5977:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5978:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5979:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5980:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
5981:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
5982:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
5983:   strBaseString = strBaseString & "      End If" & vbNewLine
5984:   strBaseString = strBaseString & "    End If" & vbNewLine
5985:   strBaseString = strBaseString & "    If strFieldName = ""Type_2_Distance"" Then" & vbNewLine
5986:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
5987:   strBaseString = strBaseString & "           ""closest feature from one of 4 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
5988:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
5989:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
5990:   strBaseString = strBaseString & "          ""Trails_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83 and TransportationLine_UTM12_NAD83.""" & vbNewLine
5991:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
5992:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
5993:   strBaseString = strBaseString & "      End If" & vbNewLine
5994:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
5995:   strBaseString = strBaseString & " " & vbNewLine
5996:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
5997:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
5998:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
5999:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6000:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6001:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6002:   strBaseString = strBaseString & "      End If" & vbNewLine
6003:   strBaseString = strBaseString & " " & vbNewLine
6004:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
6005:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
6006:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
6007:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
6008:   strBaseString = strBaseString & "    End If" & vbNewLine
6009:   strBaseString = strBaseString & "    If strFieldName = ""Type_3"" Then" & vbNewLine
6010:   strBaseString = strBaseString & "      strDescription = """"""Type"""" indicates the primary use or intended purpose of this feature, such as "" & _" & vbNewLine
6011:   strBaseString = strBaseString & "          ""distinguishing betweeen roads and hiking trails.  "" & _" & vbNewLine
6012:   strBaseString = strBaseString & "          ""This attribute field contains "" & _" & vbNewLine
6013:   strBaseString = strBaseString & "          ""the Type value from the 2nd-closest feature from 5 potential contributor feature "" & _" & vbNewLine
6014:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
6015:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
6016:   strBaseString = strBaseString & "          ""should be Null if there was no 2nd-closest feature within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
6017:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
6018:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then this value is concatenated from the three attribute fields "" & _" & vbNewLine
6019:   strBaseString = strBaseString & "          """"""OBS_USE1"""", """"OBS_USE2"""" and """"OBS_USE3""""."" & vbCrLf & _" & vbNewLine
6020:   strBaseString = strBaseString & "          ""    - See descriptions of """"BLM_OBS_USE1"""", """"BLM_OBS_USE2"""" and """"BLM_OBS_USE3"""" above for definitions."" & vbCrLf & _" & vbNewLine
6021:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"Lanes""""."" & vbCrLf & _" & vbNewLine
6022:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Lanes"""" above for definition."" & vbCrLf & _" & vbNewLine
6023:   strBaseString = strBaseString & "          "" - If from Trails_KNF_UTM12_NAD83, then the attribute field """"Designed_U""""."" & vbCrLf & _" & vbNewLine
6024:   strBaseString = strBaseString & "          ""    - See description of """"KNFTR_Designed_Use"""" above for definition."" & vbCrLf & _" & vbNewLine
6025:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"MT_FCLASS""""."" & vbCrLf & _" & vbNewLine
6026:   strBaseString = strBaseString & "          ""    - See description of """"TIG_MT_Fclass"""" above for definition."" & vbCrLf & _" & vbNewLine
6027:   strBaseString = strBaseString & "          "" - If from TransportationLine_UTM12_NAD83, then the attribute field """"PrimaryUse""""."" & vbCrLf & _" & vbNewLine
6028:   strBaseString = strBaseString & "          ""    - See description of """"PrimaryUse"""" above for definition."" & vbCrLf & _" & vbNewLine
6029:   strBaseString = strBaseString & "          vbCrLf & _" & vbNewLine
6030:   strBaseString = strBaseString & "          ""The feature classes Roads_UTM12_NAD83, Trails_UTM12_NAD83, Routes_UTM12_NAD83 and "" & _" & vbNewLine
6031:   strBaseString = strBaseString & "          ""Utah_Roads_Near_AOI_UTM12_NAD83 did not have good attribute values to describe Type.""" & vbNewLine
6032:   strBaseString = strBaseString & " " & vbNewLine
6033:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6034:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6035:   strBaseString = strBaseString & "      End If" & vbNewLine
6036:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6037:   strBaseString = strBaseString & " " & vbNewLine
6038:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6039:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6040:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6041:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6042:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6043:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6044:   strBaseString = strBaseString & "      End If" & vbNewLine
6045:   strBaseString = strBaseString & "    End If" & vbNewLine
6046:   strBaseString = strBaseString & "    If strFieldName = ""Type_3_Source"" Then" & vbNewLine
6047:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the 2nd-closest feature to this feature.  "" & _" & vbNewLine
6048:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6049:   strBaseString = strBaseString & "          ""Trails_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83 and TransportationLine_UTM12_NAD83.  "" & _" & vbNewLine
6050:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters.""" & vbNewLine
6051:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6052:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6053:   strBaseString = strBaseString & "      End If" & vbNewLine
6054:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6055:   strBaseString = strBaseString & " " & vbNewLine
6056:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6057:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6058:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6059:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6060:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6061:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6062:   strBaseString = strBaseString & "      End If" & vbNewLine
6063:   strBaseString = strBaseString & "    End If" & vbNewLine
6064:   strBaseString = strBaseString & "    If strFieldName = ""Type_3_Distance"" Then" & vbNewLine
6065:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
6066:   strBaseString = strBaseString & "           ""2nd-closest feature from one of 4 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
6067:   strBaseString = strBaseString & "           ""of 10 meters."" & _" & vbNewLine
6068:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6069:   strBaseString = strBaseString & "          ""Trails_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83 and TransportationLine_UTM12_NAD83.""" & vbNewLine
6070:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6071:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6072:   strBaseString = strBaseString & "      End If" & vbNewLine
6073:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6074:   strBaseString = strBaseString & " " & vbNewLine
6075:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6076:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6077:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6078:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6079:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6080:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6081:   strBaseString = strBaseString & "      End If" & vbNewLine
6082:   strBaseString = strBaseString & " " & vbNewLine
6083:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
6084:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
6085:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
6086:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
6087:   strBaseString = strBaseString & "    End If" & vbNewLine
6088:   strBaseString = strBaseString & "    If strFieldName = ""Type_4"" Then" & vbNewLine
6089:   strBaseString = strBaseString & "      strDescription = """"""Type"""" indicates the primary use or intended purpose of this feature, such as "" & _" & vbNewLine
6090:   strBaseString = strBaseString & "          ""distinguishing betweeen roads and hiking trails.  "" & _" & vbNewLine
6091:   strBaseString = strBaseString & "          ""This attribute field contains "" & _" & vbNewLine
6092:   strBaseString = strBaseString & "          ""the Type value from the 3rd-closest feature from 5 potential contributor feature "" & _" & vbNewLine
6093:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
6094:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
6095:   strBaseString = strBaseString & "          ""should be Null if there was no 3rd-closest feature within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
6096:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
6097:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then this value is concatenated from the three attribute fields "" & _" & vbNewLine
6098:   strBaseString = strBaseString & "          """"""OBS_USE1"""", """"OBS_USE2"""" and """"OBS_USE3""""."" & vbCrLf & _" & vbNewLine
6099:   strBaseString = strBaseString & "          ""    - See descriptions of """"BLM_OBS_USE1"""", """"BLM_OBS_USE2"""" and """"BLM_OBS_USE3"""" above for definitions."" & vbCrLf & _" & vbNewLine
6100:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"Lanes""""."" & vbCrLf & _" & vbNewLine
6101:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Lanes"""" above for definition."" & vbCrLf & _" & vbNewLine
6102:   strBaseString = strBaseString & "          "" - If from Trails_KNF_UTM12_NAD83, then the attribute field """"Designed_U""""."" & vbCrLf & _" & vbNewLine
6103:   strBaseString = strBaseString & "          ""    - See description of """"KNFTR_Designed_Use"""" above for definition."" & vbCrLf & _" & vbNewLine
6104:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"MT_FCLASS""""."" & vbCrLf & _" & vbNewLine
6105:   strBaseString = strBaseString & "          ""    - See description of """"TIG_MT_Fclass"""" above for definition."" & vbCrLf & _" & vbNewLine
6106:   strBaseString = strBaseString & "          "" - If from TransportationLine_UTM12_NAD83, then the attribute field """"PrimaryUse""""."" & vbCrLf & _" & vbNewLine
6107:   strBaseString = strBaseString & "          ""    - See description of """"PrimaryUse"""" above for definition."" & vbCrLf & _" & vbNewLine
6108:   strBaseString = strBaseString & "          vbCrLf & _" & vbNewLine
6109:   strBaseString = strBaseString & "          ""The feature classes Roads_UTM12_NAD83, Trails_UTM12_NAD83, Routes_UTM12_NAD83 and "" & _" & vbNewLine
6110:   strBaseString = strBaseString & "          ""Utah_Roads_Near_AOI_UTM12_NAD83 did not have good attribute values to describe Type.""" & vbNewLine
6111:   strBaseString = strBaseString & " " & vbNewLine
6112:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6113:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6114:   strBaseString = strBaseString & "      End If" & vbNewLine
6115:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6116:   strBaseString = strBaseString & " " & vbNewLine
6117:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6118:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6119:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6120:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6121:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6122:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6123:   strBaseString = strBaseString & "      End If" & vbNewLine
6124:   strBaseString = strBaseString & "    End If" & vbNewLine
6125:   strBaseString = strBaseString & "    If strFieldName = ""Type_4_Source"" Then" & vbNewLine
6126:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the 3rd-closest feature to this feature.  "" & _" & vbNewLine
6127:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6128:   strBaseString = strBaseString & "          ""Trails_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83 and TransportationLine_UTM12_NAD83.  "" & _" & vbNewLine
6129:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters.""" & vbNewLine
6130:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6131:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6132:   strBaseString = strBaseString & "      End If" & vbNewLine
6133:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6134:   strBaseString = strBaseString & " " & vbNewLine
6135:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6136:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6137:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6138:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6139:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6140:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6141:   strBaseString = strBaseString & "      End If" & vbNewLine
6142:   strBaseString = strBaseString & "    End If" & vbNewLine
6143:   strBaseString = strBaseString & "    If strFieldName = ""Type_4_Distance"" Then" & vbNewLine
6144:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
6145:   strBaseString = strBaseString & "           ""3rd-closest feature from one of 4 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
6146:   strBaseString = strBaseString & "           ""of 10 meters."" & _" & vbNewLine
6147:   strBaseString = strBaseString & "          ""The 5 potential contributer feature classes are Roads_KNF_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6148:   strBaseString = strBaseString & "          ""Trails_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83 and TransportationLine_UTM12_NAD83.""" & vbNewLine
6149:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6150:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6151:   strBaseString = strBaseString & "      End If" & vbNewLine
6152:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6153:   strBaseString = strBaseString & " " & vbNewLine
6154:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6155:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6156:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6157:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6158:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6159:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6160:   strBaseString = strBaseString & "      End If" & vbNewLine
6161:   strBaseString = strBaseString & " " & vbNewLine
6162:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
6163:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
6164:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
6165:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
6166:   strBaseString = strBaseString & "    End If" & vbNewLine
6167:   strBaseString = strBaseString & "   " & vbNewLine
6168:   strBaseString = strBaseString & " " & vbNewLine
6169:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
6170:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Surface Types  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
6171:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
6172:   strBaseString = strBaseString & "    If strFieldName = ""SurfaceType_1"" Then" & vbNewLine
6173:   strBaseString = strBaseString & "      strDescription = """"""Surface_Type"""" indicates the construction material of this feature, "" & _" & vbNewLine
6174:   strBaseString = strBaseString & "          ""such as distinguishing betweeen paved, gravel and dirt roads.  "" & _" & vbNewLine
6175:   strBaseString = strBaseString & "          ""This is the Surface Type value from the TransportationLine_UTM12_NAD83 feature "" & _" & vbNewLine
6176:   strBaseString = strBaseString & "          ""class attribute field """"SurfaceMaterial"""".  This attribute field ONLY has values for features "" & _" & vbNewLine
6177:   strBaseString = strBaseString & "          ""INSIDE the Grand Canyon NP.  If this feature is outside the park boundaries, or if this "" & _" & vbNewLine
6178:   strBaseString = strBaseString & "          ""feature was imported from another feature "" & _" & vbNewLine
6179:   strBaseString = strBaseString & "          ""class, then this value will be either '<Null>' or '<-- No Value -->'.""" & vbNewLine
6180:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6181:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6182:   strBaseString = strBaseString & "      End If" & vbNewLine
6183:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6184:   strBaseString = strBaseString & " " & vbNewLine
6185:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6186:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6187:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6188:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6189:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6190:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6191:   strBaseString = strBaseString & "      End If" & vbNewLine
6192:   strBaseString = strBaseString & "    End If" & vbNewLine
6193:   strBaseString = strBaseString & "    If strFieldName = ""SurfaceType_2"" Then" & vbNewLine
6194:   strBaseString = strBaseString & "      strDescription = """"""Surface_Type"""" indicates the construction material of this feature, "" & _" & vbNewLine
6195:   strBaseString = strBaseString & "          ""such as distinguishing betweeen paved, gravel and dirt roads.  "" & _" & vbNewLine
6196:   strBaseString = strBaseString & "          ""This is the Surface Type value from the closest feature from 6 potential contributor feature "" & _" & vbNewLine
6197:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
6198:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
6199:   strBaseString = strBaseString & "          ""should be Null if there were no features within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
6200:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
6201:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"SurfaceMaterial""""."" & vbCrLf & _" & vbNewLine
6202:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_SurfaceMaterial"""" above for definition."" & vbCrLf & _" & vbNewLine
6203:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"Surface_PR""""."" & vbCrLf & _" & vbNewLine
6204:   strBaseString = strBaseString & "          ""    - See description of """"BLM_Surface_PR"""" above for definition."" & vbCrLf & _" & vbNewLine
6205:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"SURFACE_TY""""."" & vbCrLf & _" & vbNewLine
6206:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Surface_Type"""" above for definition."" & vbCrLf & _" & vbNewLine
6207:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"MT_FCLASS""""."" & vbCrLf & _" & vbNewLine
6208:   strBaseString = strBaseString & "          ""    - See description of """"TIG_MT_Fclass"""" above for definition."" & vbCrLf & _" & vbNewLine
6209:   strBaseString = strBaseString & "          "" - If from Utah_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"SurfType""""."" & vbCrLf & _" & vbNewLine
6210:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_SurfType"""" above for definition."" & vbCrLf & _" & vbNewLine
6211:   strBaseString = strBaseString & "          "" - If from TransportationLine_UTM12_NAD83, then the attribute field """"SurfaceMaterial""""."" & vbCrLf & _" & vbNewLine
6212:   strBaseString = strBaseString & "          ""    - See description of """"SurfaceMaterial"""" above for definition."" & vbCrLf & _" & vbNewLine
6213:   strBaseString = strBaseString & "          vbCrLf & _" & vbNewLine
6214:   strBaseString = strBaseString & "          ""The feature classes Trails_KNF_UTM12_NAD83, Trails_UTM12_NAD83 and Routes_UTM12_NAD83 did not "" & _" & vbNewLine
6215:   strBaseString = strBaseString & "          ""have good attribute values to describe Surface Type.""" & vbNewLine
6216:   strBaseString = strBaseString & " " & vbNewLine
6217:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6218:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6219:   strBaseString = strBaseString & "      End If" & vbNewLine
6220:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6221:   strBaseString = strBaseString & " " & vbNewLine
6222:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6223:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6224:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6225:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6226:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6227:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6228:   strBaseString = strBaseString & "      End If" & vbNewLine
6229:   strBaseString = strBaseString & "    End If" & vbNewLine
6230:   strBaseString = strBaseString & "    If strFieldName = ""SurfaceType_2_Source"" Then" & vbNewLine
6231:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the closest feature to this feature.  "" & _" & vbNewLine
6232:   strBaseString = strBaseString & "          ""The 6 potential contributer feature classes are Roads_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6233:   strBaseString = strBaseString & "          ""Roads_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83, Utah_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
6234:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.  "" & _" & vbNewLine
6235:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters.""" & vbNewLine
6236:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6237:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6238:   strBaseString = strBaseString & "      End If" & vbNewLine
6239:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6240:   strBaseString = strBaseString & " " & vbNewLine
6241:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6242:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6243:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6244:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6245:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6246:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6247:   strBaseString = strBaseString & "      End If" & vbNewLine
6248:   strBaseString = strBaseString & " " & vbNewLine
6249:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6250:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6251:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6252:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6253:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6254:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6255:   strBaseString = strBaseString & "      End If" & vbNewLine
6256:   strBaseString = strBaseString & "    End If" & vbNewLine
6257:   strBaseString = strBaseString & "    If strFieldName = ""SurfaceType_2_Distance"" Then" & vbNewLine
6258:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
6259:   strBaseString = strBaseString & "           ""closest feature from one of 5 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
6260:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
6261:   strBaseString = strBaseString & "          ""The 6 potential contributer feature classes are Roads_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6262:   strBaseString = strBaseString & "          ""Roads_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83, Utah_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
6263:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.""" & vbNewLine
6264:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6265:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6266:   strBaseString = strBaseString & "      End If" & vbNewLine
6267:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6268:   strBaseString = strBaseString & " " & vbNewLine
6269:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6270:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6271:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6272:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6273:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6274:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6275:   strBaseString = strBaseString & "      End If" & vbNewLine
6276:   strBaseString = strBaseString & " " & vbNewLine
6277:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
6278:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
6279:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
6280:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
6281:   strBaseString = strBaseString & "    End If" & vbNewLine
6282:   strBaseString = strBaseString & "    If strFieldName = ""SurfaceType_3"" Then" & vbNewLine
6283:   strBaseString = strBaseString & "      strDescription = """"""Surface_Type"""" indicates the construction material of this feature, "" & _" & vbNewLine
6284:   strBaseString = strBaseString & "          ""such as distinguishing betweeen paved, gravel and dirt roads.  "" & _" & vbNewLine
6285:   strBaseString = strBaseString & "          ""This is the Surface Type value from the second closest feature from 6 potential contributor feature "" & _" & vbNewLine
6286:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
6287:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
6288:   strBaseString = strBaseString & "          ""should be Null if there was no 2nd-closest feature within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
6289:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
6290:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"SurfaceMaterial""""."" & vbCrLf & _" & vbNewLine
6291:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_SurfaceMaterial"""" above for definition."" & vbCrLf & _" & vbNewLine
6292:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"Surface_PR""""."" & vbCrLf & _" & vbNewLine
6293:   strBaseString = strBaseString & "          ""    - See description of """"BLM_Surface_PR"""" above for definition."" & vbCrLf & _" & vbNewLine
6294:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"SURFACE_TY""""."" & vbCrLf & _" & vbNewLine
6295:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Surface_Type"""" above for definition."" & vbCrLf & _" & vbNewLine
6296:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"MT_FCLASS""""."" & vbCrLf & _" & vbNewLine
6297:   strBaseString = strBaseString & "          ""    - See description of """"TIG_MT_Fclass"""" above for definition."" & vbCrLf & _" & vbNewLine
6298:   strBaseString = strBaseString & "          "" - If from Utah_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"SurfType""""."" & vbCrLf & _" & vbNewLine
6299:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_SurfType"""" above for definition."" & vbCrLf & _" & vbNewLine
6300:   strBaseString = strBaseString & "          "" - If from TransportationLine_UTM12_NAD83, then the attribute field """"SurfaceMaterial""""."" & vbCrLf & _" & vbNewLine
6301:   strBaseString = strBaseString & "          ""    - See description of """"SurfaceMaterial"""" above for definition."" & vbCrLf & _" & vbNewLine
6302:   strBaseString = strBaseString & "          vbCrLf & _" & vbNewLine
6303:   strBaseString = strBaseString & "          ""The feature classes Trails_KNF_UTM12_NAD83, Trails_UTM12_NAD83 and Routes_UTM12_NAD83 did not "" & _" & vbNewLine
6304:   strBaseString = strBaseString & "          ""have good attribute values to describe Surface Type.""" & vbNewLine
6305:   strBaseString = strBaseString & " " & vbNewLine
6306:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6307:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6308:   strBaseString = strBaseString & "      End If" & vbNewLine
6309:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6310:   strBaseString = strBaseString & " " & vbNewLine
6311:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6312:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6313:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6314:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6315:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6316:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6317:   strBaseString = strBaseString & "      End If" & vbNewLine
6318:   strBaseString = strBaseString & "    End If" & vbNewLine
6319:   strBaseString = strBaseString & "    If strFieldName = ""SurfaceType_3_Source"" Then" & vbNewLine
6320:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the second closest feature to this feature.  "" & _" & vbNewLine
6321:   strBaseString = strBaseString & "          ""The 6 potential contributer feature classes are Roads_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6322:   strBaseString = strBaseString & "          ""Roads_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83, Utah_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
6323:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.""" & vbNewLine
6324:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6325:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6326:   strBaseString = strBaseString & "      End If" & vbNewLine
6327:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6328:   strBaseString = strBaseString & " " & vbNewLine
6329:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6330:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6331:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6332:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6333:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6334:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6335:   strBaseString = strBaseString & "      End If" & vbNewLine
6336:   strBaseString = strBaseString & "    End If" & vbNewLine
6337:   strBaseString = strBaseString & "    If strFieldName = ""SurfaceType_3_Distance"" Then" & vbNewLine
6338:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
6339:   strBaseString = strBaseString & "           ""second closest feature from one of 5 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
6340:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
6341:   strBaseString = strBaseString & "          ""The 6 potential contributer feature classes are Roads_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6342:   strBaseString = strBaseString & "          ""Roads_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83, Utah_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
6343:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.""" & vbNewLine
6344:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6345:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6346:   strBaseString = strBaseString & "      End If" & vbNewLine
6347:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6348:   strBaseString = strBaseString & " " & vbNewLine
6349:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6350:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6351:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6352:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6353:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6354:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6355:   strBaseString = strBaseString & "      End If" & vbNewLine
6356:   strBaseString = strBaseString & " " & vbNewLine
6357:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
6358:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
6359:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
6360:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
6361:   strBaseString = strBaseString & "    End If" & vbNewLine
6362:   strBaseString = strBaseString & "    If strFieldName = ""SurfaceType_4"" Then" & vbNewLine
6363:   strBaseString = strBaseString & "      strDescription = """"""Surface_Type"""" indicates the construction material of this feature, "" & _" & vbNewLine
6364:   strBaseString = strBaseString & "          ""such as distinguishing betweeen paved, gravel and dirt roads.  "" & _" & vbNewLine
6365:   strBaseString = strBaseString & "          ""This is the Surface Type value from the 3rd-closest feature from 6 potential contributor feature "" & _" & vbNewLine
6366:   strBaseString = strBaseString & "          ""classes, where distance is defined as the distance from the centerpoint of this feature to the "" & _" & vbNewLine
6367:   strBaseString = strBaseString & "          ""nearest point on the nearby feature.  The maximum distance considered was 10 meters.  This value "" & _" & vbNewLine
6368:   strBaseString = strBaseString & "          ""should be Null if there was no 3rd-closest feature within 10m."" & vbCrLf & vbCrLf & _" & vbNewLine
6369:   strBaseString = strBaseString & "          ""This attribute value was drawn from different attribute fields depending on the feature class:"" & vbCrLf & _" & vbNewLine
6370:   strBaseString = strBaseString & "          "" - If from Roads_UTM12_NAD83, then the attribute field """"SurfaceMaterial""""."" & vbCrLf & _" & vbNewLine
6371:   strBaseString = strBaseString & "          ""    - See description of """"ROADS_SurfaceMaterial"""" above for definition."" & vbCrLf & _" & vbNewLine
6372:   strBaseString = strBaseString & "          "" - If from BLM_AZStrip_UTM12_NAD83, then the attribute field """"Surface_PR""""."" & vbCrLf & _" & vbNewLine
6373:   strBaseString = strBaseString & "          ""    - See description of """"BLM_Surface_PR"""" above for definition."" & vbCrLf & _" & vbNewLine
6374:   strBaseString = strBaseString & "          "" - If from Roads_KNF_UTM12_NAD83, then the attribute field """"SURFACE_TY""""."" & vbCrLf & _" & vbNewLine
6375:   strBaseString = strBaseString & "          ""    - See description of """"KNF_Surface_Type"""" above for definition."" & vbCrLf & _" & vbNewLine
6376:   strBaseString = strBaseString & "          "" - If from TIGER_2012_Trans_Near_Park_UTM12_NAD83, then the attribute field """"MT_FCLASS""""."" & vbCrLf & _" & vbNewLine
6377:   strBaseString = strBaseString & "          ""    - See description of """"TIG_MT_Fclass"""" above for definition."" & vbCrLf & _" & vbNewLine
6378:   strBaseString = strBaseString & "          "" - If from Utah_Roads_Near_AOI_UTM12_NAD83, then the attribute field """"SurfType""""."" & vbCrLf & _" & vbNewLine
6379:   strBaseString = strBaseString & "          ""    - See description of """"UTAH_SurfType"""" above for definition."" & vbCrLf & _" & vbNewLine
6380:   strBaseString = strBaseString & "          "" - If from TransportationLine_UTM12_NAD83, then the attribute field """"SurfaceMaterial""""."" & vbCrLf & _" & vbNewLine
6381:   strBaseString = strBaseString & "          ""    - See description of """"SurfaceMaterial"""" above for definition."" & vbCrLf & _" & vbNewLine
6382:   strBaseString = strBaseString & "          vbCrLf & _" & vbNewLine
6383:   strBaseString = strBaseString & "          ""The feature classes Trails_KNF_UTM12_NAD83, Trails_UTM12_NAD83 and Routes_UTM12_NAD83 did not "" & _" & vbNewLine
6384:   strBaseString = strBaseString & "          ""have good attribute values to describe Surface Type.""" & vbNewLine
6385:   strBaseString = strBaseString & " " & vbNewLine
6386:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6387:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6388:   strBaseString = strBaseString & "      End If" & vbNewLine
6389:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6390:   strBaseString = strBaseString & " " & vbNewLine
6391:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6392:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6393:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6394:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6395:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6396:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6397:   strBaseString = strBaseString & "      End If" & vbNewLine
6398:   strBaseString = strBaseString & "    End If" & vbNewLine
6399:   strBaseString = strBaseString & "    If strFieldName = ""SurfaceType_4_Source"" Then" & vbNewLine
6400:   strBaseString = strBaseString & "      strDescription = ""This is the name of the feature class containing the 3rd closest feature to this feature.  "" & _" & vbNewLine
6401:   strBaseString = strBaseString & "          ""The 6 potential contributer feature classes are Roads_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6402:   strBaseString = strBaseString & "          ""Roads_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83, Utah_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
6403:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.  "" & _" & vbNewLine
6404:   strBaseString = strBaseString & "          ""The maximum distance considered was 10 meters.""" & vbNewLine
6405:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6406:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6407:   strBaseString = strBaseString & "      End If" & vbNewLine
6408:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6409:   strBaseString = strBaseString & " " & vbNewLine
6410:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6411:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6412:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6413:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6414:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6415:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6416:   strBaseString = strBaseString & "      End If" & vbNewLine
6417:   strBaseString = strBaseString & "    End If" & vbNewLine
6418:   strBaseString = strBaseString & "    If strFieldName = ""SurfaceType_4_Distance"" Then" & vbNewLine
6419:   strBaseString = strBaseString & "      strDescription = ""This is the distance in meters from the centroid of this feature to any part of the "" & _" & vbNewLine
6420:   strBaseString = strBaseString & "           ""3rd-closest feature from one of 5 potential contributor feature classes, up to a maximum distance "" & _" & vbNewLine
6421:   strBaseString = strBaseString & "           ""of 10 meters.  "" & _" & vbNewLine
6422:   strBaseString = strBaseString & "          ""The 6 potential contributer feature classes are Roads_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6423:   strBaseString = strBaseString & "          ""Roads_KNF_UTM12_NAD83, TIGER_2012_Trans_Near_Park_UTM12_NAD83, Utah_Roads_Near_AOI_UTM12_NAD83 and "" & _" & vbNewLine
6424:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83.""" & vbNewLine
6425:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6426:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6427:   strBaseString = strBaseString & "      End If" & vbNewLine
6428:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6429:   strBaseString = strBaseString & " " & vbNewLine
6430:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6431:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6432:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6433:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6434:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6435:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6436:   strBaseString = strBaseString & "      End If" & vbNewLine
6437:   strBaseString = strBaseString & " " & vbNewLine
6438:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
6439:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
6440:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""10""" & vbNewLine
6441:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
6442:   strBaseString = strBaseString & "    End If" & vbNewLine
6443:   strBaseString = strBaseString & " " & vbNewLine
6444:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
6445:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Nearest  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
6446:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
6447:   strBaseString = strBaseString & "    If strFieldName = ""Nearest_Source"" Then" & vbNewLine
6448:   strBaseString = strBaseString & "      strDescription = ""This feature class is derived primarily from the polyline features of the "" & _" & vbNewLine
6449:   strBaseString = strBaseString & "          ""GCNP feature class """"TransportationLine_UTM12_NAD83"""", but the attributes for these features "" & _" & vbNewLine
6450:   strBaseString = strBaseString & "          ""are extracted from 8 other feature classes based on proximity ([1] BLM_AZStrip_UTM12_NAD83, [2] "" & _" & vbNewLine
6451:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, "" & _" & vbNewLine
6452:   strBaseString = strBaseString & "          ""[3] Roads_KNF_UTM12_NAD83, [4] Utah_Roads_Near_AOI_UTM12_NAD83, [5] Trails_KNF_UTM12_NAD83, "" & _" & vbNewLine
6453:   strBaseString = strBaseString & "          ""[6] Roads_UTM12_NAD83, [7] Trails_UTM12_NAD83 or [8] Routes_UTM12_NAD83)."" & vbCrLf & vbCrLf & _" & vbNewLine
6454:   strBaseString = strBaseString & "          ""This attribute field shows the name of the feature class containing the closest feature to the "" & _" & vbNewLine
6455:   strBaseString = strBaseString & "          ""centroid of this feature, up to a maximum distance of 100m.  "" & _" & vbNewLine
6456:   strBaseString = strBaseString & "          ""This closest feature is used as a candidate to extract attribute values from.""" & vbNewLine
6457:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6458:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6459:   strBaseString = strBaseString & "      End If" & vbNewLine
6460:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6461:   strBaseString = strBaseString & " " & vbNewLine
6462:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6463:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6464:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6465:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6466:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6467:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6468:   strBaseString = strBaseString & "      End If" & vbNewLine
6469:   strBaseString = strBaseString & "    End If" & vbNewLine
6470:   strBaseString = strBaseString & "    If strFieldName = ""Nearest_OID"" Then" & vbNewLine
6471:   strBaseString = strBaseString & "      strDescription = ""This feature class is derived primarily from the polyline features of the "" & _" & vbNewLine
6472:   strBaseString = strBaseString & "          ""GCNP feature class """"TransportationLine_UTM12_NAD83"""", but the attributes for these features "" & _" & vbNewLine
6473:   strBaseString = strBaseString & "          ""are extracted from 8 other feature classes based on proximity ([1] BLM_AZStrip_UTM12_NAD83, [2] "" & _" & vbNewLine
6474:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, "" & _" & vbNewLine
6475:   strBaseString = strBaseString & "          ""[3] Roads_KNF_UTM12_NAD83, [4] Utah_Roads_Near_AOI_UTM12_NAD83, [5] Trails_KNF_UTM12_NAD83, "" & _" & vbNewLine
6476:   strBaseString = strBaseString & "          ""[6] Roads_UTM12_NAD83, [7] Trails_UTM12_NAD83 or [8] Routes_UTM12_NAD83)."" & vbCrLf & vbCrLf & _" & vbNewLine
6477:   strBaseString = strBaseString & "          ""This attribute field shows the OID value of the closest feature from these 8 feature classes to the "" & _" & vbNewLine
6478:   strBaseString = strBaseString & "          ""centroid of this feature, up to a maximum distance of 100m.  "" & _" & vbNewLine
6479:   strBaseString = strBaseString & "          ""This closest feature is used as a candidate to extract attribute values from.""" & vbNewLine
6480:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6481:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6482:   strBaseString = strBaseString & "      End If" & vbNewLine
6483:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6484:   strBaseString = strBaseString & " " & vbNewLine
6485:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6486:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6487:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6488:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6489:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6490:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6491:   strBaseString = strBaseString & "      End If" & vbNewLine
6492:   strBaseString = strBaseString & "    End If" & vbNewLine
6493:   strBaseString = strBaseString & "    If strFieldName = ""Nearest_Distance"" Then" & vbNewLine
6494:   strBaseString = strBaseString & "      strDescription = ""This feature class is derived primarily from the polyline features of the "" & _" & vbNewLine
6495:   strBaseString = strBaseString & "          ""GCNP feature class """"TransportationLine_UTM12_NAD83"""", but the attributes for these features "" & _" & vbNewLine
6496:   strBaseString = strBaseString & "          ""are extracted from 8 other feature classes based on proximity ([1] BLM_AZStrip_UTM12_NAD83, [2] "" & _" & vbNewLine
6497:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, "" & _" & vbNewLine
6498:   strBaseString = strBaseString & "          ""[3] Roads_KNF_UTM12_NAD83, [4] Utah_Roads_Near_AOI_UTM12_NAD83, [5] Trails_KNF_UTM12_NAD83, "" & _" & vbNewLine
6499:   strBaseString = strBaseString & "          ""[6] Roads_UTM12_NAD83, [7] Trails_UTM12_NAD83 or [8] Routes_UTM12_NAD83)."" & vbCrLf & vbCrLf & _" & vbNewLine
6500:   strBaseString = strBaseString & "          ""This attribute field shows the distance in meters to the closest feature from these 8 feature classes to the "" & _" & vbNewLine
6501:   strBaseString = strBaseString & "          ""centroid of this feature, up to a maximum distance of 100m.  "" & _" & vbNewLine
6502:   strBaseString = strBaseString & "          ""This closest feature is used as a candidate to extract attribute values from.""" & vbNewLine
6503:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6504:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6505:   strBaseString = strBaseString & "      End If" & vbNewLine
6506:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6507:   strBaseString = strBaseString & " " & vbNewLine
6508:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6509:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6510:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6511:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6512:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6513:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6514:   strBaseString = strBaseString & "      End If" & vbNewLine
6515:   strBaseString = strBaseString & " " & vbNewLine
6516:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
6517:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
6518:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""100""" & vbNewLine
6519:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
6520:   strBaseString = strBaseString & "    End If" & vbNewLine
6521:   strBaseString = strBaseString & " " & vbNewLine
6522:   strBaseString = strBaseString & " " & vbNewLine
6523:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
6524:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Ownership  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
6525:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
6526:   strBaseString = strBaseString & " " & vbNewLine
6527:   strBaseString = strBaseString & "   ' 2 OWNERSHIP FIELDS" & vbNewLine
6528:   strBaseString = strBaseString & "   ' IF ARIZONA, THEN 1ST OWNERSHIP FIELD IS FROM ""OWN.SHP"" FIELD [DESC_]" & vbNewLine
6529:   strBaseString = strBaseString & "   '                  2ND OWNERSHIP FIELD IS FROM ""OWN.SHP"" FIELD [CATEGORY]" & vbNewLine
6530:   strBaseString = strBaseString & "   ' IF UTAH, THEN 1ST OWNERSHIP FIELD IS FROM ""LandOwnership"" FIELD [UT_LGD]; ALIAS ""UTAH BLM LEGEND""" & vbNewLine
6531:   strBaseString = strBaseString & "   '               2ND OWNERSHIP FIELD IS FROM ""LandOwnership"" FIELD [ADMIN]" & vbNewLine
6532:   strBaseString = strBaseString & " " & vbNewLine
6533:   strBaseString = strBaseString & "    If strFieldName = ""State"" Then" & vbNewLine
6534:   strBaseString = strBaseString & "      strDescription = ""The State that this feature lies in.  This value will be """"UTAH"""" if the "" & _" & vbNewLine
6535:   strBaseString = strBaseString & "          ""feature was extracted from either the Utah Roads feature class (Utah_Roads_New_AOI_UTM12_NAD83) or "" & _" & vbNewLine
6536:   strBaseString = strBaseString & "          ""from the Utah portion of the TIGER_2012_Trans_Near_Park_UTM12_NAD83 feature class.  Otherwise "" & _" & vbNewLine
6537:   strBaseString = strBaseString & "          ""this value will be """"Arizona"""".""" & vbNewLine
6538:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6539:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6540:   strBaseString = strBaseString & "      End If" & vbNewLine
6541:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6542:   strBaseString = strBaseString & " " & vbNewLine
6543:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6544:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6545:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6546:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6547:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6548:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6549:   strBaseString = strBaseString & "      End If" & vbNewLine
6550:   strBaseString = strBaseString & "    End If" & vbNewLine
6551:   strBaseString = strBaseString & " " & vbNewLine
6552:   strBaseString = strBaseString & "    If strFieldName = ""Ownership_1"" Then" & vbNewLine
6553:   strBaseString = strBaseString & "      strDescription = ""This value contains the agency or owner who is responsible for the polygon this "" & _" & vbNewLine
6554:   strBaseString = strBaseString & "          ""feature lies in. Therefore, this value is not guaranteed to show the true """"owner"""" of the polyline, "" & _" & vbNewLine
6555:   strBaseString = strBaseString & "          ""but rather the most likely responsible party."" & vbCrLf & vbCrLf & _" & vbNewLine
6556:   strBaseString = strBaseString & "          ""If the transportation feature is in Arizona, then the """"Ownership_1"""" is extracted from the "" & _" & vbNewLine
6557:   strBaseString = strBaseString & "          ""attribute field """"DESC_"""" in the Arizona Land Ownership feature class """"OWN""""."" & vbCrLf & vbCrLf & _" & vbNewLine
6558:   strBaseString = strBaseString & "          ""If the transportation feature is in Utah, then the """"Ownership_1"""" is extracted from the "" & _" & vbNewLine
6559:   strBaseString = strBaseString & "          ""attribute field """"UT_LGD"""", alias """"UTAH BLM LEGEND"""" in the Utah Land Ownership feature "" & _" & vbNewLine
6560:   strBaseString = strBaseString & "          ""class """"LandOwnership"""".""" & vbNewLine
6561:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6562:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6563:   strBaseString = strBaseString & "      End If" & vbNewLine
6564:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6565:   strBaseString = strBaseString & " " & vbNewLine
6566:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6567:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6568:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6569:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6570:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6571:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6572:   strBaseString = strBaseString & "      End If" & vbNewLine
6573:   strBaseString = strBaseString & "    End If" & vbNewLine
6574:   strBaseString = strBaseString & "    If strFieldName = ""Ownership_2"" Then" & vbNewLine
6575:   strBaseString = strBaseString & "      strDescription = ""This value contains the agency or owner who is responsible for the polygon this "" & _" & vbNewLine
6576:   strBaseString = strBaseString & "          ""feature lies in. Therefore, this value is not guaranteed to show the true """"owner"""" of the polyline, "" & _" & vbNewLine
6577:   strBaseString = strBaseString & "          ""but rather the most likely responsible party."" & vbCrLf & vbCrLf & _" & vbNewLine
6578:   strBaseString = strBaseString & "          ""If the transportation feature is in Arizona, then the """"Ownership_2"""" is extracted from the "" & _" & vbNewLine
6579:   strBaseString = strBaseString & "          ""attribute field """"CATEGORY"""" in the Arizona Land Ownership feature class """"OWN""""."" & vbCrLf & vbCrLf & _" & vbNewLine
6580:   strBaseString = strBaseString & "          ""If the transportation feature is in Utah, then the """"Ownership_1"""" is extracted from the "" & _" & vbNewLine
6581:   strBaseString = strBaseString & "          ""attribute field """"UT_LGD"""", alias """"UTAH BLM LEGEND"""" in the Utah Land Ownership feature "" & _" & vbNewLine
6582:   strBaseString = strBaseString & "          ""class """"ADMIN"""".""" & vbNewLine
6583:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6584:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6585:   strBaseString = strBaseString & "      End If" & vbNewLine
6586:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6587:   strBaseString = strBaseString & " " & vbNewLine
6588:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6589:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6590:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6591:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6592:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6593:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6594:   strBaseString = strBaseString & "      End If" & vbNewLine
6595:   strBaseString = strBaseString & "    End If" & vbNewLine
6596:   strBaseString = strBaseString & " " & vbNewLine
6597:   strBaseString = strBaseString & " " & vbNewLine
6598:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
6599:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  ADD_Feature, etc.  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
6600:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
6601:   strBaseString = strBaseString & "    If strFieldName = ""Add_Feature"" Then" & vbNewLine
6602:   strBaseString = strBaseString & "      strDescription = """"""TRUE"""" or """"FALSE"""", where """"True"""" indicates that this feature came from one of the "" & _" & vbNewLine
6603:   strBaseString = strBaseString & "          ""ancillary feature classes ([1] BLM_AZStrip_UTM12_NAD83, [2] TIGER_2012_Trans_Near_Park_UTM12_NAD83, "" & _" & vbNewLine
6604:   strBaseString = strBaseString & "          ""[3] Roads_KNF_UTM12_NAD83, [4] Utah_Roads_Near_AOI_UTM12_NAD83, [5] Trails_KNF_UTM12_NAD83, "" & _" & vbNewLine
6605:   strBaseString = strBaseString & "          ""[6] Roads_UTM12_NAD83, [7] Trails_UTM12_NAD83 or [8] Routes_UTM12_NAD83), and """"FALSE"""" indicates "" & _" & vbNewLine
6606:   strBaseString = strBaseString & "          ""that this feature came from the original TransportationLine_UTM12_NAD83 feature class.""" & vbNewLine
6607:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6608:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6609:   strBaseString = strBaseString & "      End If" & vbNewLine
6610:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6611:   strBaseString = strBaseString & " " & vbNewLine
6612:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6613:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6614:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6615:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6616:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6617:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6618:   strBaseString = strBaseString & "      End If" & vbNewLine
6619:   strBaseString = strBaseString & "    End If" & vbNewLine
6620:   strBaseString = strBaseString & "    If strFieldName = ""Add_Feature_Source"" Then" & vbNewLine
6621:   strBaseString = strBaseString & "      strDescription = ""The name of the source feature class that this feature was extracted from.  Possible "" & _" & vbNewLine
6622:   strBaseString = strBaseString & "          ""values are TransportationLine_UTM12_NAD83, BLM_AZStrip_UTM12_NAD83, "" & _" & vbNewLine
6623:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83, Roads_KNF_UTM12_NAD83, Utah_Roads_Near_AOI_UTM12_NAD83, "" & _" & vbNewLine
6624:   strBaseString = strBaseString & "          ""[5] Trails_KNF_UTM12_NAD83, Roads_UTM12_NAD83, Trails_UTM12_NAD83 or Routes_UTM12_NAD83.""" & vbNewLine
6625:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6626:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6627:   strBaseString = strBaseString & "      End If" & vbNewLine
6628:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6629:   strBaseString = strBaseString & " " & vbNewLine
6630:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6631:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6632:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6633:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6634:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6635:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6636:   strBaseString = strBaseString & "      End If" & vbNewLine
6637:   strBaseString = strBaseString & "    End If" & vbNewLine
6638:   strBaseString = strBaseString & "    If strFieldName = ""Add_Date"" Then" & vbNewLine
6639:   strBaseString = strBaseString & "      strDescription = ""The date that this feature was extracted from the ancillary feature class and added to "" & _" & vbNewLine
6640:   strBaseString = strBaseString & "          ""this feature class.""" & vbNewLine
6641:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6642:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6643:   strBaseString = strBaseString & "      End If" & vbNewLine
6644:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6645:   strBaseString = strBaseString & " " & vbNewLine
6646:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6647:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6648:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6649:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6650:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6651:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6652:   strBaseString = strBaseString & "      End If" & vbNewLine
6653:   strBaseString = strBaseString & "    End If" & vbNewLine
6654:   strBaseString = strBaseString & "    If strFieldName = ""Add_Name"" Then" & vbNewLine
6655:   strBaseString = strBaseString & "      strDescription = ""The person who added this feature.  JJENNESS = Jeff Jenness, jeffj@jennessent.com""" & vbNewLine
6656:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6657:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6658:   strBaseString = strBaseString & "      End If" & vbNewLine
6659:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6660:   strBaseString = strBaseString & " " & vbNewLine
6661:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6662:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6663:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6664:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6665:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6666:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6667:   strBaseString = strBaseString & "      End If" & vbNewLine
6668:   strBaseString = strBaseString & "    End If" & vbNewLine
6669:   strBaseString = strBaseString & "    If strFieldName = ""Add_OID"" Then" & vbNewLine
6670:   strBaseString = strBaseString & "      strDescription = ""The Object ID value of the feature in the original feature class.""" & vbNewLine
6671:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6672:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6673:   strBaseString = strBaseString & "      End If" & vbNewLine
6674:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6675:   strBaseString = strBaseString & " " & vbNewLine
6676:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6677:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6678:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6679:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6680:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6681:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6682:   strBaseString = strBaseString & "      End If" & vbNewLine
6683:   strBaseString = strBaseString & "    End If" & vbNewLine
6684:   strBaseString = strBaseString & "    If strFieldName = ""Geometry_Modified"" Then" & vbNewLine
6685:   strBaseString = strBaseString & "      strDescription = ""All features in this feature class were imported from one of nine source feature "" & _" & vbNewLine
6686:   strBaseString = strBaseString & "          ""classes (([1] BLM_AZStrip_UTM12_NAD83, [2] TIGER_2012_Trans_Near_Park_UTM12_NAD83, "" & _" & vbNewLine
6687:   strBaseString = strBaseString & "          ""[3] Roads_KNF_UTM12_NAD83, [4] Utah_Roads_Near_AOI_UTM12_NAD83, [5] Trails_KNF_UTM12_NAD83, "" & _" & vbNewLine
6688:   strBaseString = strBaseString & "          ""[6] Roads_UTM12_NAD83, [7] Trails_UTM12_NAD83, [8] Routes_UTM12_NAD83 or [9] "" & _" & vbNewLine
6689:   strBaseString = strBaseString & "          ""TransportationLine_UTM12_NAD83).  This attribute field contains """"TRUE"""" or """"FALSE"""" values "" & _" & vbNewLine
6690:   strBaseString = strBaseString & "          ""indicating whether the geometry was modified after being imported into this feature class. "" & vbCrLf & vbCrLf & _" & vbNewLine
6691:   strBaseString = strBaseString & "          ""In general, the most likely reason a geometry would be altered from its original state would "" & _" & vbNewLine
6692:   strBaseString = strBaseString & "          ""be to make it match topologically with the other features.""" & vbNewLine
6693:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6694:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6695:   strBaseString = strBaseString & "      End If" & vbNewLine
6696:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6697:   strBaseString = strBaseString & " " & vbNewLine
6698:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6699:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6700:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6701:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6702:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6703:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6704:   strBaseString = strBaseString & "      End If" & vbNewLine
6705:   strBaseString = strBaseString & "    End If" & vbNewLine
6706:   strBaseString = strBaseString & " " & vbNewLine
6707:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
6708:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Trails_KNF_UTM12_NAD83  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
6709:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
6710:   strBaseString = strBaseString & "    If strFieldName = ""KNFTR_Add_Attribute"" Then" & vbNewLine
6711:   strBaseString = strBaseString & "      strDescription = """"""TRUE"""" or """"FALSE"""", whether there was a polyline feature from the 'Trails_KNF_UTM12_NAD83' "" & _" & vbNewLine
6712:   strBaseString = strBaseString & "          ""feature class within 100m of the centroid of this polyline.  If so, then this '"" & _" & vbNewLine
6713:   strBaseString = strBaseString & "          ""Trails_KNF_UTM12_NAD83' feature would be considered a candidate for extracting attribute values "" & _" & vbNewLine
6714:   strBaseString = strBaseString & "          ""to describe this feature.""" & vbNewLine
6715:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6716:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6717:   strBaseString = strBaseString & "      End If" & vbNewLine
6718:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6719:   strBaseString = strBaseString & " " & vbNewLine
6720:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6721:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6722:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6723:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6724:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6725:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6726:   strBaseString = strBaseString & "      End If" & vbNewLine
6727:   strBaseString = strBaseString & "    End If" & vbNewLine
6728:   strBaseString = strBaseString & "    If strFieldName = ""KNFTR_Attribute_Source"" Then" & vbNewLine
6729:   strBaseString = strBaseString & "      strDescription = ""If 'KNFTR_Add_Attribute' above = """"TRUE"""", then this field will contain the name of the "" & _" & vbNewLine
6730:   strBaseString = strBaseString & "          ""Kaibab NF Trails feature class (Trails_KNF_UTM12_NAD83).  Otherwise it should be Null.""" & vbNewLine
6731:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6732:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6733:   strBaseString = strBaseString & "      End If" & vbNewLine
6734:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6735:   strBaseString = strBaseString & " " & vbNewLine
6736:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6737:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6738:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6739:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6740:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6741:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6742:   strBaseString = strBaseString & "      End If" & vbNewLine
6743:   strBaseString = strBaseString & "    End If" & vbNewLine
6744:   strBaseString = strBaseString & "    If strFieldName = ""KNFTR_Attribute_Distance"" Then" & vbNewLine
6745:   strBaseString = strBaseString & "      strDescription = ""If 'KNFTR_Add_Attribute' above = """"TRUE"""", then this field will contain the distance "" & _" & vbNewLine
6746:   strBaseString = strBaseString & "          ""(in meters) from the centroid of this polyline to the nearest Kaibab NF Trails feature.  Otherwise it should be Null.  "" & _" & vbNewLine
6747:   strBaseString = strBaseString & "          ""Values should always be <= 100m.""" & vbNewLine
6748:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6749:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6750:   strBaseString = strBaseString & "      End If" & vbNewLine
6751:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6752:   strBaseString = strBaseString & " " & vbNewLine
6753:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6754:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6755:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6756:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6757:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6758:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6759:   strBaseString = strBaseString & "      End If" & vbNewLine
6760:   strBaseString = strBaseString & " " & vbNewLine
6761:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
6762:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
6763:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""100""" & vbNewLine
6764:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
6765:   strBaseString = strBaseString & "    End If" & vbNewLine
6766:   strBaseString = strBaseString & "    If strFieldName = ""KNFTR_ObjectID"" Then" & vbNewLine
6767:   strBaseString = strBaseString & "      strDescription = ""If 'KNFTR_Add_Attribute' above = """"TRUE"""", then this field will contain the OBJECTID "" & _" & vbNewLine
6768:   strBaseString = strBaseString & "          ""value of the nearest Kaibab NF Trails feature, from the Trails_KNF_UTM12_NAD83 feature class.""" & vbNewLine
6769:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6770:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6771:   strBaseString = strBaseString & "      End If" & vbNewLine
6772:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6773:   strBaseString = strBaseString & " " & vbNewLine
6774:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6775:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6776:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6777:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6778:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6779:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6780:   strBaseString = strBaseString & "      End If" & vbNewLine
6781:   strBaseString = strBaseString & "    End If" & vbNewLine
6782:   strBaseString = strBaseString & " " & vbNewLine
6783:   strBaseString = strBaseString & "    For lngKNFTR_Index = 0 To UBound(strKNFTR_RoadArray, 1)" & vbNewLine
6784:   strBaseString = strBaseString & "      If strFieldName = strKNFTR_RoadArray(lngKNFTR_Index, 0) Then '  ""BLM_OBS_USE1"", ""BLM_OBS_USE2"" or ""BLM_OBS_USE3""" & vbNewLine
6785:   strBaseString = strBaseString & " " & vbNewLine
6786:   strBaseString = strBaseString & "        ' FIND ORIGINAL FIELD METADATA" & vbNewLine
6787:   strBaseString = strBaseString & "        For lngIndex = 0 To pTrails_KNF_UTM12_NAD83_FClass.Fields.FieldCount" & vbNewLine
6788:   strBaseString = strBaseString & "          strNames(0) = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
6789:   strBaseString = strBaseString & "          pTrails_KNF_UTM12_NAD83_PropSet.GetProperties strNames, varVals" & vbNewLine
6790:   strBaseString = strBaseString & "          varSubVals = varVals(0)" & vbNewLine
6791:   strBaseString = strBaseString & "          If Not IsEmpty(varSubVals) Then" & vbNewLine
6792:   strBaseString = strBaseString & "            ' GET FIELD NAME" & vbNewLine
6793:   strBaseString = strBaseString & "            strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrlabl""" & vbNewLine
6794:   strBaseString = strBaseString & "            varProperty = pTrails_KNF_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
6795:   strBaseString = strBaseString & "            If Not IsEmpty(varProperty) Then" & vbNewLine
6796:   strBaseString = strBaseString & "              varSubProperty = varProperty(0)" & vbNewLine
6797:   strBaseString = strBaseString & "              If IsEmpty(varSubProperty) Then" & vbNewLine
6798:   strBaseString = strBaseString & "                strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
6799:   strBaseString = strBaseString & "              Else" & vbNewLine
6800:   strBaseString = strBaseString & "                strOrigFieldName = CStr(varSubProperty)" & vbNewLine
6801:   strBaseString = strBaseString & "              End If" & vbNewLine
6802:   strBaseString = strBaseString & "            Else" & vbNewLine
6803:   strBaseString = strBaseString & "              strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
6804:   strBaseString = strBaseString & "            End If" & vbNewLine
6805:   strBaseString = strBaseString & " " & vbNewLine
6806:   strBaseString = strBaseString & "            If strOrigFieldName = strKNFTR_RoadArray(lngKNFTR_Index, 1) Then ' ""OBS_USE1"", ""OBS_USE2"", or ""OBS_USE3""" & vbNewLine
6807:   strBaseString = strBaseString & " " & vbNewLine
6808:   strBaseString = strBaseString & "              ' CHECK IF DOMAIN INFO" & vbNewLine
6809:   strBaseString = strBaseString & "              strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
6810:   strBaseString = strBaseString & "              varProperty = pTrails_KNF_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
6811:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
6812:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
6813:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
6814:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2))" & vbNewLine
6815:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
6816:   strBaseString = strBaseString & " " & vbNewLine
6817:   strBaseString = strBaseString & "                ' GET DOMAIN ATTRIBUTES FROM ORIGINAL FCLASS" & vbNewLine
6818:   strBaseString = strBaseString & "                strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
6819:   strBaseString = strBaseString & "                varProperty = pTrails_KNF_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
6820:   strBaseString = strBaseString & " " & vbNewLine
6821:   strBaseString = strBaseString & "                ' ADD DOMAIN ATTRIBUTES TO NEW FCLASS" & vbNewLine
6822:   strBaseString = strBaseString & "                varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv"")" & vbNewLine
6823:   strBaseString = strBaseString & "                If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
6824:   strBaseString = strBaseString & "                  pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv""" & vbNewLine
6825:   strBaseString = strBaseString & "                End If" & vbNewLine
6826:   strBaseString = strBaseString & "                For lngIndex3 = 0 To UBound(varProperty)" & vbNewLine
6827:   strBaseString = strBaseString & "                  strSubXName1 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
6828:   strBaseString = strBaseString & "                      varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
6829:   strBaseString = strBaseString & "                  varSubProp1 = pTrails_KNF_UTM12_NAD83_PropSet.GetProperty(strSubXName1)" & vbNewLine
6830:   strBaseString = strBaseString & " " & vbNewLine
6831:   strBaseString = strBaseString & "                  If UBound(varSubProp1) = 0 Then" & vbNewLine
6832:   strBaseString = strBaseString & "                    strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
6833:   strBaseString = strBaseString & "                        varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
6834:   strBaseString = strBaseString & "                    strValue = varSubProp1(0)" & vbNewLine
6835:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
6836:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
6837:   strBaseString = strBaseString & "                    pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
6838:   strBaseString = strBaseString & "                  Else" & vbNewLine
6839:   strBaseString = strBaseString & "                    For lngIndex4 = 0 To UBound(varSubProp1)" & vbNewLine
6840:   strBaseString = strBaseString & "                      strSubXName2 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
6841:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
6842:   strBaseString = strBaseString & "                      varSubProp2 = pTrails_KNF_UTM12_NAD83_PropSet.GetProperty(strSubXName2)" & vbNewLine
6843:   strBaseString = strBaseString & " " & vbNewLine
6844:   strBaseString = strBaseString & "                      ' WRITE VALUE BACK TO NEW FCLASS" & vbNewLine
6845:   strBaseString = strBaseString & "                      strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
6846:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
6847:   strBaseString = strBaseString & "                      strValue = varSubProp2(0)" & vbNewLine
6848:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
6849:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
6850:   strBaseString = strBaseString & "                      pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
6851:   strBaseString = strBaseString & " " & vbNewLine
6852:   strBaseString = strBaseString & "                    Next lngIndex4" & vbNewLine
6853:   strBaseString = strBaseString & "                  End If" & vbNewLine
6854:   strBaseString = strBaseString & "                Next lngIndex3" & vbNewLine
6855:   strBaseString = strBaseString & "              Else" & vbNewLine
6856:   strBaseString = strBaseString & "'                strOrigFCLassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
6857:   strBaseString = strBaseString & "'                varProperty = pTrails_KNF_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)" & vbNewLine
6858:   strBaseString = strBaseString & "'                varSubProperty = varProperty(0)" & vbNewLine
6859:   strBaseString = strBaseString & "'                Debug.Print ""Examining "" & strOrigFieldName & ""...""" & vbNewLine
6860:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
6861:   strBaseString = strBaseString & "'                  varSubProp1 = pTrails_KNF_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName & ""/"" & _" & vbNewLine
6862:   strBaseString = strBaseString & "'                        CStr(varProperty(lngIndex2)))" & vbNewLine
6863:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2)) & "" = "" & _" & vbNewLine
6864:   strBaseString = strBaseString & "'                        CStr(varSubProp1(0))" & vbNewLine
6865:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
6866:   strBaseString = strBaseString & "              End If" & vbNewLine
6867:   strBaseString = strBaseString & " " & vbNewLine
6868:   strBaseString = strBaseString & "              If strOrigFieldName = ""ROAD_NO_"" Then" & vbNewLine
6869:   strBaseString = strBaseString & "                Debug.Print ""Here...""" & vbNewLine
6870:   strBaseString = strBaseString & "              End If" & vbNewLine
6871:   strBaseString = strBaseString & " " & vbNewLine
6872:   strBaseString = strBaseString & "              ' GET DEFINITION FROM ORIGINAL FCLASS" & vbNewLine
6873:   strBaseString = strBaseString & "              varProperty = pTrails_KNF_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdef"")" & vbNewLine
6874:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
6875:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
6876:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
6877:   strBaseString = strBaseString & "                  strDescription = ""<-- No Description -->""" & vbNewLine
6878:   strBaseString = strBaseString & "                Else" & vbNewLine
6879:   strBaseString = strBaseString & "                  strDescription = CStr(varSubProperty)" & vbNewLine
6880:   strBaseString = strBaseString & "                  strDescription = Trim(strDescription)" & vbNewLine
6881:   strBaseString = strBaseString & "                  If Right(strDescription, 1) <> ""."" And Right(strDescription, 1) <> ""!"" And _" & vbNewLine
6882:   strBaseString = strBaseString & "                      Right(strDescription, 1) <> ""?"" Then" & vbNewLine
6883:   strBaseString = strBaseString & "                    strDescription = strDescription & "".""" & vbNewLine
6884:   strBaseString = strBaseString & "                  End If" & vbNewLine
6885:   strBaseString = strBaseString & "                End If" & vbNewLine
6886:   strBaseString = strBaseString & "              Else" & vbNewLine
6887:   strBaseString = strBaseString & "                strDescription = ""<-- No Description -->""" & vbNewLine
6888:   strBaseString = strBaseString & "              End If" & vbNewLine
6889:   strBaseString = strBaseString & "              strDescription = Replace(strDescription, ""  [Imported from TransportationLine_UTM12_NAD83]"", """", , , vbTextCompare)" & vbNewLine
6890:   strBaseString = strBaseString & "              strDescription = strDescription & _" & vbNewLine
6891:   strBaseString = strBaseString & "                  ""  This field should only have a value if the 'KNFTR_Add_Attribute' value = """"TRUE"""".  "" & _" & vbNewLine
6892:   strBaseString = strBaseString & "                  ""[Imported from Trails_KNF_UTM12_NAD83, Field """""" & strKNFTR_RoadArray(lngKNFTR_Index, 1) & """"""]""" & vbNewLine
6893:   strBaseString = strBaseString & " " & vbNewLine
6894:   strBaseString = strBaseString & "              ' SET FIELD DEFINITION OF NEW FCLASS" & vbNewLine
6895:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"")" & vbNewLine
6896:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
6897:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef""" & vbNewLine
6898:   strBaseString = strBaseString & "              End If" & vbNewLine
6899:   strBaseString = strBaseString & "              pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"", strDescription" & vbNewLine
6900:   strBaseString = strBaseString & " " & vbNewLine
6901:   strBaseString = strBaseString & "              ' GET DESCRIPTION SOURCE FROM ORIGINAL FCLASS" & vbNewLine
6902:   strBaseString = strBaseString & "              varProperty = pTrails_KNF_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdefs"")" & vbNewLine
6903:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
6904:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
6905:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
6906:   strBaseString = strBaseString & "                  strDescriptionSource = ""Trails_KNF_UTM12_NAD83""" & vbNewLine
6907:   strBaseString = strBaseString & "                Else" & vbNewLine
6908:   strBaseString = strBaseString & "                  strDescriptionSource = CStr(varSubProperty)" & vbNewLine
6909:   strBaseString = strBaseString & "                End If" & vbNewLine
6910:   strBaseString = strBaseString & "              Else" & vbNewLine
6911:   strBaseString = strBaseString & "                strDescriptionSource = ""Trails_KNF_UTM12_NAD83""" & vbNewLine
6912:   strBaseString = strBaseString & "              End If" & vbNewLine
6913:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""Dicitonary"", ""Dictionary"", , , vbTextCompare)" & vbNewLine
6914:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""20003"", ""2003"", , , vbTextCompare)" & vbNewLine
6915:   strBaseString = strBaseString & " " & vbNewLine
6916:   strBaseString = strBaseString & "              ' SET DESCRIPTION SOURCE DEFINITION OF NEW FCLASS" & vbNewLine
6917:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"")" & vbNewLine
6918:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
6919:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs""" & vbNewLine
6920:   strBaseString = strBaseString & "              End If" & vbNewLine
6921:   strBaseString = strBaseString & " " & vbNewLine
6922:   strBaseString = strBaseString & "              ' ONLY ADD THIS NEW ONE IF THERE WAS ONE IN THE ORIGINAL FCLASS" & vbNewLine
6923:   strBaseString = strBaseString & "              If strDescriptionSource <> """" Then" & vbNewLine
6924:   strBaseString = strBaseString & "                pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"", strDescriptionSource" & vbNewLine
6925:   strBaseString = strBaseString & "              End If" & vbNewLine
6926:   strBaseString = strBaseString & " " & vbNewLine
6927:   strBaseString = strBaseString & "              Exit For" & vbNewLine
6928:   strBaseString = strBaseString & "            End If" & vbNewLine
6929:   strBaseString = strBaseString & "          End If" & vbNewLine
6930:   strBaseString = strBaseString & "        Next lngIndex" & vbNewLine
6931:   strBaseString = strBaseString & "      End If" & vbNewLine
6932:   strBaseString = strBaseString & "    Next lngKNFTR_Index" & vbNewLine
6933:   strBaseString = strBaseString & " " & vbNewLine
6934:   strBaseString = strBaseString & "   " & vbNewLine
6935:   strBaseString = strBaseString & " " & vbNewLine
6936:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
6937:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Utah_Roads_Near_AOI_UTM12_NAD83  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
6938:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
6939:   strBaseString = strBaseString & "    If strFieldName = ""UTAH_Add_Attribute"" Then" & vbNewLine
6940:   strBaseString = strBaseString & "      strDescription = """"""TRUE"""" or """"FALSE"""", whether there was a polyline feature from the 'Utah_Roads_Near_AOI_UTM12_NAD83' "" & _" & vbNewLine
6941:   strBaseString = strBaseString & "          ""feature class within 100m of the centroid of this polyline.  If so, then this '"" & _" & vbNewLine
6942:   strBaseString = strBaseString & "          ""Utah_Roads_Near_AOI_UTM12_NAD83' feature would be considered a candidate for extracting attribute values "" & _" & vbNewLine
6943:   strBaseString = strBaseString & "          ""to describe this feature.""" & vbNewLine
6944:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6945:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6946:   strBaseString = strBaseString & "      End If" & vbNewLine
6947:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6948:   strBaseString = strBaseString & " " & vbNewLine
6949:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6950:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6951:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6952:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6953:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6954:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6955:   strBaseString = strBaseString & "      End If" & vbNewLine
6956:   strBaseString = strBaseString & "    End If" & vbNewLine
6957:   strBaseString = strBaseString & "    If strFieldName = ""UTAH_Attribute_Source"" Then" & vbNewLine
6958:   strBaseString = strBaseString & "      strDescription = ""If 'UTAH_Add_Attribute' above = """"TRUE"""", then this field will contain the name of the "" & _" & vbNewLine
6959:   strBaseString = strBaseString & "          ""Utah Roads feature class (Utah_Roads_Near_AOI_UTM12_NAD83).  Otherwise it should be Null.""" & vbNewLine
6960:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6961:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6962:   strBaseString = strBaseString & "      End If" & vbNewLine
6963:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6964:   strBaseString = strBaseString & " " & vbNewLine
6965:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6966:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6967:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6968:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6969:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6970:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6971:   strBaseString = strBaseString & "      End If" & vbNewLine
6972:   strBaseString = strBaseString & "    End If" & vbNewLine
6973:   strBaseString = strBaseString & "    If strFieldName = ""UTAH_Attribute_Distance"" Then" & vbNewLine
6974:   strBaseString = strBaseString & "      strDescription = ""If 'UTAH_Add_Attribute' above = """"TRUE"""", then this field will contain the distance "" & _" & vbNewLine
6975:   strBaseString = strBaseString & "          ""(in meters) from the centroid of this polyline to the nearest Utah Roads feature.  Otherwise it should be Null.  "" & _" & vbNewLine
6976:   strBaseString = strBaseString & "          ""Values should always be <= 100m.""" & vbNewLine
6977:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6978:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
6979:   strBaseString = strBaseString & "      End If" & vbNewLine
6980:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
6981:   strBaseString = strBaseString & " " & vbNewLine
6982:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
6983:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
6984:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
6985:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
6986:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
6987:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
6988:   strBaseString = strBaseString & "      End If" & vbNewLine
6989:   strBaseString = strBaseString & " " & vbNewLine
6990:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
6991:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
6992:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""100""" & vbNewLine
6993:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
6994:   strBaseString = strBaseString & "    End If" & vbNewLine
6995:   strBaseString = strBaseString & "    If strFieldName = ""UTAH_ObjectID"" Then" & vbNewLine
6996:   strBaseString = strBaseString & "      strDescription = ""If 'UTAH_Add_Attribute' above = """"TRUE"""", then this field will contain the OBJECTID "" & _" & vbNewLine
6997:   strBaseString = strBaseString & "          ""value of the nearest Utah Roads feature, from the Utah_Roads_Near_AOI_UTM12_NAD83 feature class.""" & vbNewLine
6998:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
6999:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7000:   strBaseString = strBaseString & "      End If" & vbNewLine
7001:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7002:   strBaseString = strBaseString & " " & vbNewLine
7003:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7004:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7005:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7006:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7007:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7008:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7009:   strBaseString = strBaseString & "      End If" & vbNewLine
7010:   strBaseString = strBaseString & "    End If" & vbNewLine
7011:   strBaseString = strBaseString & " " & vbNewLine
7012:   strBaseString = strBaseString & "    For lngUtah_Index = 0 To UBound(strUtah_RoadArray, 1)" & vbNewLine
7013:   strBaseString = strBaseString & "      If strFieldName = strUtah_RoadArray(lngUtah_Index, 0) Then '  ""BLM_OBS_USE1"", ""BLM_OBS_USE2"" or ""BLM_OBS_USE3""" & vbNewLine
7014:   strBaseString = strBaseString & " " & vbNewLine
7015:   strBaseString = strBaseString & "        ' FIND ORIGINAL FIELD METADATA" & vbNewLine
7016:   strBaseString = strBaseString & "        For lngIndex = 0 To pUtah_Roads_Near_AOI_UTM12_NAD83_FClass.Fields.FieldCount" & vbNewLine
7017:   strBaseString = strBaseString & "          strNames(0) = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
7018:   strBaseString = strBaseString & "          pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet.GetProperties strNames, varVals" & vbNewLine
7019:   strBaseString = strBaseString & "          varSubVals = varVals(0)" & vbNewLine
7020:   strBaseString = strBaseString & "          If Not IsEmpty(varSubVals) Then" & vbNewLine
7021:   strBaseString = strBaseString & "            ' GET FIELD NAME" & vbNewLine
7022:   strBaseString = strBaseString & "            strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrlabl""" & vbNewLine
7023:   strBaseString = strBaseString & "            varProperty = pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7024:   strBaseString = strBaseString & "            If Not IsEmpty(varProperty) Then" & vbNewLine
7025:   strBaseString = strBaseString & "              varSubProperty = varProperty(0)" & vbNewLine
7026:   strBaseString = strBaseString & "              If IsEmpty(varSubProperty) Then" & vbNewLine
7027:   strBaseString = strBaseString & "                strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
7028:   strBaseString = strBaseString & "              Else" & vbNewLine
7029:   strBaseString = strBaseString & "                strOrigFieldName = CStr(varSubProperty)" & vbNewLine
7030:   strBaseString = strBaseString & "              End If" & vbNewLine
7031:   strBaseString = strBaseString & "            Else" & vbNewLine
7032:   strBaseString = strBaseString & "              strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
7033:   strBaseString = strBaseString & "            End If" & vbNewLine
7034:   strBaseString = strBaseString & " " & vbNewLine
7035:   strBaseString = strBaseString & "            If strOrigFieldName = strUtah_RoadArray(lngUtah_Index, 1) Then ' ""OBS_USE1"", ""OBS_USE2"", or ""OBS_USE3""" & vbNewLine
7036:   strBaseString = strBaseString & " " & vbNewLine
7037:   strBaseString = strBaseString & "              ' CHECK IF DOMAIN INFO" & vbNewLine
7038:   strBaseString = strBaseString & "              strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
7039:   strBaseString = strBaseString & "              varProperty = pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7040:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7041:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7042:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
7043:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2))" & vbNewLine
7044:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
7045:   strBaseString = strBaseString & " " & vbNewLine
7046:   strBaseString = strBaseString & "                ' GET DOMAIN ATTRIBUTES FROM ORIGINAL FCLASS" & vbNewLine
7047:   strBaseString = strBaseString & "                strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
7048:   strBaseString = strBaseString & "                varProperty = pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7049:   strBaseString = strBaseString & " " & vbNewLine
7050:   strBaseString = strBaseString & "                ' ADD DOMAIN ATTRIBUTES TO NEW FCLASS" & vbNewLine
7051:   strBaseString = strBaseString & "                varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv"")" & vbNewLine
7052:   strBaseString = strBaseString & "                If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7053:   strBaseString = strBaseString & "                  pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv""" & vbNewLine
7054:   strBaseString = strBaseString & "                End If" & vbNewLine
7055:   strBaseString = strBaseString & "                For lngIndex3 = 0 To UBound(varProperty)" & vbNewLine
7056:   strBaseString = strBaseString & "                  strSubXName1 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
7057:   strBaseString = strBaseString & "                      varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
7058:   strBaseString = strBaseString & "                  varSubProp1 = pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet.GetProperty(strSubXName1)" & vbNewLine
7059:   strBaseString = strBaseString & " " & vbNewLine
7060:   strBaseString = strBaseString & "                  If UBound(varSubProp1) = 0 Then" & vbNewLine
7061:   strBaseString = strBaseString & "                    strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
7062:   strBaseString = strBaseString & "                        varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
7063:   strBaseString = strBaseString & "                    strValue = varSubProp1(0)" & vbNewLine
7064:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
7065:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
7066:   strBaseString = strBaseString & "                    pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
7067:   strBaseString = strBaseString & "                  Else" & vbNewLine
7068:   strBaseString = strBaseString & "                    For lngIndex4 = 0 To UBound(varSubProp1)" & vbNewLine
7069:   strBaseString = strBaseString & "                      strSubXName2 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
7070:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
7071:   strBaseString = strBaseString & "                      varSubProp2 = pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet.GetProperty(strSubXName2)" & vbNewLine
7072:   strBaseString = strBaseString & " " & vbNewLine
7073:   strBaseString = strBaseString & "                      ' WRITE VALUE BACK TO NEW FCLASS" & vbNewLine
7074:   strBaseString = strBaseString & "                      strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
7075:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
7076:   strBaseString = strBaseString & "                      strValue = varSubProp2(0)" & vbNewLine
7077:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
7078:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
7079:   strBaseString = strBaseString & "                      pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
7080:   strBaseString = strBaseString & " " & vbNewLine
7081:   strBaseString = strBaseString & "                    Next lngIndex4" & vbNewLine
7082:   strBaseString = strBaseString & "                  End If" & vbNewLine
7083:   strBaseString = strBaseString & "                Next lngIndex3" & vbNewLine
7084:   strBaseString = strBaseString & "              Else" & vbNewLine
7085:   strBaseString = strBaseString & "'                strOrigFCLassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
7086:   strBaseString = strBaseString & "'                varProperty = pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)" & vbNewLine
7087:   strBaseString = strBaseString & "'                varSubProperty = varProperty(0)" & vbNewLine
7088:   strBaseString = strBaseString & "'                Debug.Print ""Examining "" & strOrigFieldName & ""...""" & vbNewLine
7089:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
7090:   strBaseString = strBaseString & "'                  varSubProp1 = pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName & ""/"" & _" & vbNewLine
7091:   strBaseString = strBaseString & "'                        CStr(varProperty(lngIndex2)))" & vbNewLine
7092:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2)) & "" = "" & _" & vbNewLine
7093:   strBaseString = strBaseString & "'                        CStr(varSubProp1(0))" & vbNewLine
7094:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
7095:   strBaseString = strBaseString & "              End If" & vbNewLine
7096:   strBaseString = strBaseString & " " & vbNewLine
7097:   strBaseString = strBaseString & "              If strOrigFieldName = ""ROAD_NO_"" Then" & vbNewLine
7098:   strBaseString = strBaseString & "                Debug.Print ""Here...""" & vbNewLine
7099:   strBaseString = strBaseString & "              End If" & vbNewLine
7100:   strBaseString = strBaseString & " " & vbNewLine
7101:   strBaseString = strBaseString & "              ' GET DEFINITION FROM ORIGINAL FCLASS" & vbNewLine
7102:   strBaseString = strBaseString & "              varProperty = pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdef"")" & vbNewLine
7103:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7104:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7105:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
7106:   strBaseString = strBaseString & "                  strDescription = ""<-- No Description -->""" & vbNewLine
7107:   strBaseString = strBaseString & "                Else" & vbNewLine
7108:   strBaseString = strBaseString & "                  strDescription = CStr(varSubProperty)" & vbNewLine
7109:   strBaseString = strBaseString & "                  strDescription = Trim(strDescription)" & vbNewLine
7110:   strBaseString = strBaseString & "                  If Right(strDescription, 1) <> ""."" And Right(strDescription, 1) <> ""!"" And _" & vbNewLine
7111:   strBaseString = strBaseString & "                      Right(strDescription, 1) <> ""?"" Then" & vbNewLine
7112:   strBaseString = strBaseString & "                    strDescription = strDescription & "".""" & vbNewLine
7113:   strBaseString = strBaseString & "                  End If" & vbNewLine
7114:   strBaseString = strBaseString & "                End If" & vbNewLine
7115:   strBaseString = strBaseString & "              Else" & vbNewLine
7116:   strBaseString = strBaseString & "                strDescription = ""<-- No Description -->""" & vbNewLine
7117:   strBaseString = strBaseString & "              End If" & vbNewLine
7118:   strBaseString = strBaseString & "              strDescription = Replace(strDescription, ""  [Imported from TransportationLine_UTM12_NAD83]"", """", , , vbTextCompare)" & vbNewLine
7119:   strBaseString = strBaseString & "              strDescription = strDescription & _" & vbNewLine
7120:   strBaseString = strBaseString & "                  ""  This field should only have a value if the 'UTAH_Add_Attribute' value = """"TRUE"""".  "" & _" & vbNewLine
7121:   strBaseString = strBaseString & "                  ""[Imported from Utah_Roads_Near_AOI_UTM12_NAD83, Field """""" & strUtah_RoadArray(lngUtah_Index, 1) & """"""]""" & vbNewLine
7122:   strBaseString = strBaseString & " " & vbNewLine
7123:   strBaseString = strBaseString & "              ' SET FIELD DEFINITION OF NEW FCLASS" & vbNewLine
7124:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"")" & vbNewLine
7125:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7126:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef""" & vbNewLine
7127:   strBaseString = strBaseString & "              End If" & vbNewLine
7128:   strBaseString = strBaseString & "              pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"", strDescription" & vbNewLine
7129:   strBaseString = strBaseString & " " & vbNewLine
7130:   strBaseString = strBaseString & "              ' GET DESCRIPTION SOURCE FROM ORIGINAL FCLASS" & vbNewLine
7131:   strBaseString = strBaseString & "              varProperty = pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdefs"")" & vbNewLine
7132:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7133:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7134:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
7135:   strBaseString = strBaseString & "                  strDescriptionSource = ""Utah_Roads_Near_AOI_UTM12_NAD83""" & vbNewLine
7136:   strBaseString = strBaseString & "                Else" & vbNewLine
7137:   strBaseString = strBaseString & "                  strDescriptionSource = CStr(varSubProperty)" & vbNewLine
7138:   strBaseString = strBaseString & "                End If" & vbNewLine
7139:   strBaseString = strBaseString & "              Else" & vbNewLine
7140:   strBaseString = strBaseString & "                strDescriptionSource = ""Utah_Roads_Near_AOI_UTM12_NAD83""" & vbNewLine
7141:   strBaseString = strBaseString & "              End If" & vbNewLine
7142:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""Dicitonary"", ""Dictionary"", , , vbTextCompare)" & vbNewLine
7143:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""20003"", ""2003"", , , vbTextCompare)" & vbNewLine
7144:   strBaseString = strBaseString & " " & vbNewLine
7145:   strBaseString = strBaseString & "              ' SET DESCRIPTION SOURCE DEFINITION OF NEW FCLASS" & vbNewLine
7146:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"")" & vbNewLine
7147:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7148:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs""" & vbNewLine
7149:   strBaseString = strBaseString & "              End If" & vbNewLine
7150:   strBaseString = strBaseString & " " & vbNewLine
7151:   strBaseString = strBaseString & "              ' ONLY ADD THIS NEW ONE IF THERE WAS ONE IN THE ORIGINAL FCLASS" & vbNewLine
7152:   strBaseString = strBaseString & "              If strDescriptionSource <> """" Then" & vbNewLine
7153:   strBaseString = strBaseString & "                pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"", strDescriptionSource" & vbNewLine
7154:   strBaseString = strBaseString & "              End If" & vbNewLine
7155:   strBaseString = strBaseString & " " & vbNewLine
7156:   strBaseString = strBaseString & "              Exit For" & vbNewLine
7157:   strBaseString = strBaseString & "            End If" & vbNewLine
7158:   strBaseString = strBaseString & "          End If" & vbNewLine
7159:   strBaseString = strBaseString & "        Next lngIndex" & vbNewLine
7160:   strBaseString = strBaseString & "      End If" & vbNewLine
7161:   strBaseString = strBaseString & "    Next lngUtah_Index" & vbNewLine
7162:   strBaseString = strBaseString & " " & vbNewLine
7163:   strBaseString = strBaseString & " " & vbNewLine
7164:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
7165:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Routes_UTM12_NAD83  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
7166:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
7167:   strBaseString = strBaseString & "    If strFieldName = ""ROUTES_Add_Attribute"" Then" & vbNewLine
7168:   strBaseString = strBaseString & "      strDescription = """"""TRUE"""" or """"FALSE"""", whether there was a polyline feature from the 'Routes_UTM12_NAD83' "" & _" & vbNewLine
7169:   strBaseString = strBaseString & "          ""feature class within 100m of the centroid of this polyline.  If so, then this '"" & _" & vbNewLine
7170:   strBaseString = strBaseString & "          ""Routes_UTM12_NAD83' feature would be considered a candidate for extracting attribute values "" & _" & vbNewLine
7171:   strBaseString = strBaseString & "          ""to describe this feature.""" & vbNewLine
7172:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7173:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7174:   strBaseString = strBaseString & "      End If" & vbNewLine
7175:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7176:   strBaseString = strBaseString & " " & vbNewLine
7177:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7178:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7179:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7180:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7181:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7182:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7183:   strBaseString = strBaseString & "      End If" & vbNewLine
7184:   strBaseString = strBaseString & "    End If" & vbNewLine
7185:   strBaseString = strBaseString & "    If strFieldName = ""ROUTES_Attribute_Source"" Then" & vbNewLine
7186:   strBaseString = strBaseString & "      strDescription = ""If 'ROUTES_Add_Attribute' above = """"TRUE"""", then this field will contain the name of the "" & _" & vbNewLine
7187:   strBaseString = strBaseString & "          ""GCNP Routes feature class (Routes_UTM12_NAD83).  Otherwise it should be Null.""" & vbNewLine
7188:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7189:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7190:   strBaseString = strBaseString & "      End If" & vbNewLine
7191:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7192:   strBaseString = strBaseString & " " & vbNewLine
7193:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7194:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7195:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7196:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7197:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7198:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7199:   strBaseString = strBaseString & "      End If" & vbNewLine
7200:   strBaseString = strBaseString & "    End If" & vbNewLine
7201:   strBaseString = strBaseString & "    If strFieldName = ""ROUTES_Attribute_Distance"" Then" & vbNewLine
7202:   strBaseString = strBaseString & "      strDescription = ""If 'ROUTES_Add_Attribute' above = """"TRUE"""", then this field will contain the distance "" & _" & vbNewLine
7203:   strBaseString = strBaseString & "          ""(in meters) from the centroid of this polyline to the nearest GCNP Routes feature.  Otherwise it should be Null.  "" & _" & vbNewLine
7204:   strBaseString = strBaseString & "          ""Values should always be <= 100m.""" & vbNewLine
7205:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7206:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7207:   strBaseString = strBaseString & "      End If" & vbNewLine
7208:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7209:   strBaseString = strBaseString & " " & vbNewLine
7210:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7211:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7212:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7213:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7214:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7215:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7216:   strBaseString = strBaseString & "      End If" & vbNewLine
7217:   strBaseString = strBaseString & " " & vbNewLine
7218:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
7219:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
7220:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""100""" & vbNewLine
7221:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
7222:   strBaseString = strBaseString & "    End If" & vbNewLine
7223:   strBaseString = strBaseString & "    If strFieldName = ""ROUTES_ObjectID"" Then" & vbNewLine
7224:   strBaseString = strBaseString & "      strDescription = ""If 'ROUTES_Add_Attribute' above = """"TRUE"""", then this field will contain the OBJECTID "" & _" & vbNewLine
7225:   strBaseString = strBaseString & "          ""value of the nearest GCNP Routes feature, from the Routes_UTM12_NAD83 feature class.""" & vbNewLine
7226:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7227:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7228:   strBaseString = strBaseString & "      End If" & vbNewLine
7229:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7230:   strBaseString = strBaseString & " " & vbNewLine
7231:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7232:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7233:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7234:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7235:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7236:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7237:   strBaseString = strBaseString & "      End If" & vbNewLine
7238:   strBaseString = strBaseString & "    End If" & vbNewLine
7239:   strBaseString = strBaseString & " " & vbNewLine
7240:   strBaseString = strBaseString & "    For lngRoutes_Index = 0 To UBound(strRoutes_RoadArray, 1)" & vbNewLine
7241:   strBaseString = strBaseString & "      If strFieldName = strRoutes_RoadArray(lngRoutes_Index, 0) Then '  ""BLM_OBS_USE1"", ""BLM_OBS_USE2"" or ""BLM_OBS_USE3""" & vbNewLine
7242:   strBaseString = strBaseString & " " & vbNewLine
7243:   strBaseString = strBaseString & "        ' FIND ORIGINAL FIELD METADATA" & vbNewLine
7244:   strBaseString = strBaseString & "        For lngIndex = 0 To pRoutes_UTM12_NAD83_FClass.Fields.FieldCount" & vbNewLine
7245:   strBaseString = strBaseString & "          strNames(0) = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
7246:   strBaseString = strBaseString & "          pRoutes_UTM12_NAD83_PropSet.GetProperties strNames, varVals" & vbNewLine
7247:   strBaseString = strBaseString & "          varSubVals = varVals(0)" & vbNewLine
7248:   strBaseString = strBaseString & "          If Not IsEmpty(varSubVals) Then" & vbNewLine
7249:   strBaseString = strBaseString & "            ' GET FIELD NAME" & vbNewLine
7250:   strBaseString = strBaseString & "            strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrlabl""" & vbNewLine
7251:   strBaseString = strBaseString & "            varProperty = pRoutes_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7252:   strBaseString = strBaseString & "            If Not IsEmpty(varProperty) Then" & vbNewLine
7253:   strBaseString = strBaseString & "              varSubProperty = varProperty(0)" & vbNewLine
7254:   strBaseString = strBaseString & "              If IsEmpty(varSubProperty) Then" & vbNewLine
7255:   strBaseString = strBaseString & "                strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
7256:   strBaseString = strBaseString & "              Else" & vbNewLine
7257:   strBaseString = strBaseString & "                strOrigFieldName = CStr(varSubProperty)" & vbNewLine
7258:   strBaseString = strBaseString & "              End If" & vbNewLine
7259:   strBaseString = strBaseString & "            Else" & vbNewLine
7260:   strBaseString = strBaseString & "              strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
7261:   strBaseString = strBaseString & "            End If" & vbNewLine
7262:   strBaseString = strBaseString & " " & vbNewLine
7263:   strBaseString = strBaseString & "            If strOrigFieldName = strRoutes_RoadArray(lngRoutes_Index, 1) Then ' ""OBS_USE1"", ""OBS_USE2"", or ""OBS_USE3""" & vbNewLine
7264:   strBaseString = strBaseString & " " & vbNewLine
7265:   strBaseString = strBaseString & "              ' CHECK IF DOMAIN INFO" & vbNewLine
7266:   strBaseString = strBaseString & "              strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
7267:   strBaseString = strBaseString & "              varProperty = pRoutes_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7268:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7269:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7270:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
7271:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2))" & vbNewLine
7272:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
7273:   strBaseString = strBaseString & " " & vbNewLine
7274:   strBaseString = strBaseString & "                ' GET DOMAIN ATTRIBUTES FROM ORIGINAL FCLASS" & vbNewLine
7275:   strBaseString = strBaseString & "                strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
7276:   strBaseString = strBaseString & "                varProperty = pRoutes_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7277:   strBaseString = strBaseString & " " & vbNewLine
7278:   strBaseString = strBaseString & "                ' ADD DOMAIN ATTRIBUTES TO NEW FCLASS" & vbNewLine
7279:   strBaseString = strBaseString & "                varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv"")" & vbNewLine
7280:   strBaseString = strBaseString & "                If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7281:   strBaseString = strBaseString & "                  pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv""" & vbNewLine
7282:   strBaseString = strBaseString & "                End If" & vbNewLine
7283:   strBaseString = strBaseString & "                For lngIndex3 = 0 To UBound(varProperty)" & vbNewLine
7284:   strBaseString = strBaseString & "                  strSubXName1 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
7285:   strBaseString = strBaseString & "                      varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
7286:   strBaseString = strBaseString & "                  varSubProp1 = pRoutes_UTM12_NAD83_PropSet.GetProperty(strSubXName1)" & vbNewLine
7287:   strBaseString = strBaseString & " " & vbNewLine
7288:   strBaseString = strBaseString & "                  If UBound(varSubProp1) = 0 Then" & vbNewLine
7289:   strBaseString = strBaseString & "                    strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
7290:   strBaseString = strBaseString & "                        varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
7291:   strBaseString = strBaseString & "                    strValue = varSubProp1(0)" & vbNewLine
7292:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
7293:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
7294:   strBaseString = strBaseString & "                    pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
7295:   strBaseString = strBaseString & "                  Else" & vbNewLine
7296:   strBaseString = strBaseString & "                    For lngIndex4 = 0 To UBound(varSubProp1)" & vbNewLine
7297:   strBaseString = strBaseString & "                      strSubXName2 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
7298:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
7299:   strBaseString = strBaseString & "                      varSubProp2 = pRoutes_UTM12_NAD83_PropSet.GetProperty(strSubXName2)" & vbNewLine
7300:   strBaseString = strBaseString & " " & vbNewLine
7301:   strBaseString = strBaseString & "                      ' WRITE VALUE BACK TO NEW FCLASS" & vbNewLine
7302:   strBaseString = strBaseString & "                      strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
7303:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
7304:   strBaseString = strBaseString & "                      strValue = varSubProp2(0)" & vbNewLine
7305:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
7306:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
7307:   strBaseString = strBaseString & "                      pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
7308:   strBaseString = strBaseString & " " & vbNewLine
7309:   strBaseString = strBaseString & "                    Next lngIndex4" & vbNewLine
7310:   strBaseString = strBaseString & "                  End If" & vbNewLine
7311:   strBaseString = strBaseString & "                Next lngIndex3" & vbNewLine
7312:   strBaseString = strBaseString & "              Else" & vbNewLine
7313:   strBaseString = strBaseString & "'                strOrigFCLassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
7314:   strBaseString = strBaseString & "'                varProperty = pRoutes_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)" & vbNewLine
7315:   strBaseString = strBaseString & "'                varSubProperty = varProperty(0)" & vbNewLine
7316:   strBaseString = strBaseString & "'                Debug.Print ""Examining "" & strOrigFieldName & ""...""" & vbNewLine
7317:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
7318:   strBaseString = strBaseString & "'                  varSubProp1 = pRoutes_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName & ""/"" & _" & vbNewLine
7319:   strBaseString = strBaseString & "'                        CStr(varProperty(lngIndex2)))" & vbNewLine
7320:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2)) & "" = "" & _" & vbNewLine
7321:   strBaseString = strBaseString & "'                        CStr(varSubProp1(0))" & vbNewLine
7322:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
7323:   strBaseString = strBaseString & "              End If" & vbNewLine
7324:   strBaseString = strBaseString & " " & vbNewLine
7325:   strBaseString = strBaseString & "              If strOrigFieldName = ""ROAD_NO_"" Then" & vbNewLine
7326:   strBaseString = strBaseString & "                Debug.Print ""Here...""" & vbNewLine
7327:   strBaseString = strBaseString & "              End If" & vbNewLine
7328:   strBaseString = strBaseString & " " & vbNewLine
7329:   strBaseString = strBaseString & "              ' GET DEFINITION FROM ORIGINAL FCLASS" & vbNewLine
7330:   strBaseString = strBaseString & "              varProperty = pRoutes_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdef"")" & vbNewLine
7331:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7332:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7333:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
7334:   strBaseString = strBaseString & "                  strDescription = ""<-- No Description -->""" & vbNewLine
7335:   strBaseString = strBaseString & "                Else" & vbNewLine
7336:   strBaseString = strBaseString & "                  strDescription = CStr(varSubProperty)" & vbNewLine
7337:   strBaseString = strBaseString & "                  strDescription = Trim(strDescription)" & vbNewLine
7338:   strBaseString = strBaseString & "                  If Right(strDescription, 1) <> ""."" And Right(strDescription, 1) <> ""!"" And _" & vbNewLine
7339:   strBaseString = strBaseString & "                      Right(strDescription, 1) <> ""?"" Then" & vbNewLine
7340:   strBaseString = strBaseString & "                    strDescription = strDescription & "".""" & vbNewLine
7341:   strBaseString = strBaseString & "                  End If" & vbNewLine
7342:   strBaseString = strBaseString & "                End If" & vbNewLine
7343:   strBaseString = strBaseString & "              Else" & vbNewLine
7344:   strBaseString = strBaseString & "                strDescription = ""<-- No Description -->""" & vbNewLine
7345:   strBaseString = strBaseString & "              End If" & vbNewLine
7346:   strBaseString = strBaseString & "              strDescription = Replace(strDescription, ""  [Imported from TransportationLine_UTM12_NAD83]"", """", , , vbTextCompare)" & vbNewLine
7347:   strBaseString = strBaseString & "              strDescription = strDescription & _" & vbNewLine
7348:   strBaseString = strBaseString & "                  ""  This field should only have a value if the 'ROUTES_Add_Attribute' value = """"TRUE"""".  "" & _" & vbNewLine
7349:   strBaseString = strBaseString & "                  ""[Imported from Routes_UTM12_NAD83, Field """""" & strRoutes_RoadArray(lngRoutes_Index, 1) & """"""]""" & vbNewLine
7350:   strBaseString = strBaseString & " " & vbNewLine
7351:   strBaseString = strBaseString & "              ' SET FIELD DEFINITION OF NEW FCLASS" & vbNewLine
7352:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"")" & vbNewLine
7353:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7354:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef""" & vbNewLine
7355:   strBaseString = strBaseString & "              End If" & vbNewLine
7356:   strBaseString = strBaseString & "              pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"", strDescription" & vbNewLine
7357:   strBaseString = strBaseString & " " & vbNewLine
7358:   strBaseString = strBaseString & "              ' GET DESCRIPTION SOURCE FROM ORIGINAL FCLASS" & vbNewLine
7359:   strBaseString = strBaseString & "              varProperty = pRoutes_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdefs"")" & vbNewLine
7360:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7361:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7362:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
7363:   strBaseString = strBaseString & "                  strDescriptionSource = ""Routes_UTM12_NAD83""" & vbNewLine
7364:   strBaseString = strBaseString & "                Else" & vbNewLine
7365:   strBaseString = strBaseString & "                  strDescriptionSource = CStr(varSubProperty)" & vbNewLine
7366:   strBaseString = strBaseString & "                End If" & vbNewLine
7367:   strBaseString = strBaseString & "              Else" & vbNewLine
7368:   strBaseString = strBaseString & "                strDescriptionSource = ""Routes_UTM12_NAD83""" & vbNewLine
7369:   strBaseString = strBaseString & "              End If" & vbNewLine
7370:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""Dicitonary"", ""Dictionary"", , , vbTextCompare)" & vbNewLine
7371:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""20003"", ""2003"", , , vbTextCompare)" & vbNewLine
7372:   strBaseString = strBaseString & " " & vbNewLine
7373:   strBaseString = strBaseString & "              ' SET DESCRIPTION SOURCE DEFINITION OF NEW FCLASS" & vbNewLine
7374:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"")" & vbNewLine
7375:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7376:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs""" & vbNewLine
7377:   strBaseString = strBaseString & "              End If" & vbNewLine
7378:   strBaseString = strBaseString & " " & vbNewLine
7379:   strBaseString = strBaseString & "              ' ONLY ADD THIS NEW ONE IF THERE WAS ONE IN THE ORIGINAL FCLASS" & vbNewLine
7380:   strBaseString = strBaseString & "              If strDescriptionSource <> """" Then" & vbNewLine
7381:   strBaseString = strBaseString & "                pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"", strDescriptionSource" & vbNewLine
7382:   strBaseString = strBaseString & "              End If" & vbNewLine
7383:   strBaseString = strBaseString & " " & vbNewLine
7384:   strBaseString = strBaseString & "              Exit For" & vbNewLine
7385:   strBaseString = strBaseString & "            End If" & vbNewLine
7386:   strBaseString = strBaseString & "          End If" & vbNewLine
7387:   strBaseString = strBaseString & "        Next lngIndex" & vbNewLine
7388:   strBaseString = strBaseString & "      End If" & vbNewLine
7389:   strBaseString = strBaseString & "    Next lngRoutes_Index" & vbNewLine
7390:   strBaseString = strBaseString & " " & vbNewLine
7391:   strBaseString = strBaseString & " " & vbNewLine
7392:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
7393:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Trails_UTM12_NAD83  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
7394:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
7395:   strBaseString = strBaseString & "    If strFieldName = ""TRAILS_Add_Attribute"" Then" & vbNewLine
7396:   strBaseString = strBaseString & "      strDescription = """"""TRUE"""" or """"FALSE"""", whether there was a polyline feature from the 'Trails_UTM12_NAD83' "" & _" & vbNewLine
7397:   strBaseString = strBaseString & "          ""feature class within 100m of the centroid of this polyline.  If so, then this '"" & _" & vbNewLine
7398:   strBaseString = strBaseString & "          ""Trails_UTM12_NAD83' feature would be considered a candidate for extracting attribute values "" & _" & vbNewLine
7399:   strBaseString = strBaseString & "          ""to describe this feature.""" & vbNewLine
7400:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7401:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7402:   strBaseString = strBaseString & "      End If" & vbNewLine
7403:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7404:   strBaseString = strBaseString & " " & vbNewLine
7405:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7406:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7407:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7408:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7409:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7410:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7411:   strBaseString = strBaseString & "      End If" & vbNewLine
7412:   strBaseString = strBaseString & "    End If" & vbNewLine
7413:   strBaseString = strBaseString & "    If strFieldName = ""TRAILS_Attribute_Source"" Then" & vbNewLine
7414:   strBaseString = strBaseString & "      strDescription = ""If 'TRAILS_Add_Attribute' above = """"TRUE"""", then this field will contain the name of the "" & _" & vbNewLine
7415:   strBaseString = strBaseString & "          ""GCNP Trails feature class (Trails_UTM12_NAD83).  Otherwise it should be Null.""" & vbNewLine
7416:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7417:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7418:   strBaseString = strBaseString & "      End If" & vbNewLine
7419:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7420:   strBaseString = strBaseString & " " & vbNewLine
7421:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7422:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7423:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7424:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7425:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7426:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7427:   strBaseString = strBaseString & "      End If" & vbNewLine
7428:   strBaseString = strBaseString & "    End If" & vbNewLine
7429:   strBaseString = strBaseString & "    If strFieldName = ""TRAILS_Attribute_Distance"" Then" & vbNewLine
7430:   strBaseString = strBaseString & "      strDescription = ""If 'TRAILS_Add_Attribute' above = """"TRUE"""", then this field will contain the distance "" & _" & vbNewLine
7431:   strBaseString = strBaseString & "          ""(in meters) from the centroid of this polyline to the nearest GCNP Trails feature.  Otherwise it should be Null.  "" & _" & vbNewLine
7432:   strBaseString = strBaseString & "          ""Values should always be <= 100m.""" & vbNewLine
7433:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7434:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7435:   strBaseString = strBaseString & "      End If" & vbNewLine
7436:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7437:   strBaseString = strBaseString & " " & vbNewLine
7438:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7439:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7440:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7441:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7442:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7443:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7444:   strBaseString = strBaseString & "      End If" & vbNewLine
7445:   strBaseString = strBaseString & " " & vbNewLine
7446:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
7447:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
7448:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""100""" & vbNewLine
7449:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
7450:   strBaseString = strBaseString & "    End If" & vbNewLine
7451:   strBaseString = strBaseString & "    If strFieldName = ""TRAILS_ObjectID"" Then" & vbNewLine
7452:   strBaseString = strBaseString & "      strDescription = ""If 'TRAILS_Add_Attribute' above = """"TRUE"""", then this field will contain the OBJECTID "" & _" & vbNewLine
7453:   strBaseString = strBaseString & "          ""value of the nearest GCNP Trails feature, from the Trails_UTM12_NAD83 feature class.""" & vbNewLine
7454:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7455:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7456:   strBaseString = strBaseString & "      End If" & vbNewLine
7457:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7458:   strBaseString = strBaseString & " " & vbNewLine
7459:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7460:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7461:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7462:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7463:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7464:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7465:   strBaseString = strBaseString & "      End If" & vbNewLine
7466:   strBaseString = strBaseString & "    End If" & vbNewLine
7467:   strBaseString = strBaseString & " " & vbNewLine
7468:   strBaseString = strBaseString & "    For lngTrails_Index = 0 To UBound(strTrails_RoadArray, 1)" & vbNewLine
7469:   strBaseString = strBaseString & "      If strFieldName = strTrails_RoadArray(lngTrails_Index, 0) Then '  ""BLM_OBS_USE1"", ""BLM_OBS_USE2"" or ""BLM_OBS_USE3""" & vbNewLine
7470:   strBaseString = strBaseString & " " & vbNewLine
7471:   strBaseString = strBaseString & "        ' FIND ORIGINAL FIELD METADATA" & vbNewLine
7472:   strBaseString = strBaseString & "        For lngIndex = 0 To pTrails_UTM12_NAD83_FClass.Fields.FieldCount" & vbNewLine
7473:   strBaseString = strBaseString & "          strNames(0) = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
7474:   strBaseString = strBaseString & "          pTrails_UTM12_NAD83_PropSet.GetProperties strNames, varVals" & vbNewLine
7475:   strBaseString = strBaseString & "          varSubVals = varVals(0)" & vbNewLine
7476:   strBaseString = strBaseString & "          If Not IsEmpty(varSubVals) Then" & vbNewLine
7477:   strBaseString = strBaseString & "            ' GET FIELD NAME" & vbNewLine
7478:   strBaseString = strBaseString & "            strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrlabl""" & vbNewLine
7479:   strBaseString = strBaseString & "            varProperty = pTrails_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7480:   strBaseString = strBaseString & "            If Not IsEmpty(varProperty) Then" & vbNewLine
7481:   strBaseString = strBaseString & "              varSubProperty = varProperty(0)" & vbNewLine
7482:   strBaseString = strBaseString & "              If IsEmpty(varSubProperty) Then" & vbNewLine
7483:   strBaseString = strBaseString & "                strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
7484:   strBaseString = strBaseString & "              Else" & vbNewLine
7485:   strBaseString = strBaseString & "                strOrigFieldName = CStr(varSubProperty)" & vbNewLine
7486:   strBaseString = strBaseString & "              End If" & vbNewLine
7487:   strBaseString = strBaseString & "            Else" & vbNewLine
7488:   strBaseString = strBaseString & "              strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
7489:   strBaseString = strBaseString & "            End If" & vbNewLine
7490:   strBaseString = strBaseString & " " & vbNewLine
7491:   strBaseString = strBaseString & "            If strOrigFieldName = strTrails_RoadArray(lngTrails_Index, 1) Then ' ""OBS_USE1"", ""OBS_USE2"", or ""OBS_USE3""" & vbNewLine
7492:   strBaseString = strBaseString & " " & vbNewLine
7493:   strBaseString = strBaseString & "              ' CHECK IF DOMAIN INFO" & vbNewLine
7494:   strBaseString = strBaseString & "              strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
7495:   strBaseString = strBaseString & "              varProperty = pTrails_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7496:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7497:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7498:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
7499:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2))" & vbNewLine
7500:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
7501:   strBaseString = strBaseString & " " & vbNewLine
7502:   strBaseString = strBaseString & "                ' GET DOMAIN ATTRIBUTES FROM ORIGINAL FCLASS" & vbNewLine
7503:   strBaseString = strBaseString & "                strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
7504:   strBaseString = strBaseString & "                varProperty = pTrails_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7505:   strBaseString = strBaseString & " " & vbNewLine
7506:   strBaseString = strBaseString & "                ' ADD DOMAIN ATTRIBUTES TO NEW FCLASS" & vbNewLine
7507:   strBaseString = strBaseString & "                varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv"")" & vbNewLine
7508:   strBaseString = strBaseString & "                If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7509:   strBaseString = strBaseString & "                  pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv""" & vbNewLine
7510:   strBaseString = strBaseString & "                End If" & vbNewLine
7511:   strBaseString = strBaseString & "                For lngIndex3 = 0 To UBound(varProperty)" & vbNewLine
7512:   strBaseString = strBaseString & "                  strSubXName1 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
7513:   strBaseString = strBaseString & "                      varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
7514:   strBaseString = strBaseString & "                  varSubProp1 = pTrails_UTM12_NAD83_PropSet.GetProperty(strSubXName1)" & vbNewLine
7515:   strBaseString = strBaseString & " " & vbNewLine
7516:   strBaseString = strBaseString & "                  If UBound(varSubProp1) = 0 Then" & vbNewLine
7517:   strBaseString = strBaseString & "                    strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
7518:   strBaseString = strBaseString & "                        varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
7519:   strBaseString = strBaseString & "                    strValue = varSubProp1(0)" & vbNewLine
7520:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
7521:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
7522:   strBaseString = strBaseString & "                    pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
7523:   strBaseString = strBaseString & "                  Else" & vbNewLine
7524:   strBaseString = strBaseString & "                    For lngIndex4 = 0 To UBound(varSubProp1)" & vbNewLine
7525:   strBaseString = strBaseString & "                      strSubXName2 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
7526:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
7527:   strBaseString = strBaseString & "                      varSubProp2 = pTrails_UTM12_NAD83_PropSet.GetProperty(strSubXName2)" & vbNewLine
7528:   strBaseString = strBaseString & " " & vbNewLine
7529:   strBaseString = strBaseString & "                      ' WRITE VALUE BACK TO NEW FCLASS" & vbNewLine
7530:   strBaseString = strBaseString & "                      strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
7531:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
7532:   strBaseString = strBaseString & "                      strValue = varSubProp2(0)" & vbNewLine
7533:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
7534:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
7535:   strBaseString = strBaseString & "                      pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
7536:   strBaseString = strBaseString & " " & vbNewLine
7537:   strBaseString = strBaseString & "                    Next lngIndex4" & vbNewLine
7538:   strBaseString = strBaseString & "                  End If" & vbNewLine
7539:   strBaseString = strBaseString & "                Next lngIndex3" & vbNewLine
7540:   strBaseString = strBaseString & "              Else" & vbNewLine
7541:   strBaseString = strBaseString & "'                strOrigFCLassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
7542:   strBaseString = strBaseString & "'                varProperty = pTrails_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)" & vbNewLine
7543:   strBaseString = strBaseString & "'                varSubProperty = varProperty(0)" & vbNewLine
7544:   strBaseString = strBaseString & "'                Debug.Print ""Examining "" & strOrigFieldName & ""...""" & vbNewLine
7545:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
7546:   strBaseString = strBaseString & "'                  varSubProp1 = pTrails_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName & ""/"" & _" & vbNewLine
7547:   strBaseString = strBaseString & "'                        CStr(varProperty(lngIndex2)))" & vbNewLine
7548:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2)) & "" = "" & _" & vbNewLine
7549:   strBaseString = strBaseString & "'                        CStr(varSubProp1(0))" & vbNewLine
7550:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
7551:   strBaseString = strBaseString & "              End If" & vbNewLine
7552:   strBaseString = strBaseString & " " & vbNewLine
7553:   strBaseString = strBaseString & "              If strOrigFieldName = ""ROAD_NO_"" Then" & vbNewLine
7554:   strBaseString = strBaseString & "                Debug.Print ""Here...""" & vbNewLine
7555:   strBaseString = strBaseString & "              End If" & vbNewLine
7556:   strBaseString = strBaseString & " " & vbNewLine
7557:   strBaseString = strBaseString & "              ' GET DEFINITION FROM ORIGINAL FCLASS" & vbNewLine
7558:   strBaseString = strBaseString & "              varProperty = pTrails_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdef"")" & vbNewLine
7559:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7560:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7561:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
7562:   strBaseString = strBaseString & "                  strDescription = ""<-- No Description -->""" & vbNewLine
7563:   strBaseString = strBaseString & "                Else" & vbNewLine
7564:   strBaseString = strBaseString & "                  strDescription = CStr(varSubProperty)" & vbNewLine
7565:   strBaseString = strBaseString & "                  strDescription = Trim(strDescription)" & vbNewLine
7566:   strBaseString = strBaseString & "                  If Right(strDescription, 1) <> ""."" And Right(strDescription, 1) <> ""!"" And _" & vbNewLine
7567:   strBaseString = strBaseString & "                      Right(strDescription, 1) <> ""?"" Then" & vbNewLine
7568:   strBaseString = strBaseString & "                    strDescription = strDescription & "".""" & vbNewLine
7569:   strBaseString = strBaseString & "                  End If" & vbNewLine
7570:   strBaseString = strBaseString & "                End If" & vbNewLine
7571:   strBaseString = strBaseString & "              Else" & vbNewLine
7572:   strBaseString = strBaseString & "                strDescription = ""<-- No Description -->""" & vbNewLine
7573:   strBaseString = strBaseString & "              End If" & vbNewLine
7574:   strBaseString = strBaseString & "              strDescription = Replace(strDescription, ""  [Imported from TransportationLine_UTM12_NAD83]"", """", , , vbTextCompare)" & vbNewLine
7575:   strBaseString = strBaseString & "              strDescription = strDescription & _" & vbNewLine
7576:   strBaseString = strBaseString & "                  ""  This field should only have a value if the 'TRAILS_Add_Attribute' value = """"TRUE"""".  "" & _" & vbNewLine
7577:   strBaseString = strBaseString & "                  ""[Imported from Trails_UTM12_NAD83, Field """""" & strTrails_RoadArray(lngTrails_Index, 1) & """"""]""" & vbNewLine
7578:   strBaseString = strBaseString & " " & vbNewLine
7579:   strBaseString = strBaseString & "              ' SET FIELD DEFINITION OF NEW FCLASS" & vbNewLine
7580:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"")" & vbNewLine
7581:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7582:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef""" & vbNewLine
7583:   strBaseString = strBaseString & "              End If" & vbNewLine
7584:   strBaseString = strBaseString & "              pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"", strDescription" & vbNewLine
7585:   strBaseString = strBaseString & " " & vbNewLine
7586:   strBaseString = strBaseString & "              ' GET DESCRIPTION SOURCE FROM ORIGINAL FCLASS" & vbNewLine
7587:   strBaseString = strBaseString & "              varProperty = pTrails_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdefs"")" & vbNewLine
7588:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7589:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7590:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
7591:   strBaseString = strBaseString & "                  strDescriptionSource = ""Trails_UTM12_NAD83""" & vbNewLine
7592:   strBaseString = strBaseString & "                Else" & vbNewLine
7593:   strBaseString = strBaseString & "                  strDescriptionSource = CStr(varSubProperty)" & vbNewLine
7594:   strBaseString = strBaseString & "                End If" & vbNewLine
7595:   strBaseString = strBaseString & "              Else" & vbNewLine
7596:   strBaseString = strBaseString & "                strDescriptionSource = ""Trails_UTM12_NAD83""" & vbNewLine
7597:   strBaseString = strBaseString & "              End If" & vbNewLine
7598:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""Dicitonary"", ""Dictionary"", , , vbTextCompare)" & vbNewLine
7599:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""20003"", ""2003"", , , vbTextCompare)" & vbNewLine
7600:   strBaseString = strBaseString & " " & vbNewLine
7601:   strBaseString = strBaseString & "              ' SET DESCRIPTION SOURCE DEFINITION OF NEW FCLASS" & vbNewLine
7602:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"")" & vbNewLine
7603:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7604:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs""" & vbNewLine
7605:   strBaseString = strBaseString & "              End If" & vbNewLine
7606:   strBaseString = strBaseString & " " & vbNewLine
7607:   strBaseString = strBaseString & "              ' ONLY ADD THIS NEW ONE IF THERE WAS ONE IN THE ORIGINAL FCLASS" & vbNewLine
7608:   strBaseString = strBaseString & "              If strDescriptionSource <> """" Then" & vbNewLine
7609:   strBaseString = strBaseString & "                pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"", strDescriptionSource" & vbNewLine
7610:   strBaseString = strBaseString & "              End If" & vbNewLine
7611:   strBaseString = strBaseString & " " & vbNewLine
7612:   strBaseString = strBaseString & "              Exit For" & vbNewLine
7613:   strBaseString = strBaseString & "            End If" & vbNewLine
7614:   strBaseString = strBaseString & "          End If" & vbNewLine
7615:   strBaseString = strBaseString & "        Next lngIndex" & vbNewLine
7616:   strBaseString = strBaseString & "      End If" & vbNewLine
7617:   strBaseString = strBaseString & "    Next lngTrails_Index" & vbNewLine
7618:   strBaseString = strBaseString & " " & vbNewLine
7619:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
7620:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Roads_UTM12_NAD83  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
7621:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
7622:   strBaseString = strBaseString & "    If strFieldName = ""ROADS_Add_Attribute"" Then" & vbNewLine
7623:   strBaseString = strBaseString & "      strDescription = """"""TRUE"""" or """"FALSE"""", whether there was a polyline feature from the 'Roads_UTM12_NAD83' "" & _" & vbNewLine
7624:   strBaseString = strBaseString & "          ""feature class within 100m of the centroid of this polyline.  If so, then this '"" & _" & vbNewLine
7625:   strBaseString = strBaseString & "          ""Roads_UTM12_NAD83' feature would be considered a candidate for extracting attribute values "" & _" & vbNewLine
7626:   strBaseString = strBaseString & "          ""to describe this feature.""" & vbNewLine
7627:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7628:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7629:   strBaseString = strBaseString & "      End If" & vbNewLine
7630:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7631:   strBaseString = strBaseString & " " & vbNewLine
7632:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7633:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7634:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7635:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7636:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7637:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7638:   strBaseString = strBaseString & "      End If" & vbNewLine
7639:   strBaseString = strBaseString & "    End If" & vbNewLine
7640:   strBaseString = strBaseString & "    If strFieldName = ""ROADS_Attribute_Source"" Then" & vbNewLine
7641:   strBaseString = strBaseString & "      strDescription = ""If 'ROADS_Add_Attribute' above = """"TRUE"""", then this field will contain the name of the "" & _" & vbNewLine
7642:   strBaseString = strBaseString & "          ""GCNP Roads feature class (Roads_UTM12_NAD83).  Otherwise it should be Null.""" & vbNewLine
7643:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7644:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7645:   strBaseString = strBaseString & "      End If" & vbNewLine
7646:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7647:   strBaseString = strBaseString & " " & vbNewLine
7648:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7649:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7650:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7651:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7652:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7653:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7654:   strBaseString = strBaseString & "      End If" & vbNewLine
7655:   strBaseString = strBaseString & "    End If" & vbNewLine
7656:   strBaseString = strBaseString & "   " & vbNewLine
7657:   strBaseString = strBaseString & "    If strFieldName = ""ROADS_Attribute_Distance"" Then" & vbNewLine
7658:   strBaseString = strBaseString & "      strDescription = ""If 'ROADS_Add_Attribute' above = """"TRUE"""", then this field will contain the distance "" & _" & vbNewLine
7659:   strBaseString = strBaseString & "          ""(in meters) from the centroid of this polyline to the nearest GCNP Roads feature.  Otherwise it should be Null.  "" & _" & vbNewLine
7660:   strBaseString = strBaseString & "          ""Values should always be <= 100m.""" & vbNewLine
7661:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7662:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7663:   strBaseString = strBaseString & "      End If" & vbNewLine
7664:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7665:   strBaseString = strBaseString & " " & vbNewLine
7666:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7667:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7668:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7669:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7670:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7671:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7672:   strBaseString = strBaseString & "      End If" & vbNewLine
7673:   strBaseString = strBaseString & " " & vbNewLine
7674:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
7675:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
7676:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""100""" & vbNewLine
7677:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
7678:   strBaseString = strBaseString & "    End If" & vbNewLine
7679:   strBaseString = strBaseString & "    If strFieldName = ""ROADS_ObjectID"" Then" & vbNewLine
7680:   strBaseString = strBaseString & "      strDescription = ""If 'ROADS_Add_Attribute' above = """"TRUE"""", then this field will contain the OBJECTID "" & _" & vbNewLine
7681:   strBaseString = strBaseString & "          ""value of the nearest GCNP Roads feature, from the Roads_UTM12_NAD83 feature class.""" & vbNewLine
7682:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7683:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7684:   strBaseString = strBaseString & "      End If" & vbNewLine
7685:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7686:   strBaseString = strBaseString & " " & vbNewLine
7687:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7688:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7689:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7690:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7691:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7692:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7693:   strBaseString = strBaseString & "      End If" & vbNewLine
7694:   strBaseString = strBaseString & "    End If" & vbNewLine
7695:   strBaseString = strBaseString & " " & vbNewLine
7696:   strBaseString = strBaseString & "    For lngRoads_Index = 0 To UBound(strROADS_RoadArray, 1)" & vbNewLine
7697:   strBaseString = strBaseString & "      If strFieldName = strROADS_RoadArray(lngRoads_Index, 0) Then '  ""BLM_OBS_USE1"", ""BLM_OBS_USE2"" or ""BLM_OBS_USE3""" & vbNewLine
7698:   strBaseString = strBaseString & " " & vbNewLine
7699:   strBaseString = strBaseString & "        ' FIND ORIGINAL FIELD METADATA" & vbNewLine
7700:   strBaseString = strBaseString & "        For lngIndex = 0 To pRoads_UTM12_NAD83_FClass.Fields.FieldCount" & vbNewLine
7701:   strBaseString = strBaseString & "          strNames(0) = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
7702:   strBaseString = strBaseString & "          pRoads_UTM12_NAD83_PropSet.GetProperties strNames, varVals" & vbNewLine
7703:   strBaseString = strBaseString & "          varSubVals = varVals(0)" & vbNewLine
7704:   strBaseString = strBaseString & "          If Not IsEmpty(varSubVals) Then" & vbNewLine
7705:   strBaseString = strBaseString & "            ' GET FIELD NAME" & vbNewLine
7706:   strBaseString = strBaseString & "            strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrlabl""" & vbNewLine
7707:   strBaseString = strBaseString & "            varProperty = pRoads_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7708:   strBaseString = strBaseString & "            If Not IsEmpty(varProperty) Then" & vbNewLine
7709:   strBaseString = strBaseString & "              varSubProperty = varProperty(0)" & vbNewLine
7710:   strBaseString = strBaseString & "              If IsEmpty(varSubProperty) Then" & vbNewLine
7711:   strBaseString = strBaseString & "                strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
7712:   strBaseString = strBaseString & "              Else" & vbNewLine
7713:   strBaseString = strBaseString & "                strOrigFieldName = CStr(varSubProperty)" & vbNewLine
7714:   strBaseString = strBaseString & "              End If" & vbNewLine
7715:   strBaseString = strBaseString & "            Else" & vbNewLine
7716:   strBaseString = strBaseString & "              strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
7717:   strBaseString = strBaseString & "            End If" & vbNewLine
7718:   strBaseString = strBaseString & " " & vbNewLine
7719:   strBaseString = strBaseString & "            If strOrigFieldName = strROADS_RoadArray(lngRoads_Index, 1) Then ' ""OBS_USE1"", ""OBS_USE2"", or ""OBS_USE3""" & vbNewLine
7720:   strBaseString = strBaseString & " " & vbNewLine
7721:   strBaseString = strBaseString & "              ' CHECK IF DOMAIN INFO" & vbNewLine
7722:   strBaseString = strBaseString & "              strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
7723:   strBaseString = strBaseString & "              varProperty = pRoads_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7724:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7725:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7726:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
7727:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2))" & vbNewLine
7728:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
7729:   strBaseString = strBaseString & " " & vbNewLine
7730:   strBaseString = strBaseString & "                ' GET DOMAIN ATTRIBUTES FROM ORIGINAL FCLASS" & vbNewLine
7731:   strBaseString = strBaseString & "                strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
7732:   strBaseString = strBaseString & "                varProperty = pRoads_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7733:   strBaseString = strBaseString & " " & vbNewLine
7734:   strBaseString = strBaseString & "                ' ADD DOMAIN ATTRIBUTES TO NEW FCLASS" & vbNewLine
7735:   strBaseString = strBaseString & "                varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv"")" & vbNewLine
7736:   strBaseString = strBaseString & "                If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7737:   strBaseString = strBaseString & "                  pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv""" & vbNewLine
7738:   strBaseString = strBaseString & "                End If" & vbNewLine
7739:   strBaseString = strBaseString & "                For lngIndex3 = 0 To UBound(varProperty)" & vbNewLine
7740:   strBaseString = strBaseString & "                  strSubXName1 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
7741:   strBaseString = strBaseString & "                      varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
7742:   strBaseString = strBaseString & "                  varSubProp1 = pRoads_UTM12_NAD83_PropSet.GetProperty(strSubXName1)" & vbNewLine
7743:   strBaseString = strBaseString & " " & vbNewLine
7744:   strBaseString = strBaseString & "                  If UBound(varSubProp1) = 0 Then" & vbNewLine
7745:   strBaseString = strBaseString & "                    strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
7746:   strBaseString = strBaseString & "                        varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
7747:   strBaseString = strBaseString & "                    strValue = varSubProp1(0)" & vbNewLine
7748:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
7749:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
7750:   strBaseString = strBaseString & "                    pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
7751:   strBaseString = strBaseString & "                  Else" & vbNewLine
7752:   strBaseString = strBaseString & "                    For lngIndex4 = 0 To UBound(varSubProp1)" & vbNewLine
7753:   strBaseString = strBaseString & "                      strSubXName2 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
7754:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
7755:   strBaseString = strBaseString & "                      varSubProp2 = pRoads_UTM12_NAD83_PropSet.GetProperty(strSubXName2)" & vbNewLine
7756:   strBaseString = strBaseString & " " & vbNewLine
7757:   strBaseString = strBaseString & "                      ' WRITE VALUE BACK TO NEW FCLASS" & vbNewLine
7758:   strBaseString = strBaseString & "                      strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
7759:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
7760:   strBaseString = strBaseString & "                      strValue = varSubProp2(0)" & vbNewLine
7761:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
7762:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
7763:   strBaseString = strBaseString & "                      pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
7764:   strBaseString = strBaseString & " " & vbNewLine
7765:   strBaseString = strBaseString & "                    Next lngIndex4" & vbNewLine
7766:   strBaseString = strBaseString & "                  End If" & vbNewLine
7767:   strBaseString = strBaseString & "                Next lngIndex3" & vbNewLine
7768:   strBaseString = strBaseString & "              Else" & vbNewLine
7769:   strBaseString = strBaseString & "'                strOrigFCLassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
7770:   strBaseString = strBaseString & "'                varProperty = pRoads_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)" & vbNewLine
7771:   strBaseString = strBaseString & "'                varSubProperty = varProperty(0)" & vbNewLine
7772:   strBaseString = strBaseString & "'                Debug.Print ""Examining "" & strOrigFieldName & ""...""" & vbNewLine
7773:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
7774:   strBaseString = strBaseString & "'                  varSubProp1 = pRoads_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName & ""/"" & _" & vbNewLine
7775:   strBaseString = strBaseString & "'                        CStr(varProperty(lngIndex2)))" & vbNewLine
7776:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2)) & "" = "" & _" & vbNewLine
7777:   strBaseString = strBaseString & "'                        CStr(varSubProp1(0))" & vbNewLine
7778:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
7779:   strBaseString = strBaseString & "              End If" & vbNewLine
7780:   strBaseString = strBaseString & " " & vbNewLine
7781:   strBaseString = strBaseString & "              If strOrigFieldName = ""ROAD_NO_"" Then" & vbNewLine
7782:   strBaseString = strBaseString & "                Debug.Print ""Here...""" & vbNewLine
7783:   strBaseString = strBaseString & "              End If" & vbNewLine
7784:   strBaseString = strBaseString & " " & vbNewLine
7785:   strBaseString = strBaseString & "              ' GET DEFINITION FROM ORIGINAL FCLASS" & vbNewLine
7786:   strBaseString = strBaseString & "              varProperty = pRoads_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdef"")" & vbNewLine
7787:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7788:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7789:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
7790:   strBaseString = strBaseString & "                  strDescription = ""<-- No Description -->""" & vbNewLine
7791:   strBaseString = strBaseString & "                Else" & vbNewLine
7792:   strBaseString = strBaseString & "                  strDescription = CStr(varSubProperty)" & vbNewLine
7793:   strBaseString = strBaseString & "                  strDescription = Trim(strDescription)" & vbNewLine
7794:   strBaseString = strBaseString & "                  If Right(strDescription, 1) <> ""."" And Right(strDescription, 1) <> ""!"" And _" & vbNewLine
7795:   strBaseString = strBaseString & "                      Right(strDescription, 1) <> ""?"" Then" & vbNewLine
7796:   strBaseString = strBaseString & "                    strDescription = strDescription & "".""" & vbNewLine
7797:   strBaseString = strBaseString & "                  End If" & vbNewLine
7798:   strBaseString = strBaseString & "                End If" & vbNewLine
7799:   strBaseString = strBaseString & "              Else" & vbNewLine
7800:   strBaseString = strBaseString & "                strDescription = ""<-- No Description -->""" & vbNewLine
7801:   strBaseString = strBaseString & "              End If" & vbNewLine
7802:   strBaseString = strBaseString & "              strDescription = Replace(strDescription, ""  [Imported from TransportationLine_UTM12_NAD83]"", """", , , vbTextCompare)" & vbNewLine
7803:   strBaseString = strBaseString & "              strDescription = strDescription & _" & vbNewLine
7804:   strBaseString = strBaseString & "                  ""  This field should only have a value if the 'ROADS_Add_Attribute' value = """"TRUE"""".  "" & _" & vbNewLine
7805:   strBaseString = strBaseString & "                  ""[Imported from Roads_UTM12_NAD83, Field """""" & strROADS_RoadArray(lngRoads_Index, 1) & """"""]""" & vbNewLine
7806:   strBaseString = strBaseString & " " & vbNewLine
7807:   strBaseString = strBaseString & "              ' SET FIELD DEFINITION OF NEW FCLASS" & vbNewLine
7808:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"")" & vbNewLine
7809:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7810:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef""" & vbNewLine
7811:   strBaseString = strBaseString & "              End If" & vbNewLine
7812:   strBaseString = strBaseString & "              pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"", strDescription" & vbNewLine
7813:   strBaseString = strBaseString & " " & vbNewLine
7814:   strBaseString = strBaseString & "              ' GET DESCRIPTION SOURCE FROM ORIGINAL FCLASS" & vbNewLine
7815:   strBaseString = strBaseString & "              varProperty = pRoads_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdefs"")" & vbNewLine
7816:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7817:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7818:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
7819:   strBaseString = strBaseString & "                  strDescriptionSource = ""Roads_UTM12_NAD83""" & vbNewLine
7820:   strBaseString = strBaseString & "                Else" & vbNewLine
7821:   strBaseString = strBaseString & "                  strDescriptionSource = CStr(varSubProperty)" & vbNewLine
7822:   strBaseString = strBaseString & "                End If" & vbNewLine
7823:   strBaseString = strBaseString & "              Else" & vbNewLine
7824:   strBaseString = strBaseString & "                strDescriptionSource = ""Roads_UTM12_NAD83""" & vbNewLine
7825:   strBaseString = strBaseString & "              End If" & vbNewLine
7826:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""Dicitonary"", ""Dictionary"", , , vbTextCompare)" & vbNewLine
7827:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""20003"", ""2003"", , , vbTextCompare)" & vbNewLine
7828:   strBaseString = strBaseString & " " & vbNewLine
7829:   strBaseString = strBaseString & "              ' SET DESCRIPTION SOURCE DEFINITION OF NEW FCLASS" & vbNewLine
7830:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"")" & vbNewLine
7831:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7832:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs""" & vbNewLine
7833:   strBaseString = strBaseString & "              End If" & vbNewLine
7834:   strBaseString = strBaseString & " " & vbNewLine
7835:   strBaseString = strBaseString & "              ' ONLY ADD THIS NEW ONE IF THERE WAS ONE IN THE ORIGINAL FCLASS" & vbNewLine
7836:   strBaseString = strBaseString & "              If strDescriptionSource <> """" Then" & vbNewLine
7837:   strBaseString = strBaseString & "                pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"", strDescriptionSource" & vbNewLine
7838:   strBaseString = strBaseString & "              End If" & vbNewLine
7839:   strBaseString = strBaseString & " " & vbNewLine
7840:   strBaseString = strBaseString & "              Exit For" & vbNewLine
7841:   strBaseString = strBaseString & "            End If" & vbNewLine
7842:   strBaseString = strBaseString & "          End If" & vbNewLine
7843:   strBaseString = strBaseString & "        Next lngIndex" & vbNewLine
7844:   strBaseString = strBaseString & "      End If" & vbNewLine
7845:   strBaseString = strBaseString & "    Next lngRoads_Index" & vbNewLine
7846:   strBaseString = strBaseString & " " & vbNewLine
7847:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
7848:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  TIGER_2012_Trans_Near_Park_UTM12_NAD83  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
7849:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
7850:   strBaseString = strBaseString & "    If strFieldName = ""TIG_Add_Attribute"" Then" & vbNewLine
7851:   strBaseString = strBaseString & "      strDescription = """"""TRUE"""" or """"FALSE"""", whether there was a polyline feature from the 'TIGER_2012_Trans_Near_Park_UTM12_NAD83' "" & _" & vbNewLine
7852:   strBaseString = strBaseString & "          ""feature class within 100m of the centroid of this polyline.  If so, then this '"" & _" & vbNewLine
7853:   strBaseString = strBaseString & "          ""TIGER_2012_Trans_Near_Park_UTM12_NAD83' feature would be considered a candidate for extracting attribute values "" & _" & vbNewLine
7854:   strBaseString = strBaseString & "          ""to describe this feature.""" & vbNewLine
7855:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7856:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7857:   strBaseString = strBaseString & "      End If" & vbNewLine
7858:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7859:   strBaseString = strBaseString & " " & vbNewLine
7860:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7861:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7862:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7863:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7864:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7865:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7866:   strBaseString = strBaseString & "      End If" & vbNewLine
7867:   strBaseString = strBaseString & "    End If" & vbNewLine
7868:   strBaseString = strBaseString & "    If strFieldName = ""TIG_Attribute_Source"" Then" & vbNewLine
7869:   strBaseString = strBaseString & "      strDescription = ""If 'TIG_Add_Attribute' above = """"TRUE"""", then this field will contain the name of the "" & _" & vbNewLine
7870:   strBaseString = strBaseString & "          ""TIGER 2012 Transportation feature class (TIGER_2012_Trans_Near_Park_UTM12_NAD83).  Otherwise it should be Null.""" & vbNewLine
7871:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7872:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7873:   strBaseString = strBaseString & "      End If" & vbNewLine
7874:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7875:   strBaseString = strBaseString & " " & vbNewLine
7876:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7877:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7878:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7879:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7880:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7881:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7882:   strBaseString = strBaseString & "      End If" & vbNewLine
7883:   strBaseString = strBaseString & "    End If" & vbNewLine
7884:   strBaseString = strBaseString & "    If strFieldName = ""TIG_Attribute_Distance"" Then" & vbNewLine
7885:   strBaseString = strBaseString & "      strDescription = ""If 'TIG_Add_Attribute' above = """"TRUE"""", then this field will contain the distance "" & _" & vbNewLine
7886:   strBaseString = strBaseString & "          ""(in meters) from the centroid of this polyline to the nearest TIGER 2012 Transportation feature.  Otherwise it should be Null.  "" & _" & vbNewLine
7887:   strBaseString = strBaseString & "          ""Values should always be <= 100m.""" & vbNewLine
7888:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7889:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7890:   strBaseString = strBaseString & "      End If" & vbNewLine
7891:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7892:   strBaseString = strBaseString & " " & vbNewLine
7893:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7894:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7895:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7896:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7897:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7898:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7899:   strBaseString = strBaseString & "      End If" & vbNewLine
7900:   strBaseString = strBaseString & " " & vbNewLine
7901:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
7902:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
7903:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""100""" & vbNewLine
7904:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
7905:   strBaseString = strBaseString & "    End If" & vbNewLine
7906:   strBaseString = strBaseString & "    If strFieldName = ""TIG_ObjectID"" Then" & vbNewLine
7907:   strBaseString = strBaseString & "      strDescription = ""If 'TIG_Add_Attribute' above = """"TRUE"""", then this field will contain the OBJECTID "" & _" & vbNewLine
7908:   strBaseString = strBaseString & "          ""value of the nearest TIGER 2012 Transportation feature, from the TIGER_2012_Trans_Near_Park_UTM12_NAD83 feature class.""" & vbNewLine
7909:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
7910:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
7911:   strBaseString = strBaseString & "      End If" & vbNewLine
7912:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
7913:   strBaseString = strBaseString & " " & vbNewLine
7914:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
7915:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
7916:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
7917:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
7918:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
7919:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
7920:   strBaseString = strBaseString & "      End If" & vbNewLine
7921:   strBaseString = strBaseString & "    End If" & vbNewLine
7922:   strBaseString = strBaseString & " " & vbNewLine
7923:   strBaseString = strBaseString & "    For lngTIGIndex = 0 To UBound(strTIG_RoadArray, 1)" & vbNewLine
7924:   strBaseString = strBaseString & "      If strFieldName = strTIG_RoadArray(lngTIGIndex, 0) Then '  ""BLM_OBS_USE1"", ""BLM_OBS_USE2"" or ""BLM_OBS_USE3""" & vbNewLine
7925:   strBaseString = strBaseString & " " & vbNewLine
7926:   strBaseString = strBaseString & "        ' FIND ORIGINAL FIELD METADATA" & vbNewLine
7927:   strBaseString = strBaseString & "        For lngIndex = 0 To pTIGER_2012_Trans_Near_Park_UTM12_NAD83_FClass.Fields.FieldCount" & vbNewLine
7928:   strBaseString = strBaseString & "          strNames(0) = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
7929:   strBaseString = strBaseString & "          pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet.GetProperties strNames, varVals" & vbNewLine
7930:   strBaseString = strBaseString & "          varSubVals = varVals(0)" & vbNewLine
7931:   strBaseString = strBaseString & "          If Not IsEmpty(varSubVals) Then" & vbNewLine
7932:   strBaseString = strBaseString & "            ' GET FIELD NAME" & vbNewLine
7933:   strBaseString = strBaseString & "            strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrlabl""" & vbNewLine
7934:   strBaseString = strBaseString & "            varProperty = pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7935:   strBaseString = strBaseString & "            If Not IsEmpty(varProperty) Then" & vbNewLine
7936:   strBaseString = strBaseString & "              varSubProperty = varProperty(0)" & vbNewLine
7937:   strBaseString = strBaseString & "              If IsEmpty(varSubProperty) Then" & vbNewLine
7938:   strBaseString = strBaseString & "                strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
7939:   strBaseString = strBaseString & "              Else" & vbNewLine
7940:   strBaseString = strBaseString & "                strOrigFieldName = CStr(varSubProperty)" & vbNewLine
7941:   strBaseString = strBaseString & "              End If" & vbNewLine
7942:   strBaseString = strBaseString & "            Else" & vbNewLine
7943:   strBaseString = strBaseString & "              strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
7944:   strBaseString = strBaseString & "            End If" & vbNewLine
7945:   strBaseString = strBaseString & " " & vbNewLine
7946:   strBaseString = strBaseString & "            If strOrigFieldName = strTIG_RoadArray(lngTIGIndex, 1) Then ' ""OBS_USE1"", ""OBS_USE2"", or ""OBS_USE3""" & vbNewLine
7947:   strBaseString = strBaseString & " " & vbNewLine
7948:   strBaseString = strBaseString & "              ' CHECK IF DOMAIN INFO" & vbNewLine
7949:   strBaseString = strBaseString & "              strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
7950:   strBaseString = strBaseString & "              varProperty = pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7951:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
7952:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
7953:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
7954:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2))" & vbNewLine
7955:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
7956:   strBaseString = strBaseString & " " & vbNewLine
7957:   strBaseString = strBaseString & "                ' GET DOMAIN ATTRIBUTES FROM ORIGINAL FCLASS" & vbNewLine
7958:   strBaseString = strBaseString & "                strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
7959:   strBaseString = strBaseString & "                varProperty = pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
7960:   strBaseString = strBaseString & " " & vbNewLine
7961:   strBaseString = strBaseString & "                ' ADD DOMAIN ATTRIBUTES TO NEW FCLASS" & vbNewLine
7962:   strBaseString = strBaseString & "                varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv"")" & vbNewLine
7963:   strBaseString = strBaseString & "                If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
7964:   strBaseString = strBaseString & "                  pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv""" & vbNewLine
7965:   strBaseString = strBaseString & "                End If" & vbNewLine
7966:   strBaseString = strBaseString & "                For lngIndex3 = 0 To UBound(varProperty)" & vbNewLine
7967:   strBaseString = strBaseString & "                  strSubXName1 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
7968:   strBaseString = strBaseString & "                      varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
7969:   strBaseString = strBaseString & "                  varSubProp1 = pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet.GetProperty(strSubXName1)" & vbNewLine
7970:   strBaseString = strBaseString & " " & vbNewLine
7971:   strBaseString = strBaseString & "                  If UBound(varSubProp1) = 0 Then" & vbNewLine
7972:   strBaseString = strBaseString & "                    strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
7973:   strBaseString = strBaseString & "                        varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
7974:   strBaseString = strBaseString & "                    strValue = varSubProp1(0)" & vbNewLine
7975:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
7976:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
7977:   strBaseString = strBaseString & "                    pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
7978:   strBaseString = strBaseString & "                  Else" & vbNewLine
7979:   strBaseString = strBaseString & "                    For lngIndex4 = 0 To UBound(varSubProp1)" & vbNewLine
7980:   strBaseString = strBaseString & "                      strSubXName2 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
7981:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
7982:   strBaseString = strBaseString & "                      varSubProp2 = pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet.GetProperty(strSubXName2)" & vbNewLine
7983:   strBaseString = strBaseString & " " & vbNewLine
7984:   strBaseString = strBaseString & "                      ' WRITE VALUE BACK TO NEW FCLASS" & vbNewLine
7985:   strBaseString = strBaseString & "                      strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
7986:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
7987:   strBaseString = strBaseString & "                      strValue = varSubProp2(0)" & vbNewLine
7988:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
7989:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
7990:   strBaseString = strBaseString & "                      pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
7991:   strBaseString = strBaseString & " " & vbNewLine
7992:   strBaseString = strBaseString & "                    Next lngIndex4" & vbNewLine
7993:   strBaseString = strBaseString & "                  End If" & vbNewLine
7994:   strBaseString = strBaseString & "                Next lngIndex3" & vbNewLine
7995:   strBaseString = strBaseString & "              Else" & vbNewLine
7996:   strBaseString = strBaseString & "'                strOrigFCLassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
7997:   strBaseString = strBaseString & "'                varProperty = pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)" & vbNewLine
7998:   strBaseString = strBaseString & "'                varSubProperty = varProperty(0)" & vbNewLine
7999:   strBaseString = strBaseString & "'                Debug.Print ""Examining "" & strOrigFieldName & ""...""" & vbNewLine
8000:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
8001:   strBaseString = strBaseString & "'                  varSubProp1 = pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName & ""/"" & _" & vbNewLine
8002:   strBaseString = strBaseString & "'                        CStr(varProperty(lngIndex2)))" & vbNewLine
8003:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2)) & "" = "" & _" & vbNewLine
8004:   strBaseString = strBaseString & "'                        CStr(varSubProp1(0))" & vbNewLine
8005:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
8006:   strBaseString = strBaseString & "              End If" & vbNewLine
8007:   strBaseString = strBaseString & " " & vbNewLine
8008:   strBaseString = strBaseString & "              If strOrigFieldName = ""ROAD_NO_"" Then" & vbNewLine
8009:   strBaseString = strBaseString & "                Debug.Print ""Here...""" & vbNewLine
8010:   strBaseString = strBaseString & "              End If" & vbNewLine
8011:   strBaseString = strBaseString & " " & vbNewLine
8012:   strBaseString = strBaseString & "              ' GET DEFINITION FROM ORIGINAL FCLASS" & vbNewLine
8013:   strBaseString = strBaseString & "              varProperty = pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdef"")" & vbNewLine
8014:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
8015:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
8016:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
8017:   strBaseString = strBaseString & "                  strDescription = ""<-- No Description -->""" & vbNewLine
8018:   strBaseString = strBaseString & "                Else" & vbNewLine
8019:   strBaseString = strBaseString & "                  strDescription = CStr(varSubProperty)" & vbNewLine
8020:   strBaseString = strBaseString & "                  strDescription = Trim(strDescription)" & vbNewLine
8021:   strBaseString = strBaseString & "                  If Right(strDescription, 1) <> ""."" And Right(strDescription, 1) <> ""!"" And _" & vbNewLine
8022:   strBaseString = strBaseString & "                      Right(strDescription, 1) <> ""?"" Then" & vbNewLine
8023:   strBaseString = strBaseString & "                    strDescription = strDescription & "".""" & vbNewLine
8024:   strBaseString = strBaseString & "                  End If" & vbNewLine
8025:   strBaseString = strBaseString & "                End If" & vbNewLine
8026:   strBaseString = strBaseString & "              Else" & vbNewLine
8027:   strBaseString = strBaseString & "                strDescription = ""<-- No Description -->""" & vbNewLine
8028:   strBaseString = strBaseString & "              End If" & vbNewLine
8029:   strBaseString = strBaseString & "              strDescription = Replace(strDescription, ""  [Imported from TransportationLine_UTM12_NAD83]"", """", , , vbTextCompare)" & vbNewLine
8030:   strBaseString = strBaseString & "              strDescription = strDescription & _" & vbNewLine
8031:   strBaseString = strBaseString & "                  ""  This field should only have a value if the 'TIG_Add_Attribute' value = """"TRUE"""".  "" & _" & vbNewLine
8032:   strBaseString = strBaseString & "                  ""[Imported from TIGER_2012_Trans_Near_Park_UTM12_NAD83, Field """""" & strTIG_RoadArray(lngTIGIndex, 1) & """"""]""" & vbNewLine
8033:   strBaseString = strBaseString & " " & vbNewLine
8034:   strBaseString = strBaseString & "              ' SET FIELD DEFINITION OF NEW FCLASS" & vbNewLine
8035:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"")" & vbNewLine
8036:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
8037:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef""" & vbNewLine
8038:   strBaseString = strBaseString & "              End If" & vbNewLine
8039:   strBaseString = strBaseString & "              pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"", strDescription" & vbNewLine
8040:   strBaseString = strBaseString & " " & vbNewLine
8041:   strBaseString = strBaseString & "              ' GET DESCRIPTION SOURCE FROM ORIGINAL FCLASS" & vbNewLine
8042:   strBaseString = strBaseString & "              varProperty = pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdefs"")" & vbNewLine
8043:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
8044:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
8045:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
8046:   strBaseString = strBaseString & "                  strDescriptionSource = ""TIGER_2012_Trans_Near_Park_UTM12_NAD83""" & vbNewLine
8047:   strBaseString = strBaseString & "                Else" & vbNewLine
8048:   strBaseString = strBaseString & "                  strDescriptionSource = CStr(varSubProperty)" & vbNewLine
8049:   strBaseString = strBaseString & "                End If" & vbNewLine
8050:   strBaseString = strBaseString & "              Else" & vbNewLine
8051:   strBaseString = strBaseString & "                strDescriptionSource = ""TIGER_2012_Trans_Near_Park_UTM12_NAD83""" & vbNewLine
8052:   strBaseString = strBaseString & "              End If" & vbNewLine
8053:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""Dicitonary"", ""Dictionary"", , , vbTextCompare)" & vbNewLine
8054:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""20003"", ""2003"", , , vbTextCompare)" & vbNewLine
8055:   strBaseString = strBaseString & " " & vbNewLine
8056:   strBaseString = strBaseString & "              ' SET DESCRIPTION SOURCE DEFINITION OF NEW FCLASS" & vbNewLine
8057:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"")" & vbNewLine
8058:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
8059:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs""" & vbNewLine
8060:   strBaseString = strBaseString & "              End If" & vbNewLine
8061:   strBaseString = strBaseString & " " & vbNewLine
8062:   strBaseString = strBaseString & "              ' ONLY ADD THIS NEW ONE IF THERE WAS ONE IN THE ORIGINAL FCLASS" & vbNewLine
8063:   strBaseString = strBaseString & "              If strDescriptionSource <> """" Then" & vbNewLine
8064:   strBaseString = strBaseString & "                pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"", strDescriptionSource" & vbNewLine
8065:   strBaseString = strBaseString & "              End If" & vbNewLine
8066:   strBaseString = strBaseString & " " & vbNewLine
8067:   strBaseString = strBaseString & "              Exit For" & vbNewLine
8068:   strBaseString = strBaseString & "            End If" & vbNewLine
8069:   strBaseString = strBaseString & "          End If" & vbNewLine
8070:   strBaseString = strBaseString & "        Next lngIndex" & vbNewLine
8071:   strBaseString = strBaseString & "      End If" & vbNewLine
8072:   strBaseString = strBaseString & "    Next lngTIGIndex" & vbNewLine
8073:   strBaseString = strBaseString & " " & vbNewLine
8074:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
8075:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  Roads_KNF_UTM12_NAD83  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
8076:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
8077:   strBaseString = strBaseString & "    If strFieldName = ""KNF_Add_Attribute"" Then" & vbNewLine
8078:   strBaseString = strBaseString & "      strDescription = """"""TRUE"""" or """"FALSE"""", whether there was a polyline feature from the 'Roads_KNF_UTM12_NAD83' "" & _" & vbNewLine
8079:   strBaseString = strBaseString & "          ""feature class within 100m of the centroid of this polyline.  If so, then this '"" & _" & vbNewLine
8080:   strBaseString = strBaseString & "          ""Roads_KNF_UTM12_NAD83' feature would be considered a candidate for extracting attribute values "" & _" & vbNewLine
8081:   strBaseString = strBaseString & "          ""to describe this feature.""" & vbNewLine
8082:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
8083:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
8084:   strBaseString = strBaseString & "      End If" & vbNewLine
8085:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
8086:   strBaseString = strBaseString & " " & vbNewLine
8087:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
8088:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
8089:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
8090:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
8091:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
8092:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
8093:   strBaseString = strBaseString & "      End If" & vbNewLine
8094:   strBaseString = strBaseString & "    End If" & vbNewLine
8095:   strBaseString = strBaseString & "    If strFieldName = ""KNF_Attribute_Source"" Then" & vbNewLine
8096:   strBaseString = strBaseString & "      strDescription = ""If 'KNF_Add_Attribute' above = """"TRUE"""", then this field will contain the name of the "" & _" & vbNewLine
8097:   strBaseString = strBaseString & "          ""Kaibab NF Roads feature class (Roads_KNF_UTM12_NAD83).  Otherwise it should be Null.""" & vbNewLine
8098:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
8099:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
8100:   strBaseString = strBaseString & "      End If" & vbNewLine
8101:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
8102:   strBaseString = strBaseString & " " & vbNewLine
8103:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
8104:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
8105:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
8106:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
8107:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
8108:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
8109:   strBaseString = strBaseString & "      End If" & vbNewLine
8110:   strBaseString = strBaseString & "    End If" & vbNewLine
8111:   strBaseString = strBaseString & "    If strFieldName = ""KNF_Attribute_Distance"" Then" & vbNewLine
8112:   strBaseString = strBaseString & "      strDescription = ""If 'KNF_Add_Attribute' above = """"TRUE"""", then this field will contain the distance "" & _" & vbNewLine
8113:   strBaseString = strBaseString & "          ""(in meters) from the centroid of this polyline to the nearest Kaibab NF Road feature.  Otherwise it should be Null.  "" & _" & vbNewLine
8114:   strBaseString = strBaseString & "          ""Values should always be <= 100m.""" & vbNewLine
8115:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
8116:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
8117:   strBaseString = strBaseString & "      End If" & vbNewLine
8118:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
8119:   strBaseString = strBaseString & " " & vbNewLine
8120:   strBaseString = strBaseString & "   " & vbNewLine
8121:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
8122:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
8123:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
8124:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
8125:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
8126:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
8127:   strBaseString = strBaseString & "      End If" & vbNewLine
8128:   strBaseString = strBaseString & " " & vbNewLine
8129:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
8130:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
8131:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""100""" & vbNewLine
8132:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
8133:   strBaseString = strBaseString & "    End If" & vbNewLine
8134:   strBaseString = strBaseString & "    If strFieldName = ""KNF_ObjectID_1"" Then" & vbNewLine
8135:   strBaseString = strBaseString & "      strDescription = ""If 'KNF_Add_Attribute' above = """"TRUE"""", then this field will contain the OBJECTID_1 "" & _" & vbNewLine
8136:   strBaseString = strBaseString & "          ""value of the nearest Kaibab NF Road feature, from the Roads_KNF_UTM12_NAD83 feature class.""" & vbNewLine
8137:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
8138:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
8139:   strBaseString = strBaseString & "      End If" & vbNewLine
8140:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
8141:   strBaseString = strBaseString & " " & vbNewLine
8142:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
8143:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
8144:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
8145:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
8146:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
8147:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
8148:   strBaseString = strBaseString & "      End If" & vbNewLine
8149:   strBaseString = strBaseString & "    End If" & vbNewLine
8150:   strBaseString = strBaseString & " " & vbNewLine
8151:   strBaseString = strBaseString & "    For lngKNFIndex = 0 To UBound(strKNF_RoadArray, 1)" & vbNewLine
8152:   strBaseString = strBaseString & "      If strFieldName = strKNF_RoadArray(lngKNFIndex, 0) Then '  ""BLM_OBS_USE1"", ""BLM_OBS_USE2"" or ""BLM_OBS_USE3""" & vbNewLine
8153:   strBaseString = strBaseString & " " & vbNewLine
8154:   strBaseString = strBaseString & "        ' FIND ORIGINAL FIELD METADATA" & vbNewLine
8155:   strBaseString = strBaseString & "        For lngIndex = 0 To pRoads_KNF_UTM12_NAD83_FClass.Fields.FieldCount" & vbNewLine
8156:   strBaseString = strBaseString & "          strNames(0) = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
8157:   strBaseString = strBaseString & "          pRoads_KNF_UTM12_NAD83_PropSet.GetProperties strNames, varVals" & vbNewLine
8158:   strBaseString = strBaseString & "          varSubVals = varVals(0)" & vbNewLine
8159:   strBaseString = strBaseString & "          If Not IsEmpty(varSubVals) Then" & vbNewLine
8160:   strBaseString = strBaseString & "            ' GET FIELD NAME" & vbNewLine
8161:   strBaseString = strBaseString & "            strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrlabl""" & vbNewLine
8162:   strBaseString = strBaseString & "            varProperty = pRoads_KNF_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
8163:   strBaseString = strBaseString & "            If Not IsEmpty(varProperty) Then" & vbNewLine
8164:   strBaseString = strBaseString & "              varSubProperty = varProperty(0)" & vbNewLine
8165:   strBaseString = strBaseString & "              If IsEmpty(varSubProperty) Then" & vbNewLine
8166:   strBaseString = strBaseString & "                strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
8167:   strBaseString = strBaseString & "              Else" & vbNewLine
8168:   strBaseString = strBaseString & "                strOrigFieldName = CStr(varSubProperty)" & vbNewLine
8169:   strBaseString = strBaseString & "              End If" & vbNewLine
8170:   strBaseString = strBaseString & "            Else" & vbNewLine
8171:   strBaseString = strBaseString & "              strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
8172:   strBaseString = strBaseString & "            End If" & vbNewLine
8173:   strBaseString = strBaseString & " " & vbNewLine
8174:   strBaseString = strBaseString & "            If strOrigFieldName = strKNF_RoadArray(lngKNFIndex, 1) Then ' ""OBS_USE1"", ""OBS_USE2"", or ""OBS_USE3""" & vbNewLine
8175:   strBaseString = strBaseString & " " & vbNewLine
8176:   strBaseString = strBaseString & "              ' CHECK IF DOMAIN INFO" & vbNewLine
8177:   strBaseString = strBaseString & "              strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
8178:   strBaseString = strBaseString & "              varProperty = pRoads_KNF_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
8179:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
8180:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
8181:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
8182:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2))" & vbNewLine
8183:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
8184:   strBaseString = strBaseString & " " & vbNewLine
8185:   strBaseString = strBaseString & "                ' GET DOMAIN ATTRIBUTES FROM ORIGINAL FCLASS" & vbNewLine
8186:   strBaseString = strBaseString & "                strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
8187:   strBaseString = strBaseString & "                varProperty = pRoads_KNF_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
8188:   strBaseString = strBaseString & " " & vbNewLine
8189:   strBaseString = strBaseString & "                ' ADD DOMAIN ATTRIBUTES TO NEW FCLASS" & vbNewLine
8190:   strBaseString = strBaseString & "                varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv"")" & vbNewLine
8191:   strBaseString = strBaseString & "                If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
8192:   strBaseString = strBaseString & "                  pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv""" & vbNewLine
8193:   strBaseString = strBaseString & "                End If" & vbNewLine
8194:   strBaseString = strBaseString & "                For lngIndex3 = 0 To UBound(varProperty)" & vbNewLine
8195:   strBaseString = strBaseString & "                  strSubXName1 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
8196:   strBaseString = strBaseString & "                      varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
8197:   strBaseString = strBaseString & "                  varSubProp1 = pRoads_KNF_UTM12_NAD83_PropSet.GetProperty(strSubXName1)" & vbNewLine
8198:   strBaseString = strBaseString & " " & vbNewLine
8199:   strBaseString = strBaseString & "                  If UBound(varSubProp1) = 0 Then" & vbNewLine
8200:   strBaseString = strBaseString & "                    strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
8201:   strBaseString = strBaseString & "                        varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
8202:   strBaseString = strBaseString & "                    strValue = varSubProp1(0)" & vbNewLine
8203:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
8204:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
8205:   strBaseString = strBaseString & "                    pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
8206:   strBaseString = strBaseString & "                  Else" & vbNewLine
8207:   strBaseString = strBaseString & "                    For lngIndex4 = 0 To UBound(varSubProp1)" & vbNewLine
8208:   strBaseString = strBaseString & "                      strSubXName2 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
8209:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
8210:   strBaseString = strBaseString & "                      varSubProp2 = pRoads_KNF_UTM12_NAD83_PropSet.GetProperty(strSubXName2)" & vbNewLine
8211:   strBaseString = strBaseString & " " & vbNewLine
8212:   strBaseString = strBaseString & "                      ' WRITE VALUE BACK TO NEW FCLASS" & vbNewLine
8213:   strBaseString = strBaseString & "                      strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
8214:   strBaseString = strBaseString & "                          varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
8215:   strBaseString = strBaseString & "                      strValue = varSubProp2(0)" & vbNewLine
8216:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
8217:   strBaseString = strBaseString & "                      strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
8218:   strBaseString = strBaseString & "                      pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
8219:   strBaseString = strBaseString & " " & vbNewLine
8220:   strBaseString = strBaseString & "                    Next lngIndex4" & vbNewLine
8221:   strBaseString = strBaseString & "                  End If" & vbNewLine
8222:   strBaseString = strBaseString & "                Next lngIndex3" & vbNewLine
8223:   strBaseString = strBaseString & "              Else" & vbNewLine
8224:   strBaseString = strBaseString & "'                strOrigFCLassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
8225:   strBaseString = strBaseString & "'                varProperty = pRoads_KNF_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)" & vbNewLine
8226:   strBaseString = strBaseString & "'                varSubProperty = varProperty(0)" & vbNewLine
8227:   strBaseString = strBaseString & "'                Debug.Print ""Examining "" & strOrigFieldName & ""...""" & vbNewLine
8228:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
8229:   strBaseString = strBaseString & "'                  varSubProp1 = pRoads_KNF_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName & ""/"" & _" & vbNewLine
8230:   strBaseString = strBaseString & "'                        CStr(varProperty(lngIndex2)))" & vbNewLine
8231:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2)) & "" = "" & _" & vbNewLine
8232:   strBaseString = strBaseString & "'                        CStr(varSubProp1(0))" & vbNewLine
8233:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
8234:   strBaseString = strBaseString & "              End If" & vbNewLine
8235:   strBaseString = strBaseString & " " & vbNewLine
8236:   strBaseString = strBaseString & "              If strOrigFieldName = ""ROAD_NO_"" Then" & vbNewLine
8237:   strBaseString = strBaseString & "                Debug.Print ""Here...""" & vbNewLine
8238:   strBaseString = strBaseString & "              End If" & vbNewLine
8239:   strBaseString = strBaseString & " " & vbNewLine
8240:   strBaseString = strBaseString & "              ' GET DEFINITION FROM ORIGINAL FCLASS" & vbNewLine
8241:   strBaseString = strBaseString & "              varProperty = pRoads_KNF_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdef"")" & vbNewLine
8242:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
8243:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
8244:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
8245:   strBaseString = strBaseString & "                  strDescription = ""<-- No Description -->""" & vbNewLine
8246:   strBaseString = strBaseString & "                Else" & vbNewLine
8247:   strBaseString = strBaseString & "                  strDescription = CStr(varSubProperty)" & vbNewLine
8248:   strBaseString = strBaseString & "                End If" & vbNewLine
8249:   strBaseString = strBaseString & "              Else" & vbNewLine
8250:   strBaseString = strBaseString & "                strDescription = ""<-- No Description -->""" & vbNewLine
8251:   strBaseString = strBaseString & "              End If" & vbNewLine
8252:   strBaseString = strBaseString & "              strDescription = Replace(strDescription, ""  [Imported from TransportationLine_UTM12_NAD83]"", """", , , vbTextCompare)" & vbNewLine
8253:   strBaseString = strBaseString & "              strDescription = strDescription & _" & vbNewLine
8254:   strBaseString = strBaseString & "                  ""  This field should only have a value if the 'KNF_Add_Attribute' value = """"TRUE"""".  "" & _" & vbNewLine
8255:   strBaseString = strBaseString & "                  ""[Imported from Roads_KNF_UTM12_NAD83, Field """""" & strKNF_RoadArray(lngKNFIndex, 1) & """"""]""" & vbNewLine
8256:   strBaseString = strBaseString & " " & vbNewLine
8257:   strBaseString = strBaseString & "              ' SET FIELD DEFINITION OF NEW FCLASS" & vbNewLine
8258:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"")" & vbNewLine
8259:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
8260:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef""" & vbNewLine
8261:   strBaseString = strBaseString & "              End If" & vbNewLine
8262:   strBaseString = strBaseString & "              pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"", strDescription" & vbNewLine
8263:   strBaseString = strBaseString & " " & vbNewLine
8264:   strBaseString = strBaseString & "              ' GET DESCRIPTION SOURCE FROM ORIGINAL FCLASS" & vbNewLine
8265:   strBaseString = strBaseString & "              varProperty = pRoads_KNF_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdefs"")" & vbNewLine
8266:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
8267:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
8268:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
8269:   strBaseString = strBaseString & "                  strDescriptionSource = ""Roads_KNF_UTM12_NAD83""" & vbNewLine
8270:   strBaseString = strBaseString & "                Else" & vbNewLine
8271:   strBaseString = strBaseString & "                  strDescriptionSource = CStr(varSubProperty)" & vbNewLine
8272:   strBaseString = strBaseString & "                End If" & vbNewLine
8273:   strBaseString = strBaseString & "              Else" & vbNewLine
8274:   strBaseString = strBaseString & "                strDescriptionSource = ""Roads_KNF_UTM12_NAD83""" & vbNewLine
8275:   strBaseString = strBaseString & "              End If" & vbNewLine
8276:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""Dicitonary"", ""Dictionary"", , , vbTextCompare)" & vbNewLine
8277:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""20003"", ""2003"", , , vbTextCompare)" & vbNewLine
8278:   strBaseString = strBaseString & " " & vbNewLine
8279:   strBaseString = strBaseString & "              ' SET DESCRIPTION SOURCE DEFINITION OF NEW FCLASS" & vbNewLine
8280:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"")" & vbNewLine
8281:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
8282:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs""" & vbNewLine
8283:   strBaseString = strBaseString & "              End If" & vbNewLine
8284:   strBaseString = strBaseString & " " & vbNewLine
8285:   strBaseString = strBaseString & "              ' ONLY ADD THIS NEW ONE IF THERE WAS ONE IN THE ORIGINAL FCLASS" & vbNewLine
8286:   strBaseString = strBaseString & "              If strDescriptionSource <> """" Then" & vbNewLine
8287:   strBaseString = strBaseString & "                pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"", strDescriptionSource" & vbNewLine
8288:   strBaseString = strBaseString & "              End If" & vbNewLine
8289:   strBaseString = strBaseString & " " & vbNewLine
8290:   strBaseString = strBaseString & "              Exit For" & vbNewLine
8291:   strBaseString = strBaseString & "            End If" & vbNewLine
8292:   strBaseString = strBaseString & "          End If" & vbNewLine
8293:   strBaseString = strBaseString & "        Next lngIndex" & vbNewLine
8294:   strBaseString = strBaseString & "      End If" & vbNewLine
8295:   strBaseString = strBaseString & "    Next lngKNFIndex" & vbNewLine
8296:   strBaseString = strBaseString & " " & vbNewLine
8297:   strBaseString = strBaseString & "    ' ----------------------------------------------------------------------------------------------" & vbNewLine
8298:   strBaseString = strBaseString & "    ' <<<<<<<<<<<<  BLM_AZStrip_UTM12_NAD83  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>" & vbNewLine
8299:   strBaseString = strBaseString & "    '-----------------------------------------------------------------------------------------------" & vbNewLine
8300:   strBaseString = strBaseString & "    If strFieldName = ""BLM_Add_Attribute"" Then" & vbNewLine
8301:   strBaseString = strBaseString & "      strDescription = """"""TRUE"""" or """"FALSE"""", whether there was a polyline feature from the 'BLM_AZStrip_UTM12_NAD83' "" & _" & vbNewLine
8302:   strBaseString = strBaseString & "          ""feature class within 100m of the centroid of this polyline.  If so, then this '"" & _" & vbNewLine
8303:   strBaseString = strBaseString & "          ""BLM_AZStrip_UTM12_NAD83' feature would be considered a candidate for extracting attribute values "" & _" & vbNewLine
8304:   strBaseString = strBaseString & "          ""to describe this feature.""" & vbNewLine
8305:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
8306:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
8307:   strBaseString = strBaseString & "      End If" & vbNewLine
8308:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
8309:   strBaseString = strBaseString & " " & vbNewLine
8310:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
8311:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
8312:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
8313:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
8314:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
8315:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
8316:   strBaseString = strBaseString & "      End If" & vbNewLine
8317:   strBaseString = strBaseString & "    End If" & vbNewLine
8318:   strBaseString = strBaseString & "    If strFieldName = ""BLM_Attribute_Source"" Then" & vbNewLine
8319:   strBaseString = strBaseString & "      strDescription = ""If 'BLM_Add_Attribute' above = """"TRUE"""", then this field will contain the name of the "" & _" & vbNewLine
8320:   strBaseString = strBaseString & "          ""BLM feature class (BLM_AZStrip_UTM12_NAD83).  Otherwise it should be Null.""" & vbNewLine
8321:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
8322:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
8323:   strBaseString = strBaseString & "      End If" & vbNewLine
8324:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
8325:   strBaseString = strBaseString & " " & vbNewLine
8326:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
8327:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
8328:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
8329:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
8330:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
8331:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
8332:   strBaseString = strBaseString & "      End If" & vbNewLine
8333:   strBaseString = strBaseString & "    End If" & vbNewLine
8334:   strBaseString = strBaseString & "    If strFieldName = ""BLM_Attribute_Distance"" Then" & vbNewLine
8335:   strBaseString = strBaseString & "      strDescription = ""If 'BLM_Add_Attribute' above = """"TRUE"""", then this field will contain the distance "" & _" & vbNewLine
8336:   strBaseString = strBaseString & "          ""(in meters) from the centroid of this polyline to the nearest BLM feature.  Otherwise it should be Null.  "" & _" & vbNewLine
8337:   strBaseString = strBaseString & "          ""Values should always be <= 100m.""" & vbNewLine
8338:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
8339:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
8340:   strBaseString = strBaseString & "      End If" & vbNewLine
8341:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
8342:   strBaseString = strBaseString & " " & vbNewLine
8343:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
8344:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
8345:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
8346:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
8347:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
8348:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
8349:   strBaseString = strBaseString & "      End If" & vbNewLine
8350:   strBaseString = strBaseString & " " & vbNewLine
8351:   strBaseString = strBaseString & "      pPropSet.RemoveProperty strXDom" & vbNewLine
8352:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMin, ""0""" & vbNewLine
8353:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomMax, ""100""" & vbNewLine
8354:   strBaseString = strBaseString & "      pPropSet.SetProperty strXDomUnits, ""Meters""" & vbNewLine
8355:   strBaseString = strBaseString & "    End If" & vbNewLine
8356:   strBaseString = strBaseString & "    If strFieldName = ""BLM_ObjectID"" Then" & vbNewLine
8357:   strBaseString = strBaseString & "      strDescription = ""If 'BLM_Add_Attribute' above = """"TRUE"""", then this field will contain the OBJECTID "" & _" & vbNewLine
8358:   strBaseString = strBaseString & "          ""value of the nearest BLM feature, from the BLM_AZStrip_UTM12_NAD83 feature class.""" & vbNewLine
8359:   strBaseString = strBaseString & "      If Not IsEmpty(varProperty) Then" & vbNewLine
8360:   strBaseString = strBaseString & "        pPropSet.RemoveProperty strXName" & vbNewLine
8361:   strBaseString = strBaseString & "      End If" & vbNewLine
8362:   strBaseString = strBaseString & "      pPropSet.SetProperty strXName, strDescription" & vbNewLine
8363:   strBaseString = strBaseString & " " & vbNewLine
8364:   strBaseString = strBaseString & "      ' SET SOURCE IF IT IS NOT ALREADY SET" & vbNewLine
8365:   strBaseString = strBaseString & "      varSource = pPropSet.GetProperty(strXNameSource)" & vbNewLine
8366:   strBaseString = strBaseString & "      If IsEmpty(varSource) Then" & vbNewLine
8367:   strBaseString = strBaseString & "        pPropSet.SetProperty strXNameSource, ""Lab of Landscape Ecology and Conservation Biology; "" & _" & vbNewLine
8368:   strBaseString = strBaseString & "            ""School of Earth Sciences and Environmental Sustainability; College of Engineering, "" & _" & vbNewLine
8369:   strBaseString = strBaseString & "            ""Forestry and Natural Sciences; Northern Arizona University; Flagstaff, AZ 86011""" & vbNewLine
8370:   strBaseString = strBaseString & "      End If" & vbNewLine
8371:   strBaseString = strBaseString & "    End If" & vbNewLine
8372:   strBaseString = strBaseString & " " & vbNewLine
8373:   strBaseString = strBaseString & "    For lngBLMIndex = 0 To UBound(strBLMObsArray, 1)" & vbNewLine
8374:   strBaseString = strBaseString & "      If strFieldName = strBLMObsArray(lngBLMIndex, 0) Then '  ""BLM_OBS_USE1"", ""BLM_OBS_USE2"" or ""BLM_OBS_USE3""" & vbNewLine
8375:   strBaseString = strBaseString & " " & vbNewLine
8376:   strBaseString = strBaseString & "        ' FIND ORIGINAL FIELD METADATA" & vbNewLine
8377:   strBaseString = strBaseString & "        For lngIndex = 0 To pBLM_AZStrip_UTM12_NAD83_FClass.Fields.FieldCount" & vbNewLine
8378:   strBaseString = strBaseString & "          strNames(0) = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
8379:   strBaseString = strBaseString & "          pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperties strNames, varVals" & vbNewLine
8380:   strBaseString = strBaseString & "          varSubVals = varVals(0)" & vbNewLine
8381:   strBaseString = strBaseString & "          If Not IsEmpty(varSubVals) Then" & vbNewLine
8382:   strBaseString = strBaseString & "            ' GET FIELD NAME" & vbNewLine
8383:   strBaseString = strBaseString & "            strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrlabl""" & vbNewLine
8384:   strBaseString = strBaseString & "            varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
8385:   strBaseString = strBaseString & "            If Not IsEmpty(varProperty) Then" & vbNewLine
8386:   strBaseString = strBaseString & "              varSubProperty = varProperty(0)" & vbNewLine
8387:   strBaseString = strBaseString & "              If IsEmpty(varSubProperty) Then" & vbNewLine
8388:   strBaseString = strBaseString & "                strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
8389:   strBaseString = strBaseString & "              Else" & vbNewLine
8390:   strBaseString = strBaseString & "                strOrigFieldName = CStr(varSubProperty)" & vbNewLine
8391:   strBaseString = strBaseString & "              End If" & vbNewLine
8392:   strBaseString = strBaseString & "            Else" & vbNewLine
8393:   strBaseString = strBaseString & "              strOrigFieldName = ""<-- No Field Name -->""" & vbNewLine
8394:   strBaseString = strBaseString & "            End If" & vbNewLine
8395:   strBaseString = strBaseString & " " & vbNewLine
8396:   strBaseString = strBaseString & "            If strOrigFieldName = strBLMObsArray(lngBLMIndex, 1) Then ' ""OBS_USE1"", ""OBS_USE2"", or ""OBS_USE3""" & vbNewLine
8397:   strBaseString = strBaseString & " " & vbNewLine
8398:   strBaseString = strBaseString & "              If lngBLMIndex <= 4 Then" & vbNewLine
8399:   strBaseString = strBaseString & "                strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
8400:   strBaseString = strBaseString & "                varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
8401:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
8402:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
8403:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2))" & vbNewLine
8404:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
8405:   strBaseString = strBaseString & " " & vbNewLine
8406:   strBaseString = strBaseString & "                ' GET DOMAIN ATTRIBUTES FROM ORIGINAL FCLASS" & vbNewLine
8407:   strBaseString = strBaseString & "                strOrigFClassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv""" & vbNewLine
8408:   strBaseString = strBaseString & "                varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFClassXName)" & vbNewLine
8409:   strBaseString = strBaseString & " " & vbNewLine
8410:   strBaseString = strBaseString & "                ' ADD DOMAIN ATTRIBUTES TO NEW FCLASS" & vbNewLine
8411:   strBaseString = strBaseString & "                varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv"")" & vbNewLine
8412:   strBaseString = strBaseString & "                If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
8413:   strBaseString = strBaseString & "                  pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv""" & vbNewLine
8414:   strBaseString = strBaseString & "                End If" & vbNewLine
8415:   strBaseString = strBaseString & "                For lngIndex3 = 0 To UBound(varProperty)" & vbNewLine
8416:   strBaseString = strBaseString & "                  strSubXName1 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
8417:   strBaseString = strBaseString & "                      varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]""" & vbNewLine
8418:   strBaseString = strBaseString & "                  varSubProp1 = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strSubXName1)" & vbNewLine
8419:   strBaseString = strBaseString & " " & vbNewLine
8420:   strBaseString = strBaseString & "                  For lngIndex4 = 0 To UBound(varSubProp1)" & vbNewLine
8421:   strBaseString = strBaseString & "                    strSubXName2 = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdomv/"" & _" & vbNewLine
8422:   strBaseString = strBaseString & "                        varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
8423:   strBaseString = strBaseString & "                    varSubProp2 = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strSubXName2)" & vbNewLine
8424:   strBaseString = strBaseString & " " & vbNewLine
8425:   strBaseString = strBaseString & "                    ' WRITE VALUE BACK TO NEW FCLASS" & vbNewLine
8426:   strBaseString = strBaseString & "                    strSubXName3 = ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdomv/"" & _" & vbNewLine
8427:   strBaseString = strBaseString & "                        varProperty(lngIndex3) & ""["" & CStr(lngIndex3) & ""]/"" & varSubProp1(lngIndex4)" & vbNewLine
8428:   strBaseString = strBaseString & "                    strValue = varSubProp2(0)" & vbNewLine
8429:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""20003"", ""2003"")" & vbNewLine
8430:   strBaseString = strBaseString & "                    strValue = Replace(strValue, ""Dicitonary"", ""Dictionary"")" & vbNewLine
8431:   strBaseString = strBaseString & "                    pPropSet.SetProperty strSubXName3, strValue" & vbNewLine
8432:   strBaseString = strBaseString & " " & vbNewLine
8433:   strBaseString = strBaseString & "                  Next lngIndex4" & vbNewLine
8434:   strBaseString = strBaseString & "                Next lngIndex3" & vbNewLine
8435:   strBaseString = strBaseString & "              Else" & vbNewLine
8436:   strBaseString = strBaseString & "'                strOrigFCLassXName = ""eainfo/detailed/attr["" & CStr(lngIndex) & ""]""" & vbNewLine
8437:   strBaseString = strBaseString & "'                varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName)" & vbNewLine
8438:   strBaseString = strBaseString & "'                varSubProperty = varProperty(0)" & vbNewLine
8439:   strBaseString = strBaseString & "'                Debug.Print ""Examining "" & strOrigFieldName & ""...""" & vbNewLine
8440:   strBaseString = strBaseString & "'                For lngIndex2 = 0 To UBound(varProperty)" & vbNewLine
8441:   strBaseString = strBaseString & "'                  varSubProp1 = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(strOrigFCLassXName & ""/"" & _" & vbNewLine
8442:   strBaseString = strBaseString & "'                        CStr(varProperty(lngIndex2)))" & vbNewLine
8443:   strBaseString = strBaseString & "'                  Debug.Print ""       "" & CStr(lngIndex2) & ""] "" & CStr(varProperty(lngIndex2)) & "" = "" & _" & vbNewLine
8444:   strBaseString = strBaseString & "'                        CStr(varSubProp1(0))" & vbNewLine
8445:   strBaseString = strBaseString & "'                Next lngIndex2" & vbNewLine
8446:   strBaseString = strBaseString & "              End If" & vbNewLine
8447:   strBaseString = strBaseString & " " & vbNewLine
8448:   strBaseString = strBaseString & "              If strOrigFieldName = ""ROAD_NO_"" Then" & vbNewLine
8449:   strBaseString = strBaseString & "                Debug.Print ""Here...""" & vbNewLine
8450:   strBaseString = strBaseString & "              End If" & vbNewLine
8451:   strBaseString = strBaseString & " " & vbNewLine
8452:   strBaseString = strBaseString & "              ' GET DEFINITION FROM ORIGINAL FCLASS" & vbNewLine
8453:   strBaseString = strBaseString & "              varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdef"")" & vbNewLine
8454:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
8455:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
8456:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
8457:   strBaseString = strBaseString & "                  strDescription = ""<-- No Description -->""" & vbNewLine
8458:   strBaseString = strBaseString & "                Else" & vbNewLine
8459:   strBaseString = strBaseString & "                  strDescription = CStr(varSubProperty)" & vbNewLine
8460:   strBaseString = strBaseString & "                End If" & vbNewLine
8461:   strBaseString = strBaseString & "              Else" & vbNewLine
8462:   strBaseString = strBaseString & "                strDescription = ""<-- No Description -->""" & vbNewLine
8463:   strBaseString = strBaseString & "              End If" & vbNewLine
8464:   strBaseString = strBaseString & "              strDescription = Replace(strDescription, ""  [Imported from TransportationLine_UTM12_NAD83]"", """", , , vbTextCompare)" & vbNewLine
8465:   strBaseString = strBaseString & "              strDescription = strDescription & _" & vbNewLine
8466:   strBaseString = strBaseString & "                  ""  This field should only have a value if the 'BLM_Add_Attribute' value = """"TRUE"""".  "" & _" & vbNewLine
8467:   strBaseString = strBaseString & "                  ""[Imported from BLM_AZStrip_UTM12_NAD83, Field """""" & strBLMObsArray(lngBLMIndex, 1) & """"""]""" & vbNewLine
8468:   strBaseString = strBaseString & " " & vbNewLine
8469:   strBaseString = strBaseString & "              ' SET FIELD DEFINITION OF NEW FCLASS" & vbNewLine
8470:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"")" & vbNewLine
8471:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
8472:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef""" & vbNewLine
8473:   strBaseString = strBaseString & "              End If" & vbNewLine
8474:   strBaseString = strBaseString & "              pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdef"", strDescription" & vbNewLine
8475:   strBaseString = strBaseString & " " & vbNewLine
8476:   strBaseString = strBaseString & "              ' GET DESCRIPTION SOURCE FROM ORIGINAL FCLASS" & vbNewLine
8477:   strBaseString = strBaseString & "              varProperty = pBLM_AZStrip_UTM12_NAD83_PropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngIndex) & ""]/attrdefs"")" & vbNewLine
8478:   strBaseString = strBaseString & "              If Not IsEmpty(varProperty) Then" & vbNewLine
8479:   strBaseString = strBaseString & "                varSubProperty = varProperty(0)" & vbNewLine
8480:   strBaseString = strBaseString & "                If IsEmpty(varSubProperty) Then" & vbNewLine
8481:   strBaseString = strBaseString & "                  strDescriptionSource = ""BLM_AZStrip_UTM12_NAD83""" & vbNewLine
8482:   strBaseString = strBaseString & "                Else" & vbNewLine
8483:   strBaseString = strBaseString & "                  strDescriptionSource = CStr(varSubProperty)" & vbNewLine
8484:   strBaseString = strBaseString & "                End If" & vbNewLine
8485:   strBaseString = strBaseString & "              Else" & vbNewLine
8486:   strBaseString = strBaseString & "                strDescriptionSource = ""BLM_AZStrip_UTM12_NAD83""" & vbNewLine
8487:   strBaseString = strBaseString & "              End If" & vbNewLine
8488:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""Dicitonary"", ""Dictionary"", , , vbTextCompare)" & vbNewLine
8489:   strBaseString = strBaseString & "              strDescriptionSource = Replace(strDescriptionSource, ""20003"", ""2003"", , , vbTextCompare)" & vbNewLine
8490:   strBaseString = strBaseString & " " & vbNewLine
8491:   strBaseString = strBaseString & "              ' SET DESCRIPTION SOURCE DEFINITION OF NEW FCLASS" & vbNewLine
8492:   strBaseString = strBaseString & "              varCheckPropertyPresent = pPropSet.GetProperty(""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"")" & vbNewLine
8493:   strBaseString = strBaseString & "              If Not IsEmpty(varCheckPropertyPresent) Then" & vbNewLine
8494:   strBaseString = strBaseString & "                pPropSet.RemoveProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs""" & vbNewLine
8495:   strBaseString = strBaseString & "              End If" & vbNewLine
8496:   strBaseString = strBaseString & " " & vbNewLine
8497:   strBaseString = strBaseString & "              ' ONLY ADD THIS NEW ONE IF THERE WAS ONE IN THE ORIGINAL FCLASS" & vbNewLine
8498:   strBaseString = strBaseString & "              If strDescriptionSource <> """" Then" & vbNewLine
8499:   strBaseString = strBaseString & "                pPropSet.SetProperty ""eainfo/detailed/attr["" & CStr(lngFieldIndex) & ""]/attrdefs"", strDescriptionSource" & vbNewLine
8500:   strBaseString = strBaseString & "              End If" & vbNewLine
8501:   strBaseString = strBaseString & " " & vbNewLine
8502:   strBaseString = strBaseString & "              Exit For" & vbNewLine
8503:   strBaseString = strBaseString & "            End If" & vbNewLine
8504:   strBaseString = strBaseString & "          End If" & vbNewLine
8505:   strBaseString = strBaseString & "        Next lngIndex" & vbNewLine
8506:   strBaseString = strBaseString & "      End If" & vbNewLine
8507:   strBaseString = strBaseString & "    Next lngBLMIndex" & vbNewLine
8508:   strBaseString = strBaseString & "  End If" & vbNewLine
8509:   strBaseString = strBaseString & " " & vbNewLine
8510:   strBaseString = strBaseString & "  pPropSet.RemoveProperty ""eainfo/detailed/subtype""" & vbNewLine
8511:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stname"", ""Administrative""" & vbNewLine
8512:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stcode"", ""1""" & vbNewLine
8513:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[0]/stfldnm"", ""ROADS_SurfaceMaterial""" & vbNewLine
8514:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[0]/stflddd/domname"", ""SurfaceMaterialDomain""" & vbNewLine
8515:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[0]/stflddd/domdesc"", ""Description""" & vbNewLine
8516:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[0]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8517:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[0]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8518:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[0]/stflddd/splttype"", ""Default value""" & vbNewLine
8519:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[0]/stflddd/domowner"", """"" & vbNewLine
8520:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[0]/stflddd/domfldtp"", ""String""" & vbNewLine
8521:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[1]/stfldnm"", ""ROADS_Status""" & vbNewLine
8522:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[1]/stflddd/domname"", ""RoadStatusDomain""" & vbNewLine
8523:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[1]/stflddd/domdesc"", ""Description""" & vbNewLine
8524:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[1]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8525:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[1]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8526:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[1]/stflddd/splttype"", ""Default value""" & vbNewLine
8527:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[1]/stflddd/domowner"", """"" & vbNewLine
8528:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[1]/stflddd/domfldtp"", ""String""" & vbNewLine
8529:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[2]/stfldnm"", ""ROADS_Compendium""" & vbNewLine
8530:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[2]/stflddd/domname"", ""CompendiumDomain""" & vbNewLine
8531:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[2]/stflddd/domdesc"", ""Description""" & vbNewLine
8532:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[2]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8533:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[2]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8534:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[2]/stflddd/splttype"", ""Default value""" & vbNewLine
8535:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[2]/stflddd/domowner"", """"" & vbNewLine
8536:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[2]/stflddd/domfldtp"", ""String""" & vbNewLine
8537:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[3]/stfldnm"", ""WildernessRecommendation""" & vbNewLine
8538:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[3]/stflddd/domname"", ""WildernessRecommendDomain""" & vbNewLine
8539:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[3]/stflddd/domdesc"", ""Description""" & vbNewLine
8540:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[3]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8541:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[3]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8542:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[3]/stflddd/splttype"", ""Default value""" & vbNewLine
8543:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[3]/stflddd/domowner"", """"" & vbNewLine
8544:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[3]/stflddd/domfldtp"", ""String""" & vbNewLine
8545:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[4]/stfldnm"", ""WildernessMap_1980""" & vbNewLine
8546:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[4]/stflddd/domname"", ""WildMap1980Domain""" & vbNewLine
8547:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[4]/stflddd/domdesc"", ""Description""" & vbNewLine
8548:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[4]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8549:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[4]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8550:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[4]/stflddd/splttype"", ""Default value""" & vbNewLine
8551:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[4]/stflddd/domowner"", """"" & vbNewLine
8552:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[0]/stfield[4]/stflddd/domfldtp"", ""String""" & vbNewLine
8553:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stname"", ""Closed""" & vbNewLine
8554:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stcode"", ""2""" & vbNewLine
8555:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[0]/stfldnm"", ""ROADS_SurfaceMaterial""" & vbNewLine
8556:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[0]/stflddd/domname"", ""SurfaceMaterialDomain""" & vbNewLine
8557:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[0]/stflddd/domdesc"", ""Description""" & vbNewLine
8558:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[0]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8559:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[0]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8560:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[0]/stflddd/splttype"", ""Default value""" & vbNewLine
8561:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[0]/stflddd/domowner"", """"" & vbNewLine
8562:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[0]/stflddd/domfldtp"", ""String""" & vbNewLine
8563:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[1]/stfldnm"", ""ROADS_Status""" & vbNewLine
8564:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[1]/stflddd/domname"", ""RoadStatusDomain""" & vbNewLine
8565:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[1]/stflddd/domdesc"", ""Description""" & vbNewLine
8566:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[1]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8567:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[1]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8568:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[1]/stflddd/splttype"", ""Default value""" & vbNewLine
8569:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[1]/stflddd/domowner"", """"" & vbNewLine
8570:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[1]/stflddd/domfldtp"", ""String""" & vbNewLine
8571:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[2]/stfldnm"", ""ROADS_Compendium""" & vbNewLine
8572:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[2]/stflddd/domname"", ""CompendiumDomain""" & vbNewLine
8573:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[2]/stflddd/domdesc"", ""Description""" & vbNewLine
8574:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[2]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8575:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[2]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8576:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[2]/stflddd/splttype"", ""Default value""" & vbNewLine
8577:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[2]/stflddd/domowner"", """"" & vbNewLine
8578:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[2]/stflddd/domfldtp"", ""String""" & vbNewLine
8579:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[3]/stfldnm"", ""WildernessRecommendation""" & vbNewLine
8580:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[3]/stflddd/domname"", ""WildernessRecommendDomain""" & vbNewLine
8581:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[3]/stflddd/domdesc"", ""Description""" & vbNewLine
8582:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[3]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8583:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[3]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8584:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[3]/stflddd/splttype"", ""Default value""" & vbNewLine
8585:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[3]/stflddd/domowner"", """"" & vbNewLine
8586:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[3]/stflddd/domfldtp"", ""String""" & vbNewLine
8587:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[4]/stfldnm"", ""WildernessMap_1980""" & vbNewLine
8588:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[4]/stflddd/domname"", ""WildMap1980Domain""" & vbNewLine
8589:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[4]/stflddd/domdesc"", ""Description""" & vbNewLine
8590:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[4]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8591:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[4]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8592:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[4]/stflddd/splttype"", ""Default value""" & vbNewLine
8593:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[4]/stflddd/domowner"", """"" & vbNewLine
8594:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[1]/stfield[4]/stflddd/domfldtp"", ""String""" & vbNewLine
8595:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stname"", ""Public""" & vbNewLine
8596:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stcode"", ""3""" & vbNewLine
8597:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[0]/stfldnm"", ""ROADS_SurfaceMaterial""" & vbNewLine
8598:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[0]/stflddd/domname"", ""SurfaceMaterialDomain""" & vbNewLine
8599:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[0]/stflddd/domdesc"", ""Description""" & vbNewLine
8600:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[0]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8601:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[0]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8602:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[0]/stflddd/splttype"", ""Default value""" & vbNewLine
8603:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[0]/stflddd/domowner"", """"" & vbNewLine
8604:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[0]/stflddd/domfldtp"", ""String""" & vbNewLine
8605:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[1]/stfldnm"", ""ROADS_Status""" & vbNewLine
8606:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[1]/stflddd/domname"", ""RoadStatusDomain""" & vbNewLine
8607:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[1]/stflddd/domdesc"", ""Description""" & vbNewLine
8608:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[1]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8609:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[1]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8610:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[1]/stflddd/splttype"", ""Default value""" & vbNewLine
8611:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[1]/stflddd/domowner"", """"" & vbNewLine
8612:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[1]/stflddd/domfldtp"", ""String""" & vbNewLine
8613:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[2]/stfldnm"", ""ROADS_Compendium""" & vbNewLine
8614:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[2]/stflddd/domname"", ""CompendiumDomain""" & vbNewLine
8615:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[2]/stflddd/domdesc"", ""Description""" & vbNewLine
8616:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[2]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8617:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[2]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8618:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[2]/stflddd/splttype"", ""Default value""" & vbNewLine
8619:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[2]/stflddd/domowner"", """"" & vbNewLine
8620:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[2]/stflddd/domfldtp"", ""String""" & vbNewLine
8621:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[3]/stfldnm"", ""WildernessRecommendation""" & vbNewLine
8622:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[3]/stflddd/domname"", ""WildernessRecommendDomain""" & vbNewLine
8623:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[3]/stflddd/domdesc"", ""Description""" & vbNewLine
8624:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[3]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8625:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[3]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8626:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[3]/stflddd/splttype"", ""Default value""" & vbNewLine
8627:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[3]/stflddd/domowner"", """"" & vbNewLine
8628:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[3]/stflddd/domfldtp"", ""String""" & vbNewLine
8629:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[4]/stfldnm"", ""WildernessMap_1980""" & vbNewLine
8630:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[4]/stflddd/domname"", ""WildMap1980Domain""" & vbNewLine
8631:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[4]/stflddd/domdesc"", ""Description""" & vbNewLine
8632:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[4]/stflddd/domtype"", ""Coded Value""" & vbNewLine
8633:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[4]/stflddd/mrgtype"", ""Default value""" & vbNewLine
8634:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[4]/stflddd/splttype"", ""Default value""" & vbNewLine
8635:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[4]/stflddd/domowner"", """"" & vbNewLine
8636:   strBaseString = strBaseString & "  pPropSet.SetProperty ""eainfo/detailed/subtype[2]/stfield[4]/stflddd/domfldtp"", ""String""" & vbNewLine
8637:   strBaseString = strBaseString & " " & vbNewLine
8638:   strBaseString = strBaseString & "ClearMemory:" & vbNewLine
8639:   strBaseString = strBaseString & "  Set pRoads_KNF_UTM12_NAD83_FClass = Nothing" & vbNewLine
8640:   strBaseString = strBaseString & "  Set pTIGER_2012_Trans_Near_Park_UTM12_NAD83_FClass = Nothing" & vbNewLine
8641:   strBaseString = strBaseString & "  Set pBLM_AZStrip_UTM12_NAD83_FClass = Nothing" & vbNewLine
8642:   strBaseString = strBaseString & "  Set pRoads_UTM12_NAD83_FClass = Nothing" & vbNewLine
8643:   strBaseString = strBaseString & "  Set pTrails_UTM12_NAD83_FClass = Nothing" & vbNewLine
8644:   strBaseString = strBaseString & "  Set pRoutes_UTM12_NAD83_FClass = Nothing" & vbNewLine
8645:   strBaseString = strBaseString & "  Set pUtah_Roads_Near_AOI_UTM12_NAD83_FClass = Nothing" & vbNewLine
8646:   strBaseString = strBaseString & "  Set pTrails_KNF_UTM12_NAD83_FClass = Nothing" & vbNewLine
8647:   strBaseString = strBaseString & "  Set pTransportationLine_UTM12_NAD83_FClass = Nothing" & vbNewLine
8648:   strBaseString = strBaseString & "  Set pRoads_KNF_UTM12_NAD83_PropSet = Nothing" & vbNewLine
8649:   strBaseString = strBaseString & "  Set pTIGER_2012_Trans_Near_Park_UTM12_NAD83_PropSet = Nothing" & vbNewLine
8650:   strBaseString = strBaseString & "  Set pBLM_AZStrip_UTM12_NAD83_PropSet = Nothing" & vbNewLine
8651:   strBaseString = strBaseString & "  Set pRoads_UTM12_NAD83_PropSet = Nothing" & vbNewLine
8652:   strBaseString = strBaseString & "  Set pTrails_UTM12_NAD83_PropSet = Nothing" & vbNewLine
8653:   strBaseString = strBaseString & "  Set pRoutes_UTM12_NAD83_PropSet = Nothing" & vbNewLine
8654:   strBaseString = strBaseString & "  Set pUtah_Roads_Near_AOI_UTM12_NAD83_PropSet = Nothing" & vbNewLine
8655:   strBaseString = strBaseString & "  Set pTrails_KNF_UTM12_NAD83_PropSet = Nothing" & vbNewLine
8656:   strBaseString = strBaseString & "  Set pTransportationLine_UTM12_NAD83_PropSet = Nothing" & vbNewLine
8657:   strBaseString = strBaseString & "  Set pSubArray = Nothing" & vbNewLine
8658:   strBaseString = strBaseString & "  Erase strNames" & vbNewLine
8659:   strBaseString = strBaseString & " " & vbNewLine
  strBaseString = strBaseString & "End Sub" & vbNewLine
8661:   strBaseString = strBaseString & " " & vbNewLine

End Sub

