Attribute VB_Name = "MyGeneralOperations"
Option Explicit

' MyGeneralOperations
' Jeff Jenness
' Jenness Enterprises
' http://www.jennessent.com

'  BasicStatsFromArray - GIVEN anArray, Field Name, Table Name, and Application, _
            Returns Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean and Mode String
'  BasicStatsFromArraySimple - Simplified version of BasicStatsFromArray, with no progress info and no mode data.
'           GIVEN anArray, optional directive to calculate standard deviation info,
'           Returns Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean
'  BasicStatsFromArraySimpleFast - SAME AS BasicStatsFromArraySimple EXCEPT THAT IT IS A SUB AND THEREFORE FILLS VALUES INSTEAD OF
'           RETURNING THEM, AND IT USES NO ARCOBJECTS.
'  BasicStatsFromArray_Weighted - GIVEN 2-Dimensional anArray with Values and Weights, Field Name, Table Name, and Application, _
            Returns Weighted Mean, Weighted StDev and Weighted Variance
'  BasicStatsFromVAT - GIVEN 2-Dimensional Arrays (Value and Size, both sorted by Value), Field Name, Table Name, and Application, _
            Returns Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean and Mode String
'  CalcStatistics - GIVEN AN ARRAY OF DOUBLES AND AN ARRAY OF BOOLEAN STAT OPTIONS, RETURNS AN ARRAY OF STATISTICS
'  CheckCollectionForKey - GIVEN pCollection and STRING, RETURNS BOOLEAN INDICATING WHETHER COLLECTION HAS THAT KEY OR NOT
'  CheckIfCompressedFGDB - GIVEN pFeatureClass, RETURNS BOOLEAN IF THIS FEATURE CLASS COMES FROM A COMPRESSED FILE GEODATABASE
'  CheckIfFeatureClassExists - GIVEN FEATURE WORKSPACE AND FEATURE CLASS NAME, RETURNS BOOLEAN IF FEATURE CLASS ALREADY EXISTS
'  CheckIfTableExists - GIVEN FEATURE WORKSPACE AND TABLE NAME, RETURNS BOOLEAN IF TABLE WITH THAT NAME ALREADY EXISTS
'  CheckNumericReal - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY REAL NUMBER
'  CheckNumericRealPositive - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY POSITIVE REAL NUMBER
'  CheckNumericInteger - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY INTEGER
'  CheckNumericIntegerPositive - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY POSITIVE INTEGER
'  CheckSpRefDomain - GIVEN SPATIAL REFERENCE, RETURNS BOOLEAN STATING WHETHER IT HAS A VALID XY DOMAIN
'  CompareSpatialReferences - RETURNS A BOOLEAN STATING WHETHER PROJECTION / DATUM ARE SAME.
'  ConvertLongBinary - GIVEN A LONG AND OPTIONAL NUMBER OF CHARACTERS, RETURNS BINARY REPRESENTATION.
'  ConvertNumberToBullet - GIVEN A NUMBER AND TYPE, RETURNS LETTER OR ROMAN NUMERAL
'  ConvertNumberBase - GIVEN A LONG AND BASE, RETURNS LONG ARRAY CONTAINING NUMERICAL INDEX FOR EACH POSITION
'  ConvertNumberToRoman - GIVEN A LONG AND BOOLEAN FOR UPPERCASE, RETURNS ROMAN NUMERAL EQUIVALENT
'  CountGraphicsByName - GIVEN A NAME AND MAP DOCUMENT, COUNTS ALL GRAPHICS WITH A PARTICULAR NAME
'  CreateDatasetFeatureClass - GIVEN A FEATURE DATASET, FEATURE CLASS NAME, OPTIONAL GOEMETRY TYPE AND FIELD ARRAY, RETURNS A
'           NEW FEATURE CLASS INSIDE THE SPECIFIED FEATURE DATASET:  MODIFIED FROM ESRI SAMPLE
'  CreateGDBFeatureClass - GIVEN A FILE OR PERSONAL GEODATABASE, FEATURE CLASS NAME, OPTIONAL GOEMETRY TYPE, FIELD ARRAY, ETC, RETURNS A
'           NEW GEODATABASE FEATURE CLASS:  MODIFIED FROM ESRI SAMPLE
'  CreateGDBTable - GIVEN A FILE OR PERSONAL GEODATABASE, TABLE NAME, FIELD ARRAY, ETC, RETURNS A
'           NEW GEODATABASE TABLE:  MODIFIED FROM ESRI SAMPLE FOR CREATING GEODATABASE FEATURE CLASSES
'  CreateGeneralFeatureClass - RETURNS A NEW FEATURE CLASS IN A FOLDER (I.E. SHAPEFILE) OR IN A FILE / PERSONAL GEODATABASE.
'           CAN SEND IT SPECIFIC INSTRUCTIONS REGARDING NAME AND LOCATION, OR CAN HAVE IT ASK THE USER.
'  CreateGeneralTable - RETURNS A NEW TABLE IN A FOLDER (I.E. dBASE TABLE) OR IN A FILE / PERSONAL GEODATABASE.
'           CAN SEND IT SPECIFIC INSTRUCTIONS REGARDING NAME AND LOCATION, OR CAN HAVE IT ASK THE USER.
'  CreateInMemoryFeatureClass - GIVEN AN IARRAY OF GEOMETRIES (ALL OF SAME TYPE), RETURNS AN IN-MEMORY FEATURE CLASS.
'  CreateInMemoryFeatureClass2 - GIVEN AN IARRAY OF GEOMETRIES (ALL OF SAME TYPE), WITH OPTIONAL MULTIPLE FIELDS AND PAPP REFERENCE,
'           RETURNS AN IN-MEMORY FEATURE CLASS.
'  CreateNAD27_NAD83_GeoTransformationFlagstaffReturns a Geographic Transformation to convert from NAD27 to NAD83, using esriSRGeoTransformation_NAD_1927_TO_NAD_1983_NADCON (United States - lower 48 states)
'  CreateNAD27_WGS84_GeoTransformationFlagstaff:  Returns a Geographic Transformation to convert from NAD27 to WGS84, using esriSRGeoTransformation_NAD1927_To_WGS1984_4 (United States - lower 48 states)
'  CreateNAD83_WGS84_GeoTransformationFlagstaff:  Returns a Geographic Transformation to convert from NAD83 to WGS84, using esriSRGeoTransformation_NAD1983_To_WGS1984_5 (United States - CORS ITRF96)
'  CreateNestedFoldersByPath - GIVEN A PATH NAME, CREATES ANY MISSING FOLDERS IN THAT PATH
'  CreateShapefileFeatureClass - GIVEN A FOLDER, NAME, SPATIAL REFERENCE, GEOMETRY TYPE, OPTIONAL FIELD ARRAY,
'           RETURNS SHAPEFILE FEATURE CLASS.
'  CreateSpatialReferenceWGS84 - RETURNS A WGS84 GEOGRAPHIC COORDINATE SYSTEM
'  CreateSpatialReferenceNAD27 - RETURNS A NAD 1927 GEOGRAPHIC COORDINATE SYSTEM
'  CreateSpatialReferenceNAD83 - RETURNS A NAD 1983 GEOGRAPHIC COORDINATE SYSTEM
'  CreatedBASETableInFolder - GIVEN A FOLDER, NAME, OPTIONAL FIELD ARRAY, CREATEDS dBASE TABLE AND RETURNS ITable OBJECT.
'  CursorToSet_Features - GIVEN A FEATURE CURSOR, RETURNS AN ISET OF FEATURES ALLOWING SET TO BE RUN THROUGH MULTIPLE TIMES
'  CursorToSet_TableRow - GIVEN A CURSOR, RETURNS AN ISET OF ROWS ALLOWING SET TO BE RUN THROUGH MULTIPLE TIMES
'  DeleteGraphicsByName - GIVEN A NAME AND MAP DOCUMENT, DELETES ALL GRAPHICS WITH A PARTICULAR NAME
'  DeleteGraphicsByNameByBounds - GIVEN A NAME AND MAP DOCUMENT, DELETES ALL GRAPHICS WITH A PARTICULAR NAME USING BOUNDS OF GRAPHIC SYMBOLOGY
'  DoSpatialQuery - SELECTS ALL FEATURES FROM FIRST FEATURE LAYER THAT INTERSECT SELECTED FEATURES OF SECONDS FEATURE LAYER
'  EnableSelectTool - GIVEN Application, CLICKS THE "SELECT ELEMENTS" TOOL
'  ForceUppercase - GIVEN KEYASCII AND TEXTBOX, FORCES ENTERED KEYSTROKE TO BE UPPERCASE
'  Get_Element_Or_Envelope_Point - USED IN CONJUNCTION WITH Move_Element; THIS FUNCTION RETURNS A POINT AT A PARTICULAR LOCATION IN AN ENVELOPE OR
'           ELEMENT, SUCH AS THE UPPER LEFT CORNER OR THE CENTER OF THE ENVELOPE.  Move_Element HELPS YOU POSITION ONE OBJECT
'           IN RELATION TO ANOTHER, SUCH AS LINED UP ON AN EDGE.
'  GetPart - GIVEN A STRING AND DELIMITER, CLIPS OFF PORTION OF STRING IN FRONT OF DELIMITER AND RETURNS IT.  THE ORIGINAL
'           STRING HAS THE PART AND DELIMITER REMOVED FROM THE FRONT.  USED BY CreateNestedFoldersByPath FUNCTION
'  Graphic_MakeFromGeometry - GIVEN A MAP DOCUMENT, GEOMETRY AND OPTIONAL NAME AND SYMBOLOGY, ADDS GRAPHIC TO MAP.
'  Graphic_MakeFromGeometry - GIVEN A SPECIFIC MAP IN A MAP DOCUMENT, GEOMETRY AND OPTIONAL NAME AND SYMBOLOGY, ADDS GRAPHIC TO MAP.
'  Graphic_ReturnElementFromGeometry - GIVEN MAP DOC, GEOMETRY, OPTIONAL NAME AND OPTIONAL ADD-TO-VIEW, RETURNS THE GRAPHIC
'           ELEMENT
'  Graphic_ReturnElementFromGeometry2 - SAME AS ABOVE, BUT WITH OPTION TO ADD A SYMBOL TO THE GRAPHIC ELEMENT
'  GraphicsSetNameSelected - GIVEN A MAP DOCUMENT AND NAME, ASSIGNS THAT NAME TO ALL SELECTED GRAPHICS
'  IsNaN - GIVEN A VARIANT, RETURNS A BOOLEAN INDICATING WHETHER A NUMBER IS A "NOT-A-NUMBER" VALUE
'  MakeColorRGB - GIVEN RED, GREEN AND BLUE, RETURN ICOLOR
'  MakeColorHSV - GIVEN HUE, SATURATION AND VALUE, RETURN ICOLOR
'  MakeFieldNameArray - GIVEN ORIGINAL FEATURE CLASS, NEW FEATURE CLASS, AND IVARIANARRAY OF NEW FIELD NAMES,
'                   RETURN ARRAY CONTAINING INDEX VALUES FOR EACH FIELD NAME
'  MakeFieldNameVarArrayFromTable - SAME AS MakeFieldNameArray, EXCEPT THAT IT TAKES AN ORIGINAL TABLE INSTEAD OF ORIGINAL FEATURE CLASS
'  MakeRandomNormal - GIVEN MEAN, SD, PLACEHOLDER VARIABLE, OPTIONAL SECOND PLACEHOLDER, REPLACES PLACEHOLDERS WITH RANDOM NUMBERS
'                   FROM NORMAL DISTRIBUTION WITH SPECIFIED MEAN AND STANDARD DEVIATION
'                   USES BOX-MULLER TRANSFORMATION
'  MakeRandomNormalPolar - GIVEN MEAN, SD, PLACEHOLDER VARIABLE, OPTIONAL SECOND PLACEHOLDER, REPLACES PLACEHOLDERS WITH RANDOM NUMBERS
'                   FROM NORMAL DISTRIBUTION WITH SPECIFIED MEAN AND STANDARD DEVIATION
'                   Marsaglia's variation of the Box-Muller Transformation (http://en.wikipedia.org/wiki/Box-Muller_transform)
'  MakeUniquedBASEName - GIVEN A FULL FILE NAME, RETURNS A UNIQUE FILENAME IN THAT FOLDER BY APPENDING COUNTER TO ORIGINAL NAME
'  MakeUniqueGDBFeatureClassName - GIVEN IWorkspace AND NAME STRING, RETURNS A NAME STRING THAT REFLECTS A UNIQUE NAME IN THAT GDB
'  MakeUniqueGDBTableName - GIVEN IWorkspace AND NAME STRING, RETURNS A NAME STRING THAT REFLECTS A UNIQUE TABLE NAME IN THAT GDB
'  MakeUniqueRasterName - GIVEN JenDatasetType, WORKSPACE PATH STRING AND RASTER NAME, RETURNS A UNIQUE RASTER NAME FOR THAT WORKSPACE
'                   OPTIONALLY WILL TRIM TO GRID RESTRICTIONS FOR FILE-BASED RASTER
'  MakeUniqueRasterName2 - GIVEN IWorkspace, RASTER NAME AND OPTIONAL BOOLEAN TO TRIM TO 13 CHARACTERS, RETURNS A UNIQUE RASTER NAME FOR THAT WORKSPACE
'  MakeUniqueShapeFilename - GIVEN A FULL FILE NAME, RETURNS A UNIQUE FILENAME IN THAT FOLDER BY APPENDING COUNTER TO ORIGINAL NAME
'  Move_Element - MOVES AN ELEMENT ACCORDING TO THE DISTANCE AND DIRECTION BETWEEN TWO REPRESENTATIVE POINTS.  IF THE TWO POINTS
'           ARE SEPARATED BY X HORIZONTAL UNITS AND Y VERTICAL UNITS, THEN THIS FUNCTION WILL MOVE THE GRAPHIC UP Y UNITS AND OVER X UNITS.
'  Move_Geometry - MOVES A GEOMETRY ACCORDING TO THE DISTANCE AND DIRECTION BETWEEN TWO REPRESENTATIVE POINTS.  IF THE TWO POINTS
'           ARE SEPARATED BY X HORIZONTAL UNITS AND Y VERTICAL UNITS, THEN THIS FUNCTION WILL MOVE THE GEOMETRY UP Y UNITS AND OVER X UNITS.
'  OpenFile - GIVEN A DOCUMENT FILENAME AND PATH, OPENS THAT FILE USING THE REGISTERED WINDOWS PROGRAM
'  ReadTextFile - GIVEN A FILENAME, RETURNS A STRING CONTAINING ALL THE TEXT IN THE FILE
'  RemoveKeyFromCollection - GIVEN A COLLECTION AND KEY, REMOVE THE KEY WITHOUT CRASHING CODE IF COLLECTION DOES NOT HAVE THAT KEY
'  ReplaceBadChars - GIVEN A NAME, REPLACES ALL NON-STANDARD CHARACTERS WITH "_" CHARACTERS
'  ReturnCurrentMapUnits - GIVE IT AN IMAP, IT RETURNS THE NAME OF THE MAP UNITS
'  ReturnDatasetTypeName - GIVEN A TYPE (LONG; pDataset.Type), RETURNS THE NAME OF THE TYPE BASED ON ESRI HELP FILES.
'  ReturnDBASEFieldName - GIVEN SAMPLE FIELD NAME AND LIST, RETURNS A NAME THAT IS VALID FOR DBASE AND DOES NOT EXIST IN THE LIST.
'                         LIST CAN BE AN IFields, IStringArray or IVarArray (CONTAINING EITHER STRINGS OR FIELDS)
'  ReturnDistanceUnitsName - GIVEN AN esriUnits, RETURNS THE NAME
'  ReturnFeatureLayersFromGeoDatabase - GIVEN GEODATABASE WORKSPACE AND FEATURE CLASS TYPE, RETURNS VARIANT ARRAY OF FEATURE LAYERS
'  ReturnFeatureClassOrNothing - GIVEN A FEATURE WORKSPACE AND A NAME, RETURNS THE FEATURE CLASS IF ONE EXISTS WITH THAT NAME OR NOTHING
'  ReturnFieldsByType - GIVEN pFields AND JenFieldType ENUMERATION, RETURNS AN IVarARRAY OF FIELDS
'  ReturnFilesFromNestedFolders - GIVEN FOLDER PATH AND EXTENSION, RETURNS STRING ARRAY OF FILE PATHS WITH THIS EXTENSION
'  ReturnFoldersFromNestedFolders - GIVEN FOLDER PATH AND PARTIAL TEXT, RETURNS STRING ARRAY OF FILE PATHS CONTAINING FOLDERS WITH THIS TEXT
'  ReturnGraphicsByName - GIVEN A MAP DOCUMENT AND NAME, RETURNS A COLLECTION CONTAINING THE GEOMETRIES OF THOSE GRAPHICS
'  ReturnGraphicsByNameFromLayout - GIVEN A MAP DOCUMENT AND NAME, RETURNS A COLLECTION CONTAINING EITHER THE GEOMETRIES OR THE ELEMENTS
'  ReturnGraphicsByType - GIVEN A MAP DOCUMENT AND SHAPE TYPE, RETURNS A COLLECTION CONTAINING THE GEOMETRIES OF THOSE GRAPHICS
'  ReturnHistStatsFromDouble - MODIFICATION OF BasicStatsFromArraySimple
'           GIVEN anArray, optional directive to calculate standard deviation info, optional boolean for sample / population,
'                   optional boolean to return sorted array of numbers
'           RETURNS pArray, containing 4 sub-arrays: 1) Double Array of unique values, 2) Long array of counts of values,
'                   Double Array of standard stats (Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean)
'                   Optional array of sorted numbers
'  ReturnLayersByType - GIVEN FOCUSMAP AND TYPE, RETURNS IVariantArray OF LAYERS
'  ReturnLayerByName - GIVEN NAME AND MAP, RETURNS pLayer OR NOTHING
'  ReturnMapByName - GIVEN NAME AND IMxDocument, RETURNS pMap OR NOTHING
'  ReturnRasterDatasetOrNothing - GIVEN A RASTER WORKSPACE AND A NAME, RETURNS THE RASTER DATASET IF ONE EXISTS WITH THAT NAME OR NOTHING
'  ReturnSelectedLayers - GIVEN MXDOC, RETURNS IARRAY OF SELECTED LAYERS.  ARRAY IS EMPTY IF NO LAYERS SELECTED.
'  ReturnShapefileLayersFromNestedFolders - GIVEN FOLDER PATH AND FEATURE CLASS TYPE, RETURNS VARIANT ARRAY OF FEATURE LAYERS
'  ReturnShapeTypeFromGeomType - GIVEN AN esriGeometryType, RETURNS A 2-VALUE STRING CONTAINING
'                   THE SINGULAR AND PLURAL VERSIONS OF THE GEOMETRY TYPE NAME
'  ReturnShapeTypeNameFromObject - GIVEN A FEATURE CLASS OR GEOMETRY, RETURNS A 2-VALUE STRING CONTAINING
'                   THE SINGULAR AND PLURAL VERSIONS OF THE GEOMETRY TYPE NAME
'  ReturnTableByName - GIVEN NAME AND MAP, RETURNS pStandaloneTable OR NOTHING
'  ReturnTableOrNothing - GIVEN A FEATURE WORKSPACE AND A NAME, RETURNS THE TABLE IF ONE EXISTS WITH THAT NAME OR NOTHING
'  ReturnTempRasterWorkspace - RETURNS A RASTER WORKSPACE OBJECT LOCATED IN CURRENT TEMP DIRECTORY
'  ReturnTimeStamp - RETURNS STRING FORMATTED AS "YYYYMMDD_HHMMSS", OR SOMETHING LIKE "20081314_083230"
'  ReturnTimeElapsed - GIVEN A START AND END TIME, RETURNS A STRING DESCRIBING THE TIME ELAPSED.
'           Analysis Began: Wednesday, July 26, 2006;  4:39:01 PM
'           Analysis Complete: Wednesday, July 27, 2006;  5:47:22 PM
'           Time Elapsed: 1 day, 1 hour, 8 minutes, 21 seconds...
'  ReturnTimeElapsedFromMilliseconds - GIVEN A MILLISECOND COUNT (FROM GetTickCount API FUNCTION), RETURNS A STRING DESCRIBING THE TIME ELAPSED.
'           Analysis Began: Wednesday, July 26, 2006;  4:39:01 PM
'           Analysis Complete: Wednesday, July 27, 2006;  5:47:22 PM
'           Time Elapsed: 1 day, 1 hour, 8 minutes, 21 seconds...
'  ReturnTimeElapsedRTF - GIVEN A START AND END TIME, RETURNS AN RTF-FORMATTED STRING DESCRIBING THE TIME ELAPSED.
'           Analysis Began: Wednesday, July 26, 2006;  4:39:01 PM
'           Analysis Complete: Wednesday, July 27, 2006;  5:47:22 PM
'           Time Elapsed: 1 day, 1 hour, 8 minutes, 21 seconds...
'  ReturnTitleCase - GIEN A STRING, RETURNS A STRING WITH ALL WORDS UPPERCASE AT FIRST LETTER, LOWERCASE ALL OTHER LETTERS
'  ReturnQuerySpecialCharacters - GIVEN A DATASET AND PLACEHOLDERS, RETURNS SPECIAL DATABASE CHARACTERS
'  SetFeatureSymbols2 - given a layer and a path to a layer file, will apply symbology from layer file to current layer
'  SearchForTextInFolder_and_MakeReport - GIVEN A FOLDER, FILE EXTENSION AND SEARCH TEXT, WILL RETURN A LIST OF ALL FILES IN ALL SUBFOLDERS
'           WITHIN THAT FOLDER THAT CONTAIN THAT TEXT.
'  TrimZerosAndDecimas - GIVEN A NUMERIC VARIANT, RETURNS STRING WILL ALL TRAILING ZEROS AND DECIMALS TRIMMED OFF.  OPTIONAL TO ADD COMMAS
'  TrueLayerCount - GIVEN AN IMAP, RETURNS TRUE LAYER COUNT INCLUDING GROUP LAYERS

Public Declare Function CopyFile Lib "Kernel32" Alias "CopyFileA" _
  (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, _
  ByVal bFailIfExists As Long) As Long
  

Public Declare Sub Sleep Lib "Kernel32" (ByVal dwMilliseconds As Long)

Private Declare Function ShellExecute Lib "shell32.dll" Alias _
           "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, _
           ByVal lpFile As String, ByVal lpParameters As String, _
           ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal _
  hWndInsertAfter As Long, ByVal X As Long, ByVal Y As _
  Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags _
  As Long) As Long

Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
  (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_HWNDPARENT = (-8)
Private Const INVALID_HANDLE_VALUE As Long = -1
Private Const MAX_PATH As Long = 260

Declare Function GetDesktopWindow Lib "user32.dll" () As Long
Public Declare Function GetTickCount Lib "Kernel32" () As Long

Private Type SECURITY_ATTRIBUTES
   nLength As Long
   lpSecurityDescriptor As Long
   bInheritHandle As Long
End Type

Private Declare Function CreateDirectory Lib "Kernel32" _
   Alias "CreateDirectoryA" _
  (ByVal lpPathName As String, _
   lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
   
Public Enum JenFieldTypes
  ENUM_FieldString = 1
  ENUM_FieldNumber = 2
  ENUM_FieldDate = 4
  ENUM_FieldOID = 8
  ENUM_FieldGeometry = 16
  ENUM_FieldBlob = 32
  ENUM_FieldRaster = 64
  ENUM_FieldGUID = 128
  ENUM_FieldGlobalID = 256
  ENUM_FieldXML = 512
End Enum

Public Enum JenLayerTypes
  ENUM_jenFeatureLayers = 1
  ENUM_jenRasterLayers = 2
  ENUM_jenStandaloneTables = 4
  ENUM_jenPointLayers = 8
  ENUM_jenPolylineLayers = 16
  ENUM_jenPolygonLayers = 32
  ENUM_jenMultipointLayers = 64
  ENUM_jenTinLayers = 128
  ENUM_jenRastCatalogLayers = 256
End Enum

Public Enum JenDatasetTypes
  ENUM_Shapefile = 1
  ENUM_FileGDB = 2
  ENUM_PersonalGDB = 4
  ENUM_Coverage = 8
  ENUM_SDC_FeatureClass = 16
  ENUM_File_Raster = 32
End Enum

Public Enum JenBulletTypes
  ENUM_Letter_Lowercase = 1
  ENUM_Letter_Uppercase = 2
  ENUM_RomanNumeral_Lowercase = 4
  ENUM_RomanNumeral_Uppercase = 8
End Enum

Public Enum Jen_ElementEnvPoint
  ENUM_Upper_Left = 1
  ENUM_Upper_Right = 2
  ENUM_Lower_Left = 3
  ENUM_Lower_Right = 4
  ENUM_Upper_Center = 5
  ENUM_Lower_Center = 6
  ENUM_Center_Left = 7
  ENUM_Center_Right = 8
  ENUM_Center_Center = 9
  ENUM_By_Percentages = 10
End Enum

Public Enum Jen_AlignColorDialogOption
  ENUM_AlignBeneathRectangle = 1
  ENUM_AlignToRightOfRectangle = 2
End Enum

Const dblPi As Double = 3.14159265358979
Const c_sModuleFileName As String = "...MyGeneralOperations.bas"

Public Sub BasicStatsFromArraySimpleFast(dblSortedArray() As Double, _
    Optional booCalculateVariance As Boolean = False, _
    Optional theSum As Double, Optional theCount As Long, Optional theMinimum As Double, _
    Optional theMaximum As Double, Optional theMean As Double, Optional theMedian As Double, _
    Optional theVariance As Double, Optional theStDev As Double, Optional theStErrMean As Double, _
    Optional theRange As Double)
  On Error GoTo ErrorHandler

  
  ' ASSUMES ARRAY IS SORTED!!!! --------------------------------------
  
'  Dim pResponse As esriSystem.IDoubleArray
'  Set pResponse = New esriSystem.DoubleArray
  
  Dim anIndex As Long
  Dim theVal As Double
  
273:   theSum = 0
274:   theCount = UBound(dblSortedArray) + 1         ' ARRAY INDEX STARTS AT 0
275:   theMinimum = dblSortedArray(0)
276:   theMaximum = dblSortedArray(0)
  
  '  PASS 1:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
279:   For anIndex = LBound(dblSortedArray) To UBound(dblSortedArray)
    
281:     theVal = dblSortedArray(anIndex)
    
283:     If theVal < theMinimum Then
284:       theMinimum = theVal
285:     End If
286:     If theVal > theMaximum Then
287:       theMaximum = theVal
288:     End If
289:     theSum = theSum + theVal
    
291:   Next anIndex
  
293:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
299:   If booCalculateVariance Then
300:     For anIndex = LBound(dblSortedArray) To UBound(dblSortedArray)
                
302:       theVal = dblSortedArray(anIndex)
303:       theSqDev = (theVal - theMean) * (theVal - theMean)
304:       theSumSqDev = theSqDev + theSumSqDev
      
306:     Next anIndex
307:   Else
308:     theSqDev = 0
309:     theSumSqDev = 0
310:   End If
    
312:   If theCount > 1 Then
313:     If theCount Mod 2 = 0 Then      ' EVEN NUMBER
314:       theMedian = (dblSortedArray((theCount / 2) - 1) + dblSortedArray(theCount / 2)) / 2
315:     Else
316:       theMedian = dblSortedArray((theCount - 1) / 2)
317:     End If
    
319:     theVariance = theSumSqDev / (theCount - 1)
320:     theStDev = Sqr(theVariance)
321:     theStErrMean = theStDev / (Sqr(theCount))
    
323:   Else
324:     If theCount = 1 Then
325:       theMedian = dblSortedArray(0)
326:     Else
327:       theMedian = -9999
328:     End If
329:     theVariance = 0
330:     theStDev = 0
331:     theStErrMean = 0
332:   End If

334:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  
'  pResponse.Add theSum
'  pResponse.Add theMean
'  pResponse.Add theMinimum
'  pResponse.Add theMaximum
'  pResponse.Add theRange
'  pResponse.Add theCount
'  pResponse.Add theStDev
'  pResponse.Add theVariance
'  pResponse.Add theMedian
'  pResponse.Add theStErrMean
'
'  Set BasicStatsFromArraySimple = pResponse


  Exit Sub
ErrorHandler:
  HandleError True, "BasicStatsFromArraySimpleFast " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub BasicStatsFromArraySimpleFast2(dblSortedArray() As Double, _
    Optional booCalculateVariance As Boolean = False, _
    Optional theSum As Double, Optional lngCount As Long, Optional theMinimum As Double, _
    Optional theMaximum As Double, Optional theMean As Double, Optional theMedian As Double, _
    Optional theVariance As Double, Optional theStDev As Double, Optional theStErrMean As Double, _
    Optional theRange As Double, Optional booNeedToSort As Boolean = True, _
    Optional booCalculatePercentiles As Boolean = False, _
    Optional dblPercentileLevelsToCalculate As Variant, Optional dblPercentiles As Variant)
  On Error GoTo ErrorHandler

  
  ' NO LONGER ASSUMES ARRAY IS SORTED!!!! --------------------------------------
378:   If booNeedToSort Then QuickSort.DoubleAscending dblSortedArray, 0, UBound(dblSortedArray)
  
'  Dim pResponse As esriSystem.IDoubleArray
'  Set pResponse = New esriSystem.DoubleArray
  
  Dim anIndex As Long
  Dim theVal As Double
  
386:   theSum = 0
387:   lngCount = UBound(dblSortedArray) + 1         ' ARRAY INDEX STARTS AT 0
388:   theMinimum = dblSortedArray(0)
389:   theMaximum = dblSortedArray(0)
  
  '  PASS 1:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
392:   For anIndex = LBound(dblSortedArray) To UBound(dblSortedArray)
    
394:     theVal = dblSortedArray(anIndex)
    
396:     If theVal < theMinimum Then
397:       theMinimum = theVal
398:     End If
399:     If theVal > theMaximum Then
400:       theMaximum = theVal
401:     End If
402:     theSum = theSum + theVal
    
404:   Next anIndex
  
406:   theMean = theSum / lngCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
412:   If booCalculateVariance Then
413:     For anIndex = LBound(dblSortedArray) To UBound(dblSortedArray)
                
415:       theVal = dblSortedArray(anIndex)
416:       theSqDev = (theVal - theMean) * (theVal - theMean)
417:       theSumSqDev = theSqDev + theSumSqDev
      
419:     Next anIndex
420:   Else
421:     theSqDev = 0
422:     theSumSqDev = 0
423:   End If
  
  Dim dblM As Double
  Dim dblP As Double
  ' R: QUANTILE TYPE 7
428:   dblM = 1 - dblP
  ' R: QUANTILE TYPE 8
430:   dblM = (dblP + 1) / 3
  Dim dblG As Double
  
  Dim lngType As Long
434:   lngType = 8
  
  ' PERCENTILE ALGORITHM ADAPTED FROM http://en.wikipedia.org/wiki/Percentile
  Dim dblPercentileLevels() As Double
  Dim dblReturnPercentiles() As Double
  Dim lngPercIndex As Long
  Dim dblValIndex As Double
  Dim lngFloor As Long
  Dim lngCeiling As Long
  Dim dblFloorVal As Double
  Dim dblFloorPercentile As Double
  Dim dblCeilingVal As Double
  Dim dblCeilingPercentile As Double
  
  Dim dblPercentile As Double
449:   If booCalculatePercentiles Then
450:     dblPercentileLevels = dblPercentileLevelsToCalculate
    ReDim dblReturnPercentiles(UBound(dblPercentileLevels))
452:   End If
    
454:   If lngCount > 1 Then
455:     If lngCount Mod 2 = 0 Then      ' EVEN NUMBER
456:       theMedian = (dblSortedArray((lngCount / 2) - 1) + dblSortedArray(lngCount / 2)) / 2
457:     Else
458:       theMedian = dblSortedArray((lngCount - 1) / 2)
459:     End If
    
    ' PERCENTILES
462:     If booCalculatePercentiles Then
463:       For lngPercIndex = 0 To UBound(dblPercentileLevelsToCalculate)
464:         dblPercentile = dblPercentileLevelsToCalculate(lngPercIndex)
        
466:         If lngType = 5 Then
467:           dblM = 0.5
468:         ElseIf lngType = 7 Then
469:           dblM = 1 - dblPercentile
470:         ElseIf lngType = 8 Then
471:           dblM = (dblPercentile + 1) / 3
472:         End If
        
474:         dblValIndex = (CDbl(lngCount) * dblPercentile) + dblM
475:         lngFloor = Int(dblValIndex)
476:         dblG = dblValIndex - CDbl(lngFloor)
477:         If dblG = 0 Then
478:           dblReturnPercentiles(lngPercIndex) = dblSortedArray(lngFloor - 1)
479:         Else
480:           lngCeiling = lngFloor + 1
481:           dblFloorVal = dblSortedArray(lngFloor - 1)
482:           dblCeilingVal = dblSortedArray(lngCeiling - 1)
          
484:           If lngType = 5 Then
485:             dblFloorPercentile = (lngFloor - 0.5) / lngCount
486:             dblCeilingPercentile = (lngCeiling - 0.5) / lngCount
487:           ElseIf lngType = 7 Then
488:             dblFloorPercentile = (lngFloor - 1) / (lngCount - 1)
489:             dblCeilingPercentile = (lngCeiling - 1) / (lngCount - 1)
490:           ElseIf lngType = 8 Then
491:             dblFloorPercentile = (lngFloor - (1 / 3)) / (lngCount + (1 / 3))
492:             dblCeilingPercentile = (lngCeiling - (1 / 3)) / (lngCount + (1 / 3))
493:           End If
          
'          dblReturnPercentiles(lngPercIndex) = dblFloorVal + (lngCount * (dblPercentile - dblFloorPercentile) * _
              (dblCeilingVal - dblFloorVal))
          ' INTERPOLATION = Beginning Value + ((Range between values) * (percentage between values))
'          dblReturnPercentiles(lngPercIndex) = dblFloorVal + (lngCount * (dblPercentile - dblFloorPercentile) * _
              (dblCeilingVal - dblFloorVal))
500:           dblReturnPercentiles(lngPercIndex) = dblFloorVal + _
              (((dblPercentile - dblFloorPercentile) / (dblCeilingPercentile - dblFloorPercentile)) * _
              (dblCeilingVal - dblFloorVal))
              
504:         End If
505:       Next lngPercIndex
506:       dblPercentiles = dblReturnPercentiles
507:     End If
    
509:     theVariance = theSumSqDev / (lngCount - 1)
510:     theStDev = Sqr(theVariance)
511:     theStErrMean = theStDev / (Sqr(lngCount))
    
513:   Else
514:     If lngCount = 1 Then
'      dblQuartile1 = dblSortedArray(0)
516:       theMedian = dblSortedArray(0)
'      dblQuartile3 = dblSortedArray(0)
518:       If booCalculatePercentiles Then
519:         For lngPercIndex = 0 To UBound(dblPercentileLevelsToCalculate)
520:           dblReturnPercentiles(lngPercIndex) = dblSortedArray(0)
521:         Next lngPercIndex
522:         dblPercentiles = dblReturnPercentiles
523:       End If
524:     Else
'      dblQuartile1 = -9999
526:       theMedian = -9999
'      dblQuartile3 = -9999
528:       If booCalculatePercentiles Then
529:         For lngPercIndex = 0 To UBound(dblPercentileLevelsToCalculate)
530:           dblReturnPercentiles(lngPercIndex) = -9999
531:         Next lngPercIndex
532:         dblPercentiles = dblReturnPercentiles
533:       End If
534:     End If
535:     theVariance = 0
536:     theStDev = 0
537:     theStErrMean = 0
538:   End If

540:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  
'  pResponse.Add theSum
'  pResponse.Add theMean
'  pResponse.Add theMinimum
'  pResponse.Add theMaximum
'  pResponse.Add theRange
'  pResponse.Add lngCount
'  pResponse.Add theStDev
'  pResponse.Add theVariance
'  pResponse.Add theMedian
'  pResponse.Add theStErrMean
'
'  Set BasicStatsFromArraySimple = pResponse


  Exit Sub
ErrorHandler:
  HandleError True, "BasicStatsFromArraySimpleFast2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Function TrimZerosAndDecimals(varNumber As Variant, Optional booAddCommas As Boolean = True, _
    Optional lngMaxNumDecimals As Long = 15) As String
  On Error GoTo ErrorHandler


  Dim dblValue As Double
578:   dblValue = CDbl(varNumber)
  Dim strValue As String
  Dim strZeros As String
581:   strZeros = String(lngMaxNumDecimals, "0")
  
583:   If booAddCommas Then
584:     strValue = CStr(Format(dblValue, "#,##0." & strZeros))
585:   Else
586:     strValue = CStr(Format(dblValue, "0." & strZeros))
587:   End If
  
589:   Do Until Right(strValue, 1) <> "0" Or Len(strValue) = 0
590:     strValue = Left(strValue, Len(strValue) - 1)
591:   Loop
  
593:   Do Until Right(strValue, 1) <> "." Or Len(strValue) = 0
594:     strValue = Left(strValue, Len(strValue) - 1)
595:   Loop
  
597:   If strValue = "" Then
598:     strValue = "0"
599:   End If
  
601:   TrimZerosAndDecimals = strValue


  Exit Function
ErrorHandler:
  HandleError True, "TrimZerosAndDecimals " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function MakeFieldNameVarArray(pOrigFClass As IFeatureClass, pNewFClass As IFeatureClass, _
      pFieldArray As esriSystem.IVariantArray, booFieldArrayContainsNamePairs As Boolean) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

      
  ' MAKE IVariantArray OF FIELD NAME INDICES
  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
  '                     1) ORIGINAL FCLASS FIELD INDEX
  '                     2) NEW FCLASS FIELD NAME
  '                     3) NEW FCLASS FIELD INDEX
  
  Dim lngIndex As Long
  Dim pField As IField
  Dim strOrigName As String
  Dim strNewName As String
  Dim pNamePair As esriSystem.IStringArray
  Dim pFieldData As esriSystem.IVariantArray
628:   Set MakeFieldNameVarArray = New VarArray
  
630:   For lngIndex = 0 To pFieldArray.Count - 1
631:     If booFieldArrayContainsNamePairs Then
632:       Set pNamePair = pFieldArray.Element(lngIndex)
633:       strOrigName = pNamePair.Element(0)
634:       strNewName = pNamePair.Element(1)
635:     Else
636:       Set pField = pFieldArray.Element(lngIndex)
637:       strOrigName = pField.Name
638:       strNewName = pField.Name
639:     End If
640:     Set pFieldData = New esriSystem.VarArray
641:     pFieldData.Add strOrigName
642:     pFieldData.Add pOrigFClass.FindField(strOrigName)
643:     pFieldData.Add strNewName
644:     pFieldData.Add pNewFClass.FindField(strNewName)
645:     MakeFieldNameVarArray.Add pFieldData
646:   Next lngIndex
      

  Exit Function
ErrorHandler:
  HandleError True, "MakeFieldNameVarArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub MakeRandomNormal(dblMean As Double, dblSD As Double, ByVal dblRand1 As Double, Optional ByVal dblRand2 As Double = -999)
  On Error GoTo ErrorHandler


658:   Static dblSeed
' Based on the Box-Muller Transformation:.
'          y1 = sqrt( - 2 ln(x1) ) cos( 2 pi x2 )
'          y2 = sqrt( - 2 ln(x1) ) sin( 2 pi x2 )
'        where:
'          x1 = first uniform random number (between 0 and 1)
'          x2 = second uniform random number (between 0 and 1)
'          y1 = first normally distributed random number
'          y2 = second normally distributed random number.
667:   If dblSeed = 0 Then
668:     Randomize            ' USE SYSTEM TIMER
669:   Else
670:     Randomize dblSeed
671:   End If
  Dim dblX1 As Double
  Dim dblX2 As Double
674:   dblX1 = Rnd
675:   dblX2 = Rnd
  
677:   dblRand1 = (Sqr(-2 * Log(dblX1)) * Cos(2 * dblPi * dblX2) * dblSD#) + dblMean#
678:   dblRand2 = (Sqr(-2 * Log(dblX1)) * Sin(2 * dblPi * dblX2) * dblSD#) + dblMean#
  
680:   dblSeed = dblRand2
  

  Exit Sub
ErrorHandler:
  HandleError True, "MakeRandomNormal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function ReturnHistStatsFromDouble(pDouble As esriSystem.IDoubleArray, _
            Optional pCounts As esriSystem.IDoubleArray, _
            Optional booVariance As Boolean = False, _
            Optional booIsSample As Boolean = False, _
            Optional booReturnSortedArray As Boolean = False, _
            Optional strName As String = "Statistics") As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

    
  Dim dblVals() As Double
  Dim lngIndex As Long
  Dim lngCount As Long
  Dim dblWeight As Double
  
  Dim booHasWeight As Boolean
703:   booHasWeight = Not pCounts Is Nothing
  
705:   lngCount = pDouble.Count - 1
  ReDim dblVals(lngCount)
  
708:   If booHasWeight Then
    Dim dblWeightArray() As Double
    ReDim dblWeightArray(lngCount)
711:     For lngIndex = 0 To lngCount
712:       dblVals(lngIndex) = pDouble.Element(lngIndex)
713:       dblWeightArray(lngIndex) = pCounts.Element(lngIndex)
714:     Next lngIndex
    
    ' SORT VALUES
717:     QuickSort.DoubleAscendingWithSizes dblVals, dblWeightArray, 0, lngCount
718:   Else
719:     dblWeight = 1
720:     For lngIndex = 0 To lngCount
721:       dblVals(lngIndex) = pDouble.Element(lngIndex)
722:     Next lngIndex
    
    ' SORT VALUES
725:     QuickSort.DoubleAscending dblVals, 0, lngCount
726:   End If
    
  ' ASSUMES ARRAY IS SORTED!!!! --------------------------------------
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  Dim theMean As Double
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  Dim theMedian As Double
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  Dim theRange As Double
  Dim dblSumSquaredWeights As Double
  Dim dblCheckVal As Double
  Dim dblHalfCount As Double         ' FOR MEDIAN WHEN USING WEIGHTED VALUES
  Dim booFoundMedian As Boolean      ' FOR MEDIAN WHEN USING WEIGHTED VALUES
  Dim dblRunningCountTotal As Double ' FOR MEDIAN WHEN USING WEIGHTED VALUES
  
747:   booFoundMedian = False
  
  ' MAKE ARRAYS TO RETURN
  Dim pReturnArray As esriSystem.IDoubleArray
  Dim pCountArray As esriSystem.IDoubleArray  ' "Counts" might be <1 nor non-integer if they are feature lengths or areas
  Dim pResponse As esriSystem.IDoubleArray
  
754:   Set pReturnArray = New esriSystem.DoubleArray
755:   Set pCountArray = New esriSystem.DoubleArray
756:   Set pResponse = New esriSystem.DoubleArray
  
  Dim dblCounter As Long
  Dim dblTestVal As Double
  
761:   If lngCount = 0 Then
  
763:     pResponse.Add -999
764:     pResponse.Add -999
765:     pResponse.Add -999
766:     pResponse.Add -999
767:     pResponse.Add -999
768:     pResponse.Add -999
769:     pResponse.Add -999
770:     pResponse.Add -999
771:     pResponse.Add -999
772:     pResponse.Add -999
773:     pResponse.Add -999   ' FOR dblTrueCount
  
775:   Else
  
777:     dblTestVal = dblVals(0)
778:     If booHasWeight Then
779:       dblCounter = dblWeightArray(0)
780:     Else
781:       dblCounter = 1
782:     End If
783:     theMinimum = dblVals(0)
784:     theMaximum = dblVals(UBound(dblVals))
785:     theRange = theMaximum - theMinimum
786:     theSum = dblTestVal
787:     theCount = dblCounter
788:     dblSumSquaredWeights = dblCounter ^ 2
'     theCount = lngCount + 1         ' ARRAY INDEX STARTS AT 0
    
791:     If lngCount > 1 Then
    
      '  PASS 1:  MINIMUM, MAXIMUM HISTOGRAM ARRAYS AND SUM --------------------------------------------------
794:       For lngIndex = 1 To lngCount
795:         dblCheckVal = dblVals(lngIndex)
796:         If booHasWeight Then
797:           dblWeight = dblWeightArray(lngIndex)  ' OTHERWISE WEIGHT DEFAULTS TO 1
798:           dblSumSquaredWeights = dblSumSquaredWeights + (dblWeight ^ 2)
799:         End If
          
        ' BUILD HISTOGRAM ARRAYS
802:         If dblTestVal = dblCheckVal Then
803:           dblCounter = dblCounter + dblWeight
804:         Else
805:           pReturnArray.Add dblTestVal
806:           pCountArray.Add dblCounter
807:           dblTestVal = dblCheckVal
808:           dblCounter = dblWeight
809:         End If
        
        ' GENERAL STATS
812:         theSum = theSum + (dblCheckVal * dblWeight)
813:         theCount = theCount + dblWeight
814:       Next lngIndex
      
      ' FOR HISTOGRAM ARRAYS, ADD LAST VALUE
817:       pReturnArray.Add dblTestVal
818:       pCountArray.Add dblCounter
      
      ' FOR GENERAL STATS
821:       theMean = theSum / theCount
822:       dblHalfCount = theCount / 2
823:       dblRunningCountTotal = 0
      
      '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
826:       If booVariance Then
827:         For lngIndex = 0 To lngCount
                    
829:           dblCheckVal = dblVals(lngIndex)
          
831:           If booHasWeight Then
832:             dblWeight = dblWeightArray(lngIndex)
833:             theSqDev = dblWeight * ((dblCheckVal - theMean) ^ 2)
834:             If Not booFoundMedian Then
835:               dblRunningCountTotal = dblRunningCountTotal + dblWeight
836:               If dblRunningCountTotal >= dblHalfCount Then
837:                 booFoundMedian = True
838:                 theMedian = dblCheckVal
839:               End If
840:             End If
841:           Else
842:             theSqDev = (dblCheckVal - theMean) ^ 2
843:           End If
          
845:           theSumSqDev = theSqDev + theSumSqDev
846:         Next lngIndex
847:       Else
848:         theSqDev = 0
849:         theSumSqDev = 0
850:       End If
      
852:       If booHasWeight Then
        ' THEN MEDIAN IS CALCULATED UP IN PASS 2
854:       Else
855:         If theCount Mod 2 = 0 Then      ' EVEN NUMBER
856:           theMedian = (dblVals((theCount / 2) - 1) + dblVals(theCount / 2)) / 2
857:         Else
858:           theMedian = dblVals((theCount - 1) / 2)
859:         End If
860:       End If
      
862:       If booHasWeight Then
863:         If booIsSample Then
          ' FROM http://en.wikipedia.org/wiki/Weighted_standard_deviation#Weighted_sample_variance
          ' FROM http://pygsl.sourceforge.net/reference/pygsl/node36.html
866:           theVariance = (theCount / ((theCount ^ 2) - dblSumSquaredWeights)) * theSumSqDev
867:         Else
          ' FROM http://en.wikipedia.org/wiki/Weighted_standard_deviation#Weighted_sample_variance
869:           theVariance = theSumSqDev / theCount
870:         End If
871:       Else
872:         If booIsSample Then
873:           theVariance = theSumSqDev / (theCount - 1)
874:         Else
875:           theVariance = theSumSqDev / theCount
876:         End If
877:       End If
      
879:       theStDev = Sqr(theVariance)
880:       theStErrMean = theStDev / (Sqr(theCount))
      
882:     Else
883:       pReturnArray.Add dblTestVal
884:       pCountArray.Add 1
      
886:       theMean = dblTestVal
887:       theMedian = dblTestVal
888:       theVariance = 0
889:       theStDev = 0
890:       theStErrMean = 0
      
892:     End If
      
894:     pResponse.Add theSum
895:     pResponse.Add theMean
896:     pResponse.Add theMinimum
897:     pResponse.Add theMaximum
898:     pResponse.Add theRange
899:     pResponse.Add theCount
900:     pResponse.Add theStDev
901:     pResponse.Add theVariance
902:     pResponse.Add theMedian
903:     pResponse.Add theStErrMean
    
905:   End If
  
907:   Set ReturnHistStatsFromDouble = New esriSystem.VarArray
908:   ReturnHistStatsFromDouble.Add pReturnArray
909:   ReturnHistStatsFromDouble.Add pCountArray
910:   ReturnHistStatsFromDouble.Add pResponse
911:   If booReturnSortedArray Then
912:     ReturnHistStatsFromDouble.Add dblVals
913:   Else
914:     ReturnHistStatsFromDouble.Add -999
915:   End If
916:   ReturnHistStatsFromDouble.Add strName
  

  Exit Function
ErrorHandler:
  HandleError True, "ReturnHistStatsFromDouble " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function ReplaceBadChars(strName As String, Optional booReplacePeriod As Boolean = False, _
    Optional booReplaceBackSlash As Boolean = False, Optional booReplaceSpace As Boolean = True, _
    Optional booStartWithLetter As Boolean = False) As String
  On Error GoTo ErrorHandler

928:   If strName = "" Then
929:     ReplaceBadChars = "z"
930:   Else
    Dim strAcceptable As String
932:     strAcceptable = "abcdefghijklmnopqrstuvwxyz0123456789_"
933:     If Not booReplacePeriod Then strAcceptable = strAcceptable & "."
934:     If Not booReplaceBackSlash Then strAcceptable = strAcceptable & "\"
935:     If Not booReplaceSpace Then strAcceptable = strAcceptable & " "
    
    Dim strOutput As String
938:     strOutput = strName
    Dim lngIndex As Long
    Dim strChar As String
941:     For lngIndex = 1 To Len(strOutput)
942:       strChar = Mid(strOutput, lngIndex, 1)
943:       If InStr(1, strAcceptable, strChar, vbTextCompare) = 0 Then
944:         strOutput = Replace(strOutput, strChar, "_")
945:       End If
946:     Next lngIndex
947:     If booStartWithLetter Then
      Dim strLetters As String
949:       strLetters = "abcdefghijklmnopqrstuvwxyz"
950:       If InStr(1, strLetters, Left(strOutput, 1), vbTextCompare) = 0 Then
951:         strOutput = "z" & strOutput
952:       End If
953:     End If
954:     ReplaceBadChars = strOutput
955:   End If


  Exit Function
ErrorHandler:
  HandleError True, "ReplaceBadChars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateGeneralTable(Optional strDir As String = "", Optional strName As String = "", _
    Optional lngCategory As JenDatasetTypes = ENUM_Shapefile, Optional pAddFields As esriSystem.IVariantArray, _
    Optional strGxDialogCaption As String = "Specify New Table Name:") As ITable
  On Error GoTo ErrorHandler

  ' IF booIsFClass = FALSE, THEN THIS FUNCTION WILL CREATE A TABLE INSTEAD
  
  ' THIS FUNCTION ONLY ALLOWS YOU TO WRITE TO A FEATURE DATASET IF IT FORCES USER TO SELECT FEATURE DATASET WITH IGxCatalog.
  ' IF YOU SEND A SPECIFIC PATHNAME AND FILENAME, THIS FUNCTION WILL NOT ALLOW YOU TO SAVE TO A FEATURE DATASET.
  
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureClassName As IFeatureClassName
  Dim pFeatureDatasetName As IName
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDataset As String
  Dim strPath As String
  Dim strCategory As String
  Dim strParent As String
  Dim strBaseName As String
  Dim pFeatWS As IFeatureWorkspace
  Dim pWsFact As IWorkspaceFactory2
  Dim pTableName As String
  Dim pTable As ITable
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxDialog As IGxDialog
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection

  ' CHECK IF TABLE ALREADY EXISTS
  Dim booAlreadyExists As Boolean
997:   booAlreadyExists = True
  Dim lngResponse As VbMsgBoxResult
  
1000:   Do Until booAlreadyExists = False
     
    ' FIRST, CHECK IF DIRECTORY, NAME AND CATEGORY ARE SPECIFIED
1003:     If strDir <> "" And strName <> "" Then
      
      Select Case lngCategory
        Case ENUM_Shapefile
1007:           strCategory = "Shapefile"
1008:           strName = aml_func_mod.SetExtension(strName, "dbf")
1009:           If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
        Case ENUM_FileGDB
1011:           strCategory = "File Geodatabase Feature Class"
        Case ENUM_PersonalGDB
1013:           strCategory = "Personal Geodatabase Feature Class"
        Case Else
1015:           MsgBox "PROBLEM:  This function can only create dBASE Tables, File GeoDatabase Tables, " & vbCrLf & _
              " or Personal GeoDatabase Tables.  Bailing out...", vbOKOnly, "Invalid Output Type:"
1017:           Set CreateGeneralTable = Nothing
          Exit Function
1019:       End Select
      
1021:       strWsPathname = strDir
1022:       booHasFeatureDataset = False
1023:       strBaseName = strName
1024:       booHasFeatureDataset = False
1025:       strFeatDataset = ""
1026:     Else
    
 '     If pGxObj Is Nothing Or IsMissing(pGxObj) Then  ' IF NEED TO ASK USER TO SPECIFY GxObject
      
1030:       Set pGxDialog = New GxDialog
1031:       Set pGxFCFilter = New GxFilterTables
      
1033:       Set pFilterCol = pGxDialog
1034:       pFilterCol.AddFilter pGxFCFilter, True
1035:       pGxDialog.Title = strGxDialogCaption
1036:       pGxDialog.AllowMultiSelect = False
1037:       pGxDialog.ButtonCaption = "Enter"
        
1039:       If Not pGxDialog.DoModalSave(0) Then
1040:           Set CreateGeneralTable = Nothing
          Exit Function 'Exit if user press Cancel
1042:       End If
      
1044:       Set pGxObj = pGxDialog.FinalLocation
1045:       strWsPathname = pGxObj.FullName
1046:       strBaseName = pGxDialog.Name
    
 '     End If
  
  '    Dim pGxCat As IGxCatalog
  '    Set pGxCat = pGxDialog.InternalCatalog
  
      ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
1054:       If TypeOf pGxObj Is IGxDataset Then
1055:         Set pGxDataset = pGxObj
          
1057:         Set pDataset = pGxDataset.Dataset
1058:         Set pWorkspace = pDataset.Workspace
1059:         strWsPathname = pWorkspace.PathName
      
1061:         Set pFeatureDatasetName = pDataset.FullName
        
1063:         booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
1064:         If booHasFeatureDataset Then
1065:           Set pGxObj = pGxObj.Parent  ' BACK OUT IF FEATURE DATASET IF WE ARE IN ONE
1066:         End If
1067:       End If
      
1069:       strCategory = pGxObj.Category
1070:     End If
    
    ' NOW WE KNOW NAME, CATEGORY AND WORKSPACE.  NEXT CREATE WORKSPACE FACTORY
    Select Case strCategory
       Case "Shapefile", "Folder", "dBASE Table"
1075:          Set pWsFact = New ShapefileWorkspaceFactory
1076:          pTableName = strBaseName
       Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"
1079:          Set pWsFact = New FileGDBWorkspaceFactory
1080:          pTableName = strBaseName
       Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"
1084:          Set pWsFact = New AccessWorkspaceFactory
1085:          pTableName = strBaseName
'       Case "Polygon Feature Class", "Arc Feature Class", "Point Feature Class", "Route Feature Class", _
'            "Tic Feature Class", "Region Feature Class", "Label Feature Class"
'         Set pWSFact = New ArcInfoWorkspaceFactory
'         If booHasFeatureDataset Then
'           pTableName = strFeatDataset & ":" & strBaseName
'         Else
'           pTableName = strBaseName
'         End If
'       Case "SDC Feature Class"
'         Set pWSFact = New SDCWorkspaceFactory
'         If booHasFeatureDataset Then
'           pTableName = strFeatDataset & ":" & strBaseName
'         Else
'           pTableName = strBaseName
'         End If
       Case Else
1102:          MsgBox "Unexpected Workspace Type (" & strCategory & ")!  Need to write new code for this..."
1103:          Set CreateGeneralTable = Nothing
         Exit Function
1105:     End Select
    
  '  Debug.Print "Full Name = " & strPath & vbCrLf & "Name = " & strName & vbCrLf & _
        "Base Name = " & strBaseName & vbCrLf & "Category = " & strCategory & vbCrLf & "Parent = " & strParent & _
        vbCrLf & "Show String = " & strShowString & vbCrLf & "Save String = " & strSaveString & vbCrLf & _
        "Workspace Pathname = " & pWorkspace.PathName
     
    ' FOR DEBUGGING
  '  Dim frmReportForm As EcoAir_Map.frmReportDialog
  '  Beep
  '  Set frmReportForm = New EcoAir_Map.frmReportDialog
  '  frmReportForm.txtReport.Text = strWsPathName & vbCrLf & strCategory & vbCrLf & pTableName
  '  frmReportForm.Show vbModal
  '  Set frmReportForm = Nothing
  '  MsgBox strWsPathname & vbCrLf & strCategory & vbCrLf & lngCategory
1120:     If Right(strWsPathname, 1) = "\" Or Right(strWsPathname, 1) = "/" Then
1121:       strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
1122:     End If
1123:     Set pFeatWS = pWsFact.OpenFromFile(strWsPathname, 0)
        
1125:     booAlreadyExists = CheckIfTableExists(pFeatWS, strBaseName)
1126:     If booAlreadyExists Then
1127:       lngResponse = MsgBox("The Table '" & pTableName & "' already exists!  Do you wish to overwrite it?", _
            vbYesNo, "Table Already Exists:")
1129:       If lngResponse = vbYes Then
        ' DELETE FEATURE CLASS
        Dim pDelete As ITable
        Dim pDelDataset As IDataset
1133:         Set pDelete = pFeatWS.OpenTable(strBaseName)
1134:         Set pDelDataset = pDelete
1135:         If pDelDataset.CanDelete Then
1136:           pDelDataset.DELETE
1137:         Else
1138:           MsgBox "Unable to delete " & pDataset.Name & "!  Bailing out..."
1139:           Set CreateGeneralTable = Nothing
          Exit Function
1141:         End If
1142:         booAlreadyExists = CheckIfTableExists(pFeatWS, strBaseName)
1143:       Else
1144:         Set CreateGeneralTable = Nothing
1145:         Set pGxObj = Nothing
1146:         strName = ""
1147:       End If
1148:     End If
1149:   Loop
  
  ' NOW READY TO CREATE TABLE
1152:   If strCategory = "Shapefile" Or strCategory = "Folder" Or strCategory = "dBASE Table" Then      ' IF dBASE TABLE
1153:     Set pTable = CreatedBASETableInFolder(strWsPathname, strBaseName, pAddFields)
1154:   Else                                                                                            ' IF IN FILE OR PERSONAL GEODATABASE
1155:     Set pTable = CreateGDBTable(pFeatWS, strBaseName, pAddFields)
1156:   End If
  
1158:   Set CreateGeneralTable = pTable
  

  Exit Function
ErrorHandler:
  HandleError True, "CreateGeneralTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CreateGeneralFeatureClass(pGeomType As esriGeometryType, pSpatialReference As ISpatialReference, _
    Optional strDir As String = "", Optional strName As String = "", Optional lngCategory As JenDatasetTypes = ENUM_Shapefile, _
    Optional pAddFields As esriSystem.IVariantArray, Optional strGxDialogCaption As String = "Specify New Feature Class Name:", _
    Optional booIsInFeatureDataset As Boolean = False, Optional strFeatureDatasetName As String, _
    Optional booIsFClass As Boolean = True, Optional booForceUniqueIDField As Boolean = True, _
    Optional pExtent As IEnvelope, Optional lngOriginalRecCount As Long = -9999) As IFeatureClass
  On Error GoTo ErrorHandler

  ' IF booIsFClass = FALSE, THEN THIS FUNCTION WILL CREATE A TABLE INSTEAD
  
  ' THIS FUNCTION ONLY ALLOWS YOU TO WRITE TO A FEATURE DATASET IF IT FORCES USER TO SELECT FEATURE DATASET WITH IGxCatalog.
  ' IF YOU SEND A SPECIFIC PATHNAME AND FILENAME, THIS FUNCTION WILL NOT ALLOW YOU TO SAVE TO A FEATURE DATASET.
  
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureClassName As IFeatureClassName
  Dim pFeatureDatasetName As IName
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDataset As String
  Dim strPath As String
  Dim strCategory As String
  Dim strParent As String
  Dim strBaseName As String
  Dim pFeatWS As IFeatureWorkspace
  Dim pWsFact As IWorkspaceFactory2
  Dim pFClassName As String
  Dim pFClass As IFeatureClass
  Dim strWsPathname As String
  Dim pGxObj As IGxObject
  Dim pGxDialog As IGxDialog
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection

  ' CHECK IF FEATURECLASS ALREADY EXISTS
  Dim booAlreadyExists As Boolean
1204:   booAlreadyExists = True
  Dim lngResponse As VbMsgBoxResult
  
1207:   Do Until booAlreadyExists = False
     
    ' FIRST, CHECK IF DIRECTORY, NAME AND CATEGORY ARE SPECIFIED
1210:     If strDir <> "" And strName <> "" Then
      
      Select Case lngCategory
        Case ENUM_Shapefile
1214:           strCategory = "Shapefile"
1215:           strName = aml_func_mod.SetExtension(strName, "shp")
1216:           If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
        Case ENUM_FileGDB
1218:           strCategory = "File Geodatabase Feature Class"
        Case ENUM_PersonalGDB
1220:           strCategory = "Personal Geodatabase Feature Class"
        Case Else
1222:           MsgBox "PROBLEM:  This function can only create shapefiles, file geodatabase feature classes, or " & vbCrLf & _
              "personal geodatabase feature classes.  Bailing out...", vbOKOnly, "Invalid Output Type:"
1224:           Set CreateGeneralFeatureClass = Nothing
          Exit Function
1226:       End Select
      
1228:       strWsPathname = strDir
1229:       booHasFeatureDataset = False
1230:       strBaseName = strName
1231:       booHasFeatureDataset = booIsInFeatureDataset
1232:       strFeatDataset = strFeatureDatasetName
1233:     Else
    
 '     If pGxObj Is Nothing Or IsMissing(pGxObj) Then  ' IF NEED TO ASK USER TO SPECIFY GxObject
      
1237:       Set pGxDialog = New GxDialog
1238:       Set pGxFCFilter = New GxFilterFeatureClasses
      
1240:       Set pFilterCol = pGxDialog
1241:       pFilterCol.AddFilter pGxFCFilter, True
1242:       pGxDialog.Title = strGxDialogCaption
1243:       pGxDialog.AllowMultiSelect = False
1244:       pGxDialog.ButtonCaption = "Enter"
        
1246:       If Not pGxDialog.DoModalSave(0) Then
1247:           Set CreateGeneralFeatureClass = Nothing
          Exit Function 'Exit if user press Cancel
1249:       End If
      
1251:       Set pGxObj = pGxDialog.FinalLocation
1252:       strWsPathname = pGxObj.FullName
1253:       strBaseName = pGxDialog.Name
    
 '     End If
  
  '    Dim pGxCat As IGxCatalog
  '    Set pGxCat = pGxDialog.InternalCatalog
  
      ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
1261:       If TypeOf pGxObj Is IGxDataset Then
1262:         Set pGxDataset = pGxObj
          
1264:         Set pDataset = pGxDataset.Dataset
1265:         Set pWorkspace = pDataset.Workspace
1266:         strWsPathname = pWorkspace.PathName
      
''        Set pFeatureClassName = pDataset.FullName
1269:         Set pFeatureDatasetName = pDataset.FullName
        
1271:         booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
1272:         If booHasFeatureDataset Then
1273:           Set pFeatureDataset = pDataset
1274:           strFeatDataset = pFeatureDataset.Name
1275:         End If
1276:       End If
          
'      strPath = pGxObj.FullName
1279:       strCategory = pGxObj.Category
'      strName = pGxObj.Name
'      strParent = pGxObj.Parent.FullName
'      strBaseName = pGxObj.BaseName
'      strWsPathName = pWorkspace.PathName
1284:     End If
    
    ' NOW WE KNOW NAME, CATEGORY AND WORKSPACE.  NEXT CREATE WORKSPACE FACTORY
    Select Case strCategory
       Case "Shapefile", "Folder"
1289:          Set pWsFact = New ShapefileWorkspaceFactory
1290:          pFClassName = strBaseName
       Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", "File Geodatabase", "File Geodatabase Feature Dataset"
1292:          Set pWsFact = New FileGDBWorkspaceFactory
1293:          If booHasFeatureDataset Then
1294:            pFClassName = strFeatDataset & ":" & strBaseName
1295:          Else
1296:            pFClassName = strBaseName
1297:          End If
       Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", "Personal Geodatabase", "Personal Geodatabase Feature Dataset"
1299:          Set pWsFact = New AccessWorkspaceFactory
1300:          If booHasFeatureDataset Then
1301:            pFClassName = strFeatDataset & ":" & strBaseName
1302:          Else
1303:            pFClassName = strBaseName
1304:          End If
'       Case "Polygon Feature Class", "Arc Feature Class", "Point Feature Class", "Route Feature Class", _
'            "Tic Feature Class", "Region Feature Class", "Label Feature Class"
'         Set pWSFact = New ArcInfoWorkspaceFactory
'         If booHasFeatureDataset Then
'           pFClassName = strFeatDataset & ":" & strBaseName
'         Else
'           pFClassName = strBaseName
'         End If
'       Case "SDC Feature Class"
'         Set pWSFact = New SDCWorkspaceFactory
'         If booHasFeatureDataset Then
'           pFClassName = strFeatDataset & ":" & strBaseName
'         Else
'           pFClassName = strBaseName
'         End If
       Case Else
1321:          MsgBox "Unexpected Feature Class Type (" & strCategory & ")!  Need to write new code for this..."
1322:          Set CreateGeneralFeatureClass = Nothing
         Exit Function
1324:     End Select
    
  '  Debug.Print "Full Name = " & strPath & vbCrLf & "Name = " & strName & vbCrLf & _
        "Base Name = " & strBaseName & vbCrLf & "Category = " & strCategory & vbCrLf & "Parent = " & strParent & _
        vbCrLf & "Show String = " & strShowString & vbCrLf & "Save String = " & strSaveString & vbCrLf & _
        "Workspace Pathname = " & pWorkspace.PathName
     
    ' FOR DEBUGGING
  '  Dim frmReportForm As EcoAir_Map.frmReport_modal
  '  Beep
  '  Set frmReportForm = New EcoAir_Map.frmReport_modal
  '  frmReportForm.txtReport.Text = strWsPathName & vbCrLf & strCategory & vbCrLf & pFClassName
  '  frmReportForm.Show vbModal
  '  Set frmReportForm = Nothing
  '  MsgBox strWsPathname & vbCrLf & strCategory & vbCrLf & lngCategory
1339:     If Right(strWsPathname, 1) = "\" Or Right(strWsPathname, 1) = "/" Then
1340:       strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
1341:     End If
1342:     If Right(strWsPathname, 1) = "\" Or Right(strWsPathname, 1) = "/" Then
1343:       strWsPathname = Left(strWsPathname, Len(strWsPathname) - 1)
1344:     End If
1345:     Set pFeatWS = pWsFact.OpenFromFile(strWsPathname, 0)
    
    ' GET FEATURE DATASET IF IT EXISTS
1348:     If booHasFeatureDataset Then Set pFeatureDataset = pFeatWS.OpenFeatureDataset(strFeatDataset)
    
1350:     booAlreadyExists = CheckIfFeatureClassExists(pFeatWS, strBaseName)
1351:     If booAlreadyExists Then
1352:       lngResponse = MsgBox("The Feature Class '" & pFClassName & "' already exists!  Do you wish to overwrite it?", _
            vbYesNo, "Feature Class Already Exists:")
1354:       If lngResponse = vbYes Then
        ' DELETE FEATURE CLASS
        Dim pDelete As IFeatureClass
        Dim pDelDataset As IDataset
1358:         Set pDelete = pFeatWS.OpenFeatureClass(strBaseName)
1359:         Set pDelDataset = pDelete
1360:         pDelDataset.DELETE
1361:         booAlreadyExists = CheckIfFeatureClassExists(pFeatWS, strBaseName)
1362:       Else
1363:         Set CreateGeneralFeatureClass = Nothing
1364:         Set pGxObj = Nothing
1365:         strName = ""
1366:       End If
1367:     End If
1368:   Loop
  
  
  ' NOW READY TO CREATE FEATURE CLASS
1372:   If booHasFeatureDataset Then                                                     ' IF IN FEATURE DATASET
1373:     Set pFClass = CreateDatasetFeatureClass(pFeatureDataset, strBaseName, esriFTSimple, pGeomType, pAddFields)
1374:   ElseIf strCategory = "Shapefile" Or strCategory = "Folder" Then                  ' IF SHAPEFILE
1375:     Set pFClass = CreateShapefileFeatureClass(strWsPathname, strBaseName, pSpatialReference, pGeomType, pAddFields, booForceUniqueIDField)
1376:   Else                                                                             ' IF IN FILE OR PERSONAL GEODATABASE
'    Set pFClass = invoiceCreator.aml_func_mod.createWorkspaceFeatureClass(pFeatWS, strBaseName, esriFTSimple, pGeomType)
1378:     Set pFClass = CreateGDBFeatureClass(pFeatWS, strBaseName, esriFTSimple, pSpatialReference, pGeomType, pAddFields, , , , , _
          lngCategory, pExtent, lngOriginalRecCount)
1380:   End If
  
1382:   Set CreateGeneralFeatureClass = pFClass
  

  Exit Function
ErrorHandler:
  HandleError True, "CreateGeneralFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CheckIfTableExists(pWS As IFeatureWorkspace, strName As String) As Boolean
  On Error GoTo ErrorHandler

    Dim pTable As ITable
    On Error Resume Next
1395:     Set pTable = pWS.OpenTable(strName)
1396:     If pTable Is Nothing Then
1397:         CheckIfTableExists = False
1398:     Else
1399:         CheckIfTableExists = True
1400:     End If
1401:     If CheckIfTableExists = False Then
      Dim pFClass As ITable
1403:       Set pFClass = pWS.OpenFeatureClass(strName)
1404:       If pFClass Is Nothing Then
1405:           CheckIfTableExists = False
1406:       Else
1407:           CheckIfTableExists = True
1408:       End If
1409:     End If

  Exit Function
ErrorHandler:
  HandleError True, "CheckIfTableExists " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function CheckIfFeatureClassExists(pWS As IFeatureWorkspace, strName As String) As Boolean
  On Error GoTo ErrorHandler

    Dim pFClass As IFeatureClass
    On Error Resume Next
1420:     Set pFClass = pWS.OpenFeatureClass(strName)
1421:     If pFClass Is Nothing Then
1422:         CheckIfFeatureClassExists = False
1423:     Else
1424:         CheckIfFeatureClassExists = True
1425:     End If
1426:     If CheckIfFeatureClassExists = False Then
      Dim pTable As ITable
1428:       Set pTable = pWS.OpenTable(strName)
1429:       If pTable Is Nothing Then
1430:           CheckIfFeatureClassExists = False
1431:       Else
1432:           CheckIfFeatureClassExists = True
1433:       End If
1434:     End If

  Exit Function
ErrorHandler:
  HandleError True, "CheckIfFeatureClassExists " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function MakeUniqueGDBTableName(pWS As IWorkspace, strName As String) As String
  On Error GoTo ErrorHandler
  
  Dim booTableExists As Boolean
1445:   booTableExists = CheckIfTableExists(pWS, strName)
  Dim theCounter As Long
1447:   theCounter = 1
  Dim strBaseName As String
  Dim strNewName As String
1450:   strBaseName = strName
1451:   strNewName = strName
1452:   Do Until booTableExists = False
1453:     theCounter = theCounter + 1
1454:     strNewName = strBaseName & "_" & CStr(theCounter)
1455:     booTableExists = CheckIfTableExists(pWS, strNewName)
1456:   Loop
  
1458:   MakeUniqueGDBTableName = strNewName
  
  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueGDBTableName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function MakeUniqueGDBFeatureClassName(pWS As IWorkspace, strName As String) As String
  On Error GoTo ErrorHandler
  
  Dim booFCExists As Boolean
1468:   booFCExists = CheckIfFeatureClassExists(pWS, strName)
  Dim theCounter As Long
1470:   theCounter = 1
  Dim strBaseName As String
  Dim strNewName As String
1473:   strBaseName = strName
1474:   strNewName = strName
1475:   Do Until booFCExists = False
1476:     theCounter = theCounter + 1
1477:     strNewName = strBaseName & "_" & CStr(theCounter)
1478:     booFCExists = CheckIfFeatureClassExists(pWS, strNewName)
1479:   Loop
  
1481:   MakeUniqueGDBFeatureClassName = strNewName
  
  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueGDBFeatureClassName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function MakeUniquedBASEName(strFileName As String) As String
  On Error GoTo ErrorHandler

1491:   If Not ExistFileDir(strFileName) Then
1492:     MakeUniquedBASEName = strFileName
    Exit Function
1494:   Else
    
    Dim theCounter As Long
1497:     theCounter = 1
    
    Dim theFilename As String
    Dim theBaseName As String
    Dim thePointPos As Long
    Dim theExtension As String
    
1504:     If InStr(1, Right(strFileName, 5), ".", vbTextCompare) > 0 Then
1505:       thePointPos = InStrRev(strFileName, ".", -1, vbTextCompare)
1506:       theExtension = Right(strFileName, Len(strFileName) - (thePointPos - 1))
1507:       theFilename = Left(strFileName, thePointPos - 1)
1508:     Else
1509:       theExtension = ""
1510:       theFilename = strFileName
1511:     End If
    
1513:     theBaseName = theFilename
    
1515:     Do While ExistFileDir(theFilename & theExtension)
1516:       theCounter = theCounter + 1
1517:       theFilename = theBaseName & "_" & CStr(theCounter)
1518:     Loop
    
1520:     MakeUniquedBASEName = theFilename & theExtension
    
1522:   End If

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniquedBASEName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function MakeUniqueShapeFilename(strFileName As String) As String
  On Error GoTo ErrorHandler

1532:   If Not ExistFileDir(strFileName) Then
1533:     MakeUniqueShapeFilename = strFileName
    Exit Function
1535:   Else
    
    Dim theCounter As Long
1538:     theCounter = 1
    
    Dim theFilename As String
    Dim theBaseName As String
    Dim thePointPos As Long
    Dim theExtension As String
    
1545:     If InStr(1, Right(strFileName, 5), ".", vbTextCompare) > 0 Then
1546:       thePointPos = InStrRev(strFileName, ".", -1, vbTextCompare)
1547:       theExtension = Right(strFileName, Len(strFileName) - (thePointPos - 1))
1548:       theFilename = Left(strFileName, thePointPos - 1)
1549:     Else
1550:       theExtension = ""
1551:       theFilename = strFileName
1552:     End If
    
1554:     theBaseName = theFilename
    
1556:     Do While ExistFileDir(theFilename & theExtension)
1557:       theCounter = theCounter + 1
1558:       theFilename = theBaseName & "_" & CStr(theCounter)
1559:     Loop
    
1561:     MakeUniqueShapeFilename = theFilename & theExtension
    
1563:   End If

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueShapeFilename " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CreateGDBTable(featWorkspace As IFeatureWorkspace, _
                                            Name As String, _
                                            Optional pAddFields As esriSystem.IVariantArray, _
                                            Optional pCLSID As uID, _
                                            Optional pCLSEXT As uID, _
                                            Optional ConfigWord As String = "" _
                                            ) As ITable
  On Error GoTo ErrorHandler
 
'' createWorkspaceFeatureClass: simple helper to create a featureclass in a geodatabase workspace.
'' NOTE: when creating a feature class in a workspace it is important to assign the spatial
''       reference to the geometry field.
'' MODIFIED BY JENNESS APRIL 23 2008 FROM ESRI SAMPLE
  
1585:   Set CreateGDBTable = Nothing
  If featWorkspace Is Nothing Then Exit Function
  If Name = "" Then Exit Function
  
1589:   If (pCLSID Is Nothing) Or IsMissing(pCLSID) Then
1590:     Set pCLSID = Nothing
1591:     Set pCLSID = New uID
1592:     pCLSID.Value = "esriGeoDatabase.Object"
1593:   End If
  
  ' CREATE OBJECT ID FIELD; ADD ANY REQUESTED FIELDS IF NECESSARY
  ' establish a fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1604:   Set pFields = New Fields
1605:   Set pFieldsEdit = pFields
  
  '' create the object id field
1608:   Set pField = New Field
1609:   Set pFieldEdit = pField
1610:   pFieldEdit.Name = "Object_ID"
 '   pFieldEdit.AliasName = "object identifier"
1612:   pFieldEdit.Type = esriFieldTypeOID
1613:   pFieldsEdit.AddField pField
 
  ' ADD FIELDS IF REQUESTED
1616:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1618:     For lngIndex = 0 To pAddFields.Count - 1
1619:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1620:     Next lngIndex
1621:   End If
  
  ' establish the class extension
1624:   If (pCLSEXT Is Nothing) Or IsMissing(pCLSEXT) Then
1625:     Set pCLSEXT = Nothing
1626:   End If
  
1628:   Set CreateGDBTable = featWorkspace.CreateTable(Name, pFields, pCLSID, pCLSEXT, "")
    
  Exit Function
ErrorHandler:
  HandleError True, "CreateGDBTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateGDBFeatureClass(featWorkspace As IFeatureWorkspace, _
                                            Name As String, _
                                            featType As esriFeatureType, _
                                            pSpRef As ISpatialReference, _
                                            Optional geomType As esriGeometryType = esriGeometryPoint, _
                                            Optional pAddFields As esriSystem.IVariantArray, _
                                            Optional pCLSID As uID, _
                                            Optional pCLSEXT As uID, _
                                            Optional ConfigWord As String = "", _
                                            Optional booForceUniqueIDField As Boolean = True, _
                                            Optional lngCategory As JenDatasetTypes, _
                                            Optional pExtent As IEnvelope, _
                                            Optional lngOriginalRecCount As Long = -9999) As IFeatureClass
  On Error GoTo ErrorHandler

 
'' createWorkspaceFeatureClass: simple helper to create a featureclass in a geodatabase workspace.
'' NOTE: when creating a feature class in a workspace it is important to assign the spatial
''       reference to the geometry field.
'' MODIFIED BY JENNESS APRIL 23 2008 FROM ESRI SAMPLE
  
1656:   Set CreateGDBFeatureClass = Nothing
  If featWorkspace Is Nothing Then Exit Function
  If Name = "" Then Exit Function
  
1660:   If (pCLSID Is Nothing) Or IsMissing(pCLSID) Then
1661:     Set pCLSID = Nothing
1662:     Set pCLSID = New uID
    
    '' determine the appropriate geometry type corresponding the the feature type
    Select Case featType
      Case esriFTSimple
1667:         pCLSID.Value = "esriGeoDatabase.Feature"
1668:         If geomType = esriGeometryLine Then geomType = esriGeometryPolyline
      Case esriFTSimpleJunction
1670:         geomType = esriGeometryPoint
1671:         pCLSID.Value = "esriGeoDatabase.SimpleJunctionFeature"
      Case esriFTComplexJunction
1673:         pCLSID.Value = "esriGeoDatabase.ComplexJunctionFeature"
      Case esriFTSimpleEdge
1675:         geomType = esriGeometryPolyline
1676:         pCLSID.Value = "esriGeoDatabase.SimpleEdgeFeature"
      Case esriFTComplexEdge
1678:         geomType = esriGeometryPolyline
1679:         pCLSID.Value = "esriGeoDatabase.ComplexEdgeFeature"
      Case esriFTAnnotation
        Exit Function
1682:     End Select
1683:   End If
  
  ' CREATE GEOMETRY AND OBJECT ID FIELD; ADD ANY REQUESTED FIELDS IF NECESSARY
  ' establish a fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1694:   Set pFields = New Fields
1695:   Set pFieldsEdit = pFields
  
  '' create the geometry field
1698:   Set pGeomDef = New GeometryDef
1699:   Set pGeomDefEdit = pGeomDef
  
  ' SPATIAL INDEX STUFF
  ' WOULD LIKE THE AVERAGE NUMBER OF FEATURES PER GRID CELL TO BE AROUND 200
  ' GOING TO DEFAULT TO ONE SPATIAL INDEX GRID
  Dim dblIndex0 As Double
  Dim dblIndex1 As Double
  Dim dblIndex2 As Double
1707:   dblIndex0 = 100
1708:   dblIndex1 = 0
1709:   dblIndex2 = 0
  
1711:   If Not pExtent Is Nothing And lngOriginalRecCount > 0 Then
1712:     If Not pExtent.IsEmpty Then
      Dim dblOptimalGridCells As Double
1714:       dblOptimalGridCells = lngOriginalRecCount / 200
      Dim dblX As Double
      Dim dblY As Double
1717:       dblX = pExtent.Width
1718:       dblY = pExtent.Height
1719:       dblIndex0 = Sqr(dblX * dblY / dblOptimalGridCells)
1720:       If dblIndex0 > dblX Then
1721:         dblIndex0 = dblX
1722:       End If
1723:       If dblIndex0 > dblY Then
1724:         dblIndex0 = dblY
1725:       End If
      
1727:       dblIndex1 = 0
1728:       dblIndex2 = 0
1729:     End If
1730:   End If
  
1732:   If Not CheckSpRefDomain(pSpRef) Then
    Dim pSpRefRes As ISpatialReferenceResolution
1734:     Set pSpRefRes = pSpRef
1735:     pSpRefRes.ConstructFromHorizon
1736:   End If
  
  '' assign the geometry definiton properties.
1739:   With pGeomDefEdit
1740:     .GeometryType = geomType
1741:     If lngCategory = ENUM_FileGDB Then       ' FILE GDB
1742:       .GridCount = 1
1743:       .GridSize(0) = dblIndex0
'      .GridSize(1) = dblIndex1
'      .GridSize(2) = dblIndex2
'      .AvgNumPoints = 2
1747:     Else
1748:       .GridCount = 1
1749:       .GridSize(0) = dblIndex0
1750:     End If
1751:     .HasM = False
1752:     .HasZ = False
1753:     Set .SpatialReference = pSpRef
1754:   End With
  
1756:   Set pField = New Field
1757:   Set pFieldEdit = pField
  
1759:   pFieldEdit.Name = "Shape"
1760:   pFieldEdit.AliasName = "geometry"
1761:   pFieldEdit.Type = esriFieldTypeGeometry
1762:   Set pFieldEdit.GeometryDef = pGeomDef
1763:   pFieldsEdit.AddField pField

  '' create the object id field
'  If booForceUniqueIDField Then
    
    
    Dim strUniqueName As String
    Dim strUniqueBase As String
1771:     strUniqueName = "Object_ID"
1772:     strUniqueBase = strUniqueName
    Dim lngUniqueCounter As Long
1774:     lngUniqueCounter = 1
    Dim lngCounterLength As Long
    Dim lngUniqueIndex As Long
    Dim booNameExists As Boolean
    Dim pCheckField As IField
1779:     booNameExists = True
1780:     If (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
1781:       booNameExists = False
1782:     Else
1783:       Do Until booNameExists = False
1784:         booNameExists = False
1785:         For lngUniqueIndex = 0 To pAddFields.Count - 1
1786:           Set pCheckField = pAddFields.Element(lngUniqueIndex)
1787:           If pCheckField.Name = strUniqueName Then
1788:             booNameExists = True
1789:             Exit For
1790:           End If
1791:         Next lngUniqueIndex
1792:         If booNameExists Then
1793:           lngUniqueCounter = lngUniqueCounter + 1
1794:           lngCounterLength = Len(CStr(lngUniqueCounter))
1795:           strUniqueName = Left(strUniqueBase, 11 - lngCounterLength) & CStr(lngUniqueCounter)
1796:         End If
1797:       Loop
1798:     End If
    
1800:     Set pField = New Field
1801:     Set pFieldEdit = pField
1802:     pFieldEdit.Name = strUniqueName
1803:     pFieldEdit.AliasName = "object identifier"
1804:     pFieldEdit.Type = esriFieldTypeOID
1805:     pFieldsEdit.AddField pField
'  End If
  
  ' ADD FIELDS IF REQUESTED
1809:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1811:     For lngIndex = 0 To pAddFields.Count - 1
1812:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1813:     Next lngIndex
1814:   End If
  
  
  ' establish the class extension
1818:   If (pCLSEXT Is Nothing) Or IsMissing(pCLSEXT) Then
1819:     Set pCLSEXT = Nothing
1820:   End If
  
  ' locate the shape field
  Dim strShapeFld As String
  Dim j As Integer
1825:   For j = 0 To pFields.FieldCount - 1
1826:     If pFields.Field(j).Type = esriFieldTypeGeometry Then
1827:       strShapeFld = pFields.Field(j).Name
1828:     End If
1829:   Next
  
1831:   Set CreateGDBFeatureClass = featWorkspace.CreateFeatureClass(Name, pFields, pCLSID, _
                             pCLSEXT, featType, strShapeFld, ConfigWord)
  
  Exit Function
ErrorHandler:
  HandleError True, "CreateGDBFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Private Function CheckSpRefDomain(pSpRef As ISpatialReference) As Boolean
  On Error GoTo ErrorHandler
  
  Dim dXmax As Double
  Dim dYmax As Double
  Dim dXmin As Double
  Dim dYmin As Double
  
  'get the xy domain extent of the dataset
  
1849:   pSpRef.GetDomain dXmin, dXmax, dYmin, dYmax
1850:   CheckSpRefDomain = True
  
ErrorHandler:
1853:   CheckSpRefDomain = False

End Function

Public Function CreatedBASETableInFolder(sPath As String, sName As String, Optional pAddFields As esriSystem.IVariantArray) As ITable
  On Error GoTo ErrorHandler
  
1860:   If Right(sPath, 4) = ".dbf" Then sPath = ReturnDir(sPath)
1861:   If Right(sName, 4) = ".dbf" Then sName = Left(sName, Len(sName) - 4)
  
  ' Open the folder to contain the shapefile as a workspace
  Dim pFWS As IFeatureWorkspace
  Dim pWorkspaceFactory As IWorkspaceFactory
1866:   Set pWorkspaceFactory = New ShapefileWorkspaceFactory
  
1868:   If Not ExistFileDir(sPath) Then
1869:     MsgBox "Unable to create dBASE Table:" & vbCrLf & _
           sPath & " is not a valid workspace...", , "Failed to Create Table:"
1871:     Set CreatedBASETableInFolder = Nothing
    Exit Function
1873:   End If
  
1875:   Set pFWS = pWorkspaceFactory.OpenFromFile(sPath, 0)
  
'   Set up a simple fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
1880:   Set pFields = New Fields
1881:   Set pFieldsEdit = pFields

  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
  ' DON'T ADD UNIQUE ID FIELD IF IT IS ALREADY THERE
  Dim booAddUniqueID As Boolean
1888:   booAddUniqueID = True
  Dim lngIndex As Long
1890:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
1891:     For lngIndex = 0 To pAddFields.Count - 1
1892:       Set pField = pAddFields.Element(lngIndex)
1893:       If pField.Name = "Unique_ID" Then
1894:         booAddUniqueID = False
1895:         Exit For
1896:       End If
1897:     Next lngIndex
1898:   End If
  
1900:   If booAddUniqueID Then
1901:     Set pField = New Field
1902:     Set pFieldEdit = pField
1903:     With pFieldEdit
1904:         .Precision = 8
1905:         .Name = "Unique_ID"
1906:         .Type = esriFieldTypeInteger
1907:     End With
1908:     pFieldsEdit.AddField pField
1909:   End If
  
  ' ADD FIELDS IF REQUESTED
1912:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
1913:     For lngIndex = 0 To pAddFields.Count - 1
1914:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1915:     Next lngIndex
1916:   End If
    
  ' Create the dBASE Table
  ' (some parameters apply to geodatabase options and can be defaulted as Nothing)
  Dim booFileExists As Boolean
  Dim strCheckString As String
1922:   If Right(sPath, 1) = "\" Then
1923:     strCheckString = sPath & sName & ".dbf"
'    MsgBox sPath & sName & ".dbf" & vbCrLf & "File Exists? " & CStr(Dir(sPath & sName & ".dbf") <> "")
1925:   Else
1926:     strCheckString = sPath & "\" & sName & ".dbf"
'    MsgBox sPath & "\" & sName & ".dbf" & vbCrLf & "File Exists? " & CStr(Dir(sPath & "\" & sName & ".dbf") <> "")
1928:   End If
  
1930:   booFileExists = (Dir(strCheckString) <> "")
  
1932:   If booFileExists Then
1933:     MsgBox "The following file already exists:" & vbCrLf & vbCrLf & strCheckString & vbCrLf & vbCrLf & _
           "Please select a new filename...", , "Duplicate Filename:"
1935:     Set CreatedBASETableInFolder = Nothing
    Exit Function
1937:   End If
  
'  Dim lngTestIndex As Long
'  Dim pTestField As IField
'  Dim strTestReport As String
'  For lngTestIndex = 0 To pFields.FieldCount - 1
'    Set pTestField = pFields.Field(lngTestIndex)
'    strTestReport = strTestReport & CStr(lngTestIndex + 1) & "] " & pTestField.Name & "   [Type = " & CStr(pTestField.Type) & "]" & vbCrLf
'  Next lngTestIndex
'  MsgBox strTestReport
  
  
  Dim pTable As ITable
1950:   Set pTable = pFWS.CreateTable(sName, pFields, Nothing, Nothing, "")
  
1952:   Set CreatedBASETableInFolder = pTable
  
  Exit Function
ErrorHandler:
  HandleError True, "CreatedBASETableInFolder " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
    

Public Function CreateShapefileFeatureClass(sPath As String, sName As String, pSpatialReference As ISpatialReference, _
    pGeomType As esriGeometryType, Optional pAddFields As esriSystem.IVariantArray, _
    Optional booForceUniqueIDField As Boolean = True) As IFeatureClass       ' Don't include filename!
  On Error GoTo ErrorHandler

  
1966:   If Right(sPath, 4) = ".shp" Then sPath = ReturnDir(sPath)
1967:   If Right(sName, 4) = ".shp" Then sName = Left(sName, Len(sName) - 4)
  
  ' SET GEOMETRY TYPE, AND EXIT IF NOT ONE OF STANDARD OPTIONS
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
1972:   Set pGeomDef = New GeometryDef
1973:   Set pGeomDefEdit = pGeomDef
1974:   With pGeomDefEdit
1975:     .GeometryType = pGeomType
1976:     Set .SpatialReference = pSpatialReference
1977:   End With
  
  ' Open the folder to contain the shapefile as a workspace
  Dim pFWS As IFeatureWorkspace
  Dim pWorkspaceFactory As IWorkspaceFactory
1982:   Set pWorkspaceFactory = New ShapefileWorkspaceFactory
  
1984:   If Not ExistFileDir(sPath) Then
1985:     MsgBox "Unable to create Feature Class:" & vbCrLf & _
           sPath & " is not a valid workspace...", , "Failed to Create Feature Class:"
1987:     Set CreateShapefileFeatureClass = Nothing
    Exit Function
1989:   End If
  
1991:   Set pFWS = pWorkspaceFactory.OpenFromFile(sPath, 0)
  
'   Set up a simple fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
1996:   Set pFields = New Fields
1997:   Set pFieldsEdit = pFields

  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
  ' Make the shape field
  ' it will need a geometry definition, with a spatial reference
2004:   Set pField = New Field
2005:   Set pFieldEdit = pField
2006:   pFieldEdit.Name = "Shape"
2007:   pFieldEdit.Type = esriFieldTypeGeometry

2009:   Set pFieldEdit.GeometryDef = pGeomDef
2010:   pFieldsEdit.AddField pField
  
  ' MAKE SURE UNIQUE ID FIELD IS UNIQUELY NAMED
 
2014:   If booForceUniqueIDField Then
    Dim strUniqueName As String
    Dim strUniqueBase As String
2017:     strUniqueName = "Unique_ID"
2018:     strUniqueBase = strUniqueName
    Dim lngUniqueCounter As Long
2020:     lngUniqueCounter = 1
    Dim lngCounterLength As Long
    Dim lngUniqueIndex As Long
    Dim booNameExists As Boolean
    Dim pCheckField As IField
2025:     booNameExists = True
2026:     If (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
2027:       booNameExists = False
2028:     Else
2029:       Do Until booNameExists = False
2030:         booNameExists = False
2031:         For lngUniqueIndex = 0 To pAddFields.Count - 1
2032:           Set pCheckField = pAddFields.Element(lngUniqueIndex)
2033:           If pCheckField.Name = strUniqueName Then
2034:             booNameExists = True
2035:             Exit For
2036:           End If
2037:         Next lngUniqueIndex
2038:         If booNameExists Then
2039:           lngUniqueCounter = lngUniqueCounter + 1
2040:           lngCounterLength = Len(CStr(lngUniqueCounter))
2041:           strUniqueName = Left(strUniqueBase, 10 - lngCounterLength) & CStr(lngUniqueCounter)
2042:         End If
2043:       Loop
2044:     End If
    
2046:     Set pField = New Field
2047:     Set pFieldEdit = pField
2048:     With pFieldEdit
2049:         .Precision = 8
2050:         .Name = strUniqueName
2051:         .Type = esriFieldTypeInteger
2052:     End With
2053:     pFieldsEdit.AddField pField
2054:   End If
  
  ' ADD FIELDS IF REQUESTED
'  Dim strDebugReport As String
'  Dim pDebugField As IField
2059:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
2061:     For lngIndex = 0 To pAddFields.Count - 1
'      Set pDebugField = pAddFields.Element(lngIndex)
'      strDebugReport = strDebugReport & CStr(lngIndex) & "]  Field Name = " & pDebugField.Name & vbCrLf
2064:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
2065:     Next lngIndex
2066:   End If
'  MsgBox CStr(pGeomDef.GeometryType) & vbCrLf & strDebugReport
  ' Create the shapefile
  ' (some parameters apply to geodatabase options and can be defaulted as Nothing)
  Dim booFileExists As Boolean
  Dim strCheckString As String
2072:   If Right(sPath, 1) = "\" Then
2073:     strCheckString = sPath & sName & ".shp"
'    MsgBox sPath & sName & ".shp" & vbCrLf & "File Exists? " & CStr(Dir(sPath & sName & ".shp") <> "")
2075:   Else
2076:     strCheckString = sPath & "\" & sName & ".shp"
'    MsgBox sPath & "\" & sName & ".shp" & vbCrLf & "File Exists? " & CStr(Dir(sPath & "\" & sName & ".shp") <> "")
2078:   End If
  
'  booFileExists = (Dir(strCheckString) <> "")
'  MsgBox strCheckString & vbCrLf & CStr(booFileExists)
  
2083:   If booFileExists Then
2084:     MsgBox "The following file already exists:" & vbCrLf & vbCrLf & strCheckString & vbCrLf & vbCrLf & _
           "Please select a new filename...", , "Duplicate Filename:"
2086:     Set CreateShapefileFeatureClass = Nothing
    Exit Function
2088:   End If
  
  Dim pFeatClass As IFeatureClass
2091:   Set pFeatClass = pFWS.CreateFeatureClass(sName, pFields, Nothing, _
                                           Nothing, esriFTSimple, "Shape", "")
                                           
2094:   Set CreateShapefileFeatureClass = pFeatClass



  Exit Function
ErrorHandler:
  HandleError True, "CreateShapefileFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

  
Public Function CreateDatasetFeatureClass(pFDS As IFeatureDataset, _
                                  Name As String, featType As esriFeatureType, _
                                  Optional geomType As esriGeometryType = esriGeometryPoint, _
                                  Optional pAddFields As esriSystem.IVariantArray, _
                                  Optional pCLSID As uID, _
                                  Optional pCLSEXT As uID, _
                                  Optional ConfigWord As String = "" _
                                  ) As IFeatureClass
  On Error GoTo ErrorHandler

  
'' createDatasetFeatureClass: simple helper to create a featureclass in a geodatabase Dataset.
'' NOTE: when creating a feature class in a dataset the spatial reference is inherited
'' from the dataset object
'' MODIFIED BY JENNESS APRIL 23 2008 FROM ESRI SAMPLE

  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  Dim strShapeFld As String
  Dim j As Integer
  
2129:   Set CreateDatasetFeatureClass = Nothing
  If pFDS Is Nothing Then Exit Function
  If Name = "" Then Exit Function
  
2133:   If (pCLSID Is Nothing) Or IsMissing(pCLSID) Then
2134:     Set pCLSID = Nothing
2135:     Set pCLSID = New uID
    
    '' determine the appropriate geometry type corresponding the the feature type
    Select Case featType
      Case esriFTSimple
2140:         pCLSID.Value = "esriGeoDatabase.Feature"
      Case esriFTSimpleJunction
2142:         geomType = esriGeometryPoint
2143:         pCLSID.Value = "esriGeoDatabase.SimpleJunctionFeature"
      Case esriFTComplexJunction
2145:         pCLSID.Value = "esriGeoDatabase.ComplexJunctionFeature"
      Case esriFTSimpleEdge
2147:         geomType = esriGeometryPolyline
2148:         pCLSID.Value = "esriGeoDatabase.SimpleEdgeFeature"
      Case esriFTComplexEdge
2150:         geomType = esriGeometryPolyline
2151:         pCLSID.Value = "esriGeoDatabase.ComplexEdgeFeature"
      Case esriFTAnnotation
        Exit Function
2154:     End Select
2155:   End If
  
  ' CREATE GEOMETRY AND OBJECT ID FIELD; ADD ANY REQUESTED FIELDS IF NECESSARY
  ' establish a fields collection
2159:   Set pFields = New Fields
2160:   Set pFieldsEdit = pFields
  
  '' create the geometry field
2163:   Set pGeomDef = New GeometryDef
2164:   Set pGeomDefEdit = pGeomDef
  
  '' assign the geometry definiton properties.
2167:   With pGeomDefEdit
2168:     .GeometryType = geomType
2169:     .GridCount = 1
2170:     .GridSize(0) = 10
2171:     .AvgNumPoints = 2
2172:     .HasM = False
2173:     .HasZ = False
2174:   End With
  
2176:   Set pField = New Field
2177:   Set pFieldEdit = pField
  
2179:   pFieldEdit.Name = "Shape"
2180:   pFieldEdit.AliasName = "geometry"
2181:   pFieldEdit.Type = esriFieldTypeGeometry
2182:   Set pFieldEdit.GeometryDef = pGeomDef
2183:   pFieldsEdit.AddField pField

  '' create the object id field
2186:   Set pField = New Field
2187:   Set pFieldEdit = pField
2188:   pFieldEdit.Name = "Object_ID"
2189:   pFieldEdit.AliasName = "object identifier"
2190:   pFieldEdit.Type = esriFieldTypeOID
2191:   pFieldsEdit.AddField pField
  
  ' ADD FIELDS IF REQUESTED
2194:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
2196:     For lngIndex = 0 To pAddFields.Count - 1
2197:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
2198:     Next lngIndex
2199:   End If
  
  ' establish the class extension
2202:   If (pCLSEXT Is Nothing) Or IsMissing(pCLSEXT) Then
2203:     Set pCLSEXT = Nothing
2204:   End If
  
  ' locate the shape field
2207:   For j = 0 To pFields.FieldCount - 1
2208:     If pFields.Field(j).Type = esriFieldTypeGeometry Then
2209:       strShapeFld = pFields.Field(j).Name
2210:     End If
2211:   Next
  
2213:   Set CreateDatasetFeatureClass = pFDS.CreateFeatureClass(Name, pFields, pCLSID, pCLSEXT, featType, strShapeFld, ConfigWord)
  

  Exit Function
ErrorHandler:
  HandleError True, "CreateDatasetFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
           


Public Function ReturnFieldsByType(pFields As IFields, enumJenFieldTypes As JenFieldTypes) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


  Dim booString As Boolean
  Dim booNumber As Boolean
  Dim booDate As Boolean
  Dim booOID As Boolean
  Dim booGeometry As Boolean
  Dim booBlob As Boolean
  Dim booRaster As Boolean
  Dim booGUID As Boolean
  Dim booGlobalID As Boolean
  Dim booXML As Boolean
  
  Dim strBinary As String
2239:   strBinary = ConvertLongBinary(enumJenFieldTypes, 10)
'  MsgBox "Number = " & enumJenFieldTypes & vbCrLf & "Binary = " & strBinary

2242:   booXML = Mid(strBinary, 1, 1) = "1"
2243:   booGlobalID = Mid(strBinary, 2, 1) = "1"
2244:   booGUID = Mid(strBinary, 3, 1) = "1"
2245:   booRaster = Mid(strBinary, 4, 1) = "1"
2246:   booBlob = Mid(strBinary, 5, 1) = "1"
2247:   booGeometry = Mid(strBinary, 6, 1) = "1"
2248:   booOID = Mid(strBinary, 7, 1) = "1"
2249:   booDate = Mid(strBinary, 8, 1) = "1"
2250:   booNumber = Mid(strBinary, 9, 1) = "1"
2251:   booString = Mid(strBinary, 10, 1) = "1"
  
'  MsgBox "booString = " & booString & vbCrLf & _
      "booNumber = " & booNumber & vbCrLf & _
      "booDate = " & booDate & vbCrLf & _
      "booOID = " & booOID & vbCrLf & _
      "booGeometry = " & booGeometry & vbCrLf & _
      "booBlob = " & booBlob & vbCrLf & _
      "booRaster = " & booRaster & vbCrLf & _
      "booGUID = " & booGUID & vbCrLf & _
      "booGlobalID = " & booGlobalID & vbCrLf & _
      "booXML = " & booXML
  
  Dim pField As IField
  Dim lngIndex As Long
  Dim pType As esriFieldType
  
2268:   Set ReturnFieldsByType = New esriSystem.VarArray
    
2270:   For lngIndex = 0 To pFields.FieldCount - 1
2271:     Set pField = pFields.Field(lngIndex)
2272:     pType = pField.Type
2273:     If booXML And (pType = esriFieldTypeXML) Then
2274:       ReturnFieldsByType.Add pField
2275:     ElseIf booGlobalID And (pType = esriFieldTypeGlobalID) Then
2276:       ReturnFieldsByType.Add pField
2277:     ElseIf booGUID And (pType = esriFieldTypeGUID) Then
2278:       ReturnFieldsByType.Add pField
2279:     ElseIf booRaster And (pType = esriFieldTypeRaster) Then
2280:       ReturnFieldsByType.Add pField
2281:     ElseIf booBlob And (pType = esriFieldTypeBlob) Then
2282:       ReturnFieldsByType.Add pField
2283:     ElseIf booGeometry And (pType = esriFieldTypeGeometry) Then
2284:       ReturnFieldsByType.Add pField
2285:     ElseIf booOID And (pType = esriFieldTypeOID) Then
2286:       ReturnFieldsByType.Add pField
2287:     ElseIf booDate And (pType = esriFieldTypeDate) Then
2288:       ReturnFieldsByType.Add pField
2289:     ElseIf booNumber And ((pType = esriFieldTypeDouble) Or (pType = esriFieldTypeInteger) _
      Or (pType = esriFieldTypeSingle) Or (pType = esriFieldTypeSmallInteger)) Then
2291:       ReturnFieldsByType.Add pField
2292:     ElseIf booString And (pType = esriFieldTypeString) Then
2293:       ReturnFieldsByType.Add pField
2294:     End If
2295:   Next lngIndex


  Exit Function
ErrorHandler:
  HandleError True, "ReturnFieldsByType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnDBASEFieldName(strName As String, pFieldSet As Variant) As String
  On Error GoTo ErrorHandler


  Dim lngIndex As Long
  
  Dim strAcceptable As String
2310:   strAcceptable = "abcdefghijklmnopqrstuvwxyz1234567890_"
  Dim strCharacters As String
2312:   strCharacters = "abcdefghijklmnopqrstuvwxyz"
  
  Dim pField As IField
  
  Dim strNewName As String
  Dim strChar As String
  
  ' MAKE SURE SUGGESTED NAME IS VALID FOR dBASE IN GENERAL
  ' CHECK IF FIELD NAME IS EMPTY STRING
2321:   If strName = "" Then strName = "zField"
  
  ' CHECK IF FIELD NAME IS PROPER LENGTH
2324:   strName = Left(strName, 10)
  
  ' CHECK IF FIELD NAME DOES NOT START WITH A LETTER
2327:   If Not (InStr(1, strCharacters, Left(strName, 1), vbTextCompare) > 0) Then
2328:     strName = Left("z" & strName, 10)
2329:   End If
  
  ' CHECK FOR NON_CONFORMING CHARACTERS
2332:   strNewName = ""
2333:   For lngIndex = 1 To Len(strName)
2334:     strChar = Mid(strName, lngIndex, 1)
2335:     If Not (InStr(1, strAcceptable, strChar, vbTextCompare) > 0) Then
2336:       strNewName = strNewName & "_"
2337:     Else
2338:       strNewName = strNewName & strChar
2339:     End If
2340:   Next lngIndex
2341:   strName = strNewName
  
  Dim strTestName As String
    
  ' MAKE SURE FIELD NAME DOES NOT ALREADY EXIST IN LIST
  ' CONVERT OBJECT INTO LIST OF EXISTING NAMES
  Dim pFieldArray As esriSystem.IStringArray
2348:   Set pFieldArray = New esriSystem.strArray
  
2350:   If TypeOf pFieldSet Is IFields Then
    
    Dim pFields As IFields
2353:     Set pFields = pFieldSet
2354:     If pFields.FieldCount > 0 Then
2355:       For lngIndex = 0 To pFields.FieldCount - 1
2356:         strTestName = pFields.Field(lngIndex).Name
2357:         pFieldArray.Add strTestName
2358:       Next lngIndex
2359:     End If
    
2361:   ElseIf TypeOf pFieldSet Is esriSystem.IVariantArray Then
    
    Dim pVar As Variant
    Dim pVarArray As esriSystem.IVariantArray
2365:     Set pVarArray = pFieldSet
2366:     If pVarArray.Count > 0 Then
2367:       For lngIndex = 0 To pVarArray.Count - 1
2368:         If VarType(pVarArray.Element(lngIndex)) = vbDataObject Then           ' IS AN IField
2369:           Set pField = pVarArray.Element(lngIndex)
2370:           strTestName = pField.Name
2371:         Else
2372:           strTestName = pVarArray.Element(lngIndex)
2373:         End If
2374:         pFieldArray.Add strTestName
2375:       Next lngIndex
2376:     End If
  
2378:   ElseIf TypeOf pFieldSet Is esriSystem.IStringArray Then
    
2380:     Set pFieldArray = pFieldSet
  
2382:   End If
  
  ' CHECK CURRENT NAME AGAINST LIST
2385:   If pFieldArray.Count > 0 Then
    Dim lngCounter As Long
    Dim strBaseName As String
2388:     strBaseName = strName
    Dim booFoundConflict As Boolean
2390:     booFoundConflict = True
2391:     Do Until booFoundConflict = False
2392:       booFoundConflict = False
2393:       For lngIndex = 0 To pFieldArray.Count - 1
2394:         strTestName = pFieldArray.Element(lngIndex)
2395:         If StrComp(strName, strTestName, vbTextCompare) = 0 Then
2396:           booFoundConflict = True
2397:           Exit For
2398:         End If
2399:       Next lngIndex
2400:       If booFoundConflict Then
2401:         lngCounter = lngCounter + 1
2402:         strName = Left(strBaseName, 10 - Len(CStr(lngCounter))) & CStr(lngCounter)
2403:       End If
2404:     Loop
2405:   End If
  
2407:   ReturnDBASEFieldName = strName


  Exit Function
ErrorHandler:
  HandleError True, "ReturnDBASEFieldName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnLayerByName(strName As String, pMap As IMap) As ILayer
  On Error GoTo ErrorHandler


2419:   Set ReturnLayerByName = Nothing
  Dim pLayers As IEnumLayer
2421:   Set pLayers = pMap.Layers(Nothing, True)
  Dim pLayer As ILayer
2423:   pLayers.Reset
2424:   Set pLayer = pLayers.Next
2425:   Do Until pLayer Is Nothing
2426:     If pLayer.Name = strName Then
2427:       Set ReturnLayerByName = pLayer
2428:       Exit Do
2429:     End If
2430:     Set pLayer = pLayers.Next
2431:   Loop


  Exit Function
ErrorHandler:
  HandleError True, "ReturnLayerByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CheckIfCompressedFGDB(pFeatureClass As IFeatureClass) As Boolean
  ' NOTE:  WILL ONLY RETURN TRUE IF EVERYTHING WORKS; IF FUNCTION CRASHES, THEN
  ' ASSUME THIS IS NOT A FILE GEODATABASE AND THEREFORE CANNOT BE A COMPRESSED FGDB.
  ' FOR EXAMPLE, APPARENTLY PERSONAL GEODATABASES AND SHAPEFILES DON'T HAVE PROPERTY SETS???
  
  On Error GoTo EH
  
  Dim pDataset As IDataset
2447:   Set pDataset = pFeatureClass
  Dim pGeoDataset As IGeoDataset
2449:   Set pGeoDataset = pFeatureClass
  Dim strCategory As String
2451:   strCategory = pDataset.Category
  Dim booIsFGDB As Boolean
2453:   booIsFGDB = InStr(1, strCategory, "file geodatabase", vbTextCompare)
  
2455:   CheckIfCompressedFGDB = False
  
2457:   If booIsFGDB Then      ' IF FILE GEODATABASE, CHECK IF IT IS COMPRESSED
    Dim pPropSet As IPropertySet
2459:     Set pPropSet = pDataset.PropertySet
    Dim varFormat As Variant
2461:     varFormat = pPropSet.GetProperty("Datafile Format")
2462:     If varFormat = 1 Then
2463:       CheckIfCompressedFGDB = True
2464:     Else
2465:       CheckIfCompressedFGDB = False
2466:     End If
2467:   End If
  
  Exit Function
EH:
2471:   CheckIfCompressedFGDB = False
End Function

Public Function TrueLayerCount(pMap As IMap) As Long
  On Error GoTo ErrorHandler


  Dim lngLayerCount As Long
2479:   lngLayerCount = 0
  
2481:   If pMap.LayerCount > 0 Then
    Dim pEnumLayer As IEnumLayer
2483:     Set pEnumLayer = pMap.Layers
2484:     pEnumLayer.Reset
    Dim pLayer As IUnknown
2486:     Set pLayer = pEnumLayer.Next
2487:     Do Until pLayer Is Nothing
2488:       lngLayerCount = lngLayerCount + 1
2489:       Set pLayer = pEnumLayer.Next
2490:     Loop
2491:   End If
  
2493:   TrueLayerCount = lngLayerCount


  Exit Function
ErrorHandler:
  HandleError True, "TrueLayerCount " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ReturnDistanceUnitsName(lngEsriUnits As esriUnits) As String
  On Error GoTo ErrorHandler


  Select Case lngEsriUnits
    Case 0
2508:       ReturnDistanceUnitsName = "Unknown"
    Case 1
2510:       ReturnDistanceUnitsName = "Inches"
    Case 2
2512:       ReturnDistanceUnitsName = "Points"
    Case 3
2514:       ReturnDistanceUnitsName = "Feet"
    Case 4
2516:       ReturnDistanceUnitsName = "Yards"
    Case 5
2518:       ReturnDistanceUnitsName = "Miles"
    Case 6
2520:       ReturnDistanceUnitsName = "Nautical miles"
    Case 7
2522:       ReturnDistanceUnitsName = "Millimeters"
    Case 8
2524:       ReturnDistanceUnitsName = "Centimeters"
    Case 9
2526:       ReturnDistanceUnitsName = "Meters"
    Case 10
2528:       ReturnDistanceUnitsName = "Kilometers"
    Case 11
2530:       ReturnDistanceUnitsName = "Decimal degrees"
    Case 12
2532:       ReturnDistanceUnitsName = "Decimeters"
2533:   End Select


  Exit Function
ErrorHandler:
  HandleError True, "ReturnDistanceUnitsName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ConvertLongBinary(lngNumber As Long, Optional MinimumNumDigits As Long = -1) As String
  On Error GoTo ErrorHandler


  Dim strBinary As String
  Dim lngIntermediate As Long
  Dim lngRemainder As Long
2548:   lngIntermediate = lngNumber
2549:   Do Until lngIntermediate = 1
2550:     lngRemainder = lngIntermediate Mod 2
2551:     lngIntermediate = Int(lngIntermediate / 2)
2552:     strBinary = CStr(lngRemainder) & strBinary
2553:   Loop
2554:   strBinary = "1" & strBinary
  
2556:   If Len(strBinary) < MinimumNumDigits Then
2557:     Do While Len(strBinary) < MinimumNumDigits
2558:       strBinary = "0" & strBinary
2559:     Loop
2560:   End If
  
2562:   ConvertLongBinary = strBinary


  Exit Function
ErrorHandler:
  HandleError True, "ConvertLongBinary " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ReturnLayersByType(pFocusMap As IMap, enumLayerTypes As JenLayerTypes) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


  Dim booFeatureLayers As Boolean
  Dim booRasterLayers As Boolean
  Dim booStandaloneTables As Boolean
  Dim booPointLayers As Boolean
  Dim booPolylineLayers As Boolean
  Dim booPolygonLayers As Boolean
  Dim booMultipointLayers As Boolean
  Dim booTinLayers As Boolean
  Dim booTerrainLayers As Boolean
  Dim booRasterCatalogLayers As Boolean
  
  Dim strBinary As String
2587:   strBinary = ConvertLongBinary(enumLayerTypes, 9)
'  MsgBox "Number = " & enumLayerTypes & vbCrLf & "Binary = " & strBinary
2589:   booFeatureLayers = Mid(strBinary, 9, 1) = "1"
2590:   booRasterLayers = Mid(strBinary, 8, 1) = "1"
2591:   booStandaloneTables = Mid(strBinary, 7, 1) = "1"
2592:   booPointLayers = Mid(strBinary, 6, 1) = "1"
2593:   booPolylineLayers = Mid(strBinary, 5, 1) = "1"
2594:   booPolygonLayers = Mid(strBinary, 4, 1) = "1"
2595:   booMultipointLayers = Mid(strBinary, 3, 1) = "1"
2596:   booTinLayers = Mid(strBinary, 2, 1) = "1"
2597:   booRasterCatalogLayers = Mid(strBinary, 1, 1) = "1"
  
'  MsgBox "booFeatureLayers = " & booFeatureLayers & vbCrLf & _
'      "booRasterLayers = " & booRasterLayers & vbCrLf & _
'      "booStandaloneTables = " & booStandaloneTables & vbCrLf & _
'      "booPointLayers = " & booPointLayers & vbCrLf & _
'      "booPolylineLayers = " & booPolylineLayers & vbCrLf & _
'      "booPolygonLayers = " & booPolygonLayers & vbCrLf & _
'      "booMultipointLayers = " & booMultipointLayers & vbCrLf & _
'      "booTinLayers = " & booTinLayers

  Dim pEnumLayer As IEnumLayer
  Dim pFeatureLayer As IFeatureLayer
  Dim pLayer As IUnknown
  Dim pFeatureClass As IFeatureClass
  Dim pGeometryType As esriGeometryType
  Dim pFeatureLayerForValid As IFeatureLayer
  Dim booOpenDialog As Boolean
2615:   booOpenDialog = False
  Dim pRasterLayer As IRasterLayer
'  Dim pAsLayer As ILayer
    
2619:   Set ReturnLayersByType = New esriSystem.VarArray
    
2621:   If (pFocusMap.LayerCount > 0) Then
2622:     Set pEnumLayer = pFocusMap.Layers(, True)
2623:     pEnumLayer.Reset
    
2625:     Set pLayer = pEnumLayer.Next
2626:     Do Until pLayer Is Nothing
'      Set pAsLayer = pLayer
'      MsgBox "Layer Name = " & pAsLayer.Name & vbCrLf & _
'             "Feature Layer:  " & CStr(TypeOf pLayer Is IFeatureLayer) & vbCrLf & _
'             "Raster Layer:  " & CStr(TypeOf pLayer Is IRasterLayer) & vbCrLf & _
'             "TIN Layer:  " & CStr(TypeOf pLayer Is ITinLayer)
             
2633:       If TypeOf pLayer Is IGdbRasterCatalogLayer Then
2634:         Set pFeatureLayerForValid = pLayer
2635:         If pFeatureLayerForValid.Valid Then
2636:           If booRasterCatalogLayers Then ReturnLayersByType.Add pLayer
2637:         End If
            
2639:       ElseIf TypeOf pLayer Is IFeatureLayer Then
2640:         Set pFeatureLayerForValid = pLayer
        ' CHECK IF FEATURE LAYER IS VALID
2642:         If pFeatureLayerForValid.Valid Then
          ' CHECK IF POLYGON LAYER
2644:           Set pFeatureClass = pFeatureLayerForValid.FeatureClass          ' CHECK IF FEATURE LAYER
2645:           pGeometryType = pFeatureClass.ShapeType
2646:           If booFeatureLayers Then
2647:             ReturnLayersByType.Add pLayer
2648:           Else
2649:             If (pGeometryType = esriGeometryPolygon) Then                 ' CHECK IF POLYGON LAYER
2650:               If booPolygonLayers Then ReturnLayersByType.Add pLayer
2651:             ElseIf pGeometryType = esriGeometryPolyline Then              ' CHECK IF POLYLINE LAYER
2652:               If booPolylineLayers Then ReturnLayersByType.Add pLayer
2653:             ElseIf pGeometryType = esriGeometryPoint Then                 ' CHECK IF POINT LAYER
2654:               If booPointLayers Then ReturnLayersByType.Add pLayer
2655:             ElseIf pGeometryType = esriGeometryMultipoint Then            ' CHECK IF MULTIPOINT LAYER
2656:               If booMultipointLayers Then ReturnLayersByType.Add pLayer
2657:             End If
2658:           End If
2659:         End If
2660:       ElseIf TypeOf pLayer Is IRasterLayer Then                           ' CHECK IF RASTER LAYER
2661:         Set pRasterLayer = pLayer
2662:         If pRasterLayer.Valid Then
2663:           If booRasterLayers Then ReturnLayersByType.Add pLayer
2664:         End If
2665:       ElseIf TypeOf pLayer Is ITinLayer Then                              ' CHECK IF TIN LAYER
        Dim pTinLayer As ITinLayer
2667:         Set pTinLayer = pLayer
2668:         If pTinLayer.Valid Then
2669:           If booTinLayers Then ReturnLayersByType.Add pLayer
2670:         End If
2671:       End If
2672:       Set pLayer = pEnumLayer.Next
2673:     Loop
2674:   End If
  
2676:   If booStandaloneTables Then
    Dim pSTCollection As IStandaloneTableCollection
2678:     Set pSTCollection = pFocusMap
    Dim pStTble As IStandaloneTable
2680:     If pSTCollection.StandaloneTableCount > 0 Then
      Dim lngIndex As Long
2682:       For lngIndex = 0 To pSTCollection.StandaloneTableCount - 1
2683:         Set pStTble = pSTCollection.StandaloneTable(lngIndex)
2684:         If booStandaloneTables Then ReturnLayersByType.Add pStTble
2685:       Next lngIndex
2686:     End If
2687:   End If
  
'  Dim strReport As String
'  For lngIndex = 0 To ReturnLayersByType.Count - 1
'    Set pAsLayer = ReturnLayersByType.Element(lngIndex)
'    strReport = strReport & CStr(lngIndex) & "] " & pAsLayer.Name & vbCrLf
'  Next lngIndex
'  MsgBox strReport


  Exit Function
ErrorHandler:
  HandleError True, "ReturnLayersByType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function BasicStatsFromVAT(anArray() As Double, dblSizeArray() As Double, _
      theFieldName As String, theTableName As String, _
      m_App As Application, Optional lngNumberHistBins As Long = -9999) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  
  
  ' ASSUMES ARRAYS ARE SORTED!!!! --------------------------------------
  
  Dim pResponse As esriSystem.IVariantArray
2713:   Set pResponse = New esriSystem.VarArray
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
2717:   Set psbar = m_App.StatusBar
  Dim pPro As IStepProgressor
2719:   Set pPro = psbar.ProgressBar
  
  ' IF MAKING A HISTOGRAM
  Dim booMakeHistogram As Boolean
2723:   booMakeHistogram = (lngNumberHistBins > 0)
  Dim lngHistCountArray() As Long            ' WILL CONTAIN COUNTS OF VALUES LYING IN EACH HISTOGRAM BIN
2725:   If booMakeHistogram Then
    Dim dblHistLow As Double
    Dim dblHistHigh As Double
2728:     dblHistLow = anArray(0)
2729:     dblHistHigh = anArray(UBound(anArray))
    Dim dblInterval As Double
2731:     dblInterval = (dblHistHigh - dblHistLow) / lngNumberHistBins
    
    ReDim lngHistCountArray(lngNumberHistBins)
    Dim lngHistBinIndex As Long
2735:     lngHistBinIndex = 0
    Dim dblCurrentBinThreshold As Double
2737:     dblCurrentBinThreshold = dblHistLow + dblInterval
2738:   End If
  
2740:   Screen.MousePointer = vbHourglass
  
2742:   If booMakeHistogram Then
2743:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          4 * (UBound(anArray) - 1), 1, True
2745:   Else
2746:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          3 * (UBound(anArray) - 1), 1, True
2748:   End If
  
  Dim FoundMode As Boolean
2751:   FoundMode = False
  
  Dim theModeValList() As Double
  ReDim theModeValList(1, UBound(anArray))
  
  Dim theHighModeCount As Long
2757:   theHighModeCount = 0
  
  Dim anIndex As Long
  Dim theVal As Double
  Dim theSize As Double
  Dim theValTimesSize As Double
  Dim theModeCounter As Long
  Dim theModeIndex As Long
2765:   theModeIndex = -1
  
2767:   anIndex = 0
2768:   psbar.StepProgressBar
  
  ' IF MAKING HISTOGRAM
2771:   If booMakeHistogram Then
2772:     Do While anIndex <= UBound(anArray)
2773:       theVal = anArray(anIndex)
2774:       theSize = dblSizeArray(anIndex)
2775:       theValTimesSize = theVal * theSize
2776:       If theVal <= dblCurrentBinThreshold Then
2777:         lngHistCountArray(lngHistBinIndex) = lngHistCountArray(lngHistBinIndex) + theSize
2778:       Else
2779:         Do While dblCurrentBinThreshold < theVal
2780:           dblCurrentBinThreshold = dblCurrentBinThreshold + dblInterval
2781:           lngHistBinIndex = lngHistBinIndex + 1
2782:         Loop
2783:         lngHistCountArray(lngHistBinIndex) = theSize
2784:       End If
2785:       anIndex = anIndex + 1
2786:       psbar.StepProgressBar
2787:     Loop
2788:   End If
  
  '  PASS 1:  MODE --------------------------------------------------
2791:   anIndex = 0
  
2793:   Do While anIndex < UBound(anArray)
    
2795:     theModeCounter = 0
2796:     theVal = anArray(anIndex)
2797:     theSize = dblSizeArray(anIndex)
    
2799:     Do While (anIndex < UBound(anArray))
      ' IF THE NEXT VALUE UP IS DIFFERENT, THEN START NEW COUNT
2801:       If Not (anArray(anIndex + 1) = theVal) Then
2802:         theModeCounter = theSize
2803:         Exit Do
2804:       End If
            
      ' IF NEXT VALUE UP IS THE SAME, THEN ADD NEW SIZE TO CURRENT TALLY.  THEN CONTINUE LOOKING FOR A NEW VALUE.
2807:       theModeCounter = theModeCounter + theSize
      
2809:       anIndex = anIndex + 1
2810:       theSize = dblSizeArray(anIndex)
      
2812:       psbar.StepProgressBar
2813:     Loop
    
2815:     If theModeCounter > 1 Then
2816:       FoundMode = True
2817:       theModeIndex = theModeIndex + 1
2818:       theModeValList(0, theModeIndex) = theModeCounter
2819:       theModeValList(1, theModeIndex) = theVal
      
'      Debug.Print "Value = " & theModeValList(1, theModeIndex) & "[" & theModeValList(0, theModeIndex) & " cases]"
      
2823:     End If
    
2825:     anIndex = anIndex + 1
2826:     psbar.StepProgressBar
2827:   Loop
  
  Dim theModeString As String
  
  ' IF ANY VALUE OCCURED > 1 TIME
  Dim theFinalModes() As Double
2833:   If FoundMode Then
    ReDim Preserve theModeValList(1, theModeIndex)
    
    Dim theFinalModeCount As Long
2837:     theFinalModeCount = 0
    Dim theTempCount As Long
2839:     theTempCount = 0
        
    Dim theFinalModeIndex As Long
        
2843:     For anIndex = 0 To theModeIndex
2844:       theTempCount = theModeValList(0, anIndex)
2845:       If theTempCount > theFinalModeCount Then
2846:         theFinalModeCount = theTempCount
        ReDim theFinalModes(0)
2848:         theFinalModes(0) = theModeValList(1, anIndex)
2849:       ElseIf theTempCount = theFinalModeCount Then
2850:         theFinalModeIndex = UBound(theFinalModes) + 1
        ReDim Preserve theFinalModes(theFinalModeIndex)
2852:         theFinalModes(theFinalModeIndex) = theModeValList(1, anIndex)
2853:       End If
2854:     Next anIndex
    
2856:     If UBound(theFinalModes) > 0 Then
2857:       theModeString = UBound(theFinalModes) + 1 & " modes found [" & aml_func_mod.InsertCommas(theFinalModeCount) & " cases each]: Values = "
2858:       For anIndex = 0 To UBound(theFinalModes)
2859:         theModeString = theModeString & theFinalModes(anIndex) & ", "
2860:       Next anIndex
      
2862:       theModeString = aml_func_mod.BasicTrimAvenue(theModeString, "", ", ")
      
2864:     Else
2865:       theModeString = "1 mode found [" & aml_func_mod.InsertCommas(theFinalModeCount) & " cases]: Value = " & theFinalModes(0)
2866:     End If
    
2868:   Else
2869:     theModeString = " < No Mode Found >"
2870:   End If
  
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
2877:   theSum = 0
2878:   theCount = 0
2879:   theMinimum = anArray(0)
2880:   theMaximum = anArray(0)
  
  '  PASS 2:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
2883:   For anIndex = LBound(anArray) To UBound(anArray)
        
2885:     psbar.StepProgressBar
    
2887:     theVal = anArray(anIndex)
2888:     theSize = dblSizeArray(anIndex)
2889:     theCount = theCount + theSize
    
2891:     theValTimesSize = theVal * theSize
    
2893:     If theVal < theMinimum Then
2894:       theMinimum = theVal
2895:     End If
2896:     If theVal > theMaximum Then
2897:       theMaximum = theVal
2898:     End If
2899:     theSum = theSum + theValTimesSize
    
2901:   Next anIndex
  
  Dim theMean As Double
2904:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  Dim theMedian As Double
  Dim lngMiddleIndex As Long     ' DON'T HAVE TO WORRY ABOUT DECIMAL COUNTS BECAUSE WORKING WITH VAT.  ALL COUNTS ARE INTEGER.
  Dim theRunningCount As Double
2911:   theRunningCount = 0
  Dim booFoundMedian As Boolean
2913:   booFoundMedian = False
  
2915:   If theCount = 0 Then
2916:     lngMiddleIndex = 0
2917:   ElseIf theCount Mod 2 = 0 Then      ' EVEN NUMBER
'      theMedian = (anArray((theCount / 2) - 1) + anArray(theCount / 2)) / 2
2919:     lngMiddleIndex = (((theCount / 2) - 1) + (theCount / 2)) / 2
2920:   Else
'      theMedian = anArray((theCount - 1) / 2)
2922:     lngMiddleIndex = (theCount - 1) / 2
2923:   End If
  
  '  PASS 2: MEDIAN, STANDARD DEVIATION AND VARIANCE --------------------------------------------------
2926:   For anIndex = LBound(anArray) To UBound(anArray)
        
2928:     psbar.StepProgressBar
    
2930:     theVal = anArray(anIndex)
2931:     theSize = dblSizeArray(anIndex)
2932:     theRunningCount = theRunningCount + theSize
2933:     If Not booFoundMedian Then
2934:       If theRunningCount >= lngMiddleIndex Then
2935:         theMedian = theVal
2936:         booFoundMedian = True
2937:       End If
2938:     End If
2939:     theSqDev = theSize * ((theVal - theMean) * (theVal - theMean))
2940:     theSumSqDev = theSqDev + theSumSqDev
    
2942:   Next anIndex
  
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  
2948:   If theCount > 0 Then
    
2950:     theVariance = theSumSqDev / (theCount - 1)
2951:     theStDev = Sqr(theVariance)
2952:     theStErrMean = theStDev / (Sqr(theCount))
    
2954:   Else
2955:     theMedian = -9999
2956:     theVariance = 0
2957:     theStDev = 0
2958:     theStErrMean = 0
2959:   End If

  Dim theRange As Double
2962:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  '(10) = MODE STRING
  '(11) = DOUBLE ARRAY OF MODE VALUES
  '(12) = BOOLEAN INDICATING WHETHER MODE WAS FOUND
  '(13) = ARRAY OF HISTOGRAM BIN COUNTS
  
2980:   pResponse.Add theSum
2981:   pResponse.Add theMean
2982:   pResponse.Add theMinimum
2983:   pResponse.Add theMaximum
2984:   pResponse.Add theRange
2985:   pResponse.Add theCount
2986:   pResponse.Add theStDev
2987:   pResponse.Add theVariance
2988:   pResponse.Add theMedian
2989:   pResponse.Add theStErrMean
2990:   pResponse.Add theModeString
2991:   pResponse.Add theFinalModes
2992:   pResponse.Add FoundMode
2993:   pResponse.Add lngHistCountArray  ' WILL BE EMPTY ARRAY IF NO HISTOGRAM WAS REQUESTED
  
2995:   psbar.HideProgressBar
2996:   Screen.MousePointer = vbDefault
  
2998:   Set BasicStatsFromVAT = pResponse


  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromVAT " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function BasicStatsFromArray_Weighted(anArray() As Double, theFieldName As String, theTableName As String, _
      m_App As Application) As esriSystem.IDoubleArray
  On Error GoTo ErrorHandler

  
  
  ' REQUIRES 2-DIMENSIONAL INPUT ARRAY, WHERE 1ST VALUE = VALUE AND SECOND VALUE = SIZE
  
  Dim pResponse As esriSystem.IDoubleArray
3015:   Set pResponse = New esriSystem.DoubleArray
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
3019:   Set psbar = m_App.StatusBar
  Dim pPro As IStepProgressor
3021:   Set pPro = psbar.ProgressBar
    
3023:   Screen.MousePointer = vbHourglass
  
3025:   psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
        2 * (UBound(anArray) - 1), 1, True
  
  Dim anIndex As Long
  Dim theVal As Double
  Dim theWeight As Double
  Dim theWeightedVal As Double
  
3033:   anIndex = 0
3034:   psbar.StepProgressBar
    
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
3041:   theCount = 0
  
  '  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
3044:   For anIndex = LBound(anArray) To UBound(anArray)
        
3046:     psbar.StepProgressBar
    
3048:     theVal = anArray(anIndex, 0)
3049:     theWeight = anArray(anIndex, 1)
    
3051:     theCount = theCount + theWeight
3052:     theWeightedVal = theVal * theWeight
3053:     theSum = theSum + theWeightedVal
    
3055:   Next anIndex
  
  Dim theMean As Double
3058:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
3061:   theSumSqDev = 0
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
3065:   For anIndex = LBound(anArray) To UBound(anArray)
        
3067:     psbar.StepProgressBar
    
3069:     theVal = anArray(anIndex, 0)
3070:     theWeight = anArray(anIndex, 1)
3071:     theSqDev = theWeight * ((theVal - theMean) * (theVal - theMean))
3072:     theSumSqDev = theSqDev + theSumSqDev
    
3074:   Next anIndex
  
  Dim theVariance As Double
  Dim theStDev As Double
  
3079:   theVariance = theSumSqDev / theCount
3080:   theStDev = Sqr(theVariance)
  
3082:   pResponse.Add theMean
3083:   pResponse.Add theStDev
3084:   pResponse.Add theVariance
  
3086:   psbar.HideProgressBar
    
3088:   Screen.MousePointer = vbDefault
  
3090:   Set BasicStatsFromArray_Weighted = pResponse


  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromArray_Weighted " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function BasicStatsFromArraySimple(anArray() As Double, Optional booVariance As Boolean = False) As esriSystem.IDoubleArray
  On Error GoTo ErrorHandler
  
  ' ASSUMES ARRAY IS SORTED!!!! --------------------------------------
  
  Dim pResponse As esriSystem.IDoubleArray
3104:   Set pResponse = New esriSystem.DoubleArray
  
  Dim anIndex As Long
  Dim theVal As Double

  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
3114:   theSum = 0
3115:   theCount = UBound(anArray) + 1         ' ARRAY INDEX STARTS AT 0
3116:   theMinimum = anArray(0)
3117:   theMaximum = anArray(0)
  
  '  PASS 1:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
3120:   For anIndex = LBound(anArray) To UBound(anArray)
    
3122:     theVal = anArray(anIndex)
    
3124:     If theVal < theMinimum Then
3125:       theMinimum = theVal
3126:     End If
3127:     If theVal > theMaximum Then
3128:       theMaximum = theVal
3129:     End If
3130:     theSum = theSum + theVal
    
3132:   Next anIndex
  
  Dim theMean As Double
3135:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
3141:   If booVariance Then
3142:     For anIndex = LBound(anArray) To UBound(anArray)
                
3144:       theVal = anArray(anIndex)
3145:       theSqDev = (theVal - theMean) * (theVal - theMean)
3146:       theSumSqDev = theSqDev + theSumSqDev
      
3148:     Next anIndex
3149:   Else
3150:     theSqDev = 0
3151:     theSumSqDev = 0
3152:   End If
  
  Dim theMedian As Double
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  
3159:   If theCount > 1 Then
3160:     If theCount Mod 2 = 0 Then      ' EVEN NUMBER
3161:       theMedian = (anArray((theCount / 2) - 1) + anArray(theCount / 2)) / 2
3162:     Else
3163:       theMedian = anArray((theCount - 1) / 2)
3164:     End If
    
3166:     theVariance = theSumSqDev / (theCount - 1)
3167:     theStDev = Sqr(theVariance)
3168:     theStErrMean = theStDev / (Sqr(theCount))
    
3170:   Else
3171:     theMedian = -9999
3172:     theVariance = 0
3173:     theStDev = 0
3174:     theStErrMean = 0
3175:   End If

  Dim theRange As Double
3178:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  
3192:   pResponse.Add theSum
3193:   pResponse.Add theMean
3194:   pResponse.Add theMinimum
3195:   pResponse.Add theMaximum
3196:   pResponse.Add theRange
3197:   pResponse.Add theCount
3198:   pResponse.Add theStDev
3199:   pResponse.Add theVariance
3200:   pResponse.Add theMedian
3201:   pResponse.Add theStErrMean
  
3203:   Set BasicStatsFromArraySimple = pResponse

  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromArraySimple " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function BasicStatsFromArray(anArray() As Double, theFieldName As String, theTableName As String, _
      m_App As Application, Optional lngNumberHistBins As Long = -9999) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  
  
  ' ASSUMES ARRAY IS SORTED!!!! --------------------------------------
  
  Dim pResponse As esriSystem.IVariantArray
3219:   Set pResponse = New esriSystem.VarArray
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
3223:   Set psbar = m_App.StatusBar
  Dim pPro As IStepProgressor
3225:   Set pPro = psbar.ProgressBar
  
  ' IF MAKING A HISTOGRAM
  Dim booMakeHistogram As Boolean
3229:   booMakeHistogram = (lngNumberHistBins > 0)
  Dim lngHistCountArray() As Long            ' WILL CONTAIN COUNTS OF VALUES LYING IN EACH HISTOGRAM BIN
3231:   If booMakeHistogram Then
    Dim dblHistLow As Double
    Dim dblHistHigh As Double
3234:     dblHistLow = anArray(0)
3235:     dblHistHigh = anArray(UBound(anArray))
    Dim dblInterval As Double
3237:     dblInterval = (dblHistHigh - dblHistLow) / lngNumberHistBins
    
    ReDim lngHistCountArray(lngNumberHistBins)
    Dim lngHistBinIndex As Long
3241:     lngHistBinIndex = 0
    Dim dblCurrentBinThreshold As Double
3243:     dblCurrentBinThreshold = dblHistLow + dblInterval
3244:   End If
  
3246:   Screen.MousePointer = vbHourglass
  
3248:   If booMakeHistogram Then
3249:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          4 * (UBound(anArray) - 1), 1, True
3251:   Else
3252:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          3 * (UBound(anArray) - 1), 1, True
3254:   End If
  
  Dim FoundMode As Boolean
3257:   FoundMode = False
  
  Dim theModeValList() As Double
  ReDim theModeValList(1, UBound(anArray))
  
  Dim theHighModeCount As Long
3263:   theHighModeCount = 0
  
  Dim anIndex As Long
  Dim theVal As Double
  Dim theModeCounter As Long
  Dim theModeIndex As Long
3269:   theModeIndex = -1
  
3271:   anIndex = 0
3272:   psbar.StepProgressBar
  
  ' IF MAKING HISTOGRAM
3275:   If booMakeHistogram Then
3276:     Do While anIndex <= UBound(anArray)
3277:       theVal = anArray(anIndex)
3278:       If theVal <= dblCurrentBinThreshold Then
3279:         lngHistCountArray(lngHistBinIndex) = lngHistCountArray(lngHistBinIndex) + 1
3280:       Else
3281:         Do While dblCurrentBinThreshold < theVal
3282:           dblCurrentBinThreshold = dblCurrentBinThreshold + dblInterval
3283:           lngHistBinIndex = lngHistBinIndex + 1
3284:         Loop
3285:         lngHistCountArray(lngHistBinIndex) = 1
3286:       End If
3287:       anIndex = anIndex + 1
3288:       psbar.StepProgressBar
3289:     Loop
3290:   End If
  
  '  PASS 1:  MODE --------------------------------------------------
3293:   anIndex = 0
  
3295:   Do While anIndex < UBound(anArray)
    
3297:     theModeCounter = 1
3298:     theVal = anArray(anIndex)
    
3300:     Do While (anIndex < UBound(anArray))
3301:       If Not (anArray(anIndex + 1) = theVal) Then
3302:         Exit Do
3303:       End If
3304:       anIndex = anIndex + 1
3305:       psbar.StepProgressBar
3306:       theModeCounter = theModeCounter + 1
3307:     Loop
    
3309:     If theModeCounter > 1 Then
3310:       FoundMode = True
3311:       theModeIndex = theModeIndex + 1
3312:       theModeValList(0, theModeIndex) = theModeCounter
3313:       theModeValList(1, theModeIndex) = theVal
      
'      Debug.Print "Value = " & theModeValList(1, theModeIndex) & "[" & theModeValList(0, theModeIndex) & " cases]"
      
3317:     End If
    
3319:     anIndex = anIndex + 1
3320:     psbar.StepProgressBar
3321:   Loop
  
  Dim theModeString As String
  
  ' IF ANY VALUE OCCURED > 1 TIME
  Dim theFinalModes() As Double
3327:   If FoundMode Then
    ReDim Preserve theModeValList(1, theModeIndex)
    
    Dim theFinalModeCount As Long
3331:     theFinalModeCount = 0
    Dim theTempCount As Long
3333:     theTempCount = 0
        
    Dim theFinalModeIndex As Long
        
3337:     For anIndex = 0 To theModeIndex
3338:       theTempCount = theModeValList(0, anIndex)
3339:       If theTempCount > theFinalModeCount Then
3340:         theFinalModeCount = theTempCount
        ReDim theFinalModes(0)
3342:         theFinalModes(0) = theModeValList(1, anIndex)
3343:       ElseIf theTempCount = theFinalModeCount Then
3344:         theFinalModeIndex = UBound(theFinalModes) + 1
        ReDim Preserve theFinalModes(theFinalModeIndex)
3346:         theFinalModes(theFinalModeIndex) = theModeValList(1, anIndex)
3347:       End If
3348:     Next anIndex
    
3350:     If UBound(theFinalModes) > 0 Then
3351:       theModeString = UBound(theFinalModes) + 1 & " modes found [" & aml_func_mod.InsertCommas(theFinalModeCount) & " cases each]: Values = "
3352:       For anIndex = 0 To UBound(theFinalModes)
3353:         theModeString = theModeString & theFinalModes(anIndex) & ", "
3354:       Next anIndex
      
3356:       theModeString = aml_func_mod.BasicTrimAvenue(theModeString, "", ", ")
      
3358:     Else
3359:       theModeString = "1 mode found [" & aml_func_mod.InsertCommas(theFinalModeCount) & " cases]: Value = " & theFinalModes(0)
3360:     End If
    
3362:   Else
3363:     theModeString = " < No Mode Found >"
3364:   End If
  
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
3371:   theSum = 0
3372:   theCount = UBound(anArray) + 1         ' ARRAY INDEX STARTS AT 0
3373:   theMinimum = anArray(0)
3374:   theMaximum = anArray(0)
  
  '  PASS 2:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
3377:   For anIndex = LBound(anArray) To UBound(anArray)
        
3379:     psbar.StepProgressBar
    
3381:     theVal = anArray(anIndex)
    
3383:     If theVal < theMinimum Then
3384:       theMinimum = theVal
3385:     End If
3386:     If theVal > theMaximum Then
3387:       theMaximum = theVal
3388:     End If
3389:     theSum = theSum + theVal
    
3391:   Next anIndex
  
  Dim theMean As Double
3394:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
3400:   For anIndex = LBound(anArray) To UBound(anArray)
        
3402:     psbar.StepProgressBar
    
3404:     theVal = anArray(anIndex)
3405:     theSqDev = (theVal - theMean) * (theVal - theMean)
3406:     theSumSqDev = theSqDev + theSumSqDev
    
3408:   Next anIndex
  
  Dim theMedian As Double
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  
3415:   If theCount > 1 Then
3416:     If theCount Mod 2 = 0 Then      ' EVEN NUMBER
3417:       theMedian = (anArray((theCount / 2) - 1) + anArray(theCount / 2)) / 2
3418:     Else
3419:       theMedian = anArray((theCount - 1) / 2)
3420:     End If
    
3422:     theVariance = theSumSqDev / (theCount - 1)
3423:     theStDev = Sqr(theVariance)
3424:     theStErrMean = theStDev / (Sqr(theCount))
    
3426:   Else
3427:     theMedian = -9999
3428:     theVariance = 0
3429:     theStDev = 0
3430:     theStErrMean = 0
3431:   End If

  Dim theRange As Double
3434:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  '(10) = MODE STRING
  '(11) = DOUBLE ARRAY OF MODE VALUES
  '(12) = BOOLEAN INDICATING WHETHER MODE WAS FOUND
  '(13) = ARRAY OF HISTOGRAM BIN COUNTS
  
3452:   pResponse.Add theSum
3453:   pResponse.Add theMean
3454:   pResponse.Add theMinimum
3455:   pResponse.Add theMaximum
3456:   pResponse.Add theRange
3457:   pResponse.Add theCount
3458:   pResponse.Add theStDev
3459:   pResponse.Add theVariance
3460:   pResponse.Add theMedian
3461:   pResponse.Add theStErrMean
3462:   pResponse.Add theModeString
3463:   pResponse.Add theFinalModes
3464:   pResponse.Add FoundMode
3465:   pResponse.Add lngHistCountArray  ' WILL BE EMPTY ARRAY IF NO HISTOGRAM WAS REQUESTED
  
3467:   psbar.HideProgressBar
3468:   Screen.MousePointer = vbDefault
  
3470:   Set BasicStatsFromArray = pResponse


  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CalcStatistics(dblSortedNumbers() As Double, pStatOptions As esriSystem.IVariantArray, _
      Optional booReportProgress As Boolean, Optional pApp As IApplication) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


  ' FAO_WRD.Stat_CalcFieldStats
'
'Dim chkMean As Boolean
'Set chkMean = pStatOptions.Element(0)
'Dim chkSEMean As Boolean
'Set chkSEMean = pStatOptions.Element(1)
'Dim chkCIMean As Boolean
'Set chkCIMean = pStatOptions.Element(2)
'Dim ConLevel As Double
'Set ConLevel = pStatOptions.Element(3)
'Dim chkMinimum As Boolean
'Set chkMinimum = pStatOptions.Element(4)
'Dim chkQ1 As Boolean
'Set chkQ1 = pStatOptions.Element(5)
'Dim chkMedian As Boolean
'Set chkMedian = pStatOptions.Element(6)
'Dim chkQ3 As Boolean
'Set chkQ3 = pStatOptions.Element.Item(7)
'Dim chkMaximum As Boolean
'Set chkMaximum = pStatOptions.Element(8)
'Dim chkVariance As Boolean
'Set chkVariance = pStatOptions.Element(9)
'Dim chkStDev As Boolean
'Set chkStDev = pStatOptions.Element(10)
'Dim chkAvgDev As Boolean
'Set chkAvgDev = pStatOptions.Element(11)
'Dim chkSkewness As Boolean
'Set chkSkewness = pStatOptions.Element(12)
'Dim chkSkewnessFish As Boolean
'Set chkSkewnessFish = pStatOptions.Element(13)
'Dim chkKurtosis As Boolean
'Set chkKurtosis = pStatOptions.Element(14)
'Dim chkKurtosisFish As Boolean
'Set chkKurtosisFish = pStatOptions.Element(15)
'Dim chkCount As Boolean
'Set chkCount = pStatOptions.Element(16)
'Dim chkNumberNull As Boolean
'Set chkNumberNull = pStatOptions.Element(17)
'Dim chkSum As Boolean
'Set chkSum = pStatOptions.Element(18)
'Dim chkRange As Boolean
'Set chkRange = pStatOptions.Element(19)
'Dim chkMode As Boolean
'Set chkMode = pStatOptions.Element(20)
'
'' MakeHistogram = theResults.Get(21)
'
'Dim pResponse As esriSystem.IVariantArray
'Dim anIndex As Long
'For anIndex = 0 To 20
'  pResponse.Add Nothing
'Next anIndex
'
''' UNFORTUNATELY, THE HISTOGRAM FUNCTION WAS WRITTEN SEPARATELY AND THE STATS ARE IN A DIFFERENT ORDER
''theResponse = {nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil}
''theStatsForHistogramScript = {nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil}
''
''If (MakeHistogram) Then
''  chkMean = True
''  chkStDev = True
''  chkCount = True
''  chkMinimum = True
''  chkMaximum = True
''  theResults.Set(0,True)
''  theResults.Set(4,True)
''  theResults.Set(8,True)
''  theResults.Set(10,True)
''  theResults.Set(16,True)
''End
'
''' HELP IT RUN FASTER IF ONLY A FEW OPTIONS ARE CHECKED
'Dim DoQuantiles As Boolean
'Dim DoSkewKurt As Boolean
'Dim MoreThanBasic As Boolean
'Dim lngMultiplier As Long
'lngMultiplier = 1   ' FOR BASIC STATS
'
'' DIMENSION STATISTIC VARIABLES
'Dim theMean As Double
'Dim theSEMean As Double
'Dim LowerCI As Double
'Dim UpperCI As Double
'Dim theMinimum As Double
'Dim theQ1 As Double
'Dim theMedian As Double
'Dim theQ3 As Double
'Dim theMaximum As Double
'Dim theVar As Double
'Dim theStdDev As Double
'Dim theAvgDev As Double
'Dim theSkew As Double
'Dim theFisherSkew As Double
'Dim theKurt As Double
'Dim theFisherKurt As Double
'Dim theCount As Double
'Dim theNumberNull As Double
'Dim theSum As Double
'Dim theRange As Double
'Dim theModeString As String
'
'' BASIC STATS ARE Count, Minimum, Maximum, Mean, Sum
'DoQuantiles = (chkQ1 Or chkMedian Or chkQ3)
'DoSkewKurt = (chkSkewness Or chkSkewnessFish Or chkKurtosis Or chkKurtosisFish)
''MoreThanBasic = (DoQuantiles Or DoSkewKurt Or chkSEMean Or chkCIMean Or chkVariance Or chkStDev Or chkAvgDev Or MakeHistogram)
'MoreThanBasic = (DoQuantiles Or DoSkewKurt Or chkSEMean Or chkCIMean Or chkVariance Or chkStDev Or chkAvgDev)
'
'If chkVariance Or chkStDev Or chkAvgDev Then lngMultiplier = lngMultiplier + 1
'
'If DoQuantiles Then lngMultiplier = lngMultiplier + 1
'If DoSkewKurt Then lngMultiplier = lngMultiplier + 1
'If MoreThanBasic Then lngMultiplier = lngMultiplier + 1
'If chkMode Then lngMultiplier = lngMultiplier + 1
'
'If booReportProgress Then
'    ' PROGRESS BAR STUFF
'  Dim psbar As IStatusBar
'  Set psbar = pApp.StatusBar
'  Dim pPro As IStepProgressor
'  Set pPro = psbar.ProgressBar
'
'  Screen.MousePointer = vbHourglass
'
'  psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
'        lngMultiplier * (UBound(dblSortedNumbers) - 1), 1, True
'End If
'
'Dim theCount As Long
'theCount = UBound(dblSortedNumbers) - 1
'
'If chkMode Then  ' ASSUMES NUMBER ARRAY IS SORTED!
'
'  Dim pFoundMode As Boolean
'  Dim theModeValList() As Double
'  ReDim theModeValList(1, UBound(dblSortedNumbers))
'
'  Dim theHighModeCount As Long
'  theHighModeCount = 0
'
'  Dim theVal As Double
'  Dim theModeCounter As Long
'  Dim theModeIndex As Long
'  theModeIndex = -1
'
'  anIndex = 0
'
'  Do While anIndex < UBound(dblSortedNumbers)
'
'    theModeCounter = 1
'    theVal = dblSortedNumbers(anIndex)
'
'    Do While (anIndex < UBound(dblSortedNumbers))
'      If Not (dblSortedNumbers(anIndex + 1) = theVal) Then
'        Exit Do
'      End If
'      anIndex = anIndex + 1
'      If booReportProgress Then psbar.StepProgressBar
'      theModeCounter = theModeCounter + 1
'    Loop
'
'    If theModeCounter > 1 Then
'      FoundMode = True
'      theModeIndex = theModeIndex + 1
'      theModeValList(0, theModeIndex) = theModeCounter
'      theModeValList(1, theModeIndex) = theVal
'
''      Debug.Print "Value = " & theModeValList(1, theModeIndex) & "[" & theModeValList(0, theModeIndex) & " cases]"
'
'    End If
'
'    anIndex = anIndex + 1
'    If booReportProgress Then psbar.StepProgressBar
'  Loop
'
'  Dim theModeString As String
'
'  ' IF ANY VALUE OCCURED > 1 TIME
'  If FoundMode Then
'    ReDim Preserve theModeValList(1, theModeIndex)
'    Dim theFinalModes() As Double
'    Dim theFinalModeCount As Long
'    theFinalModeCount = 0
'    Dim theTempCount As Long
'    theTempCount = 0
'
'    Dim theFinalModeIndex As Long
'
'    For anIndex = 0 To theModeIndex
'      theTempCount = theModeValList(0, anIndex)
'      If theTempCount > theFinalModeCount Then
'        theFinalModeCount = theTempCount
'        ReDim theFinalModes(0)
'        theFinalModes(0) = theModeValList(1, anIndex)
'      ElseIf theTempCount = theFinalModeCount Then
'        theFinalModeIndex = UBound(theFinalModes) + 1
'        ReDim Preserve theFinalModes(theFinalModeIndex)
'        theFinalModes(theFinalModeIndex) = theModeValList(1, anIndex)
'      End If
'    Next anIndex
'
'    If UBound(theFinalModes) > 0 Then
'      theModeString = UBound(theFinalModes) + 1 & " modes found [" & aml_func_mod.InsertCommas(theFinalModeCount) & " cases each]: Values = "
'      For anIndex = 0 To UBound(theFinalModes)
'        theModeString = theModeString & theFinalModes(anIndex) & ", "
'      Next anIndex
'
'      theModeString = aml_func_mod.BasicTrimAvenue(theModeString, "", ", ")
'
'    Else
'      theModeString = "1 mode found [" & aml_func_mod.InsertCommas(theFinalModeCount) & " cases]: Value = " & theFinalModes(0)
'    End If
'
'  Else
'    theModeString = " < No Mode Found >"
'  End If
'End If
'
'theSum = 0
'theCount = UBound(dblSortedNumbers) + 1         ' ARRAY INDEX STARTS AT 0
'theMinimum = dblSortedNumbers(0)
'theMaximum = dblSortedNumbers(0)
'
''  PASS 2:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
'For anIndex = LBound(dblSortedNumbers) To UBound(dblSortedNumbers)
'
'  If booReportProgress Then psbar.StepProgressBar
'
'  theVal = dblSortedNumbers(anIndex)
'
'  If theVal < theMinimum Then
'    theMinimum = theVal
'  End If
'  If theVal > theMaximum Then
'    theMaximum = theVal
'  End If
'  theSum = theSum + theVal
'
'Next anIndex
'
'Dim theMean As Double
'theMean = theSum / theCount
'
'Dim theSumSqDev As Double
'Dim theSqDev As Double
'
''  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
'For anIndex = LBound(dblSortedNumbers) To UBound(dblSortedNumbers)
'
'  If booReportProgress Then psbar.StepProgressBar
'
'  theVal = dblSortedNumbers(anIndex)
'  theSqDev = (theVal - theMean) * (theVal - theMean)
'  theSumSqDev = theSqDev + theSumSqDev
'
'Next anIndex
'
'Dim theMedian As Double
'Dim theVariance As Double
'Dim theStDev As Double
'Dim theStErrMean As Double
'
'If theCount > 1 Then
'  If theCount Mod 2 = 0 Then      ' EVEN NUMBER
'    theMedian = (dblSortedNumbers((theCount / 2) - 1) + dblSortedNumbers(theCount / 2)) / 2
'  Else
'    theMedian = dblSortedNumbers((theCount - 1) / 2)
'  End If
'
'  theVariance = theSumSqDev / (theCount - 1)
'  theStDev = Sqr(theVariance)
'  theStErrMean = theStDev / (Sqr(theCount))
'
'Else
'  theMedian = -9999
'  theVariance = 0
'  theStDev = 0
'  theStErrMean = 0
'End If
'
'Dim theRange As Double
'theRange = theMaximum - theMinimum
'
'' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
''(0) = SUM
''(1) = MEAN
''(2) = MINIMUM
''(3) = MAXIMUM
''(4) = RANGE
''(5) = COUNT
''(6) = STANDARD DEVIATION
''(7) = VARIANCE
''(8) = MEDIAN
''(9) = STANDARD ERROR OF MEAN
''(10) = MODE STRING
'
'theStatsArray(0) = theSum
'theStatsArray(1) = theMean
'theStatsArray(2) = theMinimum
'theStatsArray(3) = theMaximum
'theStatsArray(4) = theRange
'theStatsArray(5) = theCount
'theStatsArray(6) = theStDev
'theStatsArray(7) = theVariance
'theStatsArray(8) = theMedian
'theStatsArray(9) = theStErrMean
'theStatsArray(10) = theModeString
'
''If (chkMode) Then
''  FoundMode = False
''  theModeValList = {}
''  theHighModeCount = 0
''  theDictionaryOfValues = Dictionary.Make(theCount)
''End
''
''theList = {}
''theNumberNull = 0
''theSum = 0
''theCounter = 0
''av.ClearStatus
''
''av.ShowMsg ("Calculating Pass 1")
''For Each aRecord In theSelection
''  theCounter = theCounter + 1
''  av.SetStatus ((theCounter / theCount) * 100)
''  theX = theVTab.ReturnValue(theField, aRecord)
''  If (theX.IsNull) Then
''    theNumberNull = theNumberNull + 1
''  Else
''    theList.Add (theX)
''    theSum = theSum + theX
''
''    ' CALCULATE MODE
''    If (chkMode) Then
''      theModeCount = theDictionaryOfValues.Get(theX)
''      If (theModeCount = nil) Then
''        theModeCount = 1
''      Else
''        theModeCount = theModeCount + 1
''        FoundMode = True
''      End
''      theDictionaryOfValues.Set(theX, theModeCount)
''
''      If (theModeCount > theHighModeCount) Then
''        theModeValList = {theX}
''        theHighModeCount = theModeCount
''      ElseIf (theModeCount = theHighModeCount) Then
''        theModeValList.Add (theX)
''      End
''    End
''  End
''End
''av.ClearStatus
''
''If (theList.Count = 0) Then
''  msgBox.Info("No data available to calculate!  Bailing out...", "")
''  return nil
''End
''
''If (chkMode) Then
''  If (FoundMode) Then
''    theModeValList.RemoveDuplicates
''    theModeValList.Sort (True)
''    theModeString = ""
''    For Each aModeVal In theModeValList
''      theModeString = theModeString + aModeVal.AsString + ", "
''    End
''    theModeString = theModeString.Left(theModeString.Count - 2)
''  Else
''    theModeString = " < No Mode Found >"
''  End
''End
''
''theTotalCount = theCount - theNumberNull
''
''theMean = theSum / theTotalCount
''
''If (MoreThanBasic) Then
''  av.ShowMsg ("Second Pass")
''  theCounter = 0
''
''  theAvgDev = 0
''  theMoment2 = 0
''  theMoment3 = 0
''  theMoment4 = 0
''  For Each anX In theList
''    theCounter = theCounter + 1
''    av.SetStatus ((theCounter / theTotalCount) * 100)
''    theDev = anX - theMean
''    theAvgDev = theAvgDev + (theDev.Abs)
''    theMoment2 = theMoment2 + (theDev ^ 2)
''    If (DoSkewKurt) Then
''      theMoment3 = theMoment3 + (theDev ^ 3)
''      theMoment4 = theMoment4 + (theDev ^ 4)
''    End
''  End
''  av.ClearStatus
''
''  ' MEAN, STANDARD DEVIATION, SKEWNESS, KURTOSIS --------------------------------
''  theVar = theMoment2 / (theTotalCount - 1)
''  theStdDev = theVar.Sqrt
''  theAvgDev = theAvgDev / theTotalCount
''
''  theMoment2 = theMoment2 / theTotalCount
''
''  If (DoSkewKurt) Then
''    theMoment3 = theMoment3 / theTotalCount
''    theMoment4 = theMoment4 / theTotalCount
''
''    theSkew = theMoment3 / (theMoment2 ^ (3 / 2))
''    theFisherSkew  = (theSkew*((theTotalCount*(theTotalCount-1)).sqrt))/(theTotalCount-2)
''
''    theKurt = theMoment4 / (theMoment2 ^ 2)
''    theFisherKurt = ((theTotalCount + 1) * (theTotalCount - 1)) / ((theTotalCount - 2) * (theTotalCount - 3))
''    theFisherKurt = theFisherKurt * (theKurt - (3 * (theTotalCount - 1) / (theTotalCount + 1)))
''
''    If (theVar <> 0) Then
''      theSkew = theMoment3 / (theMoment2 ^ (3 / 2))
''      theFisherSkew  = (theSkew*((theTotalCount*(theTotalCount-1)).sqrt))/(theTotalCount-2)
''
''      theKurt = theMoment4 / (theMoment2 ^ 2)
''      theFisherKurt = ((theTotalCount + 1) * (theTotalCount - 1)) / ((theTotalCount - 2) * (theTotalCount - 3))
''      theFisherKurt = theFisherKurt * (theKurt - (3 * (theTotalCount - 1) / (theTotalCount + 1)))
''    Else
''      theSkew = Number.MakeNull
''      theKurt = Number.MakeNull
''    End
''  End
''
''  ' STANDARD ERROR OF MEAN, CONFIDENCE INTERVALS
''  theSEMean = theStdDev / (theTotalCount.Sqrt)
''  If (chkCIMean) Then
''    theAlphaOver2 = 1 - ((1 - ConLevel) / 2)
''    theT = av.Run("FAO_WRD.Stat_IDF_StudentsT", {theAlphaOver2, (theTotalCount-1)})
''    theFactor = theSEMean * theT
''    LowerCI = theMean - theFactor
''    UpperCI = theMean + theFactor
''  End
''
''  ' QUANTILE DATA -----------------------------------------------------------------
''  If (DoQuantiles) Then
''
''    av.ShowMsg ("Calculating Quantile Data...")
''
''    theList.Sort (True)
''    theMinimum = theList.Get(0)
''    theMaximum = theList.Get(theList.Count - 1)
''    theRange = theMaximum - theMinimum
''
''    theListCount = theList.Count
''    theQ1Index = (theListCount + 1) * 0.25
''    theQ2Index = (theListCount + 1) * 0.5
''    theQ3Index = (theListCount + 1) * 0.75
''
''    If (theQ1Index.Round = theQ1Index) Then
''      theQ1 = theList.Get(theQ1Index - 1)
''    Else
''      theFloor = theList.Get((theQ1Index-1).Floor.Max(0))    ' POSSIBLE THAT IT COULD TRY TO GET INDEX -1, SO MAX IT WITH 0
''      theCeiling = theList.Get((theQ1Index-1).Ceiling)
''      theQ1 = (theFloor + theCeiling) / 2
''    End
''
''    If (theQ2Index.Round = theQ2Index) Then
''      theMedian = theList.Get(theQ2Index - 1)
''    Else
''      theFloor = theList.Get((theQ2Index-1).Floor)
''      theCeiling = theList.Get((theQ2Index-1).Ceiling)
''      theMedian = (theFloor + theCeiling) / 2
''    End
''
''    If (theQ3Index.Round = theQ3Index) Then
''      theQ3 = theList.Get(theQ3Index - 1)
''    Else
''      theFloor = theList.Get((theQ3Index-1).Floor)
''      theCeiling = theList.Get((theQ3Index-1).Ceiling.Min(theListCount-1))  ' POSSIBLE THAT IT COULD TRY TO GET INDEX (COUNT+1), SO MIN IT WITH COUNT
''
''      theQ3 = (theFloor + theCeiling) / 2
''    End
''  End
''End   ' END MORE THAN BASIC
''
'
'
'
'If booReportProgress Then
'  psbar.HideProgressBar
'  Screen.MousePointer = vbDefault
'End If
'
'If chkMean Then pResponse.Element(0) = theMean
'If chkSEMean Then pResponse.Element(1) = theSEMean
'If chkCIMean Then pResponse.Element(2) = LowerCI
'If chkCIMean Then pResponse.Element(3) = UpperCI
'If chkMinimum Then pResponse.Element(4) = theMinimum
'If chkQ1 Then pResponse.Element(5) = theQ1
'If chkMedian Then pResponse.Element(6) = theMedian
'If chkQ3 Then pResponse.Element(7) = theQ3
'If chkMaximum Then pResponse.Element(8) = theMaximum
'If chkVariance Then pResponse.Element(9) = theVar
'If chkStDev Then pResponse.Element(10) = theStdDev
'If chkAvgDev Then pResponse.Element(11) = theAvgDev
'If chkSkewness Then pResponse.Element(12) = theSkew
'If chkSkewnessFish Then pResponse.Element(13) = theFisherSkew
'If chkKurtosis Then pResponse.Element(14) = theKurt
'If chkKurtosisFish Then pResponse.Element(15) = theFisherKurt
'If chkCount Then pResponse.Element(16) = theCount
'If chkNumberNull Then pResponse.Element(17) = theNumberNull
'If chkSum Then pResponse.Element(18) = theSum
'If chkRange Then pResponse.Element(19) = theRange
'If chkMode Then pResponse.Element(20) = theModeString
'
'
'


  Exit Function
ErrorHandler:
  HandleError True, "CalcStatistics " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function Graphic_ReturnElementFromGeometry(ByRef pMxDoc As IMxDocument, ByRef pGeometry As IGeometry, _
    Optional strName As String, Optional AddToView As Boolean) As IElement
  On Error GoTo ErrorHandler

  
  Dim pMxDocument As esriArcMapUI.IMxDocument
  Dim pActiveView As esriCarto.IActiveView
  
  Dim pGContainer As IGraphicsContainer
4011:   Set pGContainer = pMxDoc.FocusMap
  
  Dim pElement As IElement
  Dim pPolygonElement As IPolygonElement
  Dim pSpatialReference As ISpatialReference
  Dim pGraphicElement As IGraphicElement
  Dim pElementProperties As IElementProperties
  
  Dim pClone As IClone
4020:   Set pClone = pGeometry
  Dim pNewGeometry As IGeometry
4022:   Set pNewGeometry = pClone.Clone
  
  Dim pGeometryType As esriGeometryType
4025:   pGeometryType = pNewGeometry.GeometryType
  
  'ADD GEOMETRY, NAME AND SPATIAL REFERENCE TO GRAPHIC ELEMENT
  Select Case pGeometryType
    Case 0:
4030:       MsgBox "Null Geometry!  No graphic added..."
    Case 1, 2:
4032:       Set pElement = New MarkerElement
    Case 3, 6, 13, 14, 15, 16:
4034:       Set pElement = New LineElement
    Case 4, 11:
4036:       Set pElement = New PolygonElement
    Case 5:
4038:       Set pElement = New RectangleElement
    Case Else:
4040:       MsgBox "Unexpected Shape Type:  Unable to add graphic..."
      Exit Function
4042:   End Select
  
  
4045:   If pGeometryType = 2 Then
    Dim pGroupElement As IGroupElement2
4047:     Set pGroupElement = New GroupElement
    Dim pSubElement As IElement
4049:     Set pSubElement = New MarkerElement
    Dim lngIndex As Long
    Dim pPtColl As IPointCollection
4052:     Set pPtColl = pNewGeometry
    Dim pPt As IPoint
4054:     For lngIndex = 0 To pPtColl.PointCount - 1
4055:       Set pPt = pPtColl.Point(lngIndex)
4056:       Set pSubElement = New MarkerElement
4057:       pSubElement.Geometry = pPt
4058:       pGroupElement.AddElement pSubElement
4059:     Next lngIndex
4060:     Set pGraphicElement = pGroupElement
4061:     Set pSpatialReference = pGeometry.SpatialReference
4062:     Set pGraphicElement.SpatialReference = pSpatialReference
4063:     Set pElementProperties = pGroupElement
4064:     pElementProperties.Name = strName
4065:     If AddToView Then
      ' ADD GRAPHIC TO GRAPHICS CONTAINER
4067:       pGContainer.AddElement pGroupElement, 0
      'Draw
4069:       pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, Nothing
4070:     End If

4072:   Else
4073:     pElement.Geometry = pNewGeometry
4074:     Set pGraphicElement = pElement
4075:     Set pSpatialReference = pGeometry.SpatialReference
4076:     Set pGraphicElement.SpatialReference = pSpatialReference
4077:     Set pElementProperties = pElement
4078:     pElementProperties.Name = strName
  
4080:     If AddToView Then
      ' ADD GRAPHIC TO GRAPHICS CONTAINER
4082:       pGContainer.AddElement pElement, 0
      'Draw
4084:       pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, Nothing
4085:     End If

4087:   End If
  
  
4090:   Set Graphic_ReturnElementFromGeometry = pElement


  Exit Function
ErrorHandler:
  HandleError True, "Graphic_ReturnElementFromGeometry " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Sub Graphic_MakeFromGeometry(ByRef pMxDoc As IMxDocument, ByRef pGeometry As IGeometry, Optional strName As String)
  On Error GoTo ErrorHandler

  
  Dim pMxDocument As esriArcMapUI.IMxDocument
  Dim pActiveView As esriCarto.IActiveView
  
  Dim pGContainer As IGraphicsContainer
4105:   Set pGContainer = pMxDoc.FocusMap
  
  Dim pElement As IElement
  Dim pPolygonElement As IPolygonElement
  Dim pSpatialReference As ISpatialReference
  Dim pGraphicElement As IGraphicElement
  Dim pElementProperties As IElementProperties
  
  Dim pClone As IClone
4114:   Set pClone = pGeometry
  Dim pNewGeometry As IGeometry
4116:   Set pNewGeometry = pClone.Clone
  
  Dim pGeometryType As esriGeometryType
4119:   pGeometryType = pNewGeometry.GeometryType
  
  'ADD GEOMETRY, NAME AND SPATIAL REFERENCE TO GRAPHIC ELEMENT
  Select Case pGeometryType
    Case 0:
4124:       MsgBox "Null Geometry!  No graphic added..."
    Case 1:
4126:       Set pElement = New MarkerElement
    Case 2:
4128:       Set pElement = New GroupElement
    Case 3, 6, 13, 14, 15, 16:
4130:       Set pElement = New LineElement
    Case 4, 11:
4132:       Set pElement = New PolygonElement
    Case 5:
4134:       Set pElement = New RectangleElement
    Case Else:
4136:       MsgBox "Unexpected Shape Type:  Unable to add graphic..."
4137:   End Select
  
4139:   If pGeometryType = 2 Then
    Dim pGroupElement As IGroupElement2
4141:     Set pGroupElement = New GroupElement
    Dim pSubElement As IElement
4143:     Set pSubElement = New MarkerElement
    Dim lngIndex As Long
    Dim pPtColl As IPointCollection
4146:     Set pPtColl = pNewGeometry
    Dim pPt As IPoint
4148:     For lngIndex = 0 To pPtColl.PointCount - 1
4149:       Set pPt = pPtColl.Point(lngIndex)
4150:       Set pSubElement = New MarkerElement
4151:       pSubElement.Geometry = pPt
4152:       pGroupElement.AddElement pSubElement
4153:     Next lngIndex
4154:     Set pGraphicElement = pGroupElement
4155:     Set pSpatialReference = pGeometry.SpatialReference
4156:     Set pGraphicElement.SpatialReference = pSpatialReference
4157:     Set pElementProperties = pGroupElement
4158:     pElementProperties.Name = strName
    ' ADD GRAPHIC TO GRAPHICS CONTAINER
4160:     pGContainer.AddElement pGroupElement, 0
4161:   Else
4162:     pElement.Geometry = pNewGeometry
4163:     Set pGraphicElement = pElement
4164:     Set pSpatialReference = pGeometry.SpatialReference
4165:     Set pGraphicElement.SpatialReference = pSpatialReference
4166:     Set pElementProperties = pElement
4167:     pElementProperties.Name = strName
  
    ' ADD GRAPHIC TO GRAPHICS CONTAINER
4170:     pGContainer.AddElement pElement, 0
4171:   End If

  'Draw
4174:   pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, Nothing


  Exit Sub
ErrorHandler:
  HandleError True, "Graphic_MakeFromGeometry " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub OpenDoc(theDocFilename As String, theDocPath As String)
  On Error GoTo ErrorHandler


    ' CHECK IF FILE EXISTS
    Dim booFileExists As Boolean
    Dim theCheckFilename As String
4188:     If Right(theDocPath, 1) = "\" Or Right(theDocPath, 1) = "/" Then
4189:       theCheckFilename = theDocPath & theDocFilename
4190:     Else
4191:       theCheckFilename = theDocPath & "\" & theDocFilename
4192:     End If
    
4194:     booFileExists = Dir(theCheckFilename) <> ""
    
4196:     If booFileExists Then
4197:       Call ShellExecute(0, vbNullString, theDocFilename, vbNullString, theDocPath, 1)
4198:     Else
4199:       MsgBox "Unable to find the following file:" & vbCrLf & vbCrLf & theCheckFilename & vbCrLf & _
            vbCrLf & "Bailing out...", , "Missing File:"
4201:     End If


  Exit Sub
ErrorHandler:
  HandleError True, "OpenDoc " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function MakeColorRGB(pRed As Integer, pGreen As Integer, pBlue As Integer) As IColor
  On Error GoTo ErrorHandler


  Dim pColor As IRgbColor
4214:   Set pColor = New RgbColor
4215:   pColor.Red = pRed
4216:   pColor.Blue = pBlue
4217:   pColor.Green = pGreen
4218:   pColor.UseWindowsDithering = True
  
4220:   Set MakeColorRGB = pColor


  Exit Function
ErrorHandler:
  HandleError True, "MakeColorRGB " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function MakeColorHSV(pHue As Integer, pSaturation As Integer, pValue As Integer) As IColor
  On Error GoTo ErrorHandler


  Dim pColor As IHsvColor
4232:   Set pColor = New HsvColor
4233:   pColor.Hue = pHue
4234:   pColor.Saturation = pSaturation
4235:   pColor.Value = pValue
4236:   pColor.UseWindowsDithering = True
  
4238:   Set MakeColorHSV = pColor


  Exit Function
ErrorHandler:
  HandleError True, "MakeColorHSV " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Sub GraphicsSetNameSelected(ByRef pMxDoc As IMxDocument, strName As String)
  On Error GoTo ErrorHandler


  Dim pGraphicsContainerSelect As IGraphicsContainerSelect
  
4251:   Set pGraphicsContainerSelect = pMxDoc.FocusMap
  Dim pEnumElement As IEnumElement
4253:   Set pEnumElement = pGraphicsContainerSelect.SelectedElements
4254:   pEnumElement.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
4259:   Set pElement = pEnumElement.Next
  
4261:   While Not pElement Is Nothing
4262:     Set pElementProperties = pElement
4263:     pElementProperties.Name = strName
4264:     Set pElement = pEnumElement.Next
4265:   Wend

  Exit Sub


  Exit Sub
ErrorHandler:
  HandleError True, "GraphicsSetNameSelected " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function ReturnGraphicsByName(ByRef pMxDoc As IMxDocument, strName As String, _
      Optional AsElements As Boolean) As IArray
  On Error GoTo ErrorHandler


  Dim pGraphicsContainer As IGraphicsContainer
  
4282:   Set pGraphicsContainer = pMxDoc.FocusMap
  
4284:   pGraphicsContainer.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
4289:   Set pElement = pGraphicsContainer.Next
  
  Dim pArray As IArray
4292:   Set pArray = New esriSystem.Array
  Dim pGeometry As IGeometry
  Dim pClone As IClone
  
4296:   While Not pElement Is Nothing
4297:     Set pElementProperties = pElement
4298:     If pElementProperties.Name = strName Then
4299:       If AsElements Then
4300:         pArray.Add pElement
4301:       Else
4302:         Set pGeometry = pElement.Geometry
4303:         Set pClone = pGeometry
4304:         pArray.Add pClone.Clone     ' ONLY RETURN A COPY OF THE GEOMETRY; DON'T WANT TO MODIFY ACTUAL GRAPHIC HERE
4305:       End If
4306:     End If
4307:     Set pElement = pGraphicsContainer.Next
    
4309:   Wend
4310:   Set ReturnGraphicsByName = pArray


  Exit Function
ErrorHandler:
  HandleError True, "ReturnGraphicsByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnGraphicsByType(ByRef pMxDoc As IMxDocument, intGeometryType As esriGeometryType, _
      Optional AsElements As Boolean) As IArray
  On Error GoTo ErrorHandler


  Dim pGraphicsContainer As IGraphicsContainer
  
4325:   Set pGraphicsContainer = pMxDoc.FocusMap
  
4327:   pGraphicsContainer.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
4332:   Set pElement = pGraphicsContainer.Next
  
  Dim pArray As IArray
4335:   Set pArray = New esriSystem.Array
  Dim pGeometry As IGeometry
  Dim pClone As IClone
  
  Dim pGeometryType As esriGeometryType
  
4341:   While Not pElement Is Nothing
4342:     Set pElementProperties = pElement
4343:     Set pGeometry = pElement.Geometry
4344:     pGeometryType = pGeometry.GeometryType
    
4346:     If pGeometryType = intGeometryType Then
4347:       If AsElements Then            ' IN THIS CASE RETURN THE ACTUAL GRAPHIC ELEMENT
4348:         pArray.Add pElement
4349:       Else
4350:         Set pClone = pGeometry
4351:         pArray.Add pClone.Clone     ' ONLY RETURN A COPY OF THE GEOMETRY; DON'T WANT TO MODIFY ACTUAL GRAPHIC HERE
4352:       End If
4353:     End If
4354:     Set pElement = pGraphicsContainer.Next
    
4356:   Wend
4357:   Set ReturnGraphicsByType = pArray


  Exit Function
ErrorHandler:
  HandleError True, "ReturnGraphicsByType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub DeleteGraphicsByName(ByRef pMxDoc As IMxDocument, strName As String)
  On Error GoTo ErrorHandler


  Dim pGraphicsContainer As IGraphicsContainer
  Dim pActiveView As IActiveView
  
4372:   Set pGraphicsContainer = pMxDoc.FocusMap
4373:   Set pActiveView = pMxDoc.ActiveView
  
4375:   pGraphicsContainer.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
4380:   Set pElement = pGraphicsContainer.Next
  
  Dim pEnvelope As IEnvelope
  
4384:   While Not pElement Is Nothing
4385:     Set pElementProperties = pElement
    
4387:     If pElementProperties.Name = strName Then
4388:       pGraphicsContainer.DeleteElement pElement
4389:       If (pEnvelope Is Nothing) Then
4390:         Set pEnvelope = pElement.Geometry.Envelope
4391:       Else
4392:         pEnvelope.Union pElement.Geometry.Envelope
4393:       End If
4394:     End If
4395:     Set pElement = pGraphicsContainer.Next
    
4397:   Wend
  
4399:   If (Not pEnvelope Is Nothing) Then
4400:     pActiveView.PartialRefresh esriViewGraphics + esriViewGraphicSelection + esriViewGeography, Nothing, pEnvelope
4401:   End If


  Exit Sub
ErrorHandler:
  HandleError True, "DeleteGraphicsByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub DoSpatialQuery(pSourceFeatureLayer As IFeatureLayer, pTargetFeatureLayer As IFeatureLayer, DoAll As Boolean, _
    pSelRelationship As esriSpatialRelEnum)
  On Error GoTo ErrorHandler


  Dim pFLayer As IFeatureLayer
  Dim pFc As IFeatureClass
   
  ' Specify the polygon layer with currently selected features
4419:   Set pFLayer = pSourceFeatureLayer

  Dim pFeatSel As IFeatureSelection
4422:   Set pFeatSel = pFLayer
  
  Dim pSelSet As ISelectionSet
  
4426:   If DoAll Then
4427:     pFeatSel.SelectFeatures Nothing, esriSelectionResultNew, False
4428:   End If
  
4430:   Set pSelSet = pFeatSel.SelectionSet

  Dim pEnumGeom As IEnumGeometry
  Dim pEnumGeomBind As IEnumGeometryBind

4435:   Set pEnumGeom = New EnumFeatureGeometry
4436:   Set pEnumGeomBind = pEnumGeom
4437:   pEnumGeomBind.BindGeometrySource Nothing, pSelSet

  Dim pGeomFactory As IGeometryFactory
4440:   Set pGeomFactory = New GeometryEnvironment

  Dim pGeom As IGeometry
4443:   Set pGeom = pGeomFactory.CreateGeometryFromEnumerator(pEnumGeom)

  Dim pSpFilter As ISpatialFilter
4446:   Set pSpFilter = New SpatialFilter
4447:   With pSpFilter
4448:     Set .Geometry = pGeom
4449:     .GeometryField = "SHAPE"
4450:     .SpatialRel = pSelRelationship
4451:   End With
  
4453:   Set pFLayer = pTargetFeatureLayer
4454:   Set pFeatSel = pFLayer
  
4456:   pFeatSel.SelectFeatures pSpFilter, esriSelectionResultNew, False


  Exit Sub
ErrorHandler:
  HandleError True, "DoSpatialQuery " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Function ReturnCurrentMapUnits(pMap As IMap) As String
  On Error GoTo ErrorHandler


  Dim intEsriUnits As Integer
4470:   intEsriUnits = pMap.MapUnits
  
  Select Case intEsriUnits
    Case 0
4474:       ReturnCurrentMapUnits = "Unknown"
    Case 1
4476:       ReturnCurrentMapUnits = "Inches"
    Case 2
4478:       ReturnCurrentMapUnits = "Points"
    Case 3
4480:       ReturnCurrentMapUnits = "Feet"
    Case 4
4482:       ReturnCurrentMapUnits = "Yards"
    Case 5
4484:       ReturnCurrentMapUnits = "Miles"
    Case 6
4486:       ReturnCurrentMapUnits = "Nautical Miles"
    Case 7
4488:       ReturnCurrentMapUnits = "Millimeters"
    Case 8
4490:       ReturnCurrentMapUnits = "Centimeters"
    Case 9
4492:       ReturnCurrentMapUnits = "Meters"
    Case 10
4494:       ReturnCurrentMapUnits = "Kilometers"
    Case 11
4496:       ReturnCurrentMapUnits = "Decimal Degrees"
    Case 12
4498:       ReturnCurrentMapUnits = "Decimeters"
4499:   End Select


  Exit Function
ErrorHandler:
  HandleError True, "ReturnCurrentMapUnits " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Sub ForceUppercase(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler

  
4512:   KeyAscii = Asc(UCase(Chr(KeyAscii)))


  Exit Sub
ErrorHandler:
  HandleError True, "ForceUppercase " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub CheckNumericReal(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


Select Case KeyAscii
  Case Is < 8
4526:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 43
4529:     KeyAscii = 0
  Case 45            ' "-" CHARACTER; INSERT AT BEGINNING OR REMOVE FROM BEGINNING
                     ' RESET CURSOR POSITION TO ORIGINAL CHARACTER LOCATION
4532:     KeyAscii = 0
    Dim strText As String
    Dim lngpos As Long
4535:     strText = txtTextBox.Text
4536:     lngpos = txtTextBox.SelStart
4537:     If Left(strText, 1) = "-" Then
4538:       txtTextBox.Text = Right(strText, Len(strText) - 1)
4539:       If lngpos > 0 Then
4540:         txtTextBox.SelStart = lngpos - 1
4541:       End If
4542:     Else
4543:       txtTextBox.Text = "-" & strText
4544:       txtTextBox.SelStart = lngpos + 1
4545:     End If
  Case 44 Or 46          ' DECIMAL CHARACTER; ONLY ALLOW ONE PERIOD OR COMMA
    Dim strText2 As String
4548:     strText2 = txtTextBox.Text
    Dim lngPos2 As Long
4550:     lngPos2 = txtTextBox.SelStart
4551:     If Not IsNumeric(Left(strText2, lngPos2) & Chr(KeyAscii) & Right(strText2, Len(strText2) - lngPos2)) Then
4552:       KeyAscii = 0
4553:     End If
  Case 47          ' "/" CHARACTER
4555:     KeyAscii = 0
  Case Is > 57
4557:     KeyAscii = 0
4558: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericReal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub CheckNumericRealPositive(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


Select Case KeyAscii
  Case Is < 8
4573:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 43
4576:     KeyAscii = 0
  Case 45            ' "-" CHARACTER
4578:     KeyAscii = 0

  Case 44 Or 46          ' DECIMAL CHARACTER; ONLY ALLOW ONE PERIOD OR COMMA
    Dim strText2 As String
4582:     strText2 = txtTextBox.Text
    Dim lngPos2 As Long
4584:     lngPos2 = txtTextBox.SelStart
4585:     If Not IsNumeric(Left(strText2, lngPos2) & Chr(KeyAscii) & Right(strText2, Len(strText2) - lngPos2)) Then
4586:       KeyAscii = 0
4587:     End If
  Case 47          ' "/" CHARACTER
4589:     KeyAscii = 0
  Case Is > 57
4591:     KeyAscii = 0
4592: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericRealPositive " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub CheckNumericInteger(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


Select Case KeyAscii
  Case Is < 8
4605:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 43
4608:     KeyAscii = 0
  Case 45            ' "-" CHARACTER; INSERT AT BEGINNING OR REMOVE FROM BEGINNING
                     ' RESET CURSOR POSITION TO ORIGINAL CHARACTER LOCATION
4611:     KeyAscii = 0
    Dim strText As String
    Dim lngpos As Long
4614:     strText = txtTextBox.Text
4615:     lngpos = txtTextBox.SelStart
4616:     If Left(strText, 1) = "-" Then
4617:       txtTextBox.Text = Right(strText, Len(strText) - 1)
4618:       If lngpos > 0 Then
4619:         txtTextBox.SelStart = lngpos - 1
4620:       End If
4621:     Else
4622:       txtTextBox.Text = "-" & strText
4623:       txtTextBox.SelStart = lngpos + 1
4624:     End If
  Case 44, 46, 47         ' PREVENT PERIOD OR COMMA DECIMAL CHARACTER
4626:     KeyAscii = 0
  Case Is > 57
4628:     KeyAscii = 0
4629: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericInteger " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub CheckNumericIntegerPositive(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


' ONLY ALLOW NUMBERS AND BACKSPACE
Select Case KeyAscii
  Case Is < 8
4644:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 47
4647:     KeyAscii = 0
  Case Is > 57
4649:     KeyAscii = 0
4650: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericIntegerPositive " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Function CompareSpatialReferences(ByVal pSourceSR As ISpatialReference, ByVal pTargetSR As ISpatialReference) As Boolean
  On Error GoTo ErrorHandler

  
  Dim pSourceClone As IClone
  Dim pTargetClone As IClone
  Dim bSREqual As Boolean
  
4665:   Set pSourceClone = pSourceSR
4666:   Set pTargetClone = pTargetSR
  
  'MsgBox "pSourceClone is nothing = " & CStr(pSourceClone Is Nothing) & vbCrLf & _
        "pTargetClone is nothing = " & CStr(pTargetClone Is Nothing)
  
4671:   If pSourceClone Is Nothing And pTargetClone Is Nothing Then
4672:     CompareSpatialReferences = True
4673:   ElseIf pSourceClone Is Nothing Or pTargetClone Is Nothing Then
4674:     CompareSpatialReferences = False
4675:   Else
    
    'Compare the coordinate system component of the spatial reference
4678:     bSREqual = pSourceClone.IsEqual(pTargetClone)
    
    'If the comparison failed, return false and exit
4681:     If Not bSREqual Then
4682:       CompareSpatialReferences = False
      Exit Function
4684:     End If
    
    'We can also compare the XY precision to ensure the spatial references are equal
    Dim pSourceSR2 As ISpatialReference2
    Dim bXYIsEqual As Boolean
    
4690:     Set pSourceSR2 = pSourceSR
4691:     bXYIsEqual = pSourceSR2.IsXYPrecisionEqual(pTargetSR)
    
    'If the comparison failed, return false and exit
4694:     If Not bXYIsEqual Then
4695:       CompareSpatialReferences = False
      Exit Function
4697:     End If
    
4699:     CompareSpatialReferences = True
4700:   End If


  Exit Function
ErrorHandler:
  HandleError True, "CompareSpatialReferences " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnTimeElapsedFromMilliseconds(lngMilliseconds As Long) As String
  On Error GoTo ErrorHandler

  
  Dim theElapsedTime As Double
  Dim theNumDays As Double
  Dim theNumHours As Double
  Dim theNumMinutes As Double
  Dim theNumSeconds As Double
  
4718:   theElapsedTime = lngMilliseconds / 1000
  
4720:   theNumDays = Int(theElapsedTime / 86400)
4721:   theNumHours = Int((theElapsedTime Mod 86400) / 3600)
4722:   theNumMinutes = Int((theElapsedTime Mod 3600) / 60)
4723:   theNumSeconds = theElapsedTime Mod 60
  
  Dim theDayString As String
  Dim theHourString As String
  Dim theMinString As String
  Dim theSecString As String
  
4730:   If theNumDays = 1 Then
4731:     theDayString = " day"
4732:   Else
4733:     theDayString = " days"
4734:   End If
  
4736:   If theNumHours = 1 Then
4737:     theHourString = " hour"
4738:   Else
4739:     theHourString = " hours"
4740:   End If
  
4742:   If theNumMinutes = 1 Then
4743:     theMinString = " minute"
4744:   Else
4745:     theMinString = " minutes"
4746:   End If
  
4748:   If theNumSeconds = 1 Then
4749:     theSecString = " second..."
4750:   Else
4751:     theSecString = " seconds..."
4752:   End If
  
  Dim theElapsedTimeString As String
4755:   theElapsedTimeString = ""
4756:   If theNumDays > 0 Then
4757:     theElapsedTimeString = theElapsedTimeString & theNumDays & theDayString & ", " & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4759:   ElseIf theNumHours > 0 Then
4760:     theElapsedTimeString = theElapsedTimeString & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4762:   ElseIf theNumMinutes > 0 Then
4763:     theElapsedTimeString = theElapsedTimeString & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4765:   Else
4766:     theElapsedTimeString = theElapsedTimeString & theNumSeconds & theSecString
4767:   End If
  
4769:   ReturnTimeElapsedFromMilliseconds = theElapsedTimeString


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeElapsedFromMilliseconds " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function ReturnTimeElapsed(theTimeBegan As Date, theTimeEnd As Date) As String
  On Error GoTo ErrorHandler

  
  Dim theElapsedTime As Double
  Dim theNumDays As Double
  Dim theNumHours As Double
  Dim theNumMinutes As Double
  Dim theNumSeconds As Double
  
4786:   theElapsedTime = DateDiff("s", theTimeBegan, theTimeEnd)
  
4788:   theNumDays = Int(theElapsedTime / 86400)
4789:   theNumHours = Int((theElapsedTime Mod 86400) / 3600)
4790:   theNumMinutes = Int((theElapsedTime Mod 3600) / 60)
4791:   theNumSeconds = theElapsedTime Mod 60
  
  Dim theDayString As String
  Dim theHourString As String
  Dim theMinString As String
  Dim theSecString As String
  
4798:   If theNumDays = 1 Then
4799:     theDayString = " day"
4800:   Else
4801:     theDayString = " days"
4802:   End If
  
4804:   If theNumHours = 1 Then
4805:     theHourString = " hour"
4806:   Else
4807:     theHourString = " hours"
4808:   End If
  
4810:   If theNumMinutes = 1 Then
4811:     theMinString = " minute"
4812:   Else
4813:     theMinString = " minutes"
4814:   End If
  
4816:   If theNumSeconds = 1 Then
4817:     theSecString = " second..."
4818:   Else
4819:     theSecString = " seconds..."
4820:   End If
  
  Dim theElapsedTimeString As String
4823:   theElapsedTimeString = "Time Elapsed: "
4824:   If theNumDays > 0 Then
4825:     theElapsedTimeString = theElapsedTimeString & theNumDays & theDayString & ", " & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4827:   ElseIf theNumHours > 0 Then
4828:     theElapsedTimeString = theElapsedTimeString & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4830:   ElseIf theNumMinutes > 0 Then
4831:     theElapsedTimeString = theElapsedTimeString & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4833:   Else
4834:     theElapsedTimeString = theElapsedTimeString & theNumSeconds & theSecString
4835:   End If
  
4837:   ReturnTimeElapsed = "Analysis Began: " & Format(theTimeBegan, "long date") & ";  " & Format(theTimeBegan, "long time") & vbCrLf & _
                      "Analysis Complete: " & Format(theTimeEnd, "long date") & ";  " & Format(theTimeEnd, "long time") & vbCrLf & _
                      theElapsedTimeString & vbCrLf & vbCrLf


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeElapsed " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ReturnTimeElapsedRTF(theTimeBegan As Date, theTimeEnd As Date, lngFontSize As Long) As String
  On Error GoTo ErrorHandler


  Dim theElapsedTime As Double
  Dim theNumDays As Double
  Dim theNumHours As Double
  Dim theNumMinutes As Double
  Dim theNumSeconds As Double
  
4858:   theElapsedTime = CDbl(DateDiff("s", theTimeBegan, theTimeEnd))
'  MsgBox "theElapsedTime = " & CStr(theElapsedTime)
4860:   theNumDays = Int(CDbl(theElapsedTime / 86400#))
4861:   theNumHours = Int(CDbl(theElapsedTime Mod 86400#) / 3600#)
4862:   theNumMinutes = Int(CDbl(theElapsedTime Mod 3600#) / 60)
4863:   theNumSeconds = theElapsedTime Mod 60
  
  Dim theDayString As String
  Dim theHourString As String
  Dim theMinString As String
  Dim theSecString As String
  
4870:   If theNumDays = 1 Then
4871:     theDayString = " day"
4872:   Else
4873:     theDayString = " days"
4874:   End If
  
4876:   If theNumHours = 1 Then
4877:     theHourString = " hour"
4878:   Else
4879:     theHourString = " hours"
4880:   End If
  
4882:   If theNumMinutes = 1 Then
4883:     theMinString = " minute"
4884:   Else
4885:     theMinString = " minutes"
4886:   End If
  
4888:   If theNumSeconds = 1 Then
4889:     theSecString = " second..."
4890:   Else
4891:     theSecString = " seconds..."
4892:   End If
  
  Dim theElapsedTimeString As String
4895:   theElapsedTimeString = "Time Elapsed: "
4896:   If theNumDays > 0 Then
4897:     theElapsedTimeString = theElapsedTimeString & theNumDays & theDayString & ", " & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4899:   ElseIf theNumHours > 0 Then
4900:     theElapsedTimeString = theElapsedTimeString & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4902:   ElseIf theNumMinutes > 0 Then
4903:     theElapsedTimeString = theElapsedTimeString & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4905:   Else
4906:     theElapsedTimeString = theElapsedTimeString & theNumSeconds & theSecString
4907:   End If
  
4909:   ReturnTimeElapsedRTF = _
    "\b\fszzzFontSizezzz Analysis Began:\b0\i    zzzTimeBeganzzz\par" & vbCrLf & _
    "\b\i0 Analysis Complete:\b0\i    zzzTimeEndzzz\par" & vbCrLf & _
    "\b\i0 Time Elapsed:\b0\i    zzzTimeElapsedzzz\par" & vbCrLf
  
'  ReturnTimeElapsedRTF = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
      "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\b\f0\fszzzFontSizezzz Analysis Began:\b0\i    zzzTimeBeganzzz\par" & vbCrLf & _
      "\b\i0 Analysis Complete:\b0\i    zzzTimeEndzzz\par" & vbCrLf & _
      "\b\i0 Time Elapsed:\b0\i    zzzTimeElapsedzzz\par" & vbCrLf & _
      "}"
  Dim strTimeBegan As String
4920:   strTimeBegan = CStr(Format(theTimeBegan, "long date")) & " at " & CStr(Format(theTimeBegan, "long time"))
  Dim strTimeEnd As String
4922:   strTimeEnd = CStr(Format(theTimeEnd, "long date")) & " at " & CStr(Format(theTimeEnd, "long time"))
  
4924:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzFontSizezzz", CStr(lngFontSize * 2))
4925:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzTimeBeganzzz", strTimeBegan)
4926:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzTimeEndzzz", strTimeEnd)
4927:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzTimeElapsedzzz", theElapsedTimeString)
  
'  ReturnTimeElapsedRTF = "Analysis Began: " & Format(theTimeBegan, "long date") & ";  " & Format(theTimeBegan, "long time") & vbCrLf & _
                      "Analysis Complete: " & Format(theTimeEnd, "long date") & ";  " & Format(theTimeEnd, "long time") & vbCrLf & _
                      theElapsedTimeString & vbCrLf & vbCrLf


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeElapsedRTF " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub RemoveKeyFromCollection(colCollection As Collection, strKey As String)
  On Error GoTo ErrorHandler


  On Error Resume Next
  
4945:   colCollection.Remove strKey


  Exit Sub
ErrorHandler:
  HandleError True, "RemoveKeyFromCollection " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function CheckCollectionForKey(colCollection As Collection, strKey As String) As Boolean
  On Error GoTo errHandler
  
4956:   CheckCollectionForKey = True
  Dim lngVarType As Long
4958:   lngVarType = VarType(colCollection.Item(strKey))
  
  Exit Function
errHandler:
4962:   CheckCollectionForKey = False

End Function

Public Sub EnableSelectTool(pApp As IApplication)
  On Error GoTo ErrorHandler


    Dim pUID As New uID
    Dim pCmdItem As ICommandItem
    ' Use the GUID of the Select Elements command
4973:     pUID.Value = "{C22579D1-BC17-11D0-8667-0000F8751720}"
4974:     Set pCmdItem = pApp.Document.CommandBars.Find(pUID)
4975:     pCmdItem.Execute


  Exit Sub
ErrorHandler:
  HandleError True, "EnableSelectTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function CreateNestedFoldersByPath(ByVal completeDirectory As String) As Long
  On Error GoTo ErrorHandler


  'ADAPTED FROM http://vbnet.mvps.org/index.html?code/file/nested.htm
  'Visual Basic File Routines
  'CreateDirectory: Creating Nested Folders
  '
  'Posted:     Saturday September 19, 1998
  'Updated:    Wednesday December 05, 2007
  '
  'Applies to:     VB4-32, VB5, VB6
  'Developed with:     VB5, Windows 98
  'OS restrictions:    None
  'Author:     VBnet - Randy Birch

  'creates nested directories on the drive
  'included in the path by parsing the final
  'directory string into a directory array,
  'and looping through each to create the final path.
  
  'The path could be passed to this method as a
  'pre-filled array, reducing the code.
  
   Dim r As Long
   Dim SA As SECURITY_ATTRIBUTES
   Dim drivePart As String
   Dim newDirectory  As String
   Dim Item As String
   Dim sfolders() As String
   Dim pos As Long
   Dim X As Long
      
  'must have a trailing slash for
  'the GetPart routine below
5018:    If Right$(completeDirectory, 1) <> "\" Then
5019:       completeDirectory = completeDirectory & "\"
5020:    End If
  
  'if there is a drive in the string, get it
  'else, just use nothing - assumes current drive
5024:    pos = InStr(completeDirectory, ":")

5026:    If pos Then
5027:       drivePart = GetPart(completeDirectory, "\")
5028:    Else: drivePart = ""
5029:    End If

  'now get the rest of the items that
  'make up the string
5033:    Do Until completeDirectory = ""

    'strip off one item (i.e. "Files\")
5036:      Item = GetPart(completeDirectory, "\")

    'add it to an array for later use, and
    'if this is the first item (x=0),
    'append the drivepart
     ReDim Preserve sfolders(0 To X) As String

5043:      If X = 0 Then Item = drivePart & Item
5044:      sfolders(X) = Item
     
    'increment the array counter
5047:      X = X + 1

5049:    Loop

  'Now create the directories.
  'Because the first directory is
  '0 in the array, reinitialize x to -1
5054:    X = -1
   
5056:    Do
   
5058:       X = X + 1
     'just keep appending the folders in the
     'array to newDirectory.  When x=0 ,
     'newDirectory is "", so the
     'newDirectory gets assigned drive:\firstfolder.
     
     'Subsequent loops adds the next member of the
     'array to the path, forming a fully qualified
     'path to the new directory.
5067:       newDirectory = newDirectory & sfolders(X)
      
     'the only member of the SA type needed (on
     'a win95/98 system at least)
5071:       SA.nLength = LenB(SA)
      
5073:       Call CreateDirectory(newDirectory, SA)
       
5075:    Loop Until X = UBound(sfolders)
   
  'done. Return x, but add 1 for the 0-based array.
5078:    CreateNestedFoldersByPath = X + 1


  Exit Function
ErrorHandler:
  HandleError True, "CreateNestedFoldersByPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function GetPart(startStrg As String, delimiter As String) As String
  On Error GoTo ErrorHandler


'takes a string separated by "delimiter",
'splits off 1 item, and shortens the string
'so that the next item is ready for removal.

  Dim C As Integer
  Dim Item As String
  
5097:   C = 1
  
5099:   Do

5101:     If Mid$(startStrg, C, 1) = delimiter Then
      
5103:       Item = Mid$(startStrg, 1, C)
5104:       startStrg = Mid$(startStrg, C + 1, Len(startStrg))
5105:       GetPart = Item
      Exit Function
    
5108:     End If

5110:     C = C + 1

5112:   Loop


  Exit Function
ErrorHandler:
  HandleError True, "GetPart " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnTimeStamp() As String
  On Error GoTo ErrorHandler


5124:   ReturnTimeStamp = CStr(Format(Now, "yyyymmdd_HhNnSs"))


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeStamp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Private Function IsNaN(expression As Variant) As Boolean
  On Error GoTo ErrorHandler

  On Error Resume Next
5137:   If Not IsNumeric(expression) Then
5138:     IsNaN = False
    Exit Function
5140:   End If
5141:   If (CStr(expression) = "-1.#QNAN") Or (CStr(expression) = "1,#QNAN") Then ' can vary by locale
5142:     IsNaN = True
5143:   Else
5144:     IsNaN = False
5145:   End If

  Exit Function
ErrorHandler:
  HandleError False, "IsNaN " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function MakeUniqueRasterName(pRasterType As JenDatasetTypes, strWSPath As String, strRasterName As String, _
      Optional booTrimForGRID As Boolean) As String
  On Error GoTo ErrorHandler
  
  ' ONLY RETURNS ACTUAL RASTER NAME
  
  Dim pWsFact As IWorkspaceFactory
  
  Dim pWorkspace As IWorkspace
  Dim pWorkspace2 As IWorkspace2
  Dim pWsEx As IRasterWorkspaceEx
  Dim pWS As IRasterWorkspace
  
  Dim lngIndex As Long
5167:   lngIndex = 1
  
  Dim strNewName As String
  Dim strBaseName As String
5171:   strNewName = strRasterName
5172:   strBaseName = strRasterName
  
  Dim strIndex As String
  
  Select Case pRasterType
    Case ENUM_FileGDB
5178:       Set pWsFact = New FileGDBWorkspaceFactory
5179:       Set pWsEx = pWsFact.OpenFromFile(strWSPath, 0)
5180:       Set pWorkspace2 = pWsEx
5181:       Do Until Not pWorkspace2.NameExists(esriDTRasterDataset, strNewName)
5182:         lngIndex = lngIndex + 1
5183:         strNewName = strBaseName & "_" & CStr(lngIndex)
5184:       Loop
5185:       MakeUniqueRasterName = strNewName
    Case ENUM_PersonalGDB
5187:       Set pWsFact = New AccessWorkspaceFactory
5188:       Set pWsEx = pWsFact.OpenFromFile(strWSPath, 0)
5189:       Set pWorkspace2 = pWsEx
5190:       Do Until Not pWorkspace2.NameExists(esriDTRasterDataset, strNewName)
5191:         lngIndex = lngIndex + 1
5192:         strNewName = strBaseName & "_" & CStr(lngIndex)
5193:       Loop
5194:       MakeUniqueRasterName = strNewName
    Case ENUM_File_Raster
      
5197:       If booTrimForGRID Then
        ' FOLLOW GRID RESTRICTIONS
5199:         strNewName = Left(ReplaceBadChars(strNewName, True, True, True, False), 13)
5200:         strBaseName = strNewName
5201:       End If
      
5203:       Set pWsFact = New RasterWorkspaceFactory
5204:       Set pWS = pWsFact.OpenFromFile(strWSPath, 0)
5205:       Set pWorkspace = pWS
      
      Dim pEnumDatasetName As IEnumDatasetName
5208:       Set pEnumDatasetName = pWorkspace.DatasetNames(esriDTRasterDataset)
      Dim pDatasetName As IDatasetName
      
      Dim booNameExists As Boolean
5212:       booNameExists = True
      
5214:       Do Until booNameExists = False
5215:         booNameExists = False
                    
5217:         pEnumDatasetName.Reset
5218:         Set pDatasetName = pEnumDatasetName.Next
        
5220:         Do Until pDatasetName Is Nothing
5221:           If pDatasetName.Name = strNewName Then
5222:             booNameExists = True
5223:             Set pDatasetName = Nothing
5224:           Else
5225:             Set pDatasetName = pEnumDatasetName.Next
5226:           End If
5227:         Loop
        
5229:         If booNameExists Then
5230:           lngIndex = lngIndex + 1
5231:           strIndex = "_" & CStr(lngIndex)
5232:           If booTrimForGRID Then
5233:             strNewName = Left(strBaseName, 13 - Len(strIndex)) & strIndex
5234:           Else
5235:             strNewName = strBaseName & strIndex
5236:           End If
5237:         End If
5238:       Loop
      
5240:       MakeUniqueRasterName = strNewName
5241:   End Select
      

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueRasterName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CursorToSet_Features(pFCursor As IFeatureCursor) As esriSystem.ISet
  On Error GoTo ErrorHandler

  'http://forums.esri.com/Thread.asp?c=93&f=992&t=79743&mc=16.
  Dim pFeature As IFeature
5254:   Set CursorToSet_Features = New esriSystem.Set
5255:   Set pFeature = pFCursor.NextFeature
5256:   Do While Not pFeature Is Nothing
5257:     CursorToSet_Features.Add pFeature
5258:     Set pFeature = pFCursor.NextFeature
5259:   Loop
  
5261:   CursorToSet_Features.Reset
  
  Exit Function
ErrorHandler:
  HandleError True, "CursorToSet_Features " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CursorToSet_TableRow(ByVal pCursor As ICursor) As esriSystem.ISet
  On Error GoTo ErrorHandler

' adapted from VB.NET
' http://forums.esri.com/Thread.asp?c=93&f=992&t=79743&mc=19

  Dim pSSet As esriSystem.ISet
  Dim pRow As IRow

  'populate the set with the cursor
5278:   Set pSSet = New esriSystem.Set
5279:   Set pRow = pCursor.NextRow
5280:   Do Until pRow Is Nothing
5281:     Do Until pRow Is Nothing
5282:       pSSet.Add pRow
5283:       Set pRow = pCursor.NextRow
5284:     Loop
5285:     pSSet.Reset
5286:   Loop

5288:   Set CursorToSet_TableRow = pSSet


  Exit Function
ErrorHandler:
  HandleError True, "CursorToSet_TableRow " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub MakeRandomNormalPolar(dblMean As Double, dblSD As Double, ByRef dblRand1 As Double, Optional ByRef dblRand2 As Double = -999)
  On Error GoTo ErrorHandler

'  Static dblSeed
' Based on Marsaglia's variation of the Box-Muller Transformation (http://en.wikipedia.org/wiki/Box-Muller_transform):
'        z1 = u * sqrt((-2 ln(s))/s)
'        z2 = v * sqrt((-2 ln(s))/s)
'      where:
'         s = u^2 + v^2, and is not equal to 0 or > 1
'        x1 = first uniform random number (between -1 and 1)
'        x2 = second uniform random number (between -1 and 1)
'        z1 = first normally distributed random number
'        z2 = second normally distributed random number.

' RANDOMIZE FIRST!
'  If dblSeed = 0 Then
'    Randomize            ' USE SYSTEM TIMER
'  Else
'    Randomize dblSeed
'  End If
  
  Dim dblX1 As Double
  Dim dblX2 As Double
  Dim s As Double
5320:   s = 5
5321:   Do Until s <= 1 And s <> 0
5322:     dblX1 = (Rnd * 2) - 1
5323:     dblX2 = (Rnd * 2) - 1
5324:     s = dblX2 ^ 2 + dblX1 ^ 2
5325:   Loop
  
5327:   dblRand1 = (dblX1 * Sqr(-2 * Log(s) / s) * dblSD#) + dblMean#
5328:   dblRand2 = (dblX2 * Sqr(-2 * Log(s) / s) * dblSD#) + dblMean#
  
'  dblSeed = dblRand2
  

  Exit Sub
ErrorHandler:
  HandleError True, "MakeRandomNormalPolar " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Function CreateInMemoryFeatureClass(pGeometryArray As esriSystem.IArray, _
    Optional pValueArray As esriSystem.IVariantArray, Optional pTemplateField As IField) As IFeatureClass
  On Error GoTo ErrorHandler

    ' create an inmemory featureclass
    ' ADAPTED FROM KIRK KUYKENDALL
    ' http://forums.esri.com/Thread.asp?c=93&f=993&t=210767
    
    ' ASSUMES ONE OR MORE GEOMETRIES, ALL OF WHICH ARE IN THE SAME PROJECTION
    Dim pGeom As IGeometry
5349:     Set pGeom = pGeometryArray.Element(0)
    
    Dim pWSF As IWorkspaceFactory
5352:     Set pWSF = New InMemoryWorkspaceFactory
    
    Dim pName As IName
5355:     Set pName = pWSF.Create("", "inmemory", Nothing, 0)
    Dim pFWS As IFeatureWorkspace
5357:     Set pFWS = pName.Open
    
    Dim pFlds As IFields
        
    Dim pFields As IFields
    Dim pFieldsEdit As IFieldsEdit
    Dim pField As IField
    Dim pFieldEdit As IFieldEdit
   
5366:     Set pFields = New Fields
5367:     Set pFieldsEdit = pFields
      
    '' create the geometry field
    
    Dim pGeomDef As IGeometryDef
    Dim pGeomDefEdit As IGeometryDefEdit
5373:     Set pGeomDef = New GeometryDef
5374:     Set pGeomDefEdit = pGeomDef
    
    '' assign the geometry definiton properties.
5377:     With pGeomDefEdit
5378:       .GeometryType = pGeom.GeometryType
5379:       .GridCount = 1
5380:       .GridSize(0) = 10
5381:       .AvgNumPoints = 2
5382:       .HasM = False
5383:       .HasZ = False
5384:       Set .SpatialReference = pGeom.SpatialReference
5385:     End With
    
5387:     Set pField = New Field
5388:     Set pFieldEdit = pField
    
5390:     pFieldEdit.Name = "Shape"
5391:     pFieldEdit.AliasName = "geometry"
5392:     pFieldEdit.Type = esriFieldTypeGeometry
5393:     Set pFieldEdit.GeometryDef = pGeomDef
5394:     pFieldsEdit.AddField pField
    
    Dim pClone As IClone
    Dim booAddAttribute As Boolean
5398:     booAddAttribute = Not pValueArray Is Nothing And Not pTemplateField Is Nothing
    Dim varVal As Variant
    
5401:     If booAddAttribute Then
5402:       Set pClone = pTemplateField
5403:       Set pField = pClone.Clone
5404:       pFieldsEdit.AddField pField
5405:     Else
5406:       Set pField = New Field
5407:       Set pFieldEdit = pField
5408:       With pFieldEdit
5409:         .Name = "Unique_ID"
5410:         .Type = esriFieldTypeInteger
5411:       End With
5412:       pFieldsEdit.AddField pField
5413:     End If
    
    Dim pCLSID As uID
5416:     Set pCLSID = New uID
5417:     pCLSID.Value = "esriGeoDatabase.Feature"
  
    Dim pInMemFC As IFeatureClass
5420:     Set pInMemFC = pFWS.CreateFeatureClass("In_Memory", pFields, _
                             pCLSID, Nothing, esriFTSimple, _
                             "Shape", "")
    
    Dim lngIDIndex As Long
    
    Dim lngAttIndex As Long
5427:     If booAddAttribute Then
5428:       lngAttIndex = pInMemFC.FindField(pTemplateField.Name)
5429:     Else
5430:       lngIDIndex = pInMemFC.FindField("Unique_ID")
5431:     End If
    
    Dim lngIndex As Long
    Dim pOutFeat As IFeature
5435:     For lngIndex = 0 To pGeometryArray.Count - 1
5436:       Set pGeom = pGeometryArray.Element(lngIndex)
5437:       Set pOutFeat = pInMemFC.CreateFeature
5438:       Set pOutFeat.Shape = pGeom
5439:       If booAddAttribute Then
5440:         varVal = pValueArray.Element(lngIndex)
5441:         pOutFeat.Value(lngAttIndex) = varVal
5442:       Else
5443:         pOutFeat.Value(lngIDIndex) = lngIndex + 1
5444:       End If
5445:       pOutFeat.Store
5446:     Next lngIndex
    
5448:     Set CreateInMemoryFeatureClass = pInMemFC
      
5450:     Set pGeom = Nothing
5451:     Set pWSF = Nothing
5452:     Set pName = Nothing
5453:     Set pFWS = Nothing
5454:     Set pFlds = Nothing
5455:     Set pFields = Nothing
5456:     Set pFieldsEdit = Nothing
5457:     Set pField = Nothing
5458:     Set pFieldEdit = Nothing
5459:     Set pGeomDef = Nothing
5460:     Set pGeomDefEdit = Nothing
5461:     Set pCLSID = Nothing
5462:     Set pInMemFC = Nothing
5463:     Set pOutFeat = Nothing
5464:     Set pClone = Nothing
    
  Exit Function
ErrorHandler:
  HandleError True, "CreateInMemoryFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnTempRasterWorkspace() As IWorkspace
    ' ADAPTED FROM ESRI SAMPLE http://edndoc.esri.com/arcobjects/9.2/CPP_VB6_VBA_VCPP_Doc/COM_Samples_Docs/SpatialAnalyst/ImageUpdate/Visual_Basic/ImageUpdate.frm.htm
    ' Given a pathname, returns the raster workspace object for that path
    On Error GoTo erh
    
    ' Create a Rasterworkspace
    Dim sPath As String
5478:     sPath = Environ("TEMP") ' Get temp directory
    
    Dim pWSF As IWorkspaceFactory
5481:     Set pWSF = New RasterWorkspaceFactory
    Dim pWS As IWorkspace
5483:     Set pWS = pWSF.OpenFromFile(sPath, 0)
5484:     Set ReturnTempRasterWorkspace = pWS
    Exit Function
erh:
5487:     Set ReturnTempRasterWorkspace = Nothing
End Function
Public Function MakeUniqueRasterName2(pWS As IWorkspace, strBaseName As String, booRestrictTo13CharForGrid As Boolean) As String
  On Error GoTo ErrorHandler

  
  Dim pNames As IEnumDatasetName
5494:   Set pNames = pWS.DatasetNames(esriDTAny)
  Dim pDatasetName As IDatasetName
  
  Dim booNameExists As Boolean
5498:   booNameExists = True
  
  Dim lngCounter As Long
5501:   lngCounter = 1
  Dim strCounter As String
  Dim strUniqueName As String
5504:   strUniqueName = strBaseName
  
5506:   Do Until booNameExists = False
5507:     booNameExists = False
5508:     pNames.Reset
5509:     Set pDatasetName = pNames.Next
5510:     Do Until pDatasetName Is Nothing
5511:       Debug.Print "Checking " & pDatasetName.Name
5512:       If pDatasetName.Name = strUniqueName Then
5513:         booNameExists = True
5514:         Exit Do
5515:       End If
5516:       Set pDatasetName = pNames.Next
5517:     Loop
5518:     If booNameExists = True Then
5519:       lngCounter = lngCounter + 1
5520:       strCounter = CStr(lngCounter)
5521:       If booRestrictTo13CharForGrid Then
5522:         strUniqueName = Left(strBaseName, 12 - Len(strCounter)) & "_" & strCounter
5523:       Else
5524:         strUniqueName = strBaseName & "_" & strCounter
5525:       End If
5526:     End If
5527:   Loop
5528:   MakeUniqueRasterName2 = strUniqueName
  

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueRasterName2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnTableByName(strName As String, pMap As IMap) As IStandaloneTable
  On Error GoTo ErrorHandler


5540:   Set ReturnTableByName = Nothing
  Dim pStTabCol As IStandaloneTableCollection
5542:   Set pStTabCol = pMap
  
  Dim pStTab As IStandaloneTable
  Dim lngIndex As Long
5546:   For lngIndex = 0 To pStTabCol.StandaloneTableCount - 1
5547:     Set pStTab = pStTabCol.StandaloneTable(lngIndex)
5548:     If StrComp(pStTab.Name, strName, vbTextCompare) = 0 Then
5549:       Set ReturnTableByName = pStTab
5550:       Exit For
5551:     End If
5552:   Next lngIndex


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTableByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateInMemoryFeatureClass2(pGeometryArray As esriSystem.IArray, _
    Optional pValueArray As esriSystem.IVariantArray, Optional pTemplateFields As esriSystem.IVariantArray, _
    Optional pApp As IApplication, Optional strStatusMessage As String = "") As IFeatureClass
  On Error GoTo ErrorHandler

    

    ' create an inmemory featureclass
    ' ADAPTED FROM KIRK KUYKENDALL
    ' http://forums.esri.com/Thread.asp?c=93&f=993&t=210767
    
    Dim psbar As IStatusBar
    Dim pPro As IStepProgressor
    Dim dateRunningTime As Date
    Dim strHeader As String
    Dim strMessage As String
    Dim lngTimer As Long
    Dim lngTotalCount As Long
    
5579:     If Not pApp Is Nothing Then
      ' FOR PROGRESS METER
5581:       Set psbar = pApp.StatusBar
5582:       Set pPro = psbar.ProgressBar
5583:       dateRunningTime = Now
5584:       strHeader = strStatusMessage
5585:       lngTotalCount = pGeometryArray.Count
5586:       psbar.ShowProgressBar strStatusMessage, 0, lngTotalCount, 1, True
5587:       pPro.position = 0
5588:     End If
        
    ' ASSUMES ONE OR MORE GEOMETRIES, ALL OF WHICH ARE IN THE SAME PROJECTION
    Dim pGeom As IGeometry
5592:     Set pGeom = pGeometryArray.Element(0)
    
    Dim pSpRef As ISpatialReference
5595:     Set pSpRef = pGeom.SpatialReference
    Dim pClone As IClone
    
'    If Not pDomain Is Nothing Then
'      Set pClone = pDomain
'      Set pNewDomain = pClone.Clone
'      pNewDomain.Expand 1.01, 1.01, True
'      pSpRef.SetDomain pNewDomain.XMin, pNewDomain.XMax, pNewDomain.YMin, pNewDomain.YMax
'    End If
    
    Dim pSpRefRes As ISpatialReferenceResolution
5606:     Set pSpRefRes = pSpRef
5607:     pSpRefRes.ConstructFromHorizon
    Dim pWSF As IWorkspaceFactory
5609:     Set pWSF = New InMemoryWorkspaceFactory
    
    Dim pName As IName
5612:     Set pName = pWSF.Create("", "inmemory", Nothing, 0)
    Dim pFWS As IFeatureWorkspace
5614:     Set pFWS = pName.Open
    
    Dim pFlds As IFields
        
    Dim pFields As IFields
    Dim pFieldsEdit As IFieldsEdit
    Dim pField As IField
    Dim pFieldEdit As IFieldEdit
   
5623:     Set pFields = New Fields
5624:     Set pFieldsEdit = pFields
      
    '' create the geometry field
    
    Dim pGeomDef As IGeometryDef
    Dim pGeomDefEdit As IGeometryDefEdit
5630:     Set pGeomDef = New GeometryDef
5631:     Set pGeomDefEdit = pGeomDef
    
'    MsgBox pGeom.SpatialReference.Name
    
    '' assign the geometry definiton properties.
5636:     With pGeomDefEdit
5637:       .GeometryType = pGeom.GeometryType
5638:       .GridCount = 1
5639:       .GridSize(0) = 0
5640:       If pGeom.GeometryType = esriGeometryPoint Then
5641:         .AvgNumPoints = 1
5642:       Else
5643:         .AvgNumPoints = 5
5644:       End If
5645:       .HasM = False
5646:       .HasZ = False
5647:       Set .SpatialReference = pGeom.SpatialReference
5648:     End With
    
5650:     Set pField = New Field
5651:     Set pFieldEdit = pField
    
5653:     pFieldEdit.Name = "Shape"
5654:     pFieldEdit.AliasName = "geometry"
5655:     pFieldEdit.Type = esriFieldTypeGeometry
5656:     Set pFieldEdit.GeometryDef = pGeomDef
5657:     pFieldsEdit.AddField pField
    

    Dim booAddAttribute As Boolean
5661:     booAddAttribute = Not pValueArray Is Nothing And Not pTemplateFields Is Nothing
    Dim varVal As Variant
    
    Dim lngIndex As Long
    Dim pSubArray As esriSystem.IVariantArray
    Dim pTemplateField As IField
    
    Dim lngIDIndex() As Long
    Dim pTempField As IField
5670:     If booAddAttribute Then
5671:       For lngIndex = 0 To pTemplateFields.Count - 1
5672:         Set pTemplateField = pTemplateFields.Element(lngIndex)
5673:         Set pClone = pTemplateField
5674:         Set pTempField = pClone.Clone
5675:         pFieldsEdit.AddField pTempField
5676:       Next lngIndex
      ReDim lngIDIndex(pTemplateFields.Count - 1)
5678:     Else
5679:       Set pField = New Field
5680:       Set pFieldEdit = pField
5681:       With pFieldEdit
5682:         .Name = "Unique_ID"
5683:         .Type = esriFieldTypeInteger
5684:       End With
5685:       pFieldsEdit.AddField pField
      ReDim lngIDIndex(0)
5687:     End If
    
    Dim pCLSID As uID
5690:     Set pCLSID = New uID
5691:     pCLSID.Value = "esriGeoDatabase.Feature"
  
    Dim pInMemFC As IFeatureClass
5694:     Set pInMemFC = pFWS.CreateFeatureClass("In_Memory", pFields, _
                             pCLSID, Nothing, esriFTSimple, _
                             "Shape", "")
    
    
    Dim lngAttIndex As Long
5700:     If booAddAttribute Then
5701:       For lngIndex = 0 To pTemplateFields.Count - 1
5702:         Set pTemplateField = pTemplateFields.Element(lngIndex)
5703:         lngIDIndex(lngIndex) = pInMemFC.FindField(pTemplateField.Name)
5704:       Next lngIndex
5705:     Else
5706:       lngIDIndex(0) = pInMemFC.FindField("Unique_ID")
5707:     End If
    
    Dim pOutFeat As IFeature
    Dim lngIndex2 As Long
    
5712:     For lngIndex = 0 To pGeometryArray.Count - 1
5713:       Set pClone = pGeometryArray.Element(lngIndex)
5714:       Set pGeom = pClone.Clone
5715:       Set pOutFeat = pInMemFC.CreateFeature
5716:       Set pOutFeat.Shape = pGeom
5717:       If booAddAttribute Then
5718:         Set pSubArray = pValueArray.Element(lngIndex)
5719:         For lngIndex2 = 0 To pSubArray.Count - 1
5720:           varVal = pSubArray.Element(lngIndex2)
5721:           pOutFeat.Value(lngIDIndex(lngIndex2)) = varVal
5722:         Next lngIndex2
5723:       Else
5724:         pOutFeat.Value(lngIDIndex(0)) = lngIndex + 1
5725:       End If
5726:       pOutFeat.Store
5727:       If Not pApp Is Nothing Then
5728:         pPro.Step
5729:       End If
5730:     Next lngIndex
    
5732:     If Not pApp Is Nothing Then
5733:       pPro.position = 1
5734:       psbar.HideProgressBar
5735:     End If
5736:     Set CreateInMemoryFeatureClass2 = pInMemFC
      
5738:     Set pGeom = Nothing
5739:     Set pWSF = Nothing
5740:     Set pName = Nothing
5741:     Set pFWS = Nothing
5742:     Set pFlds = Nothing
5743:     Set pFields = Nothing
5744:     Set pFieldsEdit = Nothing
5745:     Set pField = Nothing
5746:     Set pFieldEdit = Nothing
5747:     Set pGeomDef = Nothing
5748:     Set pGeomDefEdit = Nothing
5749:     Set pCLSID = Nothing
5750:     Set pInMemFC = Nothing
5751:     Set pOutFeat = Nothing
5752:     Set pClone = Nothing
5753:     Set pSubArray = Nothing
5754:     Set pTemplateField = Nothing
5755:     Set psbar = Nothing
5756:     Set pPro = Nothing
5757:     Set pTempField = Nothing
5758:     Set pSpRefRes = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "CreateInMemoryFeatureClass2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function MakeFieldNameVarArrayFromTable(pOrigTable As ITable, pNewFClass As IFeatureClass, _
      pFieldArray As esriSystem.IVariantArray, booFieldArrayContainsNamePairs As Boolean) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

      
  ' MAKE IVariantArray OF FIELD NAME INDICES
  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
  '                     1) ORIGINAL FCLASS FIELD INDEX
  '                     2) NEW FCLASS FIELD NAME
  '                     3) NEW FCLASS FIELD INDEX
  
  Dim lngIndex As Long
  Dim pField As IField
  Dim strOrigName As String
  Dim strNewName As String
  Dim pNamePair As esriSystem.IStringArray
  Dim pFieldData As esriSystem.IVariantArray
5783:   Set MakeFieldNameVarArrayFromTable = New VarArray
  
5785:   For lngIndex = 0 To pFieldArray.Count - 1
5786:     If booFieldArrayContainsNamePairs Then
5787:       Set pNamePair = pFieldArray.Element(lngIndex)
5788:       strOrigName = pNamePair.Element(0)
5789:       strNewName = pNamePair.Element(1)
5790:     Else
5791:       Set pField = pFieldArray.Element(lngIndex)
5792:       strOrigName = pField.Name
5793:       strNewName = pField.Name
5794:     End If
5795:     Set pFieldData = New esriSystem.VarArray
5796:     pFieldData.Add strOrigName
5797:     pFieldData.Add pOrigTable.FindField(strOrigName)
5798:     pFieldData.Add strNewName
5799:     pFieldData.Add pNewFClass.FindField(strNewName)
5800:     MakeFieldNameVarArrayFromTable.Add pFieldData
5801:   Next lngIndex


  Exit Function
ErrorHandler:
  HandleError True, "MakeFieldNameVarArrayFromTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Sub SetFeatureSymbols2(pFeatureLayer As ILayer, lyrFileName As String)
  On Error GoTo ErrorHandler

    
' ADAPTED FROM Kirk Kuykendall
' http://forums.esri.com/Thread.asp?c=93&f=992&t=59083
  
  Dim booScaleSymbols As Boolean
  Dim booShouldDisplayAnnotation As Boolean
  
  Dim pGxFile As IGxFile
5819:   Set pGxFile = New GxLayer
5820:   pGxFile.Path = lyrFileName
  
  Dim pGxLayer As IGxLayer
5823:   Set pGxLayer = pGxFile
  
  Dim pGFLayer As IGeoFeatureLayer
  Dim pFLayerDef As IFeatureLayerDefinition2
5827:   Set pGFLayer = pGxLayer.Layer
  
  Dim strDefQuery As String
  
5831:   If TypeOf pGFLayer Is IFeatureLayerDefinition2 Then
5832:     Set pFLayerDef = pGFLayer
5833:     strDefQuery = pFLayerDef.DefinitionExpression
5834:   End If
  
5836:   booScaleSymbols = pGFLayer.ScaleSymbols
5837:   booShouldDisplayAnnotation = pGFLayer.DisplayAnnotation
  
  ' SET TRANSPARENCY
  Dim pLayerEffects As ILayerEffects
  Dim lngTransp As Double
5842:   Set pLayerEffects = pGFLayer
5843:   lngTransp = pLayerEffects.Transparency
  
  Dim pRenderer As IFeatureRenderer
5846:   Set pRenderer = pGFLayer.Renderer
  
  Dim pAnnotation As IAnnotateLayerPropertiesCollection2
5849:   Set pAnnotation = pGFLayer.AnnotationProperties

  
'    Dim pMxDoc As IMxDocument
'    Set pMxDoc = ThisDocument
  Dim pGFLayer2 As IGeoFeatureLayer
  Dim pFLayerDef2 As IFeatureLayerDefinition2
  
5857:   Set pGFLayer2 = pFeatureLayer
5858:   Set pGFLayer2.Renderer = pRenderer        ' <<------------------------

5860:   Set pFLayerDef2 = pFeatureLayer
5861:   pFLayerDef2.DefinitionExpression = strDefQuery

5863:   Set pLayerEffects = pFeatureLayer
5864:   pLayerEffects.Transparency = lngTransp
5865:   pGFLayer2.ScaleSymbols = booScaleSymbols
5866:   pGFLayer2.DisplayAnnotation = booShouldDisplayAnnotation
5867:   pGFLayer2.AnnotationProperties = pAnnotation
  
'    pMxDoc.ActiveView.Refresh
'    pMxDoc.CurrentContentsView.Refresh pGFLayer


5873:   Set pGxFile = Nothing
5874:   Set pGxLayer = Nothing
5875:   Set pGFLayer = Nothing
5876:   Set pFLayerDef = Nothing
5877:   Set pLayerEffects = Nothing
5878:   Set pRenderer = Nothing
5879:   Set pAnnotation = Nothing
5880:   Set pGFLayer2 = Nothing
5881:   Set pFLayerDef2 = Nothing


  Exit Sub
ErrorHandler:
  HandleError True, "SetFeatureSymbols2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function ReturnQuerySpecialCharacters(pDataset As IDataset, Optional strPrefix As String, _
    Optional strSuffix As String, Optional strWildcardSingleMatch As String, _
    Optional strWildlcardManyMatch As String, Optional strSQLEscapePrefix As String, _
    Optional strSQLEscapeSuffix As String) As Boolean
  On Error GoTo errHandler
  

'  Dim pMxDoc As IMxDocument
'  Set pMxDoc = ThisDocument
'  Dim pFLayer As IFeatureLayer
'  Set pFLayer = pMxDoc.FocusMap.Layer(0)
'  Dim pFClass As IFeatureClass
'  Set pFClass = pFLayer.FeatureClass
'
'  Dim strPrefix As String
'  Dim strSuffix As String
'  Dim strWildSingle As String
'  Dim strWildMany As String
'  Dim strEscPrefix As String
'  Dim strEscSuffix As String
'
'  Dim booWorked As Boolean
'  booWorked = ReturnQuerySpecialCharacters(pFClass, strPrefix, strSuffix, strWildSingle, strWildMany, _
'      strEscPrefix, strEscSuffix)
'
'  Dim strPrefixReport As String
'  Dim strSuffixReport As String
'  Dim strWildSingleReport As String
'  Dim strWildManyReport As String
'  Dim strEscPrefixReport As String
'  Dim strEscSuffixReport As String
'
'  If strPrefix = "" Then
'    strPrefixReport = "<EMPTY>"
'  Else
'    strPrefixReport = Asc(strPrefix)
'  End If
'
'  If strSuffix = "" Then
'    strSuffixReport = "<EMPTY>"
'  Else
'    strSuffixReport = Asc(strSuffix)
'  End If
'
'  If strWildSingle = "" Then
'    strWildSingleReport = "<EMPTY>"
'  Else
'    strWildSingleReport = Asc(strWildSingle)
'  End If
'
'  If strWildMany = "" Then
'    strWildManyReport = "<EMPTY>"
'  Else
'    strWildManyReport = Asc(strWildMany)
'  End If
'
'  If strEscPrefix = "" Then
'    strEscPrefixReport = "<EMPTY>"
'  Else
'    strEscPrefixReport = Asc(strEscPrefix)
'  End If
'
'  If strEscSuffix = "" Then
'    strEscSuffixReport = "<EMPTY>"
'  Else
'    strEscSuffixReport = Asc(strEscSuffix)
'  End If
'
'  Debug.Print "strPrefix = " & strPrefix & "(ASCII = " & strPrefixReport & ")" & vbCrLf & _
'              "strSuffix = " & strSuffix & "(ASCII = " & strSuffixReport & ")" & vbCrLf & _
'              "strWildSingle = " & strWildSingle & "(ASCII = " & strWildSingleReport & ")" & vbCrLf & _
'              "strWildMany = " & strWildMany & "(ASCII = " & strWildManyReport & ")" & vbCrLf & _
'              "strEscPrefix = " & strEscPrefix & "(ASCII = " & strEscPrefixReport & ")" & vbCrLf & _
'              "strEscSuffix = " & strEscSuffix & "(ASCII = " & strEscSuffixReport & ")"
  
5964:   ReturnQuerySpecialCharacters = False
  
  Dim pWS As IWorkspace
5967:   Set pWS = pDataset.Workspace
  
  Dim pSQLSyntax As ISQLSyntax
5970:   Set pSQLSyntax = pWS
5971:   strPrefix = pSQLSyntax.GetSpecialCharacter(esriSQL_DelimitedIdentifierPrefix)
5972:   strSuffix = pSQLSyntax.GetSpecialCharacter(esriSQL_DelimitedIdentifierSuffix)
5973:   strWildcardSingleMatch = pSQLSyntax.GetSpecialCharacter(esriSQL_WildcardSingleMatch)
5974:   strWildlcardManyMatch = pSQLSyntax.GetSpecialCharacter(esriSQL_WildcardManyMatch)
5975:   strSQLEscapePrefix = pSQLSyntax.GetSpecialCharacter(esriSQL_EscapeKeyPrefix)
5976:   strSQLEscapeSuffix = pSQLSyntax.GetSpecialCharacter(esriSQL_EscapeKeySuffix)

5978:   ReturnQuerySpecialCharacters = True

  Exit Function
errHandler:
  
5983:   ReturnQuerySpecialCharacters = False
  
End Function

Public Function ReturnTitleCase(ByVal strString As String) As String
  On Error GoTo ErrorHandler

  
5991:   Do Until InStr(1, strString, "  ") = 0
5992:     strString = Replace(strString, "  ", " ")
5993:   Loop
  
  Dim strSplit() As String
5996:   strSplit = Split(strString, " ")
  Dim lngIndex As Long
  Dim strWord As String
5999:   For lngIndex = 0 To UBound(strSplit)
6000:     strWord = Trim(strSplit(lngIndex))
6001:     If Len(strWord) = 1 Then
      ReturnTitleCase = ReturnTitleCase & UCase(strWord) & " "
6003:     Else
      ReturnTitleCase = ReturnTitleCase & UCase(Left(strWord, 1)) & _
        LCase(Right(strWord, Len(strWord) - 1)) & " "
6006:     End If
6007:   Next lngIndex
  ReturnTitleCase = Left(ReturnTitleCase, Len(ReturnTitleCase) - 1)


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTitleCase " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReadTextFile(strFileName As String) As String
  On Error GoTo ErrorHandler


6020:   If Dir(strFileName) <> "" Then
  
    Dim lngFileNumber As Long
6023:     lngFileNumber = FreeFile(0)
'    MsgBox "Trying to open " & strFileName & " as " & CStr(lngFileNumber)
'
'    MsgBox "File Exists = " & CStr(PSN_Cell_Towers.aml_func_mod.ExistFileDir(strFileName))
    
    Dim strFileText As String
    
6030:     Open strFileName For Binary As #lngFileNumber
    
6032:     strFileText = Space$(LOF(lngFileNumber))
6033:     Get #lngFileNumber, , strFileText
    
6035:     Close #lngFileNumber
    
6037:     ReadTextFile = strFileText
6038:   Else
6039:     ReadTextFile = ""
6040:   End If


  Exit Function
ErrorHandler:
  HandleError True, "ReadTextFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function WriteTextFile(strFileName As String, strText As String, Optional booForceOverwrite As Boolean = False) As Boolean
  On Error GoTo ErrorHandler

  
  Dim lngFileNumber As Long
  
6054:   If Dir(strFileName) = "" Or booForceOverwrite Then
6055:     lngFileNumber = FreeFile(0)
    
6057:     Open strFileName For Output As #lngFileNumber

6059:     Print #lngFileNumber, strText
6060:     Close #lngFileNumber
6061:     WriteTextFile = True
6062:   Else
    ' CONFIRM WHETHER TO OVERWRITE FILE
    Dim lngVBResult As VbMsgBoxResult
    
6066:     lngVBResult = MsgBox("File Already Exists!" & vbCrLf & vbCrLf & "  --> " & strFileName & vbCrLf & vbCrLf & _
        "Click 'OK' to overwrite the file, or 'CANCEL' to quit...", vbOKCancel, "File Exists:")
6068:     If lngVBResult = vbOK Then
6069:       Kill strFileName
6070:       If Dir(strFileName) <> "" Then
6071:         MsgBox "Unable to delete " & strFileName & vbCrLf & vbCrLf & _
          "It may be open in another application.  Please delete this file manually or save the text to a new filename.", , "Unable to Delete File:"
6073:         WriteTextFile = False
6074:       Else
      
6076:         lngFileNumber = FreeFile(0)
        
6078:         Open strFileName For Output As #lngFileNumber
    
6080:         Print #lngFileNumber, strText
6081:         Close #lngFileNumber
6082:         WriteTextFile = True
6083:       End If
6084:     Else
6085:       WriteTextFile = False
6086:     End If
6087:   End If


  Exit Function
ErrorHandler:
  HandleError True, "WriteTextFile " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnFilesFromNestedFolders(ByVal strDir As String, strExtensionWithDot As String) As esriSystem.IStringArray
  On Error GoTo ErrorHandler

  
6099:   Set ReturnFilesFromNestedFolders = New esriSystem.strArray
    
6101:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
  
  Dim strOriginalDir As String
6104:   strOriginalDir = strDir
  
  Dim booFoundSubFolders As Boolean
      
  Dim pPathArray As esriSystem.IStringArray
6109:   Set pPathArray = New esriSystem.strArray
  
  Dim pFinalArray As esriSystem.IStringArray
6112:   Set pFinalArray = New esriSystem.strArray
  Dim pCheckColl As Collection
6114:   Set pCheckColl = New Collection
  
6116:   pFinalArray.Add strDir
6117:   pCheckColl.Add True, strDir
  
  Dim strDirName As String
    
6121:   strDirName = Dir(strDir, vbDirectory)   ' Retrieve the first entry.
6122:   Do While strDirName <> ""   ' Start the loop.
     ' Ignore the current directory and the encompassing directory.
6124:      If strDirName <> "." And strDirName <> ".." Then
        ' Use bitwise comparison to make sure MyName is a directory.
6126:         If (GetAttr(strDir & strDirName) And vbDirectory) = vbDirectory Then
6127:            pPathArray.Add strDir & strDirName & "\"
6128:            pFinalArray.Add strDir & strDirName & "\"
6129:            pCheckColl.Add False, strDir & strDirName & "\"
6130:         End If   ' it represents a directory.
6131:      End If
6132:      strDirName = Dir   ' Get next entry.
6133:   Loop
  
6135:   booFoundSubFolders = pPathArray.Count > 0
  ' If Not booFoundSubFolders Then Exit Function
  
  Dim strSubFolder As String
  
  Dim booFoundSubHere As Boolean
  Dim pSubArray As esriSystem.IStringArray
  
  Dim lngIndex As Long
  
6145:   Do While booFoundSubFolders
6146:     booFoundSubFolders = False
6147:     Set pSubArray = New esriSystem.strArray
    
6149:     For lngIndex = 0 To pPathArray.Count - 1
6150:       strSubFolder = pPathArray.Element(lngIndex)

'     If strDirName <> "." And strDirName <> ".." Then
'        lngCounter = lngCounter + 1

6155:       booFoundSubHere = False
6156:       strDirName = Dir(strSubFolder, vbDirectory)   ' Retrieve the first entry.
6157:       Do While strDirName <> ""   ' Start the loop.
         ' Ignore the current directory and the encompassing directory.
6159:          If strDirName <> "." And strDirName <> ".." Then
            ' Use bitwise comparison to make sure MyName is a directory.
6161:             If (GetAttr(strSubFolder & strDirName) And vbDirectory) = vbDirectory Then
6162:                pSubArray.Add strSubFolder & strDirName & "\"
6163:                booFoundSubFolders = True
6164:                booFoundSubHere = True
6165:                If Not CheckCollectionForKey(pCheckColl, strSubFolder & strDirName & "\") Then
6166:                  pCheckColl.Add 1, strSubFolder & strDirName & "\"
6167:                  pFinalArray.Add strSubFolder & strDirName & "\"
6168:                End If
6169:             End If   ' it represents a directory.
6170:          End If
6171:          strDirName = Dir   ' Get next entry.
6172:       Loop
      
6174:       If Not booFoundSubHere Then
6175:         pSubArray.Add strSubFolder
6176:       End If
      
6178:     Next lngIndex
    
6180:     If booFoundSubFolders Then
6181:       Set pPathArray = pSubArray
6182:     End If
    
6184:   Loop
  
  Dim strFolders() As String
  ReDim strFolders(pFinalArray.Count - 1)
  
  
6190:   For lngIndex = 0 To pFinalArray.Count - 1
6191:     strDir = pFinalArray.Element(lngIndex)
6192:     strFolders(lngIndex) = strDir
'    Debug.Print CStr(lngIndex + 1) & "]  " & strDir
6194:   Next lngIndex
  
6196:   QuickSort.StringsAscending strFolders, 0, pFinalArray.Count - 1
  
'  For lngIndex = 0 To UBound(strFolders)
'    strDir = strFolders(lngIndex)
'    Debug.Print CStr(lngIndex + 1) & "]  " & strDir
'  Next lngIndex

  Dim lngCounter As Long
6204:   lngCounter = 0

6206:   Debug.Print
  
  Dim pFolderFeatLayers As esriSystem.IVariantArray
  Dim pFileNames As esriSystem.IStringArray
6210:   Set pFolderFeatLayers = New esriSystem.VarArray
6211:   Set pFileNames = New esriSystem.strArray
  Dim strDirAndFile As String
  
6214:   For lngIndex = 0 To UBound(strFolders)
6215:     strDir = strFolders(lngIndex)
6216:     strDirName = Dir(strDir, vbNormal)   ' Retrieve the first entry.
6217:     lngCounter = lngCounter + 1

6219:     Do While strDirName <> ""   ' Start the loop.
       ' Ignore the current directory and the encompassing directory.
6221:        If strDirName <> "." And strDirName <> ".." Then
6222:           strDirAndFile = strDir & strDirName

6224:           If (GetAttr(strDirAndFile) And vbNormal) = vbNormal Then
6225:             If StrComp(Right(strDirAndFile, Len(strExtensionWithDot)), strExtensionWithDot, vbTextCompare) = 0 Then

'             Debug.Print "Examining Folder #" & CStr(lngCounter) & ":  " & strDirName
6228:               pFileNames.Add strDirAndFile
'             Debug.Print "  --> " & pDataset.BrowseName
6230:             End If
6231:           End If
6232:        End If
6233:        strDirName = Dir   ' Get next entry.
6234:     Loop
6235:   Next lngIndex

  ' CONFIRM THAT CORRECT DIRECTORY HAS BEEN SELECTED AND THAT IT ACTUALLY HAS POLYLINE SHAPEFILES
6238:   Set ReturnFilesFromNestedFolders = pFileNames
  
6240:   Set pPathArray = Nothing
6241:   Set pFinalArray = Nothing
6242:   Set pCheckColl = Nothing
6243:   Set pSubArray = Nothing
6244:   Set pFolderFeatLayers = Nothing
6245:   Set pFileNames = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "ReturnFilesFromNestedFolders " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnShapefileLayersFromNestedFolders(ByVal strDir As String, _
    lngType As esriGeometryType) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  
6258:   Set ReturnShapefileLayersFromNestedFolders = New esriSystem.VarArray
  
  
6261:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
  
  Dim strOriginalDir As String
6264:   strOriginalDir = strDir
  
  Dim booFoundSubFolders As Boolean
      
  Dim pPathArray As esriSystem.IStringArray
6269:   Set pPathArray = New esriSystem.strArray
  
  Dim pFinalArray As esriSystem.IStringArray
6272:   Set pFinalArray = New esriSystem.strArray
  Dim pCheckColl As Collection
6274:   Set pCheckColl = New Collection
  
6276:   pFinalArray.Add strDir
6277:   pCheckColl.Add True, strDir
  
  Dim strDirName As String
    
6281:   strDirName = Dir(strDir, vbDirectory)   ' Retrieve the first entry.
6282:   Do While strDirName <> ""   ' Start the loop.
     ' Ignore the current directory and the encompassing directory.
6284:      If strDirName <> "." And strDirName <> ".." Then
        ' Use bitwise comparison to make sure MyName is a directory.
6286:         If (GetAttr(strDir & strDirName) And vbDirectory) = vbDirectory Then
6287:            pPathArray.Add strDir & strDirName & "\"
6288:            pFinalArray.Add strDir & strDirName & "\"
6289:            pCheckColl.Add False, strDir & strDirName & "\"
6290:         End If   ' it represents a directory.
6291:      End If
6292:      strDirName = Dir   ' Get next entry.
6293:   Loop
  
6295:   booFoundSubFolders = pPathArray.Count > 0
  ' If Not booFoundSubFolders Then Exit Function
  
  Dim strSubFolder As String
  
  Dim booFoundSubHere As Boolean
  Dim pSubArray As esriSystem.IStringArray
  
  Dim lngIndex As Long
  
6305:   Do While booFoundSubFolders
6306:     booFoundSubFolders = False
6307:     Set pSubArray = New esriSystem.strArray
    
6309:     For lngIndex = 0 To pPathArray.Count - 1
6310:       strSubFolder = pPathArray.Element(lngIndex)

'     If strDirName <> "." And strDirName <> ".." Then
'        lngCounter = lngCounter + 1

6315:       booFoundSubHere = False
6316:       strDirName = Dir(strSubFolder, vbDirectory)   ' Retrieve the first entry.
6317:       Do While strDirName <> ""   ' Start the loop.
         ' Ignore the current directory and the encompassing directory.
6319:          If strDirName <> "." And strDirName <> ".." Then
            ' Use bitwise comparison to make sure MyName is a directory.
6321:             If (GetAttr(strSubFolder & strDirName) And vbDirectory) = vbDirectory Then
6322:                pSubArray.Add strSubFolder & strDirName & "\"
6323:                booFoundSubFolders = True
6324:                booFoundSubHere = True
6325:                If Not CheckCollectionForKey(pCheckColl, strSubFolder & strDirName & "\") Then
6326:                  pCheckColl.Add 1, strSubFolder & strDirName & "\"
6327:                  pFinalArray.Add strSubFolder & strDirName & "\"
6328:                End If
6329:             End If   ' it represents a directory.
6330:          End If
6331:          strDirName = Dir   ' Get next entry.
6332:       Loop
      
6334:       If Not booFoundSubHere Then
6335:         pSubArray.Add strSubFolder
6336:       End If
      
6338:     Next lngIndex
    
6340:     If booFoundSubFolders Then
6341:       Set pPathArray = pSubArray
6342:     End If
    
6344:   Loop
  
  Dim strFolders() As String
  ReDim strFolders(pFinalArray.Count - 1)
  
  
6350:   For lngIndex = 0 To pFinalArray.Count - 1
6351:     strDir = pFinalArray.Element(lngIndex)
6352:     strFolders(lngIndex) = strDir
'    Debug.Print CStr(lngIndex + 1) & "]  " & strDir
6354:   Next lngIndex
  
6356:   QuickSort.StringsAscending strFolders, 0, pFinalArray.Count - 1
  
'  For lngIndex = 0 To UBound(strFolders)
'    strDir = strFolders(lngIndex)
'    Debug.Print CStr(lngIndex + 1) & "]  " & strDir
'  Next lngIndex

  Dim lngCounter As Long
6364:   lngCounter = 0

6366:   Debug.Print

  Dim pShapefilePaths As esriSystem.IStringArray
6369:   Set pShapefilePaths = New esriSystem.strArray

  Dim pWS As IFeatureWorkspace
  Dim pWsFact As IWorkspaceFactory2
6373:   Set pWsFact = New ShapefileWorkspaceFactory
  Dim pFClass As IFeatureClass
  
  Dim pFolderFeatLayers As esriSystem.IVariantArray
  Dim pShapefileNames As esriSystem.IStringArray
6378:   Set pFolderFeatLayers = New esriSystem.VarArray
6379:   Set pShapefileNames = New esriSystem.strArray
  Dim pFLayer As IFeatureLayer
  Dim pDataset As IDataset
  Dim strDirAndFile As String
  
6384:   For lngIndex = 0 To UBound(strFolders)
6385:     strDir = strFolders(lngIndex)
6386:     strDirName = Dir(strDir, vbNormal)   ' Retrieve the first entry.
6387:     lngCounter = lngCounter + 1

6389:     Set pWS = pWsFact.OpenFromFile(strDir, 0) ' Me.hWnd)

6391:     Do While strDirName <> ""   ' Start the loop.
       ' Ignore the current directory and the encompassing directory.
6393:        If strDirName <> "." And strDirName <> ".." Then
6394:           strDirAndFile = strDir & strDirName

6396:           If (GetAttr(strDirAndFile) And vbNormal) = vbNormal Then
6397:             If StrComp(Right(strDirAndFile, 4), ".shp", vbTextCompare) = 0 Then

'              Debug.Print "Examining Folder #" & CStr(lngCounter) & ":  " & strDirName

6401:               Set pFClass = pWS.OpenFeatureClass(strDirName)
6402:               If pFClass.ShapeType = lngType Then
6403:                 Set pFLayer = New FeatureLayer
6404:                 Set pFLayer.FeatureClass = pFClass
6405:                 Set pDataset = pFClass
6406:                 pFLayer.Name = pDataset.BrowseName
6407:                 pFolderFeatLayers.Add pFLayer
6408:                 pShapefileNames.Add strDirAndFile
'                Debug.Print "  --> " & pDataset.BrowseName
6410:               End If
6411:             End If
6412:           End If
6413:        End If
6414:        strDirName = Dir   ' Get next entry.
6415:     Loop
6416:   Next lngIndex

  ' CONFIRM THAT CORRECT DIRECTORY HAS BEEN SELECTED AND THAT IT ACTUALLY HAS POLYLINE SHAPEFILES
6419:   Set ReturnShapefileLayersFromNestedFolders = pFolderFeatLayers
  
6421:   Set pPathArray = Nothing
6422:   Set pFinalArray = Nothing
6423:   Set pCheckColl = Nothing
6424:   Set pSubArray = Nothing
6425:   Set pShapefilePaths = Nothing
6426:   Set pWS = Nothing
6427:   Set pWsFact = Nothing
6428:   Set pFClass = Nothing
6429:   Set pFolderFeatLayers = Nothing
6430:   Set pShapefileNames = Nothing
6431:   Set pFLayer = Nothing
6432:   Set pDataset = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "ReturnShapefileLayersFromNestedFolders " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnFeatureLayersFromGeoDatabase(pFeatWS As IFeatureWorkspace, _
    lngType As esriGeometryType) As esriSystem.IVariantArray
  
  On Error GoTo errHandler
  
6445:   Set ReturnFeatureLayersFromGeoDatabase = New esriSystem.VarArray
  Dim pWS As IWorkspace
6447:   Set pWS = pFeatWS
  
  Dim pDatasets As IEnumDataset
6450:   Set pDatasets = pWS.Datasets(esriDTFeatureClass)
6451:   pDatasets.Reset
  
  Dim pDataset As IDataset
  Dim pFClass As IFeatureClass
6455:   Set pDataset = pDatasets.Next
  Dim pFLayer As IFeatureLayer
  
6458:   Do Until pDataset Is Nothing
6459:     Set pFClass = pDataset
6460:     If pFClass.ShapeType = lngType Then
6461:       Set pFLayer = New FeatureLayer
6462:       Set pFLayer.FeatureClass = pFClass
6463:       pFLayer.Name = pDataset.BrowseName
6464:       ReturnFeatureLayersFromGeoDatabase.Add pFLayer
6465:     End If
6466:     Set pDataset = pDatasets.Next
6467:   Loop
  
6469:   Set pWS = Nothing
6470:   Set pDatasets = Nothing
6471:   Set pDataset = Nothing
6472:   Set pFClass = Nothing
6473:   Set pFLayer = Nothing
 
  Exit Function

errHandler:
6478:   Set ReturnFeatureLayersFromGeoDatabase = New esriSystem.VarArray
  
6480:   Set pWS = Nothing
6481:   Set pDatasets = Nothing
6482:   Set pDataset = Nothing
6483:   Set pFClass = Nothing
6484:   Set pFLayer = Nothing

End Function

Public Function ReturnRasterDatasetOrNothing(pWS As IRasterWorkspace, strFileName As String) As IRasterDataset
  On Error GoTo errHandler
  
6491:   Set ReturnRasterDatasetOrNothing = Nothing
6492:   Set ReturnRasterDatasetOrNothing = pWS.OpenRasterDataset(strFileName)

  Exit Function
errHandler:
6496:   Set ReturnRasterDatasetOrNothing = Nothing

End Function
Public Function ReturnFeatureClassOrNothing(pWS As IFeatureWorkspace, strFileName As String) As IFeatureClass
  On Error GoTo errHandler
  
6502:   Set ReturnFeatureClassOrNothing = Nothing
6503:   Set ReturnFeatureClassOrNothing = pWS.OpenFeatureClass(strFileName)

  Exit Function
errHandler:
6507:   Set ReturnFeatureClassOrNothing = Nothing

End Function
Public Function ReturnTableOrNothing(pWS As IFeatureWorkspace, strFileName As String) As ITable
  On Error GoTo errHandler
  
6513:   Set ReturnTableOrNothing = Nothing
6514:   Set ReturnTableOrNothing = pWS.OpenTable(strFileName)

  Exit Function
errHandler:
6518:   Set ReturnTableOrNothing = Nothing

End Function

Public Function ConvertNumberToBullet(lngNumber As Long, lngBulletType As JenBulletTypes) As String
  On Error GoTo ErrorHandler


  Dim strReturn As String
6527:   If lngNumber < 1 Then
6528:     ConvertNumberToBullet = "Invalid Number..."
6529:   Else
    Select Case lngBulletType
      Case ENUM_Letter_Lowercase, ENUM_Letter_Uppercase
      
        Dim lngMod As Long
        Dim lngRemainder As Long
        
6536:         lngRemainder = lngNumber
6537:         strReturn = ""
6538:         Do While lngRemainder > 0
6539:           lngMod = (lngRemainder - 1) Mod 26
6540:           strReturn = Chr(65 + lngMod) & strReturn
6541:           lngRemainder = Int((lngRemainder - lngMod) / 26)
6542:         Loop
6543:         If lngBulletType = ENUM_Letter_Lowercase Then strReturn = LCase(strReturn)

      
      Case ENUM_RomanNumeral_Lowercase
6547:         strReturn = ConvertNumberToRoman(lngNumber, False)
      
      Case ENUM_RomanNumeral_Uppercase
6550:         strReturn = ConvertNumberToRoman(lngNumber, True)
6551:     End Select
    
6553:     ConvertNumberToBullet = strReturn
6554:   End If


  Exit Function
ErrorHandler:
  HandleError True, "ConvertNumberToBullet " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Function ConvertNumberBase(InputNum As Long, BaseNum As Long) As Long()
  On Error GoTo ErrorHandler

  
  ' MODIFIED FROM http://support.microsoft.com/kb/135635
  
  Dim quotient, remainder As Long
  Dim strCounters As String
  
  Dim lngCounters() As Long
6571:   If BaseNum <= 1 Then
    ReDim lngCounters(0)
6573:     lngCounters(0) = -999
6574:   Else
    
6576:     quotient = InputNum   ' Set quotient to number to convert.
6577:     remainder = InputNum  ' Set remainder to number to convert.
6578:     strCounters = ""
  
6580:     Do While quotient <> 0   ' Loop while quotient is not zero.
  
       ' Store the remainder of the quotient divided by base number in a
       ' variable called remainder.
6584:        remainder = quotient Mod BaseNum
  
       ' Reset quotient variable to the integer value of the quotient
       ' divided by base number.
6588:        quotient = Int(quotient / BaseNum)
  
       ' Reset strCounters to contain remainder and the previous strCounters.
6591:        strCounters = remainder & "," & strCounters
  
6593:     Loop
6594:     If strCounters = "" Then strCounters = "0"
6595:     If Right(strCounters, 1) = "," Then strCounters = Left(strCounters, Len(strCounters) - 1)
    
'    Debug.Print strCounters
    
    Dim strArray() As String
6600:     strArray = Split(strCounters, ",")
    
    ReDim lngCounters(UBound(strArray))
    Dim lngIndex As Long
6604:     For lngIndex = 0 To UBound(strArray)
6605:       lngCounters(lngIndex) = CLng(strArray(lngIndex))
'      Debug.Print "  --> Array Index = " & CStr(lngIndex) & ":  Value = " & CStr(CLng(strArray(lngIndex)))
6607:     Next lngIndex
6608:   End If
  
6610:   ConvertNumberBase = lngCounters   ' Convert strCounters variable to a number.


  Exit Function
ErrorHandler:
  HandleError True, "ConvertNumberBase " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ConvertNumberToRoman(ByVal lngNumber As Long, Optional booUppercase As Boolean = False) As String
  On Error GoTo ErrorHandler


  ' Formats a number as a roman numeral.
  ' Author: Christian d'Heureuse (www.source-code.biz)
  ' http://www.source-code.biz/snippets/vbasic/7.htm
  ' MODIFIED BY JEFF JENNESS
  
   If lngNumber = 0 Then ConvertNumberToRoman = "0": Exit Function
      ' There is no roman symbol for 0, but we don't want to return an empty string.
   
   ' roman symbols
   Dim r As String
   Dim strThousands As String
   
6634:    If booUppercase Then
6635:      r = "IVXLCDM"
6636:      strThousands = "M"
6637:    Else
6638:      r = "ivxlcdm"
6639:      strThousands = "m"
6640:    End If
   
   Dim i As Long: i = Abs(lngNumber)
   Dim s As String, p As Integer
6644:    For p = 1 To 5 Step 2
      Dim d As Integer: d = i Mod 10: i = i \ 10
      Select Case d                 ' format a decimal digit
         Case 0 To 3: s = String(d, Mid(r, p, 1)) & s
         Case 4:      s = Mid(r, p, 2) & s
         Case 5 To 8: s = Mid(r, p + 1, 1) & String(d - 5, Mid(r, p, 1)) & s
         Case 9:      s = Mid(r, p, 1) & Mid(r, p + 2, 1) & s
6651:          End Select
6652:       Next
6653:    s = String(i, strThousands) & s           ' format thousands
6654:    If lngNumber < 0 Then s = "-" & s        ' insert sign if negative (non-standard)
6655:    ConvertNumberToRoman = s


  Exit Function
ErrorHandler:
  HandleError True, "ConvertNumberToRoman " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Sub Move_Element(pElement As IElement, pFromPoint As IPoint, pToPoint As IPoint)
  On Error GoTo ErrorHandler

  
  ' EXAMPLE: TO MOVE A GRAPHIC ELEMENT SO IT IS CENTERED IN THE PAGE LAYOUT, DO THE FOLLOWING:
  ' Move_Element pGroupElement, Get_Element_Or_Envelope_Point(pElement, ENUM_Center_Center), _
      Get_Element_Or_Envelope_Point(pLayoutExtent, ENUM_By_Percentages, 0.5, 0.5)
  
    
    Dim pTrans2D As ITransform2D
6674:     Set pTrans2D = pElement

6676:     pTrans2D.Move (pToPoint.X - pFromPoint.X), _
                  (pToPoint.Y - pFromPoint.Y)
    
6679:     Set pTrans2D = Nothing


  Exit Sub
ErrorHandler:
  HandleError True, "Move_Element " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub ' Move_Legend

Public Function Get_Element_Or_Envelope_Point(pElementOrEnvelope As IUnknown, lngAnchorPoint As Jen_ElementEnvPoint, _
  Optional dblXPercent As Double = 0.5, Optional dblYPercent As Double = 0.5, Optional pActiveView As IActiveView) As IPoint
  On Error GoTo ErrorHandler


  ' Initialize the output for this procedure...
  Dim theOutput As IPoint
6694:   Set theOutput = Nothing
  Dim pEnv As IEnvelope
  
6697:   If TypeOf pElementOrEnvelope Is IElement Then
    Dim pTemp As IElement
6699:     Set pTemp = pElementOrEnvelope
6700:     If pActiveView Is Nothing Then
6701:       Set pEnv = pTemp.Geometry.Envelope
6702:     Else
6703:       Set pEnv = New Envelope
6704:       pTemp.QueryBounds pActiveView.ScreenDisplay, pEnv
6705:     End If
6706:   Else
6707:     Set pEnv = pElementOrEnvelope
6708:   End If

  Select Case lngAnchorPoint
    Case ENUM_Upper_Left  ' UPPER LEFT CORNER
6712:         Set theOutput = pEnv.UpperLeft
    Case ENUM_Upper_Right  ' UPPER RIGHT CORNER
6714:         Set theOutput = pEnv.UpperRight
    Case ENUM_Lower_Left ' LOWER LEFT CORNER
6716:         Set theOutput = pEnv.LowerLeft
    Case ENUM_Lower_Right  ' LOWER RIGHT CORNER
6718:         Set theOutput = pEnv.LowerRight
    Case ENUM_Upper_Center  ' VERTICAL TOP, HORIZONTAL CENTER
6720:         Set theOutput = New Point
6721:         theOutput.PutCoords ((pEnv.XMax - pEnv.XMin) / 2) + pEnv.XMin, pEnv.YMax
6722:         Set theOutput.SpatialReference = pEnv.SpatialReference
    Case ENUM_Lower_Center  ' VERTICAL BOTTOM, HORIZONTAL CENTER
6724:         Set theOutput = New Point
6725:         theOutput.PutCoords ((pEnv.XMax - pEnv.XMin) / 2) + pEnv.XMin, pEnv.YMin
6726:         Set theOutput.SpatialReference = pEnv.SpatialReference
    Case ENUM_Center_Left  ' VERTICAL CENTER, HORIZONTAL LEFT
6728:         Set theOutput = New Point
6729:         theOutput.PutCoords pEnv.XMin, ((pEnv.YMax - pEnv.YMin) / 2) + pEnv.YMin
6730:         Set theOutput.SpatialReference = pEnv.SpatialReference
    Case ENUM_Center_Right  ' VERTICAL CENTER, HORIZONTAL RIGHT
6732:         Set theOutput = New Point
6733:         theOutput.PutCoords pEnv.XMax, ((pEnv.YMax - pEnv.YMin) / 2) + pEnv.YMin
6734:         Set theOutput.SpatialReference = pEnv.SpatialReference
    Case ENUM_Center_Center  ' VERTICAL CENTER, HORIZONTAL CENTER
6736:         Set theOutput = New Point
6737:         theOutput.PutCoords ((pEnv.XMax - pEnv.XMin) / 2) + pEnv.XMin, ((pEnv.YMax - pEnv.YMin) / 2) + pEnv.YMin
6738:         Set theOutput.SpatialReference = pEnv.SpatialReference
    Case ENUM_By_Percentages
6740:         Set theOutput = New Point
6741:         theOutput.PutCoords ((pEnv.XMax - pEnv.XMin) * dblXPercent) + pEnv.XMin, ((pEnv.YMax - pEnv.YMin) * dblYPercent) + pEnv.YMin
6742:         Set theOutput.SpatialReference = pEnv.SpatialReference
    Case Else
6744:         MsgBox "position not supported: " & CLng(lngAnchorPoint)
6745:   End Select

  ' Return the output for this procedure...
6748:   Set Get_Element_Or_Envelope_Point = theOutput
  
6750:   Set theOutput = Nothing
6751:   Set pEnv = Nothing
6752:   Set pTemp = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "Get_Element_Or_Envelope_Point " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function ' Get_Element_Or_Envelope_Point

Public Function ReturnGraphicsByNameFromLayout(pMxDoc As IMxDocument, strName As String, _
      Optional AsElements As Boolean) As IArray
  On Error GoTo ErrorHandler


  Dim pGraphicsContainer As IGraphicsContainer
  
6767:   Set pGraphicsContainer = pMxDoc.PageLayout
  
6769:   pGraphicsContainer.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
6774:   Set pElement = pGraphicsContainer.Next
  
  Dim pArray As IArray
6777:   Set pArray = New esriSystem.Array
  Dim pGeometry As IGeometry
  Dim pClone As IClone
  
6781:   While Not pElement Is Nothing
6782:     Set pElementProperties = pElement
6783:     If StrComp(pElementProperties.Name, strName, vbTextCompare) = 0 Then
6784:       If AsElements Then
6785:         pArray.Add pElement
6786:       Else
6787:         Set pGeometry = pElement.Geometry
6788:         Set pClone = pGeometry
6789:         pArray.Add pClone.Clone     ' ONLY RETURN A COPY OF THE GEOMETRY; DON'T WANT TO MODIFY ACTUAL GRAPHIC HERE
6790:       End If
6791:     End If
6792:     Set pElement = pGraphicsContainer.Next
    
6794:   Wend
6795:   Set ReturnGraphicsByNameFromLayout = pArray


  Exit Function
ErrorHandler:
  HandleError True, "ReturnGraphicsByNameFromLayout " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Sub Move_Geometry(pGeometry As IGeometry, pFromPoint As IPoint, pToPoint As IPoint)
  On Error GoTo ErrorHandler

  
  ' EXAMPLE: TO MOVE A GRAPHIC ELEMENT SO ITS TOP LEFT CORNER TOUCHES ANOTHER POINT, DO THE FOLLOWING:
  ' Move_Geometry pPolygon, Get_Element_Or_Envelope_Point(pElement, ENUM_Upper_Left), _
      pDestinationPoint
  
    
    Dim pTrans2D As ITransform2D
6812:     Set pTrans2D = pGeometry

6814:     pTrans2D.Move (pToPoint.X - pFromPoint.X), _
                  (pToPoint.Y - pFromPoint.Y)
    
6817:     Set pTrans2D = Nothing


  Exit Sub
ErrorHandler:
  HandleError True, "Move_Geometry " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub ' Move_Legend

Public Function CreateSpatialReferenceWGS84() As ISpatialReference
  On Error GoTo ErrorHandler

  
  Dim pWGS84 As IGeographicCoordinateSystem
  Dim pSpatRefFact As ISpatialReferenceFactory
6831:   Set pSpatRefFact = New SpatialReferenceEnvironment
6832:   Set pWGS84 = pSpatRefFact.CreateGeographicCoordinateSystem(esriSRGeoCS_WGS1984)
  Dim pSpRefRes As ISpatialReferenceResolution
6834:   Set pSpRefRes = pWGS84
6835:   pSpRefRes.ConstructFromHorizon
  
6837:   Set CreateSpatialReferenceWGS84 = pWGS84
  
6839:   Set pWGS84 = Nothing
6840:   Set pSpatRefFact = Nothing
6841:   Set pSpRefRes = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "CreateSpatialReferenceWGS84 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateSpatialReferenceNAD83() As ISpatialReference
  On Error GoTo ErrorHandler

  
  Dim pNAD83 As IGeographicCoordinateSystem
  Dim pSpatRefFact As ISpatialReferenceFactory
6855:   Set pSpatRefFact = New SpatialReferenceEnvironment
6856:   Set pNAD83 = pSpatRefFact.CreateGeographicCoordinateSystem(esriSRGeoCS_NAD1983)
  Dim pSpRefRes As ISpatialReferenceResolution
6858:   Set pSpRefRes = pNAD83
6859:   pSpRefRes.ConstructFromHorizon
  
6861:   Set CreateSpatialReferenceNAD83 = pNAD83
  
6863:   Set pNAD83 = Nothing
6864:   Set pSpatRefFact = Nothing
6865:   Set pSpRefRes = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "CreateSpatialReferenceNAD83 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function CreateSpatialReferenceNAD27() As ISpatialReference
  On Error GoTo ErrorHandler

  
  Dim pNAD27 As IGeographicCoordinateSystem
  Dim pSpatRefFact As ISpatialReferenceFactory
6878:   Set pSpatRefFact = New SpatialReferenceEnvironment
6879:   Set pNAD27 = pSpatRefFact.CreateGeographicCoordinateSystem(esriSRGeoCS_NAD1927)
  Dim pSpRefRes As ISpatialReferenceResolution
6881:   Set pSpRefRes = pNAD27
6882:   pSpRefRes.ConstructFromHorizon
  
6884:   Set CreateSpatialReferenceNAD27 = pNAD27
  
6886:   Set pNAD27 = Nothing
6887:   Set pSpatRefFact = Nothing
6888:   Set pSpRefRes = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "CreateSpatialReferenceNAD27 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateNAD27_WGS84_GeoTransformationFlagstaff() As IGeoTransformation
  On Error GoTo ErrorHandler


  Dim pSpRefFact As ISpatialReferenceFactory2
6901:   Set pSpRefFact = New SpatialReferenceEnvironment
  
  Dim pTransformType As esriSRGeoTransformationType
6904:   pTransformType = esriSRGeoTransformation_NAD1927_To_WGS1984_4
  
  Dim pGeoTransform As IGeoTransformation
6907:   Set pGeoTransform = pSpRefFact.CreateGeoTransformation(pTransformType)
6908:   Set CreateNAD27_WGS84_GeoTransformationFlagstaff = pGeoTransform
  
  
'  Dim pFromSpRef As ISpatialReference
'  Dim pToSpRef As ISpatialReference
'  pGeoTransform.GetSpatialReferences pFromSpRef, pToSpRef
'  Debug.Print "CreateNAD27_WGS84_GeoTransformationFlagstaff" & vbCrLf & _
'              "  --> From " & CStr(pFromSpRef.Name) & vbCrLf & _
'              "  --> To " & CStr(pToSpRef.Name)
6917:   Set pSpRefFact = Nothing
6918:   Set pGeoTransform = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "CreateNAD27_WGS84_GeoTransformationFlagstaff " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateNAD83_WGS84_GeoTransformationFlagstaff() As IGeoTransformation
  On Error GoTo ErrorHandler


  Dim pSpRefFact As ISpatialReferenceFactory2
6931:   Set pSpRefFact = New SpatialReferenceEnvironment
  
  Dim pTransformType As esriSRGeoTransformationType
6934:   pTransformType = esriSRGeoTransformation_NAD1983_To_WGS1984_5
  
  Dim pGeoTransform As IGeoTransformation
6937:   Set pGeoTransform = pSpRefFact.CreateGeoTransformation(pTransformType)
6938:   Set CreateNAD83_WGS84_GeoTransformationFlagstaff = pGeoTransform
  
  
'  Dim pFromSpRef As ISpatialReference
'  Dim pToSpRef As ISpatialReference
'  pGeoTransform.GetSpatialReferences pFromSpRef, pToSpRef
'  Debug.Print "CreateNAD83_WGS84_GeoTransformationFlagstaff" & vbCrLf & _
'              "  --> From " & CStr(pFromSpRef.Name) & vbCrLf & _
'              "  --> To " & CStr(pToSpRef.Name)
  
6948:   Set pSpRefFact = Nothing
6949:   Set pGeoTransform = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "CreateNAD83_WGS84_GeoTransformationFlagstaff " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateNAD27_NAD83_GeoTransformationFlagstaff() As IGeoTransformation
  On Error GoTo ErrorHandler


  Dim pSpRefFact As ISpatialReferenceFactory2
6962:   Set pSpRefFact = New SpatialReferenceEnvironment
  
  Dim pTransformType As esriSRGeoTransformation2Type
6965:   pTransformType = esriSRGeoTransformation_NAD_1927_TO_NAD_1983_NADCON
  
  Dim pGeoTransform As IGeoTransformation
6968:   Set pGeoTransform = pSpRefFact.CreateGeoTransformation(pTransformType)
6969:   Set CreateNAD27_NAD83_GeoTransformationFlagstaff = pGeoTransform
  
  
'  Dim pFromSpRef As ISpatialReference
'  Dim pToSpRef As ISpatialReference
'  pGeoTransform.GetSpatialReferences pFromSpRef, pToSpRef
'  Debug.Print "CreateNAD27_NAD83_GeoTransformationFlagstaff" & vbCrLf & _
'              "  --> From " & CStr(pFromSpRef.Name) & vbCrLf & _
'              "  --> To " & CStr(pToSpRef.Name)
6978:   Set pSpRefFact = Nothing
6979:   Set pGeoTransform = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "CreateNAD27_NAD83_GeoTransformationFlagstaff " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Function MakeESRIColor(pCurrColor As IRgbColor, hParentWind As OLE_HANDLE, booCanceled As Boolean, _
  Optional lngTop As Long = 100, Optional lngLeft As Long = 500, _
  Optional lngRight As Long = 100, Optional lngBottom As Long = 500, _
  Optional lngAlignOption As Jen_AlignColorDialogOption = ENUM_AlignBeneathRectangle) As IColor
  On Error GoTo ErrorHandler


  ' ADAPTED FROM:
  ' http://help.arcgis.com/en/sdk/10.0/vba_desktop/componenthelp/index.html#/IColorPalette_Interface/001t0000005v000000/
  ' http://forums.esri.com/thread.asp?c=93&f=1154&t=58833
  
6998:   If lngAlignOption = ENUM_AlignBeneathRectangle Then
6999:     lngBottom = lngBottom + 1
7000:     lngLeft = lngLeft + 2
7001:   Else
7002:     lngRight = lngRight + 3
7003:   End If
  
  Dim pRect As tagRECT
7006:   pRect.Top = lngTop
7007:   pRect.Left = lngLeft
7008:   pRect.Right = lngRight
7009:   pRect.Bottom = lngBottom
  
'  Dim pColorSet As ISet
'  Set pColorSet = New esriSystem.Set
'  Dim pRGB As IColor
'  Set pRGB = New RgbColor
'  pRGB.RGB = RGB(pCurrColor.Red, 0, 0)
'  pColorSet.Add pRGB
'  Set pRGB = New RgbColor
'  pRGB.RGB = RGB(0, pCurrColor.Green, 0)
'  pColorSet.Add pRGB
'  Set pRGB = New RgbColor
'  pRGB.RGB = RGB(0, 0, pCurrColor.Blue)
'  pColorSet.Add pRGB
'
'  Dim pCustomColorPalette As ICustomColorPalette
'  Set pCustomColorPalette = New ColorPalette
'  Set pCustomColorPalette.ColorSet = pColorSet

  Dim pMyPalette As IColorPalette
7029:   Set pMyPalette = New ColorPalette ' pCustomColorPalette
  '
  ' Now show the Palette dialog.
  '
7033:   If Not pMyPalette.TrackPopupMenu(pRect, pCurrColor, lngAlignOption = ENUM_AlignToRightOfRectangle, hParentWind) Then
7034:      booCanceled = True
7035:   Else
    '
    ' We can retrieve the selected color from the Color property.
    '
7039:     Set MakeESRIColor = pMyPalette.Color
7040:     booCanceled = False
7041:   End If

7043:   Set pMyPalette = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "MakeESRIColor " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ReturnShapeTypeNameFromObject(pUnknown As IUnknown) As String()
  On Error GoTo ErrorHandler

  
  Dim strReturn() As String
  ReDim strReturn(1)
  
  Dim varGeomType As esriGeometryType
  Dim pFClass As IFeatureClass
  Dim pGeom As IGeometry
  
7063:   If TypeOf pUnknown Is IFeatureClass Then
7064:     Set pFClass = pUnknown
7065:     varGeomType = pFClass.ShapeType
7066:     strReturn = ReturnShapeTypeFromGeomType(varGeomType)
7067:   ElseIf TypeOf pUnknown Is IGeometry Then
7068:     Set pGeom = pUnknown
7069:     varGeomType = pGeom.GeometryType
7070:     strReturn = ReturnShapeTypeFromGeomType(varGeomType)
7071:   Else
7072:     strReturn(0) = "Unknown Object Type"
7073:     strReturn(1) = "Unknown Object Type"
7074:   End If
  
7076:   ReturnShapeTypeNameFromObject = strReturn


  Exit Function
ErrorHandler:
  HandleError True, "ReturnShapeTypeNameFromObject " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnShapeTypeFromGeomType(varShapeType As esriGeometryType) As String()
  On Error GoTo ErrorHandler


  Dim strReturn() As String
  ReDim strReturn(1)
  
  Select Case varShapeType
    Case esriGeometryNull
7093:       strReturn(0) = "Null"
7094:       strReturn(1) = "Null"
    Case esriGeometryPoint
7096:       strReturn(0) = "Point"
7097:       strReturn(1) = "Points"
    Case esriGeometryMultipoint
7099:       strReturn(0) = "Multipoint"
7100:       strReturn(1) = "Multipoints"
    Case esriGeometryLine
7102:       strReturn(0) = "Line"
7103:       strReturn(1) = "Lines"
    Case esriGeometryCircularArc
7105:       strReturn(0) = "CircularArc"
7106:       strReturn(1) = "CircularArcs"
    Case esriGeometryEllipticArc
7108:       strReturn(0) = "EllipticArc"
7109:       strReturn(1) = "EllipticArcs"
    Case esriGeometryBezier3Curve
7111:       strReturn(0) = "Bezier3Curve"
7112:       strReturn(1) = "Bezier3Curves"
    Case esriGeometryPath
7114:       strReturn(0) = "Path"
7115:       strReturn(1) = "Paths"
    Case esriGeometryPolyline
7117:       strReturn(0) = "Polyline"
7118:       strReturn(1) = "Polylines"
    Case esriGeometryRing
7120:       strReturn(0) = "Ring"
7121:       strReturn(1) = "Rings"
    Case esriGeometryPolygon
7123:       strReturn(0) = "Polygon"
7124:       strReturn(1) = "Polygons"
    Case esriGeometryEnvelope
7126:       strReturn(0) = "Envelope"
7127:       strReturn(1) = "Envelopes"
    Case esriGeometryAny
7129:       strReturn(0) = "Any"
7130:       strReturn(1) = "Any"
    Case esriGeometryBag
7132:       strReturn(0) = "GeometryBag"
7133:       strReturn(1) = "GeometryBagx"
    Case esriGeometryMultiPatch
7135:       strReturn(0) = "MultiPatch"
7136:       strReturn(1) = "MultiPatches"
    Case esriGeometryTriangleStrip
7138:       strReturn(0) = "TriangleStrip"
7139:       strReturn(1) = "TriangleStrips"
    Case esriGeometryTriangleFan
7141:       strReturn(0) = "TriangleFan"
7142:       strReturn(1) = "TriangleFans"
    Case esriGeometryRay
7144:       strReturn(0) = "Ray"
7145:       strReturn(1) = "Rays"
    Case esriGeometrySphere
7147:       strReturn(0) = "Sphere"
7148:       strReturn(1) = "Spheres"
    Case esriGeometryTriangles
7150:       strReturn(0) = "Triangle"
7151:       strReturn(1) = "Triangles"
    Case Else
7153:       strReturn(0) = ""
7154:       strReturn(1) = ""
7155:   End Select
  
7157:   ReturnShapeTypeFromGeomType = strReturn


  Exit Function
ErrorHandler:
  HandleError True, "ReturnShapeTypeFromGeomType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnFoldersFromNestedFolders(ByVal strDir As String, strPartialText As String) As esriSystem.IStringArray
  On Error GoTo ErrorHandler

  
7169:   Set ReturnFoldersFromNestedFolders = New esriSystem.strArray
    
7171:   If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
  
  Dim strOriginalDir As String
7174:   strOriginalDir = strDir
  
  Dim booFoundSubFolders As Boolean
      
  Dim pPathArray As esriSystem.IStringArray
7179:   Set pPathArray = New esriSystem.strArray
  
  Dim pFinalArray As esriSystem.IStringArray
7182:   Set pFinalArray = New esriSystem.strArray
  Dim pCheckColl As Collection
7184:   Set pCheckColl = New Collection
  
7186:   pFinalArray.Add strDir
7187:   pCheckColl.Add True, strDir
  
  Dim strDirName As String
    
7191:   strDirName = Dir(strDir, vbDirectory)   ' Retrieve the first entry.
7192:   Do While strDirName <> ""   ' Start the loop.
     ' Ignore the current directory and the encompassing directory.
7194:      If strDirName <> "." And strDirName <> ".." Then
        ' Use bitwise comparison to make sure MyName is a directory.
7196:         If (GetAttr(strDir & strDirName) And vbDirectory) = vbDirectory Then
7197:            pPathArray.Add strDir & strDirName & "\"
7198:            pFinalArray.Add strDir & strDirName & "\"
7199:            pCheckColl.Add False, strDir & strDirName & "\"
7200:         End If   ' it represents a directory.
7201:      End If
7202:      strDirName = Dir   ' Get next entry.
7203:   Loop
  
7205:   booFoundSubFolders = pPathArray.Count > 0
  ' If Not booFoundSubFolders Then Exit Function
  
  Dim strSubFolder As String
  
  Dim booFoundSubHere As Boolean
  Dim pSubArray As esriSystem.IStringArray
  
  Dim lngIndex As Long
  
7215:   Do While booFoundSubFolders
7216:     booFoundSubFolders = False
7217:     Set pSubArray = New esriSystem.strArray
    
7219:     For lngIndex = 0 To pPathArray.Count - 1
7220:       strSubFolder = pPathArray.Element(lngIndex)
      
      
'     If strDirName <> "." And strDirName <> ".." Then
'        lngCounter = lngCounter + 1

7226:       booFoundSubHere = False
7227:       strDirName = Dir(strSubFolder, vbDirectory)   ' Retrieve the first entry.
7228:       Do While strDirName <> ""   ' Start the loop.
         ' Ignore the current directory and the encompassing directory.
7230:          If strDirName <> "." And strDirName <> ".." Then
            ' Use bitwise comparison to make sure MyName is a directory.
7232:             If (GetAttr(strSubFolder & strDirName) And vbDirectory) = vbDirectory Then
7233:                pSubArray.Add strSubFolder & strDirName & "\"
7234:                booFoundSubFolders = True
7235:                booFoundSubHere = True
7236:                If Not CheckCollectionForKey(pCheckColl, strSubFolder & strDirName & "\") Then
7237:                  pCheckColl.Add 1, strSubFolder & strDirName & "\"
7238:                  pFinalArray.Add strSubFolder & strDirName & "\"
7239:                End If
7240:             End If   ' it represents a directory.
7241:          End If
7242:          strDirName = Dir   ' Get next entry.
7243:       Loop
      
7245:       If Not booFoundSubHere Then
7246:         pSubArray.Add strSubFolder
7247:       End If
      
7249:     Next lngIndex
    
7251:     If booFoundSubFolders Then
7252:       Set pPathArray = pSubArray
7253:     End If
    
7255:   Loop
  
  Dim strFolders() As String
  ReDim strFolders(pFinalArray.Count - 1)
  
  
7261:   For lngIndex = 0 To pFinalArray.Count - 1
7262:     strDir = pFinalArray.Element(lngIndex)
7263:     strFolders(lngIndex) = strDir
'    Debug.Print CStr(lngIndex + 1) & "]  " & strDir
7265:   Next lngIndex
  
7267:   QuickSort.StringsAscending strFolders, 0, pFinalArray.Count - 1
  
'  For lngIndex = 0 To UBound(strFolders)
'    strDir = strFolders(lngIndex)
'    Debug.Print CStr(lngIndex + 1) & "]  " & strDir
'  Next lngIndex

  Dim lngCounter As Long
7275:   lngCounter = 0

7277:   Debug.Print
  
  Dim pFolderFeatLayers As esriSystem.IVariantArray
  Dim pFileNames As esriSystem.IStringArray
7281:   Set pFolderFeatLayers = New esriSystem.VarArray
7282:   Set pFileNames = New esriSystem.strArray
  Dim strDirAndFile As String
  
7285:   For lngIndex = 0 To UBound(strFolders)
7286:     strDir = strFolders(lngIndex)
    
7288:     If InStr(1, strDir, strPartialText, vbTextCompare) > 0 Then
7289:       pFileNames.Add strDir
7290:     End If
7291:   Next lngIndex

  ' CONFIRM THAT CORRECT DIRECTORY HAS BEEN SELECTED AND THAT IT ACTUALLY HAS POLYLINE SHAPEFILES
7294:   Set ReturnFoldersFromNestedFolders = pFileNames
  
7296:   Set pPathArray = Nothing
7297:   Set pFinalArray = Nothing
7298:   Set pCheckColl = Nothing
7299:   Set pSubArray = Nothing
7300:   Set pFolderFeatLayers = Nothing
7301:   Set pFileNames = Nothing


  Exit Function
ErrorHandler:
  HandleError True, "ReturnFoldersFromNestedFolders " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function ReturnDatasetTypeName(lngType As Long) As String
  On Error GoTo ErrorHandler


  Select Case lngType
    Case 1
7314:       ReturnDatasetTypeName = "Any Dataset"
    Case 2
7316:       ReturnDatasetTypeName = "Any Container Dataset"
    Case 3
7318:       ReturnDatasetTypeName = "Any Geo Dataset"
    Case 4
7320:       ReturnDatasetTypeName = "Feature Dataset"
    Case 5
7322:       ReturnDatasetTypeName = "Feature Class"
    Case 6
7324:       ReturnDatasetTypeName = "Planar Graph"
    Case 7
7326:       ReturnDatasetTypeName = "Geometric Network"
    Case 8
7328:       ReturnDatasetTypeName = "Topology"
    Case 9
7330:       ReturnDatasetTypeName = "Text Dataset"
    Case 10
7332:       ReturnDatasetTypeName = "Table Dataset"
    Case 11
7334:       ReturnDatasetTypeName = "Relationship Class"
    Case 12
7336:       ReturnDatasetTypeName = "Raster Dataset"
    Case 13
7338:       ReturnDatasetTypeName = "Raster Band"
    Case 14
7340:       ReturnDatasetTypeName = "Tin Dataset"
    Case 15
7342:       ReturnDatasetTypeName = "CadDrawing Dataset"
    Case 16
7344:       ReturnDatasetTypeName = "Raster Catalog"
    Case 17
7346:       ReturnDatasetTypeName = "Toolbox"
    Case 18
7348:       ReturnDatasetTypeName = "Tool"
    Case 19
7350:       ReturnDatasetTypeName = "Network Dataset"
    Case 20
7352:       ReturnDatasetTypeName = "Terrain dataset"
    Case 21
7354:       ReturnDatasetTypeName = "Feature Class Representation"
    Case 22
7356:       ReturnDatasetTypeName = "Cadastral Fabric"
    Case 23
7358:       ReturnDatasetTypeName = "Schematic Dataset"
    Case 24
7360:       ReturnDatasetTypeName = "Address Locator"
    Case 26
7362:       ReturnDatasetTypeName = "Map"
    Case 27
7364:       ReturnDatasetTypeName = "Layer"
    Case 28
7366:       ReturnDatasetTypeName = "Style"
    Case 29
7368:       ReturnDatasetTypeName = "Mosaic Dataset"
    Case Else
7370:       ReturnDatasetTypeName = "Unknown Type [" & CStr(lngType) & "]"
7371:   End Select


  Exit Function
ErrorHandler:
  HandleError True, "ReturnDatasetTypeName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnSelectedLayers(pMxDoc As IMxDocument) As esriSystem.IArray
  On Error GoTo ErrorHandler

7382:   Set ReturnSelectedLayers = New esriSystem.Array
  
  Dim pUnknown As IUnknown
7385:   Set pUnknown = pMxDoc.SelectedItem
  Dim lngIndex As Long
  Dim pSelSet As ISet
  Dim pObj As IUnknown
  
7390:   If Not pUnknown Is Nothing Then
7391:     If TypeOf pUnknown Is ILayer Then
7392:       ReturnSelectedLayers.Add pUnknown
7393:     ElseIf TypeOf pUnknown Is ISet Then
7394:       Set pSelSet = pUnknown
7395:       pSelSet.Reset
7396:       Set pObj = pSelSet.Next
7397:       Do Until pObj Is Nothing
7398:         If TypeOf pObj Is ILayer Then
7399:           ReturnSelectedLayers.Add pObj
7400:         End If
7401:         Set pObj = pSelSet.Next
7402:       Loop
7403:     End If
7404:   End If
    
7406:   GoTo ClearMemory
  
  Exit Function
ErrorHandler:
  HandleError True, "ReturnSelectedLayers " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4

ClearMemory:
7413:   Set pUnknown = Nothing
7414:   Set pSelSet = Nothing
7415:   Set pObj = Nothing

End Function

Public Function SearchForTextInFolder_and_MakeReport(strFolder As String, strSearchString As String, _
    Optional strExtensionWithoutDot As String = "docx") As String
  
  Dim pFolders As IStringArray
7423:   Set pFolders = ReturnFoldersFromNestedFolders(strFolder, "")
  
  Dim pFiles As esriSystem.IStringArray
  Dim pFinalFiles As esriSystem.IStringArray
7427:   Set pFinalFiles = New esriSystem.strArray
  
  Dim lngIndex As Long
  Dim lngIndex2 As Long
  Dim strFile As String
  Dim strDocText As String
  
7434:   For lngIndex = 0 To pFolders.Count - 1
7435:     strFolder = pFolders.Element(lngIndex)
7436:     Debug.Print CStr(lngIndex + 1) & "] " & strFolder
      
7438:     Set pFiles = ReturnFilesFromNestedFolders(strFolder, strExtensionWithoutDot)
7439:     For lngIndex2 = 0 To pFiles.Count - 1
7440:       strFile = pFiles.Element(lngIndex2)

7442:       Debug.Print "  --> " & strFile
7443:       If InStr(1, strExtensionWithoutDot, "doc", vbTextCompare) > 0 Then
'        strDocText = ReturnWordText(strFile)
7445:       Else
7446:         strDocText = MyGeneralOperations.ReadTextFile(strFile)
7447:       End If
7448:       If InStr(1, strDocText, strSearchString, vbTextCompare) > 0 Then
7449:         pFinalFiles.Add strFile
7450:       End If

7452:     Next lngIndex2
7453:   Next lngIndex
  
7455:   SearchForTextInFolder_and_MakeReport = ""
  
7457:   Debug.Print "................................."
7458:   Debug.Print "Found '" & strSearchString & "' in the following documents:"
7459:   If pFinalFiles.Count = 0 Then
7460:     SearchForTextInFolder_and_MakeReport = "Did not find '" & strSearchString & _
        "' in any '" & strExtensionWithoutDot & "' fies in '" & strFolder & "'..."
7462:     Debug.Print SearchForTextInFolder_and_MakeReport
7463:   Else
7464:     SearchForTextInFolder_and_MakeReport = "Found '" & strSearchString & "' in the following documents:" & vbCrLf
7465:     For lngIndex = 0 To pFinalFiles.Count - 1
7466:       strFile = pFinalFiles.Element(lngIndex)
7467:       SearchForTextInFolder_and_MakeReport = SearchForTextInFolder_and_MakeReport & _
          CStr(lngIndex + 1) & "] " & strFile & vbCrLf
7469:       Debug.Print CStr(lngIndex + 1) & "] " & strFile
7470:     Next lngIndex
7471:   End If
7472:   Debug.Print "Done..."
  
ClearMemory:
7475:   Set pFolders = Nothing
7476:   Set pFiles = Nothing
7477:   Set pFinalFiles = Nothing

End Function



